/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/storage/common/storage","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/userDataSync/common/userDataSyncProfilesStorageService","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/userDataSync/electron-sandbox/userDataSyncProfilesStorageService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(Q){for(var e=[],R=0,n=Q.length;R<n;R++)e[R]=ne[Q[R]];return e};define(ne[50],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(T){return T?T.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=R;class n{constructor(I,E,b){this.id=I,this.definition=E,this.description=b,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",n.circleFilled.definition),n.closeDirty=new n("close-dirty",n.circleFilled.definition),n.debugBreakpoint=new n("debug-breakpoint",n.circleFilled.definition),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",n.circleFilled.definition),n.debugHint=new n("debug-hint",n.circleFilled.definition),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circle=new n("circle",{fontCharacter:"\\eabc"}),n.circleOutline=new n("circle-outline",n.circle.definition),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",n.circle.definition),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLarge=new n("circle-large",{fontCharacter:"\\ebb5"}),n.circleLargeOutline=new n("circle-large-outline",n.circleLarge.definition),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.searchFuzzy=new n("search-fuzzy",{fontCharacter:"\\ec0d"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function D(T,I){const E=["codicon","codicon-"+T];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=D;var L;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function E(y){if(y instanceof n)return["codicon","codicon-"+y.id];const m=I.exec(y.id);if(!m)return E(n.error);const[,v,h]=m,S=["codicon","codicon-"+v];return h&&S.push("codicon-modifier-"+h.substr(1)),S}T.asClassNameArray=E;function b(y){return E(y).join(" ")}T.asClassName=b;function C(y){return"."+E(y).join(".")}T.asCSSSelector=C})(L=e.CSSIcon||(e.CSSIcon={}))}),define(ne[62],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(T){return(I,E,b)=>{let C=null,y=null;if(typeof b.value=="function"?(C="value",y=b.value):typeof b.get=="function"&&(C="get",y=b.get),!y)throw new Error("not supported");b[C]=T(y,E)}}e.createDecorator=R;function n(T,I,E){let b=null,C=null;if(typeof E.value=="function"?(b="value",C=E.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",C=E.get),!C)throw new Error("not supported");const y=`$memoize$${I}`;E[b]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[y]}}e.memoize=n;function D(T,I,E){return R((b,C)=>{const y=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...v){this[m]||(this[m]=E?E():void 0),clearTimeout(this[y]),I&&(this[m]=I(this[m],...v),v=[this[m]]),this[y]=setTimeout(()=>{b.apply(this,v),this[m]=E?E():void 0},T)}})}e.debounce=D;function L(T,I,E){return R((b,C)=>{const y=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,v=`$throttle$lastRun$${C}`,h=`$throttle$pending$${C}`;return function(...S){if(this[m]||(this[m]=E?E():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...S)),this[h])return;const P=this[v]+T;P<=Date.now()?(this[v]=Date.now(),b.apply(this,[this[m]]),this[m]=E?E():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),b.apply(this,[this[m]]),this[m]=E?E():void 0},P-Date.now()))}})}e.throttle=L}),define(ne[9],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?a.isErrorNoTelemetry(i)?new a(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=R,e.errorHandler=new R;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function D(l){E(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function L(l){E(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=L;function T(l){if(l instanceof Error){const{name:i,message:s}=l,t=l.stacktrace||l.stack;return{$isError:!0,name:i,message:s,stack:t,noTelemetry:a.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=T;const I="Canceled";function E(l){return l instanceof b?!0:l instanceof Error&&l.name===I&&l.message===I}e.isCancellationError=E;class b extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=b;function C(){const l=new Error(I);return l.name=l.message,l}e.canceled=C;function y(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=y;function m(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=m;function v(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function S(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=S;class P extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=P;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=p;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=g;class a extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof a)return i;const s=new a;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=a;class f extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ne[18],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(X,ie=0){return X[X.length-(1+ie)]}e.tail=n;function D(X){if(X.length===0)throw new Error("Invalid tail call");return[X.slice(0,X.length-1),X[X.length-1]]}e.tail2=D;function L(X,ie,se=(ue,he)=>ue===he){if(X===ie)return!0;if(!X||!ie||X.length!==ie.length)return!1;for(let ue=0,he=X.length;ue<he;ue++)if(!se(X[ue],ie[ue]))return!1;return!0}e.equals=L;function T(X,ie){const se=X.length-1;ie<se&&(X[ie]=X[se]),X.pop()}e.removeFastWithoutKeepingOrder=T;function I(X,ie,se){return E(X.length,ue=>se(X[ue],ie))}e.binarySearch=I;function E(X,ie){let se=0,ue=X-1;for(;se<=ue;){const he=(se+ue)/2|0,ve=ie(he);if(ve<0)se=he+1;else if(ve>0)ue=he-1;else return he}return-(se+1)}e.binarySearch2=E;function b(X,ie){let se=0,ue=X.length;if(ue===0)return 0;for(;se<ue;){const he=Math.floor((se+ue)/2);ie(X[he])?ue=he:se=he+1}return se}e.findFirstInSorted=b;function C(X,ie,se){if(X=X|0,X>=ie.length)throw new TypeError("invalid index");const ue=ie[Math.floor(ie.length*Math.random())],he=[],ve=[],we=[];for(const Ee of ie){const Pe=se(Ee,ue);Pe<0?he.push(Ee):Pe>0?ve.push(Ee):we.push(Ee)}return X<he.length?C(X,he,se):X<he.length+we.length?we[0]:C(X-(he.length+we.length),ve,se)}e.quickSelect=C;function y(X,ie){const se=[];let ue;for(const he of X.slice(0).sort(ie))!ue||ie(ue[0],he)!==0?(ue=[he],se.push(ue)):ue.push(he);return se}e.groupBy=y;function m(X,ie,se){const ue=[];function he(Ee,Pe,Ue){if(Pe===0&&Ue.length===0)return;const ze=ue[ue.length-1];ze&&ze.start+ze.deleteCount===Ee?(ze.deleteCount+=Pe,ze.toInsert.push(...Ue)):ue.push({start:Ee,deleteCount:Pe,toInsert:Ue})}let ve=0,we=0;for(;;){if(ve===X.length){he(ve,0,ie.slice(we));break}if(we===ie.length){he(ve,X.length-ve,[]);break}const Ee=X[ve],Pe=ie[we],Ue=se(Ee,Pe);Ue===0?(ve+=1,we+=1):Ue<0?(he(ve,1,[]),ve+=1):Ue>0&&(he(ve,0,[Pe]),we+=1)}return ue}e.sortedDiff=m;function v(X,ie,se){const ue=m(X,ie,se),he=[],ve=[];for(const we of ue)he.push(...X.slice(we.start,we.start+we.deleteCount)),ve.push(...we.toInsert);return{removed:he,added:ve}}e.delta=v;function h(X,ie,se){if(se===0)return[];const ue=X.slice(0,se).sort(ie);return P(X,ie,ue,se,X.length),ue}e.top=h;function S(X,ie,se,ue,he){return se===0?Promise.resolve([]):new Promise((ve,we)=>{(async()=>{const Ee=X.length,Pe=X.slice(0,se).sort(ie);for(let Ue=se,ze=Math.min(se+ue,Ee);Ue<Ee;Ue=ze,ze=Math.min(ze+ue,Ee)){if(Ue>se&&await new Promise(Ve=>setTimeout(Ve)),he&&he.isCancellationRequested)throw new R.CancellationError;P(X,ie,Pe,Ue,ze)}return Pe})().then(ve,we)})}e.topAsync=S;function P(X,ie,se,ue,he){for(const ve=se.length;ue<he;ue++){const we=X[ue];if(ie(we,se[ve-1])<0){se.pop();const Ee=b(se,Pe=>ie(we,Pe)<0);se.splice(Ee,0,we)}}}function p(X){return X.filter(ie=>!!ie)}e.coalesce=p;function g(X){let ie=0;for(let se=0;se<X.length;se++)X[se]&&(X[ie]=X[se],ie+=1);X.length=ie}e.coalesceInPlace=g;function a(X,ie,se){X.splice(se,0,X.splice(ie,1)[0])}e.move=a;function f(X){return!Array.isArray(X)||X.length===0}e.isFalsyOrEmpty=f;function l(X){return Array.isArray(X)&&X.length>0}e.isNonEmptyArray=l;function i(X,ie=se=>se){const se=new Set;return X.filter(ue=>{const he=ie(ue);return se.has(he)?!1:(se.add(he),!0)})}e.distinct=i;function s(X){const ie=new Set;return se=>{const ue=X(se);return ie.has(ue)?!1:(ie.add(ue),!0)}}e.uniqueFilter=s;function t(X,ie){const se=r(X,ie);if(se!==-1)return X[se]}e.findLast=t;function r(X,ie){for(let se=X.length-1;se>=0;se--){const ue=X[se];if(ie(ue))return se}return-1}e.lastIndex=r;function o(X,ie){return X.length>0?X[0]:ie}e.firstOrDefault=o;function c(X,ie){return X.length>0?X[X.length-1]:ie}e.lastOrDefault=c;function u(X,ie,se=(ue,he)=>ue===he){let ue=0;for(let he=0,ve=Math.min(X.length,ie.length);he<ve&&se(X[he],ie[he]);he++)ue++;return ue}e.commonPrefixLength=u;function d(X){return[].concat(...X)}e.flatten=d;function w(X,ie){let se=typeof ie=="number"?X:0;typeof ie=="number"?se=X:(se=0,ie=X);const ue=[];if(se<=ie)for(let he=se;he<ie;he++)ue.push(he);else for(let he=se;he>ie;he--)ue.push(he);return ue}e.range=w;function A(X,ie,se){return X.reduce((ue,he)=>(ue[ie(he)]=se?se(he):he,ue),Object.create(null))}e.index=A;function O(X,ie){return X.push(ie),()=>_(X,ie)}e.insert=O;function _(X,ie){const se=X.indexOf(ie);if(se>-1)return X.splice(se,1),ie}e.remove=_;function M(X,ie,se){const ue=X.slice(0,ie),he=X.slice(ie);return ue.concat(se,he)}e.arrayInsert=M;function k(X,ie){let se;if(typeof ie=="number"){let ue=ie;se=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else se=Math.random;for(let ue=X.length-1;ue>0;ue-=1){const he=Math.floor(se()*(ue+1)),ve=X[ue];X[ue]=X[he],X[he]=ve}}e.shuffle=k;function F(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.unshift(ie))}e.pushToStart=F;function $(X,ie){const se=X.indexOf(ie);se>-1&&(X.splice(se,1),X.push(ie))}e.pushToEnd=$;function q(X,ie){for(const se of ie)X.push(se)}e.pushMany=q;function J(X,ie){return Array.isArray(X)?X.map(ie):ie(X)}e.mapArrayOrNot=J;function H(X){return Array.isArray(X)?X:[X]}e.asArray=H;function K(X){return X[Math.floor(Math.random()*X.length)]}e.getRandomElement=K;function W(X,ie){for(const se of X){const ue=ie(se);if(ue!==void 0)return ue}}e.mapFind=W;function B(X,ie,se){const ue=te(X,ie),he=X.length,ve=se.length;X.length=he+ve;for(let we=he-1;we>=ue;we--)X[we+ve]=X[we];for(let we=0;we<ve;we++)X[we+ue]=se[we]}e.insertInto=B;function Y(X,ie,se,ue){const he=te(X,ie),ve=X.splice(he,se);return B(X,he,ue),ve}e.splice=Y;function te(X,ie){return ie<0?Math.max(ie+X.length,0):Math.min(ie,X.length)}var ce;(function(X){function ie(he){return he<0}X.isLessThan=ie;function se(he){return he>0}X.isGreaterThan=se;function ue(he){return he===0}X.isNeitherLessOrGreaterThan=ue,X.greaterThan=1,X.lessThan=-1,X.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function z(X,ie){return(se,ue)=>ie(X(se),X(ue))}e.compareBy=z;function V(...X){return(ie,se)=>{for(const ue of X){const he=ue(ie,se);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=V;const U=(X,ie)=>X-ie;e.numberComparator=U;function N(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>0&&(se=he)}return se}e.findMaxBy=N;function j(X,ie){if(X.length===0)return;let se=X[0];for(let ue=1;ue<X.length;ue++){const he=X[ue];ie(he,se)>=0&&(se=he)}return se}e.findLastMaxBy=j;function x(X,ie){return N(X,(se,ue)=>-ie(se,ue))}e.findMinBy=x;class Z{constructor(ie){this.items=ie,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ie){let se=this.firstIdx;for(;se<this.items.length&&ie(this.items[se]);)se++;const ue=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ue}takeFromEndWhile(ie){let se=this.lastIdx;for(;se>=0&&ie(this.items[se]);)se--;const ue=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ie=this.items[this.firstIdx];return this.firstIdx++,ie}removeLast(){const ie=this.items[this.lastIdx];return this.lastIdx--,ie}takeCount(ie){const se=this.items.slice(this.firstIdx,this.firstIdx+ie);return this.firstIdx+=ie,se}}e.ArrayQueue=Z;class oe{constructor(ie){this.iterate=ie}forEach(ie){this.iterate(se=>(ie(se),!0))}toArray(){const ie=[];return this.iterate(se=>(ie.push(se),!0)),ie}filter(ie){return new oe(se=>this.iterate(ue=>ie(ue)?se(ue):!0))}map(ie){return new oe(se=>this.iterate(ue=>se(ie(ue))))}some(ie){let se=!1;return this.iterate(ue=>(se=ie(ue),!se)),se}findFirst(ie){let se;return this.iterate(ue=>ie(ue)?(se=ue,!1):!0),se}findLast(ie){let se;return this.iterate(ue=>(ie(ue)&&(se=ue),!0)),se}findLastMaxBy(ie){let se,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(ie(he,se)))&&(ue=!1,se=he),!0)),se}}e.CallbackIterable=oe,oe.empty=new oe(X=>{})}),define(ne[114],re([0,1,9]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function n(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=n;function D(E,b="Unreachable"){throw new Error(b)}e.assertNever=D;function L(E){if(!E)throw new R.BugIndicatingError("Assertion Failed")}e.assert=L;function T(E){if(!E()){debugger;E(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function I(E,b){let C=0;for(;C<E.length-1;){const y=E[C],m=E[C+1];if(!b(y,m))return!1;C++}return!0}e.checkAdjacentItems=I}),define(ne[78],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(n){const D=this;let L=!1,T;return function(){return L||(L=!0,T=n.apply(D,arguments)),T}}e.once=R}),define(ne[51],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(n){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}n.is=D;const L=Object.freeze([]);function T(){return L}n.empty=T;function*I(s){yield s}n.single=I;function E(s){return s||L}n.from=E;function b(s){return!s||s[Symbol.iterator]().next().done===!0}n.isEmpty=b;function C(s){return s[Symbol.iterator]().next().value}n.first=C;function y(s,t){for(const r of s)if(t(r))return!0;return!1}n.some=y;function m(s,t){for(const r of s)if(t(r))return r}n.find=m;function*v(s,t){for(const r of s)t(r)&&(yield r)}n.filter=v;function*h(s,t){let r=0;for(const o of s)yield t(o,r++)}n.map=h;function*S(...s){for(const t of s)for(const r of t)yield r}n.concat=S;function*P(s){for(const t of s)for(const r of t)yield r}n.concatNested=P;function p(s,t,r){let o=r;for(const c of s)o=t(o,c);return o}n.reduce=p;function g(s,t){let r=0;for(const o of s)t(o,r++)}n.forEach=g;function*a(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}n.slice=a;function f(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const o=s[Symbol.iterator]();for(let c=0;c<t;c++){const u=o.next();if(u.done)return[r,n.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return o}}]}n.consume=f;function l(s){return f(s)[0]}n.collect=l;function i(s,t,r=(o,c)=>o===c){const o=s[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const u=o.next(),d=c.next();if(u.done!==d.done)return!1;if(u.done)return!0;if(!r(u.value,d.value))return!1}}n.equals=i})(R=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var n;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function T(i,s=!1){let t=0;const r=i.length;let o="",c=0,u=16,d=0;function w($){let q=0,J=0;for(;q<$;){const H=i.charCodeAt(t);if(H>=48&&H<=57)J=J*16+H-48;else if(H>=65&&H<=70)J=J*16+H-65+10;else if(H>=97&&H<=102)J=J*16+H-97+10;else break;t++,q++}return q<$&&(J=-1),J}function A($){t=$,o="",c=0,u=16,d=0}function O(){const $=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&b(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&b(i.charCodeAt(t)))for(t++;t<i.length&&b(i.charCodeAt(t));)t++;else return d=3,i.substring($,t);let q=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&b(i.charCodeAt(t))){for(t++;t<i.length&&b(i.charCodeAt(t));)t++;q=t}else d=3;return i.substring($,q)}function _(){let $="",q=t;for(;;){if(t>=r){$+=i.substring(q,t),d=2;break}const J=i.charCodeAt(t);if(J===34){$+=i.substring(q,t),t++;break}if(J===92){if($+=i.substring(q,t),t++,t>=r){d=2;break}switch(i.charCodeAt(t++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const K=w(4);K>=0?$+=String.fromCharCode(K):d=4;break}default:d=5}q=t;continue}if(J>=0&&J<=31)if(E(J)){$+=i.substring(q,t),d=2;break}else d=6;t++}return $}function M(){if(o="",d=0,c=t,t>=r)return c=r,u=17;let $=i.charCodeAt(t);if(I($)){do t++,o+=String.fromCharCode($),$=i.charCodeAt(t);while(I($));return u=15}if(E($))return t++,o+=String.fromCharCode($),$===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),u=14;switch($){case 123:return t++,u=1;case 125:return t++,u=2;case 91:return t++,u=3;case 93:return t++,u=4;case 58:return t++,u=6;case 44:return t++,u=5;case 34:return t++,o=_(),u=10;case 47:{const q=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<r&&!E(i.charCodeAt(t));)t++;return o=i.substring(q,t),u=12}if(i.charCodeAt(t+1)===42){t+=2;const J=r-1;let H=!1;for(;t<J;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,H=!0;break}t++}return H||(t++,d=1),o=i.substring(q,t),u=13}return o+=String.fromCharCode($),t++,u=16}case 45:if(o+=String.fromCharCode($),t++,t===r||!b(i.charCodeAt(t)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),u=11;default:for(;t<r&&k($);)t++,$=i.charCodeAt(t);if(c!==t){switch(o=i.substring(c,t),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode($),t++,u=16}}function k($){if(I($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=M();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>t,scan:s?F:M,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>d}}e.createScanner=T;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function y(i,s){const t=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(w,A,O,_){c.value=w,c.offset=A,c.length=O,c.type=_,c.colonOffset=void 0,o=c}try{a(i,{onObjectBegin:(w,A)=>{if(s<=w)throw r;o=void 0,u=s>w,t.push("")},onObjectProperty:(w,A,O)=>{if(s<A||(d(w,A,O,"property"),t[t.length-1]=w,s<=A+O))throw r},onObjectEnd:(w,A)=>{if(s<=w)throw r;o=void 0,t.pop()},onArrayBegin:(w,A)=>{if(s<=w)throw r;o=void 0,t.push(0)},onArrayEnd:(w,A)=>{if(s<=w)throw r;o=void 0,t.pop()},onLiteralValue:(w,A,O)=>{if(s<A||(d(w,A,O,l(w)),s<=A+O))throw r},onSeparator:(w,A,O)=>{if(s<=A)throw r;if(w===":"&&o&&o.type==="property")o.colonOffset=A,u=!1,o=void 0;else if(w===","){const _=t[t.length-1];typeof _=="number"?t[t.length-1]=_+1:(u=!0,t[t.length-1]=""),o=void 0}}})}catch(w){if(w!==r)throw w}return{path:t,previousNode:o,isAtPropertyKey:u,matches:w=>{let A=0;for(let O=0;A<w.length&&O<t.length;O++)if(w[A]===t[O]||w[A]==="*")A++;else if(w[A]!=="**")return!1;return A===w.length}}}e.getLocation=y;function m(i,s=[],t=L.DEFAULT){let r=null,o=[];const c=[];function u(w){Array.isArray(o)?o.push(w):r!==null&&(o[r]=w)}return a(i,{onObjectBegin:()=>{const w={};u(w),c.push(o),o=w,r=null},onObjectProperty:w=>{r=w},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const w=[];u(w),c.push(o),o=w,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(w,A,O)=>{s.push({error:w,offset:A,length:O})}},t),o[0]}e.parse=m;function v(i,s=[],t=L.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(w){r.type==="property"&&(r.length=w-r.offset,r=r.parent)}function c(w){return r.children.push(w),w}a(i,{onObjectBegin:w=>{r=c({type:"object",offset:w,length:-1,parent:r,children:[]})},onObjectProperty:(w,A,O)=>{r=c({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:w,offset:A,length:O,parent:r})},onObjectEnd:(w,A)=>{r.length=w+A-r.offset,r=r.parent,o(w+A)},onArrayBegin:(w,A)=>{r=c({type:"array",offset:w,length:-1,parent:r,children:[]})},onArrayEnd:(w,A)=>{r.length=w+A-r.offset,r=r.parent,o(w+A)},onLiteralValue:(w,A,O)=>{c({type:l(w),offset:A,length:O,parent:r,value:w}),o(A+O)},onSeparator:(w,A,O)=>{r.type==="property"&&(w===":"?r.colonOffset=A:w===","&&o(A))},onError:(w,A,O)=>{s.push({error:w,offset:A,length:O})}},t);const d=r.children[0];return d&&delete d.parent,d}e.parseTree=v;function h(i,s){if(!i)return;let t=i;for(const r of s)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===r){t=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function S(i){if(!i.parent||!i.parent.children)return[];const s=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;s.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&s.push(t)}return s}e.getNodePath=S;function P(i){switch(i.type){case"array":return i.children.map(P);case"object":{const s=Object.create(null);for(const t of i.children){const r=t.children[1];r&&(s[t.children[0].value]=P(r))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=P;function p(i,s,t=!1){return s>=i.offset&&s<i.offset+i.length||t&&s===i.offset+i.length}e.contains=p;function g(i,s,t=!1){if(p(i,s,t)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=s;o++){const c=g(r[o],s,t);if(c)return c}return i}}e.findNodeAtOffset=g;function a(i,s,t=L.DEFAULT){const r=T(i,!1);function o(z){return z?()=>z(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(z){return z?V=>z(V,r.getTokenOffset(),r.getTokenLength()):()=>!0}const u=o(s.onObjectBegin),d=c(s.onObjectProperty),w=o(s.onObjectEnd),A=o(s.onArrayBegin),O=o(s.onArrayEnd),_=c(s.onLiteralValue),M=c(s.onSeparator),k=o(s.onComment),F=c(s.onError),$=t&&t.disallowComments,q=t&&t.allowTrailingComma;function J(){for(;;){const z=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(z){case 12:case 13:$?H(10):k();break;case 16:H(1);break;case 15:case 14:break;default:return z}}}function H(z,V=[],U=[]){if(F(z),V.length+U.length>0){let N=r.getToken();for(;N!==17;){if(V.indexOf(N)!==-1){J();break}else if(U.indexOf(N)!==-1)break;N=J()}}}function K(z){const V=r.getTokenValue();return z?_(V):d(V),J(),!0}function W(){switch(r.getToken()){case 11:{let z=0;try{z=JSON.parse(r.getTokenValue()),typeof z!="number"&&(H(2),z=0)}catch{H(2)}_(z);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return J(),!0}function B(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(K(!1),r.getToken()===6?(M(":"),J(),ce()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function Y(){u(),J();let z=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(z||H(4,[],[]),M(","),J(),r.getToken()===2&&q)break}else z&&H(6,[],[]);B()||H(4,[],[2,5]),z=!0}return w(),r.getToken()!==2?H(7,[2],[]):J(),!0}function te(){A(),J();let z=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(z||H(4,[],[]),M(","),J(),r.getToken()===4&&q)break}else z&&H(6,[],[]);ce()||H(4,[],[4,5]),z=!0}return O(),r.getToken()!==4?H(8,[4],[]):J(),!0}function ce(){switch(r.getToken()){case 3:return te();case 1:return Y();case 10:return K(!0);default:return W()}}return J(),r.getToken()===17?t.allowEmptyContent?!0:(H(4,[],[]),!1):ce()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=a;function f(i,s){const t=T(i),r=[];let o,c=0,u;do switch(u=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==u&&r.push(i.substring(c,u)),s!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,s)),c=t.getPosition();break}while(o!==17);return r.join("")}e.stripComments=f;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[52],re([0,1,35]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(b,C,y){let m,v,h,S,P;if(C){for(S=C.offset,P=S+C.length,h=S;h>0&&!E(b,h-1);)h--;let u=P;for(;u<b.length&&!E(b,u);)u++;v=b.substring(h,u),m=T(v,y)}else v=b,m=0,h=0,S=0,P=b.length;const p=I(y,b);let g=!1,a=0,f;y.insertSpaces?f=L(" ",y.tabSize||4):f="	";const l=(0,R.createScanner)(v,!1);let i=!1;function s(){return p+L(f,m+a)}function t(){let u=l.scan();for(g=!1;u===15||u===14;)g=g||u===14,u=l.scan();return i=u===16||l.getTokenError()!==0,u}const r=[];function o(u,d,w){!i&&d<P&&w>S&&b.substring(d,w)!==u&&r.push({offset:d,length:w-d,content:u})}let c=t();if(c!==17){const u=l.getTokenOffset()+h,d=L(f,m);o(d,h,u)}for(;c!==17;){let u=l.getTokenOffset()+l.getTokenLength()+h,d=t(),w="";for(;!g&&(d===12||d===13);){const O=l.getTokenOffset()+h;o(" ",u,O),u=l.getTokenOffset()+l.getTokenLength()+h,w=d===12?s():"",d=t()}if(d===2)c!==1&&(a--,w=s());else if(d===4)c!==3&&(a--,w=s());else{switch(c){case 3:case 1:a++,w=s();break;case 5:case 12:w=s();break;case 13:g?w=s():w=" ";break;case 6:w=" ";break;case 10:if(d===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?w=" ":d!==5&&d!==17&&(i=!0);break;case 16:i=!0;break}g&&(d===12||d===13)&&(w=s())}const A=l.getTokenOffset()+h;o(w,u,A),c=d}return r}e.format=n;function D(b,C){const y=JSON.stringify(b,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?y.replace(/\r\n|\r|\n/g,C.eol):y}e.toFormattedString=D;function L(b,C){let y="";for(let m=0;m<C;m++)y+=b;return y}function T(b,C){let y=0,m=0;const v=C.tabSize||4;for(;y<b.length;){const h=b.charAt(y);if(h===" ")m++;else if(h==="	")m+=v;else break;y++}return Math.floor(m/v)}function I(b,C){for(let y=0;y<C.length;y++){const m=C.charAt(y);if(m==="\r")return y+1<C.length&&C.charAt(y+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=I;function E(b,C){return`\r
`.indexOf(b.charAt(C))!==-1}e.isEOL=E}),define(ne[79],re([0,1,35,52]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,C,y){return L(b,C,void 0,y)}e.removeProperty=D;function L(b,C,y,m,v){const h=C.slice(),S=[],P=(0,R.parseTree)(b,S);let p,g;for(;h.length>0&&(g=h.pop(),p=(0,R.findNodeAtLocation)(P,h),p===void 0&&y!==void 0);)typeof g=="string"?y={[g]:y}:y=[y];if(p)if(p.type==="object"&&typeof g=="string"&&Array.isArray(p.children)){const a=(0,R.findNodeAtLocation)(p,[g]);if(a!==void 0)if(y===void 0){if(!a.parent)throw new Error("Malformed AST");const f=p.children.indexOf(a.parent);let l,i=a.parent.offset+a.parent.length;if(f>0){const s=p.children[f-1];l=s.offset+s.length}else l=p.offset+1,p.children.length>1&&(i=p.children[1].offset);return T(b,{offset:l,length:i-l,content:""},m)}else return T(b,{offset:a.offset,length:a.length,content:JSON.stringify(y)},m);else{if(y===void 0)return[];const f=`${JSON.stringify(g)}: ${JSON.stringify(y)}`,l=v?v(p.children.map(s=>s.children[0].value)):p.children.length;let i;if(l>0){const s=p.children[l-1];i={offset:s.offset+s.length,length:0,content:","+f}}else p.children.length===0?i={offset:p.offset+1,length:0,content:f}:i={offset:p.offset+1,length:0,content:f+","};return T(b,i,m)}}else if(p.type==="array"&&typeof g=="number"&&Array.isArray(p.children))if(y!==void 0){const a=`${JSON.stringify(y)}`;let f;if(p.children.length===0||g===0)f={offset:p.offset+1,length:0,content:p.children.length===0?a:a+","};else{const l=g===-1||g>p.children.length?p.children.length:g,i=p.children[l-1];f={offset:i.offset+i.length,length:0,content:","+a}}return T(b,f,m)}else{const a=g,f=p.children[a];let l;if(p.children.length===1)l={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===a){const i=p.children[a-1],s=i.offset+i.length,t=p.offset+p.length;l={offset:s,length:t-2-s,content:""}}else l={offset:f.offset,length:p.children[a+1].offset-f.offset,content:""};return T(b,l,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${p.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return T(b,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(y)},m)}}e.setProperty=L;function T(b,C,y){let m=I(b,C),v=C.offset,h=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;v>0&&!(0,n.isEOL)(m,v-1);)v--;for(;h<m.length&&!(0,n.isEOL)(m,h);)h++}const S=(0,n.format)(m,{offset:v,length:h-v},y);for(let p=S.length-1;p>=0;p--){const g=S[p];m=I(m,g),v=Math.min(v,g.offset),h=Math.max(h,g.offset+g.length),h+=g.content.length-g.length}const P=b.length-(m.length-h)-v;return[{offset:v,length:P,content:m.substring(v,h)}]}e.withFormatting=T;function I(b,C){return b.substring(0,C.offset)+C.content+b.substring(C.offset+C.length)}e.applyEdit=I;function E(b,C){const y=C.slice(0).sort((v,h)=>{const S=v.offset-h.offset;return S===0?v.length-h.length:S});let m=b.length;for(let v=y.length-1;v>=0;v--){const h=y[v];if(h.offset+h.length<=m)b=I(b,h);else throw new Error("Overlapping edit");m=h.offset}return b}e.applyEdits=E}),define(ne[115],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new R(()=>D(this.getValue()))}}e.Lazy=R}),define(ne[2],re([0,1,78,51]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let L=null;function T(o){L=o}if(e.setDisposableTracker=T,D){const o="__is_disposable_tracked__";T(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==g.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==g.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function I(o){return L?.trackDisposable(o),o}function E(o){L?.markAsDisposed(o)}function b(o,c){L?.setParent(o,c)}function C(o,c){if(!!L)for(const u of o)L.setParent(u,c)}function y(o){return L?.markAsSingleton(o),o}e.markAsSingleton=y;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function v(o){if(n.Iterable.is(o)){const c=[];for(const u of o)if(u)try{u.dispose()}catch(d){c.push(d)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=v;function h(o){for(const c of o)m(c)&&c.dispose();return[]}e.disposeIfDisposable=h;function S(...o){const c=P(()=>v(o));return C(o,c),c}e.combinedDisposable=S;function P(o){const c=I({dispose:(0,R.once)(()=>{E(c),o()})});return c}e.toDisposable=P;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{v(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return b(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new p,I(this),b(this._store,this)}dispose(){E(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&b(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&b(c,null),c}}e.MutableDisposable=a;class f{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,E(this))},this}}e.SafeDisposable=l;class i{constructor(){this.references=new Map}acquire(c,...u){let d=this.references.get(c);d||(d={counter:0,object:this.createReferencedObject(c,...u)},this.references.set(c,d));const{object:w}=d,A=(0,R.once)(()=>{--d.counter===0&&(this.destroyReferencedObject(c,d.object),this.references.delete(c))});return d.counter++,{object:w,dispose:A}}}e.ReferenceCollection=i;class s{constructor(c){this.referenceCollection=c}async acquire(c,...u){const d=this.referenceCollection.acquire(c,...u);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(w){throw d.dispose(),w}}}e.AsyncReferenceCollection=s;class t{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=t;function r(o){const c=new p;try{o(c)}finally{c.dispose()}}e.disposeOnReturn=r}),define(ne[116],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(L){this.element=L,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class n{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let L=this._first;for(;L!==R.Undefined;){const T=L.next;L.prev=R.Undefined,L.next=R.Undefined,L=T}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,T){const I=new R(L);if(this._first===R.Undefined)this._first=I,this._last=I;else if(T){const b=this._last;this._last=I,I.prev=b,b.next=I}else{const b=this._first;this._first=I,I.next=b,b.prev=I}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(I))}}shift(){if(this._first!==R.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==R.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==R.Undefined&&L.next!==R.Undefined){const T=L.prev;T.next=L.next,L.next.prev=T}else L.prev===R.Undefined&&L.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):L.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):L.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==R.Undefined;)yield L.element,L=L.next}}e.LinkedList=n}),function(){function Q(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function T(E){L.push(E,Date.now())}function I(){const E=[];for(let b=0;b<L.length;b+=2)E.push({name:L[b],startTime:L[b+1]});return E}return{mark:T,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))L.push({name:T.name,startTime:Math.round(D+T.startTime)});return L}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function R(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=R(n))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var n in R)(typeof exports=="object"?exports:Q)[n]=R[n]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function R(n){if(e[n])return e[n].exports;var D=e[n]={i:n,l:!1,exports:{}};return Q[n].call(D.exports,D,D.exports,R),D.l=!0,D.exports}return R.m=Q,R.c=e,R.d=function(n,D,L){R.o(n,D)||Object.defineProperty(n,D,{enumerable:!0,get:L})},R.r=function(n){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},R.t=function(n,D){if(1&D&&(n=R(n)),8&D||4&D&&typeof n=="object"&&n&&n.__esModule)return n;var L=Object.create(null);if(R.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:n}),2&D&&typeof n!="string")for(var T in n)R.d(L,T,function(I){return n[I]}.bind(null,T));return L},R.n=function(n){var D=n&&n.__esModule?function(){return n.default}:function(){return n};return R.d(D,"a",D),D},R.o=function(n,D){return Object.prototype.hasOwnProperty.call(n,D)},R.p="",R(R.s=0)}([function(Q,e,R){(function(n){var D;e=Q.exports=U,D=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],E=e.src=[],b=0,C=b++;E[C]="0|[1-9]\\d*";var y=b++;E[y]="[0-9]+";var m=b++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=b++;E[v]="("+E[C]+")\\.("+E[C]+")\\.("+E[C]+")";var h=b++;E[h]="("+E[y]+")\\.("+E[y]+")\\.("+E[y]+")";var S=b++;E[S]="(?:"+E[C]+"|"+E[m]+")";var P=b++;E[P]="(?:"+E[y]+"|"+E[m]+")";var p=b++;E[p]="(?:-("+E[S]+"(?:\\."+E[S]+")*))";var g=b++;E[g]="(?:-?("+E[P]+"(?:\\."+E[P]+")*))";var a=b++;E[a]="[0-9A-Za-z-]+";var f=b++;E[f]="(?:\\+("+E[a]+"(?:\\."+E[a]+")*))";var l=b++,i="v?"+E[v]+E[p]+"?"+E[f]+"?";E[l]="^"+i+"$";var s="[v=\\s]*"+E[h]+E[g]+"?"+E[f]+"?",t=b++;E[t]="^"+s+"$";var r=b++;E[r]="((?:<|>)?=?)";var o=b++;E[o]=E[y]+"|x|X|\\*";var c=b++;E[c]=E[C]+"|x|X|\\*";var u=b++;E[u]="[v=\\s]*("+E[c]+")(?:\\.("+E[c]+")(?:\\.("+E[c]+")(?:"+E[p]+")?"+E[f]+"?)?)?";var d=b++;E[d]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[g]+")?"+E[f]+"?)?)?";var w=b++;E[w]="^"+E[r]+"\\s*"+E[u]+"$";var A=b++;E[A]="^"+E[r]+"\\s*"+E[d]+"$";var O=b++;E[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=b++;E[_]="(?:~>?)";var M=b++;E[M]="(\\s*)"+E[_]+"\\s+",I[M]=new RegExp(E[M],"g");var k=b++;E[k]="^"+E[_]+E[u]+"$";var F=b++;E[F]="^"+E[_]+E[d]+"$";var $=b++;E[$]="(?:\\^)";var q=b++;E[q]="(\\s*)"+E[$]+"\\s+",I[q]=new RegExp(E[q],"g");var J=b++;E[J]="^"+E[$]+E[u]+"$";var H=b++;E[H]="^"+E[$]+E[d]+"$";var K=b++;E[K]="^"+E[r]+"\\s*("+s+")$|^$";var W=b++;E[W]="^"+E[r]+"\\s*("+i+")$|^$";var B=b++;E[B]="(\\s*)"+E[r]+"\\s*("+s+"|"+E[u]+")",I[B]=new RegExp(E[B],"g");var Y=b++;E[Y]="^\\s*("+E[u]+")\\s+-\\s+("+E[u]+")\\s*$";var te=b++;E[te]="^\\s*("+E[d]+")\\s+-\\s+("+E[d]+")\\s*$";var ce=b++;E[ce]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)D(z,E[z]),I[z]||(I[z]=new RegExp(E[z]));function V(ae,de){if(ae instanceof U)return ae;if(typeof ae!="string"||ae.length>L||!(de?I[t]:I[l]).test(ae))return null;try{return new U(ae,de)}catch{return null}}function U(ae,de){if(ae instanceof U){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(ae,de);D("SemVer",ae,de),this.loose=de;var fe=ae.trim().match(de?I[t]:I[l]);if(!fe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Ie=+Ce;if(Ie>=0&&Ie<T)return Ie}return Ce}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=V,e.valid=function(ae,de){var fe=V(ae,de);return fe?fe.version:null},e.clean=function(ae,de){var fe=V(ae.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ae){return D("SemVer.compare",this.version,this.loose,ae),ae instanceof U||(ae=new U(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},U.prototype.compareMain=function(ae){return ae instanceof U||(ae=new U(ae,this.loose)),j(this.major,ae.major)||j(this.minor,ae.minor)||j(this.patch,ae.patch)},U.prototype.comparePre=function(ae){if(ae instanceof U||(ae=new U(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],Ce=ae.prerelease[de];if(D("prerelease compare",de,fe,Ce),fe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ce)return j(fe,Ce)}while(++de)},U.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,fe,Ce){typeof fe=="string"&&(Ce=fe,fe=void 0);try{return new U(ae,fe).inc(de,Ce).version}catch{return null}},e.diff=function(ae,de){if(X(ae,de))return null;var fe=V(ae),Ce=V(de);if(fe.prerelease.length||Ce.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==Ce[Ie])return Ie},e.compareIdentifiers=j;var N=/^[0-9]+$/;function j(ae,de){var fe=N.test(ae),Ce=N.test(de);return fe&&Ce&&(ae=+ae,de=+de),fe&&!Ce?-1:Ce&&!fe?1:ae<de?-1:ae>de?1:0}function x(ae,de,fe){return new U(ae,fe).compare(new U(de,fe))}function Z(ae,de,fe){return x(ae,de,fe)>0}function oe(ae,de,fe){return x(ae,de,fe)<0}function X(ae,de,fe){return x(ae,de,fe)===0}function ie(ae,de,fe){return x(ae,de,fe)!==0}function se(ae,de,fe){return x(ae,de,fe)>=0}function ue(ae,de,fe){return x(ae,de,fe)<=0}function he(ae,de,fe,Ce){var Ie;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae===fe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae!==fe;break;case"":case"=":case"==":Ie=X(ae,fe,Ce);break;case"!=":Ie=ie(ae,fe,Ce);break;case">":Ie=Z(ae,fe,Ce);break;case">=":Ie=se(ae,fe,Ce);break;case"<":Ie=oe(ae,fe,Ce);break;case"<=":Ie=ue(ae,fe,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function ve(ae,de){if(ae instanceof ve){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof ve))return new ve(ae,de);D("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ae,de){return j(de,ae)},e.major=function(ae,de){return new U(ae,de).major},e.minor=function(ae,de){return new U(ae,de).minor},e.patch=function(ae,de){return new U(ae,de).patch},e.compare=x,e.compareLoose=function(ae,de){return x(ae,de,!0)},e.rcompare=function(ae,de,fe){return x(de,ae,fe)},e.sort=function(ae,de){return ae.sort(function(fe,Ce){return e.compare(fe,Ce,de)})},e.rsort=function(ae,de){return ae.sort(function(fe,Ce){return e.rcompare(fe,Ce,de)})},e.gt=Z,e.lt=oe,e.eq=X,e.neq=ie,e.gte=se,e.lte=ue,e.cmp=he,e.Comparator=ve;var we={};function Ee(ae,de){if(ae instanceof Ee)return ae.loose===de?ae:new Ee(ae.raw,de);if(ae instanceof ve)return new Ee(ae.value,de);if(!(this instanceof Ee))return new Ee(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee){return((de=Pe(fe)?"":Pe(Ce)?">="+fe+".0.0":Pe(Ie)?">="+fe+"."+Ce+".0":">="+de)+" "+($e=Pe(Ae)?"":Pe(Fe)?"<"+(+Ae+1)+".0.0":Pe(_e)?"<"+Ae+"."+(+Fe+1)+".0":ke?"<="+Ae+"."+Fe+"."+_e+"-"+ke:"<="+$e)).trim()}function ze(ae,de){for(var fe=0;fe<ae.length;fe++)if(!ae[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ae.length;fe++)if(D(ae[fe].semver),ae[fe].semver!==we&&ae[fe].semver.prerelease.length>0){var Ce=ae[fe].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ve(ae,de,fe){try{de=new Ee(de,fe)}catch{return!1}return de.test(ae)}function We(ae,de,fe,Ce){var Ie,Me,De,$e,Ae;switch(ae=new U(ae,Ce),de=new Ee(de,Ce),fe){case">":Ie=Z,Me=ue,De=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=se,De=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ve(ae,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var _e=de.set[Fe],ke=null,ee=null;if(_e.forEach(function(le){le.semver===we&&(le=new ve(">=0.0.0")),ke=ke||le,ee=ee||le,Ie(le.semver,ke.semver,Ce)?ke=le:De(le.semver,ee.semver,Ce)&&(ee=le)}),ke.operator===$e||ke.operator===Ae||(!ee.operator||ee.operator===$e)&&Me(ae,ee.semver)||ee.operator===Ae&&De(ae,ee.semver))return!1}return!0}ve.prototype.parse=function(ae){var de=this.loose?I[K]:I[W],fe=ae.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ae);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new U(fe[2],this.loose):this.semver=we},ve.prototype.toString=function(){return this.value},ve.prototype.test=function(ae){return D("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new U(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},ve.prototype.intersects=function(ae,de){if(!(ae instanceof ve))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ee(ae.value,de),Ve(this.value,fe,de);if(ae.operator==="")return fe=new Ee(this.value,de),Ve(ae.semver,fe,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return Ce||Ie||Me&&De||$e||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),D("range",ae,de);var fe=de?I[te]:I[Y];ae=ae.replace(fe,Ue),D("hyphen replace",ae),ae=ae.replace(I[B],"$1$2$3"),D("comparator trim",ae,I[B]),ae=(ae=(ae=ae.replace(I[M],"$1~")).replace(I[q],"$1^")).split(/\s+/).join(" ");var Ce=de?I[K]:I[W],Ie=ae.split(" ").map(function(Me){return function(De,$e){return D("comp",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){D("caret",ke,ee);var le=ee?I[H]:I[J];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return D("caret",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=ge==="0"?">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+".0 <"+(+ge+1)+".0.0":Re?(D("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+Re+" <"+(+ge+1)+".0.0"):(D("no pr"),Te=ge==="0"?Se==="0"?">="+ge+"."+Se+"."+be+" <"+ge+"."+Se+"."+(+be+1):">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0":">="+ge+"."+Se+"."+be+" <"+(+ge+1)+".0.0"),D("caret return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),D("caret",De),De=function(Ae,Fe){return Ae.trim().split(/\s+/).map(function(_e){return function(ke,ee){var le=ee?I[F]:I[k];return ke.replace(le,function(me,ge,Se,be,Re){var Te;return D("tilde",ke,me,ge,Se,be,Re),Pe(ge)?Te="":Pe(Se)?Te=">="+ge+".0.0 <"+(+ge+1)+".0.0":Pe(be)?Te=">="+ge+"."+Se+".0 <"+ge+"."+(+Se+1)+".0":Re?(D("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Te=">="+ge+"."+Se+"."+be+Re+" <"+ge+"."+(+Se+1)+".0"):Te=">="+ge+"."+Se+"."+be+" <"+ge+"."+(+Se+1)+".0",D("tilde return",Te),Te})}(_e,Fe)}).join(" ")}(De,$e),D("tildes",De),De=function(Ae,Fe){return D("replaceXRanges",Ae,Fe),Ae.split(/\s+/).map(function(_e){return function(ke,ee){ke=ke.trim();var le=ee?I[A]:I[w];return ke.replace(le,function(me,ge,Se,be,Re,Te){D("xRange",ke,me,ge,Se,be,Re,Te);var qe=Pe(Se),Le=qe||Pe(be),Ne=Le||Pe(Re);return ge==="="&&Ne&&(ge=""),qe?me=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ne?(Le&&(be=0),Ne&&(Re=0),ge===">"?(ge=">=",Le?(Se=+Se+1,be=0,Re=0):Ne&&(be=+be+1,Re=0)):ge==="<="&&(ge="<",Le?Se=+Se+1:be=+be+1),me=ge+Se+"."+be+"."+Re):Le?me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ne&&(me=">="+Se+"."+be+".0 <"+Se+"."+(+be+1)+".0"),D("xRange return",me),me})}(_e,Fe)}).join(" ")}(De,$e),D("xrange",De),De=function(Ae,Fe){return D("replaceStars",Ae,Fe),Ae.trim().replace(I[ce],"")}(De,$e),D("stars",De),De}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(Ce)})),Ie=Ie.map(function(Me){return new ve(Me,de)})},Ee.prototype.intersects=function(ae,de){if(!(ae instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ce){return ae.set.some(function(Ie){return Ie.every(function(Me){return Ce.intersects(Me,de)})})})})},e.toComparators=function(ae,de){return new Ee(ae,de).set.map(function(fe){return fe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new U(ae,this.loose));for(var de=0;de<this.set.length;de++)if(ze(this.set[de],ae))return!0;return!1},e.satisfies=Ve,e.maxSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==-1||(Ie=new U(Ce=De,fe)))}),Ce},e.minSatisfying=function(ae,de,fe){var Ce=null,Ie=null;try{var Me=new Ee(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(Ce&&Ie.compare(De)!==1||(Ie=new U(Ce=De,fe)))}),Ce},e.validRange=function(ae,de){try{return new Ee(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,fe){return We(ae,de,"<",fe)},e.gtr=function(ae,de,fe){return We(ae,de,">",fe)},e.outside=We,e.prerelease=function(ae,de){var fe=V(ae,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ae,de,fe){return ae=new Ee(ae,fe),de=new Ee(de,fe),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof U)return ae;if(typeof ae!="string")return null;var de=ae.match(I[O]);return de==null?null:V((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,R(1))},function(Q,e){var R,n,D=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function I(P){if(R===setTimeout)return setTimeout(P,0);if((R===L||!R)&&setTimeout)return R=setTimeout,setTimeout(P,0);try{return R(P,0)}catch{try{return R.call(null,P,0)}catch{return R.call(this,P,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:L}catch{R=L}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var E,b=[],C=!1,y=-1;function m(){C&&E&&(C=!1,E.length?b=E.concat(b):y=-1,b.length&&v())}function v(){if(!C){var P=I(m);C=!0;for(var p=b.length;p;){for(E=b,b=[];++y<p;)E&&E[y].run();y=-1,p=b.length}E=null,C=!1,function(g){if(n===clearTimeout)return clearTimeout(g);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(g);try{n(g)}catch{try{return n.call(null,g)}catch{return n.call(this,g)}}}(P)}}function h(P,p){this.fun=P,this.array=p}function S(){}D.nextTick=function(P){var p=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)p[g-1]=arguments[g];b.push(new h(P,p)),b.length!==1||C||I(v)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=S,D.addListener=S,D.once=S,D.off=S,D.removeListener=S,D.removeAllListeners=S,D.emit=S,D.prependListener=S,D.prependOnceListener=S,D.listeners=function(P){return[]},D.binding=function(P){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(P){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[117],re([0,1]),function(Q,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(I,E,b){this.level=I,this.key=E,this.value=b,this.forward=[]}}const D=void 0;class L{constructor(I,E=2**16){this.comparator=I,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new n(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,D,D)}has(I){return Boolean(L._search(this,I,this.comparator))}get(I){return L._search(this,I,this.comparator)?.value}set(I,E){return L._insert(this,I,E,this.comparator)&&(this._size+=1),this}delete(I){const E=L._delete(this,I,this.comparator);return E&&(this._size-=1),E}forEach(I,E){let b=this._header.forward[0];for(;b;)I.call(E,b.value,b.key,this),b=b.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",E=this._header.forward[0];for(;E;)I+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return I}static _search(I,E,b){let C=I._header;for(let y=I._level-1;y>=0;y--)for(;C.forward[y]&&b(C.forward[y].key,E)<0;)C=C.forward[y];if(C=C.forward[0],C&&b(C.key,E)===0)return C}static _insert(I,E,b,C){const y=[];let m=I._header;for(let v=I._level-1;v>=0;v--){for(;m.forward[v]&&C(m.forward[v].key,E)<0;)m=m.forward[v];y[v]=m}if(m=m.forward[0],m&&C(m.key,E)===0)return m.value=b,!1;{const v=L._randomLevel(I);if(v>I._level){for(let h=I._level;h<v;h++)y[h]=I._header;I._level=v}m=new n(v,E,b);for(let h=0;h<v;h++)m.forward[h]=y[h].forward[h],y[h].forward[h]=m;return!0}}static _randomLevel(I,E=.5){let b=1;for(;Math.random()<E&&b<I._maxLevel;)b+=1;return b}static _delete(I,E,b){const C=[];let y=I._header;for(let m=I._level-1;m>=0;m--){for(;y.forward[m]&&b(y.forward[m].key,E)<0;)y=y.forward[m];C[m]=y}if(y=y.forward[0],!y||b(y.key,E)!==0)return!1;for(let m=0;m<I._level&&C[m].forward[m]===y;m++)C[m].forward[m]=y.forward[m];for(;I._level>0&&I._header.forward[I._level-1]===D;)I._level-=1;return!0}}e.SkipList=L}),define(ne[41],re([0,1,9,2]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(f){const l=f;return l?typeof l.read=="function":!1}e.isReadable=D;function L(f){const l=f;return l?[l.on,l.pause,l.resume,l.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function T(f){const l=f;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function I(f,l){return new E(f,l)}e.newWriteableStream=I;class E{constructor(l,i){this.reducer=l,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l<"u"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(i=>i(l))}emitError(l){this.listeners.error.length===0?(0,R.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(i=>i(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,i){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(l,i){if(this.state.destroyed)return;let s;switch(l){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const t=s.indexOf(i);t>=0&&s.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(f,l){const i=[];let s;for(;(s=f.read())!==null;)i.push(s);return l(i)}e.consumeReadable=b;function C(f,l,i){const s=[];let t;for(;(t=f.read())!==null&&s.length<i;)s.push(t);return t===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return f.read()}}}e.peekReadable=C;function y(f,l){return new Promise((i,s)=>{const t=[];m(f,{onData:r=>{l&&t.push(r)},onError:r=>{l?s(r):i(void 0)},onEnd:()=>{i(l?l(t):void 0)}})})}e.consumeStream=y;function m(f,l){let i=!1;return f.on("error",s=>{i||l.onError(s)}),f.on("end",()=>{i||l.onEnd()}),f.on("data",s=>{i||l.onData(s)}),(0,n.toDisposable)(()=>i=!0)}e.listenStream=m;function v(f,l){return new Promise((i,s)=>{const t=new n.DisposableStore,r=[],o=d=>{if(r.push(d),r.length>l)return t.dispose(),f.pause(),i({stream:f,buffer:r,ended:!1})},c=d=>s(d),u=()=>i({stream:f,buffer:r,ended:!0});t.add((0,n.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),t.add((0,n.toDisposable)(()=>f.removeListener("end",u))),f.on("end",u),t.add((0,n.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=v;function h(f,l){const i=I(l);return i.end(f),i}e.toStream=h;function S(){const f=I(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function P(f){let l=!1;return{read:()=>l?null:(l=!0,f)}}e.toReadable=P;function p(f,l,i){const s=I(i);return m(f,{onData:t=>s.write(l.data(t)),onError:t=>s.error(l.error?l.error(t):t),onEnd:()=>s.end()}),s}e.transform=p;function g(f,l,i){let s=!1;return{read:()=>{const t=l.read();return s?t:(s=!0,t!==null?i([f,t]):f)}}}e.prefixedReadable=g;function a(f,l,i){let s=!1;const t=I(i);return m(l,{onData:r=>s?t.write(r):(s=!0,t.write(i([f,r]))),onError:r=>t.error(r),onEnd:()=>{s||(s=!0,t.write(f)),t.end()}}),t}e.prefixedStream=a}),define(ne[16],re([0,1,41]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer<"u";let D,L;class T{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return n?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return n&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,w){return!(w?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(d)):(D||(D=new TextEncoder),new T(D.encode(d)))}static fromByteArray(d){const w=T.alloc(d.length);for(let A=0,O=d.length;A<O;A++)w.buffer[A]=d[A];return w}static concat(d,w){if(typeof w>"u"){w=0;for(let _=0,M=d.length;_<M;_++)w+=d[_].byteLength}const A=T.alloc(w);let O=0;for(let _=0,M=d.length;_<M;_++){const k=d[_];A.set(k,O),O+=k.byteLength}return A}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return n?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(d,w){return new T(this.buffer.subarray(d,w))}set(d,w){if(d instanceof T)this.buffer.set(d.buffer,w);else if(d instanceof Uint8Array)this.buffer.set(d,w);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),w);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return b(this.buffer,d)}writeUInt32BE(d,w){C(this.buffer,d,w)}readUInt32LE(d){return y(this.buffer,d)}writeUInt32LE(d,w){m(this.buffer,d,w)}readUInt8(d){return v(this.buffer,d)}writeUInt8(d,w){h(this.buffer,d,w)}}e.VSBuffer=T;function I(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0}e.readUInt16LE=I;function E(u,d,w){u[w+0]=d&255,d=d>>>8,u[w+1]=d&255}e.writeUInt16LE=E;function b(u,d){return u[d]*2**24+u[d+1]*2**16+u[d+2]*2**8+u[d+3]}e.readUInt32BE=b;function C(u,d,w){u[w+3]=d,d=d>>>8,u[w+2]=d,d=d>>>8,u[w+1]=d,d=d>>>8,u[w]=d}e.writeUInt32BE=C;function y(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0|u[d+2]<<16>>>0|u[d+3]<<24>>>0}e.readUInt32LE=y;function m(u,d,w){u[w+0]=d&255,d=d>>>8,u[w+1]=d&255,d=d>>>8,u[w+2]=d&255,d=d>>>8,u[w+3]=d&255}e.writeUInt32LE=m;function v(u,d){return u[d]}e.readUInt8=v;function h(u,d,w){u[w]=d}e.writeUInt8=h;function S(u){return R.consumeReadable(u,d=>T.concat(d))}e.readableToBuffer=S;function P(u){return R.toReadable(u)}e.bufferToReadable=P;function p(u){return R.consumeStream(u,d=>T.concat(d))}e.streamToBuffer=p;async function g(u){return u.ended?T.concat(u.buffer):T.concat([...u.buffer,await p(u.stream)])}e.bufferedStreamToBuffer=g;function a(u){return R.toStream(u,d=>T.concat(d))}e.bufferToStream=a;function f(u){return R.transform(u,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}e.streamToBufferReadableStream=f;function l(u){return R.newWriteableStream(d=>T.concat(d),u)}e.newWriteableBufferStream=l;function i(u,d){return R.prefixedReadable(u,d,w=>T.concat(w))}e.prefixedBufferReadable=i;function s(u,d){return R.prefixedStream(u,d,w=>T.concat(w))}e.prefixedBufferStream=s;function t(u){let d=0,w=0,A=0;const O=new Uint8Array(Math.floor(u.length/4*3)),_=k=>{switch(w){case 3:O[A++]=d|k,w=0;break;case 2:O[A++]=d|k>>>2,d=k<<6,w=3;break;case 1:O[A++]=d|k>>>4,d=k<<4,w=2;break;default:d=k<<2,w=1}};for(let k=0;k<u.length;k++){const F=u.charCodeAt(k);if(F>=65&&F<=90)_(F-65);else if(F>=97&&F<=122)_(F-97+26);else if(F>=48&&F<=57)_(F-48+52);else if(F===43||F===45)_(62);else if(F===47||F===95)_(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${u[k]}`)}}const M=A;for(;w>0;)_(0);return T.wrap(O).slice(0,M)}e.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:u},d=!0,w=!1){const A=w?o:r;let O="";const _=u.byteLength%3;let M=0;for(;M<u.byteLength-_;M+=3){const k=u[M+0],F=u[M+1],$=u[M+2];O+=A[k>>>2],O+=A[(k<<4|F>>>4)&63],O+=A[(F<<2|$>>>6)&63],O+=A[$&63]}if(_===1){const k=u[M+0];O+=A[k>>>2],O+=A[k<<4&63],d&&(O+="==")}else if(_===2){const k=u[M+0],F=u[M+1];O+=A[k>>>2],O+=A[(k<<4|F>>>4)&63],O+=A[F<<2&63],d&&(O+="=")}return O}e.encodeBase64=c}),define(ne[14],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(s){return typeof s=="string"}e.isString=R;function n(s){return Array.isArray(s)&&s.every(t=>R(t))}e.isStringArray=n;function D(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=D;function L(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}e.isTypedArray=L;function T(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=T;function I(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=I;function E(s){return s===!0||s===!1}e.isBoolean=E;function b(s){return typeof s>"u"}e.isUndefined=b;function C(s){return!y(s)}e.isDefined=C;function y(s){return b(s)||s===null}e.isUndefinedOrNull=y;function m(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function v(s){if(y(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=v;function h(...s){const t=[];for(let r=0;r<s.length;r++){const o=s[r];if(y(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const S=Object.prototype.hasOwnProperty;function P(s){if(!D(s))return!1;for(const t in s)if(S.call(s,t))return!1;return!0}e.isEmptyObject=P;function p(s){return typeof s=="function"}e.isFunction=p;function g(...s){return s.length>0&&s.every(p)}e.areFunctions=g;function a(s,t){const r=Math.min(s.length,t.length);for(let o=0;o<r;o++)f(s[o],t[o])}e.validateConstraints=a;function f(s,t){if(R(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(p(t)){try{if(s instanceof t)return}catch{}if(!y(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function l(s){return s===null?void 0:s}e.withNullAsUndefined=l;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ne[31],re([0,1,14]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const g=Array.isArray(p)?[]:{};return Object.keys(p).forEach(a=>{p[a]&&typeof p[a]=="object"?g[a]=n(p[a]):g[a]=p[a]}),g}e.deepClone=n;function D(p){if(!p||typeof p!="object")return p;const g=[p];for(;g.length>0;){const a=g.shift();Object.freeze(a);for(const f in a)if(L.call(a,f)){const l=a[f];typeof l=="object"&&!Object.isFrozen(l)&&!(0,R.isTypedArray)(l)&&g.push(l)}}return p}e.deepFreeze=D;const L=Object.prototype.hasOwnProperty;function T(p,g){return I(p,g,new Set)}e.cloneAndChange=T;function I(p,g,a){if((0,R.isUndefinedOrNull)(p))return p;const f=g(p);if(typeof f<"u")return f;if(Array.isArray(p)){const l=[];for(const i of p)l.push(I(i,g,a));return l}if((0,R.isObject)(p)){if(a.has(p))throw new Error("Cannot clone recursive data-structure");a.add(p);const l={};for(const i in p)L.call(p,i)&&(l[i]=I(p[i],g,a));return a.delete(p),l}return p}function E(p,g,a=!0){return(0,R.isObject)(p)?((0,R.isObject)(g)&&Object.keys(g).forEach(f=>{f in p?a&&((0,R.isObject)(p[f])&&(0,R.isObject)(g[f])?E(p[f],g[f],a):p[f]=g[f]):p[f]=g[f]}),p):g}e.mixin=E;function b(p,g){if(p===g)return!0;if(p==null||g===null||g===void 0||typeof p!=typeof g||typeof p!="object"||Array.isArray(p)!==Array.isArray(g))return!1;let a,f;if(Array.isArray(p)){if(p.length!==g.length)return!1;for(a=0;a<p.length;a++)if(!b(p[a],g[a]))return!1}else{const l=[];for(f in p)l.push(f);l.sort();const i=[];for(f in g)i.push(f);if(i.sort(),!b(l,i))return!1;for(a=0;a<l.length;a++)if(!b(p[l[a]],g[l[a]]))return!1}return!0}e.equals=b;function C(p){const g=new Set;return JSON.stringify(p,(a,f)=>{if((0,R.isObject)(f)||Array.isArray(f)){if(g.has(f))return"[Circular]";g.add(f)}return f})}e.safeStringify=C;function y(p,g){const a=Object.create(null);return!p||!g||Object.keys(g).forEach(l=>{const i=p[l],s=g[l];b(i,s)||(a[l]=s)}),a}e.distinct=y;function m(p,g){const a=g.toLowerCase(),f=Object.keys(p).find(l=>l.toLowerCase()===a);return f?p[f]:p[g]}e.getCaseInsensitive=m;function v(p,g){const a=Object.create(null);for(const[f,l]of Object.entries(p))g(f,l)&&(a[f]=l);return a}e.filter=v;function h(p){let g=[],a=Object.getPrototypeOf(p);for(;Object.prototype!==a;)g=g.concat(Object.getOwnPropertyNames(a)),a=Object.getPrototypeOf(a);return g}e.getAllPropertyNames=h;function S(p){const g=[];for(const a of h(p))typeof p[a]=="function"&&g.push(a);return g}e.getAllMethodNames=S;function P(p,g){const a=l=>function(){const i=Array.prototype.slice.call(arguments,0);return g(l,i)},f={};for(const l of p)f[l]=a(l);return f}e.createProxyObject=P}),define(ne[30],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(D){return R.test(D)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(I){for(let E=0;E<I.length;E++)I[E]=Math.floor(Math.random()*256);return I};const L=new Uint8Array(16),T=[];for(let I=0;I<256;I++)T.push(I.toString(16).padStart(2,"0"));return function(){D(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,b="";return b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+="-",b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b+=T[L[E++]],b}}()}),define(ne[118],re([0,1,37]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(T){const I=T.replace(/\-/g,":").toLowerCase();return!n.has(I)}function L(){const T=(0,R.networkInterfaces)();for(const I in T){const E=T[I];if(E){for(const{mac:b}of E)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(ne[119],re([0,1,80]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(I,E,b,C=1){let y=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!y)return y=!0,m(0)},b);D(I,E,C,h=>{if(!y)return y=!0,clearTimeout(v),m(h)})})}e.findFreePort=n;function D(I,E,b,C){if(E===0)return C(0);const y=new R.Socket;y.once("connect",()=>(T(y),D(I+b,E-1,b,C))),y.once("data",()=>{}),y.once("error",m=>(T(y),m.code!=="ECONNREFUSED"?D(I+b,E-1,b,C):C(I))),y.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(I,E,b){let C=!1,y,m=1;const v=R.createServer({pauseOnConnect:!0});function h(S,P){C||(C=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),P(S))}return new Promise(S=>{y=setTimeout(()=>{h(0,S)},b),v.on("listening",()=>{h(I,S)}),v.on("error",P=>{P&&(P.code==="EADDRINUSE"||P.code==="EACCES")&&m<E?(I++,m++,v.listen(I,"127.0.0.1")):h(0,S)}),v.on("close",()=>{h(0,S)}),v.listen(I,"127.0.0.1")})}e.findFreePortFaster=L;function T(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(E){console.error(E)}}}),define(ne[120],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function n(L){return L instanceof D?!0:L instanceof Error&&L.name===R&&L.message===R}e.isOfflineError=n;class D extends Error{constructor(){super(R),this.name=this.message}}e.OfflineError=D}),define(ne[121],re([0,1,16,9,120]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(E,b){if(!navigator.onLine)throw new D.OfflineError;E.proxyAuthorization&&(E.headers={...E.headers||{},"Proxy-Authorization":E.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((y,m)=>{C.open(E.type||"GET",E.url||"",!0,E.user,E.password),T(C,E),C.responseType="arraybuffer",C.onerror=v=>m(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=v=>{y({res:{statusCode:C.status,headers:I(C)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=v=>m(new Error(`XHR timeout: ${E.timeout}ms`)),E.timeout&&(C.timeout=E.timeout),C.send(E.data),b.onCancellationRequested(()=>{C.abort(),m((0,n.canceled)())})})}e.request=L;function T(E,b){if(b.headers){e:for(const C in b.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}E.setRequestHeader(C,b.headers[C])}}}function I(E){const b=Object.create(null);for(const C of E.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const y=C.indexOf(":");b[C.substr(0,y).trim().toLowerCase()]=C.substr(y+1).trim()}return b}}),define(ne[122],re([10,11]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(ne[63],re([0,1,122]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,L=D*24,T=L*7,I=L*30,E=L*365;function b(y,m,v){typeof y!="number"&&(y=y.getTime());const h=Math.round((new Date().getTime()-y)/1e3);if(h<-30)return(0,R.localize)(0,null,b(new Date().getTime()+h*1e3,!1));if(h<30)return(0,R.localize)(1,null);let S;return h<n?(S=h,m?S===1?v?(0,R.localize)(2,null,S):(0,R.localize)(3,null,S):v?(0,R.localize)(4,null,S):(0,R.localize)(5,null,S):S===1?v?(0,R.localize)(6,null,S):(0,R.localize)(7,null,S):v?(0,R.localize)(8,null,S):(0,R.localize)(9,null,S)):h<D?(S=Math.floor(h/n),m?S===1?v?(0,R.localize)(10,null,S):(0,R.localize)(11,null,S):v?(0,R.localize)(12,null,S):(0,R.localize)(13,null,S):S===1?v?(0,R.localize)(14,null,S):(0,R.localize)(15,null,S):v?(0,R.localize)(16,null,S):(0,R.localize)(17,null,S)):h<L?(S=Math.floor(h/D),m?S===1?v?(0,R.localize)(18,null,S):(0,R.localize)(19,null,S):v?(0,R.localize)(20,null,S):(0,R.localize)(21,null,S):S===1?v?(0,R.localize)(22,null,S):(0,R.localize)(23,null,S):v?(0,R.localize)(24,null,S):(0,R.localize)(25,null,S)):h<T?(S=Math.floor(h/L),m?S===1?(0,R.localize)(26,null,S):(0,R.localize)(27,null,S):S===1?(0,R.localize)(28,null,S):(0,R.localize)(29,null,S)):h<I?(S=Math.floor(h/T),m?S===1?v?(0,R.localize)(30,null,S):(0,R.localize)(31,null,S):v?(0,R.localize)(32,null,S):(0,R.localize)(33,null,S):S===1?v?(0,R.localize)(34,null,S):(0,R.localize)(35,null,S):v?(0,R.localize)(36,null,S):(0,R.localize)(37,null,S)):h<E?(S=Math.floor(h/I),m?S===1?v?(0,R.localize)(38,null,S):(0,R.localize)(39,null,S):v?(0,R.localize)(40,null,S):(0,R.localize)(41,null,S):S===1?v?(0,R.localize)(42,null,S):(0,R.localize)(43,null,S):v?(0,R.localize)(44,null,S):(0,R.localize)(45,null,S)):(S=Math.floor(h/E),m?S===1?v?(0,R.localize)(46,null,S):(0,R.localize)(47,null,S):v?(0,R.localize)(48,null,S):(0,R.localize)(49,null,S):S===1?v?(0,R.localize)(50,null,S):(0,R.localize)(51,null,S):v?(0,R.localize)(52,null,S):(0,R.localize)(53,null,S))}e.fromNow=b;function C(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(ne[123],re([10,11]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,18,14,123]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(y,m){return m&&(y.stack||y.stacktrace)?D.localize(0,null,I(y),T(y.stack)||T(y.stacktrace)):I(y)}function T(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?D.localize(1,null,y.message):y.message||D.localize(2,null)}function E(y=null,m=!1){if(!y)return D.localize(3,null);if(Array.isArray(y)){const v=R.coalesce(y),h=E(v[0],m);return v.length>1?D.localize(4,null,h,v.length):h}if(n.isString(y))return y;if(y.detail){const v=y.detail;if(v.error)return L(v.error,m);if(v.exception)return L(v.exception,m)}return y.stack?L(y,m):y.message?y.message:D.localize(5,null)}e.toErrorMessage=E;function b(y){const m=y;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=b;function C(y,m){let v;return typeof y=="string"?v=new Error(y):v=y,v.actions=m,v}e.createErrorWithActions=C}),define(ne[124],re([10,11]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(ne[125],re([0,1,124]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(D){switch(D){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(ne[126],re([10,11]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,126]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let D=!1,L=!1,T=!1,I=!1,E=!1,b=!1,C=!1,y=!1,m=!1,v=!1,h,S=n,P,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?g=e.globals.vscode.process:typeof process<"u"&&(g=process);const a=typeof g?.versions?.electron=="string",f=a&&g?.type==="renderer";if(typeof navigator=="object"&&!f)p=navigator.userAgent,D=p.indexOf("Windows")>=0,L=p.indexOf("Macintosh")>=0,y=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=p.indexOf("Linux")>=0,v=p?.indexOf("Mobi")>=0,b=!0,h=R.getConfiguredDefaultLocale(R.localize(0,null))||n,S=h;else if(typeof g=="object"){D=g.platform==="win32",L=g.platform==="darwin",T=g.platform==="linux",I=T&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,C=a,m=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=n,S=n;const d=g.env.VSCODE_NLS_CONFIG;if(d)try{const w=JSON.parse(d),A=w.availableLanguages["*"];h=w.locale,S=A||n,P=w._translationsConfigFile}catch{}E=!0}else console.error("Unable to resolve platform.");var l;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(l=e.Platform||(e.Platform={}));function i(d){switch(d){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=i;let s=0;L?s=1:D?s=3:T&&(s=2),e.isWindows=D,e.isMacintosh=L,e.isLinux=T,e.isLinuxSnap=I,e.isNative=E,e.isElectron=C,e.isWeb=b,e.isWebWorker=b&&typeof e.globals.importScripts=="function",e.isIOS=y,e.isMobile=v,e.isCI=m,e.platform=s,e.userAgent=p,e.language=S;var t;(function(d){function w(){return e.language}d.value=w;function A(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}d.isDefaultVariant=A;function O(){return e.language==="en"}d.isDefault=O})(t=e.Language||(e.Language={})),e.locale=h,e.translationsConfigFile=P,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const d=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let O=0,_=d.length;O<_;O++){const M=d[O];if(M.id===A.data.vscodeScheduleAsyncWork){d.splice(O,1),M.callback();return}}});let w=0;return A=>{const O=++w;d.push({id:O,callback:A}),e.globals.postMessage({vscodeScheduleAsyncWork:O},"*")}}return d=>setTimeout(d)})();var r;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||y?2:D?1:3;let o=!0,c=!1;function u(){if(!c){c=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,o=new Uint16Array(d.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof R.globals.vscode<"u"&&typeof R.globals.vscode.process<"u"){const D=R.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[12],re([0,1,36]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,L=90,T=122,I=46,E=47,b=92,C=58,y=63;class m extends Error{constructor(f,l,i){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const t=f.indexOf(".")!==-1?"property":"argument";let r=`The "${f}" ${t} ${s} of type ${l}`;r+=`. Received type ${typeof i}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function v(a,f){if(typeof a!="string")throw new m(f,"string",a)}function h(a){return a===E||a===b}function S(a){return a===E}function P(a){return a>=n&&a<=L||a>=D&&a<=T}function p(a,f,l,i){let s="",t=0,r=-1,o=0,c=0;for(let u=0;u<=a.length;++u){if(u<a.length)c=a.charCodeAt(u);else{if(i(c))break;c=E}if(i(c)){if(!(r===u-1||o===1))if(o===2){if(s.length<2||t!==2||s.charCodeAt(s.length-1)!==I||s.charCodeAt(s.length-2)!==I){if(s.length>2){const d=s.lastIndexOf(l);d===-1?(s="",t=0):(s=s.slice(0,d),t=s.length-1-s.lastIndexOf(l)),r=u,o=0;continue}else if(s.length!==0){s="",t=0,r=u,o=0;continue}}f&&(s+=s.length>0?`${l}..`:"..",t=2)}else s.length>0?s+=`${l}${a.slice(r+1,u)}`:s=a.slice(r+1,u),t=u-r-1;r=u,o=0}else c===I&&o!==-1?++o:o=-1}return s}function g(a,f){if(f===null||typeof f!="object")throw new m("pathObject","Object",f);const l=f.dir||f.root,i=f.base||`${f.name||""}${f.ext||""}`;return l?l===f.root?`${l}${i}`:`${l}${a}${i}`:i}e.win32={resolve(...a){let f="",l="",i=!1;for(let s=a.length-1;s>=-1;s--){let t;if(s>=0){if(t=a[s],v(t,"path"),t.length===0)continue}else f.length===0?t=R.cwd():(t=R.env[`=${f}`]||R.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==f.toLowerCase()&&t.charCodeAt(2)===b)&&(t=`${f}\\`));const r=t.length;let o=0,c="",u=!1;const d=t.charCodeAt(0);if(r===1)h(d)&&(o=1,u=!0);else if(h(d))if(u=!0,h(t.charCodeAt(1))){let w=2,A=w;for(;w<r&&!h(t.charCodeAt(w));)w++;if(w<r&&w!==A){const O=t.slice(A,w);for(A=w;w<r&&h(t.charCodeAt(w));)w++;if(w<r&&w!==A){for(A=w;w<r&&!h(t.charCodeAt(w));)w++;(w===r||w!==A)&&(c=`\\\\${O}\\${t.slice(A,w)}`,o=w)}}}else o=1;else P(d)&&t.charCodeAt(1)===C&&(c=t.slice(0,2),o=2,r>2&&h(t.charCodeAt(2))&&(u=!0,o=3));if(c.length>0)if(f.length>0){if(c.toLowerCase()!==f.toLowerCase())continue}else f=c;if(i){if(f.length>0)break}else if(l=`${t.slice(o)}\\${l}`,i=u,u&&f.length>0)break}return l=p(l,!i,"\\",h),i?`${f}\\${l}`:`${f}${l}`||"."},normalize(a){v(a,"path");const f=a.length;if(f===0)return".";let l=0,i,s=!1;const t=a.charCodeAt(0);if(f===1)return S(t)?"\\":a;if(h(t))if(s=!0,h(a.charCodeAt(1))){let o=2,c=o;for(;o<f&&!h(a.charCodeAt(o));)o++;if(o<f&&o!==c){const u=a.slice(c,o);for(c=o;o<f&&h(a.charCodeAt(o));)o++;if(o<f&&o!==c){for(c=o;o<f&&!h(a.charCodeAt(o));)o++;if(o===f)return`\\\\${u}\\${a.slice(c)}\\`;o!==c&&(i=`\\\\${u}\\${a.slice(c,o)}`,l=o)}}}else l=1;else P(t)&&a.charCodeAt(1)===C&&(i=a.slice(0,2),l=2,f>2&&h(a.charCodeAt(2))&&(s=!0,l=3));let r=l<f?p(a.slice(l),!s,"\\",h):"";return r.length===0&&!s&&(r="."),r.length>0&&h(a.charCodeAt(f-1))&&(r+="\\"),i===void 0?s?`\\${r}`:r:s?`${i}\\${r}`:`${i}${r}`},isAbsolute(a){v(a,"path");const f=a.length;if(f===0)return!1;const l=a.charCodeAt(0);return h(l)||f>2&&P(l)&&a.charCodeAt(1)===C&&h(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let f,l;for(let t=0;t<a.length;++t){const r=a[t];v(r,"path"),r.length>0&&(f===void 0?f=l=r:f+=`\\${r}`)}if(f===void 0)return".";let i=!0,s=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++s;const t=l.length;t>1&&h(l.charCodeAt(1))&&(++s,t>2&&(h(l.charCodeAt(2))?++s:i=!1))}if(i){for(;s<f.length&&h(f.charCodeAt(s));)s++;s>=2&&(f=`\\${f.slice(s)}`)}return e.win32.normalize(f)},relative(a,f){if(v(a,"from"),v(f,"to"),a===f)return"";const l=e.win32.resolve(a),i=e.win32.resolve(f);if(l===i||(a=l.toLowerCase(),f=i.toLowerCase(),a===f))return"";let s=0;for(;s<a.length&&a.charCodeAt(s)===b;)s++;let t=a.length;for(;t-1>s&&a.charCodeAt(t-1)===b;)t--;const r=t-s;let o=0;for(;o<f.length&&f.charCodeAt(o)===b;)o++;let c=f.length;for(;c-1>o&&f.charCodeAt(c-1)===b;)c--;const u=c-o,d=r<u?r:u;let w=-1,A=0;for(;A<d;A++){const _=a.charCodeAt(s+A);if(_!==f.charCodeAt(o+A))break;_===b&&(w=A)}if(A!==d){if(w===-1)return i}else{if(u>d){if(f.charCodeAt(o+A)===b)return i.slice(o+A+1);if(A===2)return i.slice(o+A)}r>d&&(a.charCodeAt(s+A)===b?w=A:A===2&&(w=3)),w===-1&&(w=0)}let O="";for(A=s+w+1;A<=t;++A)(A===t||a.charCodeAt(A)===b)&&(O+=O.length===0?"..":"\\..");return o+=w,O.length>0?`${O}${i.slice(o,c)}`:(i.charCodeAt(o)===b&&++o,i.slice(o,c))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const f=e.win32.resolve(a);if(f.length<=2)return a;if(f.charCodeAt(0)===b){if(f.charCodeAt(1)===b){const l=f.charCodeAt(2);if(l!==y&&l!==I)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(P(f.charCodeAt(0))&&f.charCodeAt(1)===C&&f.charCodeAt(2)===b)return`\\\\?\\${f}`;return a},dirname(a){v(a,"path");const f=a.length;if(f===0)return".";let l=-1,i=0;const s=a.charCodeAt(0);if(f===1)return h(s)?a:".";if(h(s)){if(l=i=1,h(a.charCodeAt(1))){let o=2,c=o;for(;o<f&&!h(a.charCodeAt(o));)o++;if(o<f&&o!==c){for(c=o;o<f&&h(a.charCodeAt(o));)o++;if(o<f&&o!==c){for(c=o;o<f&&!h(a.charCodeAt(o));)o++;if(o===f)return a;o!==c&&(l=i=o+1)}}}}else P(s)&&a.charCodeAt(1)===C&&(l=f>2&&h(a.charCodeAt(2))?3:2,i=l);let t=-1,r=!0;for(let o=f-1;o>=i;--o)if(h(a.charCodeAt(o))){if(!r){t=o;break}}else r=!1;if(t===-1){if(l===-1)return".";t=l}return a.slice(0,t)},basename(a,f){f!==void 0&&v(f,"ext"),v(a,"path");let l=0,i=-1,s=!0,t;if(a.length>=2&&P(a.charCodeAt(0))&&a.charCodeAt(1)===C&&(l=2),f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let r=f.length-1,o=-1;for(t=a.length-1;t>=l;--t){const c=a.charCodeAt(t);if(h(c)){if(!s){l=t+1;break}}else o===-1&&(s=!1,o=t+1),r>=0&&(c===f.charCodeAt(r)?--r===-1&&(i=t):(r=-1,i=o))}return l===i?i=o:i===-1&&(i=a.length),a.slice(l,i)}for(t=a.length-1;t>=l;--t)if(h(a.charCodeAt(t))){if(!s){l=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(l,i)},extname(a){v(a,"path");let f=0,l=-1,i=0,s=-1,t=!0,r=0;a.length>=2&&a.charCodeAt(1)===C&&P(a.charCodeAt(0))&&(f=i=2);for(let o=a.length-1;o>=f;--o){const c=a.charCodeAt(o);if(h(c)){if(!t){i=o+1;break}continue}s===-1&&(t=!1,s=o+1),c===I?l===-1?l=o:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||s===-1||r===0||r===1&&l===s-1&&l===i+1?"":a.slice(l,s)},format:g.bind(null,"\\"),parse(a){v(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const l=a.length;let i=0,s=a.charCodeAt(0);if(l===1)return h(s)?(f.root=f.dir=a,f):(f.base=f.name=a,f);if(h(s)){if(i=1,h(a.charCodeAt(1))){let w=2,A=w;for(;w<l&&!h(a.charCodeAt(w));)w++;if(w<l&&w!==A){for(A=w;w<l&&h(a.charCodeAt(w));)w++;if(w<l&&w!==A){for(A=w;w<l&&!h(a.charCodeAt(w));)w++;w===l?i=w:w!==A&&(i=w+1)}}}}else if(P(s)&&a.charCodeAt(1)===C){if(l<=2)return f.root=f.dir=a,f;if(i=2,h(a.charCodeAt(2))){if(l===3)return f.root=f.dir=a,f;i=3}}i>0&&(f.root=a.slice(0,i));let t=-1,r=i,o=-1,c=!0,u=a.length-1,d=0;for(;u>=i;--u){if(s=a.charCodeAt(u),h(s)){if(!c){r=u+1;break}continue}o===-1&&(c=!1,o=u+1),s===I?t===-1?t=u:d!==1&&(d=1):t!==-1&&(d=-1)}return o!==-1&&(t===-1||d===0||d===1&&t===o-1&&t===r+1?f.base=f.name=a.slice(r,o):(f.name=a.slice(r,t),f.base=a.slice(r,o),f.ext=a.slice(t,o))),r>0&&r!==i?f.dir=a.slice(0,r-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let f="",l=!1;for(let i=a.length-1;i>=-1&&!l;i--){const s=i>=0?a[i]:R.cwd();v(s,"path"),s.length!==0&&(f=`${s}/${f}`,l=s.charCodeAt(0)===E)}return f=p(f,!l,"/",S),l?`/${f}`:f.length>0?f:"."},normalize(a){if(v(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E,l=a.charCodeAt(a.length-1)===E;return a=p(a,!f,"/",S),a.length===0?f?"/":l?"./":".":(l&&(a+="/"),f?`/${a}`:a)},isAbsolute(a){return v(a,"path"),a.length>0&&a.charCodeAt(0)===E},join(...a){if(a.length===0)return".";let f;for(let l=0;l<a.length;++l){const i=a[l];v(i,"path"),i.length>0&&(f===void 0?f=i:f+=`/${i}`)}return f===void 0?".":e.posix.normalize(f)},relative(a,f){if(v(a,"from"),v(f,"to"),a===f||(a=e.posix.resolve(a),f=e.posix.resolve(f),a===f))return"";const l=1,i=a.length,s=i-l,t=1,r=f.length-t,o=s<r?s:r;let c=-1,u=0;for(;u<o;u++){const w=a.charCodeAt(l+u);if(w!==f.charCodeAt(t+u))break;w===E&&(c=u)}if(u===o)if(r>o){if(f.charCodeAt(t+u)===E)return f.slice(t+u+1);if(u===0)return f.slice(t+u)}else s>o&&(a.charCodeAt(l+u)===E?c=u:u===0&&(c=0));let d="";for(u=l+c+1;u<=i;++u)(u===i||a.charCodeAt(u)===E)&&(d+=d.length===0?"..":"/..");return`${d}${f.slice(t+c)}`},toNamespacedPath(a){return a},dirname(a){if(v(a,"path"),a.length===0)return".";const f=a.charCodeAt(0)===E;let l=-1,i=!0;for(let s=a.length-1;s>=1;--s)if(a.charCodeAt(s)===E){if(!i){l=s;break}}else i=!1;return l===-1?f?"/":".":f&&l===1?"//":a.slice(0,l)},basename(a,f){f!==void 0&&v(f,"ext"),v(a,"path");let l=0,i=-1,s=!0,t;if(f!==void 0&&f.length>0&&f.length<=a.length){if(f===a)return"";let r=f.length-1,o=-1;for(t=a.length-1;t>=0;--t){const c=a.charCodeAt(t);if(c===E){if(!s){l=t+1;break}}else o===-1&&(s=!1,o=t+1),r>=0&&(c===f.charCodeAt(r)?--r===-1&&(i=t):(r=-1,i=o))}return l===i?i=o:i===-1&&(i=a.length),a.slice(l,i)}for(t=a.length-1;t>=0;--t)if(a.charCodeAt(t)===E){if(!s){l=t+1;break}}else i===-1&&(s=!1,i=t+1);return i===-1?"":a.slice(l,i)},extname(a){v(a,"path");let f=-1,l=0,i=-1,s=!0,t=0;for(let r=a.length-1;r>=0;--r){const o=a.charCodeAt(r);if(o===E){if(!s){l=r+1;break}continue}i===-1&&(s=!1,i=r+1),o===I?f===-1?f=r:t!==1&&(t=1):f!==-1&&(t=-1)}return f===-1||i===-1||t===0||t===1&&f===i-1&&f===l+1?"":a.slice(f,i)},format:g.bind(null,"/"),parse(a){v(a,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return f;const l=a.charCodeAt(0)===E;let i;l?(f.root="/",i=1):i=0;let s=-1,t=0,r=-1,o=!0,c=a.length-1,u=0;for(;c>=i;--c){const d=a.charCodeAt(c);if(d===E){if(!o){t=c+1;break}continue}r===-1&&(o=!1,r=c+1),d===I?s===-1?s=c:u!==1&&(u=1):s!==-1&&(u=-1)}if(r!==-1){const d=t===0&&l?1:t;s===-1||u===0||u===1&&s===r-1&&s===t+1?f.base=f.name=a.slice(d,r):(f.name=a.slice(d,s),f.base=a.slice(d,r),f.ext=a.slice(s,r))}return t>0?f.dir=a.slice(0,t-1):l&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[127],re([0,1,12]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(C){const y=(0,R.extname)(C),m=n[y.toLowerCase()];return m!==void 0?m:T(C)}e.getMediaOrTextMime=L;function T(C){const y=(0,R.extname)(C);return D[y.toLowerCase()]}e.getMediaMime=T;function I(C){for(const y in D)if(D[y]===C)return y}e.getExtensionForMimeType=I;const E=/^(.+)\/(.+?)(;.+)?$/;function b(C,y){const m=E.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:y?void 0:C}e.normalizeMimeType=b}),define(ne[81],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var D;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(I,...E){const b=E.reduce((m,v)=>(m[v]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(m=>!b[m]).forEach(m=>{for(let v=0;v<C.length;v++)if(m.search(C[v])!==-1){delete I[m];break}})}e.sanitizeProcessEnvironment=L;function T(I){!I||(delete I.DEBUG,R.isMacintosh&&delete I.DYLD_LIBRARY_PATH,R.isLinux&&delete I.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(ne[128],re([0,1,4]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=R.globals.performance&&typeof R.globals.performance.now=="function";class D{constructor(T){this._highResolution=n&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new D(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ne[3],re([0,1,9,78,2,116,128]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const I=!1,E=!1;var b;(function(c){c.None=()=>D.Disposable.None;function u(N){if(E){const{onListenerDidAdd:j}=N,x=h.create();let Z=0;N.onListenerDidAdd=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),x.print()),j?.()}}}function d(N){return(j,x=null,Z)=>{let oe=!1,X;return X=N(ie=>{if(!oe)return X?X.dispose():oe=!0,j.call(x,ie)},null,Z),oe&&X.dispose(),X}}c.once=d;function w(N,j,x){return F((Z,oe=null,X)=>N(ie=>Z.call(oe,j(ie)),null,X),x)}c.map=w;function A(N,j,x){return F((Z,oe=null,X)=>N(ie=>{j(ie),Z.call(oe,ie)},null,X),x)}c.forEach=A;function O(N,j,x){return F((Z,oe=null,X)=>N(ie=>j(ie)&&Z.call(oe,ie),null,X),x)}c.filter=O;function _(N){return N}c.signal=_;function M(...N){return(j,x=null,Z)=>(0,D.combinedDisposable)(...N.map(oe=>oe(X=>j.call(x,X),null,Z)))}c.any=M;function k(N,j,x,Z){let oe=x;return w(N,X=>(oe=j(oe,X),oe),Z)}c.reduce=k;function F(N,j){let x;const Z={onFirstListenerAdd(){x=N(oe.fire,oe)},onLastListenerRemove(){x?.dispose()}};j||u(Z);const oe=new P(Z);return j?.add(oe),oe.event}function $(N,j,x=100,Z=!1,oe,X){let ie,se,ue,he=0;const ve={leakWarningThreshold:oe,onFirstListenerAdd(){ie=N(Ee=>{he++,se=j(se,Ee),Z&&!ue&&(we.fire(se),se=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=se;se=void 0,ue=void 0,(!Z||he>1)&&we.fire(Pe),he=0},x)})},onLastListenerRemove(){ie.dispose()}};X||u(ve);const we=new P(ve);return X?.add(we),we.event}c.debounce=$;function q(N,j=(Z,oe)=>Z===oe,x){let Z=!0,oe;return O(N,X=>{const ie=Z||!j(X,oe);return Z=!1,oe=X,ie},x)}c.latch=q;function J(N,j,x){return[c.filter(N,j,x),c.filter(N,Z=>!j(Z),x)]}c.split=J;function H(N,j=!1,x=[]){let Z=x.slice(),oe=N(se=>{Z?Z.push(se):ie.fire(se)});const X=()=>{Z?.forEach(se=>ie.fire(se)),Z=null},ie=new P({onFirstListenerAdd(){oe||(oe=N(se=>ie.fire(se)))},onFirstListenerDidAdd(){Z&&(j?setTimeout(X):X())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return ie.event}c.buffer=H;class K{constructor(j){this.event=j,this.disposables=new D.DisposableStore}map(j){return new K(w(this.event,j,this.disposables))}forEach(j){return new K(A(this.event,j,this.disposables))}filter(j){return new K(O(this.event,j,this.disposables))}reduce(j,x){return new K(k(this.event,j,x,this.disposables))}latch(){return new K(q(this.event,void 0,this.disposables))}debounce(j,x=100,Z=!1,oe){return new K($(this.event,j,x,Z,oe,this.disposables))}on(j,x,Z){return this.event(j,x,Z)}once(j,x,Z){return d(this.event)(j,x,Z)}dispose(){this.disposables.dispose()}}function W(N){return new K(N)}c.chain=W;function B(N,j,x=Z=>Z){const Z=(...se)=>ie.fire(x(...se)),oe=()=>N.on(j,Z),X=()=>N.removeListener(j,Z),ie=new P({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}c.fromNodeEventEmitter=B;function Y(N,j,x=Z=>Z){const Z=(...se)=>ie.fire(x(...se)),oe=()=>N.addEventListener(j,Z),X=()=>N.removeEventListener(j,Z),ie=new P({onFirstListenerAdd:oe,onLastListenerRemove:X});return ie.event}c.fromDOMEventEmitter=Y;function te(N){return new Promise(j=>d(N)(j))}c.toPromise=te;function ce(N,j){return j(void 0),N(x=>j(x))}c.runAndSubscribe=ce;function z(N,j){let x=null;function Z(X){x?.dispose(),x=new D.DisposableStore,j(X,x)}Z(void 0);const oe=N(X=>Z(X));return(0,D.toDisposable)(()=>{oe.dispose(),x?.dispose()})}c.runAndSubscribeWithStore=z;class V{constructor(j,x){this.obs=j,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{j.addObserver(this)},onLastListenerRemove:()=>{j.removeObserver(this)}};x||u(Z),this.emitter=new P(Z),x&&x.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,x){this._hasChanged=!0}endUpdate(j){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function U(N,j){return new V(N,j).emitter.event}c.fromObservable=U})(b=e.Event||(e.Event={}));class C{constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${C._idPool++}`,C.all.add(this)}start(u){this._stopWatch=new T.StopWatch(!0),this.listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=C,C.all=new Set,C._idPool=0;let y=-1;function m(c){const u=y;return y=c,{dispose(){y=u}}}e.setGlobalLeakWarningThreshold=m;class v{constructor(u,d=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,d){let w=y;if(typeof this.customThreshold=="number"&&(w=this.customThreshold),w<=0||d<w)return;this._stacks||(this._stacks=new Map);const A=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,A+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=w*.5;let O,_=0;for(const[M,k]of this._stacks)(!O||_<k)&&(O=M,_=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${d} listeners already. MOST frequent listener (${_}):`),console.warn(O)}return()=>{const O=this._stacks.get(u.value)||0;this._stacks.set(u.value,O-1)}}}class h{constructor(u){this.value=u}static create(){return new h(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(u,d,w){this.callback=u,this.callbackThis=d,this.stack=w,this.subscription=new D.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class P{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=y>0?new v(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(I){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const d of u)d.subscription.isset()&&(d.subscription.unset(),d.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,d,w)=>{this._listeners||(this._listeners=new L.LinkedList);const A=this._listeners.isEmpty();A&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,_;this._leakageMon&&this._listeners.size>=30&&(_=h.create(),O=this._leakageMon.check(_,this._listeners.size+1)),I&&(_=_??h.create());const M=new S(u,d,_),k=this._listeners.push(M);A&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,d);const F=M.subscription.set(()=>{O?.(),this._disposed||(k(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return w instanceof D.DisposableStore?w.add(F):Array.isArray(w)&&w.push(F),F}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const d of this._listeners)this._deliveryQueue.push(this,d,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=P;class p{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(u,d,w){this._queue.push(new a(u,d,w))}clear(u){const d=new L.LinkedList;for(const w of this._queue)w.emitter!==u&&d.push(w);this._queue=d}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(d){(0,R.onUnexpectedError)(d)}}}}e.EventDeliveryQueue=p;class g extends p{clear(u){this._queue.clear()}}class a{constructor(u,d,w){this.emitter=u,this.listener=d,this.event=w}}class f extends P{async fireAsync(u,d,w){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const A of this._listeners)this._asyncDeliveryQueue.push([A,u]);for(;this._asyncDeliveryQueue.size>0&&!d.isCancellationRequested;){const[A,O]=this._asyncDeliveryQueue.shift(),_=[],M={...O,token:d,waitUntil:k=>{if(Object.isFrozen(_))throw new Error("waitUntil can NOT be called asynchronous");w&&(k=w(k,A.callback)),_.push(k)}};try{A.invoke(M)}catch(k){(0,R.onUnexpectedError)(k);continue}Object.freeze(_),await Promise.allSettled(_).then(k=>{for(const F of k)F.status==="rejected"&&(0,R.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=f;class l extends P{constructor(u){super(u),this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=l;class i extends l{constructor(u){super(u),this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=i;class s extends P{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(d=>super.fire(d)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=s;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new P({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const d={event:u,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const w=()=>{this.hasListeners&&this.unhook(d);const A=this.events.indexOf(d);this.events.splice(A,1)};return(0,D.toDisposable)((0,n.once)(w))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(d=>this.emitter.fire(d))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class r{constructor(){this.buffers=[]}wrapEvent(u){return(d,w,A)=>u(O=>{const _=this.buffers[this.buffers.length-1];_?_.push(()=>d.call(w,O)):d.call(w,O)},void 0,A)}bufferEvents(u){const d=[];this.buffers.push(d);const w=u();return this.buffers.pop(),d.forEach(A=>A()),w}}e.EventBufferer=r;class o{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new P({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ne[22],re([0,1,3]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(I,E){const b=setTimeout(I.bind(E),0);return{dispose(){clearTimeout(b)}}});var D;(function(I){function E(b){return b===I.None||b===I.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}I.isCancellationToken=E,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=T}),define(ne[129],re([0,1,22]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(I){this.task=I,this.result=null}get(){if(this.result)return this.result;const I=new R.CancellationTokenSource,E=this.task(I.token);return this.result={promise:E,dispose:()=>{this.result=null,I.cancel(),I.dispose()}},this.result}}e.Cache=n;class D{constructor(I){this.fn=I,this.lastCache=void 0,this.lastArgKey=void 0}get(I){const E=JSON.stringify(I);return this.lastArgKey!==E&&(this.lastArgKey=E,this.lastCache=this.fn(I)),this.lastCache}}e.LRUCachedFunction=D;class L{constructor(I){this.fn=I,this._map=new Map}get cachedValues(){return this._map}get(I){if(this._map.has(I))return this._map.get(I);const E=this.fn(I);return this._map.set(I,E),E}}e.CachedFunction=L}),define(ne[82],re([0,1,3,2]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=T=>({onDidChange:R.Event.None,value:T});e.staticObservableValue=D;class L extends n.Disposable{constructor(I){super(),this._value=I,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(I){I!==this._value&&(this._value=I,this.changeEmitter.fire(I))}}e.MutableObservableValue=L}),define(ne[25],re([0,1,129,115]),function(Q,e,R,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=L;const T=/{(\d+)}/g;function I(ee,...le){return le.length===0?ee:ee.replace(T,function(me,ge){const Se=parseInt(ge,10);return isNaN(Se)||Se<0||Se>=le.length?me:le[Se]})}e.format=I;const E=/{([^}]+)}/g;function b(ee,le){return ee.replace(E,(me,ge)=>le[ge]??me)}e.format2=b;function C(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=C;function y(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function m(ee,le){let me=0;const ge=le.charCodeAt(0);for(let Se=ee.length-1;Se>=0;Se--)ee.charCodeAt(Se)===ge&&me++;return me}e.count=m;function v(ee,le,me="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${me}`}e.truncate=v;function h(ee,le=" "){const me=S(ee,le);return P(me,le)}e.trim=h;function S(ee,le){if(!ee||!le)return ee;const me=le.length;if(me===0||ee.length===0)return ee;let ge=0;for(;ee.indexOf(le,ge)===ge;)ge=ge+me;return ee.substring(ge)}e.ltrim=S;function P(ee,le){if(!ee||!le)return ee;const me=le.length,ge=ee.length;if(me===0||ge===0)return ee;let Se=ge,be=-1;for(;be=ee.lastIndexOf(le,Se-1),!(be===-1||be+me!==Se);){if(be===0)return"";Se=be}return ee.substring(0,Se)}e.rtrim=P;function p(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function a(ee,le,me={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=y(ee)),me.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let ge="";return me.global&&(ge+="g"),me.matchCase||(ge+="i"),me.multiline&&(ge+="m"),me.unicode&&(ge+="u"),new RegExp(ee,ge)}e.createRegExp=a;function f(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function l(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function i(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=i;function s(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=s;function t(ee){for(let le=0,me=ee.length;le<me;le++){const ge=ee.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function r(ee,le=0,me=ee.length){for(let ge=le;ge<me;ge++){const Se=ee.charCodeAt(ge);if(Se!==32&&Se!==9)return ee.substring(le,ge)}return ee.substring(le,me)}e.getLeadingWhitespace=r;function o(ee,le=ee.length-1){for(let me=le;me>=0;me--){const ge=ee.charCodeAt(me);if(ge!==32&&ge!==9)return me}return-1}e.lastNonWhitespaceIndex=o;function c(ee,le,me){const ge=[];let Se=0;for(const be of ee.matchAll(le)){if(ge.push(ee.slice(Se,be.index)),be.index===void 0)throw new Error("match.index should be defined");Se=be.index+be[0].length,ge.push(me(be[0],...be.slice(1),be.index,ee,be.groups))}return ge.push(ee.slice(Se)),Promise.all(ge).then(be=>be.join(""))}e.replaceAsync=c;function u(ee,le){return ee<le?-1:ee>le?1:0}e.compare=u;function d(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){const qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe<Le)return-1;if(qe>Le)return 1}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstring=d;function w(ee,le){return A(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=w;function A(ee,le,me=0,ge=ee.length,Se=0,be=le.length){for(;me<ge&&Se<be;me++,Se++){let qe=ee.charCodeAt(me),Le=le.charCodeAt(Se);if(qe===Le)continue;if(qe>=128||Le>=128)return d(ee.toLowerCase(),le.toLowerCase(),me,ge,Se,be);_(qe)&&(qe-=32),_(Le)&&(Le-=32);const Ne=qe-Le;if(Ne!==0)return Ne}const Re=ge-me,Te=be-Se;return Re<Te?-1:Re>Te?1:0}e.compareSubstringIgnoreCase=A;function O(ee){return ee>=48&&ee<=57}e.isAsciiDigit=O;function _(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=_;function M(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=M;function k(ee,le){return ee.length===le.length&&A(ee,le)===0}e.equalsIgnoreCase=k;function F(ee,le){const me=le.length;return le.length>ee.length?!1:A(ee,le,0,me)===0}e.startsWithIgnoreCase=F;function $(ee,le){const me=Math.min(ee.length,le.length);let ge;for(ge=0;ge<me;ge++)if(ee.charCodeAt(ge)!==le.charCodeAt(ge))return ge;return me}e.commonPrefixLength=$;function q(ee,le){const me=Math.min(ee.length,le.length);let ge;const Se=ee.length-1,be=le.length-1;for(ge=0;ge<me;ge++)if(ee.charCodeAt(Se-ge)!==le.charCodeAt(be-ge))return ge;return me}e.commonSuffixLength=q;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function H(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=H;function K(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=K;function W(ee,le,me){const ge=ee.charCodeAt(me);if(J(ge)&&me+1<le){const Se=ee.charCodeAt(me+1);if(H(Se))return K(ge,Se)}return ge}e.getNextCodePoint=W;function B(ee,le){const me=ee.charCodeAt(le-1);if(H(me)&&le>1){const ge=ee.charCodeAt(le-2);if(J(ge))return K(ge,me)}return me}class Y{constructor(le,me=0){this._str=le,this._len=le.length,this._offset=me}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=B(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=W(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class te{constructor(le,me=0){this._iterator=new Y(le,me)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const be=me.offset,Re=le.getGraphemeBreakType(me.nextCodePoint());if(fe(Se,Re)){me.setOffset(be);break}Se=Re}return me.offset-ge}prevGraphemeLength(){const le=Ie.getInstance(),me=this._iterator,ge=me.offset;let Se=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const be=me.offset,Re=le.getGraphemeBreakType(me.prevCodePoint());if(fe(Re,Se)){me.setOffset(be);break}Se=Re}return ge-me.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=te;function ce(ee,le){return new te(ee,le).nextGraphemeLength()}e.nextCharLength=ce;function z(ee,le){return new te(ee,le).prevGraphemeLength()}e.prevCharLength=z;function V(ee,le){le>0&&H(ee.charCodeAt(le))&&le--;const me=le+ce(ee,le);return[me-z(ee,me),me]}e.getCharContainingOffset=V;let U;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(ee){return U||(U=N()),U.test(ee)}e.containsRTL=j;const x=/^[\t\n\r\x20-\x7E]*$/;function Z(ee){return x.test(ee)}e.isBasicASCII=Z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=oe;function X(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=X;function ie(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=ie;function se(ee,le){if(ee.length<le)return ee;const me=/\b/g;let ge=0;for(;me.test(ee)&&!(ee.length-me.lastIndex<le);)ge=me.lastIndex,me.lastIndex+=1;return ee.substring(ge).replace(/^\s/,"")}e.lcut=se;const ue=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function we(ee){return ee&&(ee=ee.replace(ue,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=we,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Pe(ee){return Ee(ee)?ee.substr(1):ee}e.stripUTF8BOM=Pe;function Ue(ee,le){if(!ee||!le||ee.length<le.length)return!1;const me=le.length,ge=ee.toLowerCase();let Se=0,be=-1;for(;Se<me;){const Re=ge.indexOf(le[Se],be+1);if(Re<0)return!1;be=Re,Se++}return!0}e.fuzzyContains=Ue;function ze(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=ze;function Ve(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ve;function We(ee,le=1){if(le===0)return"";let me=-1;do me=ee.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?ee:(ee[me-1]==="\r"&&me--,ee.substr(0,me))}e.getNLines=We;function ae(ee){return ee=ee%(2*26),ee<26?String.fromCharCode(97+ee):String.fromCharCode(65+ee-26)}e.singleLetterHash=ae;function de(ee){return Ie.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=de;function fe(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var Ce;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(Ce=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{constructor(){this._data=Me()}static getInstance(){return Ie._INSTANCE||(Ie._INSTANCE=new Ie),Ie._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this._data,ge=me.length/3;let Se=1;for(;Se<=ge;)if(le<me[3*Se])Se=2*Se;else if(le>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}Ie._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(ee,le){if(ee===0)return 0;const me=$e(ee,le);if(me!==void 0)return me;const ge=new Y(le,ee);return ge.prevCodePoint(),ge.offset}e.getLeftDeleteOffset=De;function $e(ee,le){const me=new Y(le,ee);let ge=me.prevCodePoint();for(;Ae(ge)||ge===65039||ge===8419;){if(me.offset===0)return;ge=me.prevCodePoint()}if(!ie(ge))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function Ae(ee){return 127995<=ee&&ee<=127999}var Fe;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class _e{constructor(le){this.confusableDictionary=le}static getInstance(le){return _e.cache.get(Array.from(le))}static getLocales(){return _e._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=_e,D=_e,_e.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.cache=new R.LRUCachedFunction(ee=>{function le(Le){const Ne=new Map;for(let xe=0;xe<Le.length;xe+=2)Ne.set(Le[xe],Le[xe+1]);return Ne}function me(Le,Ne){const xe=new Map(Le);for(const[Xe,Ze]of Ne)xe.set(Xe,Ze);return xe}function ge(Le,Ne){if(!Le)return Ne;const xe=new Map;for(const[Xe,Ze]of Le)Ne.has(Xe)&&xe.set(Xe,Ze);return xe}const Se=D.ambiguousCharacterData.getValue();let be=ee.filter(Le=>!Le.startsWith("_")&&Le in Se);be.length===0&&(be=["_default"]);let Re;for(const Le of be){const Ne=le(Se[Le]);Re=ge(Re,Ne)}const Te=le(Se._common),qe=me(Te,Re);return new _e(qe)}),_e._locales=new n.Lazy(()=>Object.keys(_e.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class ke{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ke.getRawData())),this._data}static isInvisibleCharacter(le){return ke.getData().has(le)}static get codePoints(){return ke.getData()}}e.InvisibleCharacters=ke,ke._data=void 0}),define(ne[46],re([0,1,12,4,25,14]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function I(o){return o.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=I;function E(o){return o.indexOf("/")===-1&&(o=I(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=E;function b(o,c=R.posix.sep){if(!o)return"";const u=o.length,d=o.charCodeAt(0);if(T(d)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let A=3;const O=A;for(;A<u&&!T(o.charCodeAt(A));A++);if(O!==A&&!T(o.charCodeAt(A+1))){for(A+=1;A<u;A++)if(T(o.charCodeAt(A)))return o.slice(0,A+1).replace(/[\\/]/g,c)}}return c}else if(p(d)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let w=o.indexOf("://");if(w!==-1){for(w+=3;w<u;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1)}return""}e.getRoot=b;function C(o){if(!n.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let u=2;const d=u;for(;u<o.length&&(c=o.charCodeAt(u),c!==92);u++);return!(d===u||(c=o.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=C;const y=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,c=n.isWindows){const u=c?y:m;return!(!o||o.length===0||/^\s+$/.test(o)||(u.lastIndex=0,u.test(o))||c&&v.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function S(o,c,u){const d=o===c;return!u||d?d:!o||!c?!1:(0,D.equalsIgnoreCase)(o,c)}e.isEqual=S;function P(o,c,u,d=R.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(u){if(!(0,D.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let A=c.length;return c.charAt(c.length-1)===d&&A--,o.charAt(A)===d}return c.charAt(c.length-1)!==d&&(c+=d),o.indexOf(c)===0}e.isEqualOrParent=P;function p(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=p;function g(o,c){return n.isWindows&&o.endsWith(":")&&(o+=R.sep),(0,R.isAbsolute)(o)||(o=(0,R.join)(c,o)),o=(0,R.normalize)(o),n.isWindows?(o=(0,D.rtrim)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,D.rtrim)(o,R.sep),o||(o=R.sep)),o}e.sanitizeFilePath=g;function a(o){const c=(0,R.normalize)(o);return n.isWindows?o.length>3?!1:f(c)&&(o.length===2||c.charCodeAt(2)===92):c===R.posix.sep}e.isRootOrDriveLetter=a;function f(o,c=n.isWindows){return c?p(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function l(o){return f(o)?o[0]:void 0}e.getDriveLetter=l;function i(o,c,u){return c.length>o.length?-1:o===c?0:(u&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=i;function s(o){const c=o.split(":");let u,d,w;for(const A of c){const O=Number(A);(0,L.isNumber)(O)?d===void 0?d=O:w===void 0&&(w=O):u=u?[u,A].join(":"):A}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(o,c,u=8){let d="";for(let A=0;A<u;A++)d+=t.charAt(Math.floor(Math.random()*t.length));let w;return c?w=`${c}-${d}`:w=d,o?(0,R.join)(o,w):w}e.randomPath=r}),define(ne[64],re([0,1,25]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(p){return D(p,0)}e.hash=n;function D(p,g){switch(typeof p){case"object":return p===null?L(349,g):Array.isArray(p)?E(p,g):b(p,g);case"string":return I(p,g);case"boolean":return T(p,g);case"number":return L(p,g);case"undefined":return L(937,g);default:return L(617,g)}}e.doHash=D;function L(p,g){return(g<<5)-g+p|0}e.numberHash=L;function T(p,g){return L(p?433:863,g)}function I(p,g){g=L(149417,g);for(let a=0,f=p.length;a<f;a++)g=L(p.charCodeAt(a),g);return g}e.stringHash=I;function E(p,g){return g=L(104579,g),p.reduce((a,f)=>D(f,a),g)}function b(p,g){return g=L(181387,g),Object.keys(p).sort().reduce((a,f)=>(a=I(f,a),D(p[f],a)),g)}class C{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=D(g,this._value),this._value}}e.Hasher=C;var y;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function m(p,g,a=32){const f=a-g,l=~((1<<f)-1);return(p<<g|(l&p)>>>f)>>>0}function v(p,g=0,a=p.byteLength,f=0){for(let l=0;l<a;l++)p[g+l]=f}function h(p,g,a="0"){for(;p.length<g;)p=a+p;return p}function S(p,g=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(a=>a.toString(16).padStart(2,"0")).join(""):h((p>>>0).toString(16),g/4)}e.toHexString=S;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const a=g.length;if(a===0)return;const f=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,s,t;for(i!==0?(s=i,t=-1,i=0):(s=g.charCodeAt(0),t=0);;){let r=s;if(R.isHighSurrogate(s))if(t+1<a){const o=g.charCodeAt(t+1);R.isLowSurrogate(o)?(t++,r=R.computeCodePoint(s,o)):r=65533}else{i=s;break}else R.isLowSurrogate(s)&&(r=65533);if(l=this._push(f,l,r),t++,t<a)s=g.charCodeAt(t);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(g,a,f){return f<128?g[a++]=f:f<2048?(g[a++]=192|(f&1984)>>>6,g[a++]=128|(f&63)>>>0):f<65536?(g[a++]=224|(f&61440)>>>12,g[a++]=128|(f&4032)>>>6,g[a++]=128|(f&63)>>>0):(g[a++]=240|(f&1835008)>>>18,g[a++]=128|(f&258048)>>>12,g[a++]=128|(f&4032)>>>6,g[a++]=128|(f&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=P._bigBlock32,a=this._buffDV;for(let u=0;u<64;u+=4)g.setUint32(u,a.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,m(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let f=this._h0,l=this._h1,i=this._h2,s=this._h3,t=this._h4,r,o,c;for(let u=0;u<80;u++)u<20?(r=l&i|~l&s,o=1518500249):u<40?(r=l^i^s,o=1859775393):u<60?(r=l&i|l&s|i&s,o=2400959708):(r=l^i^s,o=3395469782),c=m(f,5)+r+t+o+g.getUint32(u*4,!1)&4294967295,t=s,s=i,i=m(l,30),l=f,f=c;this._h0=this._h0+f&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,18,25]),function(Q,e,R,n){"use strict";var D,L,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(t,r,o){let c=t.get(r);return c===void 0&&(c=o,t.set(r,c)),c}e.getOrSet=I;function E(t){const r=[];return t.forEach((o,c)=>{r.push(`${c} => ${o}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=E;function b(t){const r=[];return t.forEach(o=>{r.push(o)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=b;class C{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const o=r.charCodeAt(0),c=this._value.charCodeAt(this._pos);return o-c}value(){return this._value[this._pos]}}e.StringIterator=C;class y{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,n.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(r=!0,o=!0){this._splitOnBackslash=r,this._caseSensitive=o}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let o=r.length-1;o>=0;o--,this._valueLen--){const c=this._value.charCodeAt(o);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,n.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var v;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(r,o){this._ignorePathCasing=r,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,n.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(P||(P={}));class p{constructor(r){this._iter=r}static forUris(r=()=>!1,o=()=>!1){return new p(new h(r,o))}static forPaths(r=!1){return new p(new m(void 0,!r))}static forStrings(){return new p(new C)}static forConfigKeys(){return new p(new y)}clear(){this._root=void 0}fill(r,o){if(o){const c=o.slice(0);(0,R.shuffle)(c);for(const u of c)this.set(u,r)}else{const c=r.slice(0);(0,R.shuffle)(c);for(const u of c)this.set(u[0],u[1])}}set(r,o){const c=this._iter.reset(r);let u;this._root||(this._root=new S,this._root.segment=c.value());const d=[];for(u=this._root;;){const A=c.cmp(u.segment);if(A>0)u.left||(u.left=new S,u.left.segment=c.value()),d.push([-1,u]),u=u.left;else if(A<0)u.right||(u.right=new S,u.right.segment=c.value()),d.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new S,u.mid.segment=c.value()),d.push([0,u]),u=u.mid;else break}const w=u.value;u.value=o,u.key=r;for(let A=d.length-1;A>=0;A--){const O=d[A][1];O.updateHeight();const _=O.balanceFactor();if(_<-1||_>1){const M=d[A][0],k=d[A+1][0];if(M===1&&k===1)d[A][1]=O.rotateLeft();else if(M===-1&&k===-1)d[A][1]=O.rotateRight();else if(M===1&&k===-1)O.right=d[A+1][1]=d[A+1][1].rotateRight(),d[A][1]=O.rotateLeft();else if(M===-1&&k===1)O.left=d[A+1][1]=d[A+1][1].rotateLeft(),d[A][1]=O.rotateRight();else throw new Error;if(A>0)switch(d[A-1][0]){case-1:d[A-1][1].left=d[A][1];break;case 1:d[A-1][1].right=d[A][1];break;case 0:d[A-1][1].mid=d[A][1];break}else this._root=d[0][1]}}return w}get(r){return this._getNode(r)?.value}_getNode(r){const o=this._iter.reset(r);let c=this._root;for(;c;){const u=o.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else break}return c}has(r){const o=this._getNode(r);return!(o?.value===void 0&&o?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,o){const c=this._iter.reset(r),u=[];let d=this._root;for(;d;){const w=c.cmp(d.segment);if(w>0)u.push([-1,d]),d=d.left;else if(w<0)u.push([1,d]),d=d.right;else if(c.hasNext())c.next(),u.push([0,d]),d=d.mid;else break}if(!!d){if(o?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const w=this._min(d.right),{key:A,value:O,segment:_}=w;this._delete(w.key,!1),d.key=A,d.value=O,d.segment=_}else{const w=d.left??d.right;if(u.length>0){const[A,O]=u[u.length-1];switch(A){case-1:O.left=w;break;case 0:O.mid=w;break;case 1:O.right=w;break}}else this._root=w}for(let w=u.length-1;w>=0;w--){const A=u[w][1];A.updateHeight();const O=A.balanceFactor();if(O>1?(A.right.balanceFactor()>=0||(A.right=A.right.rotateRight()),u[w][1]=A.rotateLeft()):O<-1&&(A.left.balanceFactor()<=0||(A.left=A.left.rotateLeft()),u[w][1]=A.rotateRight()),w>0)switch(u[w-1][0]){case-1:u[w-1][1].left=u[w][1];break;case 1:u[w-1][1].right=u[w][1];break;case 0:u[w-1][1].mid=u[w][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const o=this._iter.reset(r);let c=this._root,u;for(;c;){const d=o.cmp(c.segment);if(d>0)c=c.left;else if(d<0)c=c.right;else if(o.hasNext())o.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(r){const o=this._iter.reset(r);let c=this._root;for(;c;){const u=o.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(r){for(const[o,c]of this)r(c,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const o=[];return this._dfsEntries(r,o),o[Symbol.iterator]()}_dfsEntries(r,o){!r||(r.left&&this._dfsEntries(r.left,o),r.value&&o.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,o),r.right&&this._dfsEntries(r.right,o))}_isBalanced(){const r=o=>{if(!o)return!0;const c=o.balanceFactor();return c<-1||c>1?!1:r(o.left)&&r(o.right)};return r(this._root)}}e.TernarySearchTree=p;class g{constructor(r,o){this.uri=r,this.value=o}}class a{constructor(r,o){this[D]="ResourceMap",r instanceof a?(this.map=new Map(r.map),this.toKey=o??a.defaultToKey):(this.map=new Map,this.toKey=r??a.defaultToKey)}set(r,o){return this.map.set(this.toKey(r),new g(r,o)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,o){typeof o<"u"&&(r=r.bind(o));for(const[c,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=a,a.defaultToKey=t=>t.toString();class f{constructor(r,o){this[L]="ResourceSet",!r||typeof r=="function"?this._map=new a(r):(this._map=new a(o),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,o){this._map.forEach((c,u)=>r.call(o,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var l;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class i{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,o=0){const c=this._map.get(r);if(!!c)return o!==0&&this.touch(c,o),c.value}set(r,o,c=0){let u=this._map.get(r);if(u)u.value=o,c!==0&&this.touch(u,c);else{switch(u={key:r,value:o,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const o=this._map.get(r);if(!!o)return this._map.delete(r),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,o){const c=this._state;let u=this._head;for(;u;){if(o?r.bind(o)(u.value,u.key,this):r(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const d={value:c.key,done:!1};return c=c.next,d}else return{value:void 0,done:!0}}};return u}values(){const r=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const d={value:c.value,done:!1};return c=c.next,d}else return{value:void 0,done:!0}}};return u}entries(){const r=this,o=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const d={value:[c.key,c.value],done:!1};return c=c.next,d}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let o=this._head,c=this.size;for(;o&&c>r;)this._map.delete(o.key),o=o.next,c--;this._head=o,this._size=c,o&&(o.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const o=r.next,c=r.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}r.next=void 0,r.previous=void 0,this._state++}touch(r,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(r===this._head)return;const c=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(o===2){if(r===this._tail)return;const c=r.next,u=r.previous;r===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((o,c)=>{r.push([c,o])}),r}fromJSON(r){this.clear();for(const[o,c]of r)this.set(o,c)}}e.LinkedMap=i;class s extends i{constructor(r,o=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,o=2){return super.get(r,o)}peek(r){return super.get(r,0)}set(r,o){return super.set(r,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s}),define(ne[83],re([0,1,34]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new R.LRUCache(1e4);function D(b){return E(b,"NFC",n)}e.normalizeNFC=D;const L=new R.LRUCache(1e4);function T(b){return E(b,"NFD",L)}e.normalizeNFD=T;const I=/[^\u0000-\u0080]/;function E(b,C,y){if(!b)return b;const m=y.get(b);if(m)return m;let v;return I.test(b)?v=b.normalize(C):v=b,y.set(b,v),v}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(C){return T(C).replace(b,"")}}()}),define(ne[84],re([0,1,25]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(n||(n={})),function(D){const L="error",T="warning",I="warn",E="info",b="ignore";function C(m){return m?R.equalsIgnoreCase(L,m)?D.Error:R.equalsIgnoreCase(T,m)||R.equalsIgnoreCase(I,m)?D.Warning:R.equalsIgnoreCase(E,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function y(m){switch(m){case D.Error:return L;case D.Warning:return T;case D.Info:return E;default:return b}}D.toString=y}(n||(n={})),e.default=n}),define(ne[7],re([0,1,12,4]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,L=/^\//,T=/^\/\//;function I(t,r){if(!t.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,r){return!t&&!r?"file":t}function b(t,r){switch(t){case"https":case"http":case"file":r?r[0]!==y&&(r=y+r):r=y;break}return r}const C="",y="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(r,o,c,u,d,w=!1){typeof r=="object"?(this.scheme=r.scheme||C,this.authority=r.authority||C,this.path=r.path||C,this.query=r.query||C,this.fragment=r.fragment||C):(this.scheme=E(r,w),this.authority=o||C,this.path=b(this.scheme,c||C),this.query=u||C,this.fragment=d||C,I(this,w))}static isUri(r){return r instanceof v?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return a(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:c,path:u,query:d,fragment:w}=r;return o===void 0?o=this.scheme:o===null&&(o=C),c===void 0?c=this.authority:c===null&&(c=C),u===void 0?u=this.path:u===null&&(u=C),d===void 0?d=this.query:d===null&&(d=C),w===void 0?w=this.fragment:w===null&&(w=C),o===this.scheme&&c===this.authority&&u===this.path&&d===this.query&&w===this.fragment?this:new S(o,c,u,d,w)}static parse(r,o=!1){const c=m.exec(r);return c?new S(c[2]||C,s(c[4]||C),s(c[5]||C),s(c[7]||C),s(c[9]||C),o):new S(C,C,C,C,C)}static file(r){let o=C;if(n.isWindows&&(r=r.replace(/\\/g,y)),r[0]===y&&r[1]===y){const c=r.indexOf(y,2);c===-1?(o=r.substring(2),r=y):(o=r.substring(2,c),r=r.substring(c)||y)}return new S("file",o,r,C,C)}static from(r){const o=new S(r.scheme,r.authority,r.path,r.query,r.fragment);return I(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return n.isWindows&&r.scheme==="file"?c=v.file(R.win32.join(a(r,!0),...o)).path:c=R.posix.join(r.path,...o),r.with({path:c})}toString(r=!1){return f(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof v)return r;{const o=new S(r);return o._formatted=r.external,o._fsPath=r._sep===h?r.fsPath:null,o}}else return r}}e.URI=v;const h=n.isWindows?1:void 0;class S extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(r=!1){return r?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=h),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(t,r){let o,c=-1;for(let u=0;u<t.length;u++){const d=t.charCodeAt(u);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||r&&d===47)c!==-1&&(o+=encodeURIComponent(t.substring(c,u)),c=-1),o!==void 0&&(o+=t.charAt(u));else{o===void 0&&(o=t.substr(0,u));const w=P[d];w!==void 0?(c!==-1&&(o+=encodeURIComponent(t.substring(c,u)),c=-1),o+=w):c===-1&&(c=u)}}return c!==-1&&(o+=encodeURIComponent(t.substring(c))),o!==void 0?o:t}function g(t){let r;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(r===void 0&&(r=t.substr(0,o)),r+=P[c]):r!==void 0&&(r+=t[o])}return r!==void 0?r:t}function a(t,r){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?r?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=a;function f(t,r){const o=r?g:p;let c="",{scheme:u,authority:d,path:w,query:A,fragment:O}=t;if(u&&(c+=u,c+=":"),(d||u==="file")&&(c+=y,c+=y),d){let _=d.indexOf("@");if(_!==-1){const M=d.substr(0,_);d=d.substr(_+1),_=M.indexOf(":"),_===-1?c+=o(M,!1):(c+=o(M.substr(0,_),!1),c+=":",c+=o(M.substr(_+1),!1)),c+="@"}d=d.toLowerCase(),_=d.indexOf(":"),_===-1?c+=o(d,!1):(c+=o(d.substr(0,_),!1),c+=d.substr(_))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const _=w.charCodeAt(1);_>=65&&_<=90&&(w=`/${String.fromCharCode(_+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const _=w.charCodeAt(0);_>=65&&_<=90&&(w=`${String.fromCharCode(_+32)}:${w.substr(2)}`)}c+=o(w,!0)}return A&&(c+="?",c+=o(A,!1)),O&&(c+="#",c+=r?O:p(O,!1)),c}function l(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+l(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(t){return t.match(i)?t.replace(i,r=>l(r)):t}}),define(ne[130],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(b){const C=b;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=n;function D(b){const C=[];let y;try{const m=JSON.parse(b.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),y=v.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",b.arguments)}return{args:C,stack:y}}e.parse=D;function L(b){if(typeof b!="string")return L(D(b).stack);const C=b;if(C){const y=T(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=L;function T(b){if(!b)return b;const C=b.indexOf(`
`);return C===-1?b:b.substring(0,C)}function I(b,C){const{args:y,stack:m}=D(b),v=typeof y[0]=="string"&&y.length===1;let h=T(m);h&&(h=`(${h.trim()})`);let S=[];if(typeof y[0]=="string"?h&&v?S=[`%c[${C}] %c${y[0]} %c${h}`,E("blue"),E(""),E("grey")]:S=[`%c[${C}] %c${y[0]}`,E("blue"),E(""),...y.slice(1)]:S=[`%c[${C}]%`,E("blue"),...y],h&&!v&&S.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,S)}e.log=I;function E(b){return`color: ${b}`}}),define(ne[65],re([0,1,16,25,7]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(b){return JSON.stringify(b,I)}e.stringify=L;function T(b){let C=JSON.parse(b);return C=E(C),C}e.parse=T;function I(b,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function E(b,C=0){if(!b||C>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof R.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=E(b[y],C+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=E(b[y],C+1))}return b}e.revive=E}),define(ne[20],re([0,1,4,7]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${D.vscodeRemoteResource}`}set(b,C,y){this._hosts[b]=C,this._ports[b]=y}setConnectionToken(b,C){this._connectionTokens[b]=C}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const C=b.authority;let y=this._hosts[C];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const m=this._ports[C],v=this._connectionTokens[C];let h=`path=${encodeURIComponent(b.path)}`;return typeof v=="string"&&(h+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),n.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${y}:${m}`,path:this._remoteResourcesPath,query:h})}}e.RemoteAuthorities=new L;class T{asBrowserUri(b,C){const y=this.toUri(b,C);return y.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===D.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${D.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?y.with({scheme:D.vscodeFileResource,authority:y.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(b,C){const y=this.toUri(b,C);return y.scheme===D.vscodeFileResource?y.with({scheme:D.file,authority:y.authority!==T.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(b,C){return n.URI.isUri(b)?b:n.URI.parse(C.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T;var I;(function(E){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(b.get("3"));const C="vscode-coi";function y(v){let h;typeof v=="string"?h=new URL(v).searchParams:v instanceof URL?h=v.searchParams:n.URI.isUri(v)&&(h=new URL(v.toString(!0)).searchParams);const S=h?.get(C);if(!!S)return b.get(S)}E.getHeadersFromQuery=y;function m(v,h,S){if(!globalThis.crossOriginIsolated)return;const P=h&&S?"3":S?"2":"1";v instanceof URLSearchParams?v.set(C,P):v[C]=P}E.addSearchParam=m})(I=e.COI||(e.COI={}))}),define(ne[17],re([0,1,46,20,12,4,25,7]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(v){return(0,I.uriToFsPath)(v,!0)}e.originalFSPath=E;class b{constructor(h){this._ignorePathCasing=h}compare(h,S,P=!1){return h===S?0:(0,T.compare)(this.getComparisonKey(h,P),this.getComparisonKey(S,P))}isEqual(h,S,P=!1){return h===S?!0:!h||!S?!1:this.getComparisonKey(h,P)===this.getComparisonKey(S,P)}getComparisonKey(h,S=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,S,P=!1){if(h.scheme===S.scheme){if(h.scheme===n.Schemas.file)return R.isEqualOrParent(E(h),E(S),this._ignorePathCasing(h))&&h.query===S.query&&(P||h.fragment===S.fragment);if((0,e.isEqualAuthority)(h.authority,S.authority))return R.isEqualOrParent(h.path,S.path,this._ignorePathCasing(h),"/")&&h.query===S.query&&(P||h.fragment===S.fragment)}return!1}joinPath(h,...S){return I.URI.joinPath(h,...S)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let S;return h.scheme===n.Schemas.file?S=I.URI.file(D.dirname(E(h))).path:(S=D.posix.dirname(h.path),h.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),S="/")),h.with({path:S})}normalizePath(h){if(!h.path.length)return h;let S;return h.scheme===n.Schemas.file?S=I.URI.file(D.normalize(E(h))).path:S=D.posix.normalize(h.path),h.with({path:S})}relativePath(h,S){if(h.scheme!==S.scheme||!(0,e.isEqualAuthority)(h.authority,S.authority))return;if(h.scheme===n.Schemas.file){const g=D.relative(E(h),E(S));return L.isWindows?R.toSlashes(g):g}let P=h.path||"/";const p=S.path||"/";if(this._ignorePathCasing(h)){let g=0;for(const a=Math.min(P.length,p.length);g<a&&!(P.charCodeAt(g)!==p.charCodeAt(g)&&P.charAt(g).toLowerCase()!==p.charAt(g).toLowerCase());g++);P=p.substr(0,g)+P.substr(g)}return D.posix.relative(P,p)}resolvePath(h,S){if(h.scheme===n.Schemas.file){const P=I.URI.file(D.resolve(E(h),S));return h.with({authority:P.authority,path:P.path})}return S=R.toPosixPath(S),h.with({path:D.posix.resolve(h.path,S)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,S){return h===S||h!==void 0&&S!==void 0&&(0,T.equalsIgnoreCase)(h,S)}hasTrailingPathSeparator(h,S=D.sep){if(h.scheme===n.Schemas.file){const P=E(h);return P.length>R.getRoot(P).length&&P[P.length-1]===S}else{const P=h.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,S=D.sep){return(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,S=D.sep){let P=!1;if(h.scheme===n.Schemas.file){const p=E(h);P=p!==void 0&&p.length===R.getRoot(p).length&&p[p.length-1]===S}else{S="/";const p=h.path;P=p.length===1&&p.charCodeAt(p.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(h,S)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(v=>v.scheme===n.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new b(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(v,h){const S=[];for(let P=0;P<v.length;P++){const p=h(v[P]);v.some((g,a)=>a===P?!1:(0,e.isEqualOrParent)(p,h(g)))||S.push(v[P])}return S}e.distinctParents=C;var y;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(S){const P=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(a=>{const[f,l]=a.split(":");f&&l&&P.set(f,l)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&P.set(v.META_DATA_MIME,g),P}v.parseMetaData=h})(y=e.DataUri||(e.DataUri={}));function m(v,h,S){if(h){let P=v.path;return P&&P[0]!==D.posix.sep&&(P=D.posix.sep+P),v.with({scheme:S,authority:h,path:P})}return v.with({scheme:S})}e.toLocalResource=m}),define(ne[6],re([0,1,22,9,3,2,17,4]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(V){return!!V&&typeof V.then=="function"}e.isThenable=E;function b(V){const U=new R.CancellationTokenSource,N=V(U.token),j=new Promise((x,Z)=>{const oe=U.token.onCancellationRequested(()=>{oe.dispose(),U.dispose(),Z(new n.CancellationError)});Promise.resolve(N).then(X=>{oe.dispose(),U.dispose(),x(X)},X=>{oe.dispose(),U.dispose(),Z(X)})});return new class{cancel(){U.cancel()}then(x,Z){return j.then(x,Z)}catch(x){return this.then(void 0,x)}finally(x){return j.finally(x)}}}e.createCancelablePromise=b;function C(V,U,N){return new Promise((j,x)=>{const Z=U.onCancellationRequested(()=>{Z.dispose(),j(N)});V.then(j,x).finally(()=>Z.dispose())})}e.raceCancellation=C;function y(V,U){return new Promise((N,j)=>{const x=U.onCancellationRequested(()=>{x.dispose(),j(new n.CancellationError)});V.then(N,j).finally(()=>x.dispose())})}e.raceCancellationError=y;async function m(V){let U=-1;const N=V.map((x,Z)=>x.then(oe=>(U=Z,oe))),j=await Promise.race(N);return V.forEach((x,Z)=>{Z!==U&&x.cancel()}),j}e.raceCancellablePromises=m;function v(V,U,N){let j;const x=setTimeout(()=>{j?.(void 0),N?.()},U);return Promise.race([V.finally(()=>clearTimeout(x)),new Promise(Z=>j=Z)])}e.raceTimeout=v;function h(V){return new Promise((U,N)=>{const j=V();E(j)?j.then(U,N):U(j)})}e.asPromise=h;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(N,N).then(j)})}return new Promise((N,j)=>{this.queuedPromise.then(N,j)})}return this.activePromise=U(),new Promise((N,j)=>{this.activePromise.then(x=>{this.activePromise=null,N(x)},x=>{this.activePromise=null,j(x)})})}}e.Throttler=S;class P{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=P;class p{constructor(){this.promiseMap=new Map}queue(U,N){const x=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(U)===x&&this.promiseMap.delete(U)});return this.promiseMap.set(U,x),x}}e.SequencerByKey=p;const g=(V,U)=>{let N=!0;const j=setTimeout(()=>{N=!1,U()},V);return{isTriggered:()=>N,dispose:()=>{clearTimeout(j),N=!1}}},a=V=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,V())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(U){this.defaultDelay=U,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,N=this.defaultDelay){this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((x,Z)=>{this.doResolve=x,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const x=this.task;return this.task=null,x()}}));const j=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=N===e.MicrotaskDelay?a(j):g(N,j),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class l{constructor(U){this.delayer=new f(U),this.throttler=new S}trigger(U,N){return this.delayer.trigger(()=>this.throttler.queue(U),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class i{constructor(){this._isOpen=!1,this._promise=new Promise((U,N)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class s extends i{constructor(U){super(),this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function t(V,U){return U?new Promise((N,j)=>{const x=setTimeout(()=>{Z.dispose(),N()},V),Z=U.onCancellationRequested(()=>{clearTimeout(x),Z.dispose(),j(new n.CancellationError)})}):b(N=>t(V,N))}e.timeout=t;function r(V,U=0){const N=setTimeout(V,U);return(0,L.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=r;function o(V){const U=[];let N=0;const j=V.length;function x(){return N<j?V[N++]():null}function Z(oe){oe!=null&&U.push(oe);const X=x();return X?X.then(Z):Promise.resolve(U)}return Promise.resolve(null).then(Z)}e.sequence=o;function c(V,U=j=>!!j,N=null){let j=0;const x=V.length,Z=()=>{if(j>=x)return Promise.resolve(N);const oe=V[j++];return Promise.resolve(oe()).then(ie=>U(ie)?Promise.resolve(ie):Z())};return Z()}e.first=c;function u(V,U=j=>!!j,N=null){if(V.length===0)return Promise.resolve(N);let j=V.length;const x=()=>{j=-1;for(const Z of V)Z.cancel?.()};return new Promise((Z,oe)=>{for(const X of V)X.then(ie=>{--j>=0&&U(ie)?(x(),Z(ie)):j===0&&Z(N)}).catch(ie=>{--j>=0&&(x(),oe(ie))})})}e.firstParallel=u;class d{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(U){return this._size++,new Promise((N,j)=>{this.outstandingPromises.push({factory:U,c:N,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const N=U.factory();N.then(U.c,U.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=d;class w extends d{constructor(){super(1)}}e.Queue=w;class A{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const U=new W;return this.drainers.add(U),U.p}isDrained(){for(const[,U]of this.queues)if(U.size>0)return!1;return!0}queueFor(U,N=T.extUri){const j=N.getComparisonKey(U);let x=this.queues.get(j);return x||(x=new w,D.Event.once(x.onDrained)(()=>{x?.dispose(),this.queues.delete(j),this.onDidQueueDrain()}),this.queues.set(j,x)),x}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const U of this.drainers)U.complete();this.drainers.clear()}dispose(){for(const[,U]of this.queues)U.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=A;class O{constructor(U,N){this._token=-1,typeof U=="function"&&typeof N=="number"&&this.setIfNotSet(U,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},N)}setIfNotSet(U,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},N))}}e.TimeoutTimer=O;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setInterval(()=>{U()},N)}}e.IntervalTimer=_;class M{constructor(U,N){this.timeoutToken=-1,this.runner=U,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class k{constructor(U,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=k;class F extends M{constructor(U,N){super(U,N),this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner?.(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=F;class $ extends L.Disposable{constructor(U,N){super(),this.options=U,this.handler=N,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.options.maxBufferedWork)return!1}else if(this.pending+U.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=V=>{(0,I.setTimeout0)(()=>{if(U)return;const N=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(V,U)=>{const N=requestIdleCallback(V,typeof U=="number"?{timeout:U}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(N))}}}}();class q{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function J(V,U,N){let j;for(let x=0;x<N;x++)try{return await V()}catch(Z){j=Z,await t(U)}throw j}e.retry=J;class H{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(U,N,j){return this._pending={taskId:U,cancel:()=>j?.(),promise:N},N.then(()=>this.donePending(U),()=>this.donePending(U)),N}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let N,j;const x=new Promise((Z,oe)=>{N=Z,j=oe});this._next={run:U,promise:x,promiseResolve:N,promiseReject:j}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=H;class K{constructor(U,N=()=>Date.now()){this.interval=U,this.nowFn=N,this.lastIncrementTime=0,this.value=0}increment(){const U=this.nowFn();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,N)=>{this.completeCallback=U,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(N=>{this.completeCallback(U),this.resolved=!0,N()})}error(U){return new Promise(N=>{this.errorCallback(U),this.rejected=!0,N()})}cancel(){new Promise(U=>{this.errorCallback(new n.CancellationError),this.rejected=!0,U()})}}e.DeferredPromise=W;var B;(function(V){async function U(j){let x;const Z=await Promise.all(j.map(oe=>oe.then(X=>X,X=>{x||(x=X)})));if(typeof x<"u")throw x;return Z}V.settled=U;function N(j){return new Promise(async(x,Z)=>{try{await j(x,Z)}catch(oe){Z(oe)}})}V.withAsyncBody=N})(B=e.Promises||(e.Promises={}));var Y;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(Y||(Y={}));class te{constructor(U){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const N={emitOne:j=>this.emitOne(j),emitMany:j=>this.emitMany(j),reject:j=>this.reject(j)};try{await Promise.resolve(U(N)),this.resolve()}catch(j){this.reject(j)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}static fromArray(U){return new te(N=>{N.emitMany(U)})}static fromPromise(U){return new te(async N=>{N.emitMany(await U)})}static fromPromises(U){return new te(async N=>{await Promise.all(U.map(async j=>N.emitOne(await j)))})}static merge(U){return new te(async N=>{await Promise.all(U.map(async j=>{for await(const x of j)N.emitOne(x)}))})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(U<this._results.length)return{done:!1,value:this._results[U++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(U,N){return new te(async j=>{for await(const x of U)j.emitOne(N(x))})}map(U){return te.map(this,U)}static filter(U,N){return new te(async j=>{for await(const x of U)N(x)&&j.emitOne(x)})}filter(U){return te.filter(this,U)}static coalesce(U){return te.filter(U,N=>!!N)}coalesce(){return te.coalesce(this)}static async toPromise(U){const N=[];for await(const j of U)N.push(j);return N}toPromise(){return te.toPromise(this)}emitOne(U){this._state===0&&(this._results.push(U),this._onStateChanged.fire())}emitMany(U){this._state===0&&(this._results=this._results.concat(U),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(U){this._state===0&&(this._state=2,this._error=U,this._onStateChanged.fire())}}e.AsyncIterableObject=te,te.EMPTY=te.fromArray([]);class ce extends te{constructor(U,N){super(N),this._source=U}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function z(V){const U=new R.CancellationTokenSource,N=V(U.token);return new ce(U,async j=>{const x=U.token.onCancellationRequested(()=>{x.dispose(),U.dispose(),j.reject(new n.CancellationError)});try{for await(const Z of N){if(U.token.isCancellationRequested)return;j.emitOne(Z)}x.dispose(),U.dispose()}catch(Z){x.dispose(),U.dispose(),j.reject(Z)}})}e.createCancelableAsyncIterable=z}),define(ne[85],re([0,1,18,6,46,34,12,4,25]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",y="[^/\\\\]",m=/\//g;function v(W,B){switch(W){case 0:return"";case 1:return`${y}*?`;default:return`(?:${C}|${y}+${C}${B?`|${C}${y}+`:""})*?`}}function h(W,B){if(!W)return[];const Y=[];let te=!1,ce=!1,z="";for(const V of W){switch(V){case B:if(!te&&!ce){Y.push(z),z="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}z+=V}return z&&Y.push(z),Y}e.splitGlobAware=h;function S(W){if(!W)return"";let B="";const Y=h(W,e.GLOB_SPLIT);if(Y.every(te=>te===e.GLOBSTAR))B=".*";else{let te=!1;Y.forEach((ce,z)=>{if(ce===e.GLOBSTAR){if(te)return;B+=v(2,z===Y.length-1)}else{let V=!1,U="",N=!1,j="";for(const x of ce){if(x!=="}"&&V){U+=x;continue}if(N&&(x!=="]"||!j)){let Z;x==="-"?Z=x:(x==="^"||x==="!")&&!j?Z="^":x===e.GLOB_SPLIT?Z="":Z=(0,E.escapeRegExpCharacters)(x),j+=Z;continue}switch(x){case"{":V=!0;continue;case"[":N=!0;continue;case"}":{B+=`(?:${h(U,",").map(X=>S(X)).join("|")})`,V=!1,U="";break}case"]":{B+="["+j+"]",N=!1,j="";break}case"?":B+=y;continue;case"*":B+=v(1);continue;default:B+=(0,E.escapeRegExpCharacters)(x)}}z<Y.length-1&&(Y[z+1]!==e.GLOBSTAR||z+2<Y.length)&&(B+=C)}te=ce===e.GLOBSTAR})}return B}const P=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.LRUCache(1e4),s=function(){return!1},t=function(){return null};function r(W,B){if(!W)return t;let Y;typeof W!="string"?Y=W.pattern:Y=W,Y=Y.trim();const te=`${Y}_${!!B.trimForExclusions}`;let ce=i.get(te);if(ce)return o(ce,W);let z;return P.test(Y)?ce=u(Y.substr(4),Y):(z=p.exec(c(Y,B)))?ce=d(z[1],Y):(B.trimForExclusions?a:g).test(Y)?ce=w(Y,B):(z=f.exec(c(Y,B)))?ce=A(z[1].substr(1),Y,!0):(z=l.exec(c(Y,B)))?ce=A(z[1],Y,!1):ce=O(Y),i.set(te,ce),o(ce,W)}function o(W,B){if(typeof B=="string")return W;const Y=function(te,ce){return(0,D.isEqualOrParent)(te,B.base,!I.isLinux)?W(te.substr(B.base.length+1),ce):null};return Y.allBasenames=W.allBasenames,Y.allPaths=W.allPaths,Y.basenames=W.basenames,Y.patterns=W.patterns,Y}function c(W,B){return B.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function u(W,B){return function(Y,te){return typeof Y=="string"&&Y.endsWith(W)?B:null}}function d(W,B){const Y=`/${W}`,te=`\\${W}`,ce=function(V,U){return typeof V!="string"?null:U?U===W?B:null:V===W||V.endsWith(Y)||V.endsWith(te)?B:null},z=[W];return ce.basenames=z,ce.patterns=[B],ce.allBasenames=z,ce}function w(W,B){const Y=H(W.slice(1,-1).split(",").map(U=>r(U,B)).filter(U=>U!==t),W),te=Y.length;if(!te)return t;if(te===1)return Y[0];const ce=function(U,N){for(let j=0,x=Y.length;j<x;j++)if(Y[j](U,N))return W;return null},z=Y.find(U=>!!U.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function A(W,B,Y){const te=T.sep===T.posix.sep,ce=te?W:W.replace(m,T.sep),z=T.sep+ce,V=T.posix.sep+W;let U;return Y?U=function(N,j){return typeof N=="string"&&(N===ce||N.endsWith(z)||!te&&(N===W||N.endsWith(V)))?B:null}:U=function(N,j){return typeof N=="string"&&(N===ce||!te&&N===W)?B:null},U.allPaths=[(Y?"*/":"./")+W],U}function O(W){try{const B=new RegExp(`^${S(W)}$`);return function(Y){return B.lastIndex=0,typeof Y=="string"&&B.test(Y)?W:null}}catch{return t}}function _(W,B,Y){return!W||typeof B!="string"?!1:M(W)(B,void 0,Y)}e.match=_;function M(W,B={}){if(!W)return s;if(typeof W=="string"||k(W)){const Y=r(W,B);if(Y===t)return s;const te=function(ce,z){return!!Y(ce,z)};return Y.allBasenames&&(te.allBasenames=Y.allBasenames),Y.allPaths&&(te.allPaths=Y.allPaths),te}return q(W,B)}e.parse=M;function k(W){const B=W;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=k;function F(W){return W.allBasenames||[]}e.getBasenameTerms=F;function $(W){return W.allPaths||[]}e.getPathTerms=$;function q(W,B){const Y=H(Object.getOwnPropertyNames(W).map(U=>J(U,W[U],B)).filter(U=>U!==t)),te=Y.length;if(!te)return t;if(!Y.some(U=>!!U.requiresSiblings)){if(te===1)return Y[0];const U=function(x,Z){let oe;for(let X=0,ie=Y.length;X<ie;X++){const se=Y[X](x,Z);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(oe||(oe=[]),oe.push(se))}return oe?(async()=>{for(const X of oe){const ie=await X;if(typeof ie=="string")return ie}return null})():null},N=Y.find(x=>!!x.allBasenames);N&&(U.allBasenames=N.allBasenames);const j=Y.reduce((x,Z)=>Z.allPaths?x.concat(Z.allPaths):x,[]);return j.length&&(U.allPaths=j),U}const ce=function(U,N,j){let x,Z;for(let oe=0,X=Y.length;oe<X;oe++){const ie=Y[oe];ie.requiresSiblings&&j&&(N||(N=(0,T.basename)(U)),x||(x=N.substr(0,N.length-(0,T.extname)(U).length)));const se=ie(U,N,x,j);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(Z||(Z=[]),Z.push(se))}return Z?(async()=>{for(const oe of Z){const X=await oe;if(typeof X=="string")return X}return null})():null},z=Y.find(U=>!!U.allBasenames);z&&(ce.allBasenames=z.allBasenames);const V=Y.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return V.length&&(ce.allPaths=V),ce}function J(W,B,Y){if(B===!1)return t;const te=r(W,Y);if(te===t)return t;if(typeof B=="boolean")return te;if(B){const ce=B.when;if(typeof ce=="string"){const z=(V,U,N,j)=>{if(!j||!te(V,U))return null;const x=ce.replace("$(basename)",N),Z=j(x);return(0,n.isThenable)(Z)?Z.then(oe=>oe?W:null):Z?W:null};return z.requiresSiblings=!0,z}}return te}function H(W,B){const Y=W.filter(U=>!!U.basenames);if(Y.length<2)return W;const te=Y.reduce((U,N)=>{const j=N.basenames;return j?U.concat(j):U},[]);let ce;if(B){ce=[];for(let U=0,N=te.length;U<N;U++)ce.push(B)}else ce=Y.reduce((U,N)=>{const j=N.patterns;return j?U.concat(j):U},[]);const z=function(U,N){if(typeof U!="string")return null;if(!N){let x;for(x=U.length;x>0;x--){const Z=U.charCodeAt(x-1);if(Z===47||Z===92)break}N=U.substr(x)}const j=te.indexOf(N);return j!==-1?ce[j]:null};z.basenames=te,z.patterns=ce,z.allBasenames=te;const V=W.filter(U=>!U.basenames);return V.push(z),V}function K(W,B){return(0,R.equals)(W,B,(Y,te)=>typeof Y=="string"&&typeof te=="string"?Y===te:typeof Y!="string"&&typeof te!="string"?Y.base===te.base&&Y.pattern===te.pattern:!1)}e.patternsEquals=K}),define(ne[131],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(C){return C.toJSON()}class D{constructor(y){this._uriTransformer=y}transformIncoming(y){const m=this._uriTransformer.transformIncoming(y);return m===y?y:n(R.URI.from(m))}transformOutgoing(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:n(R.URI.from(m))}transformOutgoingURI(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:R.URI.from(m)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function L(C,y,m){if(!C||m>200)return null;if(typeof C=="object"){if(C instanceof R.URI)return y.transformOutgoing(C);for(const v in C)if(Object.hasOwnProperty.call(C,v)){const h=L(C[v],y,m+1);h!==null&&(C[v]=h)}}return null}function T(C,y){const m=L(C,y,0);return m===null?C:m}e.transformOutgoingURIs=T;function I(C,y,m,v){if(!C||v>200)return null;if(typeof C=="object"){if(C.$mid===1)return m?R.URI.revive(y.transformIncoming(C)):y.transformIncoming(C);for(const h in C)if(Object.hasOwnProperty.call(C,h)){const S=I(C[h],y,m,v+1);S!==null&&(C[h]=S)}}return null}function E(C,y){const m=I(C,y,!1,0);return m===null?C:m}e.transformIncomingURIs=E;function b(C,y){const m=I(C,y,!0,0);return m===null?C:m}e.transformAndReviveIncomingURIs=b}),define(ne[132],re([0,1,37,9,34,30,118]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,y=0;const m=(0,R.networkInterfaces)();for(const v in m){const h=m[v];if(h)for(const{mac:S,internal:P}of h)P||(y+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(C+=1))}this._value=y>0?C/y:0}return this._value}};let I;async function E(){return I||(I=(async()=>await b()||L.generateUuid())()),I}e.getMachineId=E;async function b(){try{const C=await new Promise((m,v)=>{Q(["crypto"],m,v)}),y=(0,T.getMac)();return C.createHash("sha256").update(y,"utf8").digest("hex")}catch(C){n.onUnexpectedError(C);return}}}),define(ne[28],re([0,1,53,37,272,6,46,83,12,4,17,7]),function(Q,e,R,n,D,L,T,I,E,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(q){q[q.UNLINK=0]="UNLINK",q[q.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function v(q,J=m.UNLINK){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");return J===m.UNLINK?S(q):h(q)}async function h(q){try{const J=(0,T.randomPath)((0,n.tmpdir)());try{await R.promises.rename(q,J)}catch(H){return H.code==="ENOENT"?void 0:S(q)}S(J).catch(H=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function S(q){return(0,D.promisify)(R.rm)(q,{recursive:!0,force:!0,maxRetries:3})}function P(q){if((0,T.isRootOrDriveLetter)(q))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=P;async function p(q,J){return f(await(J?g(q):(0,D.promisify)(R.readdir)(q)))}async function g(q){try{return await(0,D.promisify)(R.readdir)(q,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const J=[],H=await p(q);for(const K of H){let W=!1,B=!1,Y=!1;try{const te=await e.Promises.lstat((0,E.join)(q,K));W=te.isFile(),B=te.isDirectory(),Y=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}J.push({name:K,isFile:()=>W,isDirectory:()=>B,isSymbolicLink:()=>Y})}return J}function a(q){return f(R.readdirSync(q))}e.readdirSync=a;function f(q){return q.map(J=>typeof J=="string"?b.isMacintosh?(0,I.normalizeNFC)(J):J:(J.name=b.isMacintosh?(0,I.normalizeNFC)(J.name):J.name,J))}async function l(q){const J=await p(q),H=[];for(const K of J)await s.existsDirectory((0,E.join)(q,K))&&H.push(K);return H}function i(q,J=1e3){return new Promise(H=>{let K=!1;const W=setInterval(()=>{K||(K=!0,R.access(q,B=>{K=!1,B&&(clearInterval(W),H(void 0))}))},J)})}e.whenDeleted=i;var s;(function(q){async function J(W){let B;try{if(B=await e.Promises.lstat(W),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(b.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw te}throw Y}}q.stat=J;async function H(W){try{const{stat:B,symbolicLink:Y}=await q.stat(W);return B.isFile()&&Y?.dangling!==!0}catch{}return!1}q.existsFile=H;async function K(W){try{const{stat:B,symbolicLink:Y}=await q.stat(W);return B.isDirectory()&&Y?.dangling!==!0}catch{}return!1}q.existsDirectory=K})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function r(q,J,H){return t.queueFor(y.URI.file(q),C.extUriBiasedIgnorePathCase).queue(()=>{const K=w(H);return new Promise((W,B)=>u(q,J,K,Y=>Y?B(Y):W()))})}let o=!0;function c(q){o=q}e.configureFlushOnWrite=c;function u(q,J,H,K){if(!o)return R.writeFile(q,J,{mode:H.mode,flag:H.flag},K);R.open(q,H.flag,H.mode,(W,B)=>{if(W)return K(W);R.writeFile(B,J,Y=>{if(Y)return R.close(B,()=>K(Y));R.fdatasync(B,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),c(!1)),R.close(B,ce=>K(ce))))})})}function d(q,J,H){const K=w(H);if(!o)return R.writeFileSync(q,J,{mode:K.mode,flag:K.flag});const W=R.openSync(q,K.flag,K.mode);try{R.writeFileSync(W,J);try{R.fdatasyncSync(W)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),c(!1)}}finally{R.closeSync(W)}}e.writeFileSync=d;function w(q){return q?{mode:typeof q.mode=="number"?q.mode:438,flag:typeof q.flag=="string"?q.flag:"w"}:{mode:438,flag:"w"}}async function A(q,J){if(q!==J)try{await e.Promises.rename(q,J)}catch(H){if(q.toLowerCase()!==J.toLowerCase()&&H.code==="EXDEV"||q.endsWith("."))await O(q,J,{preserveSymlinks:!1}),await v(q,m.MOVE);else throw H}}async function O(q,J,H){return M(q,J,{root:{source:q,target:J},options:H,handledSourcePaths:new Set})}const _=511;async function M(q,J,H){if(H.handledSourcePaths.has(q))return;H.handledSourcePaths.add(q);const{stat:K,symbolicLink:W}=await s.stat(q);if(W){if(H.options.preserveSymlinks)try{return await $(q,J,H)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(W.dangling)return}return K.isDirectory()?k(q,J,K.mode&_,H):F(q,J,K.mode&_)}async function k(q,J,H,K){await e.Promises.mkdir(J,{recursive:!0,mode:H});const W=await p(q);for(const B of W)await M((0,E.join)(q,B),(0,E.join)(J,B),K)}async function F(q,J,H){await e.Promises.copyFile(q,J),await e.Promises.chmod(J,H)}async function $(q,J,H){let K=await e.Promises.readlink(q);(0,T.isEqualOrParent)(K,H.root.source,!b.isLinux)&&(K=(0,E.join)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,J)}e.Promises=new class{get access(){return(0,D.promisify)(R.access)}get stat(){return(0,D.promisify)(R.stat)}get lstat(){return(0,D.promisify)(R.lstat)}get utimes(){return(0,D.promisify)(R.utimes)}get read(){return(q,J,H,K,W)=>new Promise((B,Y)=>{R.read(q,J,H,K,W,(te,ce,z)=>te?Y(te):B({bytesRead:ce,buffer:z}))})}get readFile(){return(0,D.promisify)(R.readFile)}get write(){return(q,J,H,K,W)=>new Promise((B,Y)=>{R.write(q,J,H,K,W,(te,ce,z)=>te?Y(te):B({bytesWritten:ce,buffer:z}))})}get appendFile(){return(0,D.promisify)(R.appendFile)}get fdatasync(){return(0,D.promisify)(R.fdatasync)}get truncate(){return(0,D.promisify)(R.truncate)}get rename(){return(0,D.promisify)(R.rename)}get copyFile(){return(0,D.promisify)(R.copyFile)}get open(){return(0,D.promisify)(R.open)}get close(){return(0,D.promisify)(R.close)}get symlink(){return(0,D.promisify)(R.symlink)}get readlink(){return(0,D.promisify)(R.readlink)}get chmod(){return(0,D.promisify)(R.chmod)}get mkdir(){return(0,D.promisify)(R.mkdir)}get unlink(){return(0,D.promisify)(R.unlink)}get rmdir(){return(0,D.promisify)(R.rmdir)}get realpath(){return(0,D.promisify)(R.realpath)}async exists(q){try{return await e.Promises.access(q),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return l}get writeFile(){return r}get rm(){return v}get move(){return A}get copy(){return O}}}),define(ne[133],re([0,1,53,12,4,25,28]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function I(m){if(D.isLinux)return m;const v=(0,n.dirname)(m);if(m===v)return m;const h=((0,n.basename)(m)||m).toLowerCase();try{const P=(0,T.readdirSync)(v).filter(p=>p.toLowerCase()===h);if(P.length===1){const p=I(v);if(p)return(0,n.join)(p,P[0])}else if(P.length>1){const p=P.indexOf(h);if(p>=0){const g=I(v);if(g)return(0,n.join)(g,P[p])}}}catch{}return null}e.realcaseSync=I;async function E(m){if(D.isLinux)return m;const v=(0,n.dirname)(m);if(m===v)return m;const h=((0,n.basename)(m)||m).toLowerCase();try{const P=(await T.Promises.readdir(v)).filter(p=>p.toLowerCase()===h);if(P.length===1){const p=await E(v);if(p)return(0,n.join)(p,P[0])}else if(P.length>1){const p=P.indexOf(h);if(p>=0){const g=await E(v);if(g)return(0,n.join)(g,P[p])}}}catch{}return null}e.realcase=E;async function b(m){try{return await T.Promises.realpath(m)}catch{const h=y(m);return await T.Promises.access(h,R.constants.R_OK),h}}e.realpath=b;function C(m){try{return R.realpathSync(m)}catch{const h=y(m);return R.accessSync(h,R.constants.R_OK),h}}e.realpathSync=C;function y(m){return(0,L.rtrim)((0,n.normalize)(m),n.sep)}}),define(ne[86],re([0,1,37,12,28]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,T=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var E;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(E||(E={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class y{constructor(l,i,s){this.exePath=l,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:f=!1}={}){return f?b===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:f=!1,findPreview:l=!1}={}){const i=m({useAlternateBitness:f});if(!i)return null;const s=n.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let t=-1,r=null;for(const u of await D.Promises.readdir(s)){let d=-1;if(l){const A=u.indexOf("-");if(A<0)continue;const O=u.substring(0,A);if(!L.test(O)||u.substring(A+1)!=="preview")continue;d=parseInt(O,10)}else{if(!L.test(u))continue;d=parseInt(u,10)}if(d<=t)continue;const w=n.join(s,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(w)||(r=w,t=d)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",c=l?" Preview":"";return new y(r,`PowerShell${c}${o}`,!0)}async function h({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=f?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(l))if(i.test(t)){const r=n.join(l,t,"pwsh.exe");return new y(r,s)}return null}function S(){const f=n.join(R.homedir(),".dotnet","tools","pwsh.exe");return new y(f,".NET Core PowerShell Global Tool")}function P(){const f=n.join(process.env.windir,b===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(f,"Windows PowerShell",!0)}async function*p(){let f=await v();f&&(yield f),f=await v({useAlternateBitness:!0}),f&&(yield f),f=await h(),f&&(yield f),f=S(),f&&(yield f),f=await v({findPreview:!0}),f&&(yield f),f=await h({findPreview:!0}),f&&(yield f),f=await v({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=P(),f&&(yield f)}async function*g(){for await(const f of p())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function a(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=a}),define(ne[87],re([0,1,12,4,36,81,14,28]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(y=D.env){return y.comspec||"cmd.exe"}e.getWindowsShell=E;function b(y){let m=[],v=!1;const h=function(S){if(v){m.push(S);return}(!y.send(S,p=>{if(p&&console.error(p),v=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(a=>h(a))}})||n.isWindows)&&(v=!0)};return{send:h}}e.createQueuedSender=b;var C;(function(y){async function m(v,h,S){if(R.isAbsolute(v))return v;if(h===void 0&&(h=D.cwd()),R.dirname(v)!=="."||(S===void 0&&T.isString(D.env.PATH)&&(S=D.env.PATH.split(R.delimiter)),S===void 0||S.length===0))return R.join(h,v);async function p(g){if(await I.Promises.exists(g)){let a;try{a=await I.Promises.stat(g)}catch(f){f.message.startsWith("EACCES")&&(a=await I.Promises.lstat(g))}return a?!a.isDirectory():!1}return!1}for(const g of S){let a;if(R.isAbsolute(g)?a=R.join(g,v):a=R.join(h,g,v),await p(a))return a;let f=a+".com";if(await p(f)||(f=a+".exe",await p(f)))return f}return R.join(h,v)}y.findExecutable=m})(C=e.win32||(e.win32={}))}),define(ne[134],re([0,1,54,20]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((I,E)=>{let b;const C=new Map;function y(v,h,S,P,p){const g=C.get(h);if(v===T||g){const a={name:m(S),cmd:S,pid:v,ppid:h,load:P,mem:p};C.set(v,a),v===T&&(b=a),g&&(g.children||(g.children=[]),g.children.push(a),g.children.length>1&&(g.children=g.children.sort((f,l)=>f.pid-l.pid)))}}function m(v){const h=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,P=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,a=/--crashes-directory/,f=/\\pipe\\winpty-control/,l=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(a.exec(v))return"electron-crash-reporter";if(f.exec(v))return"winpty-process";if(l.exec(v))return"console-window-host (Windows internal process)";let s=i.exec(v);if(s&&s.length===2){if(s[1]==="renderer")return h.exec(v)?"shared-process":S.exec(v)?"issue-reporter":P.exec(v)?"process-explorer":"window";if(s[1]==="utility"){if(p.exec(v))return"utility-network-service";if(g.exec(v))return"extension-host"}return s[1]}const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(v),s&&(r+=s+" ");while(s);return r&&v.indexOf("node ")<0&&v.indexOf("node.exe")<0?`electron_node ${r}`:v}if(process.platform==="win32"){const v=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,S)=>{Q(["windows-process-tree"],h,S)}).then(h=>{h.getProcessList(T,S=>{if(!S){E(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(S,P=>{const p=new Map;P.forEach(g=>{const a=v(g.commandLine||"");p.set(g.pid,{name:m(a),cmd:a,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),b=p.get(T),b?(p.forEach(g=>{const a=p.get(g.ppid);a&&(a.children||(a.children=[]),a.children.push(g))}),p.forEach(g=>{g.children&&(g.children=g.children.sort((a,f)=>a.pid-f.pid))}),I(b)):E(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let v=function(){let h=[b];const S=[];for(;h.length;){const p=h.shift();p&&(S.push(p.pid),p.children&&(h=h.concat(p.children)))}let P=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);P+=" "+S.join(" "),(0,R.exec)(P,{},(p,g,a)=>{if(p||a)E(p||new Error(a.toString()));else{const f=g.toString().split(`
`);for(let l=0;l<S.length;l++){const i=C.get(S[l]);i.load=parseFloat(f[l])}if(!b){E(new Error(`Root process ${T} not found`));return}I(b)}})};(0,R.exec)("which ps",{},(h,S,P)=>{if(h||P)if(process.platform!=="linux")E(h||new Error(P.toString()));else{const p=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,R.exec)(p,{},(g,a,f)=>{g||f?E(g||new Error(f.toString())):(L(a,y),v())})}else{const p=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${p} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(a,f,l)=>{a||l&&!l.includes("screen size is bogus")?E(a||new Error(l.toString())):(L(f,y),process.platform==="linux"?v():b?I(b):E(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function L(T,I){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=T.toString().split(`
`);for(const C of b){const y=E.exec(C.trim());y&&y.length===6&&I(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(ne[135],re([0,1,37,4,86,87]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(v,h){return v===1?n.isWindows?y():L.getWindowsShell(h):b(v,h)}e.getSystemShell=T;function I(v,h){return v===1?n.isWindows?m(h):L.getWindowsShell(h):b(v,h)}e.getSystemShellSync=I;let E=null;function b(v,h){if(n.isLinux&&v===2||n.isMacintosh&&v===3)return"/bin/bash";if(!E){let S;if(n.isWindows)S="/bin/bash";else{if(S=h.SHELL,!S)try{S=(0,R.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}E=S}return E}let C=null;async function y(){return C||(C=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),C}function m(v){if(C)return C;const h=n.isWindows&&parseFloat((0,R.release)())>=10,S=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${v.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?P:L.getWindowsShell(v)}});var pe=this&&this.__decorate||function(Q,e,R,n){var D=arguments.length,L=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,R):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,R,n);else for(var I=Q.length-1;I>=0;I--)(T=Q[I])&&(L=(D<3?T(L):D>3?T(e,R,L):T(e,R))||L);return D>3&&L&&Object.defineProperty(e,R,L),L};define(ne[39],re([0,1,18,6,16,22,62,9,3,2,65,25,14]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function P(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(p||(p={}));class g{constructor(B){this.buffer=B,this.pos=0}read(B){const Y=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Y.byteLength,Y}}class a{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var f;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object"})(f||(f={}));function l(W){const B=D.VSBuffer.alloc(4);return B.writeUInt32BE(W,0),B}function i(W){return W.read(4).readUInt32BE(0)}function s(W){const B=D.VSBuffer.alloc(1);return B.writeUInt8(W,0),B}const t={Undefined:s(f.Undefined),String:s(f.String),Buffer:s(f.Buffer),VSBuffer:s(f.VSBuffer),Array:s(f.Array),Object:s(f.Object)},r=typeof Buffer<"u";function o(W,B){if(typeof B>"u")W.write(t.Undefined);else if(typeof B=="string"){const Y=D.VSBuffer.fromString(B);W.write(t.String),W.write(l(Y.byteLength)),W.write(Y)}else if(r&&Buffer.isBuffer(B)){const Y=D.VSBuffer.wrap(B);W.write(t.Buffer),W.write(l(Y.byteLength)),W.write(Y)}else if(B instanceof D.VSBuffer)W.write(t.VSBuffer),W.write(l(B.byteLength)),W.write(B);else if(Array.isArray(B)){W.write(t.Array),W.write(l(B.length));for(const Y of B)o(W,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(B));W.write(t.Object),W.write(l(Y.byteLength)),W.write(Y)}}function c(W){switch(W.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return W.read(i(W)).toString();case f.Buffer:return W.read(i(W)).buffer;case f.VSBuffer:return W.read(i(W));case f.Array:{const Y=i(W),te=[];for(let ce=0;ce<Y;ce++)te.push(c(W));return te}case f.Object:return JSON.parse(W.read(i(W)).toString())}}class u{constructor(B,Y,te=null,ce=1e3){this.protocol=B,this.ctx=Y,this.logger=te,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(B,Y){this.channels.set(B,Y),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const Y=this.send([B.type]);this.logger?.logOutgoing(Y,0,1,P(B.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(Y,B.id,1,P(B.type),B.data);return}}}send(B,Y=void 0){const te=new a;return o(te,B),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Y=new g(B),te=c(Y),ce=c(Y),z=te[0];switch(z){case 100:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}: ${te[2]}.${te[3]}`,ce),this.onPromise({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 102:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}: ${te[2]}.${te[3]}`,ce),this.onEventListen({type:z,id:te[1],channelName:te[2],name:te[3],arg:ce});case 101:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:te[1]});case 103:return this.logger?.logIncoming(B.byteLength,te[1],1,`${h(z)}`),this.disposeActiveRequest({type:z,id:te[1]})}}onPromise(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const te=new L.CancellationTokenSource;let ce;try{ce=Y.call(this.ctx,B.name,B.arg,te.token)}catch(U){ce=Promise.reject(U)}const z=B.id;ce.then(U=>{this.sendResponse({id:z,data:U,type:201}),this.activeRequests.delete(B.id)},U=>{U instanceof Error?this.sendResponse({id:z,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.sendResponse({id:z,data:U,type:203}),this.activeRequests.delete(B.id)});const V=(0,b.toDisposable)(()=>te.cancel());this.activeRequests.set(B.id,V)}onEventListen(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const te=B.id,z=Y.listen(this.ctx,B.name,B.arg)(V=>this.sendResponse({id:te,data:V,type:204}));this.activeRequests.set(B.id,z)}disposeActiveRequest(B){const Y=this.activeRequests.get(B.id);Y&&(Y.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Y=this.pendingRequests.get(B.channelName);Y||(Y=[],this.pendingRequests.set(B.channelName,Y));const te=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:B,timeoutTimer:te})}flushPendingRequests(B){const Y=this.pendingRequests.get(B);if(Y){for(const te of Y)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.onPromise(te.request);break;case 102:this.onEventListen(te.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=u;var d;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(B,Y=null){this.protocol=B,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(te=>this.onBuffer(te)),this.logger=Y}getChannel(B){const Y=this;return{call(te,ce,z){return Y.isDisposed?Promise.reject(new I.CancellationError):Y.requestPromise(B,te,ce,z)},listen(te,ce){return Y.isDisposed?E.Event.None:Y.requestEvent(B,te,ce)}}}requestPromise(B,Y,te,ce=L.CancellationToken.None){const z=this.lastRequestId++,U={id:z,type:100,channelName:B,name:Y,arg:te};if(ce.isCancellationRequested)return Promise.reject(new I.CancellationError);let N;return new Promise((x,Z)=>{if(ce.isCancellationRequested)return Z(new I.CancellationError);const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(z),x(he.data);break;case 202:{this.handlers.delete(z);const ve=new Error(he.data.message);ve.stack=he.data.stack,ve.name=he.data.name,Z(ve);break}case 203:this.handlers.delete(z),Z(he.data);break}};this.handlers.set(z,ue),this.sendRequest(U)};let X=null;this.state===p.Idle?oe():(X=(0,n.createCancelablePromise)(ue=>this.whenInitialized()),X.then(()=>{X=null,oe()}));const ie=()=>{X?(X.cancel(),X=null):this.sendRequest({id:z,type:101}),Z(new I.CancellationError)},se=ce.onCancellationRequested(ie);N=(0,b.combinedDisposable)((0,b.toDisposable)(ie),se),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(B,Y,te){const ce=this.lastRequestId++,V={id:ce,type:102,channelName:B,name:Y,arg:te};let U=null;const N=new E.Emitter({onFirstListenerAdd:()=>{U=(0,n.createCancelablePromise)(x=>this.whenInitialized()),U.then(()=>{U=null,this.activeRequests.add(N),this.sendRequest(V)})},onLastListenerRemove:()=>{U?(U.cancel(),U=null):(this.activeRequests.delete(N),this.sendRequest({id:ce,type:103}))}}),j=x=>N.fire(x.data);return this.handlers.set(ce,j),N.event}sendRequest(B){switch(B.type){case 100:case 102:{const Y=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(Y,B.id,0,`${h(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Y=this.send([B.type,B.id]);this.logger?.logOutgoing(Y,B.id,0,h(B.type));return}}}send(B,Y=void 0){const te=new a;return o(te,B),o(te,Y),this.sendBuffer(te.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Y=new g(B),te=c(Y),ce=c(Y),z=te[0];switch(z){case 200:return this.logger?.logIncoming(B.byteLength,0,0,P(z)),this.onResponse({type:te[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,te[1],0,P(z),ce),this.onResponse({type:te[0],id:te[1],data:ce})}}onResponse(B){if(B.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,b.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}pe([T.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class A{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:Y,onDidClientDisconnect:te})=>{E.Event.once(Y.onMessage)(z=>{const V=new g(z),U=c(V),N=new u(Y,U),j=new w(Y);this.channels.forEach((Z,oe)=>N.registerChannel(oe,Z));const x={channelServer:N,channelClient:j,ctx:U};this._connections.add(x),this._onDidAddConnection.fire(x),te(()=>{N.dispose(),j.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)})})})}get connections(){const B=[];return this._connections.forEach(Y=>B.push(Y)),B}getChannel(B,Y){const te=this;return{call(ce,z,V){let U;if((0,m.isFunction)(Y)){const j=(0,R.getRandomElement)(te.connections.filter(Y));U=j?Promise.resolve(j):E.Event.toPromise(E.Event.filter(te.onDidAddConnection,Y))}else U=Y.routeCall(te,ce,z);const N=U.then(j=>j.channelClient.getChannel(B));return _(N).call(ce,z,V)},listen(ce,z){if((0,m.isFunction)(Y))return te.getMulticastEvent(B,Y,ce,z);const V=Y.routeEvent(te,ce,z).then(U=>U.channelClient.getChannel(B));return _(V).listen(ce,z)}}}getMulticastEvent(B,Y,te,ce){const z=this;let V=new b.DisposableStore;const U=new E.Emitter({onFirstListenerAdd:()=>{V=new b.DisposableStore;const N=new E.EventMultiplexer,j=new Map,x=oe=>{const ie=oe.channelClient.getChannel(B).listen(te,ce),se=N.add(ie);j.set(oe,se)},Z=oe=>{const X=j.get(oe);!X||(X.dispose(),j.delete(oe))};z.connections.filter(Y).forEach(x),E.Event.filter(z.onDidAddConnection,Y)(x,void 0,V),z.onDidRemoveConnection(Z,void 0,V),N.event(U.fire,U,V),V.add(N)},onLastListenerRemove:()=>{V.dispose()}});return U.event}registerChannel(B,Y){this.channels.set(B,Y),this._connections.forEach(te=>{te.channelServer.registerChannel(B,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(B,Y,te=null){const ce=new a;o(ce,Y),B.send(ce.buffer),this.channelClient=new w(B,te),this.channelServer=new u(B,Y,te)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Y){this.channelServer.registerChannel(B,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function _(W){return{call(B,Y,te){return W.then(ce=>ce.call(B,Y,te))},listen(B,Y){const te=new E.Relay;return W.then(ce=>te.input=ce.listen(B,Y)),te.event}}}e.getDelayedChannel=_;function M(W){let B=!1;return{call(Y,te,ce){return B?W.call(Y,te,ce):(0,n.timeout)(0).then(()=>B=!0).then(()=>W.call(Y,te,ce))},listen(Y,te){if(B)return W.listen(Y,te);const ce=new E.Relay;return(0,n.timeout)(0).then(()=>B=!0).then(()=>ce.input=W.listen(Y,te)),ce.event}}}e.getNextTickChannel=M;class k{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Y of B.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await E.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=k;var F;(function(W){function B(z,V){const U=z,N=V&&V.disableMarshalling,j=new Map;for(const x in U)te(x)&&j.set(x,E.Event.buffer(U[x],!0));return new class{listen(x,Z,oe){const X=j.get(Z);if(X)return X;if(ce(Z)){const ie=U[Z];if(typeof ie=="function")return ie.call(U,oe)}throw new Error(`Event not found: ${Z}`)}call(x,Z,oe){const X=U[Z];if(typeof X=="function"){if(!N&&Array.isArray(oe))for(let ie=0;ie<oe.length;ie++)oe[ie]=(0,C.revive)(oe[ie]);return X.apply(U,oe)}throw new Error(`Method not found: ${Z}`)}}}W.fromService=B;function Y(z,V){const U=V&&V.disableMarshalling;return new Proxy({},{get(N,j){if(typeof j=="string")return V?.properties?.has(j)?V.properties.get(j):ce(j)?function(x){return z.listen(j,x)}:te(j)?z.listen(j):async function(...x){let Z;V&&!(0,m.isUndefinedOrNull)(V.context)?Z=[V.context,...x]:Z=x;const oe=await z.call(j,Z);return U?oe:(0,C.revive)(oe)};throw new Error(`Property not found: ${String(j)}`)}})}W.toService=Y;function te(z){return z[0]==="o"&&z[1]==="n"&&y.isUpperAsciiLetter(z.charCodeAt(2))}function ce(z){return/^onDynamic/.test(z)&&y.isUpperAsciiLetter(z.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const B=W.toString();if(B!=="[object Object]")return B}return W}function J(W){return Array.isArray(W)?W.map(q):q(W)}function H(W,B,Y,te,ce,z,V){V=J(V);const U=$[ce],N=U[te%U.length];let j=[`%c[${W}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(z)?(j=j.concat(V),j.push(")")):j.push(V),console.log.apply(console,j)}e.logWithColors=H;class K{constructor(B,Y){this._outgoingPrefix=B,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Y,te,ce,z){this._totalOutgoing+=B,H(this._outgoingPrefix,this._totalOutgoing,B,Y,te,ce,z)}logIncoming(B,Y,te,ce,z){this._totalIncoming+=B,H(this._incomingPrefix,this._totalIncoming,B,Y,te,ce,z)}}e.IPCLogger=K}),define(ne[136],re([0,1,16,3,39]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(E){this.port=E,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",b=>R.VSBuffer.wrap(b.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class T extends D.IPCClient{constructor(E,b){const C=new L(E);super(C,b),this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[88],re([0,1,16,3,2,39]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(r){r.Created="created",r.Read="read",r.Write="write",r.Open="open",r.Error="error",r.Close="close",r.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",r.NodeEndReceived="nodeEndReceived",r.NodeEndSent="nodeEndSent",r.NodeDrainBegin="nodeDrainBegin",r.NodeDrainEnd="nodeDrainEnd",r.zlibInflateError="zlibInflateError",r.zlibInflateData="zlibInflateData",r.zlibInflateInitialWrite="zlibInflateInitialWrite",r.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",r.zlibInflateWrite="zlibInflateWrite",r.zlibInflateFlushFired="zlibInflateFlushFired",r.zlibDeflateError="zlibDeflateError",r.zlibDeflateData="zlibDeflateData",r.zlibDeflateWrite="zlibDeflateWrite",r.zlibDeflateFlushFired="zlibDeflateFlushFired",r.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",r.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",r.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",r.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",r.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",r.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",r.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",r.ProtocolHeaderRead="protocolHeaderRead",r.ProtocolMessageRead="protocolMessageRead",r.ProtocolHeaderWrite="protocolHeaderWrite",r.ProtocolMessageWrite="protocolMessageWrite",r.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(r){r.enableDiagnostics=!1,r.records=[];const o=new WeakMap;let c=0;function u(w,A){if(!o.has(w)){const O=String(++c);o.set(w,O)}return o.get(w)}function d(w,A,O,_){if(!r.enableDiagnostics)return;const M=u(w,A);if(_ instanceof R.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const k=R.VSBuffer.alloc(_.byteLength);k.set(_),r.records.push({timestamp:Date.now(),id:M,label:A,type:O,buff:k})}else r.records.push({timestamp:Date.now(),id:M,label:A,type:O,data:_})}r.traceSocketEvent=d})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function C(){return b||(b=R.VSBuffer.alloc(0)),b}class y{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,c){if(o===0)return C();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const A=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=o),A}if(this._chunks[0].byteLength>o){const A=this._chunks[0].slice(0,o);return c&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),A}const u=R.VSBuffer.alloc(o);let d=0,w=0;for(;o>0;){const A=this._chunks[w];if(A.byteLength>o){const O=A.slice(0,o);u.set(O,d),d+=o,c&&(this._chunks[w]=A.slice(o),this._totalLength-=o),o-=o}else u.set(A,d),d+=A.byteLength,c?(this._chunks.shift(),this._totalLength-=A.byteLength):w++,o-=A.byteLength}return u}}e.ChunkStream=y;var m;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest",r[r.Pause=7]="Pause",r[r.Resume=8]="Resume",r[r.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(r){switch(r){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var h;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.TimeoutTime=2e4]="TimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(o,c,u,d){this.type=o,this.id=c,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class P extends D.Disposable{constructor(o){super(),this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new y,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:v(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,d=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new S(u,d,w,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=R.VSBuffer.alloc(13);c.writeUInt8(o.type,0),c.writeUInt32BE(o.id,1),c.writeUInt32BE(o.ack,5),c.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:v(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(c,o.data)}_bufferAdd(o,c){const u=this._totalLength===0;return this._data.push(o,c),this._totalLength+=o.byteLength+c.byteLength,u}_bufferTake(){const o=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,c){this._bufferAdd(o,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends D.Disposable{constructor(o){super(),this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new P(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new S(1,0,0,o))}}e.Protocol=g;class a extends L.IPCClient{constructor(o,c,u=null){super(o,c,u),this.protocol=o}static fromSocket(o,c){return new a(new g(o),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=a;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class l{constructor(o){this.data=o,this.next=null}}class i{constructor(){this._first=null,this._last=null}length(){let o=0,c=this._first;for(;c;)c=c.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let c=0,u=this._first;for(;u;)o[c++]=u.data,u=u.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const c=new l(o);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let c=0;c<s._HISTORY_LENGTH;c++)this.lastRuns[c]=o-1e3*c;setInterval(()=>{for(let c=s._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),c=(1+s._HISTORY_LENGTH)*1e3;let u=0;for(let d=0;d<s._HISTORY_LENGTH;d++)o-this.lastRuns[d]<=c&&u++;return 1-u/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,c=null,u=s.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new i,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new P(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),c&&this._socketReader.acceptChunk(c),this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new S(5,0,0,C());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new S(7,0,0,C());this._socketWriter.write(o)}sendResume(){const o=new S(8,0,0,C());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,c){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new P(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,C());this._socketWriter.write(o);const c=this._outgoingUnackMsg.toArray();for(let u=0,d=c.length;u<d;u++)this._socketWriter.write(c[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new S(6,0,0,C())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let u=0,d=c.length;u<d;u++)this._socketWriter.write(c[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new S(1,c,this._incomingAckId,o);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(o){const c=new S(2,0,0,o);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),c=Date.now()-o.writtenTime,u=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&u>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:u});return}const w=Math.max(2e4-c,2e4-u,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,C());this._socketWriter.write(o)}_sendKeepAlive(){const o=new S(9,0,0,C());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(ne[137],re([0,1,89,3,39,136]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends D.IPCServer{static getOnDidClientConnect(){const E=n.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(b,C)=>C);return n.Event.map(E,b=>{const{port1:C,port2:y}=new MessageChannel,v={protocol:new L.Protocol(C),onDidClientDisconnect:n.Event.fromDOMEventEmitter(C,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[y]),v})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[66],re([0,1,54,6,16,22,130,9,3,2,31,87,81,39]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends v.ChannelServer{constructor(p){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",g=>D.VSBuffer.wrap(Buffer.from(g,"base64")))},p),process.once("disconnect",()=>this.dispose())}}e.Server=h;class S{constructor(p,g){this.modulePath=p,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const a=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(a),this.child=null,this._client=null}getChannel(p){const g=this;return{call(a,f,l){return g.requestPromise(p,a,f,l)},listen(a,f){return g.requestEvent(p,a,f)}}}requestPromise(p,g,a,f=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(p),i=(0,n.createCancelablePromise)(r=>l.call(g,a,r)),s=f.onCancellationRequested(()=>i.cancel()),t=(0,b.toDisposable)(()=>i.cancel());return this.activeRequests.add(t),i.finally(()=>{s.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(p,g,a){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let f;const l=new E.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(g,a)(l.fire,l),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(g.env),this.child=(0,R.fork)(this.modulePath,p,g);const a=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.options.serverName}`);return}a.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const l=this.options.useQueue?(0,y.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),s=a.event,t={send:i,onMessage:s};this._client=new v.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(u=>(0,b.dispose)(u)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(p){let g=this.channels.get(p);return g||(g=this.client.getChannel(p),this.channels.set(p,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[138],re([0,1,16,9,3,2,12,4,30,39,88]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function y(){return{crypto:Q.__$__nodeRequire("crypto"),zlib:Q.__$__nodeRequire("zlib"),net:Q.__$__nodeRequire("net"),os:Q.__$__nodeRequire("os")}}class m{constructor(u,d=""){this.debugLabel=d,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,n.onUnexpectedError)(w)}},this.socket.on("error",this._errorListener)}traceSocketEvent(u,d){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,d)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const d=w=>{this.traceSocketEvent("read",w),u(R.VSBuffer.wrap(w))};return this.socket.on("data",d),{dispose:()=>this.socket.off("data",d)}}onClose(u){const d=w=>{this.traceSocketEvent("close",{hadError:w}),u({type:0,hadError:w,error:void 0})};return this.socket.on("close",d),{dispose:()=>this.socket.off("close",d)}}onEnd(u){const d=()=>{this.traceSocketEvent("nodeEndReceived"),u()};return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(u){if(!this.socket.destroyed)try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,d=>{if(d){if(d.code==="EPIPE")return;(0,n.onUnexpectedError)(d)}})}catch(d){if(d.code==="EPIPE")return;(0,n.onUnexpectedError)(d)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,d)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=m;var v;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class S extends L.Disposable{constructor(u,d,w,A){super(),this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:d,inflateBytesLength:w?.byteLength||0,recordInflateBytes:A}),this._flowManager=this._register(new P(this,d,w,A,this._onData,(O,_)=>this._write(O,_))),this._register(this._flowManager.onError(O=>{console.error(O),(0,n.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(u,d){this.socket.traceSocketEvent(u,d)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._flowManager.writeMessage(u)}_write(u,d){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let w=2;u.byteLength<126?w+=0:u.byteLength<2**16?w+=2:w+=8;const A=R.VSBuffer.alloc(w);if(d?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(u.byteLength>>>24&255,++O),A.writeUInt8(u.byteLength>>>16&255,++O),A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}this.socket.write(R.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const d=this._incomingData.peek(this._state.readLen),w=d.readUInt8(0),A=(w&128)>>>7,O=(w&64)>>>6,_=d.readUInt8(1),M=(_&128)>>>7,k=_&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(k===126?2:0)+(k===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const d=this._incomingData.read(this._state.readLen),w=d.readUInt8(1),A=(w&128)>>>7;let O=w&127,_=1;O===126?O=d.readUInt8(++_)*2**8+d.readUInt8(++_):O===127&&(O=d.readUInt8(++_)*0+d.readUInt8(++_)*0+d.readUInt8(++_)*0+d.readUInt8(++_)*0+d.readUInt8(++_)*2**24+d.readUInt8(++_)*2**16+d.readUInt8(++_)*2**8+d.readUInt8(++_));let M=0;A&&(M=d.readUInt8(++_)*2**24+d.readUInt8(++_)*2**16+d.readUInt8(++_)*2**8+d.readUInt8(++_)),this._state.state=3,this._state.readLen=O,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const d=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",d),a(d,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",d),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(d,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class P extends L.Disposable{constructor(u,d,w,A,O,_){super(),this._tracer=u,this._onData=O,this._writeFn=_,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,d?(this._zlibInflateStream=this._register(new p(this._tracer,A,w,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}writeMessage(u){this._writeQueue.push(u),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const u=this._writeQueue.shift();if(this._zlibDeflateStream){const d=await this._deflateMessage(this._zlibDeflateStream,u);this._writeFn(d,!0)}else this._writeFn(u,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(u,d){return new Promise((w,A)=>{u.write(d),u.flush(O=>w(O))})}acceptFrame(u,d,w){this._readQueue.push({data:u,isCompressed:d,isLastFrameOfMessage:w}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const u=this._readQueue.shift();if(this._zlibInflateStream&&u.isCompressed){const d=await this._inflateFrame(this._zlibInflateStream,u.data,u.isLastFrameOfMessage);this._onData.fire(d)}else this._onData.fire(u.data)}this._isProcessingReadQueue=!1}}_inflateFrame(u,d,w){return new Promise((A,O)=>{u.write(d),w&&u.write(R.VSBuffer.fromByteArray([0,0,255,255])),u.flush(_=>A(_))})}}class p extends L.Disposable{constructor(u,d,w,A){super(),this._tracer=u,this._recordInflateBytes=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=y().zlib.createInflateRaw(A),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(R.VSBuffer.wrap(O))}),w&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this._zlibInflate.write(w.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}write(u){this._recordInflateBytes&&this._recordedInflateBytes.push(u.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",u),this._zlibInflate.write(u.buffer)}flush(u){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const d=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,u(d)})}}class g extends L.Disposable{constructor(u,d){super(),this._tracer=u,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=y().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",w=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this._onError.fire(w)}),this._zlibDeflate.on("data",w=>{this._tracer.traceSocketEvent("zlibDeflateData",w),this._pendingDeflateData.push(R.VSBuffer.wrap(w))})}write(u){this._tracer.traceSocketEvent("zlibDeflateWrite",u.buffer),this._zlibDeflate.write(u.buffer)}flush(u){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let d=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,d=d.slice(0,d.byteLength-4),u(d)})}}function a(c,u){if(u===0)return;const d=c.byteLength>>>2;for(let k=0;k<d;k++){const F=c.readUInt32BE(k*4);c.writeUInt32BE(F^u,k*4)}const w=d*4,A=c.byteLength-w,O=u>>>24&255,_=u>>>16&255,M=u>>>8&255;A>=1&&c.writeUInt8(c.readUInt8(w)^O,w),A>=2&&c.writeUInt8(c.readUInt8(w+1)^_,w+1),A>=3&&c.writeUInt8(c.readUInt8(w+2)^M,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function l(){const c=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):u=(0,T.join)(y().os.tmpdir(),`vscode-ipc-${c}.sock`),s(u),u}e.createRandomIPCHandle=l;function i(c,u,d){const w=y().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${d}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${w.substr(0,8)}-${d}-${u}.sock`):A=(0,T.join)(c,`${d}-${u}.sock`),s(A),A}e.createStaticIPCHandle=i;function s(c){const u=f[I.platform];typeof u=="number"&&c.length>=u&&console.warn(`WARNING: IPC handle "${c}" is longer than ${u} chars, try a shorter --user-data-dir`)}class t extends b.IPCServer{constructor(u){super(t.toClientConnectionEvent(u)),this.server=u}static toClientConnectionEvent(u){const d=D.Event.fromNodeEventEmitter(u,"connection");return D.Event.map(d,w=>({protocol:new C.Protocol(new m(w,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(w,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function r(c){return new Promise((u,d)=>{const w=y().net.createServer();w.on("error",d),w.listen(c,()=>{w.removeListener("error",d),u(new t(w))})})}e.serve=r;function o(c,u){return new Promise((d,w)=>{const A=y().net.createConnection(c,()=>{A.removeListener("error",w),d(C.Client.fromSocket(new m(A,`ipc-client${u}`),u))});A.once("error",w)})}e.connect=o}),define(ne[67],re([0,1,6,3,2,14]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function I(y){const m=y;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var E;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(E=e.StorageState||(e.StorageState={}));class b extends D.Disposable{constructor(m,v=Object.create(null)){super(),this.database=m,this.options=v,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((v,h)=>this.accept(h,v)),m.deleted?.forEach(v=>this.accept(v,void 0))}accept(m,v){if(this.state===E.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(v)?h=this.cache.delete(m):this.cache.get(m)!==v&&(this.cache.set(m,v),h=!0),h&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,v){const h=this.cache.get(m);return(0,L.isUndefinedOrNull)(h)?v:h}getBoolean(m,v){const h=this.get(m);return(0,L.isUndefinedOrNull)(h)?v:h==="true"}getNumber(m,v){const h=this.get(m);return(0,L.isUndefinedOrNull)(h)?v:parseInt(h,10)}async set(m,v){if(this.state===E.Closed)return;if((0,L.isUndefinedOrNull)(v))return this.delete(m);const h=String(v);if(this.cache.get(m)!==h)return this.cache.set(m,h),this.pendingInserts.set(m,h),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===E.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((v,h)=>this.items.set(h,v)),m.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=C}),define(ne[139],re([10,11]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(ne[140],re([10,11]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[141],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(ne[142],re([10,11]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(ne[143],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[144],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[145],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[146],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[147],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[148],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[149],re([10,11]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[150],re([10,11]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[151],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(ne[152],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(ne[153],re([10,11]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(ne[154],re([10,11]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[155],re([10,11]),function(Q,e){return Q.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[156],re([10,11]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(ne[157],re([10,11]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(ne[158],re([10,11]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[159],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[160],re([10,11]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[161],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[162],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[163],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[164],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[165],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[166],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[167],re([10,11]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[168],re([10,11]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(ne[90],re([0,1,63,62,20,12,36,17,7]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(S,P,p){this._args=S,this.paths=P,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(D.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get stateResource(){return(0,I.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return E.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(E.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=T.env.VSCODE_PORTABLE;return S?E.URI.file((0,L.join)(S,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(D.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const P=T.env.VSCODE_EXTENSIONS;if(P)return P;const p=T.env.VSCODE_PORTABLE;return p?(0,L.join)(p,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(P=>/^[^:/?#]+?:\/\//.test(P)?E.URI.parse(P):E.URI.file((0,L.normalize)(P)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?E.URI.parse(S):E.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return E.URI.file((0,L.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=T.env.VSCODE_PORTABLE;return S?E.URI.file((0,L.join)(S,"policy.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}pe([n.memoize],b.prototype,"appRoot",null),pe([n.memoize],b.prototype,"userHome",null),pe([n.memoize],b.prototype,"userDataPath",null),pe([n.memoize],b.prototype,"appSettingsHome",null),pe([n.memoize],b.prototype,"tmpDir",null),pe([n.memoize],b.prototype,"cacheHome",null),pe([n.memoize],b.prototype,"stateResource",null),pe([n.memoize],b.prototype,"userRoamingDataHome",null),pe([n.memoize],b.prototype,"userDataSyncHome",null),pe([n.memoize],b.prototype,"userDataSyncLogResource",null),pe([n.memoize],b.prototype,"editSessionsLogResource",null),pe([n.memoize],b.prototype,"sync",null),pe([n.memoize],b.prototype,"machineSettingsResource",null),pe([n.memoize],b.prototype,"workspaceStorageHome",null),pe([n.memoize],b.prototype,"localHistoryHome",null),pe([n.memoize],b.prototype,"keyboardLayoutResource",null),pe([n.memoize],b.prototype,"argvResource",null),pe([n.memoize],b.prototype,"isExtensionDevelopment",null),pe([n.memoize],b.prototype,"untitledWorkspacesHome",null),pe([n.memoize],b.prototype,"installSourcePath",null),pe([n.memoize],b.prototype,"builtinExtensionsPath",null),pe([n.memoize],b.prototype,"extensionsPath",null),pe([n.memoize],b.prototype,"extensionDevelopmentLocationURI",null),pe([n.memoize],b.prototype,"extensionDevelopmentKind",null),pe([n.memoize],b.prototype,"extensionTestsLocationURI",null),pe([n.memoize],b.prototype,"debugExtensionHost",null),pe([n.memoize],b.prototype,"serviceMachineIdResource",null),pe([n.memoize],b.prototype,"telemetryLogResource",null),pe([n.memoize],b.prototype,"disableWorkspaceTrust",null),pe([n.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function C(h,S){return v(h["inspect-extensions"],h["inspect-brk-extensions"],5870,S,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=C;function y(h,S){return v(h["inspect-search"],h["inspect-brk-search"],5876,S,h.extensionEnvironment)}e.parseSearchPort=y;function m(h,S){return v(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,S,h.extensionEnvironment)}e.parsePtyHostPort=m;function v(h,S,P,p,g,a){const l=Number(S||h)||(p?null:P),i=l?Boolean(!!S):!1;let s;if(a)try{s=JSON.parse(a)}catch{}return{port:l,break:i,debugId:g,env:s}}}),define(ne[169],re([0,1,273,4,141]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},profile:{type:"string",cat:"o",args:"settingsProfileName",description:(0,D.localize)(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(13,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(14,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},category:{type:"string",cat:"e",description:(0,D.localize)(17,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(18,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(19,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(22,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(24,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(25,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(26,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(27,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(28,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(29,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(33,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(h,S,P=T){const p={},g=["_"],a=[];for(const s in S){const t=S[s];t.alias&&(p[s]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(s),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(a.push(s),t.deprecates&&a.push(...t.deprecates))}const f=R(h,{string:g,boolean:a,alias:p}),l={},i=f;l._=f._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(const s in S){const t=S[s];t.alias&&delete i[t.alias];let r=i[s];if(t.deprecates)for(const o of t.deprecates)i.hasOwnProperty(o)&&(r||(r=i[o],r&&P.onDeprecatedOption(o,t.deprecationMessage||(0,D.localize)(35,null,s))),delete i[o]);if(typeof r<"u"){if(t.type==="string[]"){if(Array.isArray(r)||(r=[r]),!t.allowEmptyValue){const o=r.filter(c=>c.length>0);o.length!==r.length&&(P.onEmptyValue(s),r=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(r)?(r=r.pop(),P.onMultipleValues(s,r)):!r&&!t.allowEmptyValue&&(P.onEmptyValue(s),r=void 0));l[s]=r,t.deprecationMessage&&P.onDeprecatedOption(s,t.deprecationMessage)}delete i[s]}for(const s in i)P.onUnknownOption(s);return l}e.parseArgs=I;function E(h,S){let P="";return S.args&&(Array.isArray(S.args)?P=` <${S.args.join("> <")}>`:P=` <${S.args}>`),S.alias?`-${S.alias} --${h}${P}`:`--${h}${P}`}function b(h,S){let P=0;const p=[];for(const l in h){const i=h[l],s=E(l,i);P=Math.max(P,s.length),p.push([s,i.description])}const g=P+2+1;if(S-g<25)return p.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const a=S-g-1,f=[];for(const l of p){const i=l[0],s=y(l[1],a),t=C(g-i.length-2);f.push("  "+i+t+s[0]);for(let r=1;r<s.length;r++)f.push(C(g)+s[r])}return f}e.formatOptions=b;function C(h){return" ".repeat(h)}function y(h,S){const P=[];for(;h.length;){const p=h.length<S?h.length:h.lastIndexOf(" ",S),g=h.slice(0,p).trim();h=h.slice(p),P.push(g)}return P}function m(h,S,P,p,g){const a=process.stdout.isTTY&&process.stdout.columns||80,f=g?.noInputFiles!==!0?`[${(0,D.localize)(36,null)}...]`:"",l=[`${h} ${P}`];l.push(""),l.push(`${(0,D.localize)(37,null)}: ${S} [${(0,D.localize)(38,null)}]${f}`),l.push(""),g?.noPipe!==!0&&(n.isWindows?l.push((0,D.localize)(39,null,S)):l.push((0,D.localize)(40,null,S)),l.push(""));const i={};for(const s in p){const t=p[s];if(t.description&&t.cat){let r=i[t.cat];r||(i[t.cat]=r={}),r[s]=t}}for(const s in i){const t=s,r=i[t];r&&(l.push(L[t]),l.push(...b(r,a)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=m;function v(h,S){return`${h||(0,D.localize)(41,null)}
${S||(0,D.localize)(42,null)}
${process.arch}`}e.buildVersionMessage=v}),define(ne[170],re([0,1,274,142,169]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function T(m,v){const h={onUnknownOption:P=>{console.warn((0,n.localize)(0,null,P))},onMultipleValues:(P,p)=>{console.warn((0,n.localize)(1,null,P,p))},onEmptyValue:P=>{console.warn((0,n.localize)(2,null,P))},onDeprecatedOption:(P,p)=>{console.warn((0,n.localize)(3,null,P,p))}},S=(0,D.parseArgs)(m,D.OPTIONS,v?h:void 0);return S.goto&&S._.forEach(P=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,n.localize)(4,null))),S["max-memory"]&&R(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function I(m){const v=m.findIndex(h=>!/^-/.test(h));if(v>-1)return[...m.slice(0,v),...m.slice(v+1)]}function E(m){let[,...v]=m;process.env.VSCODE_DEV&&(v=I(v)||[]);const h=!y(process.env);return T(v,h)}e.parseMainProcessArgv=E;function b(m){const[,,...v]=m;return T(v,!0)}e.parseCLIProcessArgv=b;function C(m,...v){const h=m.indexOf("--");return h===-1?m.push(...v):m.splice(h,0,...v),m}e.addArg=C;function y(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),function(){"use strict";function Q(e,R,n,D){function L(I){const E=T(I),b=[E];return e.isAbsolute(E)||b.unshift(D),e.resolve(...b)}function T(I){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,n);const C=I["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(y,"AppData","Roaming")}break;case"darwin":b=e.join(R.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,n)}return{getUserDataPath:L}}if(typeof define=="function")define(ne[171],re([0,275,37,20,17,36]),function(e,R,n,D,L,T){const I=L.dirname(D.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(L.joinPath(I,"package.json").fsPath);return Q(R,n,E.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),n=require("os");module.exports=Q(R,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[172],re([0,1,37,90,171]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends n.AbstractNativeEnvironmentService{constructor(I,E){super(I,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I)},E)}}e.NativeEnvironmentService=L}),define(ne[173],re([0,1,7]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,I=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(P){const p=P.match(T);return p?p[1]:null}function C(P){if(P.indexOf("://")===-1){const p=P.match(n);return p?b(p[2]):null}try{const p=R.URI.parse(P);if(p.authority)return b(p.authority)}catch{}return null}function y(P,p){const g=new Set;let a;for(;a=I.exec(P);){const l=C(a[1]);l&&g.add(l)}const f=new Set(p);return Array.from(g).map(l=>f.has(l)?l:l.replace(E,"a"))}e.getDomainsOfRemotes=y;function m(P){const p=P.match(L);return p?p[2]:null}function v(P,p,g){return P&&p?(g&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${P}${p}`:`${P}/${p}`):null}function h(P,p){if(P.indexOf("://")===-1){const g=P.match(D);if(g)return v(g[2],g[3],p)}try{const g=R.URI.parse(P);if(g.authority)return v(m(g.authority),g.path,p)}catch{}return null}function S(P,p=!1){const g=[];let a;for(;a=I.exec(P);){const f=h(a[1],p);f&&g.push(f)}return g}e.getRemotes=S}),define(ne[174],re([0,1,14,145]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(T,I,E){try{L(T,I,E)}catch{}return T}e.localizeManifest=D;function L(T,I,E){const b=(C,y,m)=>{const v=C[y];if((0,R.isString)(v)){const h=v,S=h.length;if(S>1&&h[0]==="%"&&h[S-1]==="%"){const P=h.substr(1,S-2);let p=I[P];p===void 0&&E&&(p=E[P]);const g=typeof p=="string"?p:p.message;if(g!==void 0){const a=E?.[P],f=typeof a=="string"?a:a?.message;if(m&&(y==="title"||y==="category")&&f&&f!==g){const l={value:g,original:f};C[y]=l}else C[y]=g}else console.warn(`[${T.name}]: ${(0,n.localize)(0,null,P)}`)}}else if((0,R.isObject)(v))for(const h in v)v.hasOwnProperty(h)&&(h==="commands"?b(v,h,!0):b(v,h,m));else if(Array.isArray(v))for(let h=0;h<v.length;h++)b(v,h,m)};for(const C in T)T.hasOwnProperty(C)&&b(T,C)}}),define(ne[175],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,T,I,E){return this.channel.call("promptImportantExtensionsInstallNotification",[L,T,I,E])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class n{constructor(L){this.service=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,I){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(I[0],I[1],I[2],I[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[68],re([0,1,17,84,150,55]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function E(p){return p=p.trim(),p==="*"||T.test(p)}e.isValidVersionStr=E;function b(p){if(!E(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=p.match(T);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=b;function C(p){if(!p)return null;const g=p.majorBase,a=p.majorMustEqual,f=p.minorBase;let l=p.minorMustEqual;const i=p.patchBase;let s=p.patchMustEqual;p.hasCaret&&(g===0||(l=!1),s=!1);let t=0;if(p.preRelease){const r=I.exec(p.preRelease);if(r){const[,o,c,u]=r;t=Date.UTC(Number(o),Number(c)-1,Number(u))}}return{majorBase:g,majorMustEqual:a,minorBase:f,minorMustEqual:l,patchBase:i,patchMustEqual:s,isMinimum:p.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function y(p,g,a){let f;typeof p=="string"?f=C(b(p)):f=p;let l;g instanceof Date?l=g.getTime():typeof g=="string"&&(l=new Date(g).getTime());let i;if(typeof a=="string"?i=C(b(a)):i=a,!f||!i)return!1;const s=f.majorBase,t=f.minorBase,r=f.patchBase;let o=i.majorBase,c=i.minorBase,u=i.patchBase;const d=i.notBefore;let w=i.majorMustEqual,A=i.minorMustEqual,O=i.patchMustEqual;return i.isMinimum?s>o?!0:s<o?!1:t>c?!0:t<c||l&&l<d?!1:r>=u:(s===1&&o===0&&(!w||!A||!O)&&(o=1,c=0,u=0,w=!0,A=!1,O=!1),s<o?!1:s>o?!w:t<c?!1:t>c?!A:r<u?!1:r>u?!O:!(l&&l<d))}e.isValidVersion=y;function m(p,g,a,f,l){const i=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return i.push([n.default.Error,D.localize(0,null)]),i;if(typeof f.name!="string")return i.push([n.default.Error,D.localize(1,null,"name")]),i;if(typeof f.version!="string")return i.push([n.default.Error,D.localize(2,null,"version")]),i;if(!f.engines)return i.push([n.default.Error,D.localize(3,null,"engines")]),i;if(typeof f.engines.vscode!="string")return i.push([n.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof f.extensionDependencies<"u"&&!P(f.extensionDependencies))return i.push([n.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof f.activationEvents<"u"){if(!P(f.activationEvents))return i.push([n.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof f.main>"u"&&typeof f.browser>"u")return i.push([n.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&i.push([n.default.Warning,D.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return i.push([n.default.Error,D.localize(9,null,"main")]),i;{const r=(0,R.joinPath)(a,f.main);(0,R.isEqualOrParent)(r,a)||i.push([n.default.Warning,D.localize(10,null,r.path,a.path)])}if(typeof f.activationEvents>"u")return i.push([n.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof f.browser<"u"){if(typeof f.browser!="string")return i.push([n.default.Error,D.localize(12,null,"browser")]),i;{const r=(0,R.joinPath)(a,f.browser);(0,R.isEqualOrParent)(r,a)||i.push([n.default.Warning,D.localize(13,null,r.path,a.path)])}if(typeof f.activationEvents>"u")return i.push([n.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!L.valid(f.version))return i.push([n.default.Error,D.localize(15,null)]),i;const s=[];if(!v(p,g,f,l,s))for(const r of s)i.push([n.default.Error,r]);return i}e.validateExtensionManifest=m;function v(p,g,a,f,l){return f||typeof a.main>"u"&&typeof a.browser>"u"?!0:S(p,g,a.engines.vscode,l)}e.isValidExtensionVersion=v;function h(p,g,a){return p==="*"||S(g,a,p)}e.isEngineValid=h;function S(p,g,a,f=[]){const l=C(b(a));if(!l)return f.push(D.localize(16,null,a)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return f.push(D.localize(17,null,a)),!1}else if(!l.majorMustEqual)return f.push(D.localize(18,null,a)),!1;return y(p,g,l)?!0:(f.push(D.localize(19,null,p,a)),!1)}function P(p){if(!Array.isArray(p))return!1;for(let g=0,a=p.length;g<a;g++)if(typeof p[g]!="string")return!1;return!0}}),define(ne[47],re([0,1,16,30]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(L,T,I){let E=I&&I.get("storage.serviceMachineId",-1)||null;if(E)return E;try{const C=(await T.readFile(L.serviceMachineIdResource)).value.toString();E=(0,n.isUUID)(C)?C:null}catch{E=null}if(!E){E=(0,n.generateUuid)();try{await T.writeFile(L.serviceMachineIdResource,R.VSBuffer.fromString(E))}catch{}}return I?.store("storage.serviceMachineId",E,-1,1),E}e.getServiceMachineId=D}),define(ne[56],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(D,L=[],T=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=R}),define(ne[91],re([0,1,56]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const n=[];var D;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function L(I,E,b){E instanceof R.SyncDescriptor||(E=new R.SyncDescriptor(E,[],Boolean(b))),n.push([I,E])}e.registerSingleton=L;function T(){return n}e.getSingletonServiceDescriptors=T}),define(ne[176],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(L,T){this.key=L,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class n{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const T of this._nodes.values())T.outgoing.size===0&&L.push(T);return L}insertEdge(L,T){const I=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(T);I.outgoing.set(E.key,E),E.incoming.set(I.key,I)}removeNode(L){const T=this._hashFn(L);this._nodes.delete(T);for(const I of this._nodes.values())I.outgoing.delete(T),I.incoming.delete(T)}lookupOrInsertNode(L){const T=this._hashFn(L);let I=this._nodes.get(T);return I||(I=new R(T,L),this._nodes.set(T,I)),I}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[T,I]of this._nodes)L.push(`${T}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,T]of this._nodes){const I=new Set([L]),E=this._findCycle(T,I);if(E)return E}}_findCycle(L,T){for(const[I,E]of L.outgoing){if(T.has(I))return[...T,I].join(" -> ");T.add(I);const b=this._findCycle(E,T);if(b)return b;T.delete(I)}}}e.Graph=n}),define(ne[5],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function I(E){return E[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=I})(R=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(T,I,E){I[R.DI_TARGET]===I?I[R.DI_DEPENDENCIES].push({id:T,index:E}):(I[R.DI_DEPENDENCIES]=[{id:T,index:E}],I[R.DI_TARGET]=I)}function D(T){if(R.serviceIds.has(T))return R.serviceIds.get(T);const I=function(E,b,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(I,E,C)};return I.toString=()=>T,R.serviceIds.set(T,I),I}e.createDecorator=D;function L(T){return T}e.refineServiceDecorator=L}),define(ne[177],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(ne[19],re([0,1,14,7,5]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function L(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationOverrides=L;function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var I;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function b(p,g){const a=Object.create(null);for(const f in p)C(a,f,p[f],g);return a}e.toValuesTree=b;function C(p,g,a,f){const l=g.split("."),i=l.pop();let s=p;for(let t=0;t<l.length;t++){const r=l[t];let o=s[r];switch(typeof o){case"undefined":o=s[r]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${l.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}s=o}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{f(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(s)}`)}else f(`Ignoring ${g} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=C;function y(p,g){const a=g.split(".");m(p,a)}e.removeFromValueTree=y;function m(p,g){const a=g.shift();if(g.length===0){delete p[a];return}if(Object.keys(p).indexOf(a)!==-1){const f=p[a];typeof f=="object"&&!Array.isArray(f)&&(m(f,g),Object.keys(f).length===0&&delete p[a])}}function v(p,g,a){function f(s,t){let r=s;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const l=g.split("."),i=f(p,l);return typeof i>"u"?a:i}e.getConfigurationValue=v;function h(p,g,a){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in p?R.isObject(p[f])&&R.isObject(g[f])?h(p[f],g[f],a):a&&(p[f]=g[f]):p[f]=g[f])})}e.merge=h;function S(p,g,a){const f=p.inspect(g),l=p.inspect(a);return typeof f.userValue<"u"||typeof f.workspaceValue<"u"||typeof f.workspaceFolderValue<"u"?f.value:typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:f.defaultValue}e.getMigratedSettingValue=S;function P(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=P}),define(ne[178],re([0,1,4,25,5]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",R.isMacintosh),L.set("isLinux",R.isLinux),L.set("isWindows",R.isWindows),L.set("isWeb",R.isWeb),L.set("isMacNative",R.isMacintosh&&!R.isWeb),L.set("isEdge",R.isEdge),L.set("isFirefox",R.isFirefox),L.set("isChrome",R.isChrome),L.set("isSafari",R.isSafari);const T=Object.prototype.hasOwnProperty;var I;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(I=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(k){return v.create(k)}static equals(k,F){return h.create(k,F)}static notEquals(k,F){return p.create(k,F)}static regex(k,F){return t.create(k,F)}static in(k,F){return S.create(k,F)}static notIn(k,F){return P.create(k,F)}static not(k){return g.create(k)}static and(...k){return c.create(k,null)}static or(...k){return u.create(k,null,!0)}static greater(k,F){return f.create(k,F)}static greaterEquals(k,F){return l.create(k,F)}static smaller(k,F){return i.create(k,F)}static smallerEquals(k,F){return s.create(k,F)}static deserialize(k,F=!1){if(!!k)return this._deserializeOrExpression(k,F)}static _deserializeOrExpression(k,F){const $=k.split("||");return u.create($.map(q=>this._deserializeAndExpression(q,F)),null,!0)}static _deserializeAndExpression(k,F){const $=k.split("&&");return c.create($.map(q=>this._deserializeOne(q,F)),null)}static _deserializeOne(k,F){if(k=k.trim(),k.indexOf("!=")>=0){const $=k.split("!=");return p.create($[0].trim(),this._deserializeValue($[1],F))}if(k.indexOf("==")>=0){const $=k.split("==");return h.create($[0].trim(),this._deserializeValue($[1],F))}if(k.indexOf("=~")>=0){const $=k.split("=~");return t.create($[0].trim(),this._deserializeRegexValue($[1],F))}if(k.indexOf(" not in ")>=0){const $=k.split(" not in ");return P.create($[0].trim(),$[1].trim())}if(k.indexOf(" in ")>=0){const $=k.split(" in ");return S.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const $=k.split(">=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const $=k.split(">");return f.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const $=k.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const $=k.split("<");return i.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(k)?g.create(k.substr(1).trim()):v.create(k)}static _deserializeValue(k,F){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;const $=/^'([^']*)'$/.exec(k);return $?$[1].trim():k}static _deserializeRegexValue(k,F){if((0,n.isFalsyOrWhitespace)(k)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=k.indexOf("/"),q=k.lastIndexOf("/");if($===q||$<0){if(F)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}const J=k.slice($+1,q),H=k[q+1]==="i"?"i":"";try{return new RegExp(J,H)}catch(K){if(F)throw new Error(`bad regexp-value '${k}', parse error: ${K}`);return console.warn(`bad regexp-value '${k}', parse error: ${K}`),null}}}e.ContextKeyExpr=E;function b(M,k){const F=M?M.substituteConstants():void 0,$=k?k.substituteConstants():void 0;return!F&&!$?!0:!F||!$?!1:F.equals($)}e.expressionsAreEqualWithConstantSubstitution=b;function C(M,k){return M.cmp(k)}class y{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class m{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class v{constructor(k,F){this.key=k,this.negated=F,this.type=2}static create(k,F=null){const $=L.get(k);return typeof $=="boolean"?$?m.INSTANCE:y.INSTANCE:new v(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?m.INSTANCE:y.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=v;class h{constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=4}static create(k,F,$=null){if(typeof F=="boolean")return F?v.create(k,$):g.create(k,$);const q=L.get(k);return typeof q=="boolean"?F===(q?"true":"false")?m.INSTANCE:y.INSTANCE:new h(k,F,$)}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const F=k?"true":"false";return this.value===F?m.INSTANCE:y.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class S{constructor(k,F){this.key=k,this.valueKey=F,this.type=10,this.negated=null}static create(k,F){return new S(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const F=k.getValue(this.valueKey),$=k.getValue(this.key);return Array.isArray(F)?F.includes($):typeof $=="string"&&typeof F=="object"&&F!==null?T.call(F,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class P{constructor(k,F){this.key=k,this.valueKey=F,this.type=11,this._negated=S.create(k,F)}static create(k,F){return new P(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:this._negated.cmp(k._negated)}equals(k){return k.type===this.type?this._negated.equals(k._negated):!1}substituteConstants(){return this}evaluate(k){return!this._negated.evaluate(k)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(k){return k.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=P;class p{constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=5}static create(k,F,$=null){if(typeof F=="boolean")return F?g.create(k,$):v.create(k,$);const q=L.get(k);return typeof q=="boolean"?F===(q?"true":"false")?y.INSTANCE:m.INSTANCE:new p(k,F,$)}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=L.get(this.key);if(typeof k=="boolean"){const F=k?"true":"false";return this.value===F?y.INSTANCE:m.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class g{constructor(k,F){this.key=k,this.negated=F,this.type=3}static create(k,F=null){const $=L.get(k);return typeof $=="boolean"?$?y.INSTANCE:m.INSTANCE:new g(k,F)}cmp(k){return k.type!==this.type?this.type-k.type:w(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=L.get(this.key);return typeof k=="boolean"?k?y.INSTANCE:m.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function a(M,k){if(typeof M=="string"){const F=parseFloat(M);isNaN(F)||(M=F)}return typeof M=="string"||typeof M=="number"?k(M):y.INSTANCE}class f{constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=12}static create(k,F,$=null){return a(F,q=>new f(k,q,$))}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class l{constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=13}static create(k,F,$=null){return a(F,q=>new l(k,q,$))}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class i{constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=14}static create(k,F,$=null){return a(F,q=>new i(k,q,$))}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class s{constructor(k,F,$){this.key=k,this.value=F,this.negated=$,this.type=15}static create(k,F,$=null){return a(F,q=>new s(k,q,$))}cmp(k){return k.type!==this.type?this.type-k.type:A(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class t{constructor(k,F){this.key=k,this.regexp=F,this.type=7,this.negated=null}static create(k,F){return new t(k,F)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const F=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return F<$?-1:F>$?1:0}equals(k){if(k.type===this.type){const F=this.regexp?this.regexp.source:"",$=k.regexp?k.regexp.source:"";return this.key===k.key&&F===$}return!1}substituteConstants(){return this}evaluate(k){const F=k.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{constructor(k){this._actual=k,this.type=8}static create(k){return new r(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new r(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function o(M){let k=null;for(let F=0,$=M.length;F<$;F++){const q=M[F].substituteConstants();if(M[F]!==q&&k===null){k=[];for(let J=0;J<F;J++)k[J]=M[J]}k!==null&&(k[F]=q)}return k===null?M:k}class c{constructor(k,F){this.expr=k,this.negated=F,this.type=6}static create(k,F){return c._normalizeArr(k,F)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const q=C(this.expr[F],k.expr[F]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:c.create(k,this.negated)}evaluate(k){for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].evaluate(k))return!1;return!0}static _normalizeArr(k,F){const $=[];let q=!1;for(const J of k)if(!!J){if(J.type===1){q=!0;continue}if(J.type===0)return y.INSTANCE;if(J.type===6){$.push(...J.expr);continue}$.push(J)}if($.length===0&&q)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(C);for(let J=1;J<$.length;J++)$[J-1].equals($[J])&&($.splice(J,1),J--);if($.length===1)return $[0];for(;$.length>1;){const J=$[$.length-1];if(J.type!==9)break;$.pop();const H=$.pop(),K=$.length===0,W=u.create(J.expr.map(B=>c.create([B,H],null)),null,K);W&&($.push(W),$.sort(C))}return $.length===1?$[0]:new c($,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const F of this.expr)k.push(...F.keys());return k}map(k){return new c(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.negated){const k=[];for(const F of this.expr)k.push(F.negate());this.negated=u.create(k,this,!0)}return this.negated}}class u{constructor(k,F){this.expr=k,this.negated=F,this.type=9}static create(k,F,$){return u._normalizeArr(k,F,$)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let F=0,$=this.expr.length;F<$;F++){const q=C(this.expr[F],k.expr[F]);if(q!==0)return q}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let F=0,$=this.expr.length;F<$;F++)if(!this.expr[F].equals(k.expr[F]))return!1;return!0}return!1}substituteConstants(){const k=o(this.expr);return k===this.expr?this:u.create(k,this.negated,!1)}evaluate(k){for(let F=0,$=this.expr.length;F<$;F++)if(this.expr[F].evaluate(k))return!0;return!1}static _normalizeArr(k,F,$){let q=[],J=!1;if(k){for(let H=0,K=k.length;H<K;H++){const W=k[H];if(!!W){if(W.type===0){J=!0;continue}if(W.type===1)return m.INSTANCE;if(W.type===9){q=q.concat(W.expr);continue}q.push(W)}}if(q.length===0&&J)return y.INSTANCE;q.sort(C)}if(q.length!==0){if(q.length===1)return q[0];for(let H=1;H<q.length;H++)q[H-1].equals(q[H])&&(q.splice(H,1),H--);if(q.length===1)return q[0];if($){for(let H=0;H<q.length;H++)for(let K=H+1;K<q.length;K++)O(q[H],q[K])&&(q.splice(K,1),K--);if(q.length===1)return q[0]}return new u(q,F)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const F of this.expr)k.push(...F.keys());return k}map(k){return new u(this.expr.map(F=>F.map(k)),null)}negate(){if(!this.negated){const k=[];for(const F of this.expr)k.push(F.negate());for(;k.length>1;){const F=k.shift(),$=k.shift(),q=[];for(const H of _(F))for(const K of _($))q.push(c.create([H,K],null));const J=k.length===0;k.unshift(u.create(q,null,J))}this.negated=k[0]}return this.negated}}class d extends v{constructor(k,F,$){super(k,null),this._defaultValue=F,typeof $=="object"?d._info.push({...$,key:k}):$!==!0&&d._info.push({key:k,description:$,type:F!=null?typeof F:void 0})}static all(){return d._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return h.create(this.key,k)}notEqualsTo(k){return p.create(this.key,k)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(M,k){return M<k?-1:M>k?1:0}function A(M,k,F,$){return M<F?-1:M>F?1:k<$?-1:k>$?1:0}function O(M,k){if(k.type===6&&M.type!==9&&M.type!==6){for(const q of k.expr)if(M.equals(q))return!0}const F=M.negate(),$=_(F).concat(_(k));$.sort(C);for(let q=0;q<$.length;q++){const H=$[q].negate();for(let K=q+1;K<$.length;K++){const W=$[K];if(H.equals(W))return!0}}return!1}e.implies=O;function _(M){return M.type===9?M.expr:[M]}}),define(ne[92],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n;class D{async getPerformanceInfo(T,I){return{}}async getSystemInfo(T,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,I){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=D}),define(ne[93],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ne[15],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[29],re([0,1,144,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function L(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function T(p,g){switch(p){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function I(p,g){return g==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function E(p,g,a){return I(g,a)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===a?!0:b(a).includes(p)}e.isTargetPlatformCompatible=E;function b(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function C(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=C;var y;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var m;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(p){p.Install="install",p.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var h;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var S;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(g,a){super(g),this.code=a,this.name=a}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ne[179],re([0,1,3,2,65,31,7,131,29]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(P,p){return T.URI.revive(p?p.transformIncoming(P):P)}function C(P,p){return p?p.transformOutgoingURI(P):P}function y(P,p){p=p||I.DefaultURITransformer;const g=P.manifest;return{...(0,I.transformAndReviveIncomingURIs)({...P,manifest:void 0},p),manifest:g}}function m(P,p){return p?(0,L.cloneAndChange)(P,g=>g instanceof T.URI?p.transformOutgoingURI(g):void 0):P}class v{constructor(p,g){this.service=p,this.getUriTransformer=g,this.onInstallExtension=R.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,g){const a=this.getUriTransformer(p);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,f=>f.map(l=>({...l,local:l.local?m(l.local,a):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,g,a){const f=this.getUriTransformer(p);switch(g){case"zip":return this.service.zip(y(a[0],f)).then(l=>C(l,f));case"unzip":return this.service.unzip(b(a[0],f));case"install":return this.service.install(b(a[0],f),(0,D.revive)(a[1]));case"getManifest":return this.service.getManifest(b(a[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(a[0]);case"installFromGallery":return this.service.installFromGallery(a[0],(0,D.revive)(a[1]));case"uninstall":return this.service.uninstall(y(a[0],f),(0,D.revive)(a[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(y(a[0],f));case"getInstalled":return this.service.getInstalled(a[0],T.URI.revive(a[1])).then(l=>l.map(i=>m(i,f)));case"getMetadata":return this.service.getMetadata(y(a[0],f));case"updateMetadata":return this.service.updateMetadata(y(a[0],f),a[1]).then(l=>m(l,f));case"updateExtensionScope":return this.service.updateExtensionScope(y(a[0],f),a[1]).then(l=>m(l,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=v;class h extends n.Disposable{constructor(p){super(),this.channel=p,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?T.URI.revive(g.source):g.source,profileLocation:T.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(a=>({...a,local:a.local?y(a.local,null):a.local,source:this.isUriComponents(a.source)?T.URI.revive(a.source):a.source,profileLocation:T.URI.revive(a.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:T.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:T.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const g=await this.getTargetPlatform();return p.allTargetPlatforms.some(a=>(0,E.isTargetPlatformCompatible)(a,p.allTargetPlatforms,g))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(g=>T.URI.revive(g)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,g){return Promise.resolve(this.channel.call("install",[p,g])).then(a=>y(a,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,g){return Promise.resolve(this.channel.call("installFromGallery",[p,g])).then(a=>y(a,null))}uninstall(p,g){return Promise.resolve(this.channel.call("uninstall",[p,g]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null,g){return Promise.resolve(this.channel.call("getInstalled",[p,g])).then(a=>a.map(f=>y(f,null)))}getMetadata(p){return Promise.resolve(this.channel.call("getMetadata",[p]))}updateMetadata(p,g){return Promise.resolve(this.channel.call("updateMetadata",[p,g])).then(a=>y(a,null))}updateExtensionScope(p,g){return Promise.resolve(this.channel.call("updateExtensionScope",[p,g])).then(a=>y(a,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class S{constructor(p){this.service=p}listen(p,g){throw new Error("Invalid listen")}call(p,g,a){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(a[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[94],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function D(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var L;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,25,14,7,152,5]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function b(H){return H.create===!0}e.isFileOpenForWriteOptions=b;var C;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var y;(function(H){H[H.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var m;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=v;function h(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=h;function S(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=S;function P(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=P;function p(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=p;function g(H){return v(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var a;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(a=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(K,W){super(K),this.code=W}}e.FileSystemProviderError=f;function l(H,K){const W=new f(H.toString(),K);return s(W,K),W}e.createFileSystemProviderError=l;function i(H){return H||l((0,I.localize)(0,null),a.Unknown)}e.ensureFileSystemProviderError=i;function s(H,K){return H.name=K?`${K} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=s;function t(H){if(!H)return a.Unknown;if(H instanceof f)return H.code;const K=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!K)return a.Unknown;switch(K[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileExceedsMemoryLimit:return a.FileExceedsMemoryLimit;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.toFileSystemProviderErrorCode=t;function r(H){if(H instanceof A)return H.fileOperationResult;switch(t(H)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 10;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileExceedsMemoryLimit:return 9;case a.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(K,W,B){this.resource=K,this.operation=W,this.target=B}isOperation(K){return this.operation===K}}e.FileOperationEvent=c;var u;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class d{constructor(K,W){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=K;const B=new Map;for(const Y of K){const te=B.get(Y.type);switch(te?te.push([Y.resource,Y]):B.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,te]of B)switch(Y){case 1:this.added=R.TernarySearchTree.forUris(()=>W),this.added.fill(te);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>W),this.updated.fill(te);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>W),this.deleted.fill(te);break}}contains(K,...W){return this.doContains(K,{includeChildren:!1},...W)}affects(K,...W){return this.doContains(K,{includeChildren:!0},...W)}doContains(K,W,...B){if(!K)return!1;const Y=B.length>0;return!!((!Y||B.includes(1))&&(this.added?.get(K)||W.includeChildren&&this.added?.findSuperstr(K))||(!Y||B.includes(0))&&(this.updated?.get(K)||W.includeChildren&&this.updated?.findSuperstr(K))||(!Y||B.includes(2))&&(this.deleted?.findSubstr(K)||W.includeChildren&&this.deleted?.findSuperstr(K)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=d;function w(H,K,W){return!H||!K||H===K||K.length>H.length?!1:(K.charAt(K.length-1)!==n.sep&&(K+=n.sep),W?(0,D.startsWithIgnoreCase)(H,K):H.indexOf(K)===0)}e.isParent=w;class A extends Error{constructor(K,W,B){super(K),this.fileOperationResult=W,this.options=B}}e.FileOperationError=A;class O extends A{constructor(K,W,B){super(K,2,B),this.stat=W}}e.NotModifiedSinceFileOperationError=O;var _;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=k;async function F(H,K){if(!K.hasProvider(T.URI.from({scheme:H.scheme})))return new Promise(W=>{const B=K.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===H.scheme&&Y.added&&(B.dispose(),W())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(K){return(0,L.isNumber)(K)||(K=0),K<$.KB?(0,I.localize)(1,null,K.toFixed(0)):K<$.MB?(0,I.localize)(2,null,(K/$.KB).toFixed(2)):K<$.GB?(0,I.localize)(3,null,(K/$.MB).toFixed(2)):K<$.TB?(0,I.localize)(4,null,(K/$.GB).toFixed(2)):(0,I.localize)(5,null,(K/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var q;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function J(H){return{maxFileSize:H===0?300*$.MB:16*$.GB,maxHeapSize:H===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=J});var G=this&&this.__param||function(Q,e){return function(R,n){e(R,n,Q)}};define(ne[180],re([0,1,95,41,13]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(I){this.fileService=I}async checksum(I){const E=(await this.fileService.readFileStream(I)).value;return new Promise((b,C)=>{const y=(0,R.createHash)("md5");(0,n.listenStream)(E,{onData:m=>y.update(m.buffer),onError:m=>C(m),onEnd:()=>b(y.digest("base64").replace(/=+$/,""))})})}};L=pe([G(0,D.IFileService)],L),e.ChecksumService=L}),define(ne[181],re([0,1,16,38,9,3,2,41,7,30,13]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class y extends T.Disposable{constructor(v,h){super(),this.channel=v,this.extraCapabilities=h,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=57374,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(v){return this.channel.call("stat",[v])}readdir(v){return this.channel.call("readdir",[v])}async readFile(v,h){const{buffer:S}=await this.channel.call("readFile",[v,h]);return S}readFileStream(v,h,S){const P=(0,I.newWriteableStream)(g=>R.VSBuffer.concat(g.map(a=>R.VSBuffer.wrap(a))).buffer),p=this.channel.listen("readFileStream",[v,h])(g=>{if(g instanceof R.VSBuffer)P.write(g.buffer);else{if(g==="end")P.end();else{let a=g;a instanceof Error||(a=(0,C.createFileSystemProviderError)((0,n.toErrorMessage)(a),C.FileSystemProviderErrorCode.Unknown)),P.error(a),P.end()}p.dispose()}});return S.onCancellationRequested(()=>{P.error((0,D.canceled)()),P.end(),p.dispose()}),P}writeFile(v,h,S){return this.channel.call("writeFile",[v,R.VSBuffer.wrap(h),S])}open(v,h){return this.channel.call("open",[v,h])}close(v){return this.channel.call("close",[v])}async read(v,h,S,P,p){const[g,a]=await this.channel.call("read",[v,h,p]);return S.set(g.buffer.slice(0,a),P),a}write(v,h,S,P,p){return this.channel.call("write",[v,h,R.VSBuffer.wrap(S),P,p])}mkdir(v){return this.channel.call("mkdir",[v])}delete(v,h){return this.channel.call("delete",[v,h])}rename(v,h,S){return this.channel.call("rename",[v,h,S])}copy(v,h,S){return this.channel.call("copy",[v,h,S])}cloneFile(v,h){return this.channel.call("cloneFile",[v,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(v=>{if(Array.isArray(v)){const h=v;this._onDidChange.fire(h.map(S=>({resource:E.URI.revive(S.resource),type:S.type})))}else{const h=v;this._onDidWatchError.fire(h)}}))}watch(v,h){const S=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,S,v,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=y}),define(ne[96],re([0,1,16,9,153,13]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(C,y,m,v,h,S){let P;try{await I(C,y,m,v,h,S)}catch(p){P=p}finally{P&&h.errorTransformer&&(P=h.errorTransformer(P)),typeof P<"u"&&m.error(P),m.end()}}e.readFileIntoStream=T;async function I(C,y,m,v,h,S){E(S);const P=await C.open(y,{create:!1});try{E(S);let p=0,g=0,a=h&&typeof h.length=="number"?h.length:void 0,f=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,i=0;do g=await C.read(P,l,f.buffer,i,f.byteLength-i),l+=g,i+=g,p+=g,typeof a=="number"&&(a-=g),i===f.byteLength&&(await m.write(v(f)),f=R.VSBuffer.alloc(Math.min(h.bufferSize,typeof a=="number"?a:h.bufferSize)),i=0);while(g>0&&(typeof a!="number"||a>0)&&E(S)&&b(p,h));if(i>0){let s=i;typeof a=="number"&&(s=Math.min(i,a)),m.write(v(f.slice(0,s)))}}catch(p){throw(0,L.ensureFileSystemProviderError)(p)}finally{await C.close(P)}}function E(C){if(C.isCancellationRequested)throw(0,n.canceled)();return!0}function b(C,y){if(y?.limits){if(typeof y.limits.memory=="number"&&C>y.limits.memory)throw(0,L.createFileSystemProviderError)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof y.limits.size=="number"&&C>y.limits.size)throw(0,L.createFileSystemProviderError)((0,D.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,85,2,12,4,7,13]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function E(p){return p.recursive===!0}e.isRecursiveWatchRequest=E;class b extends n.Disposable{constructor(g,a,f,l){super(),this.onFileChanges=g,this.onLogMessage=a,this.verboseLogging=f,this.options=l,this.watcherDisposables=this._register(new n.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new n.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(a=>this.onFileChanges(a))),g.add(this.watcher.onDidLogMessage(a=>this.onLogMessage(a))),g.add(this.watcher.onDidError(a=>this.onError(a)))}onError(g){this.options.restartOnError?this.restartCounter<b.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=b,b.MAX_RESTARTS=5;class C extends b{constructor(g,a,f){super(g,a,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class y extends b{constructor(g,a,f){super(g,a,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=y;function m(p){return p.map(g=>({type:g.type,resource:T.URI.file(g.path)}))}e.toFileChanges=m;function v(p){const g=new P;for(const a of p)g.processEvent(a);return g.coalesce()}e.coalesceEvents=v;function h(p,g){return typeof g=="string"&&!g.startsWith(R.GLOBSTAR)&&!(0,D.isAbsolute)(g)?{base:p,pattern:g}:g}e.normalizeWatcherPattern=h;function S(p,g){const a=[];for(const f of g)a.push((0,R.parse)(h(p,f)));return a}e.parseWatcherPatterns=S;class P{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return L.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const a=this.mapPathToChange.get(this.toKey(g));let f=!1;if(a){const l=a.type,i=g.type;a.path!==g.path&&(g.type===2||g.type===1)?f=!0:l===1&&i===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(a)):l===2&&i===1?a.type=0:l===1&&i===0||(a.type=i)}else f=!0;f&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],a=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,l)=>f.path.length-l.path.length).filter(f=>a.some(l=>(0,I.isParent)(f.path,l,!L.isLinux))?!1:(a.push(f.path),!0)).concat(g)}}}),define(ne[182],re([0,1,53,6,22,46,2,83,12,4,133,28,57]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class v extends T.Disposable{constructor(P,p,g,a){super(),this.request=P,this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=a,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(v.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,m.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,m.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const P=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await y.Promises.stat(P);this._register(await this.doWatch(P,p.isDirectory()))}catch(P){P.code!=="ENOENT"?this.error(P):this.trace(P)}}async normalizePath(P){let p=P.path;try{p=await y.Promises.realpath(P.path),P.path===p&&(p=await(0,C.realcase)(P.path)??P.path),P.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${P.path}, real: ${p})`)}catch{}return p}async doWatch(P,p){if(b.isMacintosh&&(0,L.isEqualOrParent)(P,"/Volumes/",!0))return this.error(`Refusing to watch ${P} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const g=new D.CancellationTokenSource(this.cts.token),a=new T.DisposableStore;try{const f=(0,E.basename)(P),l=(0,R.watch)(P);a.add((0,T.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${P}'`);const i=new Set;if(p)try{for(const t of await y.Promises.readdir(P))i.add(t)}catch(t){this.error(t)}const s=new Map;a.add((0,T.toDisposable)(()=>{for(const[,t]of s)t.dispose();s.clear()})),l.on("error",(t,r)=>{this.error(`Failed to watch ${P} for changes using fs.watch() (${t}, ${r})`),this.dispose()}),l.on("change",(t,r)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${r}`);let o="";if(r&&(o=r.toString(),b.isMacintosh&&(o=(0,I.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(p)if(t==="rename"){s.get(o)?.dispose();const c=setTimeout(async()=>{if(s.delete(o),o===f&&!await y.Promises.exists(P)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,E.join)(P,o));if(g.token.isCancellationRequested)return;let d;u?i.has(o)?d=0:(d=1,i.add(o)):(i.delete(o),d=2),this.onFileChange({path:(0,E.join)(this.request.path,o),type:d})},v.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,T.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(o)?c=0:(c=1,i.add(o)),this.onFileChange({path:(0,E.join)(this.request.path,o),type:c})}else if(t==="rename"||o!==f){const c=setTimeout(async()=>{const u=await y.Promises.exists(P);g.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),a.add(await this.doWatch(P,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},v.FILE_DELETE_HANDLER_DELAY);a.clear(),a.add((0,T.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await y.Promises.exists(P)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${P} for changes using fs.watch() (${f.toString()})`)}return(0,T.toDisposable)(()=>{g.dispose(!0),a.dispose()})}async onFileChange(P,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),!p&&this.excludes.some(g=>g(P.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${P.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(P.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${P.path}`):this.fileChangesBuffer.push(P);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const a=(0,m.coalesceEvents)(g);if(a.length>0){if(this.verboseLogging)for(const l of a)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(a)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(P){if(b.isLinux)return y.Promises.exists(P);try{const p=(0,E.basename)(P);return(await y.Promises.readdir((0,E.dirname)(P))).some(a=>a===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(P){this.verboseLogging=P}error(P){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${P}`})}warn(P){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${P}`})}trace(P){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=v,v.FILE_DELETE_HANDLER_DELAY=100,v.FILE_CHANGES_HANDLER_DELAY=50;async function h(S,P,p,g,a=512){const f=await y.Promises.open(S,"r"),l=Buffer.allocUnsafe(a),i=new D.CancellationTokenSource(g);let s,t=!1;const r={path:S,excludes:[],recursive:!1},o=new v(r,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:d}=await y.Promises.read(f,l,0,a,null);if(!d||i.token.isCancellationRequested)break;P(l.slice(0,d))}}catch(d){s=new Error(d),i.dispose(!0)}finally{t=!1}}})()});return await o.ready,p(),new Promise((c,u)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await y.Promises.close(f)}catch(d){s=new Error(d)}s?u(s):c()})})}e.watchFileContents=h}),define(ne[183],re([0,1,3,85,2,4,182]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class I extends D.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(b){const C=this.normalizeRequests(b),y=C.filter(v=>{const h=this.watchers.get(v.path);return h?!(0,n.patternsEquals)(h.request.excludes,v.excludes)||!(0,n.patternsEquals)(h.request.includes,v.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:v})=>!C.find(h=>h.path===v.path&&(0,n.patternsEquals)(h.excludes,v.excludes)&&(0,n.patternsEquals)(h.includes,v.includes))).map(({request:v})=>v.path);y.length&&this.trace(`Request to start watching: ${y.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.stopWatching(v);for(const v of y)this.startWatching(v)}startWatching(b){const C=new T.NodeJSFileWatcherLibrary(b,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),y={request:b,instance:C};this.watchers.set(b.path,y)}async stop(){for(const[b]of this.watchers)this.stopWatching(b);this.watchers.clear()}stopWatching(b){const C=this.watchers.get(b);C&&(this.watchers.delete(b),C.instance.dispose())}normalizeRequests(b){const C=new Map;for(const y of b){const m=L.isLinux?y.path:y.path.toLowerCase();C.set(m,y)}return Array.from(C.values())}async setVerboseLogging(b){this.verboseLogging=b;for(const[,C]of this.watchers)C.instance.setVerboseLogging(b)}trace(b){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(b)})}toMessage(b,C){return C?`[File Watcher (node.js)] ${b} (path: ${C.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=I}),define(ne[184],re([0,1,57,183]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends R.AbstractNonRecursiveWatcherClient{constructor(T,I,E){super(T,I,E),this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(ne[185],re([0,1,20,39,66,57]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends L.AbstractUniversalWatcherClient{constructor(E,b,C){super(E,b,C),this.init()}createWatcher(E){const b=E.add(new D.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:C,signal:y})=>this.onError(`terminated by itself with code ${C}, signal: ${y}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[97],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...D){this._entries=new Map;for(const[L,T]of D)this.set(L,T)}set(D,L){const T=this._entries.get(D);return this._entries.set(D,L),T}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=R}),define(ne[186],re([0,1,6,9,56,176,5,97]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class b extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class C{constructor(h=new I.ServiceCollection,S=!1,P,p=E){this._services=h,this._strict=S,this._parent=P,this._enableTracing=p,this._activeInstantiations=new Set,this._services.set(T.IInstantiationService,this),this._globalGraph=p?P?._globalGraph??new L.Graph(g=>g):void 0}createChild(h){return new C(h,this._strict,this,this._enableTracing)}invokeFunction(h,...S){const P=m.traceInvocation(this._enableTracing,h);let p=!1;try{return h({get:a=>{if(p)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(a,P);if(!f)throw new Error(`[invokeFunction] unknown service '${a}'`);return f}},...S)}finally{p=!0,P.stop()}}createInstance(h,...S){let P,p;return h instanceof D.SyncDescriptor?(P=m.traceCreation(this._enableTracing,h.ctor),p=this._createInstance(h.ctor,h.staticArguments.concat(S),P)):(P=m.traceCreation(this._enableTracing,h),p=this._createInstance(h,S,P)),P.stop(),p}_createInstance(h,S=[],P){const p=T._util.getServiceDependencies(h).sort((f,l)=>f.index-l.index),g=[];for(const f of p){const l=this._getOrCreateServiceInstance(f.id,P);l||this._throwIfStrict(`[createInstance] ${h.name} depends on UNKNOWN service ${f.id}.`,!1),g.push(l)}const a=p.length>0?p[0].index:S.length;if(S.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${S.length} static arguments`);const f=a-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,a)}return new h(...S,...g)}_setServiceInstance(h,S){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,S);else if(this._parent)this._parent._setServiceInstance(h,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){const S=this._services.get(h);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):S}_getOrCreateServiceInstance(h,S){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(h));const P=this._getServiceInstanceOrDescriptor(h);return P instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,P,S.branch(h,!0)):(S.branch(h,!1),P)}_safeCreateAndCacheServiceInstance(h,S,P){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,S,P)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,S,P){const p=new L.Graph(f=>f.id.toString());let g=0;const a=[{id:h,desc:S,_trace:P}];for(;a.length;){const f=a.pop();if(p.lookupOrInsertNode(f),g++>1e3)throw new b(p);for(const l of T._util.getServiceDependencies(f.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(l.id);if(i||this._throwIfStrict(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(f.id),String(l.id)),i instanceof D.SyncDescriptor){const s={id:l.id,desc:i,_trace:f._trace.branch(l.id,!0)};p.insertEdge(f,s),a.push(s)}}}for(;;){const f=p.roots();if(f.length===0){if(!p.isEmpty())throw new b(p);break}for(const{data:l}of f){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}p.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,S,P=[],p,g){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(h,S,P,p,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,S,P,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(h,S,P=[],p,g){if(p){const a=new C(void 0,this._strict,this,this._enableTracing);a._globalGraphImplicitDependency=String(h);const f=new R.IdleValue(()=>a._createInstance(S,P,g));return new Proxy(Object.create(null),{get(l,i){if(i in l)return l[i];const s=f.value;let t=s[i];return typeof t!="function"||(t=t.bind(s),l[i]=t),t},set(l,i,s){return f.value[i]=s,!0}})}else return this._createInstance(S,P,g)}_throwIfStrict(h,S){if(S&&console.warn(h),this._strict)throw new Error(h)}}e.InstantiationService=C;var y;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(y||(y={}));class m{constructor(h,S){this.type=h,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(h,S){return h?new m(1,S.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(h,S){return h?new m(0,S.name):m._None}branch(h,S){const P=new m(2,h.toString());return this._dep.push([h,S,P]),P}stop(){const h=Date.now()-this._start;m._totals+=h;let S=!1;function P(g,a){const f=[],l=new Array(g+1).join("	");for(const[i,s,t]of a._dep)if(s&&t){S=!0,f.push(`${l}CREATES -> ${i}`);const r=P(g+1,t);r&&f.push(r)}else f.push(`${l}uses -> ${i}`);return f.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(h>2||S)&&m.all.add(p.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(ne[187],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(D,L){this.server=D,this.router=L}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,L){this.server.registerChannel(D,L)}}e.MessagePortMainProcessService=R}),define(ne[58],re([0,1,39,56,91,5]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(v,h,S){const P=S.getChannel(v);return I(h)?new h.channelClientCtor(P):R.ProxyChannel.toService(P,h?.proxyOptions)}}function I(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let E=class extends T{constructor(v,h,S){super(v,h,S)}};E=pe([G(2,e.IMainProcessService)],E);function b(m,v,h){(0,D.registerSingleton)(m,new n.SyncDescriptor(E,[v,h],!0))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let C=class extends T{constructor(v,h,S){super(v,h,S)}};C=pe([G(2,e.ISharedProcessService)],C);function y(m,v,h){(0,D.registerSingleton)(m,new n.SyncDescriptor(C,[v,h],!0))}e.registerSharedProcessRemoteService=y}),define(ne[69],re([0,1,22,2,4,155,29,5]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,I.createDecorator)("languagePackService");let E=class extends n.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new R.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let y;try{y=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const v=y.firstPage.filter(h=>h.properties.localizedLanguages?.length&&h.tags.some(S=>S.startsWith("lp-"))).map(h=>{const S=h.properties.localizedLanguages?.[0],P=this.getLocale(h);return{...this.createQuickPickItem(P,S,h),extensionId:h.identifier.id,galleryExtension:h}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(C){return C.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(C,y,m){const v=y??C;let h;if(v!==C&&(h=`(${C})`),C.toLowerCase()===D.language.toLowerCase()&&(h??="",h+=(0,L.localize)(0,null)),m?.installCount){h??="";const S=m.installCount;let P;S>1e6?P=`${Math.floor(S/1e5)/10}M`:S>1e3?P=`${Math.floor(S/1e3)}K`:P=String(S),h+=` $(cloud-download) ${P}`}return{id:C,label:v,description:h}}};E=pe([G(0,T.IExtensionGalleryService)],E),e.LanguagePackBaseService=E}),define(ne[188],re([0,1,2,69]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends R.Disposable{constructor(T){super(),this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=pe([G(0,n.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(ne[8],re([0,1,38,3,2,4,5]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function I(){return new Date().toISOString()}var E;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function b(s,t,r){switch(t){case E.Trace:s.trace(r);break;case E.Debug:s.debug(r);break;case E.Info:s.info(r);break;case E.Warning:s.warn(r);break;case E.Error:s.error(r);break;case E.Critical:s.critical(r);break;default:throw new Error("Invalid log level")}}e.log=b;function C(s){let t="";for(let r=0;r<s.length;r++){let o=s[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(r>0?" ":"")+o}return t}e.format=C;class y extends D.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class m extends y{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(E.Trace)&&this.log(E.Trace,C([t,...r]))}debug(t,...r){this.checkLogLevel(E.Debug)&&this.log(E.Debug,C([t,...r]))}info(t,...r){this.checkLogLevel(E.Info)&&this.log(E.Info,C([t,...r]))}warn(t,...r){this.checkLogLevel(E.Warning)&&this.log(E.Warning,C([t,...r]))}error(t,...r){if(this.checkLogLevel(E.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(E.Error,C(o))}else this.log(E.Error,C([t,...r]))}critical(t,...r){this.checkLogLevel(E.Critical)&&this.log(E.Critical,C([t,...r]))}flush(){}}e.AbstractMessageLogger=m;class v extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}debug(t,...r){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}info(t,...r){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.log(`[main ${I()}]`,t,...r))}warn(t,...r){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,t,...r):console.warn(`[main ${I()}]`,t,...r))}error(t,...r){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,t,...r):console.error(`[main ${I()}]`,t,...r))}critical(t,...r){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${I()}]\x1B[0m`,t,...r):console.error(`[main ${I()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...r){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=h;class S extends y{constructor(t,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class P extends y{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=P;class p extends D.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=p;class g extends D.Disposable{constructor(t,r){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?E.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class a{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=a;function f(s){if(s.verbose)return E.Trace;if(typeof s.logLevel=="string"){const t=l(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function l(s){switch(s){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=l;function i(s){switch(s){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=i}),define(ne[189],re([0,1,6,9,2,12,28,15,8]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(y,m){super(),this.environmentService=y,this.logService=m,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,L.basename)(this.environmentService.logsPath),m=(0,L.dirname)(this.environmentService.logsPath),S=(await T.Promises.readdir(m)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==y),P=S.slice(0,Math.max(0,S.length-9));P.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${P.join(", ")}'`),await Promise.all(P.map(p=>T.Promises.rm((0,L.join)(m,p)))))}catch(y){(0,n.onUnexpectedError)(y)}}};b=pe([G(0,I.IEnvironmentService),G(1,E.ILogService)],b),e.LogsDataCleaner=b}),define(ne[190],re([0,1,18,6,9,3,2,12,57,8]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends T.Disposable{constructor(m,v){super(),this.logService=m,this.options=v,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(m,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,v):this.watchNonRecursive(m,v)}watchUniversal(m,v){const h={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive},S=(0,R.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,E.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.universalPathsToWatch)(0,E.isRecursiveWatchRequest)(v)&&m.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,v){const h={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:!1},S=(0,R.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,E.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(ne[191],re([0,1,18,6,16,22,3,64,51,2,34,20,192,17,41,151,13,96,8]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends b.Disposable{constructor(l){super(),this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,i){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${l}`);const s=new b.DisposableStore;return this.provider.set(l,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:i}),s.add(i.onDidChangeFile(t=>this._onDidFilesChange.fire(new P.FileChangesEvent(t,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&s.add(i.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),s.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:l}))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:i}),this.provider.delete(l),(0,b.dispose)(s)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(s){i.push(s)}}),!this.provider.has(l)&&await n.Promises.settled(i)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,i){const s=this.provider.get(l.scheme);return!!(s&&s.capabilities&i)}listCapabilities(){return E.Iterable.map(this.provider,([l,i])=>({scheme:l,capabilities:i.capabilities}))}async withProvider(l){if(!(0,v.isAbsolutePath)(l))throw new P.FileOperationError((0,S.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const i=this.provider.get(l.scheme);if(!i){const s=new Error;throw s.name="ENOPRO",s.message=(0,S.localize)(1,null,l.toString()),s}return i}async withReadProvider(l){const i=await this.withProvider(l);if((0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i)||(0,P.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const i=await this.withProvider(l);if((0,P.hasOpenReadWriteCloseCapability)(i)||(0,P.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,i){try{return await this.doResolveFile(l,i)}catch(s){throw(0,P.toFileSystemProviderErrorCode)(s)===P.FileSystemProviderErrorCode.FileNotFound?new P.FileOperationError((0,S.localize)(2,null,this.resourceForError(l)),1):(0,P.ensureFileSystemProviderError)(s)}}async doResolveFile(l,i){const s=await this.withProvider(l),t=this.isPathCaseSensitive(s),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,c=i?.resolveMetadata,u=await s.stat(l);let d;return this.toFileStat(s,l,u,void 0,!!c,(w,A)=>(d||(d=C.TernarySearchTree.forUris(()=>!t),d.set(l,!0),r&&d.fill(!0,r)),d.get(w.resource)||d.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&o?A===1:!1))}async toFileStat(l,i,s,t,r,o){const{providerExtUri:c}=this.getExtUri(l),u={resource:i,name:c.basename(i),isFile:(s.type&P.FileType.File)!==0,isDirectory:(s.type&P.FileType.Directory)!==0,isSymbolicLink:(s.type&P.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&P.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,P.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(u.isDirectory&&o(u,t)){try{const d=await l.readdir(i),w=await n.Promises.settled(d.map(async([A,O])=>{try{const _=c.joinPath(i,A),M=r?await l.stat(_):{type:O};return await this.toFileStat(l,_,M,d.length,r,o)}catch(_){return this.logService.trace(_),null}}));u.children=(0,R.coalesce)(w)}catch(d){this.logService.trace(d),u.children=[]}return u}return u}async resolveAll(l){return n.Promises.settled(l.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(l){const i=await this.withProvider(l),s=await i.stat(l);return this.toFileStat(i,l,s,void 0,!0,()=>!1)}async exists(l){const i=await this.withProvider(l);try{return!!await i.stat(l)}catch{return!1}}async canCreateFile(l,i){try{await this.doValidateCreateFile(l,i)}catch(s){return s}return!0}async doValidateCreateFile(l,i){if(!i?.overwrite&&await this.exists(l))throw new P.FileOperationError((0,S.localize)(3,null,this.resourceForError(l)),3,i)}async createFile(l,i=D.VSBuffer.fromString(""),s){await this.doValidateCreateFile(l,s);const t=await this.writeFile(l,i);return this._onDidRunOperation.fire(new P.FileOperationEvent(l,0,t)),t}async writeFile(l,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,l,s)||await this.mkdirp(t,r.dirname(l));let c;if((0,P.hasReadWriteCapability)(t)&&!(i instanceof D.VSBuffer))if((0,h.isReadableStream)(i)){const u=await(0,h.peekStream)(i,3);u.ended?c=D.VSBuffer.concat(u.buffer):c=u}else c=(0,h.peekReadable)(i,u=>D.VSBuffer.concat(u),3);else c=i;!(0,P.hasOpenReadWriteCloseCapability)(t)||(0,P.hasReadWriteCapability)(t)&&c instanceof D.VSBuffer?await this.doWriteUnbuffered(t,l,s,c):await this.doWriteBuffered(t,l,s,c instanceof D.VSBuffer?(0,D.bufferToReadable)(c):c),this._onDidRunOperation.fire(new P.FileOperationEvent(l,4))}catch(o){throw new P.FileOperationError((0,S.localize)(4,null,this.resourceForError(l),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),s)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,i,s){if(!!s?.unlock&&!(l.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(i)));let r;try{r=await l.stat(i)}catch{return}if((r.type&P.FileType.Directory)!==0)throw new P.FileOperationError((0,S.localize)(6,null,this.resourceForError(i)),0,s);if(this.throwIfFileIsReadonly(i,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==P.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,P.etag)({mtime:s.mtime,size:r.size}))throw new P.FileOperationError((0,S.localize)(7,null),3,s);return r}async readFile(l,i,s){const t=await this.withReadProvider(l);return i?.atomic?this.doReadFileAtomic(t,l,i,s):this.doReadFile(t,l,i,s)}async doReadFileAtomic(l,i,s,t){return new Promise((r,o)=>{this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(l,i,s,t);r(c)}catch(c){o(c)}})})}async doReadFile(l,i,s,t){const r=await this.doReadFileStream(l,i,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,D.streamToBuffer)(r.value)}}async readFileStream(l,i,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,i,s)}async doReadFileStream(l,i,s,t){const r=new L.CancellationTokenSource(t),o=this.validateReadFile(i,s).then(u=>u,u=>{throw r.cancel(),u});let c;try{return typeof s?.etag=="string"&&s.etag!==P.ETAG_DISABLED&&await o,s?.atomic&&(0,P.hasFileAtomicReadCapability)(l)||!((0,P.hasOpenReadWriteCloseCapability)(l)||(0,P.hasFileReadStreamCapability)(l))||(0,P.hasReadWriteCapability)(l)&&s?.preferUnbuffered?c=this.readFileUnbuffered(l,i,s):(0,P.hasFileReadStreamCapability)(l)?c=this.readFileStreamed(l,i,r.token,s):c=this.readFileBuffered(l,i,r.token,s),{...await o,value:c}}catch(u){c&&await(0,h.consumeStream)(c);const d=(0,S.localize)(8,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(u).toString());throw u instanceof P.NotModifiedSinceFileOperationError?new P.NotModifiedSinceFileOperationError(d,u.stat,s):new P.FileOperationError(d,(0,P.toFileOperationResult)(u),s)}}readFileStreamed(l,i,s,t=Object.create(null)){const r=l.readFileStream(i,t,s);return(0,h.transform)(r,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new P.FileOperationError((0,S.localize)(9,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),t)},o=>D.VSBuffer.concat(o))}readFileBuffered(l,i,s,t=Object.create(null)){const r=(0,D.newWriteableBufferStream)();return(0,p.readFileIntoStream)(l,i,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new P.FileOperationError((0,S.localize)(10,null,this.resourceForError(i),(0,P.ensureFileSystemProviderError)(o).toString()),(0,P.toFileOperationResult)(o),t)},s),r}readFileUnbuffered(l,i,s){const t=(0,h.newWriteableStream)(r=>D.VSBuffer.concat(r));return(async()=>{try{let r;s?.atomic&&(0,P.hasFileAtomicReadCapability)(l)?r=await l.readFile(i,{atomic:!0}):r=await l.readFile(i),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(i,r.byteLength,s),t.end(D.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(l,i){const s=await this.resolve(l,{resolveMetadata:!0});if(s.isDirectory)throw new P.FileOperationError((0,S.localize)(11,null,this.resourceForError(l)),0,i);if(typeof i?.etag=="string"&&i.etag!==P.ETAG_DISABLED&&i.etag===s.etag)throw new P.NotModifiedSinceFileOperationError((0,S.localize)(12,null),s,i);return this.validateReadFileLimits(l,s.size,i),s}validateReadFileLimits(l,i,s){if(s?.limits){let t;if(typeof s.limits.memory=="number"&&i>s.limits.memory&&(t=9),typeof s.limits.size=="number"&&i>s.limits.size&&(t=7),typeof t=="number")throw new P.FileOperationError((0,S.localize)(13,null,this.resourceForError(l)),t)}}async canMove(l,i,s){return this.doCanMoveCopy(l,i,"move",s)}async canCopy(l,i,s){return this.doCanMoveCopy(l,i,"copy",s)}async doCanMoveCopy(l,i,s,t){if(l.toString()!==i.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,l,o,i,s,t)}catch(r){return r}return!0}async move(l,i,s){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,l,r,i,"move",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(l,o==="move"?2:3,c)),c}async copy(l,i,s){const t=await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(t,l,r,i,"copy",!!s),c=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(l,o==="copy"?3:2,c)),c}async doMoveCopy(l,i,s,t,r,o){if(i.toString()===t.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(l,i,s,t,r,o);if(c&&!u&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(t)),r==="copy"){if(l===s&&(0,P.hasFileFolderCopyCapability)(l))await l.copy(i,t,{overwrite:o});else{const d=await this.resolve(i);d.isDirectory?await this.doCopyFolder(l,d,s,t):await this.doCopyFile(l,i,s,t)}return r}else return l===s?(await l.rename(i,t,{overwrite:o}),r):(await this.doMoveCopy(l,i,s,t,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(l,i,s,t){if((0,P.hasOpenReadWriteCloseCapability)(l)&&(0,P.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(l,i,s,t);if((0,P.hasOpenReadWriteCloseCapability)(l)&&(0,P.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(l,i,s,t);if((0,P.hasReadWriteCapability)(l)&&(0,P.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(l,i,s,t);if((0,P.hasReadWriteCapability)(l)&&(0,P.hasReadWriteCapability)(s))return this.doPipeUnbuffered(l,i,s,t)}async doCopyFolder(l,i,s,t){await s.mkdir(t),Array.isArray(i.children)&&await n.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(l,await this.resolve(r.resource),s,o):this.doCopyFile(l,r.resource,s,o)}))}async doValidateMoveCopy(l,i,s,t,r,o){let c=!1;if(l===s){const{providerExtUri:d,isPathCaseSensitive:w}=this.getExtUri(l);if(w||(c=d.isEqual(i,t)),c&&r==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(i),this.resourceForError(t)));if(!c&&d.isEqualOrParent(t,i))throw new Error((0,S.localize)(15,null,this.resourceForError(i),this.resourceForError(t)))}const u=await this.exists(t);if(u&&!c){if(!o)throw new P.FileOperationError((0,S.localize)(16,null,this.resourceForError(i),this.resourceForError(t)),4);if(l===s){const{providerExtUri:d}=this.getExtUri(l);if(d.isEqualOrParent(i,t))throw new Error((0,S.localize)(17,null,this.resourceForError(i),this.resourceForError(t)))}}return{exists:u,isSameResourceWithDifferentPathCase:c}}getExtUri(l){const i=this.isPathCaseSensitive(l);return{providerExtUri:i?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(i,l);const s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new P.FileOperationEvent(l,0,s)),s}async mkdirp(l,i){const s=[],{providerExtUri:t}=this.getExtUri(l);for(;!t.isEqual(i,t.dirname(i));)try{if(((await l.stat(i)).type&P.FileType.Directory)===0)throw new Error((0,S.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,P.toFileSystemProviderErrorCode)(r)!==P.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(i)),i=t.dirname(i)}for(let r=s.length-1;r>=0;r--){i=t.joinPath(i,s[r]);try{await l.mkdir(i)}catch(o){if((0,P.toFileSystemProviderErrorCode)(o)!==P.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,i){try{await this.doValidateDelete(l,i)}catch(s){return s}return!0}async doValidateDelete(l,i){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!i?.useTrash&&!(s.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(l)));let r;try{r=await s.stat(l)}catch{}if(r)this.throwIfFileIsReadonly(l,r);else throw new P.FileOperationError((0,S.localize)(20,null,this.resourceForError(l)),1);if(!!!i?.recursive){const c=await this.resolve(l);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(l)))}return s}async del(l,i){const s=await this.doValidateDelete(l,i),t=!!i?.useTrash,r=!!i?.recursive;await s.delete(l,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new P.FileOperationEvent(l,1))}async cloneFile(l,i){const s=await this.withProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(s===t&&this.getExtUri(s).providerExtUri.isEqual(l,i))return;if(s===t&&(0,P.hasFileCloneCapability)(s))return s.cloneFile(l,i);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri);return s===t&&(0,P.hasFileFolderCopyCapability)(s)?r.queue(()=>s.copy(l,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(s,l,t,i))}watch(l,i={recursive:!1,excludes:[]}){const s=new b.DisposableStore;let t=!1,r=()=>{t=!0};return s.add((0,b.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(l,i);t?(0,b.dispose)(o):r=()=>(0,b.dispose)(o)}catch(o){this.logService.error(o)}})(),s}async doWatch(l,i){const s=await this.withProvider(l),t=(0,I.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(l),i]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:s.watch(l,i)},this.activeWatchers.set(t,r)),r.count+=1,(0,b.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,b.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,b.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(async()=>{const r=await l.open(i,{create:!0,unlock:s?.unlock??!1});try{(0,h.isReadableStream)(t)||(0,h.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(l,r,t):await this.doWriteReadableBufferedQueued(l,r,t)}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await l.close(r)}})}async doWriteStreamBufferedQueued(l,i,s){let t=0,r;if((0,h.isReadableBufferedStream)(s)){if(s.buffer.length>0){const o=D.VSBuffer.concat(s.buffer);await this.doWriteBuffer(l,i,o,o.byteLength,t,0),t+=o.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((o,c)=>{(0,h.listenStream)(r,{onData:async u=>{r.pause();try{await this.doWriteBuffer(l,i,u,u.byteLength,t,0)}catch(d){return c(d)}t+=u.byteLength,setTimeout(()=>r.resume())},onError:u=>c(u),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,i,s){let t=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(l,i,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(l,i,s,t,r,o){let c=0;for(;c<t;)c+=await l.write(i,r+c,s.buffer,o+c,t-c)}async doWriteUnbuffered(l,i,s,t){return this.writeQueue.queueFor(i,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,i,s,t))}async doWriteUnbufferedQueued(l,i,s,t){let r;t instanceof D.VSBuffer?r=t:(0,h.isReadableStream)(t)?r=await(0,D.streamToBuffer)(t):(0,h.isReadableBufferedStream)(t)?r=await(0,D.bufferedStreamToBuffer)(t):r=(0,D.readableToBuffer)(t),await l.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,i,s,t))}async doPipeBufferedQueued(l,i,s,t){let r,o;try{r=await l.open(i,{create:!1}),o=await s.open(t,{create:!0,unlock:!1});const c=D.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,d=0,w=0;do w=await l.read(r,u,c.buffer,d,c.byteLength-d),await this.doWriteBuffer(s,o,c,w,u,d),u+=w,d+=w,d===c.byteLength&&(d=0);while(w>0)}catch(c){throw(0,P.ensureFileSystemProviderError)(c)}finally{await n.Promises.settled([typeof r=="number"?l.close(r):Promise.resolve(),typeof o=="number"?s.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,i,s,t))}async doPipeUnbufferedQueued(l,i,s,t){return s.writeFile(t,await l.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,i,s,t){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,i,s,t))}async doPipeUnbufferedToBufferedQueued(l,i,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const o=await l.readFile(i);await this.doWriteBuffer(s,r,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,P.ensureFileSystemProviderError)(o)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(l,i,s,t){const r=await(0,D.streamToBuffer)(this.readFileBuffered(l,i,L.CancellationToken.None));await this.doWriteUnbuffered(s,t,void 0,r)}throwIfFileSystemIsReadonly(l,i){if(l.capabilities&2048)throw new P.FileOperationError((0,S.localize)(22,null,this.resourceForError(i)),6);return l}throwIfFileIsReadonly(l,i){if((i.permissions??0)&P.FilePermission.Readonly)throw new P.FileOperationError((0,S.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===y.Schemas.file?l.fsPath:l.toString(!0)}};a=pe([G(0,g.ILogService)],a),e.FileService=a}),define(ne[193],re([0,1,53,276,6,34,16,3,46,2,12,4,17,41,28,154,13,96,190,38,185,184]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(R)}catch(s){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(s)}`)}})();class i extends g.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new L.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,y.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await h.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await h.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let u;c.isSymbolicLink()?u=(await this.stat((0,m.joinPath)(t,c.name))).type:u=this.toType(c),o.push([c.name,u])}catch(u){this.logService.trace(u)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=P.FileType.Unknown:t.isFile()?o=P.FileType.File:t.isDirectory()?o=P.FileType.Directory:o=P.FileType.Unknown,r&&(o|=P.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new D.Barrier;return this.resourceLocks.set(t,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const c=this.toFilePath(t);return await h.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}readFileStream(t,r,o){const c=(0,v.newWriteableStream)(u=>T.VSBuffer.concat(u.map(d=>T.VSBuffer.wrap(d))).buffer);return(0,p.readFileIntoStream)(this,t,c,u=>u.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(t,r,o){let c;try{const u=this.toFilePath(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(u)){if(!o.overwrite)throw(0,P.createFileSystemProviderError)((0,S.localize)(0,null),P.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,P.createFileSystemProviderError)((0,S.localize)(1,null),P.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(t,u)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){i.canFlush=t}async open(t,r){const o=this.toFilePath(t);let c;(0,P.isFileOpenForWriteOptions)(r)&&(c=await this.createResourceLock(t));let u;try{if((0,P.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:w}=await h.SymlinkSupport.stat(o);w.mode&128||await h.Promises.chmod(o,w.mode|128)}catch(w){this.logService.trace(w)}let d;if((0,P.isFileOpenForWriteOptions)(r)){if(y.isWindows)try{await h.Promises.truncate(o,0),d="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}d||(d="w")}else d="r";u=await h.Promises.open(o,d)}catch(d){throw c?.dispose(),(0,P.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(u,0),(0,P.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(u,t),c){const d=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${o})`),this.mapHandleToLock.set(u,c),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${o})`),d.dispose())}return u}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&i.canFlush)try{await h.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await h.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,c,u){const d=this.normalizePos(t,r);let w=null;try{w=(await h.Promises.read(t,o,c,u,d)).bytesRead}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(t,d,w)}return w}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const c=this.mapHandleToPos.get(t);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,c+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,c,u){return(0,D.retry)(()=>this.doWrite(t,r,o,c,u),100,3)}async doWrite(t,r,o,c,u){const d=this.normalizePos(t,r);let w=null;try{w=(await h.Promises.write(t,o,c,u,d)).bytesWritten}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),A)}finally{this.updatePos(t,d,w)}return w}async mkdir(t){try{await h.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const c=this.toFilePath(t),u=this.toFilePath(r);if(c!==u)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await h.Promises.move(c,u)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(2,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(t,r,o){const c=this.toFilePath(t),u=this.toFilePath(r);if(c!==u)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await h.Promises.copy(c,u,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,S.localize)(3,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(t,r,o,c){const u=this.toFilePath(t),d=this.toFilePath(r);let w=!1;if(!!(this.capabilities&1024)||(w=(0,E.isEqual)(u,d,!0)),w&&o==="copy")throw(0,P.createFileSystemProviderError)((0,S.localize)(4,null),P.FileSystemProviderErrorCode.FileExists);if(!w&&await h.Promises.exists(d)){if(!c)throw(0,P.createFileSystemProviderError)((0,S.localize)(5,null),P.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const c=this.toFilePath(t),u=this.toFilePath(r),d=!!(this.capabilities&1024);if((0,E.isEqual)(c,u,!d))return;const w=new b.DisposableStore;try{const[A,O]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);w.add(A),w.add(O),o&&await h.Promises.mkdir((0,C.dirname)(u),{recursive:!0}),await h.Promises.copyFile(c,u)}catch(A){if(A.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(A)}finally{w.dispose()}}createUniversalWatcher(t,r,o){return new f.UniversalWatcherClient(c=>t(c),c=>r(c),o)}createNonRecursiveWatcher(t,r,o){return new l.NodeJSWatcherClient(c=>t(c),c=>r(c),o)}toFileSystemProviderError(t){if(t instanceof P.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=P.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=P.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=P.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=P.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=P.FileSystemProviderErrorCode.NoPermissions;break;default:r=P.FileSystemProviderErrorCode.Unknown}return(0,P.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===P.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.toFilePath(t));c.mode&128||(o=(0,P.createFileSystemProviderError)(r,P.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}e.DiskFileSystemProvider=i,i.canFlush=!0}),define(ne[98],re([0,1,3,7,8]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(m){this.service=m,this.onDidChangeLogLevel=R.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,v){switch(v){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${v}`)}}e.LogLevelChannel=L;class T{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){T.setLevel(this.channel,m)}static setLevel(m,v){return m.call("setLevel",v)}}e.LogLevelChannelClient=T;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,v){throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"createLogger":this.createLogger(n.URI.revive(h[0]),h[1]);return;case"log":return this.log(n.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${v}`)}createLogger(m,v){this.loggers.set(m.toString(),this.loggerService.createLogger(m,v))}consoleLog(m,v){let h=console.log;switch(m){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...v)}log(m,v){const h=this.loggers.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[S,P]of v)(0,D.log)(h,S,P)}}e.LoggerChannel=I;class E extends D.AbstractLoggerService{constructor(m,v,h){super(m,v),this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(m,v)=>{this.channel.call("consoleLog",[m,v])}})}doCreateLogger(m,v,h){return new b(this.channel,m,v,h)}}e.LoggerChannelClient=E;class b extends D.AbstractMessageLogger{constructor(m,v,h,S){super(S?.always),this.channel=m,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[v,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,v){const h=[[m,v]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(m){this.channel.call("log",[this.file,m])}}class C extends D.LogService{constructor(m,v){super(v),this.parent=m,this._register(m.onDidChangeLogLevel(h=>v.setLevel(h)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=C}),define(ne[59],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(ne[60],re([0,1,3,51,2,5]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class T extends D.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(b){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...b,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(b),n.Iterable.reduce(this.policies.entries(),(y,[m,v])=>({...y,[m]:v}),{})}getPolicyValue(b){return this.policies.get(b)}serialize(){return n.Iterable.reduce(Object.entries(this.policyDefinitions),(b,[C,y])=>({...b,[C]:{definition:y,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=T;class I{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=I}),define(ne[194],re([0,1,3,2,60]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(E){this.service=E,this.disposables=new n.DisposableStore}listen(E,b){switch(b){case"onDidChange":return R.Event.map(this.service.onDidChange,C=>C.reduce((y,m)=>({...y,[m]:this.service.getPolicyValue(m)??null}),{}),this.disposables)}throw new Error(`Event not found: ${b}`)}call(E,b,C){switch(b){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${b}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class T extends D.AbstractPolicyService{constructor(E,b){super(),this.channel=b;for(const C in E){const{definition:y,value:m}=E[C];this.policyDefinitions[C]=y,m!==void 0&&this.policies.set(C,m)}this.channel.listen("onDidChange")(C=>{for(const y in C){const m=C[y];m===null?this.policies.delete(y):this.policies.set(y,m)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(E){const b=await this.channel.call("registerPolicyDefinitions",E);for(const C in b)this.policies.set(C,b[C])}}e.PolicyChannelClient=T}),define(ne[99],re([0,1,20,4,36,17]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof n.globals.vscode<"u"&&typeof n.globals.vscode.context<"u"){const I=n.globals.vscode.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const I=(0,L.dirname)(R.FileAccess.asFileUri("",Q));T=Q.__$__nodeRequire((0,L.joinPath)(I,"product.json").fsPath);const E=Q.__$__nodeRequire((0,L.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),Object.assign(T,{version:E.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ne[26],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[195],re([0,1,6,9,2,12,28,8,26]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(y,m,v){super(),this.productService=m,this.logService=v,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(y)},3e4)).schedule()}async cleanUpCodeCaches(y){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),v=(0,L.dirname)(y),h=(0,L.basename)(y),S=await T.Promises.readdir(v);await Promise.all(S.map(async P=>{if(P===h)return;const p=(0,L.join)(v,P),g=await T.Promises.stat(p);if(g.isDirectory()&&m-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${P}.`),T.Promises.rm(p)}))}catch(m){(0,n.onUnexpectedError)(m)}}};b=pe([G(1,E.IProductService),G(2,I.ILogService)],b),e.CodeCacheCleaner=b}),define(ne[196],re([0,1,6,9,2,12,28,15,8,26]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends D.Disposable{constructor(m,v,h){super(),this.environmentService=m,this.logService=v,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),v=JSON.parse(await T.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(v)){const a=v[g];m[`${a.hash}.${g}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const P=await T.Promises.readdir(h);for(const g of P){if(m[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await T.Promises.rm((0,L.join)(h,g))}const p=Date.now();for(const g of Object.keys(m)){const a=(0,L.join)(h,g),f=await T.Promises.readdir(a);for(const l of f){if(l==="tcf.json")continue;const i=(0,L.join)(a,l),s=await T.Promises.stat(i);s.isDirectory()&&p-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(g,l)}`),await T.Promises.rm(i))}}}catch(m){(0,n.onUnexpectedError)(m)}}};C=pe([G(0,I.INativeEnvironmentService),G(1,E.ILogService),G(2,b.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(ne[197],re([0,1,12,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var D;(function(L){function T(I,E="noAbsolutePaths"){for(const b of I.nodes)b.callFrame&&b.callFrame.url&&((0,R.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(b.callFrame.url))&&(b.callFrame.url=(0,R.join)(E,(0,R.basename)(b.callFrame.url)));return I}L.rewriteAbsolutePaths=T})(D=e.Utils||(e.Utils={}))}),define(ne[198],re([0,1,30]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(L){const I=await(await new Promise((b,C)=>{Q(["v8-inspect-profiler"],b,C)})).startProfiling({port:L.port,checkForPaused:!0}),E=(0,R.generateUuid)();return this._sessions.set(E,I),E}async stopProfiling(L){const T=this._sessions.get(L);if(!T)throw new Error(`UNKNOWN session '${L}'`);const I=await T.stop();return this._sessions.delete(L),I.profile}}e.InspectProfilingService=n}),define(ne[40],re([0,1,114,14]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(T,I){R.ok(n.isString(T)),R.ok(n.isObject(I)),R.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,I)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new D}),define(ne[100],re([0,1,3,40]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class L{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,b){this.schemasById[D(E)]=b,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new L;n.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[42],re([0,1,18,3,14,140,19,100,40]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=E.Registry.as(I.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const t=this.doRegisterConfigurations(i,s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(i){const s=this.doDeregisterConfigurations(i);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:i,remove:s}){const t=[];t.push(...this.doDeregisterConfigurations(s)),t.push(...this.doRegisterConfigurations(i,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(i){const s=[],t=[];for(const{overrides:r,source:o}of i)for(const c in r)if(s.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const u=this.configurationDefaultsOverrides.get(c),d=u?.valuesSources??new Map;if(o)for(const _ of Object.keys(r[c]))d.set(_,o);const w={...u?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:w,valuesSources:d});const A=(0,T.getLanguageTagSettingPlainKey)(c),O={type:"object",default:w,description:L.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(c)),this.configurationProperties[c]=O,this.defaultLanguageConfigurationOverridesNode.properties[c]=O}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:o});const u=this.configurationProperties[c];u&&(this.updatePropertyDefaultValue(c,u),this.updateSchema(c,u))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const s=[];for(const{overrides:t,source:r}of i)for(const o in t){const c=this.configurationDefaultsOverrides.get(o),u=D.isString(r)?r:r?.id,d=D.isString(c?.source)?c?.source:c?.source?.id;if(u===d)if(s.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const w=this.configurationProperties[o];w&&(this.updatePropertyDefaultValue(o,w),this.updateSchema(o,w))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const s of i)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,s){const t=[];return i.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,s,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(i){const s=[],t=r=>{if(r.properties)for(const o in r.properties){s.push(o);const c=this.configurationProperties[o];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of i){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return s}validateAndRegisterProperties(i,s=!0,t,r,o=3){o=D.isUndefinedOrNull(i.scope)?o:i.scope;const c=[],u=i.properties;if(u)for(const w in u){const A=u[w];if(s&&a(w,A)){delete u[w];continue}if(A.source=t,A.defaultDefaultValue=u[w].default,this.updatePropertyDefaultValue(w,A),e.OVERRIDE_PROPERTY_REGEX.test(w)?A.scope=void 0:(A.scope=D.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=D.isUndefinedOrNull(A.restricted)?!!r?.includes(w):A.restricted),u[w].hasOwnProperty("included")&&!u[w].included){this.excludedConfigurationProperties[w]=u[w],delete u[w];continue}else this.configurationProperties[w]=u[w],u[w].policy?.name&&this.policyConfigurations.set(u[w].policy.name,w);!u[w].deprecationMessage&&u[w].markdownDeprecationMessage&&(u[w].deprecationMessage=u[w].markdownDeprecationMessage),c.push(w)}const d=i.allOf;if(d)for(const w of d)c.push(...this.validateAndRegisterProperties(w,s,t,r,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const s=t=>{const r=t.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);t.allOf?.forEach(s)};s(i)}updateSchema(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.resourceLanguageSettingsSchema.properties[i]=s;break}}removeFromSchema(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const s=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,t),e.allSettings.properties[s]=t,e.applicationSettings.properties[s]=t,e.machineSettings.properties[s]=t,e.machineOverridableSettings.properties[s]=t,e.windowSettings.properties[s]=t,e.resourceSettings.properties[s]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,s){const t=this.configurationDefaultsOverrides.get(i);let r=t?.value,o=t?.source;D.isUndefined(r)&&(r=s.defaultDefaultValue,o=void 0),D.isUndefined(r)&&(r=p(s.type)),s.default=r,s.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",h=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(l){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let s=h.exec(l);for(;s?.length;){const t=s[1].trim();t&&i.push(t),s=h.exec(l)}}return(0,R.distinct)(i)}e.overrideIdentifiersFromKey=S;function P(l){return l.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=P;function p(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const g=new m;E.Registry.add(e.Extensions.Configuration,g);function a(l,i){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):g.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,l,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=a;function f(){const l=[],i=g.getConfigurationProperties();for(const s of Object.keys(i))l.push([s,i[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=f}),define(ne[70],re([0,1,18,3,35,2,34,31,14,7,19,42,40]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(i={},s=[],t=[]){this._contents=i,this._keys=s,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,C.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const t=this.getContentsForOverrideIdentifer(s);return t?i?(0,C.getConfigurationValue)(t,i):t:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const t of this.overrides)t.identifiers.includes(i)&&s.push(...t.keys);return R.distinct(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return R.distinct(i)}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=I.deepClone(this.contents),t=I.deepClone(this.overrides),r=[...this.keys];for(const o of i)if(!o.isEmpty()){this.mergeContents(s,o.contents);for(const c of o.overrides){const[u]=t.filter(d=>R.equals(d.identifiers,c.identifiers));u?(this.mergeContents(u.contents,c.contents),u.keys.push(...c.keys),u.keys=R.distinct(u.keys)):t.push(I.deepClone(c))}for(const c of o.keys)r.indexOf(c)===-1&&r.push(c)}return new v(s,r,t)}freeze(){return this.frozen=!0,this}clone(){return new v(I.deepClone(this.contents),[...this.keys],I.deepClone(this.overrides))}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of R.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[r];const c=s[r];c&&(typeof o=="object"&&typeof c=="object"?(o=I.deepClone(o),this.mergeContents(o,c)):o=c),t[r]=o}return new v(t,this.keys,this.overrides)}mergeContents(i,s){for(const t of Object.keys(s)){if(t in i&&E.isObject(i[t])&&E.isObject(s[t])){this.mergeContents(i[t],s[t]);continue}i[t]=I.deepClone(s[t])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let s=null,t=null;const r=o=>{o&&(t?this.mergeContents(t,o):t=I.deepClone(o))};for(const o of this.overrides)R.equals(o.identifiers,[i])?s=o.contents:o.identifiers.includes(i)&&r(o.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,C.addToValueTree)(this.contents,i,s,t=>{throw new Error(t)})}removeValue(i){this.removeKey(i)&&(0,C.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let t=0;t<s;t++)i.indexOf(this.keys[t])===0&&(s=t);this.keys.splice(s,1,i)}removeKey(i){const s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=v;class h{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!E.isUndefinedOrNull(i)){const t=this.doParseContent(i);this.parseRaw(t,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:t,keys:r,overrides:o,restricted:c}=this.doParseRaw(i,s);this._configurationModel=new v(t,r,o),this._restrictedConfigurations=c||[]}doParseContent(i){let s={},t=null,r=[];const o=[],c=[];function u(w){Array.isArray(r)?r.push(w):t!==null&&(r[t]=w)}const d={onObjectBegin:()=>{const w={};u(w),o.push(r),r=w,t=null},onObjectProperty:w=>{t=w},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const w=[];u(w),o.push(r),r=w,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:u,onError:(w,A,O)=>{c.push({error:w,offset:A,length:O})}};if(i)try{D.visit(i,d),s=r[0]||{}}catch(w){console.error(`Error while parsing settings file ${this._name}: ${w}`),this._parseErrors=[w]}return s}doParseRaw(i,s){const t=m.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,t,!0,s);i=r.raw;const o=(0,C.toValuesTree)(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),c=Object.keys(i),u=this.toOverrides(i,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:o,keys:c,overrides:u,restricted:r.restricted}}filter(i,s,t,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const o={},c=[];for(const u in i)if(y.OVERRIDE_PROPERTY_REGEX.test(u)&&t){const d=this.filter(i[u],s,!1,r);o[u]=d.raw,c.push(...d.restricted)}else{const d=s[u],w=d?typeof d.scope<"u"?d.scope:3:void 0;d?.restricted&&c.push(u),(w===void 0||r.scopes===void 0||r.scopes.includes(w))&&(r.skipRestricted&&d?.restricted||(o[u]=i[u]))}return{raw:o,restricted:c}}toOverrides(i,s){const t=[];for(const r of Object.keys(i))if(y.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const c in i[r])o[c]=i[r][c];t.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,C.toValuesTree)(o,s)})}return t}}e.ConfigurationModelParser=h;class S extends L.Disposable{constructor(i,s,t,r){super(),this.userSettingsResource=i,this.scopes=s,this.fileService=r,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class P{constructor(i,s,t,r,o=new v,c=new v,u=new T.ResourceMap,d=new v,w=new T.ResourceMap,A=!0){this._defaultConfiguration=i,this._policyConfiguration=s,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=c,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=w,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,s,t){return this.getConsolidatedConfigurationModel(i,s,t).getValue(i)}updateValue(i,s,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new v,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,s===void 0?r.removeValue(i):r.setValue(i,s),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,t){const r=this.getConsolidatedConfigurationModel(i,s,t),o=this.getFolderConfigurationModelForResource(s.resource,t),c=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),d=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),w=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),A=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),O=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),_=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),M=t?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,k=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(i):o.freeze().getValue(i):void 0,F=s.overrideIdentifier?c.override(s.overrideIdentifier).getValue(i):c.getValue(i),$=r.getValue(i),q=R.distinct(r.overrides.map(J=>J.identifiers).flat()).filter(J=>r.getOverrideValue(i,J)!==void 0);return{defaultValue:u,policyValue:d,applicationValue:w,userValue:A,userLocalValue:O,userRemoteValue:_,workspaceValue:M,workspaceFolderValue:k,memoryValue:F,value:$,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,policy:d!==void 0?{value:d}:void 0,application:w!==void 0?{value:w,override:s.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:M!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:k!==void 0?{value:o?.freeze().getValue(i),override:s.overrideIdentifier?o?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:c.getValue(i),override:s.overrideIdentifier?c.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const t=[];if(!s){const{added:r,updated:o,removed:c}=a(this._defaultConfiguration,i);s=[...r,...o,...c]}for(const r of s)for(const o of(0,y.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=i.getKeysForOverrideIdentifier(o),d=[...u.filter(w=>c.indexOf(w)===-1),...c.filter(w=>u.indexOf(w)===-1),...c.filter(w=>!I.equals(this._defaultConfiguration.override(o).getValue(w),i.override(o).getValue(w)))];t.push([o,d])}return this.updateDefaultConfiguration(i),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:t,removed:r}=a(this._policyConfiguration,i),o=[...s,...t,...r];return o.length&&this.updatePolicyConfiguration(i),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.applicationConfiguration,i),c=[...s,...t,...r];return c.length&&this.updateApplicationConfiguration(i),{keys:c,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.localUserConfiguration,i),c=[...s,...t,...r];return c.length&&this.updateLocalUserConfiguration(i),{keys:c,overrides:o}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.remoteUserConfiguration,i),c=[...s,...t,...r];return c.length&&this.updateRemoteUserConfiguration(i),{keys:c,overrides:o}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:t,removed:r,overrides:o}=a(this.workspaceConfiguration,i),c=[...s,...t,...r];return c.length&&this.updateWorkspaceConfiguration(i),{keys:c,overrides:o}}compareAndUpdateFolderConfiguration(i,s){const t=this.folderConfigurations.get(i),{added:r,updated:o,removed:c,overrides:u}=a(t,s),d=[...r,...o,...c];return(d.length||!t)&&this.updateFolderConfiguration(i,s),{keys:d,overrides:u}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:t,updated:r,removed:o,overrides:c}=a(s,void 0);return{keys:[...t,...r,...o],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,s,t){let r=this.getConsolidatedConfigurationModelForResource(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},s){let t=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const r=s.getFolder(i);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const o=this._memoryConfigurationByResource.get(i);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(s=t.merge(r),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=t}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const t=s.getFolder(i);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:t,overrides:r,keys:o}=this._folderConfigurations.get(s);return i.push([s,{contents:t,overrides:r,keys:o}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(t=>i.add(t))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),t=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),o=this.parseConfigurationModel(i.user),c=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((d,w)=>(d.set(b.URI.revive(w[0]),this.parseConfigurationModel(w[1])),d),new T.ResourceMap);return new P(s,t,r,o,new v,c,u,new v,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new v(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=P;function p(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,s=new Map;for(const r of l)r.keys.forEach(o=>i.add(o)),r.overrides.forEach(([o,c])=>{const u=(0,T.getOrSet)(s,o,new Set);c.forEach(d=>u.add(d))});const t=[];return s.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...i.values()],overrides:t}}e.mergeChanges=p;class g{constructor(i,s,t,r){this.change=i,this.previous=s,this.currentConfiguraiton=t,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;i.keys.forEach(u=>o.add(u)),i.overrides.forEach(([,u])=>u.forEach(d=>o.add(d))),this.affectedKeys=[...o.values()];const c=new v;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const t=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!I.equals(t,r)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let t=(0,C.toValuesTree)({[s]:!0},()=>{}),r;for(;typeof t=="object"&&(r=Object.keys(t)[0]);){if(i=i[r],!i)return!1;t=t[r]}return!0}}e.ConfigurationChangeEvent=g;function a(l,i){const{added:s,removed:t,updated:r}=f(i,l),o=[],c=l?.getAllOverrideIdentifiers()||[],u=i?.getAllOverrideIdentifiers()||[];if(i){const d=u.filter(w=>!c.includes(w));for(const w of d)o.push([w,i.getKeysForOverrideIdentifier(w)])}if(l){const d=c.filter(w=>!u.includes(w));for(const w of d)o.push([w,l.getKeysForOverrideIdentifier(w)])}if(i&&l){for(const d of c)if(u.includes(d)){const w=f({contents:l.getOverrideValue(void 0,d)||{},keys:l.getKeysForOverrideIdentifier(d)},{contents:i.getOverrideValue(void 0,d)||{},keys:i.getKeysForOverrideIdentifier(d)});o.push([d,[...w.added,...w.removed,...w.updated]])}}return{added:s,removed:t,updated:r,overrides:o}}function f(l,i){const s=l?i?l.keys.filter(o=>i.keys.indexOf(o)===-1):[...l.keys]:[],t=i?l?i.keys.filter(o=>l.keys.indexOf(o)===-1):[...i.keys]:[],r=[];if(l&&i){for(const o of i.keys)if(l.keys.indexOf(o)!==-1){const c=(0,C.getConfigurationValue)(i.contents,o),u=(0,C.getConfigurationValue)(l.contents,o);I.equals(c,u)||r.push(o)}}return{added:s,removed:t,updated:r}}}),define(ne[199],re([0,1,18,3,2,31,14,19,70,42,8,60,40]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends D.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new h(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:a})=>this.onDidUpdateConfiguration(g,a))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,a){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class h extends E.ConfigurationModel{constructor(g={}){const a=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(a),l=Object.create(null),i=[];for(const s in a){const t=g[s],r=t!==void 0?t:a[s].default;(0,I.addToValueTree)(l,s,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const s of Object.keys(l))b.OVERRIDE_PROPERTY_REGEX.test(s)&&i.push({identifiers:(0,b.overrideIdentifiersFromKey)(s),keys:Object.keys(l[s]),contents:(0,I.toValuesTree)(l[s],t=>console.error(`Conflict in default settings file: ${t}`))});super(l,f,i)}}e.DefaultConfigurationModel=h;class S{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new E.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let P=class extends D.Disposable{constructor(g,a,f){super(),this.defaultConfiguration=g,this.policyService=a,this.logService=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new E.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const a={},f=[],l=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties();for(const i of g){const s=l[i];if(!s){f.push(i);continue}if(s.policy){if(s.type!=="string"&&s.type!=="number"){this.logService.warn(`Policy ${s.policy.name} has unsupported type ${s.type}`);continue}f.push(i),a[s.policy.name]={type:s.type}}}return(0,T.isEmptyObject)(a)||await this.policyService.registerPolicyDefinitions(a),f}onDidChangePolicies(g){const a=m.Registry.as(b.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(g.map(l=>a.get(l)));this.update(f,!0)}update(g,a){const f=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=[],i=this._configurationModel.isEmpty();for(const s of g){const t=f[s]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(i?r!==void 0:!(0,L.equals)(this._configurationModel.getValue(s),r))&&l.push([s,r])}else this._configurationModel.getValue(s)!==void 0&&l.push([s,void 0])}if(l.length){const s=this._configurationModel;this._configurationModel=new E.ConfigurationModel;for(const t of s.keys)this._configurationModel.setValue(t,s.getValue(t));for(const[t,r]of l)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);a&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};P=pe([G(1,y.IPolicyService),G(2,C.ILogService)],P),e.PolicyConfiguration=P}),define(ne[200],re([0,1,6,3,2,17,19,70,199,60]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(m,v,h,S){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new E.DefaultConfiguration),this.policyConfiguration=h instanceof b.NullPolicyService?new E.NullPolicyConfiguration:this._register(new E.PolicyConfiguration(this.defaultConfiguration,h,S)),this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,v)),this.configuration=new I.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new I.ConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:P,properties:p})=>this.onDidDefaultConfigurationChange(P,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(P=>this.onDidPolicyConfigurationChange(P))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,v,h]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new I.Configuration(m,v,new I.ConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(m,v){const h=typeof m=="string"?m:void 0,S=(0,T.isConfigurationOverrides)(m)?m:(0,T.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(h,S,void 0)}updateValue(m,v,h,S){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(h,v,2)}onDidDefaultConfigurationChange(m,v){const h=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(m,v);this.trigger(S,h,7)}onDidPolicyConfigurationChange(m){const v=this.configuration.toData(),h=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(h,v,7)}trigger(m,v,h){const S=new I.ConfigurationChangeEvent(m,{data:v},this.configuration);S.source=h,S.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(ne[201],re([0,1,9,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var D;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends R.ErrorNoTelemetry{constructor(I,E=D.Unknown,b){super(I),this._message=I,this._code=E,this._detail=b,this.isHandled=E===D.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(I){return I instanceof L&&I._code===D.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof L&&I._code===D.NoResolverFound}static isHandled(I){return I instanceof L&&I.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[101],re([0,1,20]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(b){return b.scheme===R.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=n;function D(b){if(!b)return;const C=b.indexOf("+");return C<0?b:b.substr(0,C)}e.getRemoteName=D;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=L;function T(b){const{host:C,port:y}=E(b);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:y}}e.parseAuthorityWithPort=T;function I(b,C){let{host:y,port:m}=E(b);return typeof m>"u"&&(m=C),{host:y,port:m}}e.parseAuthorityWithOptionalPort=I;function E(b){const C=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const y=b.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const m=b.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:b,port:void 0}}}),define(ne[43],re([0,1,25,5,101]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=L;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));var E;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,P){if(typeof S>"u"||S===null)return typeof P>"u"||P===null;if(typeof P>"u"||P===null)return!1;if(typeof S=="string"||typeof P=="string"){const p=typeof S=="string"?S:S.value,g=typeof P=="string"?P:P.value;return R.equalsIgnoreCase(p,g)}return S._lower===P._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;function C(h){return y(h)}e.isApplicationScopedExtension=C;function y(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function m(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function v(h,S){if(S){const P=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return h.activationEvents?.indexOf(P)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[32],re([0,1,25,29,43,4,7,9,36]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,R.compareIgnoreCase)(s.id,t.id)===0}e.areSameExtensions=b;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new y(t.identifier,r,o)}static parse(t){const r=C.exec(t);return r&&r[1]&&r[2]?new y({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof y?b(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=y;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const t=m.exec(s);return t&&t[1]?[S(t[1]),t[2]]:[S(s),void 0]}e.getIdAndVersion=v;function h(s,t){return`${s}.${t}`}e.getExtensionId=h;function S(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function P(s,t){return S(h(s,t))}e.getGalleryExtensionId=P;function p(s,t){const r=[],o=c=>{for(const u of r)if(u.some(d=>b(t(d),t(c))))return u;return null};for(const c of s){const u=o(c);u?u.push(c):r.push([c])}return r}e.groupByExtension=p;function g(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function a(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=a,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function f(s,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(u=>!b(u.identifier,{id:c}))){const u=s.filter(d=>b(d.identifier,{id:c}));u.length===1&&(r.push(u[0]),o.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=f;async function l(s,t){if(!L.isLinux)return!1;let r;try{r=(await s.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=l;async function i(s,t){const r=await l(s,t),o=(0,n.getTargetPlatform)(r?"alpine":L.platform,E.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=i}),define(ne[48],re([0,1,6,16,2,34,7,32,13,5,8]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let y=class extends D.Disposable{constructor(v,h){super(),this.fileService=v,this.logService=h,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,h){return this.withProfileExtensions(h,S=>(S=S.filter(P=>v.some(([p])=>!(0,I.areSameExtensions)(P.identifier,p.identifier))),S.push(...v.map(([P,p])=>({identifier:P.identifier,version:P.manifest.version,location:P.location,metadata:p}))),S))}removeExtensionFromProfile(v,h){return this.withProfileExtensions(h,S=>S.filter(P=>!(0,I.areSameExtensions)(P.identifier,v)))}async withProfileExtensions(v,h){return this.getResourceAccessQueue(v).queue(async()=>{let S=[];try{const P=await this.fileService.readFile(v),p=JSON.parse(P.value.toString());for(const g of p){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}S.push({identifier:g.identifier,location:T.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}if(h){S=h(S);const P=S.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(v,n.VSBuffer.fromString(JSON.stringify(P)))}return S})}getResourceAccessQueue(v){let h=this.resourcesAccessQueueMap.get(v);return h||(h=new R.Queue,this.resourcesAccessQueueMap.set(v,h)),h}};y=pe([G(0,E.IFileService),G(1,C.ILogService)],y),e.ExtensionsProfileScannerService=y}),define(ne[202],re([0,1,22,32]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(L,T,I,E,b){try{const C=await L.getExtensionsControlManifest();if(!C.deprecated)return;const y=await L.getInstalled(1);for(const[m,v]of Object.entries(C.deprecated)){if(!v?.extension)continue;const{id:h,autoMigrate:S,preRelease:P}=v.extension;if(!S)continue;const p=y.find(a=>(0,n.areSameExtensions)(a.identifier,{id:m}));if(!p)continue;const g=(await T.getExtensions([{id:h,preRelease:P}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){b.info(`Skipping migrating '${p.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{b.info(`Migrating '${p.identifier.id}' extension to '${h}' extension...`);const a=!E.getDisabledExtensions().some(l=>(0,n.areSameExtensions)(l,p.identifier));await L.uninstall(p),b.info(`Uninstalled the unsupported extension '${p.identifier.id}'`);let f=y.find(l=>(0,n.areSameExtensions)(l.identifier,{id:h}));(!f||!f.isPreReleaseVersion&&a)&&(f=await L.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:p.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${f.identifier.id}'`),a||(await E.disableExtension(f.identifier),b.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${p.identifier.id}' is disabled`)),S.storage&&(I.addToMigrationList((0,n.getExtensionId)(p.manifest.publisher,p.manifest.name),(0,n.getExtensionId)(f.manifest.publisher,f.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${p.identifier.id}' extension to '${h}' extension.`)}catch(a){b.error(a)}}}catch(C){b.error(C)}}e.migrateUnsupportedExtensions=D}),define(ne[203],re([0,1,6,9,2,4,17,55,7,30,28,15,29,32,13,8]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let P=class extends D.Disposable{constructor(g,a,f,l){super(),this.fileService=a,this.extensionGalleryService=f,this.logService=l,this.extensionsDownloadDir=E.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const f=this.getName(g),l=(0,T.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(l)){const i=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,a);try{await this.rename(i,l,Date.now()+2*60*1e3)}catch(s){try{await this.fileService.del(i)}catch{}if(s.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(s)}. Deleted the vsix from downloaded location`,i.path),s}}return l}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,a,f){try{await C.Promises.rename(g.fsPath,a.fsPath)}catch(l){if(L.isWindows&&l&&l.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,f);throw l}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],f=[];for(const s of g.children){const t=v.ExtensionKey.parse(s.name);t&&f.push([t,s])}const l=(0,v.groupByExtension)(f,([s])=>s),i=[];for(const s of l)s.sort((t,r)=>I.rcompare(t[0].version,r[0].version)),a.push(...s.slice(1).map(t=>t[1].resource)),i.push(s[0][1]);i.sort((s,t)=>s.mtime-t.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(s=>s.resource)),await R.Promises.settled(a.map(s=>(this.logService.trace("Deleting vsix from cache",s.path),this.fileService.del(s))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?v.ExtensionKey.create(g).toString().toLowerCase():(0,b.generateUuid)()}};P=pe([G(0,y.INativeEnvironmentService),G(1,h.IFileService),G(2,m.IExtensionGalleryService),G(3,S.ILogService)],P),e.ExtensionsDownloader=P}),define(ne[204],re([0,1,2,12,28,43]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends R.Disposable{constructor(E,b){super(),this.environmentService=E,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(b.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(E){E.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[205],re([0,1,95,18,6,2,20,12,28,15,29,32,8,69]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let h=class extends v.LanguagePackBaseService{constructor(g,a,f,l){super(f),this.extensionManagementService=g,this.logService=l,this.cache=this._register(new S(a,l)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),a=Object.keys(g).map(f=>{const l=g[f];return{...this.createQuickPickItem(f,l.label),extensionId:l.extensions[0].extensionIdentifier.id}});return a.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),a.sort((f,l)=>f.label.localeCompare(l.label)),a}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const a=await this.cache.getLanguagePacks();Object.keys(a).some(f=>a[f]&&a[f].extensions.some(l=>(0,y.areSameExtensions)(l.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(a);return!(0,n.equals)(Object.keys(g),Object.keys(f))}};h=pe([G(0,C.IExtensionManagementService),G(1,b.INativeEnvironmentService),G(2,C.IExtensionGalleryService),G(3,m.ILogService)],h),e.NativeLanguagePackService=h;let S=class extends L.Disposable{constructor(g,a){super(),this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(a=>{Object.keys(a).forEach(f=>delete a[f]),this.createLanguagePacksFromExtensions(a,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...a){for(const f of a)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,a){const f=a.identifier,l=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const i of l)if(a.location.scheme===T.Schemas.file&&P(i)){let s=g[i.languageId];s||(s={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},g[i.languageId]=s);const t=s.extensions.filter(r=>(0,y.areSameExtensions)(r.extensionIdentifier,f))[0];t?t.version=a.manifest.version:s.extensions.push({extensionIdentifier:f,version:a.manifest.version});for(const r of i.translations)s.translations[r.id]=(0,I.join)(a.location.fsPath,r.path)}}updateHash(g){if(g){const a=(0,R.createHash)("md5");for(const f of g.extensions)a.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=a.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(a=g(f),f)).then(f=>{for(const i of Object.keys(f))f[i]||delete f[i];this.languagePacks=f,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),E.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>a,f=>this.logService.error(f))})}};S=pe([G(0,b.INativeEnvironmentService),G(1,m.ILogService)],S);function P(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const g of p.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ne[206],re([0,1,6,16,22,9,3,2,30,88,201,101]),function(Q,e,R,n,D,L,T,I,E,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const m=30*1e3;var v;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(v=e.ConnectionType||(e.ConnectionType={}));function h(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(z){const V=new D.CancellationTokenSource;return setTimeout(()=>V.cancel(),z),V.token}function P(z,V){if(z.isCancellationRequested||V.isCancellationRequested)return D.CancellationToken.Cancelled;const U=new D.CancellationTokenSource;return z.onCancellationRequested(()=>U.cancel()),V.onCancellationRequested(()=>U.cancel()),U.token}class p{constructor(V){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((U,N)=>{this._resolvePromise=U,this._rejectPromise=N}),V.isCancellationRequested?this._timeout():this._disposables.add(V.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(V){this._state==="pending"?this._disposables.add(V):V.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(V))}reject(V){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(V))}}function g(z,V){const U=new p(V);return U.registerDisposable(z.onControlMessage(N=>{const j=JSON.parse(N.toString()),x=W(j);x?U.reject(x):U.resolve(j)})),U.promise}function a(z,V,U,N,j,x,Z,oe){const X=new p(oe);return V.connect(U,N,j,x,Z,(ie,se)=>{X.didTimeout?(ie&&z.error(ie),se?.dispose()):ie||!se?X.reject(ie):X.resolve(se)}),X.promise}function f(z,V){const U=new p(V);return z.then(N=>{U.didTimeout||U.resolve(N)},N=>{U.didTimeout||U.reject(N)}),U.promise}async function l(z,V,U,N){const j=te(z,V);z.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let x;try{x=await a(z.logService,z.socketFactory,z.host,z.port,(0,y.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${h(V)}-${z.reconnectionToken}`,N)}catch(se){throw z.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),z.logService.error(se),se}z.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let Z,oe;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(x,null),Z=z.reconnectionProtocol,oe=!1):(Z=new b.PersistentProtocol(x,null),oe=!0),z.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const X=await f(z.signService.createNewMessage((0,E.generateUuid)()),N),ie={type:"auth",auth:z.connectionToken||"00000000000000000000",data:X.data};Z.sendControl(n.VSBuffer.fromString(JSON.stringify(ie)));try{const se=await g(Z,P(N,S(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${j} 4/6. received SignRequest control message.`),!await f(z.signService.validate(X,se.signedData),N)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const he=await f(z.signService.sign(se.data),N),ve={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:V};return U&&(ve.args=U),z.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(n.VSBuffer.fromString(JSON.stringify(ve))),{protocol:Z,ownsProtocol:oe}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(z.logService.error(`${j} the handshake timed out. Error:`),z.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${j} received error control message when negotiating connection. Error:`),z.logService.error(se)),oe&&K(Z),se}}async function i(z,V,U,N){const j=Date.now(),x=te(z,V),{protocol:Z,ownsProtocol:oe}=await l(z,V,U,N),X=new p(N);return X.registerDisposable(Z.onControlMessage(ie=>{const se=JSON.parse(ie.toString()),ue=W(se);ue?(z.logService.error(`${x} received error control message when negotiating connection. Error:`),z.logService.error(ue),oe&&K(Z),X.reject(ue)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${ce(j)}!`),X.resolve({protocol:Z,firstMessage:se}))})),X.promise}async function s(z,V){const{protocol:U}=await i(z,1,void 0,V);return{protocol:U}}async function t(z,V,U){const{protocol:N,firstMessage:j}=await i(z,2,V,U),x=j&&j.debugPort;return{protocol:N,debugPort:x}}async function r(z,V,U){const N=Date.now(),j=te(z,3),{protocol:x}=await l(z,3,V,U);return z.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ce(N)}!`),x}async function o(z,V,U){const{host:N,port:j,connectionToken:x}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:N,port:j,connectionToken:x,reconnectionToken:V,reconnectionProtocol:U,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function c(z,V,U){return d(z,async N=>{const{protocol:j}=await s(N,D.CancellationToken.None);return new J(z,V,U,N.reconnectionToken,j)})}e.connectRemoteAgentManagement=c;async function u(z,V){return d(z,async U=>{const{protocol:N,debugPort:j}=await t(U,V,D.CancellationToken.None);return new H(z,V,U.reconnectionToken,N,j)})}e.connectRemoteAgentExtensionHost=u;async function d(z,V){for(let N=1;;N++)try{const j=(0,E.generateUuid)(),x=await o(z,j,null);return await V(x)}catch(j){if(N<5)z.logService.error(`[remote-connection][attempt ${N}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(j);else throw z.logService.error(`[remote-connection][attempt ${N}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(j),q.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(j)),j}}async function w(z,V,U){const N=await o(z,(0,E.generateUuid)(),null);return await r(N,{host:V,port:U},D.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function A(z){return(0,R.createCancelablePromise)(V=>new Promise((U,N)=>{const j=setTimeout(U,z*1e3);V.onCancellationRequested(()=>{clearTimeout(j),U()})}))}var O;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(O=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class _{constructor(V,U){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.type=0}}e.ConnectionLostEvent=_;class M{constructor(V,U,N,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.durationSeconds=N,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=M;class k{constructor(V,U,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=2}}e.ReconnectionRunningEvent=k;class F{constructor(V,U,N){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.type=4}}e.ConnectionGainEvent=F;class ${constructor(V,U,N,j){this.reconnectionToken=V,this.millisSinceLastIncomingData=U,this.attempt=N,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class q extends I.Disposable{constructor(V,U,N,j,x){super(),this._connectionType=V,this._options=U,this.reconnectionToken=N,this.protocol=j,this._reconnectionFailureIsFatal=x,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(j.onSocketClose(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(Z=>{const oe=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),q._instances.push(this),this._register((0,I.toDisposable)(()=>{const Z=q._instances.indexOf(this);Z>=0&&q._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(q._permanentFailureMillisSinceLastIncomingData,q._permanentFailureAttempt,q._permanentFailureHandled)}static triggerPermanentFailure(V,U,N){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=V,this._permanentFailureAttempt=U,this._permanentFailureHandled=N,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(V=>V._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(V=>V._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||q._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const V=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const U=[0,5,5,10,10,10,10,10,30];let N=-1;do{N++;const j=N<U.length?U[N]:U[U.length-1];try{if(j>0){const Z=A(j);this._onDidStateChange.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,Z)),this._options.logService.info(`${V} waiting for ${j} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new k(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1)),this._options.logService.info(`${V} resolving connection...`);const x=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${V} connecting to ${x.host}:${x.port}...`),await this._reconnect(x,S(m)),this._options.logService.info(`${V} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(N>360){this._options.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(x)){this._options.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this._options.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if((0,L.isCancellationError)(x)){this._options.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(x);continue}if(x instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,C.RemoteAuthorityResolverError.isHandled(x));break}this._options.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(x),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),N+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(V,U,N){this._reconnectionFailureIsFatal?q.triggerPermanentFailure(V,U,N):this._gotoPermanentFailure(V,U,N)}_gotoPermanentFailure(V,U,N){this._onDidStateChange.fire(new $(this.reconnectionToken,V,U,N)),K(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=q,q._permanentFailure=!1,q._permanentFailureMillisSinceLastIncomingData=0,q._permanentFailureAttempt=0,q._permanentFailureHandled=!1,q._instances=[];class J extends q{constructor(V,U,N,j,x){super(1,V,j,x,!0),this.client=this._register(new b.Client(x,{remoteAuthority:U,clientId:N},V.ipcLogger))}async _reconnect(V,U){await s(V,U)}}e.ManagementPersistentConnection=J;class H extends q{constructor(V,U,N,j,x){super(2,V,N,j,!1),this._startArguments=U,this.debugPort=x}async _reconnect(V,U){await t(V,this._startArguments,U)}}e.ExtensionHostPersistentConnection=H;function K(z){try{z.acceptDisconnect();const V=z.getSocket();z.dispose(),V.dispose()}catch(V){(0,L.onUnexpectedError)(V)}}function W(z){if(z&&z.type==="error"){const V=new Error(`Connection error: ${z.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function B(z,V){for(;z.length<V;)z+=" ";return z}function Y(z,V,U){return`[remote-connection][${B(h(z),13)}][${V.substr(0,5)}\u2026][${U?"reconnect":"initial"}]`}function te(z,V){return`${Y(V,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function ce(z){return`${Date.now()-z} ms`}}),define(ne[207],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[208],re([0,1,80,138]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,L,T,I,E,b){const C=m=>b(m,void 0),y=R.createConnection({host:D,port:L},()=>{y.removeListener("error",C);const m=Buffer.alloc(16);for(let P=0;P<16;P++)m[P]=Math.round(Math.random()*256);const v=m.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${L}${T}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`];y.write(h.join(`\r
`)+`\r
\r
`);const S=P=>{P.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",S),b(void 0,new n.NodeSocket(y,E)))};y.on("data",S)});y.setNoDelay(!0),y.once("error",C)}}}),define(ne[209],re([0,1,121,19,8]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(I,E){this.configurationService=I,this.logService=E}async request(I,E){this.logService.trace("RequestService#request (browser) - begin",I.url),I.proxyAuthorization||(I.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const b=await(0,R.request)(I,E);return this.logService.trace("RequestService#request (browser) - success",I.url),b}catch(b){throw this.logService.error("RequestService#request (browser) - error",I.url,b),b}}async resolveProxy(I){}};L=pe([G(0,n.IConfigurationService),G(1,D.ILogService)],L),e.RequestService=L}),define(ne[44],re([0,1,16,156,42,5,40]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function I(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=I;function E(S){return S.res.statusCode===204}async function b(S){return E(S)?null:(await(0,R.streamToBuffer)(S.stream)).toString()}e.asText=b;async function C(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);return b(S)}e.asTextOrError=C;async function y(S){if(!I(S))throw new Error("Server returned "+S.res.statusCode);if(E(S))return null;const p=(await(0,R.streamToBuffer)(S.stream)).toString();try{return JSON.parse(p)}catch(g){throw g.message+=`:
`+p,g}}e.asJson=y;function m(S){h(S)}e.updateProxyConfigurationsScope=m;let v;function h(S){const P=T.Registry.as(D.Extensions.Configuration),p=v;v={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},P.updateConfigurations({add:[v],remove:p?[p]:[]})}h(2)}),define(ne[210],re([0,1,22,20,13,44]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(E,b){this.requestService=E,this.fileService=b}async download(E,b,C=R.CancellationToken.None){if(E.scheme===n.Schemas.file||E.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(E,b);return}const y={type:"GET",url:E.toString(!0)},m=await this.requestService.request(y,C);if(m.res.statusCode===200)await this.fileService.writeFile(b,m.stream);else{const v=await(0,L.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};T=pe([G(0,L.IRequestService),G(1,D.IFileService)],T),e.DownloadService=T}),define(ne[211],re([0,1,18,22,2,17,173,13,8,26,44]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let y=class extends D.Disposable{constructor(v,h,S,P){super(),this.fileService=v,this.productService=h,this.requestService=S,this.logService=P,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,p])=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(v){return this.getValidConfigBasedTips(v)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(v){const h=[];for(const[S,P]of this.allConfigBasedTips)if(!(P.configScheme&&P.configScheme!==v.scheme))try{const p=await this.fileService.readFile((0,L.joinPath)(v,S)),g=new Map;Object.entries(P.recommendations).forEach(([f,l])=>{if((0,R.isNonEmptyArray)(l.remotes))for(const i of l.remotes)g.set(i,{extensionId:f,extensionName:l.name,configName:P.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled});else h.push({extensionId:f,extensionName:l.name,configName:P.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})});const a=(0,T.getDomainsOfRemotes)(p.value.toString(),[...g.keys()]);for(const f of a){const l=g.get(f);l&&h.push(l)}}catch{}return h}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const v=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(v.res.statusCode!==200)return[];const h=await(0,C.asJson)(v);return h?h.workspaceRecommendations||[]:[]}catch(v){return this.logService.error(v),[]}}};y=pe([G(0,I.IFileService),G(1,b.IProductService),G(2,C.IRequestService),G(3,E.ILogService)],y),e.ExtensionTipsService=y}),define(ne[212],re([0,1,16,22]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(I){this.service=I}listen(I,E){throw new Error("Invalid listen")}call(I,E,b,C=n.CancellationToken.None){switch(E){case"request":return this.service.request(b[0],C).then(async({res:y,stream:m})=>{const v=await(0,R.streamToBuffer)(m);return[{statusCode:y.statusCode,headers:y.headers},v]});case"resolveProxy":return this.service.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class L{constructor(I){this.channel=I}async request(I,E){const[b,C]=await this.channel.call("request",[I],E);return{res:b,stream:(0,R.bufferToStream)(C)}}async resolveProxy(I){return this.channel.call("resolveProxy",[I])}}e.RequestChannelClient=L}),define(ne[213],re([0,1,209,212]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class D{constructor(T,I,E){this.configurationService=I,this.logService=E,this.browserRequestService=new R.RequestService(I,E),this.mainRequestService=new n.RequestChannelClient(T.getChannel("request"))}request(T,I){return this.getRequestService().request(T,I)}async resolveProxy(T){return this.getRequestService().resolveProxy(T)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=D}),define(ne[102],re([0,1,64,5]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(L){return(0,R.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[214],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[215],re([0,1,89,6,22,3,2,20,30,8,102,214]),function(Q,e,R,n,D,L,T,I,E,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const P=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${P})`);const p=(0,C.hash)(S);this.processeDisposables.has(p)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${P})`),this.doDisposeWorker(S));const g=new D.CancellationTokenSource;let a,f,l;this.processeDisposables.set(p,r=>{g.dispose(!0),a?.terminate(S,D.CancellationToken.None),f?.close(),l?.close(),this.processeDisposables.delete(p);const o=this.processResolvers.get(p);o&&(this.processResolvers.delete(p),o({reason:r}))}),a=await this.getOrCreateWebWorker(S);const i=new Promise(r=>{this.processResolvers.set(p,r)});if(g.token.isCancellationRequested)return i;const{port1:s,port2:t}=new MessageChannel;return f=s,l=t,await a.spawn(S,l,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${P})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),i}getOrCreateWebWorker(S){let P=this.workers.get(S.process.moduleId);if(!P){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const p=new v(S.process.type,this.logService);P=p.init(),p.onDidProcessSelfTerminate(({configuration:g,reason:a})=>{this.doDisposeWorker(g,a)}),this.workers.set(S.process.moduleId,P)}return P}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,P){const p=this.processeDisposables.get((0,C.hash)(S));p&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),p(P))}};m=pe([G(0,b.ILogService)],m),e.SharedProcessWorkerService=m;class v extends T.Disposable{constructor(S,P){super(),this.type=S,this.logService=P,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new n.DeferredPromise,P=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return P.onerror=p=>{this.logService.error(`SharedProcess: worker error (${this.type})`,p.message)},P.onmessageerror=p=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,p)},P.onmessage=p=>{const{id:g,message:a,configuration:f,nonce:l}=p.data;switch(g){case y.SharedProcessWorkerMessages.Ready:S.complete(P);break;case y.SharedProcessWorkerMessages.Ack:if(l){const i=this.mapMessageNonceToPendingMessageResolve.get(l);i&&(this.mapMessageNonceToPendingMessageResolve.delete(l),i())}break;case y.SharedProcessWorkerMessages.SelfTerminated:f&&a&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(a)});break;case y.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case y.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,p)}},P.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,P,p){const g=await this.workerReady;if(!P.isCancellationRequested)return new Promise(a=>{const f=(0,E.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,a);const l={...S,nonce:f};p?g.postMessage(l,[p]):g.postMessage(l),P.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&a()})})}spawn(S,P,p){const g={id:y.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:I.FileAccess.asFileUri("bootstrap-fork",Q).fsPath}};return this.send(g,p,P)}terminate(S,P){const p={id:y.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(p,P)}}}),define(ne[216],re([0,1,62,20,172]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}pe([R.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(ne[217],re([0,1,54,12,157,22,38,9,4,30,135,170,6]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let h;async function S(p,g,a){return g["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.isLaunchedFromCli)(a)&&!g["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.isLaunchedFromCli)(a)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(f,l)=>{const i=new L.CancellationTokenSource,s=setTimeout(()=>{i.dispose(!0),l(new Error((0,D.localize)(0,null)))},v);try{f(await P(p,i.token))}catch(t){!(0,I.isCancellationError)(t)&&!i.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(t)))):f({})}finally{clearTimeout(s),i.dispose()}})),h)}e.getResolvedShellEnv=S;async function P(p,g){const a=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",a);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",f);const l=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",s);const t=await(0,C.getSystemShell)(E.OS,s);return p.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(g.isCancellationRequested)return o((0,I.canceled)());const c=(0,n.basename)(t);let u,d;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(u=`& '${process.execPath}' ${w} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' ${w} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,c==="tcsh"?d=["-ic"]:d=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const A=(0,R.spawn)(t,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});g.onCancellationRequested(()=>(A.kill(),o((0,I.canceled)()))),A.on("error",M=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(M)),o(M)});const O=[];A.stdout.on("data",M=>O.push(M));const _=[];A.stderr.on("data",M=>_.push(M)),A.on("close",(M,k)=>{const F=Buffer.concat(O).toString("utf8");p.trace("getUnixShellEnvironment#raw",F);const $=Buffer.concat(_).toString("utf8");if($.trim()&&p.trace("getUnixShellEnvironment#stderr",$),M||k)return o(new Error((0,D.localize)(2,null,M,k)));const q=i.exec(F),J=q?q[1]:"{}";try{const H=JSON.parse(J);a?H.ELECTRON_RUN_AS_NODE=a:delete H.ELECTRON_RUN_AS_NODE,f?H.ELECTRON_NO_ATTACH_CONSOLE=f:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",H),r(H)}catch(H){p.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(H)),o(H)}})})}}),define(ne[103],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[218],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((D,L)=>Q(["vsda"],D,L))}async createNewMessage(D){try{const L=await this.vsda(),T=new L.validator;if(T){const I=String(R._nextId++);return this.validators.set(I,T),{id:I,data:T.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,L){if(!D.id)return!0;const T=this.validators.get(D.id);if(!T)return!1;this.validators.delete(D.id);try{return T.validate(L)==="ok"}catch{return!1}}async sign(D){try{const L=await this.vsda(),T=new L.signer;if(T)return T.sign(D)}catch{}return D}}e.SignService=R,R._nextId=1}),define(ne[71],re([0,1,3,2]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends n.Disposable{constructor(y,m,v){super(),this.channel=y,this.profile=m,this.workspace=v}async getItems(){const y={profile:this.profile,workspace:this.workspace},m=await this.channel.call("getItems",y);return new Map(m)}updateItems(y){const m={profile:this.profile,workspace:this.workspace};return y.insert&&(m.insert=Array.from(y.insert.entries())),y.delete&&(m.delete=Array.from(y.delete.values())),this.channel.call("updateItems",m)}}class L extends D{constructor(y,m){super(y,m,void 0),this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(y=>this.onDidChangeStorage(y)))}onDidChangeStorage(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this._onDidChangeItemsExternal.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class T extends L{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class I extends L{constructor(y,m){super(y,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=I;class E extends D{constructor(y,m){super(y,void 0,m),this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=E;class b{constructor(y){this.channel=y}isUsed(y){const m={payload:y,profile:void 0,workspace:void 0};return this.channel.call("isUsed",m)}}e.StorageClient=b}),define(ne[104],re([0,1,4,36,7,30]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(b){if(R.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function I(b,C,y,m,v,h,S,P,p,g){const a=Object.create(null);a["common.machineId"]=S,a.sessionID=(0,L.generateUuid)()+Date.now(),a.commitHash=v,a.version=h,a["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,R.PlatformToString)(R.platform),a["common.nodePlatform"]=n.platform,a["common.nodeArch"]=m,a["common.product"]=g||"desktop",P&&(a["common.msftInternal"]=P);let f=0;const l=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),R.isLinuxSnap&&(a["common.snap"]="true");const i=T(y);i&&(a["common.platformDetail"]=i);try{const s=await b.readFile(D.URI.file(p));a["common.source"]=s.value.toString().slice(0,30)}catch{}return a}e.resolveCommonProperties=I;function E(b){const C=n.env.USERDNSDOMAIN;if(!C)return!1;const y=C.toLowerCase();return b.some(m=>y===m)}e.verifyMicrosoftInternalDomain=E}),define(ne[23],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[219],re([0,1,37,51,6,35,20,12,4,7,132,28,134,92,13,26,23]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function g(s,t){const r=`${s}::${t.join(":")}`,o=p.get(r);if(o)return o;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,d=new Map,w=2e4;function A(_,M,k,F){const $=M.substring(_.length+1);return D.Promises.withAsyncBody(async q=>{let J;try{J=await y.Promises.readdir(M,{withFileTypes:!0})}catch{q();return}if(F.count>=w){F.count+=J.length,F.maxReached=!0,q();return}let H=J.length;if(H===0){q();return}let K=J;F.count+J.length>w&&(F.maxReached=!0,H=w-F.count,K=J.slice(0,H)),F.count+=J.length;for(const W of K)if(W.isDirectory()){if(k.includes(W.name)||await A(_,(0,I.join)(M,W.name),k,F),--H===0){q();return}}else{const B=W.name.lastIndexOf(".");if(B>=0){const Y=W.name.substring(B+1);Y&&u.set(Y,(u.get(Y)??0)+1)}for(const Y of c)Y.relativePathPattern?.test($)!==!1&&Y.filePattern.test(W.name)&&d.set(Y.tag,(d.get(Y.tag)??0)+1);if(--H===0){q();return}}})}const O=D.Promises.withAsyncBody(async _=>{const M={count:0,maxReached:!1};await A(s,s,t,M);const k=await l(s);_({configFiles:a(d),fileTypes:a(u),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:k})});return p.set(r,O),O}e.collectWorkspaceStats=g;function a(s){return[...n.Iterable.map(s.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function f(){const s={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(s.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),s}e.getMachineInfo=f;async function l(s){try{const t=new Map,r=(0,I.join)(s,".vscode","launch.json"),o=await y.Promises.readFile(r),c=[],u=(0,L.parse)(o.toString(),c);if(c.length)return console.log(`Unable to parse ${r}`),[];if((0,L.getNodeType)(u)==="object"&&u.configurations)for(const d of u.configurations){const w=d.type;w&&(t.has(w)?t.set(w,t.get(w)+1):t.set(w,1))}return a(t)}catch{return[]}}e.collectLaunchConfigs=l;let i=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const o=R.cpus();return o&&o.length>0&&r.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),r.push(`Memory (System):  ${(R.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||r.push(`Load (avg):       ${R.loadavg().map(c=>Math.round(c)).join(", ")}`),r.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([(0,m.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[c,u]=o,d=this.formatProcessList(t,c);return r.forEach(w=>{if((0,v.isRemoteDiagnosticError)(w))d+=`
${w.errorMessage}`,u+=`
${w.errorMessage}`;else if(d+=`

Remote: ${w.hostName}`,w.processes&&(d+=`
${this.formatProcessList(t,w.processes)}`),w.workspaceMetadata){u+=`
|  Remote: ${w.hostName}`;for(const A of Object.keys(w.workspaceMetadata)){const O=w.workspaceMetadata[A];let _=`${O.fileCount} files`;O.maxFilesReached&&(_=`more than ${_}`),u+=`|    Folder (${A}): ${_}`,u+=this.formatWorkspaceStats(O)}}}),{processInfo:d,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:o,vmHint:c,os:u,cpus:d}=f(),w={os:u,memory:o,cpus:d,vmHint:c,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return E.isWindows||(w.load=`${R.loadavg().map(A=>Math.round(A)).join(", ")}`),E.isLinux&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(t,r){const o=[];return(0,m.listProcesses)(t.mainPID).then(async c=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,c)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if((0,v.isRemoteDiagnosticError)(u))o.push(`
${u.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${u.hostName}`),o.push(this.formatMachineInfo(u.machineInfo)),u.processes&&o.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const d of Object.keys(u.workspaceMetadata)){const w=u.workspaceMetadata[d];let A=`${w.fileCount} files`;w.maxFilesReached&&(A=`more than ${A}`),o.push(`Folder (${d}): ${A}`),o.push(this.formatWorkspaceStats(w))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const r=[];let c=0;const u=(O,_)=>{const M=` ${O}(${_})`;c+M.length>60?(r.push(d),d="|                 ",c=d.length):c+=M.length,d+=M};let d="|      File types:";const w=10,A=t.fileTypes.length>w?w:t.fileTypes.length;for(let O=0;O<A;O++){const _=t.fileTypes[O];u(_.name,_.count)}if(r.push(d),t.configFiles.length>=0&&(d="|      Conf files:",c=0,t.configFiles.forEach(O=>{u(O.name,O.count)}),r.push(d)),t.launchConfigFiles.length>0){let O="|      Launch Configs:";t.launchConfigFiles.forEach(_=>{O+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),r.push(O)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(r-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],o=[];return t.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(r.push(`|  Window (${c.title})`),c.folderURIs.forEach(u=>{const d=b.URI.revive(u);if(d.scheme===T.Schemas.file){const w=d.fsPath;o.push(g(w,["node_modules",".git"]).then(A=>{let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),r.push(`|    Folder (${(0,I.basename)(w)}): ${O}`),r.push(this.formatWorkspaceStats(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${w} (${A.toString()})`)}))}else r.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(c=>r.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(t,r){const o=new Map;t.windows.forEach(u=>o.set(u.pid,u.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,o,c,r,0),c.join(`
`)}formatProcessItem(t,r,o,c,u){const d=u===0;let w;d?w=c.pid===t?`${this.productService.applicationName} main`:"remote agent":(w=`${"  ".repeat(u)} ${c.name}`,c.name==="window"&&(w=`${w} (${r.get(c.pid)})`));const A=process.platform==="win32"?c.mem:R.totalmem()*(c.mem/100);o.push(`${c.load.toFixed(0).padStart(5," ")}	${(A/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(c.children)&&c.children.forEach(O=>this.formatProcessItem(t,r,o,O,u+1))}async getWorkspaceFileExtensions(t){const r=new Set;for(const{uri:o}of t.folders){const c=b.URI.revive(o);if(c.scheme!==T.Schemas.file)continue;const u=c.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(w=>r.add(w.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const o=b.URI.revive(r);if(o.scheme!==T.Schemas.file)continue;const c=o.fsPath;try{const u=await g(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})}),u.launchConfigFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})}),u.configFiles.forEach(d=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};i=pe([G(0,P.ITelemetryService),G(1,S.IProductService)],i),e.DiagnosticsService=i}),define(ne[105],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(L){this.appenders=L}listen(L,T){throw new Error(`Event not found: ${T}`)}call(L,T,{eventName:I,data:E}){return this.appenders.forEach(b=>b.log(I,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class n{constructor(L){this.channel=L}log(L,T){return this.channel.call("log",{eventName:L,data:T}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[49],re([0,1,31,82,14,19,104,23]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class E{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,n.staticObservableValue)(0)}publicLog(i,s){return Promise.resolve(void 0)}publicLog2(i,s){return this.publicLog(i,s)}publicLogError(i,s){return Promise.resolve(void 0)}publicLogError2(i,s){return this.publicLogError(i,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=E,e.NullTelemetryService=new E;class b{async publicLog(i,s,t){}async publicLogError(i,s,t){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(l,i){return i.onDidChangeConfiguration(s=>{s.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(s.source),configurationKeys:p(s.sourceConfig)})})}e.configurationTelemetry=C;function y(l,i){return!(i.disableTelemetry||!l.enableTelemetry||i.extensionTestsLocationURI)}e.supportsTelemetry=y;function m(l){const i=l.getValue(I.TELEMETRY_SETTING_ID),s=l.getValue("telemetry.enableCrashReporter");if(l.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function v(l){const i={},s={},t={};P(l,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const o=t[r];typeof o=="number"?s[r]=o:typeof o=="boolean"?s[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),i[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(i[r]=o)}return{properties:i,measurements:s}}e.validateTelemetryData=v;const h=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(l){if(!l)return"none";for(const i of h)if(l.startsWith(`${i}+`))return i;return"other"}e.cleanRemoteAuthority=S;function P(l,i,s=0,t){if(!!l)for(const r of Object.getOwnPropertyNames(l)){const o=l[r],c=t?t+r:r;Array.isArray(o)?i[c]=(0,R.safeStringify)(o):o instanceof Date?i[c]=o.toISOString():(0,D.isObject)(o)?s<2?P(o,i,s+1,c+"."):i[c]=(0,R.safeStringify)(o):i[c]=o}}function p(l){if(!l)return[];const i=[];return g(i,"",l),i}function g(l,i,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(t=>g(l,i?`${i}.${t}`:t,s[t])):l.push(i)}function a(l,i){const s=l.msftInternalDomains||[],t=i.getValue("telemetry.internalTesting");return(0,T.verifyMicrosoftInternalDomain)(s)||t}e.isInternalTelemetry=a;function f(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(ne[220],re([0,1,47,49]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(L,T,I,E,b,C,y){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${T.nameShort})`};if((0,n.supportsTelemetry)(T,I)&&(0,n.getTelemetryLevel)(E)===3){const v=await(0,R.getServiceMachineId)(I,b,C),{sessionId:h}=await y.getTelemetryInfo();m["X-Market-User-Id"]=v,m["VSCode-SessionId"]=h}return m}e.resolveMarketplaceHeaders=D}),define(ne[221],re([0,1,9,31,49]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function T(E,b,C){const y=await new Promise((P,p)=>{Q(["@microsoft/1ds-core-js"],P,p)}),m=await new Promise((P,p)=>{Q(["@microsoft/1ds-post-js"],P,p)}),v=new y.AppInsightsCore,h=new m.PostChannel,S={instrumentationKey:E,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[h]]};if(C){S.extensionConfig={};const P={alwaysUseXhrOverride:!0,httpXHROverride:C};S.extensionConfig[h.identifier]=P}return v.initialize(S,[]),v.addTelemetryInitializer(P=>{b&&(P.ext=P.ext??{},P.ext.utc=P.ext.utc??{},P.ext.utc.flags=8462029)}),v}class I{constructor(b,C,y,m,v){this._isInternalTelemetry=b,this._eventPrefix=C,this._defaultData=y,this._xhrOverride=v,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(b){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){b(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=T(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(C=>{b(C)},C=>{(0,R.onUnexpectedError)(C),console.error(C)})}}log(b,C){if(!this._aiCoreOrKey)return;C=(0,n.mixin)(C,this._defaultData),C=(0,D.validateTelemetryData)(C);const y=this._eventPrefix+"/"+b;try{this._withAIClient(m=>{m.pluginVersionString=C?.properties.version??"Unknown",m.track({name:y,baseData:{name:y,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(b=>{this._withAIClient(C=>{C.unload(!0,()=>{this._aiCoreOrKey=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(ne[106],re([0,1,2,15,8,49]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends R.Disposable{constructor(E,b,C=""){super(),this.prefix=C;const y=E.getLogger(b.telemetryLogResource);y?this.logger=this._register(y):(this.logger=this._register(E.createLogger(b.telemetryLogResource)),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,b){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,L.validateTelemetryData)(b))}};T=pe([G(0,D.ILoggerService),G(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[107],re([0,1,2,31,82,4,25,158,19,42,99,26,40,23,49]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(g,a,f){this._configurationService=a,this._productService=f,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,a){this._experimentProperties[g]=a}_updateTelemetryLevel(){let g=(0,h.getTelemetryLevel)(this._configurationService);const a=this._productService.enabledTelemetryLevels;if(a){this._sendErrorTelemetry=this.sendErrorTelemetry?a.error:!1;const f=a.usage?3:a.error?2:0;g=Math.min(g,f)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,a=g.sessionID,f=g["common.machineId"],l=g["common.firstSessionDate"],i=g["common.msftInternal"];return{sessionId:a,machineId:f,firstSessionDate:l,msftInternal:i}}dispose(){this._disposables.dispose()}_log(g,a,f,l){return this.telemetryLevel.value<a?Promise.resolve(void 0):this._commonProperties.then(i=>{f=(0,n.mixin)(f,i),f=(0,n.mixin)(f,this._experimentProperties),f=(0,n.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,l)}),this._appenders.forEach(s=>s.log(g,f))},i=>{console.error(i)})}publicLog(g,a,f){return this._log(g,3,a,f)}publicLog2(g,a,f){return this.publicLog(g,a,f)}publicLogError(g,a){return this._sendErrorTelemetry?this._log(g,2,a,!0):Promise.resolve(void 0)}publicLogError2(g,a){return this.publicLogError(g,a)}_anonymizeFilePaths(g){let a=g;const f=[];for(const t of this._cleanupPatterns)for(;;){const r=t.exec(g);if(!r)break;f.push([r.index,t.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(a="";;){const t=i.exec(g);if(!t)break;!l.test(t[0])&&f.every(([r,o])=>t.index<r||t.index>=o)&&(a+=g.substring(s,t.index)+"<REDACTED: user-file-path>",s=i.lastIndex)}return s<g.length&&(a+=g.substr(s)),a}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const a=g.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of f)if(l.regex.test(a))return`<REDACTED: ${l.label}>`;return g}_cleanupInfo(g,a){let f=g;a&&(f=this._anonymizeFilePaths(f));for(const l of this._cleanupPatterns)f=f.replace(l,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=pe([G(1,E.IConfigurationService),G(2,y.IProductService)],S),e.TelemetryService=S;function P(){const p=(0,I.localize)(0,null,C.default.nameLong),g=C.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=L.isWeb?"":(0,I.localize)(3,null),f=(0,I.localize)(4,null),l=(0,I.localize)(5,null),i=(0,I.localize)(6,null),s=(0,I.localize)(7,null),t=`
|       | ${f} | ${l} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${p} ${g} ${a}

&nbsp;

${s}
${t}

&nbsp;

${r}
`}m.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:P(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(b.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,I.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,I.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[222],re([0,1,277,221]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends n.AbstractOneDataSystemAppender{constructor(T,I,E,b){const C={sendPOST:(y,m)=>{const v={method:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data)}};try{const h=R.request(y.urlString,v,S=>{S.on("data",function(P){m(S.statusCode??200,S.headers,P.toString())}),S.on("error",function(P){m(0,{})})});h.write(y.data),h.end()}catch{m(0,{})}}};super(T,I,E,b,C)}}e.OneDataSystemAppender=D}),define(ne[223],re([0,1,20,66,19,15,8,26,23,105,106,107]),function(Q,e,R,n,D,L,T,I,E,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(h,S,P,p,g){this.configurationService=h,this.telemetryService=S,this.loggerService=P,this.environmentService=p,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(h){if(!this.customTelemetryServices.has(h.id)){const{machineId:S,sessionId:P}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=S,p["common.vscodesessionid"]=P;const g=[h.id,JSON.stringify(p),h.aiKey],f=new n.Client(R.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new b.TelemetryAppenderClient(f),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${h.id}] `)];this.customTelemetryServices.set(h.id,new y.TelemetryService({appenders:l,sendErrorTelemetry:h.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(h.id)}async publicLog(h,S,P){await(await this.getCustomTelemetryService(h)).publicLog(S,P)}async publicLogError(h,S,P){await(await this.getCustomTelemetryService(h)).publicLogError(S,P)}};m=pe([G(0,D.IConfigurationService),G(1,E.ITelemetryService),G(2,T.ILoggerService),G(3,L.IEnvironmentService),G(4,I.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(ne[224],re([0,1,6,22,3,2,8]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let I=class extends L.Disposable{constructor(b,C){super(),this._logService=C,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((C,y)=>{const m=++this._lastRequestId;this._pendingRequests.set(m,C),this._onCreateRequest.fire({requestId:m,...b});const v=new n.CancellationTokenSource;(0,R.timeout)(this._timeout,v.token).then(()=>y(`Request ${m} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(m,[(0,L.toDisposable)(()=>v.cancel())])})}acceptReply(b,C){const y=this._pendingRequests.get(b);y?(this._pendingRequests.delete(b),(0,L.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),y(C)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};I=pe([G(1,T.ILogService)],I),e.RequestStore=I}),define(ne[108],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(a){a.Shell="terminal.integrated.shell.",a.ShellArgs="terminal.integrated.shellArgs.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(a){a.ShellLinux="terminal.integrated.shell.linux",a.ShellMacOs="terminal.integrated.shell.osx",a.ShellWindows="terminal.integrated.shell.windows",a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationShellLinux="terminal.integrated.automationShell.linux",a.AutomationShellMacOs="terminal.integrated.automationShell.osx",a.AutomationShellWindows="terminal.integrated.automationShell.windows",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ShellArgsLinux="terminal.integrated.shellArgs.linux",a.ShellArgsMacOs="terminal.integrated.shellArgs.osx",a.ShellArgsWindows="terminal.integrated.shellArgs.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.CustomGlyphs="terminal.integrated.customGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(a){a.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var I;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash"})(I=e.WindowsShellType||(e.WindowsShellType={}));var E;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(E=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.Log="log",a.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var C;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var y;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var v;(function(a){a.TerminalView="view",a.Editor="editor"})(v=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var P;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(P=e.ProfileSource||(e.ProfileSource={}));var p;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(p=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[225],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(ne[226],re([0,1,37,20,31,12,4,36,25,14,28]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let l=0;return f&&f.length===4&&(l=parseInt(f[3])),l}e.getWindowsBuildNumber=y;async function m(f,l,i,s=I.env,t=C.Promises.exists){if(L.isAbsolute(f))return await t(f)?f:void 0;if(l===void 0&&(l=I.cwd()),L.dirname(f)!=="."){const u=L.join(l,f);return await t(u)?u:void 0}const o=(0,D.getCaseInsensitive)(s,"PATH");if(i===void 0&&(0,b.isString)(o)&&(i=o.split(L.delimiter)),i===void 0||i.length===0){const u=L.join(l,f);return await t(u)?u:void 0}for(const u of i){let d;if(L.isAbsolute(u)?d=L.join(u,f):d=L.join(l,u,f),await t(d))return d;if(T.isWindows){let w=d+".com";if(await t(w)||(w=d+".exe",await t(w)))return w}}const c=L.join(l,f);return await t(c)?c:void 0}e.findExecutable=m;function v(f,l,i,s){if(!l.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const t=f.args,r=I.platform==="win32"?L.basename(f.executable).toLowerCase():L.basename(f.executable),o=L.dirname(n.FileAccess.asFileUri("",Q).fsPath);let c;const u={VSCODE_INJECTION:"1"};if(T.isWindows){if(r==="pwsh.exe")return!t||g(t)?c=e.shellIntegrationArgs.get(h.WindowsPwsh):p(t)&&(c=e.shellIntegrationArgs.get(h.WindowsPwshLogin)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o,""),{newArgs:c,envMixin:u}):void 0;s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(r){case"bash":return!t||t.length===0?c=e.shellIntegrationArgs.get(h.Bash):a(t)&&(u.VSCODE_SHELL_LOGIN="1",c=e.shellIntegrationArgs.get(h.Bash)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o),{newArgs:c,envMixin:u}):void 0;case"pwsh":return!t||g(t)?c=e.shellIntegrationArgs.get(h.Pwsh):p(t)&&(c=e.shellIntegrationArgs.get(h.PwshLogin)),c?(c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o,""),{newArgs:c,envMixin:u}):void 0;case"zsh":{if(!t||t.length===0?c=e.shellIntegrationArgs.get(h.Zsh):a(t)?c=e.shellIntegrationArgs.get(h.ZshLogin):(t===e.shellIntegrationArgs.get(h.Zsh)||t===e.shellIntegrationArgs.get(h.ZshLogin))&&(c=t),!c)return;c=[...c],c[c.length-1]=(0,E.format)(c[c.length-1],o);const d=L.join(R.tmpdir(),`${R.userInfo().username}-vscode-zsh`);u.ZDOTDIR=d;const w=i?.ZDOTDIR??R.homedir();u.USER_ZDOTDIR=w;const A=[];return A.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(d,".zshrc")}),A.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(d,".zprofile")}),A.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(d,".zshenv")}),A.push({source:L.join(o,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(d,".zlogin")}),{newArgs:c,envMixin:u,filesToCopy:A}}}s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=v;var h;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(h=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),e.shellIntegrationArgs.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(h.Zsh,["-i"]),e.shellIntegrationArgs.set(h.ZshLogin,["-il"]),e.shellIntegrationArgs.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],P=["-nol","-nologo"];function p(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(P.includes(f[0].toLowerCase())||P.includes(f[1].toLowerCase()))}function g(f){return typeof f=="string"?P.includes(f.toLowerCase()):f.length===0||f?.length===1&&P.includes(f[0].toLowerCase())}function a(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(ne[227],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function n(L){return L===R.HIGH_CONTRAST_DARK||L===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function D(L){return L===R.DARK||L===R.HIGH_CONTRAST_DARK}e.isDark=D}),define(ne[109],re([0,1,50,3,2,5,40,227]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(P){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}P.isThemeColor=p})(E=e.ThemeColor||(e.ThemeColor={}));function b(P){return{id:P}}e.themeColorFromId=b;var C;(function(P){function p(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||E.isThemeColor(r.color))}P.isThemeIcon=p;const g=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function a(r){const o=g.exec(r);if(!o)return;const[,c]=o;return{id:c}}P.fromString=a;function f(r){return{id:r}}P.fromId=f;function l(r,o){let c=r.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),o&&(c=`${c}~${o}`),{id:c}}P.modify=l;function i(r){const o=r.id.lastIndexOf("~");if(o!==-1)return r.id.substring(o+1)}P.getModifier=i;function s(r,o){return r.id===o.id&&r.color?.id===o.color?.id}P.isEqual=s;function t(r,o){return{id:r.id,color:o?b(o):void 0}}P.asThemeIcon=t,P.asClassNameArray=R.CSSIcon.asClassNameArray,P.asClassName=R.CSSIcon.asClassName,P.asCSSSelector=R.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function y(P){switch(P){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case I.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,D.toDisposable)(()=>{const g=this.themingParticipants.indexOf(p);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const v=new m;T.Registry.add(e.Extensions.ThemingContribution,v);function h(P){return v.onColorThemeChange(P)}e.registerThemingParticipant=h;class S extends D.Disposable{constructor(p){super(),this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,g){let a=this.theme.getColor(p);return a&&g&&(a=g(a,this.theme)),a?a.toString():null}}e.Themable=S}),define(ne[228],re([0,1,50,7,160,109]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(m,v){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...m.map(S=>({name:S.profileName,description:I(S)}))),v&&h.push(...v.map(S=>({name:S.title,description:E(S)}))),{values:h.map(S=>S.name),markdownDescriptions:h.map(S=>S.description)}}e.createProfileSchemaEnums=T;function I(m){let v=`$(${L.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:R.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?v+=`
- args: "${m.args}"`:v+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(v+=`
- overrideName: ${m.overrideName}`),m.color&&(v+=`
- color: ${m.color}`),m.env&&(v+=`
- env: ${JSON.stringify(m.env)}`),v}function E(m){return`$(${L.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:R.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function b(m,v){if(!m&&!v)return!0;if(typeof m=="string"&&typeof v=="string")return m===v;if(Array.isArray(m)&&Array.isArray(v)){if(m.length!==v.length)return!1;for(let h=0;h<m.length;h++)if(m[h]!==v[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function C(m,v){if(!m&&!v)return!0;if(!m||!v)return!1;if(L.ThemeIcon.isThemeIcon(m)&&L.ThemeIcon.isThemeIcon(v))return m.id===v.id&&m.color===v.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof v=="object"&&"light"in v&&"dark"in v){const h=m,S=v;if((n.URI.isUri(h.light)||y(h.light))&&(n.URI.isUri(h.dark)||y(h.dark))&&(n.URI.isUri(S.light)||y(S.light))&&(n.URI.isUri(S.dark)||y(S.dark)))return h.light.path===S.light.path&&h.dark.path===S.dark.path}if(n.URI.isUri(m)&&n.URI.isUri(v)||y(m)||y(v)){const h=m,S=v;return h.path===S.path&&h.scheme===S.scheme}return!1}e.terminalIconsEqual=C;function y(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=y}),define(ne[229],re([0,1,50,159,42,40,228]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(R.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),f=>`$(${f.id})`)};const I={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...I}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...I}},C=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),y=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),v=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),P={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:y},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...I}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...I}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){L.Registry.as(D.Extensions.Configuration).registerConfiguration(P),a()}e.registerTerminalPlatformConfiguration=p;let g;function a(f,l){const i=L.Registry.as(D.Extensions.Configuration);let s;f&&(s=(0,T.createProfileSchemaEnums)(f?.profiles,l));const t=g;g={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?s?.values:void 0,markdownEnumDescriptions:f?.os===3?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?s?.values:void 0,markdownEnumDescriptions:f?.os===2?s?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?s?.values:void 0,markdownEnumDescriptions:f?.os===1?s?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=a}),define(ne[230],re([0,1,54,50,12,4,28,86,226,109]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,y=!0;function m(s,t,r,o,c=process.env,u,d,w,A){return u=u||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},L.isWindows?v(r,u,c,d,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),A,w):f(u,d,r,s&&typeof s=="object"?{...s}:o.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,w,c)}e.detectAvailableProfiles=m;async function v(s,t,r,o,c,u,d,w,A){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let M=!1;(0,E.getWindowsBuildNumber)()>=16299&&(M=!0),await P(w);const k=new Map;s&&(k.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),k.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),k.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(u,k);const F=await h(k.entries(),d,t,r,o,A);if(s||c)try{const $=await g(`${_}\\${M?"wsl":"bash"}.exe`,d);for(const q of $)(!u||!(q.profileName in u))&&F.push(q)}catch{y&&(o?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return F}async function h(s,t,r,o=process.env,c,u){const d=[];for(const[w,A]of s){if(A===null)continue;let O,_,M;if("source"in A){const $=C?.get(A.source);if(!$)continue;O=$.paths,_=A.args||$.args,A.icon?M=S(A.icon):$.icon&&(M=$.icon)}else O=Array.isArray(A.path)?A.path:[A.path],_=L.isWindows||Array.isArray(A.args)?A.args:void 0,M=S(A.icon);const k=await u?.(O)||O.slice(),F=await i(w,t,k,r,o,_,A.env,A.overrideName,A.isAutoDetected,c);F?(F.isAutoDetected=A.isAutoDetected,F.icon=M,F.color=A.color,d.push(F)):c?.debug("Terminal profile not validated",w,O)}return c?.debug("Validated terminal profiles",d),d}function S(s){return typeof s=="string"?{id:s}:s}async function P(s){C&&!s||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),C.set("PowerShell",{profileName:"PowerShell",paths:s||await p(),icon:b.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function p(){const s=[];for await(const t of(0,I.enumeratePowerShellInstallations)())s.push(t.exePath);return s}async function g(s,t){const r=[],o=await new Promise((d,w)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(A,O)=>{if(A)return w("Problem occurred when getting wsl distros");d(O)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),u=o.split(c).filter(d=>d.trim().length>0&&d!=="");for(const d of u){if(d===""||d.startsWith("docker-desktop"))continue;const w=`${d} (WSL)`,A={profileName:w,path:s,args:["-d",`${d}`],isDefault:w===t,icon:a(d),isAutoDetected:!1};r.push(A)}return r}function a(s){return s.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):s.includes("Debian")?b.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function f(s,t,r,o,c,u,d,w){const A=new Map;if(r){const O=(await s.readFile("/etc/shells")).toString(),_=u||O.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),M=new Map;for(const k of _){let F=(0,D.basename)(k),$=M.get(F)||0;$++,$>1&&(F=`${F} (${$})`),M.set(F,$),A.set(F,{path:k,isAutoDetected:!0})}}return l(o,A),await h(A.entries(),c,s,w,t,d)}function l(s,t){if(!!s)for(const[r,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?t.delete(r):(o.icon=o.icon||t.get(r)?.icon,t.set(r,o))}async function i(s,t,r,o,c,u,d,w,A,O){if(r.length===0)return Promise.resolve(void 0);const _=r.shift();if(_==="")return i(s,t,r,o,c,u,d,w,A);const M={profileName:s,path:_,args:u,env:d,overrideName:w,isAutoDetected:A,isDefault:s===t};if((0,D.basename)(_)===_){const F=c.PATH?c.PATH.split(D.delimiter):void 0,$=await(0,E.findExecutable)(_,void 0,F,void 0,o.existsFile);return $?(M.path=$,M.isFromPath=!0,M):i(s,t,r,o,c,u)}return await o.existsFile((0,D.normalize)(_))?M:i(s,t,r,o,c,u,d,w,A)}}),define(ne[231],re([0,1,3,2,20,4,39,66,19,15,90,217,8,98,224,108,229,230]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(l){l[l.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let a=0,f=class extends n.Disposable{constructor(i,s,t,r){super(),this._reconnectConstants=i,this._configurationService=s,this._environmentService=t,this._logService=r,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,P.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new h.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,y.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(i){return this._logService.error("ptyHost was unable to resolve shell environment",i),{}}}_startPtyHost(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:a,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},s=(0,C.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);s&&(s.break&&s.port?i.debugBrk=s.port:!s.break&&s.port&&(i.debug=s.port));const t=new I.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,i);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(u=>{this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const o=t.getChannel(S.TerminalIpcChannels.Log);v.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{v.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(u=>this._onProcessData.fire(u))),this._register(c.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(c.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(c.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(c.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(c.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(c.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(i,s,t,r,o,c,u,d,w,A,O){const _=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),M=await this._proxy.createProcess(i,s,t,r,o,c,u,d,w,A,O);return clearTimeout(_),a=Math.max(a,M),M}updateTitle(i,s,t){return this._proxy.updateTitle(i,s,t)}updateIcon(i,s,t,r){return this._proxy.updateIcon(i,s,t,r)}attachToProcess(i){return this._proxy.attachToProcess(i)}detachFromProcess(i,s){return this._proxy.detachFromProcess(i,s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(i){return this._proxy.start(i)}shutdown(i,s){return this._proxy.shutdown(i,s)}input(i,s){return this._proxy.input(i,s)}processBinary(i,s){return this._proxy.processBinary(i,s)}resize(i,s,t){return this._proxy.resize(i,s,t)}acknowledgeDataEvent(i,s){return this._proxy.acknowledgeDataEvent(i,s)}setUnicodeVersion(i,s){return this._proxy.setUnicodeVersion(i,s)}getInitialCwd(i){return this._proxy.getInitialCwd(i)}getCwd(i){return this._proxy.getCwd(i)}getLatency(i){return this._proxy.getLatency(i)}orphanQuestionReply(i){return this._proxy.orphanQuestionReply(i)}installAutoReply(i,s){return this._proxy.installAutoReply(i,s)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(i){return this._proxy.uninstallAutoReply(i)}getDefaultSystemShell(i){return this._proxy.getDefaultSystemShell(i)}async getProfiles(i,s,t,r=!1){const o=await this._shellEnv;return(0,p.detectAvailableProfiles)(s,t,r,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,i))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(i){return this._proxy.getWslPath(i)}getRevivedPtyNewId(i){return this._proxy.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this._proxy.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this._proxy.getTerminalLayoutInfo(i)}async requestDetachInstance(i,s){return this._proxy.requestDetachInstance(i,s)}async acceptDetachInstanceReply(i,s){return this._proxy.acceptDetachInstanceReply(i,s)}async serializeTerminalState(i){return this._proxy.serializeTerminalState(i)}async reviveTerminalProcesses(i,s){return this._proxy.reviveTerminalProcesses(i,s)}async refreshProperty(i,s){return this._proxy.refreshProperty(i,s)}async updateProperty(i,s,t){return this._proxy.updateProperty(i,s,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(i,s){return this._resolveVariablesRequestStore.createRequest({workspaceId:i,originalText:s})}async acceptPtyHostResolvedVariables(i,s){this._resolveVariablesRequestStore.acceptReply(i,s)}};f=pe([G(1,E.IConfigurationService),G(2,b.IEnvironmentService),G(3,m.ILogService)],f),e.PtyHostService=f}),define(ne[72],re([0,1,3,4,5,8]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var T;(function(S){S.Http="http",S.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const P=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!P)return{address:P[1],port:+P[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=y;function m(S,P){return P?P!==1&&S<1024:!n.isWindows&&S<1024}e.isPortPrivileged=m;class v{constructor(P,p,g){this.remoteAddress=P,this.localAddress=p,this._dispose=g,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=v;let h=class{constructor(P){this.logService=P,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(P){return this._tunnelProvider=P,P?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(P){this._canElevate=P.elevation,this._privacyOptions=P.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const P=[],p=Array.from(this._tunnels.values());for(const g of p){const a=Array.from(g.values());for(const f of a){const l=await f.value;l&&P.push(l)}}return P}async dispose(){for(const P of this._tunnels.values()){for(const{value:p}of P.values())await p.then(g=>g?.dispose());P.clear()}this._tunnels.clear()}openTunnel(P,p,g,a,f=!1,l,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${g} on local port ${a}.`),!P)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.retainOrCreateTunnel(P,p,g,a,f,l,i);return s?s.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(P){return{tunnelRemotePort:P.tunnelRemotePort,tunnelRemoteHost:P.tunnelRemoteHost,tunnelLocalPort:P.tunnelLocalPort,localAddress:P.localAddress,privacy:P.privacy,protocol:P.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${P.tunnelRemoteHost}:${P.tunnelRemotePort} `);const p=this._tunnels.get(P.tunnelRemoteHost);if(p){const g=p.get(P.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(P.tunnelRemoteHost,P.tunnelRemotePort,g))}}}}async tryDisposeTunnel(P,p,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${P}:${p}.`);const a=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(P)&&this._tunnels.get(P).delete(p),a}}async closeTunnel(P,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${P}:${p} `);const g=this._tunnels.get(P);if(g&&g.has(p)){const a=g.get(p);a.refcount=0,await this.tryDisposeTunnel(P,p,a)}}addTunnelToMap(P,p,g){this._tunnels.has(P)||this._tunnels.set(P,new Map),this._tunnels.get(P).set(p,{refcount:1,value:g})}async removeEmptyTunnelFromMap(P,p){const g=this._tunnels.get(P);g&&(await g.get(p)||g.delete(p),g.size===0&&this._tunnels.delete(P))}getTunnelFromMap(P,p){const g=[P];C(P)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):y(P)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const a=g.map(f=>this._tunnels.get(f));for(const f of a){const l=f?.get(p);if(l)return l}}canTunnel(P){return!!b(P)}createWithProvider(P,p,g,a,f,l,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${g} on local port ${a}.`);const s=g;this._factoryInProgress.add(s);const r={elevationRequired:f?m(a===void 0?g:a):!1},o={remoteAddress:{host:p,port:g},localAddressPort:a,privacy:l,public:l?l!==I.Private:void 0,protocol:i},c=P.forwardPort(o,r);return c?(this.addTunnelToMap(p,g,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(s)})):this._factoryInProgress.delete(s),c}};h=pe([G(0,L.ILogService)],h),e.AbstractTunnelService=h}),define(ne[232],re([0,1,8,72,2,9,6]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class I extends D.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(C){this._address=C,this._addressPromise&&(this._addressPromise.complete(C),this._addressPromise=null)}setTunnel(C){this._register(C)}}let E=class Ct extends D.Disposable{constructor(C,y){super(),this._tunnelService=C,this._logService=y,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(C,y,m,v,h,S){const P=new I,p=await Promise.resolve(this._tunnelService.openTunnel(C,P,m,v,h,S));if(!p)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${v} (remote).`),P.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(y))throw this._disposedTunnels.delete(y),P.dispose(),await p.dispose(),(0,L.canceled)();return P.setTunnel(p),this._tunnels.set(y,P),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${y}: ${p.localAddress} (local) to ${m}:${v} (remote).`),{tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress}}async setAddress(C,y){const m=this._tunnels.get(C);!m||m.setAddress(y)}async destroyTunnel(C){const y=this._tunnels.get(C);if(y){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this._tunnels.delete(C),await y.dispose();return}this._disposedTunnels.add(C)}};E._lastId=0,E=pe([G(0,n.ISharedTunnelsService),G(1,R.ILogService)],E),e.SharedProcessTunnelService=E}),define(ne[233],re([0,1,80,119,208,6,2,19,8,26,206,72,103]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function v(g,a,f,l,i){let s;for(let t=3;t&&(s?.dispose(),s=await new h(g,a,f,l,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));t--);return s}class h extends T.Disposable{constructor(a,f,l,i,s){super(),this.defaultTunnelHost=f,this.suggestedLocalPort=s,this.privacy=y.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=a,this._server=R.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let a=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(a=0,this._server.listen(a,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(a){a.pause();const f=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,C.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),i=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&a.write(s.buffer),a.on("end",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.end()}),a.on("close",()=>i.end()),a.on("error",()=>{a.localAddress&&this._socketsDispose.delete(a.localAddress),i.destroy()}),i.on("end",()=>a.end()),i.on("close",()=>a.end()),i.on("error",()=>{a.destroy()}),a.pipe(i),i.pipe(a),a.localAddress&&this._socketsDispose.set(a.localAddress,()=>{a.end(),i.end()})}}let S=class extends y.AbstractTunnelService{constructor(a,f,l,i,s){super(f),this.socketFactory=a,this.signService=l,this.productService=i,this.configurationService=s}get defaultTunnelHost(){const a=this.configurationService.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(a,f,l,i,s,t,r){const o=this.getTunnelFromMap(f,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,l,i,s,t,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${l} on local port ${i}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:a,signService:this.signService,logService:this.logService,ipcLogger:null},u=v(c,this.defaultTunnelHost,f,l,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,l,u),u}}};S=pe([G(1,E.ILogService),G(2,m.ISignService),G(3,b.IProductService),G(4,I.IConfigurationService)],S),e.BaseTunnelService=S;let P=class extends S{constructor(a,f,l,i){super(D.nodeSocketFactory,a,f,l,i)}};P=pe([G(0,E.ILogService),G(1,m.ISignService),G(2,b.IProductService),G(3,I.IConfigurationService)],P),e.TunnelService=P;let p=class extends T.Disposable{constructor(a,f,l,i){super(),this.logService=a,this.productService=f,this.signService=l,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(a,f,l,i,s,t,r,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${s}.`),!this._tunnelServices.has(a)){const c=new P(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(a,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(a))})}return this._tunnelServices.get(a).openTunnel(f,l,i,s,t,r,o)}};p=pe([G(0,E.ILogService),G(1,b.IProductService),G(2,m.ISignService),G(3,I.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ne[33],re([0,1,5]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ne[234],re([0,1,3,2,7,15,32,13,8,33]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let C=class extends n.Disposable{constructor(m,v,h,S,P){super(),this.extensionsManagementService=m,this.logService=S,this.uriIdentityService=P,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(g=>this.onInstallExtension(g))),this._register(m.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(m.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const p=D.URI.file(h.extensionsPath);this._register(v.watch(p)),this._register(R.Event.filter(v.onDidFilesChange,g=>g.rawChanges.some(a=>this.doesChangeAffects(a,p)))(()=>this.onDidChange()))}doesChangeAffects(m,v){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),v)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const v of m)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(v=>!(0,T.areSameExtensions)(v,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,T.areSameExtensions)(v,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),v=m.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(P=>(0,T.areSameExtensions)(P,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),h=this.installedExtensions.filter(S=>this.installingExtensions.some(P=>(0,T.areSameExtensions)(P,S))?!1:m.every(P=>!(0,T.areSameExtensions)(P.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=m.map(S=>S.identifier),(v.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:h})}}};C=pe([G(1,I.IFileService),G(2,L.INativeEnvironmentService),G(3,E.ILogService),G(4,b.IUriIdentityService)],C),e.ExtensionsWatcher=C}),define(ne[235],re([0,1,33,91,13,17,117,3,2]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(m){this.uri=m,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let C=class{constructor(m){this._fileService=m,this._dispooables=new E.DisposableStore,this._limit=2**16;const v=new Map,h=S=>{let P=v.get(S.scheme);return P===void 0&&(P=m.hasProvider(S)&&!this._fileService.hasCapability(S,1024),v.set(S.scheme,P)),P};this._dispooables.add(I.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(S=>{v.delete(S.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new T.SkipList((S,P)=>this.extUri.compare(S,P,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,L.normalizePath)(m));const v=this._canonicalUris.get(m);return v?v.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new b(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((h,S)=>h[1].touch<S[1].touch?1:h[1].touch>S[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let h=0;h<v;h++)this._canonicalUris.set(m[h][0],m[h][1].touch())}};C=pe([G(0,D.IFileService)],C),e.UriIdentityService=C,(0,n.registerSingleton)(R.IUriIdentityService,C,!0)}),define(ne[236],re([0,1,3,2,13,41,34,16]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class E extends n.Disposable{constructor(C,y,m,v){super(),this.fileSystemScheme=C,this.fileSystemProvider=y,this.userDataScheme=m,this.logService=v,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&-5}watch(C,y){this.watchResources.set(C,C);const m=this.fileSystemProvider.watch(this.toFileSystemResource(C),y);return(0,n.toDisposable)(()=>{this.watchResources.delete(C),m.dispose()})}stat(C){return this.fileSystemProvider.stat(this.toFileSystemResource(C))}mkdir(C){return this.fileSystemProvider.mkdir(this.toFileSystemResource(C))}rename(C,y,m){return this.fileSystemProvider.rename(this.toFileSystemResource(C),this.toFileSystemResource(y),m)}readFile(C){return this.fileSystemProvider.readFile(this.toFileSystemResource(C),{atomic:!0})}readFileStream(C,y,m){const v=(0,L.newWriteableStream)(h=>I.VSBuffer.concat(h.map(S=>I.VSBuffer.wrap(S))).buffer);return(async()=>{try{const h=await this.readFile(C);v.end(h)}catch(h){v.error(h),v.end()}})(),v}readdir(C){return this.fileSystemProvider.readdir(this.toFileSystemResource(C))}writeFile(C,y,m){return this.fileSystemProvider.writeFile(this.toFileSystemResource(C),y,m)}delete(C,y){return this.fileSystemProvider.delete(this.toFileSystemResource(C),y)}copy(C,y,m){if((0,D.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(C),this.toFileSystemResource(y),m);throw new Error("copy not supported")}handleFileChanges(C){const y=[];for(const m of C){if(m.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(m.resource);this.watchResources.findSubstr(v)&&y.push({resource:v,type:m.type})}y.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(y))}toFileSystemResource(C){return C.with({scheme:this.fileSystemScheme})}toUserDataResource(C){return C.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=E}),define(ne[61],re([0,1,79]),function(Q,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,I,E,b){const C=(0,R.setProperty)(T,I,E,b)[0];return C&&(T=T.substring(0,C.offset)+C.content+T.substring(C.offset+C.length)),T}e.edit=n;function D(T,I,E){let b=E;for(;b>=0;){if(T.charAt(b)===I.charAt(I.length-1)&&I.length===1)return b+1;if(b--,I.length===2&&b>=0&&T.charAt(b)===I.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function L(T,I,E){let b=E;for(;b>=0;)if(T.charAt(b)===I.charAt(I.length-1)&&I.length===1||(b++,I.length===2&&b>=0&&T.charAt(b)===I.charAt(1)))return b;return T.length-1}e.getLineEndOffset=L}),define(ne[237],re([0,1,31,55,14]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(m,v,h,S,P){const p=[],g=[],a=[];if(!v){const _=m.filter(({identifier:M})=>P.every(k=>k.toLowerCase()!==M.id.toLowerCase()));return{local:{added:p,removed:g,updated:a},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}m=m.map(C),v=v.map(C),h=h?h.map(C):null;const f=new Map,l=_=>{_.uuid&&f.set(_.id.toLowerCase(),_.uuid)};m.forEach(({identifier:_})=>l(_)),v.forEach(({identifier:_})=>l(_)),h?.forEach(({identifier:_})=>l(_));const i=_=>{const M=_.identifier.uuid||f.get(_.identifier.id.toLowerCase());return M?`uuid:${M}`:`id:${_.identifier.id.toLowerCase()}`},s=(_,M)=>(_.set(i(M),M),_),t=m.reduce(s,new Map),r=v.reduce(s,new Map),o=v.reduce((_,M)=>{const k=i(M);M=(0,R.deepClone)(M);const F=t.get(k);return F&&(F.installed&&(M.installed=!0),M.version||(M.version=F.version)),s(_,M)},new Map),c=h?h.reduce(s,new Map):null,u=S.reduce(s,new Map),d=P.reduce((_,M)=>{const k=f.get(M.toLowerCase());return _.add(k?`uuid:${k}`:`id:${M.toLowerCase()}`)},new Set),w=T(t,r,d);if(w.added.size>0||w.removed.size>0||w.updated.size>0){const _=T(c,t,d),M=T(c,r,d),k=(F,$)=>{const q=t.get(F);if(q){const J=r.get(F),H=$?J:q;return{...H,version:J.version&&(!q.installed||n.gt(J.version,q.version))?J.version:q.version,state:I(q,J,c?.get(F)),preRelease:(0,D.isUndefined)(H.preRelease)?q.preRelease:q.installed?H.preRelease:J.preRelease}}};for(const F of M.removed.values()){const $=t.get(F);$&&g.push($.identifier)}for(const F of M.added.values())if(_.added.has(F)){if(w.updated.has(F)){const $=k(F,!0);$&&(a.push(y($,F)),o.set(F,$))}}else{const $=r.get(F);$.installed&&p.push(y($,F))}for(const F of M.updated.values()){const $=k(F,!0);$&&(a.push(y($,F)),o.set(F,$))}for(const F of _.added.values())M.added.has(F)||o.set(F,t.get(F));for(const F of _.updated.values())if(!M.removed.has(F)&&!M.updated.has(F)){const $=k(F,!1);$&&(o.get(F)?.installed&&($.installed=!0),o.set(F,$))}for(const F of _.removed.values())!u.has(F)&&!M.updated.has(F)&&c?.get(F)?.installed&&o.delete(F)}const A=[],O=T(r,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&o.forEach((_,M)=>A.push(y(_,M))),{local:{added:p,removed:g,updated:a},remote:A.length?{added:[...O.added].map(_=>o.get(_)),updated:[...O.updated].map(_=>o.get(_)),removed:[...O.removed].map(_=>r.get(_)),all:A}:null}}e.merge=L;function T(m,v,h,{checkInstalledProperty:S,checkVersionProperty:P}={checkInstalledProperty:!1,checkVersionProperty:!1}){const p=m?[...m.keys()].filter(i=>!h.has(i)):[],g=[...v.keys()].filter(i=>!h.has(i)),a=g.filter(i=>p.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),f=p.filter(i=>g.indexOf(i)===-1).reduce((i,s)=>(i.add(s),i),new Set),l=new Set;for(const i of p){if(f.has(i))continue;const s=m.get(i),t=v.get(i);(!t||s.disabled!==t.disabled||s.installed&&t.installed&&s.preRelease!==t.preRelease||!b(s.state,t.state)||P&&s.version!==t.version||S&&s.installed!==t.installed)&&l.add(i)}return{added:a,removed:f,updated:l}}function I(m,v,h){const S=m.state,P=v.state,p=h?.state;if(!v.version||S&&n.gt(m.version,v.version))return S;if(P&&n.gt(v.version,m.version)||!S)return P;if(!P)return S;const g=(0,R.deepClone)(S),a=p?E(p,P):{added:Object.keys(P).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set},f=p?E(p,S):{added:Object.keys(S).reduce((l,i)=>(l.add(i),l),new Set),removed:new Set,updated:new Set};for(const l of[...a.added.values(),...a.updated.values()])g[l]=P[l];for(const l of a.removed.values())f.updated.has(l)||delete g[l];return g}function E(m,v){const h=Object.keys(m),S=Object.keys(v),P=S.filter(a=>h.indexOf(a)===-1).reduce((a,f)=>(a.add(f),a),new Set),p=h.filter(a=>S.indexOf(a)===-1).reduce((a,f)=>(a.add(f),a),new Set),g=new Set;for(const a of h){if(p.has(a))continue;const f=m[a],l=v[a];(0,R.equals)(f,l)||g.add(a)}return{added:P,removed:p,updated:g}}function b(m={},v={}){const{added:h,removed:S,updated:P}=E(m,v);return h.size===0&&S.size===0&&P.size===0}function C(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function y(m,v){const h={identifier:{id:m.identifier.id,uuid:v.startsWith("uuid:")?v.substring(5):void 0},preRelease:!!m.preRelease};return m.version&&(h.version=m.version),m.disabled&&(h.disabled=!0),m.installed&&(h.installed=!0),m.state&&(h.state=m.state),h}}),define(ne[110],re([0,1,18,19,5]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(I){this.configurationService=I}hasToNeverSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.getConfiguredIgnoredExtensions().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return b=b.filter(C=>C!==I&&C!==`-${I}`),E&&b.push(I.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(I,E){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return b=b.filter(C=>C!==I&&C!==`-${I}`),E&&b.push(`-${I.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(I){const E=I.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(m=>m.toLowerCase()),C=[],y=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?y.push(m.substring(1)):C.push(m);return(0,R.distinct)([...E,...C].filter(m=>y.indexOf(m)===-1))}getConfiguredIgnoredExtensions(){let I=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.configurationService.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};L=pe([G(0,n.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(ne[238],re([0,1,18,35,31,178,61]),function(Q,e,R,n,D,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function I(f){return(0,n.parse)(f)||[]}e.parseKeybindings=I;async function E(f,l,i,s,t){const r=I(f),o=I(l),c=i?I(i):null,u=[...r,...o,...c||[]].map(J=>J.key),d=await t.resolveUserBindings(u),w=C(r,o,c,d);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const A=m(r),O=m(o),_=c?m(c):null,M=h(A,O,d),k=_?h(_,A,d):{added:[...A.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},F=_?h(_,O,d):{added:[...O.keys()].reduce((J,H)=>(J.add(H),J),new Set),removed:new Set,updated:new Set},$=b(M,k,F);let q=f;for(const J of $.removed.values())$.conflicts.has(J)||(q=g(q,J,s));for(const J of $.added.values()){if($.conflicts.has(J))continue;const H=O.get(J);if(H.some(K=>K.command!==`-${J}`&&w.conflicts.has(d[K.key]))){$.conflicts.add(J);continue}q=p(q,H,s)}for(const J of $.updated.values()){if($.conflicts.has(J))continue;const H=O.get(J);if(H.some(K=>K.command!==`-${J}`&&w.conflicts.has(d[K.key]))){$.conflicts.add(J);continue}q=a(q,J,H,s)}return{mergeContent:q,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=E;function b(f,l,i){const s=new Set,t=new Set,r=new Set,o=new Set;for(const c of l.removed.values())i.updated.has(c)&&o.add(c);for(const c of i.removed.values())o.has(c)||(l.updated.has(c)?o.add(c):t.add(c));for(const c of l.added.values())o.has(c)||i.added.has(c)&&f.updated.has(c)&&o.add(c);for(const c of i.added.values())o.has(c)||(l.added.has(c)?f.updated.has(c)&&o.add(c):s.add(c));for(const c of l.updated.values())o.has(c)||i.updated.has(c)&&f.updated.has(c)&&o.add(c);for(const c of i.updated.values())o.has(c)||(l.updated.has(c)?f.updated.has(c)&&o.add(c):r.add(c));return{added:s,removed:t,updated:r,conflicts:o}}function C(f,l,i,s){const t=new Set,r=y(f,s),o=y(l,s),c=i?y(i,s):null,u=v(r,o);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const d=c?v(c,r):{added:[...r.keys()].reduce((k,F)=>(k.add(F),k),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const w=c?v(c,o):{added:[...o.keys()].reduce((k,F)=>(k.add(F),k),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:A,removed:O,updated:_,conflicts:M}=b(u,d,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:_,conflicts:M}}function y(f,l){const i=new Map;for(const s of f){const t=l[s.key];let r=i.get(t);r||(r=[],i.set(t,r)),r.push(s)}return i}function m(f){const l=new Map;for(const i of f){const s=i.command[0]==="-"?i.command.substring(1):i.command;let t=l.get(s);t||(t=[],l.set(s,t)),t.push(i)}return l}function v(f,l){const i=[...f.keys()],s=[...l.keys()],t=s.filter(c=>i.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),r=i.filter(c=>s.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),o=new Set;for(const c of i){if(r.has(c))continue;const u=f.get(c).map(w=>({...w,key:c})),d=l.get(c).map(w=>({...w,key:c}));(0,R.equals)(u,d,(w,A)=>P(w,A))||o.add(c)}return{added:t,removed:r,updated:o}}function h(f,l,i){const s=[...f.keys()],t=[...l.keys()],r=t.filter(u=>s.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),o=s.filter(u=>t.indexOf(u)===-1).reduce((u,d)=>(u.add(d),u),new Set),c=new Set;for(const u of s){if(o.has(u))continue;const d=f.get(u).map(A=>({...A,key:i[A.key]})),w=l.get(u).map(A=>({...A,key:i[A.key]}));S(d,w)||c.add(u)}return{added:r,removed:o,updated:c}}function S(f,l){return!(!(0,R.equals)(f.filter(({command:i})=>i[0]!=="-"),l.filter(({command:i})=>i[0]!=="-"),(i,s)=>P(i,s))||!(0,R.equals)(f.filter(({command:i})=>i[0]==="-"),l.filter(({command:i})=>i[0]==="-"),(i,s)=>P(i,s)))}function P(f,l){if(f.command!==l.command||f.key!==l.key)return!1;const i=L.ContextKeyExpr.deserialize(f.when),s=L.ContextKeyExpr.deserialize(l.when);return!(i&&!s||!i&&s||i&&s&&!i.equals(s)||!D.equals(f.args,l.args))}function p(f,l,i){for(const s of l)f=T.edit(f,[-1],s,i);return f}function g(f,l,i){const s=I(f);for(let t=s.length-1;t>=0;t--)(s[t].command===l||s[t].command===`-${l}`)&&(f=T.edit(f,[t],void 0,i));return f}function a(f,l,i,s){const t=I(f),r=t.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=t.length-1;o>=0;o--)(t[o].command===l||t[o].command===`-${l}`)&&(f=T.edit(f,[o],void 0,s));for(let o=i.length-1;o>=0;o--)f=T.edit(f,[r],i[o],s);return f}}),define(ne[239],re([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(L,T,I){const E={},b={},C=new Set;if(!T)return{local:{added:E,updated:b,removed:[...C.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const y=n(L,T);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:E,updated:b,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=n(I,L),v=n(I,T),h={},S={},P=new Set,p=new Set;for(const g of m.removed.values())v.updated.has(g)?E[g]=T[g]:P.add(g);for(const g of v.removed.values())p.has(g)||(m.updated.has(g)?p.add(g):C.add(g));for(const g of m.updated.values())p.has(g)||(v.updated.has(g)?y.updated.has(g)&&p.add(g):S[g]=L[g]);for(const g of v.updated.values())p.has(g)||(m.updated.has(g)?y.updated.has(g)&&p.add(g):L[g]!==void 0&&(b[g]=T[g]));for(const g of m.added.values())p.has(g)||(v.added.has(g)?y.updated.has(g)&&p.add(g):h[g]=L[g]);for(const g of v.added.values())p.has(g)||(m.added.has(g)?y.updated.has(g)&&p.add(g):E[g]=T[g]);return{local:{added:E,removed:[...C.values()],updated:b},remote:{added:h,removed:[...P.values()],updated:S},conflicts:[...p.values()]}}e.merge=R;function n(L,T){const I=L?Object.keys(L):[],E=T?Object.keys(T):[],b=E.filter(m=>I.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),C=I.filter(m=>E.indexOf(m)===-1).reduce((m,v)=>(m.add(v),m),new Set),y=new Set;for(const m of I){if(C.has(m))continue;const v=L[m],h=T[m];v!==h&&y.add(m)}return{added:b,removed:C,updated:y}}function D(L,T){const{added:I,removed:E,updated:b}=n(L,T);return I.size===0&&E.size===0&&b.size===0}e.areSame=D}),define(ne[27],re([0,1,18,17,14,166,42,29,5,100,40]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function y(){const c=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(u=>!!c[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=y;function m(){const c=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(c).filter(A=>!!c[A].ignoreSync),d=Object.keys(c).filter(A=>c[A].scope===2||c[A].scope===6),w=y();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...d,...w])}e.getDefaultIgnoredSettings=m,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function v(){const c="vscode://schemas/ignoredSettings",u=C.Registry.as(T.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:I.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=C.Registry.as(b.Extensions.JSONContribution),w=()=>{const A=y(),O=m().filter(F=>F!==e.CONFIGURATION_SYNC_STORE_KEY),_=Object.keys(T.allSettings.properties).filter(F=>O.indexOf(F)===-1),M=O.filter(F=>A.indexOf(F)===-1),k={items:{type:"string",enum:[..._,...M.map(F=>`-${F}`)]}};d.registerSchema(c,k)};return u.onDidUpdateConfiguration(()=>w())}e.registerConfiguration=v;function h(c){return c&&(0,D.isObject)(c)&&(0,D.isString)(c.id)&&Array.isArray(c.scopes)}e.isAuthenticationProvider=h;var S;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function P(c,u,d){return d.joinPath(u.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=P,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(c){const u={};return u[e.HEADER_EXECUTION_ID]=c,u}e.createSyncHeaders=p;var g;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoCollection="NoCollection",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class a extends Error{constructor(u,d,w,A){super(u),this.code=d,this.resource=w,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=a;class f extends a{constructor(u,d,w,A,O){super(u,w,void 0,O),this.url=d,this.serverCode=A}}e.UserDataSyncStoreError=f;class l extends a{constructor(u,d){super(u,d)}}e.UserDataAutoSyncError=l,function(c){function u(d){if(d instanceof c)return d;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(w&&w[1]){const A=w[2]==="unknown"?void 0:w[2],O=w[3]==="unknown"?void 0:w[3];return new c(d.message,w[1],A,O)}return new c(d.message,"Unknown")}c.toUserDataSyncError=u}(a=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var s;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var t;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(c){return`sync.enable.${c}`}e.getEnablementKey=r,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(c,u){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,n.isEqualOrParent)(c,(0,n.joinPath)(u.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[240],re([0,1,31,27]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(I,E,b,C,y){if(!E)return{remote:Object.keys(I).length>0?I:null,local:{added:{},removed:[],updated:{}}};const m=L(I,E);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const v=b?L(b,E):{added:Object.keys(E).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},h=b?L(b,I):{added:Object.keys(I).reduce((g,a)=>(g.add(a),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},P=R.deepClone(E),p=!b;for(const g of h.added.values())g!==n.SYNC_SERVICE_URL_TYPE&&p&&v.added.has(g)||(P[g]=I[g]);for(const g of h.updated.values())P[g]=I[g];for(const g of h.removed.values())C.unregistered.includes(g)||delete P[g];for(const g of v.added.values()){const a=E[g];if(C.machine.includes(g)){y.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(g))continue;const f=I[g];f&&f.value===a.value||g===n.SYNC_SERVICE_URL_TYPE&&p&&h.added.has(g)||(f?S.updated[g]=a:S.added[g]=a)}for(const g of v.updated.values()){const a=E[g];if(C.machine.includes(g)){y.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(g)||h.removed.has(g))continue;const f=I[g];f&&f.value===a.value||(S.updated[g]=a)}for(const g of v.removed.values()){if(C.machine.includes(g)){y.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}h.updated.has(g)||h.removed.has(g)||S.removed.push(g)}return{local:S,remote:T(P,E)?null:P}}e.merge=D;function L(I,E){const b=Object.keys(I),C=Object.keys(E),y=C.filter(h=>b.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),m=b.filter(h=>C.indexOf(h)===-1).reduce((h,S)=>(h.add(S),h),new Set),v=new Set;for(const h of b){if(m.has(h))continue;const S=I[h],P=E[h];R.equals(S,P)||v.add(h)}return{added:y,removed:m,updated:v}}function T(I,E){const{added:b,removed:C,updated:y}=L(I,E);return b.size===0&&C.size===0&&y.size===0}}),define(ne[241],re([0,1,18,35,79,52,31,61,27]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function b(u,d,w){let A=[];w?A=y(w):A=C(d);const O=[],_=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(A))for(const M of A)M.startsWith("-")?_.push(M.substring(1)):O.push(M);return(0,R.distinct)([...u,...O].filter(M=>_.indexOf(M)===-1))}e.getIgnoredSettings=b;function C(u){let d=u.inspect("settingsSync.ignoredSettings").userValue;return d!==void 0||(d=u.inspect("sync.ignoredSettings").userValue,d!==void 0)?d:u.getValue("settingsSync.ignoredSettings")||[]}function y(u){const d=(0,n.parse)(u);return d?d["settingsSync.ignoredSettings"]||d["sync.ignoredSettings"]||[]:[]}function m(u,d){const w=(0,n.parse)(u)||{};let A="{}";for(const O of Object.keys(w)){const _=(0,D.setProperty)(A,[O],w[O],d);A=(0,D.applyEdits)(A,_)}return A}e.removeComments=m;function v(u,d,w,A){if(w.length){const O=c(d),_=(0,n.parse)(d)||{},M=(0,n.parse)(u);if(!M)return u;const k=[];for(const F of w){const $=_[F],q=M[F];$===void 0?u=I.edit(u,[F],void 0,A):q!==void 0?u=I.edit(u,[F],$,A):k.push(i(F,O))}k.sort((F,$)=>F.startOffset-$.startOffset),k.forEach(F=>u=g(F.setting.key,d,u,A))}return u}e.updateIgnoredSettings=v;function h(u,d,w,A,O,_){const M=v(u,d,A,_),k=w!==M,F=w!==d;if(!k&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(k&&!F)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(F&&!k)return{conflictsSettings:[],localContent:v(d,u,A,_),remoteContent:null,hasConflicts:!1};if(w===null&&P(u)){const x=S(u,d,A)?null:v(d,u,A,_);return{conflictsSettings:[],localContent:x,remoteContent:null,hasConflicts:!1}}let $=u,q=d;const J=(0,n.parse)(u),H=(0,n.parse)(d),K=w?(0,n.parse)(w):null,W=A.reduce((x,Z)=>(x.add(Z),x),new Set),B=p(J,H,W),Y=p(K,J,W),te=p(K,H,W),ce=new Map,z=new Set,V=x=>{z.add(x);const Z=O.filter(({key:oe})=>oe===x)[0];Z?($=I.edit($,[x],Z.value,_),q=I.edit(q,[x],Z.value,_)):ce.set(x,{key:x,localValue:J[x],remoteValue:H[x]})};for(const x of Y.removed.values())te.updated.has(x)?V(x):q=I.edit(q,[x],void 0,_);for(const x of te.removed.values())z.has(x)||(Y.updated.has(x)?V(x):$=I.edit($,[x],void 0,_));for(const x of Y.updated.values())z.has(x)||(te.updated.has(x)?B.updated.has(x)&&V(x):q=I.edit(q,[x],J[x],_));for(const x of te.updated.values())z.has(x)||(Y.updated.has(x)?B.updated.has(x)&&V(x):$=I.edit($,[x],H[x],_));for(const x of Y.added.values())z.has(x)||(te.added.has(x)?B.updated.has(x)&&V(x):q=g(x,$,q,_));for(const x of te.added.values())z.has(x)||(Y.added.has(x)?B.updated.has(x)&&V(x):$=g(x,q,$,_));const U=ce.size>0||!S($,q,A),N=U||!S($,u,[]),j=U||!S(q,d,[]);return{localContent:N?$:null,remoteContent:j?q:null,conflictsSettings:[...ce.values()],hasConflicts:U}}e.merge=h;function S(u,d,w){if(u===d)return!0;const A=(0,n.parse)(u),O=(0,n.parse)(d),_=w.reduce((F,$)=>(F.add($),F),new Set),M=c(u).filter(F=>!(F.setting&&_.has(F.setting.key))),k=c(d).filter(F=>!(F.setting&&_.has(F.setting.key)));if(M.length!==k.length)return!1;for(let F=0;F<M.length;F++){const $=M[F],q=k[F];if($.setting&&q.setting){if($.setting.key!==q.setting.key||!T.equals(A[$.setting.key],O[$.setting.key]))return!1}else if(!$.setting&&!q.setting){if($.value!==q.value)return!1}else return!1}return!0}e.areSame=S;function P(u){return u?c(u).length===0:!0}e.isEmpty=P;function p(u,d,w){const A=u?Object.keys(u).filter(F=>!w.has(F)):[],O=Object.keys(d).filter(F=>!w.has(F)),_=O.filter(F=>A.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),M=A.filter(F=>O.indexOf(F)===-1).reduce((F,$)=>(F.add($),F),new Set),k=new Set;if(u)for(const F of A){if(M.has(F))continue;const $=u[F],q=d[F];T.equals($,q)||k.add(F)}return{added:_,removed:M,updated:k}}function g(u,d,w,A){const O=(0,n.parse)(d),_=c(d),M=c(w),k=a(u,_,M);return f(w,u,O[u],k,M,A)}e.addSetting=g;function a(u,d,w){const A=d.findIndex(_=>_.setting?.key===u),O=d[A-1];if(O){if(O.setting){const M=i(O.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!0}}else{const M=s(A,d);if(M){const k=i(M.setting.key,w);if(k){const F=t(w.indexOf(k),w),$=r(d,M,d[A]);if(F){const q=r(w,k,F),J=o($,q);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.indexOf(F),insertAfter:!1}}else{const q=r(w,k,w[w.length-1]),J=o($,q);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const _=d[A+1];if(_)if(_.setting){const M=i(_.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!1}}else{const M=t(A,d);if(M){const k=i(M.setting.key,w);if(k){const F=s(w.indexOf(k),w),$=r(d,d[A],M);if(F){const q=r(w,F,k),J=o($.reverse(),q.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:w.indexOf(F),insertAfter:!0}}else{const q=r(w,w[0],k),J=o($.reverse(),q.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function f(u,d,w,A,O,_){let M;return A.index===-1?M=(0,D.setProperty)(u,[d],w,_):M=l(u,d,w,A,O,_).map(k=>(0,D.withFormatting)(u,k,_)[0]),(0,D.applyEdits)(u,M)}function l(u,d,w,A,O,_){const M=`${JSON.stringify(d)}: ${JSON.stringify(w)}`,k=(0,L.getEOL)(_,u),F=O[A.index];if(A.insertAfter){const $=[];if(F.setting)$.push({offset:F.endOffset,length:0,content:","+M});else{const q=t(A.index,O),J=s(A.index,O),H=J?.setting?.commaOffset;J&&H===void 0&&$.push({offset:J.endOffset,length:0,content:","});const K=H!==void 0&&H>F.endOffset;$.push({offset:K?H+1:F.endOffset,length:0,content:q?k+M+",":k+M})}return $}else{if(F.setting)return[{offset:F.startOffset,length:0,content:M+","}];const $=(O[A.index-1]&&!O[A.index-1].setting?k:"")+M+(t(A.index,O)?",":"")+k;return[{offset:F.startOffset,length:0,content:$}]}}function i(u,d){return d.filter(w=>w.setting?.key===u)[0]}function s(u,d){for(let w=u-1;w>=0;w--)if(d[w].setting)return d[w]}function t(u,d){for(let w=u+1;w<d.length;w++)if(d[w].setting)return d[w]}function r(u,d,w){const A=u.indexOf(d),O=u.indexOf(w);return u.filter((_,M)=>A<M&&M<O)}function o(u,d){if(u.length&&d.length){let w=0;for(;w<d.length&&w<u.length;w++)if(u[w].value!==d[w].value)return d[w-1];return d[w-1]}}function c(u){const d=[];let w=-1,A,O;const _={onObjectBegin:M=>{w++},onObjectProperty:(M,k,F)=>{w===0&&(A=k,O=M)},onObjectEnd:(M,k)=>{w--,w===0&&d.push({startOffset:A,endOffset:M+k,value:u.substring(A,M+k),setting:{key:O,commaOffset:void 0}})},onArrayBegin:(M,k)=>{w++},onArrayEnd:(M,k)=>{w--,w===0&&d.push({startOffset:A,endOffset:M+k,value:u.substring(A,M+k),setting:{key:O,commaOffset:void 0}})},onLiteralValue:(M,k,F)=>{w===0&&d.push({startOffset:A,endOffset:k+F,value:u.substring(A,k+F),setting:{key:O,commaOffset:void 0}})},onSeparator:(M,k,F)=>{if(w===0&&M===","){let $=d.length-1;for(;$>=0&&!d[$].setting;$--);const q=d[$];q&&d.splice($,1,{startOffset:q.startOffset,endOffset:q.endOffset,value:q.value,setting:{key:q.setting.key,commaOffset:k}})}},onComment:(M,k)=>{w===0&&d.push({startOffset:M,endOffset:M+k,value:u.substring(M,M+k)})}};return(0,n.visit)(u,_),d}}),define(ne[73],re([0,1,3,2,5,27]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{constructor(E,b){super(),this.userDataSyncStoreService=E,this.logService=b,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};T=pe([G(0,L.IUserDataSyncStoreService),G(1,L.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[242],re([0,1,6,16,63,2,17,19,15,13,27]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let y=class extends L.Disposable{constructor(v,h,S,P){super(),this.environmentService=v,this.fileService=h,this.configurationService=S,this.logService=P,C.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(v){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,v),S=await this.fileService.resolve(h);return S.children?S.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(v,h){if(!h){const S=await this.getAllRefs(v);S.length&&(h=S[S.length-1].ref)}if(h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,v,h);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(v,h){const S=(0,T.joinPath)(this.environmentService.userDataSyncHome,v),P=(0,T.joinPath)(S,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(P,n.VSBuffer.fromString(h))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(v)}catch{}}async cleanUpBackup(v){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,v);try{try{if(!await this.fileService.exists(h))return}catch{return}const S=await this.fileService.resolve(h);if(S.children){const P=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=P.filter(f=>Date.now()-this.getCreationTime(f)>p);const a=P.length-g.length;a<10&&(g=g.slice(10-a)),await R.Promises.settled(g.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(v){return v.ctime||new Date(parseInt(v.name.substring(0,4)),parseInt(v.name.substring(4,6))-1,parseInt(v.name.substring(6,8)),parseInt(v.name.substring(9,11)),parseInt(v.name.substring(11,13)),parseInt(v.name.substring(13,15))).getTime()}};y=pe([G(0,E.IEnvironmentService),G(1,b.IFileService),G(2,I.IConfigurationService),G(3,C.IUserDataSyncLogService)],y),e.UserDataSyncBackupStoreService=y}),define(ne[243],re([0,1,2,7]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(m){this.service=m}listen(m,v){switch(v){case"onError":return this.service.onError}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class L{constructor(m){this.service=m}listen(m,v){throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class T{constructor(m){this.channel=m}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.channel.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.channel.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=T;class I{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${v}`)}async call(m,v,h){switch(v){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablements":return this.service.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=I;class E{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class b{constructor(m){this.service=m}listen(m,v){switch(v){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${v}`)}call(m,v,h){switch(v){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class C extends R.Disposable{constructor(m){super(),this.channel=m,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.channel.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(m)}revive(m){return{url:n.URI.revive(m.url),type:m.type,defaultUrl:n.URI.revive(m.defaultUrl),insidersUrl:n.URI.revive(m.insidersUrl),stableUrl:n.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(ne[244],re([0,1,15,8]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends n.AbstractLogger{constructor(T,I){super(),this.logger=this._register(T.createLogger(I.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...I){this.logger.trace(T,...I)}debug(T,...I){this.logger.debug(T,...I)}info(T,...I){this.logger.info(T,...I)}warn(T,...I){this.logger.warn(T,...I)}error(T,...I){this.logger.error(T,...I)}critical(T,...I){this.logger.critical(T,...I)}flush(){this.logger.flush()}};D=pe([G(0,n.ILoggerService),G(1,R.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(ne[245],re([0,1,3,2,7,27]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class T{constructor(C,y){this.service=C,this.logService=y,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(C,y){switch(y){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${y}`)}async call(C,y,m){try{return await this._call(C,y,m)}catch(v){throw this.logService.error(v),v}}async _call(C,y,m){switch(y){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(D.URI.revive(m[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(m[0],D.URI.revive(m[1]),m[2],m[3]);case"resolveContent":return this.service.resolveContent(D.URI.revive(m[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(m[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(m[0]);case"getAssociatedResources":return this.service.getAssociatedResources(m[0],{created:m[1].created,uri:D.URI.revive(m[1].uri)});case"getMachineId":return this.service.getMachineId(m[0],{created:m[1].created,uri:D.URI.revive(m[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(y.startsWith("manualSync/")){const v=y.substring(11),h=m[0],S=this.getManualSyncTask(h);switch(m=m.slice(1),v){case"preview":return S.preview();case"accept":return S.accept(D.URI.revive(m[0]),m[1]);case"merge":return S.merge(D.URI.revive(m[0]));case"discard":return S.discard(D.URI.revive(m[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(C){const y=this.manualSyncTasks.get(this.createKey(C));if(!y)throw new Error(`Manual sync taks not found: ${C}`);return y.manualSyncTask}async createManualSyncTask(){const C=new n.DisposableStore,y=C.add(await this.service.createManualSyncTask());return C.add(y.onSynchronizeResources(m=>this.onManualSynchronizeResources.fire({manualSyncTaskId:y.id,data:m}))),this.manualSyncTasks.set(this.createKey(y.id),{manualSyncTask:y,disposables:C}),{id:y.id,manifest:y.manifest,status:y.status}}disposeManualSyncTask(C){C.dispose();const y=this.createKey(C.id);this.manualSyncTasks.get(y)?.disposables.dispose(),this.manualSyncTasks.delete(y)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=T;class I extends n.Disposable{constructor(C){super(),this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(y,m,v){return C.call(y,m,v).then(null,h=>{throw L.UserDataSyncError.toUserDataSyncError(h)})},listen(y,m){return C.listen(y,m)}},this.channel.call("_getInitialData").then(([y,m,v])=>{this.updateStatus(y),this.updateConflicts(m),v&&this.updateLastSyncTime(v),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(y=>this.updateConflicts(y))),this._register(this.channel.listen("onSyncErrors")(y=>this._onSyncErrors.fire(y.map(([m,v])=>[m,L.UserDataSyncError.toUserDataSyncError(v)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:y,status:m}=await this.channel.call("createManualSyncTask"),v=this,h=new E(C,y,m,{async call(S,P,p){return v.channel.call(`manualSync/${S}`,[C,...Array.isArray(P)?P:[P]],p)},listen(S,P){return R.Event.map(R.Event.filter(v.channel.listen(`manualSync/${S}`,P),p=>!h.isDiposed()&&p.manualSyncTaskId===C),p=>p.data)}});return h}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,y,m,v){return this.channel.call("accept",[C,y,m,v])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:m,uri:v})=>({created:m,uri:D.URI.revive(v)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:m,uri:v})=>({created:m,uri:D.URI.revive(v)}))}async getAssociatedResources(C,y){return(await this.channel.call("getAssociatedResources",[C,y])).map(({resource:v,comparableResource:h})=>({resource:D.URI.revive(v),comparableResource:D.URI.revive(h)}))}async getMachineId(C,y){return this.channel.call("getMachineId",[C,y])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([y,m])=>[y,m.map(v=>({...v,baseResource:D.URI.revive(v.baseResource),localResource:D.URI.revive(v.localResource),remoteResource:D.URI.revive(v.remoteResource),previewResource:D.URI.revive(v.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=I;class E extends n.Disposable{constructor(C,y,m,v){super(),this.id=C,this.manifest=y,this._disposed=!1,this._status=m;const h=this;this.channel={async call(S,P,p){try{const g=await v.call(S,P,p);return h.isDiposed()||(h._status=await v.call("_getStatus")),g}catch(g){throw L.UserDataSyncError.toUserDataSyncError(g)}},listen(S,P){return v.listen(S,P)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,y){const m=await this.channel.call("accept",[C,y]);return this.deserializePreviews(m)}async merge(C){const y=await this.channel.call("merge",[C]);return this.deserializePreviews(y)}async discard(C){const y=await this.channel.call("discard",[C]);return this.deserializePreviews(y)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([y,m])=>[y,{isLastSyncFromCurrentMachine:m.isLastSyncFromCurrentMachine,resourcePreviews:m.resourcePreviews.map(v=>({...v,baseResource:D.URI.revive(v.baseResource),localResource:D.URI.revive(v.localResource),remoteResource:D.URI.revive(v.remoteResource),previewResource:D.URI.revive(v.previewResource),acceptedResource:D.URI.revive(v.acceptedResource)}))}])}}}),define(ne[246],re([0,1,6,3,2]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends D.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:E,getActiveWindowId:b}){super(),this.disposables=this._register(new D.DisposableStore),n.Event.latch(n.Event.any(I,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>b()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(ne[111],re([0,1,168,12,34,17,7,5,20]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");function b(s){const t=s;return typeof t?.id=="string"&&T.URI.isUri(t.uri)}e.isSingleFolderWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function C(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,n.basename)(s)}:t?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=s;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=C;function y(s){const t=s;return typeof t?.id=="string"&&T.URI.isUri(t.configPath)}e.isWorkspaceIdentifier=y;function m(s){const t=s;if(t?.uri)return{id:t.id,uri:T.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:T.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=m;var v;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function h(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.isWorkspace=h;function S(s){const t=s;return!!(t&&typeof t=="object"&&T.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.isWorkspaceFolder=S;class P{constructor(t,r,o,c,u){this._id=t,this._transient=o,this._configuration=c,this._ignorePathCasing=u,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class p{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function g(s){return new p({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function a(s,t){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,t.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function f(s){let t;return T.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=f;function l(s,t){return!a(s,t)&&!f(s)}e.isSavedWorkspace=l;function i(s){return(typeof s=="string"?(0,n.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(ne[24],re([0,1,64,3,2,17,14,7,161,15,13,5,8,111,34,33,6,30,25]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function a(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&((0,T.isUndefined)(t.extensionsResource)||I.URI.isUri(t.extensionsResource)))}e.isUserDataProfile=a,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,y.createDecorator)("IUserDataProfilesService");function f(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,location:I.URI.revive(s.location).with({scheme:t}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(s.extensionsResource)?.with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.reviveProfile=f,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function l(s,t,r,o,c){return{id:s,name:t,location:r,isDefault:!1,globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:(0,L.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:o,isTransient:c}}e.toUserDataProfile=l;let i=class extends D.Disposable{constructor(t,r,o,c){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=o,this.logService=c,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new n.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new n.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new n.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new n.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new h.ResourceMap},this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(u=>l((0,L.basename)(u.location),u.name,u.location,u.useDefaultFlags)):[];let r;const o=new h.ResourceMap,c=l((0,R.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,E.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...c,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||t.length>0||this.transientProfilesObject.profiles.length>0?c.extensionsResource:void 0}),t.length){const u=this.getStoredProfileAssociations();if(u.workspaces)for(const[d,w]of Object.entries(u.workspaces)){const A=I.URI.parse(d),O=I.URI.parse(w),_=t.find(M=>this.uriIdentityService.extUri.isEqual(M.location,O));_&&o.set(A,_)}if(u.emptyWindow){const d=I.URI.parse(u.emptyWindow);r=t.find(w=>this.uriIdentityService.extUri.isEqual(w.location,d))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:r}}return this._profilesObject}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,g.escapeRegExpCharacters)(r)}\\s(\\d+)`);let c=0;for(const d of this.profiles){const w=o.exec(d.name),A=w?parseInt(w[1]):0;c=A>c?A:c}const u=`${r} ${c+1}`;return this.createProfile((0,R.hash)((0,p.generateUuid)()).toString(16),u,void 0,!0,t)}async createNamedProfile(t,r,o){return this.createProfile((0,R.hash)((0,p.generateUuid)()).toString(16),t,r,!1,o)}async createProfile(t,r,o,c,u){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const d=await this.doCreateProfile(t,r,o,!!c);return u&&await this.setProfileForWorkspace(u,d),d}async doCreateProfile(t,r,o,c){let u=this.profileCreationPromises.get(r);return u||(u=(async()=>{try{const d=this.profiles.find(O=>O.name===r||O.id===t);if(d)return d;const w=l(t,r,(0,L.joinPath)(this.profilesHome,t),o,c);await this.fileService.createFolder(w.location);const A=[];return this._onWillCreateProfile.fire({profile:w,join(O){A.push(O)}}),await P.Promises.settled(A),this.updateProfiles([w],[],[]),w}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,u)),u}async updateProfile(t,r,o,c){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let u=this.profiles.find(d=>d.id===t.id);if(!u)throw new Error(`Profile '${t.name}' does not exist`);return u=l(u.id,r,u.location,o,c??u.isTransient),this.updateProfiles([],[],[u]),u}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(c=>c.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(c){o.push(c)}}),await P.Promises.settled(o),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const c of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(c)?.id&&this.profilesObject.workspaces.delete(c);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(c){this.logService.error(c)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(c=>c.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return I.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,v.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,v.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,o){const c=[...this.profiles,...t],u=[];this.transientProfilesObject.profiles=[];for(let d of c)d.isDefault||r.some(w=>d.id===w.id)||(d=o.find(w=>d.id===w.id)??d,d.isTransient?this.transientProfilesObject.profiles.push(d):u.push({location:d.location,name:d.name,useDefaultFlags:d.useDefaultFlags}));this.saveStoredProfiles(u),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,o)}triggerProfilesChanges(t,r,o){this._onDidChangeProfiles.fire({added:t,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const c=this.getWorkspace(t),u=o?this.transientProfilesObject:this.profilesObject;I.URI.isUri(c)?(u.workspaces.delete(c),r&&u.workspaces.set(c,r)):u.emptyWindow=r,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,c]of this.profilesObject.workspaces.entries())t[o.toString()]=c.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};i.PROFILES_KEY="userDataProfiles",i.PROFILE_ASSOCIATIONS_KEY="profileAssociations",i=pe([G(0,b.IEnvironmentService),G(1,C.IFileService),G(2,S.IUriIdentityService),G(3,m.ILogService)],i),e.UserDataProfilesService=i}),define(ne[247],re([0,1,6,2,24]),function(Q,e,R,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let L=class extends n.Disposable{constructor(I){super(),this._register(new R.RunOnceScheduler(()=>{I.cleanUp()},10*1e3)).schedule()}};L=pe([G(0,D.IUserDataProfilesService)],L),e.UserDataProfilesCleaner=L}),define(ne[248],re([0,1,18,6,22,9,3,2,4,7,143,29,32,43,8,26,23,24]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends I.Disposable{constructor(t,r,o,c,u){super(),this.galleryService=t,this.telemetryService=r,this.logService=o,this.productService=c,this.userDataProfilesService=u,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(({task:d})=>d.cancel()),this.uninstallingExtensions.forEach(d=>d.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,y.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new y.ExtensionManagementError(C.localize(0,null),y.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw l(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},D.CancellationToken.None);if(!o)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,o){const c=_=>`${m.ExtensionKey.create(_).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!b.URI.isUri(r)){const _=this.installingExtensions.get(c(r));if(_){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:M}=await _.task.waitUntilTaskIsFinished();return M}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const u=[],d=[],w=[],A=this.createInstallExtensionTask(t,r,o);b.URI.isUri(r)||this.installingExtensions.set(c(r),{task:A,waitingTasks:[]}),this._onInstallExtension.fire({identifier:A.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",A.identifier.id),u.push({task:A,manifest:t});let O=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const M=await this.getAllDepsAndPackExtensions(A.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),k=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:F,manifest:$}of M){O=O||!!$.extensionDependencies?.some(H=>(0,m.areSameExtensions)({id:H},A.identifier));const q=c(F),J=this.installingExtensions.get(q);if(J){if(this.canWaitForTask(A,J.task)){this.logService.info("Waiting for already requested installing extension",F.identifier.id,A.identifier.id),J.waitingTasks.push(A);const H=J.task.identifier;d.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,K=>K.some(W=>(0,m.areSameExtensions)(W.identifier,H)))).then(K=>{if(!K.find(B=>(0,m.areSameExtensions)(B.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!k.some(({identifier:H})=>(0,m.areSameExtensions)(H,F.identifier))){const H=this.createInstallExtensionTask($,F,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(q,{task:H,waitingTasks:[A]}),this._onInstallExtension.fire({identifier:H.identifier,source:F,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",H.identifier.id,A.identifier.id),u.push({task:H,manifest:$})}}}catch(M){if(b.URI.isUri(A.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",A.identifier.id,M.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",A.identifier.id,M.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),M}const _=u.reduce((M,{task:k,manifest:F})=>(M.set(k.identifier.id.toLowerCase(),{task:k,manifest:F}),M),new Map);for(;_.size;){let M;const k=[..._.values()].filter(({manifest:F})=>!F.extensionDependencies?.some($=>_.has($.toLowerCase())));k.length?M=_.size===1?k:k.filter(({task:F})=>!(F===A&&!O)):(this.logService.info("Found extensions with circular dependencies",k.map(({task:F})=>F.identifier.id)),M=[..._.values()]),await this.joinAllSettled(M.map(async({task:F})=>{const $=new Date().getTime();try{const{local:q}=await F.run();if(await this.joinAllSettled(this.participants.map(J=>J.postInstall(q,F.source,o,D.CancellationToken.None))),!b.URI.isUri(F.source)){const J=F.operation===3,H=J?void 0:(new Date().getTime()-F.source.lastUpdated)/1e3;if(l(this.telemetryService,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-$,durationSinceUpdate:H}),E.isWeb&&F.operation!==3)try{await this.galleryService.reportStatistic(q.manifest.publisher,q.manifest.name,q.manifest.version,"install")}catch{}}w.push({local:q,identifier:F.identifier,operation:F.operation,source:F.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:q.isApplicationScoped})}catch(q){throw b.URI.isUri(F.source)||l(this.telemetryService,F.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(F.source),duration:new Date().getTime()-$,error:q}),this.logService.error("Error while installing the extension:",F.identifier.id),q}finally{_.delete(F.identifier.id.toLowerCase())}}))}return d.length&&await this.joinAllSettled(d),w.forEach(({identifier:M})=>this.logService.info("Extension installed successfully:",M.id)),this._onDidInstallExtensions.fire(w),w.filter(({identifier:M})=>(0,m.areSameExtensions)(M,A.identifier))[0].local}catch(_){if(u.forEach(({task:M})=>M.cancel()),w.length)try{const M=await Promise.allSettled(w.map(({local:k})=>this.createUninstallExtensionTask(k,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let k=0;k<M.length;k++){const F=M[k],{identifier:$}=w[k];F.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",$.id):this.logService.warn("Rollback: Error while uninstalling extension",$.id,(0,L.getErrorMessage)(F.reason))}}catch(M){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(M),w.map(({identifier:k})=>k.id))}throw this._onDidInstallExtensions.fire(u.map(({task:M})=>({identifier:M.identifier,operation:2,source:M.source,context:o.context,profileLocation:o.profileLocation}))),_}finally{for(const[_,{task:M,waitingTasks:k}]of this.installingExtensions.entries()){const F=k.indexOf(A);F!==-1&&k.splice(F,1),k.length===0&&(M===A||F!==-1)&&this.installingExtensions.delete(_)}}}canWaitForTask(t,r){for(const[,{task:o,waitingTasks:c}]of this.installingExtensions.entries())if(o===t&&(c.includes(r)||c.some(u=>this.canWaitForTask(u,r)))||o===r&&c[0]&&!this.canWaitForTask(t,c[0]))return!1;return!0}async joinAllSettled(t){const r=[],o=[],c=await Promise.allSettled(t);for(const u of c)u.status==="fulfilled"?r.push(u.value):o.push(u.reason);if(o.length)throw a(o);return r}async getAllDepsAndPackExtensions(t,r,o,c,u){if(!this.galleryService.isEnabled())return[];const d=await this.getInstalled(void 0,u),w=[t],A=[],O=async(_,M)=>{const k=M.extensionDependencies||[],F=[...k];if(M.extensionPack){const $=o?d.find(q=>(0,m.areSameExtensions)(q.identifier,_)):void 0;for(const q of M.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(J=>(0,m.areSameExtensions)({id:J},{id:q}))||F.every(J=>!(0,m.areSameExtensions)({id:J},{id:q}))&&F.push(q)}if(F.length){const $=[...w,...A.map(J=>J.gallery.identifier)],q=F.filter(J=>$.every(H=>!(0,m.areSameExtensions)(H,{id:J})));if(q.length){const J=await this.galleryService.getExtensions(q.map(H=>({id:H,preRelease:c})),D.CancellationToken.None);for(const H of J){if($.find(B=>(0,m.areSameExtensions)(B,H.identifier)))continue;const K=k.some(B=>(0,m.areSameExtensions)({id:B},H.identifier));let W;try{W=await this.checkAndGetCompatibleVersion(H,!1,c)}catch(B){if(B instanceof y.ExtensionManagementError&&B.code===y.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!K){this.logService.info("Skipping the packed extension as it cannot be installed",H.identifier.id);continue}else throw B}A.push({gallery:W.extension,manifest:W.manifest}),await O(W.extension.identifier,W.manifest)}}}};return await O(t,r),A}async checkAndGetCompatibleVersion(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(w=>(0,m.areSameExtensions)(t.identifier,w)))throw new y.ExtensionManagementError(C.localize(3,null,t.identifier.id),y.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const w=await this.getTargetPlatform();throw new y.ExtensionManagementError(C.localize(4,null,t.identifier.id,this.productService.nameLong,(0,y.TargetPlatformToString)(w)),y.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.getCompatibleVersion(t,r,o);if(u){if(o&&!r&&t.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new y.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),y.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],D.CancellationToken.None))[0]?new y.ExtensionManagementError(C.localize(6,null,t.identifier.id),y.ExtensionManagementErrorCode.ReleaseVersionNotFound):new y.ExtensionManagementError(C.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),y.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",u.identifier.id);const d=await this.galleryService.getManifest(u,D.CancellationToken.None);if(d===null)throw new y.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,y.ExtensionManagementErrorCode.Invalid);if(d.version!==u.version)throw new y.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,y.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:d}}async getCompatibleVersion(t,r,o){const c=await this.getTargetPlatform();let u=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(u=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null),!u&&await this.galleryService.isExtensionCompatible(t,o,c)&&(u=t),u||(r?u=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},D.CancellationToken.None))[0]||null:u=await this.galleryService.getCompatibleExtension(t,o,c)),u}async uninstallExtension(t,r){const o=O=>`${O.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,c=this.uninstallingExtensions.get(o(t.identifier));if(c)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),c.waitUntilTaskIsFinished();const u=(O,_)=>{const M=this.createUninstallExtensionTask(O,_);return this.uninstallingExtensions.set(o(M.extension.identifier),M),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${O.identifier.id}@${O.manifest.version}`),this._onUninstallExtension.fire({identifier:O.identifier,profileLocation:r.profileLocation,applicationScoped:O.isApplicationScoped}),M},d=(O,_)=>{_?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${O.identifier.id}@${O.manifest.version}`,r.profileLocation.toString(),_.message):this.logService.error("Failed to uninstall extension:",`${O.identifier.id}@${O.manifest.version}`,_.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${O.identifier.id}@${O.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${O.identifier.id}@${O.manifest.version}`),l(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(O),error:_}),this._onDidUninstallExtension.fire({identifier:O.identifier,version:O.manifest.version,error:_?.code,profileLocation:r.profileLocation,applicationScoped:O.isApplicationScoped})},w=[],A=[];try{w.push(u(t,r));const O=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const _=this.getAllPackExtensionsToUninstall(t,O);for(const M of _)this.uninstallingExtensions.has(o(M.identifier))?this.logService.info("Extensions is already requested to uninstall",M.identifier.id):w.push(u(M,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(w.map(_=>_.extension),O,t),await this.joinAllSettled(w.map(async _=>{try{if(await _.run(),await this.joinAllSettled(this.participants.map(M=>M.postUninstall(_.extension,r,D.CancellationToken.None))),_.extension.identifier.uuid)try{await this.galleryService.reportStatistic(_.extension.manifest.publisher,_.extension.manifest.name,_.extension.manifest.version,"uninstall")}catch{}d(_.extension)}catch(M){const k=M instanceof y.ExtensionManagementError?M:new y.ExtensionManagementError((0,L.getErrorMessage)(M),y.ExtensionManagementErrorCode.Internal);throw d(_.extension,k),k}finally{A.push(_)}}))}catch(O){const _=O instanceof y.ExtensionManagementError?O:new y.ExtensionManagementError((0,L.getErrorMessage)(O),y.ExtensionManagementErrorCode.Internal);for(const M of w){try{M.cancel()}catch{}A.includes(M)||d(M.extension,_)}throw _}finally{for(const O of w)this.uninstallingExtensions.delete(o(O.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",O.extension.identifier.id)}}checkForDependents(t,r,o){for(const c of t){const u=this.getDependents(c,r);if(u.length){const d=u.filter(w=>!t.some(A=>(0,m.areSameExtensions)(A.identifier,w.identifier)));if(d.length)throw new Error(this.getDependentsErrorMessage(c,d,o))}}}getDependentsErrorMessage(t,r,o){return o===t?r.length===1?C.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const u=r.filter(w=>!w.isBuiltin&&c.some(A=>(0,m.areSameExtensions)({id:A},w.identifier))),d=[];for(const w of u)d.push(...this.getAllPackExtensionsToUninstall(w,r,o));return[...u,...d]}return[]}getDependents(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,m.areSameExtensions)({id:c},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,r,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,r,o)}createUninstallExtensionTask(t,r){return r.profileLocation&&t.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,r)}};g=pe([G(0,y.IExtensionGalleryService),G(1,P.ITelemetryService),G(2,h.ILogService),G(3,S.IProductService),G(4,p.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function a(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=a;function f(s){if(s instanceof y.ExtensionManagementError)return s;const t=new y.ExtensionManagementError(s.message,y.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}function l(s,t,{extensionData:r,duration:o,error:c,durationSinceUpdate:u}){const d=c?c instanceof y.ExtensionManagementError?c.code:y.ExtensionManagementErrorCode.Internal:void 0;s.publicLog(t,{...r,success:!c,duration:o,errorcode:d,durationSinceUpdate:u})}e.reportTelemetry=l;class i{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>new Promise((r,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=i}),define(ne[74],re([0,1,18,6,31,16,9,35,125,2,20,12,4,17,55,84,14,7,146,15,32,43,68,13,5,8,26,3,65,48,24,33,174]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l,i,s,t,r,o,c,u,d,w,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var _;(function(H){function K(W,B){if(W===B)return!0;const Y=Object.keys(W),te=new Set;for(const ce of Object.keys(B))te.add(ce);if(Y.length!==te.size)return!1;for(const ce of Y){if(W[ce]!==B[ce])return!1;te.delete(ce)}return te.size===0}H.equals=K})(_=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=class extends b.Disposable{constructor(K,W,B,Y,te,ce,z,V,U,N,j){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=W,this.extensionsControlLocation=B,this.cacheLocation=Y,this.userDataProfilesService=te,this.extensionsProfileScannerService=ce,this.fileService=z,this.logService=V,this.environmentService=U,this.productService=N,this.instantiationService=j,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,l.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance($,(0,v.joinPath)(this.cacheLocation,l.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(K,W,B){const[Y,te]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(W)]),ce=B?await this.scanExtensionsUnderDevelopment(K,[...Y,...te]):[];return this.dedupExtensions(Y,te,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const W=[];W.push(this.scanDefaultSystemExtensions(!!K.useCache,K.language)),W.push(this.scanDevSystemExtensions(K.language,!!K.checkControlFile));const[B,Y]=await Promise.all(W);return this.applyScanOptions([...B,...Y],0,K,!1)}async scanUserExtensions(K){this.logService.trace("Started scanning user extensions");const W=await this.createExtensionScannerInput(K.profileLocation??this.userExtensionsLocation,!!K.profileLocation,1,!K.includeUninstalled,K.language);let Y=await(K.useCache&&!W.devMode&&W.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(W);return Y=await this.applyScanOptions(Y,1,K,!0),this.logService.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(K,W){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const B=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(Y=>Y.scheme===C.Schemas.file).map(async Y=>{const te=await this.createExtensionScannerInput(Y,!1,1,!0,K.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(te)).map(z=>(z.type=W.find(V=>(0,f.areSameExtensions)(V.identifier,z.identifier))?.type??z.type,this.extensionsScanner.validate(z,te)))}))).flat();return this.applyScanOptions(B,"development",K,!0)}return[]}async scanExistingExtension(K,W,B){const Y=await this.createExtensionScannerInput(K,!1,W,!0,B.language),te=await this.extensionsScanner.scanExtension(Y);return!te||!B.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(K,W,B){const Y=await this.createExtensionScannerInput(K,!1,W,!0,B.language),te=await this.extensionsScanner.scanOneOrMultipleExtensions(Y);return this.applyScanOptions(te,W,B,!0)}async scanMetadata(K){const W=(0,v.joinPath)(K,"package.json"),B=(await this.fileService.readFile(W)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(K,W){const B=(0,v.joinPath)(K,"package.json"),Y=(await this.fileService.readFile(B)).value.toString(),te=JSON.parse(Y);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,te.__metadata={...te.__metadata,...W},await this.fileService.writeFile((0,v.joinPath)(K,"package.json"),L.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async applyScanOptions(K,W,B,Y){return B.includeAllVersions||(K=this.dedupExtensions(W===0?K:void 0,W===1?K:void 0,W==="development"?K:void 0,await this.getTargetPlatform(),Y)),B.includeInvalid||(K=K.filter(te=>te.isValid)),K.sort((te,ce)=>{const z=y.basename(te.location.fsPath),V=y.basename(ce.location.fsPath);return z<V?-1:z>V?1:0})}dedupExtensions(K,W,B,Y,te){const ce=(V,U,N)=>{if(V.isValid&&!U.isValid)return!1;if(V.isValid===U.isValid){if(te&&h.gt(V.manifest.version,U.manifest.version))return this.logService.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${V.location.path} with version ${V.manifest.version}`),!1;if(h.eq(V.manifest.version,U.manifest.version)){if(V.type===0)return this.logService.debug(`Skipping extension ${U.location.path} in favour of system extension ${V.location.path} with same version`),!1;if(V.targetPlatform===Y)return this.logService.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return N?this.logService.warn(`Overwriting user extension ${V.location.path} with ${U.location.path}.`):this.logService.debug(`Overwriting user extension ${V.location.path} with ${U.location.path}.`),!0},z=new Map;return K?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),N=z.get(U);(!N||ce(N,V,!1))&&z.set(U,V)}),W?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),N=z.get(U);if(!N&&K&&V.type===0){this.logService.debug(`Skipping obsolete system extension ${V.location.path}.`);return}(!N||ce(N,V,!1))&&z.set(U,V)}),B?.forEach(V=>{const U=l.ExtensionIdentifier.toKey(V.identifier.id),N=z.get(U);(!N||ce(N,V,!0))&&z.set(U,V),z.set(U,V)}),[...z.values()]}async scanDefaultSystemExtensions(K,W){this.logService.trace("Started scanning system extensions");const B=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,W),te=await(K&&!B.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return this.logService.trace("Scanned system extensions:",te.length),te}async scanDevSystemExtensions(K,W){const B=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!B?.length)return[];this.logService.trace("Started scanning dev system extensions");const Y=W?await this.getBuiltInExtensionControl():{},te=[],ce=p.URI.file(y.normalize(y.join(C.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions")));for(const V of B){const U=Y[V.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":te.push((0,v.joinPath)(ce,V.name));break;default:te.push(p.URI.file(U));break}}const z=await Promise.all(te.map(async V=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(V,!1,0,!0,K))));return this.logService.trace("Scanned dev system extensions:",z.length),(0,R.coalesce)(z)}async getBuiltInExtensionControl(){try{const K=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(K.value.toString())}catch{return{}}}async createExtensionScannerInput(K,W,B,Y,te,ce=!0){const z=await this.getTranslations(te??m.language),V=await this.getMtime(K),U=W?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,N=U?await this.getMtime(U):void 0;return new k(K,V,U,N,W,B,Y,ce,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,te,z)}async getMtime(K){try{const W=await this.fileService.stat(K);if(typeof W.mtime=="number")return W.mtime}catch{}}};M=pe([G(4,w.IUserDataProfilesService),G(5,d.IExtensionsProfileScannerService),G(6,s.IFileService),G(7,r.ILogService),G(8,a.IEnvironmentService),G(9,o.IProductService),G(10,t.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class k{constructor(K,W,B,Y,te,ce,z,V,U,N,j,x,Z,oe){this.location=K,this.mtime=W,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=Y,this.profile=te,this.type=ce,this.excludeObsolete=z,this.validate=V,this.productVersion=U,this.productDate=N,this.productCommit=j,this.devMode=x,this.language=Z,this.translations=oe}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,W){return(0,v.isEqual)(K.location,W.location)&&K.mtime===W.mtime&&(0,v.isEqual)(K.applicationExtensionslocation,W.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&K.profile===W.profile&&K.type===W.type&&K.excludeObsolete===W.excludeObsolete&&K.validate===W.validate&&K.productVersion===W.productVersion&&K.productDate===W.productDate&&K.productCommit===W.productCommit&&K.devMode===W.devMode&&K.language===W.language&&_.equals(K.translations,W.translations)}}let F=class extends b.Disposable{constructor(K,W,B,Y,te){super(),this.obsoleteFile=K,this.extensionsProfileScannerService=W,this.uriIdentityService=B,this.fileService=Y,this.logService=te}async scanExtensions(K){const W=K.profile?await this.scanExtensionsFromProfile(K):await this.scanExtensionsFromLocation(K);let B={};if(K.excludeObsolete&&K.type===1)try{const Y=(await this.fileService.readFile(this.obsoleteFile)).value.toString();B=JSON.parse(Y)}catch{}return(0,P.isEmptyObject)(B)?W:W.filter(Y=>!B[f.ExtensionKey.create(Y).toString()])}async scanExtensionsFromLocation(K){const W=await this.fileService.resolve(K.location);if(!W.children?.length)return[];const B=await Promise.all(W.children.map(async Y=>{if(!Y.isDirectory||K.type===1&&(0,v.basename)(Y.resource).indexOf(".")===0)return null;const te=new k(Y.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(te)}));return(0,R.coalesce)(B).sort((Y,te)=>Y.location.path<te.location.path?-1:1)}async scanExtensionsFromProfile(K){let W=await this.scanExtensionsFromProfileResource(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(K.location,K.applicationExtensionslocation)){W=W.filter(Y=>!Y.metadata?.isApplicationScoped);const B=await this.scanExtensionsFromProfileResource(K.applicationExtensionslocation,Y=>!!Y.metadata?.isApplicationScoped,K);W.push(...B)}return W}async scanExtensionsFromProfileResource(K,W,B){const Y=await this.extensionsProfileScannerService.scanProfileExtensions(K);if(!Y.length)return[];const te=await Promise.all(Y.map(async ce=>{if(W(ce)){const z=new k(ce.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(z,ce.metadata)}return null}));return(0,R.coalesce)(te)}async scanOneOrMultipleExtensions(K){try{if(await this.fileService.exists((0,v.joinPath)(K.location,"package.json"))){const W=await this.scanExtension(K);return W?[W]:[]}else return await this.scanExtensions(K)}catch(W){return this.logService.error(`Error scanning extensions at ${K.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(K,W){try{let B=await this.scanExtensionManifest(K.location);if(B){B.publisher||(B.publisher=l.UNDEFINED_PUBLISHER),W=W??B.__metadata,delete B.__metadata;const Y=(0,f.getGalleryExtensionId)(B.publisher,B.name),te=W?.id?{id:Y,uuid:W.id}:{id:Y},ce=W?.isSystem?0:K.type,z=ce===0||!!W?.isBuiltin;B=await this.translateManifest(K.location,B,k.createNlsConfiguration(K));const V={type:ce,identifier:te,manifest:B,location:K.location,isBuiltin:z,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return K.validate?this.validate(V,K):V}}catch(B){K.type!==0&&this.logService.error(B)}return null}validate(K,W){let B=!0;const Y=(0,i.validateExtensionManifest)(W.productVersion,W.productDate,W.location,K.manifest,K.isBuiltin);for(const[te,ce]of Y)te===S.default.Error&&(B=!1,this.logService.error(this.formatMessage(W.location,ce)));return K.isValid=B,K.validations=Y,K}async scanExtensionManifest(K){const W=(0,v.joinPath)(K,"package.json");let B;try{B=(await this.fileService.readFile(W)).value.toString()}catch(te){return(0,s.toFileOperationResult)(te)!==1&&this.logService.error(this.formatMessage(K,(0,g.localize)(0,null,W.path,te.message))),null}let Y;try{Y=JSON.parse(B)}catch{const ce=[];(0,I.parse)(B,ce);for(const z of ce)this.logService.error(this.formatMessage(K,(0,g.localize)(1,null,W.path,z.offset,z.length,(0,E.getParseErrorMessage)(z.error))));return null}return(0,I.getNodeType)(Y)!=="object"?(this.logService.error(this.formatMessage(K,(0,g.localize)(2,null,W.path))),null):Y}async translateManifest(K,W,B){const Y=await this.getLocalizedMessages(K,W,B);if(Y)try{const te=[],ce=await this.resolveOriginalMessageBundle(Y.default,te);if(te.length>0)return te.forEach(V=>{this.logService.error(this.formatMessage(K,(0,g.localize)(3,null,Y.default?.path,(0,E.getParseErrorMessage)(V.error))))}),W;if((0,I.getNodeType)(Y)!=="object")return this.logService.error(this.formatMessage(K,(0,g.localize)(4,null,Y.default?.path))),W;const z=Y.values||Object.create(null);return(0,O.localizeManifest)(W,z,ce)}catch{}return W}async getLocalizedMessages(K,W,B){const Y=(0,v.joinPath)(K,"package.nls.json"),te=(U,N)=>{N.forEach(j=>{this.logService.error(this.formatMessage(K,(0,g.localize)(5,null,U?.path,(0,E.getParseErrorMessage)(j.error))))})},ce=U=>{this.logService.error(this.formatMessage(K,(0,g.localize)(6,null,U?.path)))},z=`${W.publisher}.${W.name}`,V=B.translations[z];if(V)try{const U=p.URI.file(V),N=(await this.fileService.readFile(U)).value.toString(),j=[],x=(0,I.parse)(N,j);return j.length>0?(te(U,j),{values:void 0,default:Y}):(0,I.getNodeType)(x)!=="object"?(ce(U),{values:void 0,default:Y}):{values:x.contents?x.contents.package:void 0,default:Y}}catch{return{values:void 0,default:Y}}else{if(!await this.fileService.exists(Y))return;let N;try{N=await this.findMessageBundles(K,B)}catch{return}if(!N.localized)return{values:void 0,default:N.original};try{const j=(await this.fileService.readFile(N.localized)).value.toString(),x=[],Z=(0,I.parse)(j,x);return x.length>0?(te(N.localized,x),{values:void 0,default:N.original}):(0,I.getNodeType)(Z)!=="object"?(ce(N.localized),{values:void 0,default:N.original}):{values:Z,default:N.original}}catch{return{values:void 0,default:N.original}}}}async resolveOriginalMessageBundle(K,W){if(K)try{const B=(await this.fileService.readFile(K)).value.toString();return(0,I.parse)(B,W)}catch{}}findMessageBundles(K,W){return new Promise((B,Y)=>{const te=ce=>{const z=(0,v.joinPath)(K,`package.nls.${ce}.json`);this.fileService.exists(z).then(V=>{V&&B({localized:z,original:(0,v.joinPath)(K,"package.nls.json")});const U=ce.lastIndexOf("-");U===-1?B({localized:(0,v.joinPath)(K,"package.nls.json"),original:null}):(ce=ce.substring(0,U),te(ce))})};if(W.devMode||W.pseudo||!W.language)return B({localized:(0,v.joinPath)(K,"package.nls.json"),original:null});te(W.language)})}formatMessage(K,W){return`[${K.path}]: ${W}`}};F=pe([G(1,d.IExtensionsProfileScannerService),G(2,A.IUriIdentityService),G(3,s.IFileService),G(4,r.ILogService)],F);let $=class extends F{constructor(K,W,B,Y,te,ce){super(W,B,Y,te,ce),this.cacheFile=K,this.cacheValidatorThrottler=this._register(new n.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(K){const W=await this.readExtensionCache();if(this.input=K,W&&W.input&&k.equals(W.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),W.result.map(Y=>(Y.location=p.URI.revive(Y.location),Y));const B=await super.scanExtensions(K);return await this.writeExtensionCache({input:K,result:B}),B}async readExtensionCache(){try{const K=await this.fileService.readFile(this.cacheFile),W=JSON.parse(K.value.toString());return{result:W.result,input:(0,u.revive)(W.input)}}catch(K){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(K))}return null}async writeExtensionCache(K){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify(K)))}catch(W){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,T.getErrorMessage)(W))}}async validateCache(){if(!this.input)return;const K=await this.readExtensionCache();if(!K)return;const W=K.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!D.equals(B,W))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(Y){this.logService.error(Y)}}};$=pe([G(2,d.IExtensionsProfileScannerService),G(3,A.IUriIdentityService),G(4,s.IFileService),G(5,r.ILogService)],$);function q(H,K){const W=(0,f.getExtensionId)(H.manifest.publisher,H.manifest.name);return{id:W,identifier:new l.ExtensionIdentifier(W),isBuiltin:H.type===0,isUserBuiltin:H.type===1&&H.isBuiltin,isUnderDevelopment:K,extensionLocation:H.location,uuid:H.identifier.uuid,targetPlatform:H.targetPlatform,...H.manifest}}e.toExtensionDescription=q;class J extends M{constructor(K,W,B,Y,te,ce,z,V,U,N,j){super(K,W,(0,v.joinPath)(B,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(Y,l.MANIFEST_CACHE_FOLDER),te,ce,z,V,U,N,j),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const x=await this.fileService.readFile(p.URI.file(m.translationsConfigFile));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}getTranslations(K){return this.translationsPromise}}e.NativeExtensionsScannerService=J}),define(ne[249],re([0,1,54,6,38,3,2,20,12,28,8,24]),function(Q,e,R,n,D,L,T,I,E,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends T.Disposable{constructor(h,S){super(),this.userDataProfilesService=h,this.logService=S,this.processesLimiter=new n.Limiter(5)}async postUninstall(h){const S=this.parseScript(h,"uninstall");return S&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),P=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${P}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,P=>this.logService.error("Error while removing extension storage path",P))}parseScript(h,S){const P=`vscode:${S}`;if(h.location.scheme===I.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[P]=="string"){const p=h.manifest.scripts[P].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${P} should be a node script`),null):{script:(0,E.join)(h.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(h,S,P,p,g){return new Promise((a,f)=>{const l=this.start(h,S,P,g);let i;const s=t=>{i&&(clearTimeout(i),i=null),t?f(t):a(void 0)};l.on("error",t=>{s((0,D.toErrorMessage)(t)||"Unknown")}),l.on("exit",(t,r)=>{s(t?`post-${S} process exited with code ${t}`:void 0)}),p&&(i=setTimeout(()=>{i=null,l.kill(),f("timed out")},5e3))})}start(h,S,P,p){const g={silent:!0,execArgv:void 0},a=(0,R.fork)(h,[`--type=extension-post-${S}`,...P],g);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const f=L.Event.fromNodeEventEmitter(a.stdout,"data"),l=L.Event.fromNodeEventEmitter(a.stderr,"data");f(t=>this.logService.info(p.identifier.id,p.manifest.version,`post-${S}`,t)),l(t=>this.logService.error(p.identifier.id,p.manifest.version,`post-${S}`,t));const i=L.Event.any(L.Event.map(f,t=>({data:`%c${t}`,format:[""]})),L.Event.map(l,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(p.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),a}getExtensionStoragePath(h){return(0,E.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=pe([G(0,y.IUserDataProfilesService),G(1,C.ILogService)],m),e.ExtensionsLifecycle=m}),define(ne[250],re([0,1,7,15,48,74,13,5,8,26,24]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends L.NativeExtensionsScannerService{constructor(v,h,S,P,p,g,a){super(R.URI.file(p.builtinExtensionsPath),R.URI.file(p.extensionsPath),p.userHome,R.URI.file(p.userDataPath),v,h,S,P,p,g,a)}};y=pe([G(0,C.IUserDataProfilesService),G(1,D.IExtensionsProfileScannerService),G(2,T.IFileService),G(3,E.ILogService),G(4,n.INativeEnvironmentService),G(5,b.IProductService),G(6,I.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(ne[21],re([0,1,6,3,2,192,14,67,5,24]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,E.createDecorator)("storageService");var C;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var y;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(y=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function v(g){const a=g.get(e.TARGET_KEY);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}e.loadKeyTargets=v;class h extends D.Disposable{constructor(a={flushInterval:h.DEFAULT_FLUSH_INTERVAL}){super(),this.options=a,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(a,f){if(f===e.TARGET_KEY){switch(a){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:a})}else this._onDidChangeValue.fire({scope:a,key:f,target:this.getKeyTargets(a)[f]})}emitWillSaveState(a){this._onWillSaveState.fire({reason:a})}get(a,f,l){return this.getStorage(f)?.get(a,l)}getBoolean(a,f,l){return this.getStorage(f)?.getBoolean(a,l)}getNumber(a,f,l){return this.getStorage(f)?.getNumber(a,l)}store(a,f,l,i){if((0,T.isUndefinedOrNull)(f)){this.remove(a,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(a,l,i),this.getStorage(l)?.set(a,f)})}remove(a,f){this.withPausedEmitters(()=>{this.updateKeyTarget(a,f,void 0),this.getStorage(f)?.delete(a)})}withPausedEmitters(a){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{a()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(a,f){const l=[],i=this.getKeyTargets(a);for(const s of Object.keys(i))i[s]===f&&l.push(s);return l}updateKeyTarget(a,f,l){const i=this.getKeyTargets(f);typeof l=="number"?i[a]!==l&&(i[a]=l,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[a]=="number"&&(delete i[a],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(a){switch(a){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(a){const f=this.getStorage(a);return f?v(f):Object.create(null)}isNew(a){return this.getBoolean(e.IS_NEW_KEY,a)===!0}async flush(a=C.NONE){this._onWillSaveState.fire({reason:a});const f=this.getStorage(-1),l=this.getStorage(0),i=this.getStorage(1);switch(a){case C.NONE:await R.Promises.settled([f?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await R.Promises.settled([f?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const a=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return p(a,f,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(a,f){return this.emitWillSaveState(C.NONE),(0,b.isUserDataProfile)(a)?this.switchToProfile(a,f):this.switchToWorkspace(a,f)}canSwitchProfile(a,f){return!(a.id===f.id||S(f)&&S(a))}switchData(a,f,l,i){this.withPausedEmitters(()=>{if(i)for(const[s,t]of a)f.set(s,t);else{const s=new Set;for(const[t,r]of a)s.add(t),f.get(t)!==r&&this.emitDidChangeValue(l,t);for(const[t]of f.items)s.has(t)||this.emitDidChangeValue(l,t)}})}}e.AbstractStorageService=h,h.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class P extends h{constructor(){super(),this.applicationStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.profileStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(a=>this.emitDidChangeValue(1,a))),this._register(this.profileStorage.onDidChangeStorage(a=>this.emitDidChangeValue(0,a))),this._register(this.applicationStorage.onDidChangeStorage(a=>this.emitDidChangeValue(-1,a)))}getStorage(a){switch(a){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(a){switch(a){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(a){return!1}}e.InMemoryStorageService=P;async function p(g,a,f,l,i,s){const t=_=>{try{return JSON.parse(_)}catch{return _}},r=new Map,o=new Map;g.forEach((_,M)=>{r.set(M,_),o.set(M,t(_))});const c=new Map,u=new Map;a.forEach((_,M)=>{c.set(M,_),u.set(M,t(_))});const d=new Map,w=new Map;f.forEach((_,M)=>{d.set(M,_),w.set(M,t(_))}),console.group(l!==i?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const A=[];if(r.forEach((_,M)=>{A.push({key:M,value:_})}),console.table(A),console.groupEnd(),console.log(o),l!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const _=[];c.forEach((M,k)=>{_.push({key:k,value:M})}),console.table(_),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${s})`);const O=[];d.forEach((_,M)=>{O.push({key:M,value:_})}),console.table(O),console.groupEnd(),console.log(w)}e.logStorage=p}),define(ne[251],re([0,1,3,2,14,29,32,21]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends n.Disposable{constructor(y,m){super(),this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(y)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"}))),this._register(m.onDidInstallExtensions(v=>v.forEach(({local:h,operation:S})=>{h&&S===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(y,m){return this._removeFromDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}async disableExtension(y,m){return this._addToDisabledExtensions(y)?(this._onDidChangeEnablement.fire({extensions:[y],source:m}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(y){const m=this.getDisabledExtensions();return m.every(v=>!(0,T.areSameExtensions)(v,y))?(m.push(y),this._setDisabledExtensions(m),!0):!1}_removeFromDisabledExtensions(y){const m=this.getDisabledExtensions();for(let v=0;v<m.length;v++){const h=m[v];if((0,T.areSameExtensions)(h,y))return m.splice(v,1),this._setDisabledExtensions(m),!0}return!1}_setDisabledExtensions(y){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,y)}_getExtensions(y){return this.storageManger.get(y,0)}_setExtensions(y,m){this.storageManger.set(y,m,0)}};E=pe([G(0,I.IStorageService),G(1,L.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class b extends n.Disposable{constructor(y){super(),this.storageService=y,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(y.onDidChangeValue(m=>this.onDidStorageChange(m)))}get(y,m){let v;return m===0?((0,D.isUndefinedOrNull)(this.storage[y])&&(this.storage[y]=this._get(y,m)),v=this.storage[y]):v=this._get(y,m),JSON.parse(v)}set(y,m,v){const h=JSON.stringify(m.map(({id:P,uuid:p})=>({id:P,uuid:p})));this._get(y,v)!==h&&(v===0&&(m.length?this.storage[y]=h:delete this.storage[y]),this._set(y,m.length?h:void 0,v))}onDidStorageChange(y){if(y.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[y.key])&&this._get(y.key,y.scope)!==this.storage[y.key]){const v=this.get(y.key,y.scope);delete this.storage[y.key];const h=this.get(y.key,y.scope),S=v.filter(p=>!h.some(g=>(0,T.areSameExtensions)(p,g))),P=h.filter(p=>!v.some(g=>(0,T.areSameExtensions)(g,p)));(S.length||P.length)&&this._onDidChange.fire([...S,...P])}}_get(y,m){return this.storageService.get(y,m,"[]")}_set(y,m,v){m?this.storageService.store(y,m,v,1):this.storageService.remove(y,v)}}e.StorageManager=b}),define(ne[252],re([0,1,18,22,9,4,36,14,7,19,15,29,32,68,13,8,26,44,220,21,23]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=L.isWeb?"web":(0,y.getTargetPlatform)(L.platform,T.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function s(...U){return String(U.reduce((N,j)=>N|j,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class d{constructor(N=u){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,j=this.state.pageSize){return new d({...this.state,pageNumber:N,pageSize:j})}withFilter(N,...j){const x=[...this.state.criteria,...j.length?j.map(Z=>({filterType:N,value:Z})):[{filterType:N}]];return new d({...this.state,criteria:x})}withSortBy(N){return new d({...this.state,sortBy:N})}withSortOrder(N){return new d({...this.state,sortOrder:N})}withFlags(...N){return new d({...this.state,flags:N.reduce((j,x)=>j|x,0)})}withAssetTypes(...N){return new d({...this.state,assetTypes:N})}withSource(N){return new d({...this.state,source:N})}get raw(){const{criteria:N,pageNumber:j,pageSize:x,sortBy:Z,sortOrder:oe,flags:X,assetTypes:ie}=this.state;return{filters:[{criteria:N,pageNumber:j,pageSize:x,sortBy:Z,sortOrder:oe}],assetTypes:ie,flags:X}}get searchText(){const N=this.state.criteria.filter(j=>j.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function w(U,N){const j=(U||[]).filter(x=>x.statisticName===N)[0];return j?j.value:0}function A(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(x=>x.assetType.indexOf(N)===0).reduce((x,Z)=>{const oe=M(U,Z.assetType);return oe&&x.push([Z.assetType.substring(N.length),oe]),x},[])}function O(U){if(U.properties){const N=U.properties.filter(Z=>Z.key===r.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=N.filter(Z=>j.test(Z.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return M(U,r.Repository)}function _(U){return{uri:`${U.fallbackAssetUri}/${r.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${r.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function M(U,N){return U.files.filter(x=>x.assetType===N)[0]?{uri:`${U.assetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${N}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function k(U,N){const j=U.properties?U.properties.filter(Z=>Z.key===N):[],x=j.length>0&&j[0].value;return x?x.split(",").map(Z=>(0,m.adoptToGalleryExtensionId)(Z)):[]}function F(U){const N=U.properties?U.properties.filter(j=>j.key===o.Engine):[];return N.length>0&&N[0].value||""}function $(U){const N=U.properties?U.properties.filter(j=>j.key===o.PreRelease):[];return N.length>0&&N[0].value==="true"}function q(U){const N=U.properties?U.properties.filter(x=>x.key===o.LocalizedLanguages):[],j=N.length>0&&N[0].value||"";return j?j.split(","):[]}function J(U){return U.properties?.find(N=>N.key===o.SponsorLink)?.value}function H(U){return U.indexOf("preview")!==-1}function K(U){return U.targetPlatform?(0,y.toTargetPlatform)(U.targetPlatform):"undefined"}function W(U){const N=(0,R.distinct)(U.versions.map(K)),j=!!U.tags?.includes(y.WEB_EXTENSION_TAG),x=N.indexOf("web");return j?x===-1&&N.push("web"):x!==-1&&N.splice(x,1),N}function B(U,N){const j=(0,y.getFallbackTargetPlarforms)(N);for(let x=0;x<U.length;x++){const Z=U[x];if(Z.version===U[x-1]?.version){let oe=x;const X=K(Z);if(X===N)for(;oe>0&&U[oe-1].version===Z.version;)oe--;else if(j.includes(X))for(;oe>0&&U[oe-1].version===Z.version&&K(U[oe-1])!==N;)oe--;oe!==x&&(U.splice(x,1),U.splice(oe,0,Z))}}return U}e.sortExtensionVersions=B;function Y(U,N,j){U.telemetryData={index:N,querySource:j}}function te(U,N,j){const x=U.versions[0],Z={manifest:M(N,r.Manifest),readme:M(N,r.Details),changelog:M(N,r.Changelog),license:M(N,r.License),repository:O(N),download:_(N),icon:M(N,r.Icon),coreTranslations:A(N)};return{identifier:{id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(x),description:U.shortDescription||"",installCount:w(U.statistics,"install"),rating:w(U.statistics,"averagerating"),ratingCount:w(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:j,assets:Z,properties:{dependencies:k(N,o.Dependency),extensionPack:k(N,o.ExtensionPack),engine:F(N),localizedLanguages:q(N),targetPlatform:K(N),isPreReleaseVersion:$(N)},hasPreReleaseVersion:$(x),hasReleaseVersion:!0,preview:H(U.flags)}}let ce=class{constructor(N,j,x,Z,oe,X,ie,se){this.requestService=j,this.logService=x,this.environmentService=Z,this.telemetryService=oe,this.fileService=X,this.productService=ie,this.configurationService=se;const ue=ie.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ie.version,ie,this.environmentService,this.configurationService,this.fileService,N,this.telemetryService)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,j,x){const Z=n.CancellationToken.isCancellationToken(j)?{}:j,oe=n.CancellationToken.isCancellationToken(j)?j:x,X=[],ie=[],se=[],ue=[];let he=!0;for(const Ee of N){Ee.uuid?ie.push(Ee.uuid):X.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),he=he&&!!Ee.hasPreRelease&&!Pe}if(!ie.length&&!X.length)return[];let ve=new d().withPage(1,N.length);ie.length&&(ve=ve.withFilter(t.ExtensionId,...ie)),X.length&&(ve=ve.withFilter(t.ExtensionName,...X)),(Z.queryAllVersions||he)&&(ve=ve.withFlags(ve.flags,i.IncludeVersions)),Z.source&&(ve=ve.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(ve,{targetPlatform:Z.targetPlatform??l,includePreRelease:se,versions:ue,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ee,Pe)=>Y(Ee,Pe,Z.source)),we}async getCompatibleExtension(N,j,x){if((0,y.isNotWebExtensionInWebTargetPlatform)(N.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(N,j,x))return N;const Z=new d().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:x,compatible:!0,includePreRelease:j},n.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(N,j,x){if(!(0,y.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,x)||!j&&N.properties.isPreReleaseVersion)return!1;let Z=N.properties.engine;if(!Z){const oe=await this.getManifest(N,n.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,v.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(N,j,x,Z,oe){if(!(0,y.isTargetPlatformCompatible)(K(N),Z,oe)||j!=="any"&&$(N)!==(j==="prerelease"))return!1;if(x)try{const X=await this.getEngine(N);if(!(0,v.isEngineValid)(X,this.productService.version,this.productService.date))return!1}catch(X){return this.logService.error(`Error while getting the engine for the version ${N.version}.`,(0,D.getErrorMessage)(X)),!1}return!0}async query(N,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let x=N.text||"";const Z=N.pageSize??50;let oe=new d().withPage(1,Z);x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Category,we||ve),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,ve,we)=>(oe=oe.withFilter(t.Tag,we||ve),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),oe=oe.withFilter(t.SearchText,x)),oe=oe.withSortBy(0)):N.ids?oe=oe.withFilter(t.ExtensionId,...N.ids):N.names?oe=oe.withFilter(t.ExtensionName,...N.names):oe=oe.withSortBy(4),typeof N.sortBy=="number"&&(oe=oe.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(oe=oe.withSortOrder(N.sortOrder)),N.source&&(oe=oe.withSource(N.source));const X=async(he,ve)=>{const{extensions:we,total:Ee}=await this.queryGalleryExtensions(he,{targetPlatform:l,compatible:!1,includePreRelease:!!N.includePreRelease},ve);return we.forEach((Pe,Ue)=>Y(Pe,(he.pageNumber-1)*he.pageSize+Ue,N.source)),{extensions:we,total:Ee}},{extensions:ie,total:se}=await X(oe,j),ue=async(he,ve)=>{if(ve.isCancellationRequested)throw new D.CancellationError;const{extensions:we}=await X(oe.withPage(he+1),ve);return we};return{firstPage:ie,total:se,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(N,j,x){const Z=N.flags;!!(N.flags&i.IncludeLatestVersionOnly)&&!!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(N.flags&i.IncludeLatestVersionOnly)&&!(N.flags&i.IncludeVersions)&&(N=N.withFlags(N.flags,i.IncludeLatestVersionOnly)),j.versions?.length&&(N=N.withFlags(N.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),N=N.withFlags(N.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:oe,total:X}=await this.queryRawGalleryExtensions(N,x);if(!(N.flags&i.IncludeLatestVersionOnly)){const he=[];for(const ve of oe){const we=await this.toGalleryExtensionWithCriteria(ve,j);we&&he.push(we)}return{extensions:he,total:X}}const se=[],ue=new Map;for(let he=0;he<oe.length;he++){const ve=oe[he],we={id:(0,m.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),uuid:ve.extensionId},Ee=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(Ue=>(0,m.areSameExtensions)(Ue,we))?.includePreRelease;if(j.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(W(ve),j.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(ve,j);!Pe||Pe.properties.isPreReleaseVersion&&(!Ee||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==j.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(ve.extensionId,he):se.push([he,Pe])}if(ue.size){const he=new Date().getTime(),ve=new d().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(ve,j,x);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ee of we){const Pe=ue.get(Ee.identifier.uuid);se.push([Pe,Ee])}}return{extensions:se.sort((he,ve)=>he[0]-ve[0]).map(([,he])=>he),total:X}}async toGalleryExtensionWithCriteria(N,j){const x={id:(0,m.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},Z=j.versions?.find(se=>(0,m.areSameExtensions)(se,x))?.version,oe=(0,I.isBoolean)(j.includePreRelease)?j.includePreRelease:!!j.includePreRelease.find(se=>(0,m.areSameExtensions)(se,x))?.includePreRelease,X=W(N),ie=B(N.versions,j.targetPlatform);if(j.compatible&&(0,y.isNotWebExtensionInWebTargetPlatform)(X,j.targetPlatform))return null;for(let se=0;se<ie.length;se++){const ue=ie[se];if(!(Z&&ue.version!==Z)){if(await this.isValidVersion(ue,oe?"any":"release",j.compatible,X,j.targetPlatform))return te(N,ue,X);if(Z&&ue.version===Z)return null}}return Z||j.compatible?null:te(N,N.versions[0],X)}async queryRawGalleryExtensions(N,j){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(i.Unpublished));const x=await this.commonHeadersPromise,Z=JSON.stringify(N.raw),oe={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},X=new Date().getTime();let ie,se,ue=0;try{if(ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:oe},j),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,p.asJson)(ie);if(he){const ve=he.results[0],we=ve.extensions,Ee=ve.resultMetadata&&ve.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw se=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-X,success:!!ie&&(0,p.isSuccess)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(N,j,x,Z){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${N}.${j}/version/${x}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${j}/${x}/stats?statType=${Z}`),X=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.commonHeadersPromise,Accept:X};try{await this.requestService.request({type:"POST",url:oe,headers:se},n.CancellationToken.None)}catch{}}async download(N,j,x){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const Z=(0,m.getGalleryExtensionTelemetryData)(N),oe=new Date().getTime(),X=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:he}),ie=x===2?"install":x===3?"update":"",se=ie?{uri:`${N.assets.download.uri}${E.URI.parse(N.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${N.assets.download.fallbackUri}${E.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:N.assets.download,ue=await this.getAsset(se);await this.fileService.writeFile(j,ue.stream),X(new Date().getTime()-oe)}async getReadme(N,j){if(N.assets.readme){const x=await this.getAsset(N.assets.readme,{},j);return await(0,p.asTextOrError)(x)||""}return""}async getManifest(N,j){if(N.assets.manifest){const x=await this.getAsset(N.assets.manifest,{},j),Z=await(0,p.asTextOrError)(x);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(N,j){const x=M(N,r.Manifest);if(!x)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(x,{headers:Z});return await(0,p.asJson)(oe)}async getCoreTranslation(N,j){const x=N.assets.coreTranslations.filter(Z=>Z[0]===j.toUpperCase())[0];if(x){const Z=await this.getAsset(x[1]),oe=await(0,p.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(N,j){if(N.assets.changelog){const x=await this.getAsset(N.assets.changelog,{},j);return await(0,p.asTextOrError)(x)||""}return""}async getAllCompatibleVersions(N,j,x){let Z=new d().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?Z=Z.withFilter(t.ExtensionId,N.identifier.uuid):Z=Z.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,n.CancellationToken.None);if(!oe.length)return[];const X=W(oe[0]);if((0,y.isNotWebExtensionInWebTargetPlatform)(X,x))return[];const ie=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,j?"any":"release",!0,X,x)&&ie.push(he)}catch{}}));const se=[],ue=new Set;for(const he of B(ie,x))ue.has(he.version)||(ue.add(he.version),se.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:$(he)}));return se}async getAsset(N,j={},x=n.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},X={...Z,...j.headers||{}};j={...j,...oe,headers:X};const ie=N.uri,se=N.fallbackUri,ue={...j,url:ie};try{const he=await this.requestService.request(ue,x);if(he.res.statusCode===200)return he;const ve=await(0,p.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${ve}`)}catch(he){if((0,D.isCancellationError)(he))throw he;const ve=(0,D.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:ve});const we={...j,url:se};return this.requestService.request(we,x)}}async getEngine(N){let j=F(N);if(!j){const x=await this.getManifestFromRawExtensionVersion(N,n.CancellationToken.None);if(!x)throw new Error("Manifest was not found");j=x.engines.vscode}return j}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,p.asJson)(N),x=[],Z={};if(j){for(const oe of j.malicious)x.push({id:oe});if(j.migrateToPreRelease)for(const[oe,X]of Object.entries(j.migrateToPreRelease))(!X.engine||(0,v.isEngineValid)(X.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:X.id,displayName:X.displayName,autoMigrate:{storage:!!X.migrateStorage},preRelease:!0}});if(j.deprecated)for(const[oe,X]of Object.entries(j.deprecated))X&&(Z[oe.toLowerCase()]=(0,I.isBoolean)(X)?{}:X)}return{malicious:x,deprecated:Z}}};ce=pe([G(1,p.IRequestService),G(2,S.ILogService),G(3,C.IEnvironmentService),G(4,f.ITelemetryService),G(5,h.IFileService),G(6,P.IProductService),G(7,b.IConfigurationService)],ce);let z=class extends ce{constructor(N,j,x,Z,oe,X,ie,se){super(N,j,x,Z,oe,X,ie,se)}};z=pe([G(0,a.IStorageService),G(1,p.IRequestService),G(2,S.ILogService),G(3,C.IEnvironmentService),G(4,f.ITelemetryService),G(5,h.IFileService),G(6,P.IProductService),G(7,b.IConfigurationService)],z),e.ExtensionGalleryService=z;let V=class extends ce{constructor(N,j,x,Z,oe,X,ie){super(void 0,N,j,x,Z,oe,X,ie)}};V=pe([G(0,p.IRequestService),G(1,S.ILogService),G(2,C.IEnvironmentService),G(3,f.ITelemetryService),G(4,h.IFileService),G(5,P.IProductService),G(6,b.IConfigurationService)],V),e.ExtensionGalleryServiceWithNoStorageService=V}),define(ne[75],re([0,1,5,3,2,21,32,26,18,8,14]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const y=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Qe extends D.Disposable{constructor(h,S,P){super(),this.storageService=h,this.productService=S,this.logService=P,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Qe.readAllExtensionsWithKeysForSync(h),this._register(this.storageService.onDidChangeValue(p=>this.onDidChangeStorageValue(p)))}static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const S=y.exec(h);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(h,S){const P=await h.getInstalled(),p=[];for(const[g,a]of Qe.readAllExtensionsWithKeysForSync(S)){const f=P.find(l=>(0,T.areSameExtensions)(l.identifier,{id:g}))?.manifest.version;for(const l of a)f!==l&&p.push(Qe.toKey({id:g,version:l}))}for(const g of p)S.remove(g,0)}static readAllExtensionsWithKeysForSync(h){const S=new Map,P=h.keys(0,1);for(const p of P){const g=Qe.fromKey(p);if(g){let a=S.get(g.id.toLowerCase());a||S.set(g.id.toLowerCase(),a=[]),a.push(g.version)}}return S}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Qe.fromKey(h.key);if(S){if(this.storageService.get(h.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let P=this.extensionsWithKeysForSync.get(S.id.toLowerCase());P||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),P=[]),P.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(h){if((0,C.isString)(h))return h;const S=h.manifest?h.manifest.publisher:h.publisher,P=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(S,P)}getExtensionState(h,S){const P=this.getExtensionId(h),p=this.storageService.get(P,S?0:1);if(p)try{return JSON.parse(p)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${P}, global: ${S}): ${g}`)}}setExtensionState(h,S,P){const p=this.getExtensionId(h);S===void 0?this.storageService.remove(p,P?0:1):this.storageService.store(p,JSON.stringify(S),P?0:1,1)}setKeysForSync(h,S){this.storageService.store(Qe.toKey(h),JSON.stringify(S),0,1)}getKeysForSync(h){const S=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],P=this.storageService.get(Qe.toKey(h),0),p=P?JSON.parse(P):void 0;return p&&S?(0,E.distinct)([...p,...S]):p||S}addToMigrationList(h,S){if(h!==S){const P=this.migrationList.filter(p=>!p.includes(h)&&!p.includes(S));P.push([h,S]),this.migrationList=P}}getSourceExtensionToMigrate(h){const S=this.migrationList.find(([,P])=>h===P);return S?S[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(h);if(Array.isArray(S))return S}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};m=pe([G(0,L.IStorageService),G(1,I.IProductService),G(2,b.ILogService)],m),e.ExtensionStorageService=m}),define(ne[253],re([0,1,18,6,3,12,4,36,7,147,15,29,32,211,94,13,8,59,26,44,21,23]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let t=class extends v.ExtensionTipsService{constructor(o,c,u,d,w,A,O,_,M,k){super(O,_,M,k),this.environmentService=o,this.telemetryService=c,this.extensionManagementService=u,this.storageService=d,this.nativeHostService=w,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&Object.entries(_.exeBasedExtensionTips).forEach(([F,$])=>{const q=[],J=[],H=[];Object.entries($.recommendations).forEach(([K,W])=>{W.important?$.important?q.push({extensionId:K,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):J.push({extensionId:K,extensionName:W.name,isExtensionPack:!!W.isExtensionPack}):H.push({extensionId:K,extensionName:W.name,isExtensionPack:!!W.isExtensionPack})}),q.length&&this.highImportanceExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:q}),J.length&&this.mediumImportanceExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:J}),H.length&&this.allOtherExecutableTips.set(F,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,u)}groupImportantTipsByExe(o,c){const u=new Map;o.forEach(_=>u.set(_.extensionId.toLowerCase(),_));const{installed:d,uninstalled:w}=this.groupByInstalled([...u.keys()],c);for(const _ of d){const M=u.get(_);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:M.exeName})}for(const _ of w){const M=u.get(_);M&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:M.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const _ of w){const M=u.get(_);if(M&&(!A[M.exeName]||!A[M.exeName].includes(M.extensionId))){let k=O.get(M.exeName);k||(k=[],O.set(M.exeName,k)),k.push(M)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const d=D.Event.once(D.Event.latch(D.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const d=this._register((0,n.disposableTimeout)(()=>{d.dispose(),this.promptHighImportanceExeBasedTip()},36e5));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),c=Date.now()-o,u=7*24*60*60*1e3;if(c<u){const A=this._register((0,n.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-c));return}const[d,w]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(w).then(A=>{switch(A){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(w[0].exeName,w);const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break}case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=D.Event.once(D.Event.latch(D.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,n.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},36e5));break}}})}async promptExeRecommendations(o){const c=await this.extensionManagementService.getInstalled(1),u=o.filter(w=>!w.whenNotInstalled||w.whenNotInstalled.every(A=>c.every(O=>!(0,m.areSameExtensions)(O.identifier,{id:A})))).map(({extensionId:w})=>w.toLowerCase()),d=(0,b.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(u,d,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,-1,"{}"))}addToRecommendedExecutables(o,c){const u=this.getPromptedExecutableTips();u[o]=c.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(i,JSON.stringify(u),-1,0)}groupByInstalled(o,c){const u=[],d=[],w=c.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return o.forEach(A=>{w.has(A.toLowerCase())?u.push(A):d.push(A)}),{installed:u,uninstalled:d}}async getValidExecutableBasedExtensionTips(o){const c=[],u=new Map;for(const d of o.keys()){const w=o.get(d);if(!w||!(0,R.isNonEmptyArray)(w.recommendations))continue;const A=[];T.isWindows?w.windowsPath&&A.push(w.windowsPath.replace("%USERPROFILE%",I.env.USERPROFILE).replace("%ProgramFiles(x86)%",I.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",I.env.ProgramFiles).replace("%APPDATA%",I.env.APPDATA).replace("%WINDIR%",I.env.WINDIR)):(A.push((0,L.join)("/usr/local/bin",d)),A.push((0,L.join)("/usr/bin",d)),A.push((0,L.join)(this.environmentService.userHome.fsPath,d)));for(const O of A){let _=u.get(O);if(_===void 0&&(_=await this.fileService.exists(E.URI.file(O)),u.set(O,_)),_)for(const{extensionId:M,extensionName:k,isExtensionPack:F,whenNotInstalled:$}of w.recommendations)c.push({extensionId:M,extensionName:k,isExtensionPack:F,exeName:d,exeFriendlyName:w.exeFriendlyName,windowsPath:w.windowsPath,whenNotInstalled:$})}}return c}};t=pe([G(0,C.INativeEnvironmentService),G(1,l.ITelemetryService),G(2,y.IExtensionManagementService),G(3,f.IStorageService),G(4,p.INativeHostService),G(5,h.IExtensionRecommendationNotificationService),G(6,S.IFileService),G(7,g.IProductService),G(8,a.IRequestService),G(9,P.ILogService)],t),e.ExtensionTipsService=t}),define(ne[254],re([0,1,6,2,17,67,21,71,24]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(y,m,v,h){super(),this.initialWorkspace=y,this.initialProfiles=m,this.mainProcessService=v,this.environmentService=h,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new n.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new n.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const y=this._register(new I.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),m=this._register(new L.Storage(y));return this._register(m.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),m}createProfileStorage(y){this.profileStorageDisposables.clear(),this.profileStorageProfile=y;let m;if((0,T.isProfileUsingDefaultStorage)(y))m=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new I.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),y));m=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(m.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),m}createWorkspaceStorage(y){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=y?.id;let m;if(y){const v=this.workspaceStorageDisposables.add(new I.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),y));m=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(m.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)))}return m}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(y){switch(y){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(y){switch(y){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(y,m){if(!this.canSwitchProfile(this.profileStorageProfile,y))return;const v=this.profileStorage,h=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(y),await this.profileStorage.init(),this.switchData(h,this.profileStorage,0,m)}async switchToWorkspace(y,m){const v=this.workspaceStorage,h=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(y),await this.workspaceStorage.init(),this.switchData(h,this.workspaceStorage,1,m)}hasScope(y){return(0,E.isUserDataProfile)(y)?this.profileStorageProfile.id===y.id:this.workspaceStorageId===y.id}}e.NativeStorageService=b}),define(ne[255],re([0,1,3,2,17,15,58,24]),function(Q,e,R,n,D,L,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let E=class extends n.Disposable{constructor(C,y,m){super(),this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=y.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(m.userRoamingDataHome,"profiles"),this._profiles=C.map(v=>(0,I.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const h=v.added.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),S=v.removed.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),P=v.updated.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme));this._profiles=v.all.map(p=>(0,I.reviveProfile)(p,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:h,removed:S,updated:P,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createNamedProfile(C,y,m){const v=await this.channel.call("createNamedProfile",[C,y,m]);return(0,I.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(C,y,m,v,h){const S=await this.channel.call("createProfile",[C,y,m,v,h]);return(0,I.reviveProfile)(S,this.profilesHome.scheme)}async createTransientProfile(C){const y=await this.channel.call("createTransientProfile",[C]);return(0,I.reviveProfile)(y,this.profilesHome.scheme)}async setProfileForWorkspace(C,y){await this.channel.call("setProfileForWorkspace",[C,y])}removeProfile(C){return this.channel.call("removeProfile",[C])}async updateProfile(C,y,m,v){const h=await this.channel.call("updateProfile",[C,y,m,v]);return(0,I.reviveProfile)(h,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}};E=pe([G(1,T.IMainProcessService),G(2,L.IEnvironmentService)],E),e.UserDataProfilesNativeService=E}),define(ne[45],re([0,1,18,6,16,22,3,35,2,25,14,7,162,19,15,13,8,47,21,23,33,27,24]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=s;let t=class extends E.Disposable{constructor(d,w,A,O,_,M,k,F,$,q,J){super(),this.resource=d,this.fileService=w,this.environmentService=A,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=M,this.userDataSyncEnablementService=k,this.telemetryService=F,this.logService=$,this.configurationService=q,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=J.extUri,this.syncFolder=this.extUri.joinPath(A.userDataSyncHome,d),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(d,A,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(A,w,O)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const d=await this.syncPreviewPromise;this.syncPreviewPromise=null;const w=await this.performSync(d.remoteUserData,d.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(w)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const d=await this.getLastSyncUserData();(d?await this.hasRemoteChanged(d):!0)&&this._onDidChangeLocal.fire()}}setStatus(d){this._status!==d&&(this._status=d,this._onDidChangStatus.fire(d))}async sync(d,w={}){await this._sync(d,!0,this.getUserDataSyncConfiguration(),w)}async preview(d,w,A={}){return this._sync(d,!1,w,A)}async apply(d,w={}){try{this.syncHeaders={...w};const A=await this.doApply(d);return this.setStatus(A),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(d,w,A,O){try{if(this.syncHeaders={...O},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const M=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(d,M);return _=await this.performSync(k,M,w,A),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(d){const w=await this.resolveContent(d);if(!w)return!1;const A=this.parseSyncData(w);if(!A)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const O=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,O),M=await this.isRemoteDataFromCurrentMachine(_),k=await this.generateSyncPreview({ref:_.ref,syncData:A},O,M,this.getUserDataSyncConfiguration(),L.CancellationToken.None),F=[];for(const $ of k){const q=await this.getAcceptResult($,$.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult($,$.previewResource,$.remoteContent,L.CancellationToken.None);F.push([$,{...q,remoteChange:J!==0?J:2}])}await this.applyResult(_,O,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(d){const w=await this.currentMachineIdPromise;return!!d.syncData?.machineId&&d.syncData.machineId===w}async getLatestRemoteUserData(d,w){if(w){const A=d&&d.latest?d.latest[this.resource]:void 0;if(w.ref===A||A===void 0&&w.syncData===null)return w}return this.getRemoteUserData(w)}async performSync(d,w,A,O){if(d.syncData&&d.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,m.localize)(0,null,this.resource,this.version,d.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(d,w,A,O)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(d,w,A,O);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),d=await this.getRemoteUserData(null),w=await this.getLastSyncUserData(),this.performSync(d,w,A,O)}throw _}}async doSync(d,w,A,O){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(M=>this.doGenerateSyncResourcePreview(d,w,A,O,M)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:M})=>M==="conflict")?"hasConflicts":A?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(d){return await this.updateSyncResourcePreview(d,async w=>{const A=await this.getMergeResult(w,L.CancellationToken.None);await this.fileService.writeFile(w.previewResource,D.VSBuffer.fromString(A?.content||""));const O=A&&!A.hasConflicts?await this.getAcceptResult(w,w.previewResource,void 0,L.CancellationToken.None):void 0;return w.acceptResult=O,w.mergeState=A.hasConflicts?"conflict":O?"accepted":"preview",w.localChange=O?O.localChange:A.localChange,w.remoteChange=O?O.remoteChange:A.remoteChange,w}),this.syncPreviewPromise}async accept(d,w){return await this.updateSyncResourcePreview(d,async A=>{const O=await this.getAcceptResult(A,d,w,L.CancellationToken.None);return A.acceptResult=O,A.mergeState="accepted",A.localChange=O.localChange,A.remoteChange=O.remoteChange,A}),this.syncPreviewPromise}async discard(d){return await this.updateSyncResourcePreview(d,async w=>{const A=await this.getMergeResult(w,L.CancellationToken.None);return await this.fileService.writeFile(w.previewResource,D.VSBuffer.fromString(A.content||"")),w.acceptResult=void 0,w.mergeState="preview",w.localChange=A.localChange,w.remoteChange=A.remoteChange,w}),this.syncPreviewPromise}async updateSyncResourcePreview(d,w){if(!this.syncPreviewPromise)return;let A=await this.syncPreviewPromise;const O=A.resourcePreviews.findIndex(({localResource:_,remoteResource:M,previewResource:k})=>this.extUri.isEqual(_,d)||this.extUri.isEqual(M,d)||this.extUri.isEqual(k,d));O!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const M=[...A.resourcePreviews];return M[O]=await w(M[O]),{...A,resourcePreviews:M}}),A=await this.syncPreviewPromise,this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(d){if(!this.syncPreviewPromise)return"idle";const w=await this.syncPreviewPromise;return w.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":w.resourcePreviews.some(({mergeState:A})=>A!=="accepted")?"syncing":(await this.applyResult(w.remoteUserData,w.lastSyncUserData,w.resourcePreviews.map(A=>[A,A.acceptResult]),d),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(d){const w=d.filter(({mergeState:A})=>A==="conflict");(0,R.equals)(this._conflicts,w,(A,O)=>this.extUri.isEqual(A.previewResource,O.previewResource))||(this._conflicts=w,this._onDidChangeConflicts.fire(w))}async hasPreviouslySynced(){const d=await this.getLastSyncUserData();return!!d&&d.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllResourceRefs(this.resource)).map(({created:w,ref:A})=>({created:w,uri:this.toRemoteBackupResource(A)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:w,ref:A})=>({created:w,uri:this.toLocalBackupResource(A)}))}toRemoteBackupResource(d){return y.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${d}`})}toLocalBackupResource(d){return y.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${d}`})}async getMachineId({uri:d}){const w=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(w))){const{content:A}=await this.getUserData(w);if(A)return this.parseSyncData(A)?.machineId}}async resolveContent(d){const w=this.extUri.basename(d);if(this.extUri.isEqual(d,this.toRemoteBackupResource(w))){const{content:A}=await this.getUserData(w);return A}return this.extUri.isEqual(d,this.toLocalBackupResource(w))?this.userDataSyncBackupStoreService.resolveContent(this.resource,w):null}async resolvePreviewContent(d){const w=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(w)for(const A of w.resourcePreviews){if(this.extUri.isEqual(A.acceptedResource,d))return A.acceptResult?A.acceptResult.content:null;if(this.extUri.isEqual(A.remoteResource,d))return A.remoteContent;if(this.extUri.isEqual(A.localResource,d))return A.localContent;if(this.extUri.isEqual(A.baseResource,d))return A.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(d,w,A,O,_){const M=await this.isRemoteDataFromCurrentMachine(d),k=await this.generateSyncPreview(d,w,M,O,_),F=[];for(const $ of k){const q=$.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)F.push({...$,acceptedResource:q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=A?await this.getMergeResult($,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,D.VSBuffer.fromString(J?.content||""));const H=J&&!J.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,_):void 0;F.push({...$,acceptResult:H,mergeState:J?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:J?J.localChange:$.localChange,remoteChange:H?H.remoteChange:J?J.remoteChange:$.remoteChange})}}return{remoteUserData:d,lastSyncUserData:w,resourcePreviews:F,isLastSyncFromCurrentMachine:M}}async getLastSyncUserData(){try{const d=await this.fileService.readFile(this.lastSyncResource),w=JSON.parse(d.value.toString()),A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=w.version&&A&&w.version!==A,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${w.version} is not compatible with current sync state version ${A}.`),await this.resetLocal(),null;const O=w;if(O.content===null)return{ref:w.ref,syncData:null};const _=JSON.parse(O.content);if(s(_))return{...w,syncData:_,content:void 0}}catch(d){d instanceof S.FileOperationError&&d.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Not synced yet. Last sync resource does not exist.`):this.logService.error(d)}return null}async updateLastSyncUserData(d,w={}){if(w.ref||w.content||w.version)throw new Error("Cannot have core properties as additional");const A=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),O={ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null,version:A,...w};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(O)))}async getRemoteUserData(d){const{ref:w,content:A}=await this.getUserData(d);let O=null;return A!==null&&(O=this.parseSyncData(A)),{ref:w,syncData:O}}parseSyncData(d){try{const w=JSON.parse(d);if(s(w))return w}catch(w){this.logService.error(w)}throw new l.UserDataSyncError((0,m.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(d){if((0,C.isString)(d)){const w=await this.userDataSyncStoreService.resolveResourceContent(this.resource,d);return{ref:d,content:w}}else{const w=d?{ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,w,void 0,this.syncHeaders)}}async updateRemoteUserData(d,w){const A=await this.currentMachineIdPromise,O={version:this.version,machineId:A,content:d};try{return w=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(O),w,void 0,this.syncHeaders),{ref:w,syncData:O}}catch(_){throw _ instanceof l.UserDataSyncError&&_.code==="TooLarge"&&(_=new l.UserDataSyncError(_.message,_.code,this.resource)),_}}async backupLocal(d){const w={version:this.version,content:d};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(w))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=pe([G(1,S.IFileService),G(2,h.IEnvironmentService),G(3,g.IStorageService),G(4,l.IUserDataSyncStoreService),G(5,l.IUserDataSyncBackupStoreService),G(6,l.IUserDataSyncEnablementService),G(7,a.ITelemetryService),G(8,l.IUserDataSyncLogService),G(9,v.IConfigurationService),G(10,f.IUriIdentityService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(d,w,A,O,_,M,k,F,$,q,J,H){super(w,A,O,_,M,k,F,$,q,J,H),this.file=d,this._register(this.fileService.watch(this.extUri.dirname(d))),this._register(this.fileService.onDidFilesChange(K=>this.onFileChanges(K)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(d,w,A){try{w?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(d),A?void 0:w):await this.fileService.createFile(this.file,D.VSBuffer.fromString(d),{overwrite:A})}catch(O){throw O instanceof S.FileOperationError&&O.fileOperationResult===1||O instanceof S.FileOperationError&&O.fileOperationResult===3?new l.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}onFileChanges(d){!d.contains(this.file)||this.triggerLocalChange()}};r=pe([G(2,S.IFileService),G(3,h.IEnvironmentService),G(4,g.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncEnablementService),G(8,a.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,v.IConfigurationService),G(11,f.IUriIdentityService)],r),e.AbstractFileSynchroniser=r;let o=class extends r{constructor(d,w,A,O,_,M,k,F,$,q,J,H,K){super(d,w,A,O,_,M,k,F,$,q,H,K),this.userDataSyncUtilService=J,this._formattingOptions=void 0}hasErrors(d,w){const A=[],O=(0,I.parse)(d,A,{allowEmptyContent:!0,allowTrailingComma:!0});return A.length>0||!(0,C.isUndefined)(O)&&w!==Array.isArray(O)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=pe([G(2,S.IFileService),G(3,h.IEnvironmentService),G(4,g.IStorageService),G(5,l.IUserDataSyncStoreService),G(6,l.IUserDataSyncBackupStoreService),G(7,l.IUserDataSyncEnablementService),G(8,a.ITelemetryService),G(9,l.IUserDataSyncLogService),G(10,l.IUserDataSyncUtilService),G(11,v.IConfigurationService),G(12,f.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let c=class{constructor(d,w,A,O,_,M){this.resource=d,this.userDataProfilesService=w,this.environmentService=A,this.logService=O,this.fileService=_,this.extUri=M.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,A,this.extUri)}async initialize({ref:d,content:w}){if(!w){this.logService.info("Remote content does not exist.",this.resource);return}const A=this.parseSyncData(w);if(!!A)try{await this.doInitialize({ref:d,syncData:A})}catch(O){this.logService.error(O)}}parseSyncData(d){try{const w=JSON.parse(d);if(s(w))return w}catch(w){this.logService.error(w)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(d,w={}){const A={ref:d.ref,content:d.syncData?JSON.stringify(d.syncData):null,...w};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(A)))}};c=pe([G(1,i.IUserDataProfilesService),G(2,h.IEnvironmentService),G(3,P.ILogService),G(4,S.IFileService),G(5,f.IUriIdentityService)],c),e.AbstractInitializer=c}),define(ne[256],re([0,1,6,22,9,3,52,25,7,19,15,29,32,75,13,8,21,23,33,24,45,237,110,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(c,u){const d=JSON.parse(c.content);if(c.version===1||c.version===2){const w=(await u.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of d)c.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),c.version===2&&w.every(O=>!(0,m.areSameExtensions)(O.identifier,A.identifier))&&(A.installed=!0)}return d}let r=class gt extends f.AbstractSynchroniser{constructor(u,d,w,A,O,_,M,k,F,$,q,J,H,K,W,B){super("extensions",w,d,A,O,_,H,K,$,J,B),this.profileLocation=u,this.extensionManagementService=M,this.extensionEnablementService=k,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=q,this.extensionStorageService=W,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:te})=>!!te)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(u,d){const w=u.syncData?await t(u.syncData,this.extensionManagementService):null,A=d?.skippedExtensions||[],O=d?.syncData?await t(d.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),M=this.getLocalExtensions(_),k=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);w?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:$}=(0,l.merge)(M,w,O,A,k),q={local:F,remote:$,content:this.getPreviewContent(M,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:$!==null?2:0},J=this.stringify(M,!1);return[{skippedExtensions:A,baseResource:this.baseResource,baseContent:O?this.stringify(O,!1):J,localResource:this.localResource,localContent:J,localExtensions:M,remoteResource:this.remoteResource,remoteContent:w?this.stringify(w,!1):null,previewResource:this.previewResource,previewResult:q,localChange:q.localChange,remoteChange:q.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const d=u.syncData?await t(u.syncData,this.extensionManagementService):null,w=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),A=this.getLocalExtensions(w),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(w),{remote:_}=(0,l.merge)(A,d,d,u.skippedExtensions||[],O);return _!==null}getPreviewContent(u,d,w,A){const O=[...d,...w],_=new Set,M=k=>{_.add(k.id.toLowerCase()),k.uuid&&_.add(k.uuid)};O.forEach(({identifier:k})=>M(k)),A.forEach(M);for(const k of u)_.has(k.identifier.id.toLowerCase())||k.identifier.uuid&&_.has(k.identifier.uuid)||O.push(k);return this.stringify(O,!1)}async getMergeResult(u,d){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,d,w,A){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(d,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(u){const d=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=(0,l.merge)(u.localExtensions,null,null,u.skippedExtensions,w),{local:O,remote:_}=A;return{content:u.localContent,local:O,remote:_,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(u){const d=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),w=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),A=u.remoteContent?JSON.parse(u.remoteContent):null;if(A!==null){const O=(0,l.merge)(u.localExtensions,A,u.localExtensions,[],w),{local:_,remote:M}=O;return{content:u.remoteContent,local:_,remote:M,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,d,w,A){let{skippedExtensions:O,localExtensions:_}=w[0][0];const{local:M,remote:k,localChange:F,remoteChange:$}=w[0][1];if(F===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(_)),O=await this.updateLocalExtensions(M.added,M.removed,M.updated,O)),k){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const q=JSON.stringify(k.all);u=await this.updateRemoteUserData(q,A?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${k.added.length?` Added: ${JSON.stringify(k.added.map(J=>J.identifier.id))}.`:""}${k.updated.length?` Updated: ${JSON.stringify(k.updated.map(J=>J.identifier.id))}.`:""}${k.removed.length?` Removed: ${JSON.stringify(k.removed.map(J=>J.identifier.id))}.`:""}`)}d?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(q=>q.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,gt.EXTENSIONS_DATA_URI)){const w=await this.extensionManagementService.getInstalled(void 0,this.profileLocation),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(w),O=this.getLocalExtensions(w).filter(_=>!A.some(M=>(0,m.areSameExtensions)({id:M},_.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const w=await this.resolvePreviewContent(u);return w&&this.stringify(JSON.parse(w),!0)}let d=await super.resolveContent(u);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(u)),d){const w=this.parseSyncData(d);if(w)switch(this.extUri.basename(u)){case"extensions.json":return this.stringify(this.parseExtensions(w),!0)}}return null}stringify(u,d){return u.sort((w,A)=>!w.identifier.uuid&&A.identifier.uuid?-1:w.identifier.uuid&&!A.identifier.uuid?1:(0,I.compare)(w.identifier.id,A.identifier.id)),d?(0,T.toFormattedString)(u,{}):JSON.stringify(u)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(this.getLocalExtensions(u).some(w=>w.installed||w.disabled))return!0}catch{}return!1}async updateLocalExtensions(u,d,w,A){const O=[],_=[],M=await this.extensionManagementService.getInstalled(void 0,this.profileLocation);if(d.length){const F=M.filter(({identifier:$,isBuiltin:q})=>!q&&d.some(J=>(0,m.areSameExtensions)($,J)));await R.Promises.settled(F.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),O.push($.identifier)}))}(u.length||w.length)&&await R.Promises.settled([...u,...w].map(async F=>{const $=M.find(J=>(0,m.areSameExtensions)(J.identifier,F.identifier));if($&&$.isBuiltin){F.state&&$.manifest.version===F.version&&this.updateExtensionState(F.state,$,$.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(H=>(0,m.areSameExtensions)(H,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id))),O.push(F.identifier);return}const q=(await this.extensionGalleryService.getExtensions([{...F.identifier,preRelease:F.preRelease}],n.CancellationToken.None))[0];if(F.state&&($?$.manifest.version===F.version:!!q)&&this.updateExtensionState(F.state,$||q,$?.manifest.version),q)try{this.extensionEnablementService.getDisabledExtensions().some(H=>(0,m.areSameExtensions)(H,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,q.version),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,q.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,q.version),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,q.version))),(!$||$.preRelease!==F.preRelease)&&(await this.extensionManagementService.canInstall(q)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,q.version),await this.extensionManagementService.installFromGallery(q,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:F.preRelease,profileLocation:this.profileLocation}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,q.version),O.push(q.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),_.push(F)))}catch(J){_.push(F),J instanceof y.ExtensionManagementError&&[y.ExtensionManagementErrorCode.Incompatible,y.ExtensionManagementErrorCode.IncompatiblePreRelease,y.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,q.displayName||q.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,q.displayName||q.identifier.id))}else _.push(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,F.identifier.id)}));const k=[];for(const F of A)O.some($=>(0,m.areSameExtensions)($,F.identifier))||k.push(F);for(const F of _)k.some($=>(0,m.areSameExtensions)($.identifier,F.identifier))||k.push(F);return k}updateExtensionState(u,d,w){const A=this.extensionStorageService.getExtensionState(d,!0)||{},O=w?this.extensionStorageService.getKeysForSync({id:d.identifier.id,version:w}):void 0;O?O.forEach(_=>{A[_]=u[_]}):Object.keys(u).forEach(_=>A[_]=u[_]),this.extensionStorageService.setExtensionState(d,A,!0)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const d=this.extensionEnablementService.getDisabledExtensions();return u.map(w=>{const{identifier:A,isBuiltin:O,manifest:_,preRelease:M}=w,k={identifier:A,preRelease:M,version:_.version};d.some(F=>(0,m.areSameExtensions)(F,A))&&(k.disabled=!0),O||(k.installed=!0);try{const F=this.extensionStorageService.getKeysForSync({id:A.id,version:_.version});if(F){const $=this.extensionStorageService.getExtensionState(w,!0)||{};k.state=Object.keys($).reduce((q,J)=>(F.includes(J)&&(q[J]=$[J]),q),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(F))}return k})}};r.EXTENSIONS_DATA_URI=E.URI.from({scheme:s.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=pe([G(1,C.IEnvironmentService),G(2,h.IFileService),G(3,P.IStorageService),G(4,s.IUserDataSyncStoreService),G(5,s.IUserDataSyncBackupStoreService),G(6,y.IExtensionManagementService),G(7,y.IGlobalExtensionEnablementService),G(8,i.IIgnoredExtensionsManagementService),G(9,s.IUserDataSyncLogService),G(10,y.IExtensionGalleryService),G(11,b.IConfigurationService),G(12,s.IUserDataSyncEnablementService),G(13,p.ITelemetryService),G(14,v.IExtensionStorageService),G(15,g.IUriIdentityService)],r),e.ExtensionsSynchroniser=r;let o=class extends f.AbstractInitializer{constructor(u,d,w,A,O,_,M){super("extensions",A,O,_,w,M),this.extensionManagementService=u,this.ignoredExtensionsManagementService=d}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,d){const w=[],A=[],O=[];for(const _ of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const M=d.find(k=>(0,m.areSameExtensions)(k.identifier,_.identifier));M?(w.push(M),_.disabled&&O.push(_.identifier)):_.installed&&(A.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&O.push(_.identifier))}return{installedExtensions:w,newExtensions:A,disabledExtensions:O,remoteExtensions:u}}};o=pe([G(0,y.IExtensionManagementService),G(1,i.IIgnoredExtensionsManagementService),G(2,h.IFileService),G(3,a.IUserDataProfilesService),G(4,C.IEnvironmentService),G(5,S.ILogService),G(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[257],re([0,1,18,16,3,35,4,14,163,19,15,13,21,23,33,24,45,238,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function a(i,s,t){try{const r=JSON.parse(i);if(!s)return(0,I.isUndefined)(r.all)?null:r.all;switch(T.OS){case 2:return(0,I.isUndefined)(r.mac)?null:r.mac;case 3:return(0,I.isUndefined)(r.linux)?null:r.linux;case 1:return(0,I.isUndefined)(r.windows)?null:r.windows}}catch(r){return t.error(r),null}}e.getKeybindingsContentFromSyncContent=a;let f=class extends P.AbstractJsonFileSynchroniser{constructor(s,t,r,o,c,u,d,w,A,O,_,M){super(s,"keybindings",d,w,A,t,r,u,_,o,O,c,M),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(c.onDidChangeConfiguration,k=>k.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,r,o){const c=s.syncData?a(s.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&r?s:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,d=await this.getLocalFileContent(),w=await this.getFormattingOptions();let A=null,O=!1,_=!1,M=!1;if(c){let $=d?d.value.toString():"[]";if($=$||"[]",this.hasErrors($,!0))throw new g.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!u||u!==$||u!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const q=await(0,p.merge)($,c,u,w,this.userDataSyncUtilService);q.hasChanges&&(A=q.mergeContent,M=q.hasConflicts,O=M||q.mergeContent!==$,_=M||q.mergeContent!==c)}}else d&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),A=d.value.toString(),_=!0);const k={content:A,localChange:O?d?2:1:0,remoteChange:_?2:0,hasConflicts:M},F=d?d.value.toString():null;return[{fileContent:d,baseResource:this.baseResource,baseContent:u!==null?u:F,localResource:this.localResource,localContent:F,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getKeybindingsContentFromLastSyncUserData(s);if(t===null)return!0;const r=await this.getLocalFileContent(),o=r?r.value.toString():"",c=await this.getFormattingOptions(),u=await(0,p.merge)(o||"[]",t,t,c,this.userDataSyncUtilService);return u.hasConflicts||u.mergeContent!==t}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,r,o){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,o){const{fileContent:c}=r[0][0];let{content:u,localChange:d,remoteChange:w}=r[0][1];if(d===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u,!0)))throw new g.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(u||"[]",c,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),w!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const A=this.toSyncContent(u||"[]",s.syncData?.content);s=await this.updateRemoteUserData(A,o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,L.parse)(s.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.baseResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(s)){case"keybindings.json":return a(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:a(s.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(s,t){let r={};try{r=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=s,T.OS){case 2:r.mac=s;break;case 3:r.linux=s;break;case 1:r.windows=s;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=pe([G(1,g.IUserDataSyncStoreService),G(2,g.IUserDataSyncBackupStoreService),G(3,g.IUserDataSyncLogService),G(4,b.IConfigurationService),G(5,g.IUserDataSyncEnablementService),G(6,y.IFileService),G(7,C.IEnvironmentService),G(8,m.IStorageService),G(9,g.IUserDataSyncUtilService),G(10,v.ITelemetryService),G(11,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let l=class extends P.AbstractInitializer{constructor(s,t,r,o,c){super("keybindings",t,r,o,s,c)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,n.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(s.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return a(s,!0,this.logService)}catch(t){return this.logService.error(t),null}}};l=pe([G(0,y.IFileService),G(1,S.IUserDataProfilesService),G(2,C.IEnvironmentService),G(3,g.IUserDataSyncLogService),G(4,h.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(ne[258],re([0,1,16,3,164,19,70,15,29,13,21,23,33,24,45,61,241,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function a(i){const s=JSON.parse(i);return g(s)?s:{settings:i}}e.parseSettingsSyncContent=a;let f=class extends h.AbstractJsonFileSynchroniser{constructor(s,t,r,o,c,u,d,w,A,O,_,M,k){super(s,"settings",t,r,o,c,u,O,_,d,w,A,k),this.extensionManagementService=M,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const t=await this.getLastSyncUserData(),r=await this.getLatestRemoteUserData(s,t),o=this.getSettingsSyncContent(r),c=new T.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&c.parse(o.settings),c.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,t,r){const o=await this.getLocalFileContent(),c=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);t=t===null&&r?s:t;const d=t?this.getSettingsSyncContent(t):null,w=await this.getIgnoredSettings();let A=null,O=!1,_=!1,M=!1;if(u){let $=o?o.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const q=(0,P.merge)($,u.settings,d?d.settings:null,w,[],c);A=q.localContent||q.remoteContent,O=q.localContent!==null,_=q.remoteContent!==null,M=q.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=o.value.toString().trim()||"{}",this.validateContent(A),_=!0);const k={content:A,localChange:O?2:0,remoteChange:_?2:0,hasConflicts:M},F=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:d?d.settings:F,localResource:this.localResource,localContent:F,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const t=this.getSettingsSyncContent(s);if(t===null)return!0;const r=await this.getLocalFileContent(),o=r?r.value.toString().trim():"",c=await this.getIgnoredSettings(),u=await this.getFormattingOptions();return(0,P.merge)(o||"{}",t.settings,t.settings,c,[],u).remoteContent!==null}async getMergeResult(s,t){const r=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,P.updateIgnoredSettings)(s.previewResult.content,"{}",o,r):null}}async getAcceptResult(s,t,r,o){const c=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?(0,P.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent!==null?(0,P.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:r!==null?(0,P.updateIgnoredSettings)(r,s.fileContent?s.fileContent.value.toString():"{}",u,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,r,o){const{fileContent:c}=r[0][0];let{content:u,localChange:d,remoteChange:w}=r[0][1];if(d===0&&w===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(u,c,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),w!==0){const A=await this.getFormattingOptions(),O=this.getSettingsSyncContent(s),_=await this.getIgnoredSettings(u);u=(0,P.updateIgnoredSettings)(u,O?O.settings:"{}",_,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),o?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=await this.getFormattingOptions(),r=(0,S.edit)(s.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,P.isEmpty)(r)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)||this.extUri.isEqual(this.baseResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const r=this.parseSyncData(t);if(r){const o=this.parseSettingsSyncContent(r.content);if(o)switch(this.extUri.basename(s)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(s){let t=await super.resolvePreviewContent(s);if(t){const r=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,P.updateIgnoredSettings)(t,"{}",o,r)}return t}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:c})=>!!c)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,P.getIgnoredSettings)(t,this.configurationService,s)}validateContent(s){if(this.hasErrors(s,!1))throw new p.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};f=pe([G(1,b.IFileService),G(2,I.IEnvironmentService),G(3,C.IStorageService),G(4,p.IUserDataSyncStoreService),G(5,p.IUserDataSyncBackupStoreService),G(6,p.IUserDataSyncLogService),G(7,p.IUserDataSyncUtilService),G(8,L.IConfigurationService),G(9,p.IUserDataSyncEnablementService),G(10,y.ITelemetryService),G(11,E.IExtensionManagementService),G(12,m.IUriIdentityService)],f),e.SettingsSynchroniser=f;let l=class extends h.AbstractInitializer{constructor(s,t,r,o,c){super("settings",t,r,o,s,c)}async doInitialize(s){const t=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,P.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return a(s)}catch(t){this.logService.error(t)}return null}};l=pe([G(0,b.IFileService),G(1,v.IUserDataProfilesService),G(2,I.IEnvironmentService),G(3,p.IUserDataSyncLogService),G(4,m.IUriIdentityService)],l),e.SettingsInitializer=l}),define(ne[259],re([0,1,16,3,31,19,15,13,21,23,33,24,45,239,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends m.AbstractSynchroniser{constructor(g,a,f,l,i,s,t,r,o,c,u){super("snippets",f,a,l,i,s,o,c,t,r,u),this.snippetsFolder=g,this.version=1,this._register(this.fileService.watch(a.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,d=>d.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,a,f){const l=await this.getSnippetsFileContents(),i=this.toSnippetsContents(l),s=g.syncData?this.parseSnippets(g.syncData):null;a=a===null&&f?g:a;const t=a&&a.syncData?this.parseSnippets(a.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,v.merge)(i,s,t);return this.getResourcePreviews(r,l,s||{},t||{})}async hasRemoteChanged(g){const a=g.syncData?this.parseSnippets(g.syncData):null;if(a===null)return!0;const f=await this.getSnippetsFileContents(),l=this.toSnippetsContents(f),i=(0,v.merge)(l,a,a);return Object.keys(i.remote.added).length>0||Object.keys(i.remote.updated).length>0||i.remote.removed.length>0||i.conflicts.length>0}async getMergeResult(g,a){return g.previewResult}async getAcceptResult(g,a,f,l){if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(a,this.syncPreviewFolder))return f===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:f,localChange:f===null?g.fileContent!==null?3:0:2,remoteChange:f===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(g,a,f,l){const i=f.map(([s,t])=>({...s,acceptResult:t}));i.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),i.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(i),await this.updateLocalSnippets(i,l)),i.some(({remoteChange:s})=>s!==0)&&(g=await this.updateRemoteSnippets(i,g,l)),a?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of i)try{await this.fileService.del(s)}catch{}}getResourcePreviews(g,a,f,l){const i=new Map;for(const s of Object.keys(g.local.added)){const t={content:g.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.local.updated)){const t={content:g.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.added)){const t={content:g.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(g.remote.updated)){const t={content:g.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s],localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of g.conflicts){const t={content:a[s]?a[s].value.toString():null,hasConflicts:!0,localChange:a[s]?2:1,remoteChange:f[s]?2:1},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(a))if(!i.has(s)){const t={content:a[s]?a[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},r=a[s]?a[s].value.toString():null;i.set(s,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:l[s]??r,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:a[s]||null,localContent:r,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...i.values()]}async getAssociatedResources({uri:g}){const a=await super.resolveContent(g);if(a){const f=this.parseSyncData(a);if(f){const l=this.parseSnippets(f),i=[];for(const s of Object.keys(l)){const t=this.extUri.joinPath(g,s),r=this.extUri.joinPath(this.snippetsFolder,s),o=await this.fileService.exists(r);i.push({resource:t,comparableResource:o?r:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})})}return i}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let a=await super.resolveContent(g);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(g)),a){const f=this.parseSyncData(a);if(f)return this.parseSnippets(f)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const a={};for(const f of g)f.fileContent&&(a[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(a)))}async updateLocalSnippets(g,a){for(const{fileContent:f,acceptResult:l,localResource:i,remoteResource:s,localChange:t}of g)if(t!==0){const r=s?this.extUri.basename(s):this.extUri.basename(i),o=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,R.VSBuffer.fromString(l.content),{overwrite:a}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,R.VSBuffer.fromString(l.content),a?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,a,f){const l=a.syncData?this.parseSnippets(a.syncData):{},i=(0,D.deepClone)(l);for(const{acceptResult:s,localResource:t,remoteResource:r,remoteChange:o}of g)if(o!==0){const c=t?this.extUri.basename(t):this.extUri.basename(r);o===3?delete i[c]:i[c]=s.content}return(0,v.areSame)(l,i)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),a=await this.updateRemoteUserData(JSON.stringify(i),f?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),a}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const a={};for(const f of Object.keys(g))a[f]=g[f].value.toString();return a}async getSnippetsFileContents(){const g={};let a;try{a=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof I.FileOperationError&&f.fileOperationResult===1)return g;throw f}for(const f of a.children||[]){const l=f.resource,i=this.extUri.extname(l);if(i===".json"||i===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,l),t=await this.fileService.readFile(l);g[s]=t}}return g}};S=pe([G(1,T.IEnvironmentService),G(2,I.IFileService),G(3,E.IStorageService),G(4,h.IUserDataSyncStoreService),G(5,h.IUserDataSyncBackupStoreService),G(6,h.IUserDataSyncLogService),G(7,L.IConfigurationService),G(8,h.IUserDataSyncEnablementService),G(9,b.ITelemetryService),G(10,C.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let P=class extends m.AbstractInitializer{constructor(g,a,f,l,i){super("snippets",a,f,l,g,i)}async doInitialize(g){const a=g.syncData?JSON.parse(g.syncData.content):null;if(!a){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(a)){const i=a[l];if(i){const s=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,l);await this.fileService.createFile(s,R.VSBuffer.fromString(i)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};P=pe([G(0,I.IFileService),G(1,y.IUserDataProfilesService),G(2,T.IEnvironmentService),G(3,h.IUserDataSyncLogService),G(4,C.IUriIdentityService)],P),e.SnippetsInitializer=P}),define(ne[260],re([0,1,16,19,15,13,21,23,33,24,45,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(P,p){try{return JSON.parse(P).tasks}catch(g){return p.error(g),null}}e.getTasksContentFromSyncContent=m;let v=class extends C.AbstractFileSynchroniser{constructor(p,g,a,f,l,i,s,t,r,o,c){super(p,"tasks",s,t,r,g,a,i,o,f,l,c),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(p,g,a,f){const l=p.syncData?m(p.syncData.content,this.logService):null;g=g===null&&a?p:g;const i=g?.syncData?m(g.syncData.content,this.logService):null,s=await this.getLocalFileContent();let t=null,r=!1,o=!1,c=!1;if(l){const w=s?s.value.toString():null;if(!i||i!==w||i!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const A=S(w,l,i);t=A.content,c=A.hasConflicts,r=A.hasLocalChanged,o=A.hasRemoteChanged}}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=s.value.toString(),o=!0);const u={content:t,localChange:r?s?2:1:0,remoteChange:o?2:0,hasConflicts:c},d=s?s.value.toString():null;return[{fileContent:s,baseResource:this.baseResource,baseContent:i!==null?i:d,localResource:this.localResource,localContent:d,localChange:u.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:u.remoteChange,previewResource:this.previewResource,previewResult:u,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(p){const g=p?.syncData?m(p.syncData.content,this.logService):null;if(g===null)return!0;const a=await this.getLocalFileContent(),f=a?a.value.toString():null,l=S(f,g,g);return l.hasLocalChanged||l.hasRemoteChanged}async getMergeResult(p,g){return p.previewResult}async getAcceptResult(p,g,a,f){if(this.extUri.isEqual(g,this.localResource))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:p.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return a===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:a,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(p,g,a,f){const{fileContent:l}=a[0][0],{content:i,localChange:s,remoteChange:t}=a[0][1];if(s===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),s!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),l&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(l.value.toString()))),await this.updateLocalFileContent(i||"{}",l,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const r=JSON.stringify(this.toTasksSyncContent(i||"{}"));p=await this.updateRemoteUserData(r,f?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:p}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(p,"tasks.json"),comparableResource:g}]}async resolveContent(p){if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let g=await super.resolveContent(p);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(p)),g){const a=this.parseSyncData(g);if(a)switch(this.extUri.basename(p)){case"tasks.json":return m(a.content,this.logService)}}return null}toTasksSyncContent(p){return{tasks:p}}};v=pe([G(1,y.IUserDataSyncStoreService),G(2,y.IUserDataSyncBackupStoreService),G(3,y.IUserDataSyncLogService),G(4,n.IConfigurationService),G(5,y.IUserDataSyncEnablementService),G(6,L.IFileService),G(7,D.IEnvironmentService),G(8,T.IStorageService),G(9,I.ITelemetryService),G(10,E.IUriIdentityService)],v),e.TasksSynchroniser=v;let h=class extends C.AbstractInitializer{constructor(p,g,a,f,l){super("tasks",g,a,f,p,l),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(p){const g=p.syncData?m(p.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(g)),await this.updateLastSyncUserData(p)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};h=pe([G(0,L.IFileService),G(1,b.IUserDataProfilesService),G(2,D.IEnvironmentService),G(3,y.IUserDataSyncLogService),G(4,E.IUriIdentityService)],h),e.TasksInitializer=h;function S(P,p,g){if(P===null&&p===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(P===p)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const a=g!==P,f=g!==p;return!a&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:a&&!f?{content:P,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!a?{content:p,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:P,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[261],re([0,1,3,2,4,15,21,23,27]),function(Q,e,R,n,D,L,T,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let C=class extends n.Disposable{constructor(m,v,h,S){super(),this.storageService=m,this.telemetryService=v,this.environmentService=h,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(m.onDidChangeValue(P=>this.onDidStorageChange(P)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:m}),this.storageService.store(b,m,-1,1))}isResourceEnabled(m){return this.storageService.getBoolean((0,E.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,v){if(this.isResourceEnabled(m)!==v){const h=(0,E.getEnablementKey)(m);this.storeResourceEnablement(h,v)}}getResourceSyncStateVersion(m){}storeResourceEnablement(m,v){this.storageService.store(m,v,-1,D.isWeb?0:1)}onDidStorageChange(m){if(m.scope!==-1)return;if(b===m.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const v=E.ALL_SYNC_RESOURCES.filter(h=>(0,E.getEnablementKey)(h)===m.key)[0];if(v){this._onDidChangeResourceEnablement.fire([v,this.isResourceEnabled(v)]);return}}};C=pe([G(0,T.IStorageService),G(1,I.ITelemetryService),G(2,L.IEnvironmentService),G(3,E.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(ne[76],re([0,1,3,2,4,25,167,15,13,5,26,47,21,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",S="Safari",P="Chrome",p="Edge",g="Firefox",a="Android";function f(s){switch(s){case S:case P:case p:case g:case a:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function l(){return D.isSafari?S:D.isChrome?P:D.isEdge?p:D.isFirefox?g:D.isAndroid?a:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let i=class nt extends n.Disposable{constructor(t,r,o,c,u,d){super(),this.storageService=o,this.userDataSyncStoreService=c,this.logService=u,this.productService=d,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,y.getServiceMachineId)(t,r,o)}async getMachines(t){const r=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(c=>({...c,isCurrent:c.id===r}))}async addCurrentMachine(t){const r=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:c})=>c===r)||(o.machines.push({id:r,name:this.computeCurrentMachineName(o.machines),platform:l()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const r=await this.currentMachineIdPromise,o=await this.readMachinesData(t),c=o.machines.filter(({id:u})=>u!==r);c.length!==o.machines.length&&(o.machines=c,await this.writeMachinesData(o))}async renameMachine(t,r,o){const c=await this.readMachinesData(o),u=c.machines.find(({id:d})=>d===t);if(u){u.name=r,await this.writeMachinesData(c);const d=await this.currentMachineIdPromise;t===d&&this.storageService.store(h,r,-1,1)}}async setEnablements(t){const r=await this.readMachinesData();for(const[o,c]of t){const u=r.machines.find(d=>d.id===o);u&&(u.disabled=c?void 0:!0)}await this.writeMachinesData(r)}computeCurrentMachineName(t){const r=this.storageService.get(h,-1);if(r)return r;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${l()} (${this.productService.nameShort})`,c=new RegExp(`${(0,L.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let u=0;for(const d of t){const w=c.exec(d.name),A=w?parseInt(w[1]):0;u=A>u?A:u}return`${o} #${u+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const r=this.parse(this.userData);if(r.version!==nt.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return r}async writeMachinesData(t){const r=JSON.stringify(t),o=await this.userDataSyncStoreService.writeResource(nt.RESOURCE,r,this.userData?.ref||null);this.userData={ref:o,content:r},this._onDidChange.fire()}async readUserData(t){if(this.userData){const r=t&&t.latest?t.latest[nt.RESOURCE]:void 0;if(this.userData.ref===r)return this.userData;if(r===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(nt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(r){this.logService.error(r)}return{version:nt.VERSION,machines:[]}}};i.VERSION=1,i.RESOURCE="machines",i=pe([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,m.IStorageService),G(3,v.IUserDataSyncStoreService),G(4,v.IUserDataSyncLogService),G(5,C.IProductService)],i),e.UserDataSyncMachinesService=i}),define(ne[262],re([0,1,6,63,38,9,3,2,4,17,7,165,26,21,23,27,73,76]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",a="sync.sessionId",f="sync.storeUrl",l="sync.productQuality";let i=class extends I.Disposable{constructor(r,o,c,u,d,w,A,O,_,M){super(),this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncEnablementService=u,this.userDataSyncService=d,this.logService=w,this.userDataSyncAccountService=A,this.telemetryService=O,this.userDataSyncMachinesService=_,this.storageService=M,this.autoSync=this._register(new I.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=r.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(A.onDidChangeAccount(()=>this.updateAutoSync())),this._register(c.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(d.onDidChangeLocal(k=>this.triggerSync([k],!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,k])=>k)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const r=this.storageService.get(f,-1);return r?C.URI.parse(r):void 0}set syncUrl(r){r?this.storageService.store(f,r.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(l,-1)}set productQuality(r){r?this.storageService.store(l,r,-1,1):this.storageService.remove(l,-1)}updateAutoSync(){const{enabled:r,message:o}=this.isAutoSyncEnabled();r?this.autoSync.value===void 0&&(this.autoSync.value=new s(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(c=>this.onDidFinishSync(c))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(r,o,c){try{this.userDataSyncAccountService.account&&!c&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,-1),r?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(u){if(o)this.logService.error(u),this.updateEnablement(!1);else throw u}}updateEnablement(r){this.userDataSyncEnablementService.isEnabled()!==r&&(this.userDataSyncEnablementService.setEnablement(r),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(r){if(!r){this.successiveFailures=0;return}const o=S.UserDataSyncError.toUserDataSyncError(r);o instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?E.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,R.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(r,o,c){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...r),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",c)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};i=pe([G(0,m.IProductService),G(1,S.IUserDataSyncStoreManagementService),G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncEnablementService),G(4,S.IUserDataSyncService),G(5,S.IUserDataSyncLogService),G(6,P.IUserDataSyncAccountService),G(7,h.ITelemetryService),G(8,p.IUserDataSyncMachinesService),G(9,v.IStorageService)],i),e.UserDataAutoSyncService=i;class s extends I.Disposable{constructor(r,o,c,u,d,w,A,O){super(),this.lastSyncUrl=r,this.interval=o,this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=u,this.userDataSyncService=d,this.userDataSyncMachinesService=w,this.logService=A,this.storageService=O,this.intervalHandler=this._register(new I.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,I.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(s.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(s.INTERVAL_SYNCING,!1),this.interval)}sync(r,o){const c=(0,R.createCancelablePromise)(async u=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,L.isCancellationError)(d))return}return this.doSync(r,o,u)});return this.syncPromise=c,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const r=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!r&&(!(0,b.isEqual)(o.defaultUrl,r.defaultUrl)||!(0,b.isEqual)(o.insidersUrl,r.insidersUrl)||!(0,b.isEqual)(o.stableUrl,r.stableUrl))}async doSync(r,o,c){this.logService.info(`Auto Sync: Triggered by ${r}`),this._onDidStartSync.fire();let u;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),c.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,y.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,y.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,y.localize)(2,null),"TurnedOff");const d=this.storageService.get(a,-1);if(d&&this.manifest&&d!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,y.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,y.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,y.localize)(5,null),"SessionExpired");const w=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(c.isCancellationRequested)return;const A=w.find(O=>O.isCurrent);if(A?.disabled)throw new S.UserDataAutoSyncError((0,y.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new S.UserDataAutoSyncError((0,D.toErrorMessage)(O),O instanceof S.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==d&&this.storageService.store(a,this.manifest.session,-1,1),c.isCancellationRequested)return;A||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(d){this.logService.error(d),u=d}this._onDidFinishSync.fire(u)}register(r){return super._register(r)}}s.INTERVAL_SYNCING="Interval"}),define(ne[77],re([0,1,2,67,5,21]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataSyncProfilesStorageService=e.IUserDataSyncProfilesStorageService=void 0,e.IUserDataSyncProfilesStorageService=(0,D.createDecorator)("IUserDataSyncProfilesStorageService");let T=class extends R.Disposable{constructor(b){super(),this.storageService=b}async readStorageData(b){if(this.storageService.hasScope(b))return this.getItems(this.storageService);const C=await this.createStorageDatabase(b),y=new I(C);try{return await y.initialize(),this.getItems(y)}finally{y.dispose(),await this.closeAndDispose(C)}}async updateStorageData(b,C,y){if(this.storageService.hasScope(b))return this.writeItems(this.storageService,C,y);const m=await this.createStorageDatabase(b),v=new I(m);try{await v.initialize(),this.writeItems(v,C,y),await v.flush()}finally{v.dispose(),await this.closeAndDispose(m)}}getItems(b){const C=new Map,y=m=>{for(const v of b.keys(0,m))C.set(v,{value:b.get(v,0),target:m})};return y(0),y(1),C}writeItems(b,C,y){for(const[m,v]of C)b.store(m,v,0,y)}async closeAndDispose(b){try{await b.close()}finally{(0,R.isDisposable)(b)&&b.dispose()}}};T=pe([G(0,L.IStorageService)],T),e.AbstractUserDataSyncProfilesStorageService=T;class I extends L.AbstractStorageService{constructor(b){super({flushInterval:100}),this.profileStorage=this._register(new n.Storage(b))}doInitialize(){return this.profileStorage.init()}getStorage(b){return b===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ne[263],re([0,1,16,9,3,35,52,4,7,30,19,15,13,8,47,21,23,33,45,61,240,27,24,77]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const t="globalState.argv.",r=["locale"];function o(A,O){const _=A.storage?Object.keys(A.storage).sort():[],M={};return _.forEach(k=>M[k]=A.storage[k]),A.storage=M,O?(0,T.toFormattedString)(A,{}):JSON.stringify(A)}const c=1;let u=class mt extends g.AbstractSynchroniser{constructor(O,_,M,k,F,$,q,J,H,K,W,B){super("globalState",M,q,W,k,F,J,H,$,K,B),this.profile=O,this.userDataSyncProfilesStorageService=_,this.version=c,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(M.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(M.onDidFilesChange,Y=>Y.contains(this.environmentService.argvResource)),D.Event.filter(this.userDataSyncProfilesStorageService.onDidChange,Y=>!!(Y.targetChanges.some(te=>this.profile.id===te.id)||Y.valueChanges.some(({profile:te,changes:ce})=>this.profile.id===te.id&&ce.some(z=>z.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(O,_,M){const k=O.syncData?JSON.parse(O.syncData.content):null;_=_===null&&M?O:_;const F=_&&_.syncData?JSON.parse(_.syncData.content):null,$=await this.getLocalGlobalState();k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=await this.getStorageKeys(F),{local:J,remote:H}=(0,f.merge)($.storage,k?k.storage:null,F?F.storage:null,q,this.logService),K={content:null,local:J,remote:H,localChange:Object.keys(J.added).length>0||Object.keys(J.updated).length>0||J.removed.length>0?2:0,remoteChange:H!==null?2:0},W=o($,!1);return[{baseResource:this.baseResource,baseContent:F?o(F,!1):W,localResource:this.localResource,localContent:W,localUserData:$,remoteResource:this.remoteResource,remoteContent:k?o(k,!1):null,previewResource:this.previewResource,previewResult:K,localChange:K.localChange,remoteChange:K.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async hasRemoteChanged(O){const _=O.syncData?JSON.parse(O.syncData.content):null;if(_===null)return!0;const M=await this.getLocalGlobalState(),k=await this.getStorageKeys(_),{remote:F}=(0,f.merge)(M.storage,_.storage,_.storage,k,this.logService);return F!==null}async getMergeResult(O,_){return{...O.previewResult,hasConflicts:!1}}async getAcceptResult(O,_,M,k){if(this.extUri.isEqual(_,this.localResource))return this.acceptLocal(O);if(this.extUri.isEqual(_,this.remoteResource))return this.acceptRemote(O);if(this.extUri.isEqual(_,this.previewResource))return O.previewResult;throw new Error(`Invalid Resource: ${_.toString()}`)}async acceptLocal(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:O.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(O){if(O.remoteContent!==null){const _=JSON.parse(O.remoteContent),{local:M,remote:k}=(0,f.merge)(O.localUserData.storage,_.storage,null,O.storageKeys,this.logService);return{content:O.remoteContent,local:M,remote:k,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(O,_,M,k){const{localUserData:F}=M[0][0],{local:$,remote:q,localChange:J,remoteChange:H}=M[0][1];if(J===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),J!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),H!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const K=JSON.stringify({storage:q});O=await this.updateRemoteUserData(K,k?null:O.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}_?.ref!==O.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(O),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:O}){return[{resource:this.extUri.joinPath(O,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(O){if(this.extUri.isEqual(O,mt.GLOBAL_STATE_DATA_URI)){const M=await this.getLocalGlobalState();return o(M,!0)}if(this.extUri.isEqual(this.remoteResource,O)||this.extUri.isEqual(this.baseResource,O)||this.extUri.isEqual(this.localResource,O)||this.extUri.isEqual(this.acceptedResource,O)){const M=await this.resolvePreviewContent(O);return M&&o(JSON.parse(M),!0)}let _=await super.resolveContent(O);if(_)return _;if(_=await super.resolveContent(this.extUri.dirname(O)),_){const M=this.parseSyncData(_);if(M)switch(this.extUri.basename(O)){case"globalState.json":return o(JSON.parse(M.content),!0)}}return null}async hasLocalData(){try{const{storage:O}=await this.getLocalGlobalState();if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const O={},_=await this.getLocalArgvContent(),M=(0,L.parse)(_);for(const F of r)M[F]!==void 0&&(O[`${t}${F}`]={version:1,value:M[F]});const k=await this.userDataSyncProfilesStorageService.readStorageData(this.profile);for(const[F,$]of k)$.value&&$.target===0&&(O[F]={version:1,value:$.value});return{storage:O}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const O=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),O.value.toString()}catch(O){this.logService.debug((0,n.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:_,updated:M}){const k={},F=new Map,$=await this.userDataSyncProfilesStorageService.readStorageData(this.profile),q=(J,H)=>{for(const K of J){if(K.startsWith(t)){k[K.substring(t.length)]=H?H[K].value:void 0;continue}if(H){const W=H[K];W.value!==$.get(K)?.value&&F.set(K,W.value)}else $.get(K)!==void 0&&F.set(K,void 0)}};q(Object.keys(O),O),q(Object.keys(M),M),q(_),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),F.size&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`),await this.userDataSyncProfilesStorageService.updateStorageData(this.profile,F,0),this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,[...F.keys()]))}async updateArgv(O){const _=await this.getLocalArgvContent();let M=_;for(const k of Object.keys(O))M=(0,a.edit)(M,[k],O[k],{});_!==M&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(M)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}async getStorageKeys(O){const _=await this.userDataSyncProfilesStorageService.readStorageData(this.profile),M=[],k=[];for(const[q,J]of _)J.target===0?M.push(q):J.target===1&&k.push(q);const F=[...M,...k],$=O?.storage?Object.keys(O.storage).filter(q=>!q.startsWith(t)&&!F.includes(q)&&_.get(q)!==void 0):[];if(!I.isWeb){const q=[...l.ALL_SYNC_RESOURCES.map(J=>(0,l.getEnablementKey)(J)),l.SYNC_SERVICE_URL_TYPE];$.push(...q),k.push(...q)}return{user:M,machine:k,unregistered:$}}};u.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),u=pe([G(1,s.IUserDataSyncProfilesStorageService),G(2,m.IFileService),G(3,l.IUserDataSyncStoreService),G(4,l.IUserDataSyncBackupStoreService),G(5,l.IUserDataSyncLogService),G(6,y.IEnvironmentService),G(7,l.IUserDataSyncEnablementService),G(8,P.ITelemetryService),G(9,C.IConfigurationService),G(10,S.IStorageService),G(11,p.IUriIdentityService)],u),e.GlobalStateSynchroniser=u;let d=class extends g.AbstractInitializer{constructor(O,_,M,k,F,$){super("globalState",M,k,F,_,$),this.storageService=O}async doInitialize(O){const _=O.syncData?JSON.parse(O.syncData.content):null;if(!_){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const M={},k={};for(const F of Object.keys(_.storage))F.startsWith(t)?M[F.substring(t.length)]=_.storage[F].value:this.storageService.get(F,0)===void 0&&(k[F]=_.storage[F].value);if(Object.keys(M).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(M))F=(0,a.edit)(F,[$],M[$],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(F))}if(Object.keys(k).length)for(const F of Object.keys(k))this.storageService.store(F,k[F],0,0)}};d=pe([G(0,S.IStorageService),G(1,m.IFileService),G(2,i.IUserDataProfilesService),G(3,y.IEnvironmentService),G(4,l.IUserDataSyncLogService),G(5,p.IUriIdentityService)],d),e.GlobalStateInitializer=d;let w=class{constructor(O,_,M,k,F){this.userDataSyncStoreClient=O,this.storageService=_,this.environmentService=M,this.fileService=k,this.logService=F}getSyncStoreType(O){return this.parseGlobalState(O)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const _=(0,l.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(O,_)}catch(M){if(M instanceof l.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(O,_)}throw M}}async doSync(O,_){const M=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,_),k=this.parseGlobalState(M)||{storage:{}};k.storage[l.SYNC_SERVICE_URL_TYPE]={value:O,version:c};const F=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:c,machineId:F,content:o(k,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify($),M.ref,void 0,_)}parseGlobalState({content:O}){if(!O)return null;const _=JSON.parse(O);if((0,g.isSyncData)(_))return _?JSON.parse(_.content):null;throw new Error("Invalid remote data")}};w=pe([G(1,S.IStorageService),G(2,y.IEnvironmentService),G(3,m.IFileService),G(4,v.ILogService)],w),e.UserDataSyncStoreTypeSynchronizer=w}),define(ne[264],re([0,1,18,6,38,3,2,17,14,30,19,29,5,21,23,24,256,263,257,258,259,260,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let t=class extends T.Disposable{constructor(O,_,M,k,F,$,q,J,H){super(),this.userDataSyncStoreService=O,this.userDataSyncStoreManagementService=_,this.instantiationService=M,this.configurationService=k,this.logService=F,this.telemetryService=$,this.storageService=q,this.userDataSyncEnablementService=J,this.userDataProfilesService=H,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this._status=_.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(s,-1,void 0),this._register((0,T.toDisposable)(()=>this.clearProfileSynchronizers()))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(O,_){this.checkEnablement();const M=(0,b.generateUuid)();try{const q=(0,i.createSyncHeaders)(M);_&&(q["Cache-Control"]="no-cache"),O=await this.userDataSyncStoreService.manifest(O,q)}catch(q){const J=i.UserDataSyncError.toUserDataSyncError(q);throw d(J,M,this.userDataSyncStoreManagementService,this.telemetryService),J}const k=!1,F=this;let $;return{manifest:O,async run(){if(k)throw new Error("Can run a task only once");return $=(0,n.createCancelablePromise)(q=>F.sync(O,M,q)),$.finally(()=>$=void 0)},stop(){return $?.cancel(),F.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new i.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const O=(0,b.generateUuid)(),_=(0,i.createSyncHeaders)(O);let M;try{M=await this.userDataSyncStoreService.manifest(null,_)}catch($){const q=i.UserDataSyncError.toUserDataSyncError($);throw d(q,O,this.userDataSyncStoreManagementService,this.telemetryService),q}await this.resetLocal();const k=this.getProfileSynchronizers(),F=async()=>{await this.stop(),await this.resetLocal()};return new r(O,M,_,k[0].enabled,F,this.configurationService,this.logService)}async sync(O,_,M){if(M.isCancellationRequested)return;const k=this.getProfileSynchronizers(),F=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");for(const $ of k){if(M.isCancellationRequested)return;this._syncErrors.push(...await $.sync(O,_,M))}this.logService.info(`Sync done. Took ${new Date().getTime()-F}ms`),this.updateLastSyncTime()}finally{this._onSyncErrors.fire(this._syncErrors)}}async stop(){this.status!=="idle"&&this.profileSynchronizers&&await Promise.allSettled([...this.profileSynchronizers.values()].map(([O])=>O.stop()))}async replace(O){this.checkEnablement(),await this.performSynchronizerAction(async _=>{if(await _.replace(O))return!0})}async accept(O,_,M,k){this.checkEnablement(),await this.performSynchronizerAction(async F=>{if(F.resource===O)return await F.accept(_,M),k&&await F.apply(!1,(0,i.createSyncHeaders)((0,b.generateUuid)())),!0})}async resolveContent(O){return this.performSynchronizerAction(async _=>{const M=await _.resolveContent(O);if(M)return M})}async getRemoteSyncResourceHandles(O){return await this.performSynchronizerAction(async M=>{if(M.resource===O)return M.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(O){return await this.performSynchronizerAction(async M=>{if(M.resource===O)return M.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(O,_){return await this.performSynchronizerAction(async k=>{if(k.resource===O)return k.getAssociatedResources(_)})||[]}async getMachineId(O,_){return await this.performSynchronizerAction(async k=>{if(k.resource===O)return await k.getMachineId(_)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async _=>{if(_.resource!=="globalState"&&await _.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async _=>{if(await _.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(O){this.logService.error(O)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(s,-1),this.profileSynchronizers){for(const[O]of this.profileSynchronizers.values())try{await O.resetLocal()}catch(_){this.logService.error(_)}this.clearProfileSynchronizers()}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(O){const _=new T.DisposableStore;try{let M=this.profileSynchronizers;M||(M=this.createProfileSynchronizers(),M.forEach(([,k])=>_.add(k)));for(const[k]of M.values()){const F=[...k.enabled,...k.disabled.map($=>_.add(k.createSynchronizer($)))];for(const $ of F){const q=await O($);if(!(0,E.isUndefined)(q))return q}}return null}finally{_.dispose()}}setStatus(O){const _=this._status;this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O),_==="hasConflicts"&&this.updateLastSyncTime())}setConflicts(O){(0,R.equals)(this._conflicts,O,([_,M],[k,F])=>_===_&&(0,R.equals)(M,F,($,q)=>(0,I.isEqual)($.previewResource,q.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getProfileSynchronizers(){return this.profileSynchronizers||(this.profileSynchronizers=this.createProfileSynchronizers()),[...this.profileSynchronizers.values()].map(([O])=>O)}createProfileSynchronizers(){const O=new Map;for(const _ of[this.userDataProfilesService.defaultProfile]){const M=new T.DisposableStore,k=M.add(_.isDefault?this.instantiationService.createInstance(c):this.instantiationService.createInstance(o,_));M.add(k.onDidChangeStatus(F=>this.setStatus(F))),M.add(k.onDidChangeConflicts(F=>this.setConflicts(F))),M.add(k.onDidChangeLocal(F=>this._onDidChangeLocal.fire(F))),O.set(_.id,[k,M])}return O}clearProfileSynchronizers(){this.profileSynchronizers&&(this.profileSynchronizers.forEach(([,O])=>O.dispose()),this.profileSynchronizers.clear(),this.profileSynchronizers=void 0)}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};t=pe([G(0,i.IUserDataSyncStoreService),G(1,i.IUserDataSyncStoreManagementService),G(2,m.IInstantiationService),G(3,C.IConfigurationService),G(4,i.IUserDataSyncLogService),G(5,h.ITelemetryService),G(6,v.IStorageService),G(7,i.IUserDataSyncEnablementService),G(8,S.IUserDataProfilesService)],t),e.UserDataSyncService=t;class r extends T.Disposable{constructor(O,_,M,k,F,$,q){super(),this.id=O,this.manifest=_,this.syncHeaders=M,this.synchronisers=k,this.onStop=F,this.configurationService=$,this.logService=q,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(O=>O.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(O=>O.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(O=>this.getPreviews(O))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(O){throw this.logService.error(O),O}}async accept(O,_){try{return await this.performAction(O,M=>M.accept(O,_))}catch(M){throw this.logService.error(M),M}}async merge(O){try{return O?await this.performAction(O,_=>_.merge(O)):await this.mergeAll()}catch(_){throw this.logService.error(_),_}}async discard(O){try{return await this.performAction(O,_=>_.discard(O))}catch(_){throw this.logService.error(_),_}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const O=[];for(const[,_]of this.previews)for(const M of _.resourcePreviews)M.mergeState==="conflict"&&O.push(M.previewResource);for(const _ of O)await this.discard(_);return this.previews}catch(O){throw this.logService.error(O),O}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const O=[];for(const[_,M]of this.previews){this.synchronizingResources.push([_,M.resourcePreviews.map($=>$.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const k=this.synchronisers.find($=>$.resource===_);for(const $ of M.resourcePreviews)($.localChange!==0||$.remoteChange!==0)&&$.mergeState==="preview"&&await k.merge($.previewResource);const F=await k.apply(!1,this.syncHeaders);F&&O.push(this.toSyncResourcePreview(k.resource,F)),this.synchronizingResources.splice(this.synchronizingResources.findIndex($=>$[0]===_),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=O,this.previews}catch(O){throw this.logService.error(O),O}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[O,_]of this.previews){this.synchronizingResources.push([O,_.resourcePreviews.map(k=>k.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const M=this.synchronisers.find(k=>k.resource===O);for(const k of _.resourcePreviews)await M.accept(k.remoteResource);await M.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(k=>k[0]===O),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(O){throw this.logService.error(O),O}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[O,_]of this.previews){this.synchronizingResources.push([O,_.resourcePreviews.map(k=>k.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const M=this.synchronisers.find(k=>k.resource===O);for(const k of _.resourcePreviews)await M.accept(k.localResource);await M.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(k=>k[0]===O),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(O){throw this.logService.error(O),O}}async stop(){await this.onStop(),this.reset()}async performAction(O,_){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const M=this.previews.findIndex(([,W])=>W.resourcePreviews.some(({localResource:B,previewResource:Y,remoteResource:te})=>(0,I.isEqual)(O,B)||(0,I.isEqual)(O,Y)||(0,I.isEqual)(O,te)));if(M===-1)return this.previews;const[k,F]=this.previews[M],$=F.resourcePreviews.find(({localResource:W,remoteResource:B,previewResource:Y})=>(0,I.isEqual)(W,O)||(0,I.isEqual)(B,O)||(0,I.isEqual)(Y,O));if(!$)return this.previews;let q=this.synchronizingResources.find(W=>W[0]===k);q||(q=[k,[]],this.synchronizingResources.push(q)),q[1].some(W=>(0,I.isEqual)(W,$.localResource))||(q[1].push($.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const J=this.synchronisers.find(W=>W.resource===this.previews[M][0]),H=await _(J);H?this.previews.splice(M,1,this.toSyncResourcePreview(J.resource,H)):this.previews.splice(M,1);const K=this.synchronizingResources.findIndex(W=>W[0]===k);return this.synchronizingResources[K][1].splice(q[1].findIndex(W=>(0,I.isEqual)(W,$.localResource)),1),q[1].length||(this.synchronizingResources.splice(K,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const O=[];for(const[_,M]of this.previews){this.synchronizingResources.push([_,M.resourcePreviews.map($=>$.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const k=this.synchronisers.find($=>$.resource===_);let F=M;for(const $ of M.resourcePreviews)($.localChange!==0||$.remoteChange!==0)&&$.mergeState==="preview"&&(F=await k.merge($.previewResource));F&&O.push(this.toSyncResourcePreview(k.resource,F)),this.synchronizingResources.splice(this.synchronizingResources.findIndex($=>$[0]===_),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=O,this.previews}async getPreviews(O){const _=[],M=await this.getUserDataSyncConfiguration();for(const k of this.synchronisers){if(O.isCancellationRequested)return[];const F=await k.preview(this.manifest,M,this.syncHeaders);F&&_.push(this.toSyncResourcePreview(k.resource,F))}return _}async getUserDataSyncConfiguration(){const O=this.configurationService.getValue(i.USER_DATA_SYNC_CONFIGURATION_SCOPE),_=this.synchronisers.find(M=>M instanceof a.SettingsSynchroniser);if(_){const M=await _.getRemoteUserDataSyncConfiguration(this.manifest);return{...O,...M}}return O}toSyncResourcePreview(O,_){return[O,{isLastSyncFromCurrentMachine:_.isLastSyncFromCurrentMachine,resourcePreviews:_.resourcePreviews.map(w)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let o=class extends T.Disposable{constructor(O,_,M,k,F,$,q){super(),this.profile=O,this.userDataSyncEnablementService=_,this.instantiationService=M,this.extensionGalleryService=k,this.userDataSyncStoreManagementService=F,this.telemetryService=$,this.logService=q,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(_.onDidChangeResourceEnablement(([J,H])=>this.onDidChangeResourceEnablement(J,H))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,J])=>J.dispose())));for(const J of i.ALL_SYNC_RESOURCES)_.isResourceEnabled(J)&&this.registerSynchronizer(J)}get enabled(){return this._enabled.sort((O,_)=>O[1]-_[1]).map(([O])=>O)}get disabled(){return i.ALL_SYNC_RESOURCES.filter(O=>!this.userDataSyncEnablementService.isResourceEnabled(O))}get status(){return this._status}get conflicts(){return this._conflicts}onDidChangeResourceEnablement(O,_){_?this.registerSynchronizer(O):this.deRegisterSynchronizer(O)}registerSynchronizer(O){if(this._enabled.some(([F])=>F.resource===O))return;if(O==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const _=new T.DisposableStore,M=_.add(this.createSynchronizer(O));_.add(M.onDidChangeStatus(()=>this.updateStatus())),_.add(M.onDidChangeConflicts(()=>this.updateConflicts())),_.add(M.onDidChangeLocal(()=>this._onDidChangeLocal.fire(O)));const k=this.getOrder(O);this._enabled.push([M,k,_])}deRegisterSynchronizer(O){const _=this._enabled.findIndex(([M])=>M.resource===O);if(_!==-1){const M=this._enabled.splice(_,1);for(const[k,,F]of M){if(k.status!=="idle"){const $=k.conflicts.length>0;k.stop(),$&&this.updateConflicts(),this.updateStatus()}F.dispose()}}}createSynchronizer(O){switch(O){case"settings":return this.instantiationService.createInstance(a.SettingsSynchroniser,this.profile.settingsResource);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser,this.profile.keybindingsResource);case"snippets":return this.instantiationService.createInstance(f.SnippetsSynchroniser,this.profile.snippetsHome);case"tasks":return this.instantiationService.createInstance(l.TasksSynchroniser,this.profile.tasksResource);case"globalState":return this.instantiationService.createInstance(p.GlobalStateSynchroniser,this.profile);case"extensions":return this.instantiationService.createInstance(P.ExtensionsSynchroniser,this.profile.extensionsResource)}}async sync(O,_,M){if(M.isCancellationRequested)return[];const k=this.enabled;if(!k.length)return[];try{const F=[],$=(0,i.createSyncHeaders)(_);for(const q of k){if(M.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(q.resource))return[];try{await q.sync(O,$)}catch(J){const H=i.UserDataSyncError.toUserDataSyncError(J);if(d(H,_,this.userDataSyncStoreManagementService,this.telemetryService),u(J))throw H;this.logService.error(J),this.logService.error(`${q.resource}: ${(0,D.toErrorMessage)(J)}`),F.push([q.resource,H])}}return F}finally{this.updateStatus()}}async stop(){for(const O of this.enabled)try{O.status!=="idle"&&await O.stop()}catch(_){this.logService.error(_)}}async resetLocal(){for(const O of this.enabled)try{await O.resetLocal()}catch(_){this.logService.error(`${O.resource}: ${(0,D.toErrorMessage)(_)}`),this.logService.error(_)}}setStatus(O){this._status!==O&&(this._status=O,this._onDidChangeStatus.fire(O))}updateStatus(){return this.updateConflicts(),this.enabled.some(O=>O.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(O=>O.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const O=this.enabled.filter(_=>_.status==="hasConflicts").map(_=>[_.resource,_.conflicts.map(w)]);(0,R.equals)(this._conflicts,O,([_,M],[k,F])=>_===_&&(0,R.equals)(M,F,($,q)=>(0,I.isEqual)($.previewResource,q.previewResource)))||(this._conflicts=O,this._onDidChangeConflicts.fire(O))}getOrder(O){switch(O){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};o=pe([G(1,i.IUserDataSyncEnablementService),G(2,m.IInstantiationService),G(3,y.IExtensionGalleryService),G(4,i.IUserDataSyncStoreManagementService),G(5,h.ITelemetryService),G(6,i.IUserDataSyncLogService)],o);let c=class extends o{constructor(O,_,M,k,F,$,q){super(O.defaultProfile,_,M,k,F,$,q),this._register(O.onDidChangeProfiles(()=>{(O.defaultProfile.extensionsResource&&!this.profile.extensionsResource||!O.defaultProfile.extensionsResource&&this.profile.extensionsResource)&&(this.deRegisterSynchronizer("extensions"),this.profile=O.defaultProfile,this.registerSynchronizer("extensions"))}))}};c=pe([G(0,S.IUserDataProfilesService),G(1,i.IUserDataSyncEnablementService),G(2,m.IInstantiationService),G(3,y.IExtensionGalleryService),G(4,i.IUserDataSyncStoreManagementService),G(5,h.ITelemetryService),G(6,i.IUserDataSyncLogService)],c);function u(A){if(A instanceof i.UserDataSyncError)switch(A.code){case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function d(A,O,_,M){M.publicLog2("sync/error",{code:A.code,serverCode:A instanceof i.UserDataSyncStoreError?String(A.serverCode):void 0,url:A instanceof i.UserDataSyncStoreError?A.url:void 0,resource:A.resource,executionId:O,service:_.userDataSyncStore.url.toString()})}function w(A){return{baseResource:A.baseResource,localResource:A.localResource,previewResource:A.previewResource,remoteResource:A.remoteResource,acceptedResource:A.acceptedResource,localChange:A.localChange,remoteChange:A.remoteChange,mergeState:A.mergeState}}}),define(ne[265],re([0,1,6,22,9,3,2,127,4,17,14,7,30,19,15,13,26,44,47,21,27]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",i="sync.donot-make-requests-until",s="sync.user-session-id",t="sync.machine-session-id",r=100,o=1e3*60*5;let c=class extends T.Disposable{constructor(_,M,k){super(),this.productService=_,this.configurationService=M,this.storageService=k,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(k.onDidChangeValue,F=>F.key===f.SYNC_SERVICE_URL_TYPE&&F.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(_){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,_,-1,E.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(_,M){_=E.isWeb&&_?.web?{..._,..._.web}:_;const k={..._||{},...M||{}};if(k&&(0,C.isString)(k.url)&&(0,C.isObject)(k.authenticationProviders)&&Object.keys(k.authenticationProviders).every(F=>Array.isArray(k.authenticationProviders[F].scopes))){const F=k,$=!!F.canSwitch&&!M?.url,q=F.url===F.insidersUrl?"insiders":"stable",J=($?this.userDataSyncStoreType:void 0)||q,H=M?.url||(J==="insiders"?F.insidersUrl:J==="stable"?F.stableUrl:F.url);return{url:y.URI.parse(H),type:J,defaultType:q,defaultUrl:y.URI.parse(F.url),stableUrl:y.URI.parse(F.stableUrl),insidersUrl:y.URI.parse(F.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(F.authenticationProviders).reduce((K,W)=>(K.push({id:W,scopes:F.authenticationProviders[W].scopes}),K),[])}}}};c=pe([G(0,P.IProductService),G(1,v.IConfigurationService),G(2,a.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let u=class extends c{constructor(_,M,k){super(_,M,k);const F=this.storageService.get(l,-1);F&&(this.previousConfigurationSyncStore=JSON.parse(F));const $=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),-1,1):this.storageService.remove(l,-1)}async switch(_){_!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=_,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=pe([G(0,P.IProductService),G(1,v.IConfigurationService),G(2,a.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let d=class extends T.Disposable{constructor(_,M,k,F,$,q,J){super(),this.requestService=k,this.logService=F,this.storageService=J,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(_),this.commonHeadersPromise=(0,g.getServiceMachineId)($,q,J).then(H=>{const K={"X-Client-Name":`${M.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(K["X-Client-Commit"]=M.commit),K}),this.session=new A(r,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(_,M){this.authToken={token:_,type:M}}updateUserDataSyncStoreUrl(_){this.userDataSyncStoreUrl=_?(0,b.joinPath)(_,"v1"):void 0}initDonotMakeRequestsUntil(){const _=this.storageService.getNumber(i,-1);_&&Date.now()<_&&this.setDonotMakeRequestsUntil(new Date(_))}setDonotMakeRequestsUntil(_){this._donotMakeRequestsUntil?.getTime()!==_?.getTime()&&(this._donotMakeRequestsUntil=_,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(M=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),M).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,M=>null)):this.storageService.remove(i,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]="application/json";const k=await this.request(M,{type:"GET",headers:_},[],n.CancellationToken.None);return await(0,p.asJson)(k)||[]}async createCollection(_={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();_={..._},_["Content-Type"]=I.Mimes.text;const k=await this.request(M,{type:"POST",headers:_},[],n.CancellationToken.None),F=await(0,p.asTextOrError)(k);if(!F)throw new f.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",k.res.statusCode,k.res.headers[f.HEADER_OPERATION_ID]);return F}async deleteCollection(_,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=_?(0,b.joinPath)(this.userDataSyncStoreUrl,"collection",_).toString():(0,b.joinPath)(this.userDataSyncStoreUrl,"collection").toString();M={...M},await this.request(k,{type:"DELETE",headers:M},[],n.CancellationToken.None)}async getAllResourceRefs(_,M){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=this.getResourceUrl(this.userDataSyncStoreUrl,M,_),F={},$=await this.request(k.toString(),{type:"GET",headers:F},[],n.CancellationToken.None);return(await(0,p.asJson)($)||[]).map(({url:J,created:H})=>({ref:(0,b.relativePath)(k,k.with({path:J})),created:H*1e3}))}async resolveResourceContent(_,M,k,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),M).toString();F={...F},F["Cache-Control"]="no-cache";const q=await this.request($,{type:"GET",headers:F},[],n.CancellationToken.None);return await(0,p.asTextOrError)(q)}async deleteResource(_,M,k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=M!==null?(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),M).toString():this.getResourceUrl(this.userDataSyncStoreUrl,k,_).toString(),$={};await this.request(F,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),M={"Content-Type":I.Mimes.text};await this.request(_,{type:"DELETE",headers:M},[],n.CancellationToken.None)}async readResource(_,M,k,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,k,_),"latest").toString();F={...F},F["Cache-Control"]="no-cache",M&&(F["If-None-Match"]=M.ref);const q=await this.request($,{type:"GET",headers:F},[304],n.CancellationToken.None);let J=null;if(q.res.statusCode===304&&(J=M),J===null){const H=q.res.headers.etag;if(!H)throw new f.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);const K=await(0,p.asTextOrError)(q);if(!K&&q.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",$,"EmptyResponse",q.res.statusCode,q.res.headers[f.HEADER_OPERATION_ID]);J={ref:H,content:K}}return J}async writeResource(_,M,k,F,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=this.getResourceUrl(this.userDataSyncStoreUrl,F,_).toString();$={...$},$["Content-Type"]=I.Mimes.text,k&&($["If-Match"]=k);const J=await this.request(q,{type:"POST",data:M,headers:$},[],n.CancellationToken.None),H=J.res.headers.etag;if(!H)throw new f.UserDataSyncStoreError("Server did not return the ref",q,"NoRef",J.res.statusCode,J.res.headers[f.HEADER_OPERATION_ID]);return H}async manifest(_,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();M={...M},M["Content-Type"]="application/json",_&&(M["If-None-Match"]=_.ref);const F=await this.request(k,{type:"GET",headers:M},[304],n.CancellationToken.None);let $=null;if(F.res.statusCode===304&&($=_),!$){const J=F.res.headers.etag;if(!J)throw new f.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",F.res.statusCode,F.res.headers[f.HEADER_OPERATION_ID]);const H=await(0,p.asTextOrError)(F);if(!H&&F.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",k,"EmptyResponse",F.res.statusCode,F.res.headers[f.HEADER_OPERATION_ID]);H&&($={...JSON.parse(H),ref:J})}const q=this.storageService.get(s,-1);return q&&$&&q!==$.session&&this.clearSession(),$===null&&q&&this.clearSession(),$&&this.storageService.store(s,$.session,-1,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteResources(),await this.deleteCollection(),this.clearSession()}getResourceUrl(_,M,k){return M?(0,b.joinPath)(_,"collection",M,"resource",k):(0,b.joinPath)(_,"resource",k)}clearSession(){this.storageService.remove(s,-1),this.storageService.remove(t,-1)}async request(_,M,k,F){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",_,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;M.headers={...M.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(M.headers),this.logService.trace("Sending request to server",{url:_,type:M.type,headers:{...M.headers,authorization:void 0}});let q;try{q=await this.session.request(_,M,F)}catch(W){if(!(W instanceof f.UserDataSyncStoreError)){let B="RequestFailed";const Y=(0,D.getErrorMessage)(W).toLowerCase();Y.includes("xhr timeout")?B="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?B="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":Y.includes("headers must be an object")?B="RequestHeadersNotObject":(0,D.isCancellationError)(W)&&(B="RequestCanceled"),W=new f.UserDataSyncStoreError(`Connection refused for the request '${_}'.`,_,B,void 0,void 0)}throw this.logService.info("Request failed",_),W}const J=q.res.headers[f.HEADER_OPERATION_ID],H={url:_,status:q.res.statusCode,"execution-id":M.headers[f.HEADER_EXECUTION_ID],"operation-id":J},K=(0,p.isSuccess)(q)||q.res.statusCode&&k.indexOf(q.res.statusCode)!==-1;if(K?this.logService.trace("Request succeeded",H):this.logService.info("Request failed",H),q.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${_}' failed because of Unauthorized (401).`,_,"Unauthorized",q.res.statusCode,J);if(this._onTokenSucceed.fire(),q.res.statusCode===409)throw new f.UserDataSyncStoreError(`${M.type} request '${_}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,_,"Conflict",q.res.statusCode,J);if(q.res.statusCode===410)throw new f.UserDataSyncStoreError(`${M.type} request '${_}' failed because the requested resource is not longer available (410).`,_,"Gone",q.res.statusCode,J);if(q.res.statusCode===412)throw new f.UserDataSyncStoreError(`${M.type} request '${_}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,_,"PreconditionFailed",q.res.statusCode,J);if(q.res.statusCode===413)throw new f.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too large payload (413).`,_,"TooLarge",q.res.statusCode,J);if(q.res.statusCode===426)throw new f.UserDataSyncStoreError(`${M.type} request '${_}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,_,"UpgradeRequired",q.res.statusCode,J);if(q.res.statusCode===429){const W=q.res.headers["retry-after"];throw W?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(W)*1e3)),new f.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too many requests (429).`,_,"TooManyRequestsAndRetryAfter",q.res.statusCode,J)):new f.UserDataSyncStoreError(`${M.type} request '${_}' failed because of too many requests (429).`,_,"RemoteTooManyRequests",q.res.statusCode,J)}if(!K)throw new f.UserDataSyncStoreError("Server returned "+q.res.statusCode,_,"Unknown",q.res.statusCode,J);return q}addSessionHeaders(_){let M=this.storageService.get(t,-1);M===void 0&&(M=(0,m.generateUuid)(),this.storageService.store(t,M,-1,1)),_["X-Machine-Session-Id"]=M;const k=this.storageService.get(s,-1);k!==void 0&&(_["X-User-Session-Id"]=k)}};d=pe([G(1,P.IProductService),G(2,p.IRequestService),G(3,f.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,S.IFileService),G(6,a.IStorageService)],d),e.UserDataSyncStoreClient=d;let w=class extends d{constructor(_,M,k,F,$,q,J){super(_.userDataSyncStore?.url,M,k,F,$,q,J),this._register(_.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(_.userDataSyncStore?.url)))}};w=pe([G(0,f.IUserDataSyncStoreManagementService),G(1,P.IProductService),G(2,p.IRequestService),G(3,f.IUserDataSyncLogService),G(4,h.IEnvironmentService),G(5,S.IFileService),G(6,a.IStorageService)],w),e.UserDataSyncStoreService=w;class A{constructor(_,M,k,F){this.limit=_,this.interval=M,this.requestService=k,this.logService=F,this.requests=[],this.startTime=void 0}request(_,M,k){if(this.isExpired()&&this.reset(),M.url=_,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,_,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(_),this.requestService.request(M,k)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(ne[266],re([0,1,3,59,26,21,23,262,27,73,76]),function(Q,e,R,n,D,L,T,I,E,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let y=class extends I.UserDataAutoSyncService{constructor(v,h,S,P,p,g,a,f,l,i,s){super(v,h,S,P,p,a,f,l,i,s),this._register(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,r)=>t?[...t,r]:[r],1e3)(t=>this.triggerSync(t,!0,!1)))}};y=pe([G(0,D.IProductService),G(1,E.IUserDataSyncStoreManagementService),G(2,E.IUserDataSyncStoreService),G(3,E.IUserDataSyncEnablementService),G(4,E.IUserDataSyncService),G(5,n.INativeHostService),G(6,E.IUserDataSyncLogService),G(7,b.IUserDataSyncAccountService),G(8,T.ITelemetryService),G(9,C.IUserDataSyncMachinesService),G(10,L.IStorageService)],y),e.UserDataAutoSyncService=y}),define(ne[267],re([0,1,3,2,58,8,77,21,71,24]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncProfilesStorageService=void 0;let C=class extends T.AbstractUserDataSyncProfilesStorageService{constructor(m,v,h,S){super(h),this.mainProcessService=m;const P=m.getChannel("profileStorageListener"),p=this._register(new n.MutableDisposable);this._onDidChange=this._register(new R.Emitter({onFirstListenerAdd:()=>{p.value=P.listen("onDidChange")(g=>{S.trace("profile storage changes",g),this._onDidChange.fire({targetChanges:g.targetChanges.map(a=>(0,b.reviveProfile)(a,v.profilesHome.scheme)),valueChanges:g.valueChanges.map(a=>({...a,profile:(0,b.reviveProfile)(a.profile,v.profilesHome.scheme)}))})})},onLastListenerRemove:()=>p.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(m){const v=this.mainProcessService.getChannel("storage");return(0,I.isProfileUsingDefaultStorage)(m)?new E.ApplicationStorageDatabaseClient(v):new E.ProfileStorageDatabaseClient(v,m)}};C=pe([G(0,D.IMainProcessService),G(1,b.IUserDataProfilesService),G(2,I.IStorageService),G(3,L.ILogService)],C),e.UserDataSyncProfilesStorageService=C}),define(ne[268],re([0,1,95,20,4,17]),function(Q,e,R,n,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(b){function C(){let y=b.scheme===n.Schemas.file?(0,L.originalFSPath)(b):b.toString();return D.isLinux||(y=y.toLowerCase()),(0,R.createHash)("md5").update(y).digest("hex")}return{id:C(),configPath:b}}e.getWorkspaceIdentifier=T;function I(b,C){function y(){if(b.scheme!==n.Schemas.file)return(0,R.createHash)("md5").update(b.toString()).digest("hex");if(!C)return;let v;return D.isLinux?v=C.ino:D.isMacintosh?v=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?v=Math.floor(C.birthtimeMs):v=C.birthtime.getTime()),(0,R.createHash)("md5").update(b.fsPath).update(v?String(v):"").digest("hex")}const m=y();if(typeof m=="string")return{id:m,uri:b}}e.getSingleFolderWorkspaceIdentifier=I;function E(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=E}),define(ne[269],re([0,1,6,9,2,12,28,15,58,8,59,71,111,268]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(P,p,g,a){super(),this.environmentService=P,this.logService=p,this.nativeHostService=g,this.mainProcessService=a,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const P=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath),p=new y.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(P.map(async g=>{const a=(0,L.join)(this.environmentService.workspaceStorageHome.fsPath,g);g.length===v.NON_EMPTY_WORKSPACE_ID_LENGTH||g===m.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows()).some(i=>i.workspace?.id===g)||await p.isUsed(a)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await T.Promises.rm(a))}))}catch(P){(0,n.onUnexpectedError)(P)}}};h=pe([G(0,I.INativeEnvironmentService),G(1,b.ILogService),G(2,C.INativeHostService),G(3,E.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(ne[112],re([0,1,53,6,12,14,28,139,278,279]),function(Q,e,R,n,D,L,T,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(i,s){let t=s.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=s}}e.ExtractError=C;function y(l){const i=l.externalFileAttributes>>16||33188;return[448,56,7].map(s=>i&s).reduce((s,t)=>s+t,i&61440)}function m(l){if(l instanceof C)return l;let i;return/end of central directory record signature not found/.test(l.message)&&(i="CorruptZip"),new C(i,l)}function v(l,i,s,t,r,o){const c=D.dirname(i),u=D.join(t,c);if(!u.startsWith(t))return Promise.reject(new Error(I.localize(0,null,i)));const d=D.join(t,i);let w;return o.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(T.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!o.isCancellationRequested)try{w=(0,R.createWriteStream)(d,{mode:s}),w.once("close",()=>A()),w.once("error",O),l.once("error",O),l.pipe(w)}catch(_){O(_)}}))}function h(l,i,s,t){let r=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),l.close()}),new Promise((c,u)=>{const d=new n.Sequencer,w=A=>{A.isCancellationRequested||(o++,l.readEntry())};l.once("error",u),l.once("close",()=>r.then(()=>{t.isCancellationRequested||l.entryCount===o?c():u(new C("Incomplete",new Error(I.localize(1,null,o,l.entryCount))))},u)),l.readEntry(),l.on("entry",A=>{if(t.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){w(t);return}const O=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const k=D.join(i,O);r=(0,n.createCancelablePromise)(F=>T.Promises.mkdir(k,{recursive:!0}).then(()=>w(F)).then(void 0,u));return}const _=P(l,A),M=y(A);r=(0,n.createCancelablePromise)(k=>d.queue(()=>_.then(F=>v(F,O,M,i,s,k).then(()=>w(k)))).then(null,u))})})}function S(l,i=!1){return new Promise((s,t)=>{(0,E.open)(l,i?{lazyEntries:!0}:void 0,(r,o)=>{r?t(m(r)):s((0,L.assertIsDefined)(o))})})}function P(l,i){return new Promise((s,t)=>{l.openReadStream(i,(r,o)=>{r?t(m(r)):s((0,L.assertIsDefined)(o))})})}function p(l,i){return new Promise((s,t)=>{const r=new b.ZipFile;i.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,R.createWriteStream)(l);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>s(l))})}e.zip=p;function g(l,i,s={},t){const r=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=S(l,!0);return s.overwrite&&(o=o.then(c=>T.Promises.rm(i).then(()=>c))),o.then(c=>h(c,i,{sourcePathRegex:r},t))}e.extract=g;function a(l,i){return S(l).then(s=>new Promise((t,r)=>{s.on("entry",o=>{o.fileName===i&&P(s,o).then(c=>t(c),c=>r(c))}),s.once("close",()=>r(new Error(I.localize(2,null,i))))}))}function f(l,i){return a(l,i).then(s=>new Promise((t,r)=>{const o=[];s.once("error",r),s.on("data",c=>o.push(c)),s.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(ne[270],re([0,1,112,149]),function(Q,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(L){return(0,R.buffer)(L,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=D}),define(ne[113],re([0,1,6,38,9,2,20,12,4,17,55,14,7,30,28,112,148,93,15,248,29,32,48,74,203,249,270,204,234,43,68,13,5,8,26,23,33,24]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l,i,s,t,r,o,c,u,d,w,A,O,_,M,k,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,O.refineServiceDecorator)(f.IExtensionManagementService);let q=class extends a.AbstractExtensionManagementService{constructor(z,V,U,N,j,x,Z,oe,X,ie,se,ue){super(z,V,U,ie,ue),this.extensionsScannerService=j,this.extensionsProfileScannerService=x,this.downloadService=Z,this.fileService=X,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(J,we=>he.postUninstall(we))),this.manifestCache=this._register(new c.ExtensionsManifestCache(N,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const ve=this._register(new u.ExtensionsWatcher(this,X,N,U,se));this._register(ve.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ee})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ee.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const V=await this.collectFiles(z),U=await(0,S.zip)((0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,V);return m.URI.file(U)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:V,cleanup:U}=await this.downloadVsix(z),N=I.resolve(V.fsPath);try{return await(0,o.getManifest)(N)}finally{await U()}}getInstalled(z,V){return this.extensionsScanner.scanExtensions(z??null,V)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(z,V={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:U,cleanup:N}=await this.downloadVsix(z);try{const j=await(0,o.getManifest)(I.resolve(U.fsPath));if(j.engines&&j.engines.vscode&&!(0,w.isEngineValid)(j.engines.vscode,this.productService.version,this.productService.date))throw new Error(P.localize(0,null,(0,l.getGalleryExtensionId)(j.publisher,j.name),this.productService.version));return await this.installExtension(j,U,V)}finally{await N()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,V){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const U={...V};return V.isPreReleaseVersion&&(U.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,U),this.manifestCache.invalidate(),z}async updateExtensionScope(z,V){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:V}),this.manifestCache.invalidate(),z}removeUninstalledExtensions(z){return this.extensionsScanner.cleanUp(z)}async downloadVsix(z){if(z.scheme===T.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const V=(0,b.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(z,V),this.logService.info("Downloaded extension to",V.toString()),{location:V,cleanup:async()=>{try{await this.fileService.del(V)}catch(N){this.logService.error(N)}}}}doCreateInstallExtensionTask(z,V,U){let N;if(m.URI.isUri(V))N=new W(z,V,U,this.galleryService,this.extensionsScanner,this.logService);else{const j=l.ExtensionKey.create(V).toString();N=this.installGalleryExtensionsTasks.get(j),N||(this.installGalleryExtensionsTasks.set(j,N=new K(z,V,U,this.extensionsDownloader,this.extensionsScanner,this.logService)),N.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(j)))}return U.profileLocation?new B(N,U.profileLocation,this.extensionsProfileScannerService):N}doCreateUninstallExtensionTask(z,V){return V.profileLocation?new te(z,V.profileLocation,this.extensionsProfileScannerService):new Y(z,V,this.extensionsScanner)}async collectFiles(z){const V=async N=>{let j=await h.Promises.readdir(N);j=j.map(oe=>I.join(N,oe));const x=await Promise.all(j.map(oe=>h.Promises.stat(oe)));let Z=Promise.resolve([]);return x.forEach((oe,X)=>{const ie=j[X];oe.isFile()&&(Z=Z.then(se=>[...se,ie])),oe.isDirectory()&&(Z=Z.then(se=>V(ie).then(ue=>[...se,...ue])))}),Z};return(await V(z.location.fsPath)).map(N=>({path:`extension/${I.relative(z.location.fsPath,N)}`,localPath:N}))}};q=pe([G(0,f.IExtensionGalleryService),G(1,k.ITelemetryService),G(2,_.ILogService),G(3,g.INativeEnvironmentService),G(4,s.IExtensionsScannerService),G(5,i.IExtensionsProfileScannerService),G(6,p.IDownloadService),G(7,O.IInstantiationService),G(8,A.IFileService),G(9,M.IProductService),G(10,F.IUriIdentityService),G(11,$.IUserDataProfilesService)],q),e.ExtensionManagementService=q;let J=class extends L.Disposable{constructor(z,V,U,N){super(),this.beforeRemovingExtension=z,this.fileService=V,this.extensionsScannerService=U,this.logService=N,this.uninstalledPath=(0,b.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(z){await this.removeUninstalledExtensions(),z&&await this.removeOutdatedExtensions()}async scanExtensions(z,V){const U={includeInvalid:!0,profileLocation:V};let N=[];return z===null||z===0?N.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},U,!1)):z===1&&N.push(...await this.extensionsScannerService.scanUserExtensions(U)),N=z!==null?N.filter(j=>j.type===z):N,Promise.all(N.map(j=>this.toLocalExtension(j)))}async scanUserExtensions(z){const V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(V.map(U=>this.toLocalExtension(U)))}async extractUserExtension(z,V,U,N){const j=z.toString(),x=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),Z=I.join(this.extensionsScannerService.userExtensionsLocation.fsPath,j);try{await h.Promises.rm(Z)}catch{throw new f.ExtensionManagementError(P.localize(1,null,Z,z.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,V,x,N),U={...U,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(m.URI.file(x),U);try{await this.rename(z,x,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await h.Promises.rm(x)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(oe)}. Deleted from extracted location`,x),oe}return this.scanLocalExtension(m.URI.file(Z),1)}async updateMetadata(z,V){return await this.extensionsScannerService.updateMetadata(z.location,V),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const V=z.map(U=>l.ExtensionKey.create(U));await this.withUninstalledExtensions(U=>{V.forEach(N=>U[N.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(N=>delete N[z.toString()]);const U=(await this.scanUserExtensions(!0)).find(N=>l.ExtensionKey.create(N).equals(z))||null;return U?this.updateMetadata(U,{installedTimestamp:Date.now()}):null}async removeExtension(z,V){this.logService.trace(`Deleting ${V} extension from disk`,z.identifier.id,z.location.fsPath),await h.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(V=>delete V[l.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let V;try{V=await h.Promises.readFile(this.uninstalledPath,"utf8")}catch(N){if(N.code!=="ENOENT")throw N}let U={};if(V)try{U=JSON.parse(V)}catch{}return z&&(z(U),Object.keys(U).length?await h.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await h.Promises.rm(this.uninstalledPath)),U})}async extractAtLocation(z,V,U,N){this.logService.trace(`Started extracting the extension from ${V} to ${U}`);try{await h.Promises.rm(U)}catch(j){throw new f.ExtensionManagementError(this.joinErrors(j).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(V,U,{sourcePath:"extension",overwrite:!0},N),this.logService.info(`Extracted extension to ${U}:`,z.id)}catch(j){try{await h.Promises.rm(U)}catch{}let x=f.ExtensionManagementErrorCode.Extract;throw j instanceof S.ExtractError&&(j.type==="CorruptZip"?x=f.ExtensionManagementErrorCode.CorruptZip:j.type==="Incomplete"&&(x=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(j.message,x)}}async rename(z,V,U,N){try{await h.Promises.rename(V,U)}catch(j){if(E.isWindows&&j&&j.code==="EPERM"&&Date.now()<N)return this.logService.info(`Failed renaming ${V} to ${U} with 'EPERM' error. Trying again...`,z.id),this.rename(z,V,U,N);throw new f.ExtensionManagementError(j.message||P.localize(2,null,V,U),j.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,V){const U=await this.extensionsScannerService.scanExistingExtension(z,V,{includeInvalid:!0});if(U)return this.toLocalExtension(U);throw new Error(P.localize(3,null,z.path))}async toLocalExtension(z){const V=await this.fileService.resolve(z.location);let U,N;return V.children&&(U=V.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,N=V.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:U,changelogUrl:N,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const x of V)z[l.ExtensionKey.create(x).toString()]||U.add(x.identifier.id.toLowerCase());const N=(0,l.groupByExtension)(V,x=>x.identifier);await R.Promises.settled(N.map(async x=>{const Z=x.sort((oe,X)=>C.rcompare(oe.manifest.version,X.manifest.version))[0];U.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const j=V.filter(x=>z[l.ExtensionKey.create(x).toString()]);await R.Promises.settled(j.map(x=>this.removeUninstalledExtension(x)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanSystemExtensions({}),V=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=[],N=await this.extensionsScannerService.getTargetPlatform(),j=(0,l.groupByExtension)(V,x=>x.identifier);for(const x of j)if(x.length>1&&U.push(...x.sort((Z,oe)=>{const X=C.rcompare(Z.manifest.version,oe.manifest.version);return X!==0?X:Z.targetPlatform===N?-1:1}).slice(1)),x[0].type===0){const Z=z.find(oe=>(0,l.areSameExtensions)(oe.identifier,x[0].identifier));(!Z||C.gte(Z.manifest.version,x[0].manifest.version))&&U.push(x[0])}await R.Promises.settled(U.map(x=>this.removeExtension(x,"outdated")))}joinErrors(z){const V=Array.isArray(z)?z:[z];return V.length===1?V[0]instanceof Error?V[0]:new Error(V[0]):V.reduce((U,N)=>new Error(`${U.message}${U.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}};J=pe([G(1,A.IFileService),G(2,s.IExtensionsScannerService),G(3,_.ILogService)],J);class H extends a.AbstractExtensionTask{constructor(z,V,U,N,j){super(),this.identifier=z,this.source=V,this.options=U,this.extensionsScanner=N,this.logService=j,this._operation=2}get operation(){return(0,y.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(z,V){try{const U=await this.unsetUninstalledAndGetLocal(z.key);if(U)return z.metadata?this.extensionsScanner.updateMetadata(U,z.metadata):U}catch{throw E.isMacintosh?new f.ExtensionManagementError(P.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(P.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(z,V)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const U=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),U}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:V,metadata:U},N){const j=await this.extensionsScanner.extractUserExtension(V,z,U,N);return this.logService.info("Extracting completed.",V.id),j}}class K extends H{constructor(z,V,U,N,j,x){super(V.identifier,V,U,j,x),this.manifest=z,this.gallery=V,this.extensionsDownloader=N}async doRun(z){const U=(await this.extensionsScanner.scanExtensions(null,void 0)).find(x=>(0,l.areSameExtensions)(x.identifier,this.gallery.identifier));U&&(this._operation=3);const N={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,d.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||U?.isMachineScoped,isBuiltin:this.options.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,y.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(U,N),metadata:N};const j=await this.downloadExtension(this.gallery,this._operation);try{const x=await this.installExtension({zipPath:j,key:l.ExtensionKey.create(this.gallery),metadata:N},z);return U&&!this.options.profileLocation&&(U.targetPlatform!==x.targetPlatform||C.neq(U.manifest.version,x.manifest.version))&&await this.extensionsScanner.setUninstalled(U),{local:x,metadata:N}}catch(x){throw await this.deleteDownloadedVSIX(j),x}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(m.URI.file(z))}catch(V){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,D.getErrorMessage)(V))}}async downloadExtension(z,V){let U;try{this.logService.trace("Started downloading extension:",z.identifier.id),U=(await this.extensionsDownloader.downloadExtension(z,V)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,U)}catch(N){throw new f.ExtensionManagementError((0,a.joinErrors)(N).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(U),U}catch(N){throw await this.deleteDownloadedVSIX(U),new f.ExtensionManagementError((0,a.joinErrors)(N).message,f.ExtensionManagementErrorCode.Invalid)}}}class W extends H{constructor(z,V,U,N,j,x){super({id:(0,l.getGalleryExtensionId)(z.publisher,z.name)},V,U,j,x),this.manifest=z,this.location=V,this.galleryService=N}async doRun(z){const V=new l.ExtensionKey(this.identifier,this.manifest.version),N=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,l.areSameExtensions)(this.identifier,Z.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(j.isApplicationScoped=(0,d.isApplicationScopedExtension)(this.manifest),j.isMachineScoped=this.options.isMachineScoped||N?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||N?.isBuiltin,N)if(this._operation=3,V.equals(new l.ExtensionKey(N.identifier,N.manifest.version)))try{await this.extensionsScanner.removeExtension(N,"existing")}catch{throw new Error(P.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&C.gt(N.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(N);else{const Z=await this.unsetUninstalledAndGetLocal(V);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(P.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:I.resolve(this.location.fsPath),key:V,metadata:j},z),metadata:j}}async getMetadata(z,V,U){try{let[N]=await this.galleryService.getExtensions([{id:z,version:V}],U);if(N||([N]=await this.galleryService.getExtensions([{id:z}],U)),N)return{id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B{constructor(z,V,U){this.task=z,this.profileLocation=V,this.extensionsProfileScannerService=U,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends a.AbstractExtensionTask{constructor(z,V,U){super(),this.extension=z,this.options=V,this.extensionsScanner=U}async doRun(z){const V=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const N=l.ExtensionKey.create(this.extension);V.push(...U.filter(j=>N.equals(l.ExtensionKey.create(j))))}else V.push(...U.filter(N=>(0,l.areSameExtensions)(N.identifier,this.extension.identifier)));if(!V.length)throw new Error(P.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...V),this.options.remove)for(const N of V)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(N)}catch(j){throw new Error(P.localize(9,null,(0,n.toErrorMessage)(j)))}}}class te extends a.AbstractExtensionTask{constructor(z,V,U){super(),this.extension=z,this.profileLocation=V,this.extensionsProfileScannerService=U}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[271],re([0,1,2,29,32,48,75,202,113,43,5,8,21,33,24]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let P=class extends R.Disposable{constructor(a,f,l,i,s,t,r,o){super(),this.userDataProfilesService=f,a.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,I.migrateUnsupportedExtensions)(a,l,i,s,o),T.ExtensionStorageService.removeOutdatedExtensionVersions(a,r),this._register(t.createInstance(p))}};P=pe([G(0,E.INativeServerExtensionManagementService),G(1,h.IUserDataProfilesService),G(2,n.IExtensionGalleryService),G(3,T.IExtensionStorageService),G(4,n.IGlobalExtensionEnablementService),G(5,C.IInstantiationService),G(6,m.IStorageService),G(7,y.ILogService)],P),e.ExtensionsCleaner=P;let p=class extends R.Disposable{constructor(a,f,l,i,s){super(),this.extensionManagementService=a,this.userDataProfilesService=f,this.extensionsProfileScannerService=l,this.uriIdentityService=i,this.logService=s,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new R.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:a,removed:f,all:l}){try{await Promise.all(f.map(i=>i.extensionsResource?this.removeExtensionsFromProfile(i.extensionsResource):Promise.resolve()))}catch(i){this.logService.error(i)}if(l.length===1){this.profileModeDisposables.clear();const i=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{i.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{a.length&&(await Promise.all(a.map(i=>i.extensionsResource?this.populateExtensionsFromProfile(i.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new R.DisposableStore,this.profileModeDisposables.value.add((0,R.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(i=>this.onDidChangeProfiles(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(i=>this.onDidInstallExtensions(i))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(i=>this.onDidUninstallExtension(i))),await this.uninstallExtensionsNotInProfiles()))}catch(i){this.logService.error(i)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(l=>!this.profileExtensionsLocations.has(this.getKey(l.identifier,l.manifest.version)));f.length&&await Promise.all(f.map(l=>this.extensionManagementService.uninstall(l,S)))}async onDidInstallExtensions(a){for(const{local:f,profileLocation:l}of a)!f||!l||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),l)}async onDidUninstallExtension(a){!a.profileLocation||!a.version||this.removeExtensionWithKey(this.getKey(a.identifier,a.version),a.profileLocation)&&await this.uninstallExtensions([{identifier:a.identifier,version:a.version}])}async populateExtensionsFromProfile(a){const f=await this.extensionsProfileScannerService.scanProfileExtensions(a);for(const l of f)this.addExtensionWithKey(this.getKey(l.identifier,l.version),a)}async removeExtensionsFromProfile(a){const f=[];for(const l of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(l,a))continue;const i=this.fromKey(l);i&&f.push(i)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(a,f){let l=this.profileExtensionsLocations.get(a);l||(l=[],this.profileExtensionsLocations.set(a,l)),l.push(f)}removeExtensionWithKey(a,f){const l=this.profileExtensionsLocations.get(a);if(l){const i=l.findIndex(s=>this.uriIdentityService.extUri.isEqual(s,f));i>-1&&l.splice(i,1)}return l?.length?!1:(this.profileExtensionsLocations.delete(a),!0)}async uninstallExtensions(a){const l=(await this.extensionManagementService.getAllUserInstalled()).filter(i=>a.some(s=>this.getKey(i.identifier,i.manifest.version)===this.getKey(s.identifier,s.version)));l.length&&await Promise.all(l.map(i=>this.extensionManagementService.uninstall(i,S)))}getKey(a,f){return`${b.ExtensionIdentifier.toKey(a.id)}@${f}`}fromKey(a){const[f,l]=(0,D.getIdAndVersion)(a);return l?{identifier:{id:f},version:l}:void 0}};p=pe([G(0,E.INativeServerExtensionManagementService),G(1,h.IUserDataProfilesService),G(2,L.IExtensionsProfileScannerService),G(3,v.IUriIdentityService),G(4,y.ILogService)],p)}),define(ne[280],re([0,1,89,37,38,9,2,20,17,7,39,137,195,271,196,188,189,269,177,180,19,200,92,219,93,210,15,216,251,252,29,179,253,113,94,175,13,191,193,56,5,186,97,187,58,69,205,8,98,59,99,26,44,21,254,104,23,105,106,107,49,223,108,225,231,75,110,27,73,242,243,244,76,261,264,245,265,266,267,77,246,103,218,72,233,207,232,102,215,33,235,4,236,181,198,197,74,250,24,48,194,60,255,213,222,247]),function(Q,e,R,n,D,L,T,I,E,b,C,y,m,v,h,S,P,p,g,a,f,l,i,s,t,r,o,c,u,d,w,A,O,_,M,k,F,$,q,J,H,K,W,B,Y,te,ce,z,V,U,N,j,x,Z,oe,X,ie,se,ue,he,ve,we,Ee,Pe,Ue,ze,Ve,We,ae,de,fe,Ce,Ie,Me,De,$e,Ae,Fe,_e,ke,ee,le,me,ge,Se,be,Re,Te,qe,Le,Ne,xe,Xe,Ze,Pt,pt,It,Rt,Dt,vt,kt,St,Lt,Tt,At,_t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ot extends T.Disposable{constructor(ye){super(),this.configuration=ye,this.server=this._register(new y.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(He,et)=>{this.onDisposeWorker(et)};R.ipcRenderer.on(Oe,je),this._register((0,T.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(z.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,T.combinedDisposable)(ye.createInstance(m.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(h.LanguagePackCachedDataCleaner),ye.createInstance(p.UnusedWorkspaceStorageDataCleaner),ye.createInstance(P.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(v.ExtensionsCleaner),ye.createInstance(_t.UserDataProfilesCleaner)))}async initServices(){const ye=new W.ServiceCollection,Oe={_serviceBrand:void 0,...N.default};ye.set(j.IProductService,Oe);const je=new C.StaticRouter(Ye=>Ye==="main"),He=new B.MessagePortMainProcessService(this.server,je);ye.set(Y.IMainProcessService,He);const et=this.configuration.policiesData?new kt.PolicyChannelClient(this.configuration.policiesData,He.getChannel("policy")):new St.NullPolicyService;ye.set(St.IPolicyService,et);const Be=new c.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(o.INativeEnvironmentService,Be);const ot=new V.LogLevelChannelClient(this.server.getChannel("logLevel",je)),tt=new V.LoggerChannelClient(this.configuration.logLevel,ot.onDidChangeLogLevel,He.getChannel("logger"));ye.set(z.ILoggerService,tt);const lt=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(tt.createLogger((0,E.joinPath)(b.URI.file(Be.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new V.FollowerLogService(ot,lt));ye.set(z.ILogService,Ge),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Ge),ye.set(Te.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ye.set(F.IFileService,Je);const ut=this._register(new q.DiskFileSystemProvider(Ge));Je.registerProvider(I.Schemas.file,ut);const ht=this._register(new Xe.FileUserDataProvider(I.Schemas.file,this._register(new Ze.DiskFileSystemProviderClient(He.getChannel(Ze.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:xe.isLinux})),I.Schemas.vscodeUserData,Ge));Je.registerProvider(I.Schemas.vscodeUserData,ht);const it=this._register(new Lt.UserDataProfilesNativeService(this.configuration.profiles,He,Be));ye.set(Dt.IUserDataProfilesService,it);const Ke=this._register(new l.ConfigurationService(it.defaultProfile.settingsResource,Je,et,Ge));ye.set(f.IConfigurationService,Ke);const rt=new oe.NativeStorageService(void 0,{defaultProfile:it.defaultProfile,currentProfile:it.defaultProfile},He,Be);ye.set(Z.IStorageService,rt),this._register((0,T.toDisposable)(()=>rt.flush())),await Promise.all([Ke.initialize(),rt.initialize()]),ye.set(Le.IUriIdentityService,new Ne.UriIdentityService(Je)),ye.set(x.IRequestService,new Tt.SharedProcessRequestService(He,Ke,Ge)),ye.set(g.IChecksumService,new J.SyncDescriptor(a.ChecksumService,void 0,!1)),ye.set(pt.IV8InspectProfilingService,new J.SyncDescriptor(Pt.InspectProfilingService,void 0,!1));const at=C.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(U.INativeHostService,at),ye.set(t.IDownloadService,new J.SyncDescriptor(r.DownloadService,void 0,!0));const dt=this._register(new ee.ActiveWindowManager(at)),Mt=new C.StaticRouter(Ye=>dt.getActiveClientId().then(ft=>Ye===ft));ye.set(M.IExtensionRecommendationNotificationService,new k.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Mt)));let ct;const st=[],wt=(0,ve.isInternalTelemetry)(Oe,Ke);if((0,ve.supportsTelemetry)(Oe,Be)){const Ye=new ue.TelemetryLogAppender(tt,Be);st.push(Ye);const{installSourcePath:ft}=Be;if(Oe.aiConfig?.ariaKey){const bt=new At.OneDataSystemAppender(wt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,T.toDisposable)(()=>bt.flush())),st.push(bt)}ct=new he.TelemetryService({appenders:st,commonProperties:(0,X.resolveCommonProperties)(Je,(0,n.release)(),(0,n.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,wt,ft),sendErrorTelemetry:!0,piiPaths:(0,ve.getPiiPathsFromEnvironment)(Be)},Ke,Oe)}else{ct=ve.NullTelemetryService;const Ye=ve.NullAppender;st.push(Ye)}this.server.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(st)),ye.set(ie.ITelemetryService,ct);const Ft=new we.CustomEndpointTelemetryService(Ke,ct,tt,Be,Oe);ye.set(ie.ICustomEndpointTelemetryService,Ft),ye.set(vt.IExtensionsProfileScannerService,new J.SyncDescriptor(vt.ExtensionsProfileScannerService,void 0,!0)),ye.set(It.IExtensionsScannerService,new J.SyncDescriptor(Rt.ExtensionsScannerService,void 0,!0)),ye.set(_.INativeServerExtensionManagementService,new J.SyncDescriptor(_.ExtensionManagementService,void 0,!0)),ye.set(w.IExtensionGalleryService,new J.SyncDescriptor(d.ExtensionGalleryService,void 0,!0)),ye.set(w.IExtensionTipsService,new J.SyncDescriptor(O.ExtensionTipsService,void 0,!1)),ye.set(te.ILanguagePackService,new J.SyncDescriptor(ce.NativeLanguagePackService,void 0,!1)),ye.set(i.IDiagnosticsService,new J.SyncDescriptor(s.DiagnosticsService,void 0,!1)),ye.set(ae.IUserDataSyncAccountService,new J.SyncDescriptor(ae.UserDataSyncAccountService,void 0,!0)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),ye.set(We.IUserDataSyncUtilService,new fe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ye=>Ye.ctx!=="main"))),ye.set(w.IGlobalExtensionEnablementService,new J.SyncDescriptor(u.GlobalExtensionEnablementService,void 0,!1)),ye.set(Ve.IIgnoredExtensionsManagementService,new J.SyncDescriptor(Ve.IgnoredExtensionsManagementService,void 0,!0)),ye.set(ze.IExtensionStorageService,new J.SyncDescriptor(ze.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService,void 0,!0)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService,void 0,!0)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService,void 0,!0)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Me.UserDataSyncEnablementService,void 0,!0)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(De.UserDataSyncService,void 0,!1)),ye.set(ke.IUserDataSyncProfilesStorageService,new J.SyncDescriptor(_e.UserDataSyncProfilesStorageService,void 0,!0));const Et=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ke.getValue("terminal.integrated.persistentSessionScrollback")??100},Ke,Be,Ge);return Et.initialize(),ye.set(Pe.ILocalPtyService,this._register(Et)),ye.set(le.ISignService,new J.SyncDescriptor(me.SignService,void 0,!1)),ye.set(ge.ISharedTunnelsService,new J.SyncDescriptor(Se.SharedTunnelsService)),ye.set(be.ISharedProcessTunnelService,new J.SyncDescriptor(Re.SharedProcessTunnelService)),new K.InstantiationService(ye)}initChannels(ye){const Oe=new A.ExtensionManagementChannel(ye.get(w.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=C.ProxyChannel.fromService(ye.get(te.ILanguagePackService));this.server.registerChannel("languagePacks",je);const He=C.ProxyChannel.fromService(ye.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const et=new A.ExtensionTipsChannel(ye.get(w.IExtensionTipsService));this.server.registerChannel("extensionTipsService",et);const Be=C.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",Be);const ot=C.ProxyChannel.fromService(ye.get(pt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",ot);const tt=new fe.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",tt);const lt=C.ProxyChannel.fromService(ye.get(ie.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",lt);const Ge=new fe.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new fe.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ut=new $e.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(z.ILogService));this.server.registerChannel("userDataSync",ut);const ht=this._register(ye.get(H.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),it=new fe.UserDataAutoSyncChannel(ht);this.server.registerChannel("userDataAutoSync",it);const Ke=ye.get(Pe.ILocalPtyService),rt=C.ProxyChannel.fromService(Ke);this.server.registerChannel(Ee.TerminalIpcChannels.LocalPty,rt);const at=C.ProxyChannel.fromService(ye.get(be.ISharedProcessTunnelService));this.server.registerChannel(be.ipcSharedProcessTunnelChannelName,at);const dt=C.ProxyChannel.fromService(ye.get(Te.ISharedProcessWorkerService));this.server.registerChannel(Te.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,D.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Ut(yt){const ye=new Ot(yt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ut})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b3546b4bb5aff5254ef857cfd68a3da8534c068f/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
