/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(B){for(var i=[],D=0,C=B.length;D<C;D++)i[D]=Q[B[D]];return i};define(Q[49],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(L){return(p,a,d)=>{let b=null,w=null;if(typeof d.value=="function"?(b="value",w=d.value):typeof d.get=="function"&&(b="get",w=d.get),!w)throw new Error("not supported");d[b]=L(w,a)}}i.createDecorator=D;function C(L,p,a){let d=null,b=null;if(typeof a.value=="function"?(d="value",b=a.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof a.get=="function"&&(d="get",b=a.get),!b)throw new Error("not supported");const w=`$memoize$${p}`;a[d]=function(...h){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,h)}),this[w]}}i.memoize=C;function P(L,p,a){return D((d,b)=>{const w=`$debounce$${b}`,h=`$debounce$result$${b}`;return function(...v){this[h]||(this[h]=a?a():void 0),clearTimeout(this[w]),p&&(this[h]=p(this[h],...v),v=[this[h]]),this[w]=setTimeout(()=>{d.apply(this,v),this[h]=a?a():void 0},L)}})}i.debounce=P;function T(L,p,a){return D((d,b)=>{const w=`$throttle$timer$${b}`,h=`$throttle$result$${b}`,v=`$throttle$lastRun$${b}`,f=`$throttle$pending$${b}`;return function(...m){if(this[h]||(this[h]=a?a():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[h]=p(this[h],...m)),this[f])return;const y=this[v]+L;y<=Date.now()?(this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=a?a():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=a?a():void 0},y-Date.now()))}})}i.throttle=T}),define(Q[68],Z([0,1,11]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.checkAdjacentItems=i.assertFn=i.assert=i.assertNever=i.ok=void 0;function C(a,d){if(!a)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}i.ok=C;function P(a,d="Unreachable"){throw new Error(d)}i.assertNever=P;function T(a){if(!a)throw new D.BugIndicatingError("Assertion Failed")}i.assert=T;function L(a){if(!a()){debugger;a(),(0,D.onUnexpectedError)(new D.BugIndicatingError("Assertion Failed"))}}i.assertFn=L;function p(a,d){let b=0;for(;b<a.length-1;){const w=a[b],h=a[b+1];if(!d(w,h))return!1;b++}return!0}i.checkAdjacentItems=p}),define(Q[50],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var C;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(C=i.SyntaxKind||(i.SyntaxKind={}));var P;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(P=i.ParseErrorCode||(i.ParseErrorCode={}));var T;(function(e){e.DEFAULT={allowTrailingComma:!0}})(T=i.ParseOptions||(i.ParseOptions={}));function L(e,n=!1){let t=0;const r=e.length;let o="",S=0,E=16,I=0;function O(ne){let fe=0,le=0;for(;fe<ne;){const ie=e.charCodeAt(t);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;t++,fe++}return fe<ne&&(le=-1),le}function W(ne){t=ne,o="",S=0,E=16,I=0}function _(){const ne=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&d(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&d(e.charCodeAt(t)))for(t++;t<e.length&&d(e.charCodeAt(t));)t++;else return I=3,e.substring(ne,t);let fe=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&d(e.charCodeAt(t))){for(t++;t<e.length&&d(e.charCodeAt(t));)t++;fe=t}else I=3;return e.substring(ne,fe)}function Y(){let ne="",fe=t;for(;;){if(t>=r){ne+=e.substring(fe,t),I=2;break}const le=e.charCodeAt(t);if(le===34){ne+=e.substring(fe,t),t++;break}if(le===92){if(ne+=e.substring(fe,t),t++,t>=r){I=2;break}switch(e.charCodeAt(t++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const V=O(4);V>=0?ne+=String.fromCharCode(V):I=4;break}default:I=5}fe=t;continue}if(le>=0&&le<=31)if(a(le)){ne+=e.substring(fe,t),I=2;break}else I=6;t++}return ne}function X(){if(o="",I=0,S=t,t>=r)return S=r,E=17;let ne=e.charCodeAt(t);if(p(ne)){do t++,o+=String.fromCharCode(ne),ne=e.charCodeAt(t);while(p(ne));return E=15}if(a(ne))return t++,o+=String.fromCharCode(ne),ne===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),E=14;switch(ne){case 123:return t++,E=1;case 125:return t++,E=2;case 91:return t++,E=3;case 93:return t++,E=4;case 58:return t++,E=6;case 44:return t++,E=5;case 34:return t++,o=Y(),E=10;case 47:{const fe=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<r&&!a(e.charCodeAt(t));)t++;return o=e.substring(fe,t),E=12}if(e.charCodeAt(t+1)===42){t+=2;const le=r-1;let ie=!1;for(;t<le;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,I=1),o=e.substring(fe,t),E=13}return o+=String.fromCharCode(ne),t++,E=16}case 45:if(o+=String.fromCharCode(ne),t++,t===r||!d(e.charCodeAt(t)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),E=11;default:for(;t<r&&re(ne);)t++,ne=e.charCodeAt(t);if(S!==t){switch(o=e.substring(S,t),o){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return o+=String.fromCharCode(ne),t++,E=16}}function re(ne){if(p(ne)||a(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ne;do ne=X();while(ne>=12&&ne<=15);return ne}return{setPosition:W,getPosition:()=>t,scan:n?se:X,getToken:()=>E,getTokenValue:()=>o,getTokenOffset:()=>S,getTokenLength:()=>t-S,getTokenError:()=>I}}i.createScanner=L;function p(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function a(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var b;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(b||(b={}));function w(e,n){const t=[],r=new Object;let o;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function I(O,W,_,Y){S.value=O,S.offset=W,S.length=_,S.type=Y,S.colonOffset=void 0,o=S}try{g(e,{onObjectBegin:(O,W)=>{if(n<=O)throw r;o=void 0,E=n>O,t.push("")},onObjectProperty:(O,W,_)=>{if(n<W||(I(O,W,_,"property"),t[t.length-1]=O,n<=W+_))throw r},onObjectEnd:(O,W)=>{if(n<=O)throw r;o=void 0,t.pop()},onArrayBegin:(O,W)=>{if(n<=O)throw r;o=void 0,t.push(0)},onArrayEnd:(O,W)=>{if(n<=O)throw r;o=void 0,t.pop()},onLiteralValue:(O,W,_)=>{if(n<W||(I(O,W,_,s(O)),n<=W+_))throw r},onSeparator:(O,W,_)=>{if(n<=W)throw r;if(O===":"&&o&&o.type==="property")o.colonOffset=W,E=!1,o=void 0;else if(O===","){const Y=t[t.length-1];typeof Y=="number"?t[t.length-1]=Y+1:(E=!0,t[t.length-1]=""),o=void 0}}})}catch(O){if(O!==r)throw O}return{path:t,previousNode:o,isAtPropertyKey:E,matches:O=>{let W=0;for(let _=0;W<O.length&&_<t.length;_++)if(O[W]===t[_]||O[W]==="*")W++;else if(O[W]!=="**")return!1;return W===O.length}}}i.getLocation=w;function h(e,n=[],t=T.DEFAULT){let r=null,o=[];const S=[];function E(O){Array.isArray(o)?o.push(O):r!==null&&(o[r]=O)}return g(e,{onObjectBegin:()=>{const O={};E(O),S.push(o),o=O,r=null},onObjectProperty:O=>{r=O},onObjectEnd:()=>{o=S.pop()},onArrayBegin:()=>{const O=[];E(O),S.push(o),o=O,r=null},onArrayEnd:()=>{o=S.pop()},onLiteralValue:E,onError:(O,W,_)=>{n.push({error:O,offset:W,length:_})}},t),o[0]}i.parse=h;function v(e,n=[],t=T.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(O){r.type==="property"&&(r.length=O-r.offset,r=r.parent)}function S(O){return r.children.push(O),O}g(e,{onObjectBegin:O=>{r=S({type:"object",offset:O,length:-1,parent:r,children:[]})},onObjectProperty:(O,W,_)=>{r=S({type:"property",offset:W,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:O,offset:W,length:_,parent:r})},onObjectEnd:(O,W)=>{r.length=O+W-r.offset,r=r.parent,o(O+W)},onArrayBegin:(O,W)=>{r=S({type:"array",offset:O,length:-1,parent:r,children:[]})},onArrayEnd:(O,W)=>{r.length=O+W-r.offset,r=r.parent,o(O+W)},onLiteralValue:(O,W,_)=>{S({type:s(O),offset:W,length:_,parent:r,value:O}),o(W+_)},onSeparator:(O,W,_)=>{r.type==="property"&&(O===":"?r.colonOffset=W:O===","&&o(W))},onError:(O,W,_)=>{n.push({error:O,offset:W,length:_})}},t);const I=r.children[0];return I&&delete I.parent,I}i.parseTree=v;function f(e,n){if(!e)return;let t=e;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const S of t.children)if(Array.isArray(S.children)&&S.children[0].value===r){t=S.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=f;function m(e){if(!e.parent||!e.parent.children)return[];const n=m(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;n.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&n.push(t)}return n}i.getNodePath=m;function y(e){switch(e.type){case"array":return e.children.map(y);case"object":{const n=Object.create(null);for(const t of e.children){const r=t.children[1];r&&(n[t.children[0].value]=y(r))}return n}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=y;function c(e,n,t=!1){return n>=e.offset&&n<e.offset+e.length||t&&n===e.offset+e.length}i.contains=c;function u(e,n,t=!1){if(c(e,n,t)){const r=e.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const S=u(r[o],n,t);if(S)return S}return e}}i.findNodeAtOffset=u;function g(e,n,t=T.DEFAULT){const r=L(e,!1);function o(A){return A?()=>A(r.getTokenOffset(),r.getTokenLength()):()=>!0}function S(A){return A?U=>A(U,r.getTokenOffset(),r.getTokenLength()):()=>!0}const E=o(n.onObjectBegin),I=S(n.onObjectProperty),O=o(n.onObjectEnd),W=o(n.onArrayBegin),_=o(n.onArrayEnd),Y=S(n.onLiteralValue),X=S(n.onSeparator),re=o(n.onComment),se=S(n.onError),ne=t&&t.disallowComments,fe=t&&t.allowTrailingComma;function le(){for(;;){const A=r.scan();switch(r.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:ne||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:ne?ie(10):re();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,U=[],R=[]){if(se(A),U.length+R.length>0){let k=r.getToken();for(;k!==17;){if(U.indexOf(k)!==-1){le();break}else if(R.indexOf(k)!==-1)break;k=le()}}}function V(A){const U=r.getTokenValue();return A?Y(U):I(U),le(),!0}function N(){switch(r.getToken()){case 11:{let A=0;try{A=JSON.parse(r.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}Y(A);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return le(),!0}function F(){return r.getToken()!==10?(ie(3,[],[2,5]),!1):(V(!1),r.getToken()===6?(X(":"),le(),J()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function z(){E(),le();let A=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),X(","),le(),r.getToken()===2&&fe)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return O(),r.getToken()!==2?ie(7,[2],[]):le(),!0}function $(){W(),le();let A=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),X(","),le(),r.getToken()===4&&fe)break}else A&&ie(6,[],[]);J()||ie(4,[],[4,5]),A=!0}return _(),r.getToken()!==4?ie(8,[4],[]):le(),!0}function J(){switch(r.getToken()){case 3:return $();case 1:return z();case 10:return V(!0);default:return N()}}return le(),r.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):J()?(r.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}i.visit=g;function l(e,n){const t=L(e),r=[];let o,S=0,E;do switch(E=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:S!==E&&r.push(e.substring(S,E)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),S=t.getPosition();break}while(o!==17);return r.join("")}i.stripComments=l;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function B(P){const T=[];typeof P=="number"&&T.push("code/timeOrigin",P);function L(a){T.push(a,Date.now())}function p(){const a=[];for(let d=0;d<T.length;d+=2)a.push({name:T[d],startTime:T[d+1]});return a}return{mark:L,getMarks:p}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(P+L.startTime)});return T}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function D(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=i()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=D(C))}(),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var C in D)(typeof exports=="object"?exports:B)[C]=D[C]}}(typeof self<"u"?self:this,function(){return function(B){var i={};function D(C){if(i[C])return i[C].exports;var P=i[C]={i:C,l:!1,exports:{}};return B[C].call(P.exports,P,P.exports,D),P.l=!0,P.exports}return D.m=B,D.c=i,D.d=function(C,P,T){D.o(C,P)||Object.defineProperty(C,P,{enumerable:!0,get:T})},D.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},D.t=function(C,P){if(1&P&&(C=D(C)),8&P||4&P&&typeof C=="object"&&C&&C.__esModule)return C;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:C}),2&P&&typeof C!="string")for(var L in C)D.d(T,L,function(p){return C[p]}.bind(null,L));return T},D.n=function(C){var P=C&&C.__esModule?function(){return C.default}:function(){return C};return D.d(P,"a",P),P},D.o=function(C,P){return Object.prototype.hasOwnProperty.call(C,P)},D.p="",D(D.s=0)}([function(B,i,D){(function(C){var P;i=B.exports=R,P=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,p=i.re=[],a=i.src=[],d=0,b=d++;a[b]="0|[1-9]\\d*";var w=d++;a[w]="[0-9]+";var h=d++;a[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=d++;a[v]="("+a[b]+")\\.("+a[b]+")\\.("+a[b]+")";var f=d++;a[f]="("+a[w]+")\\.("+a[w]+")\\.("+a[w]+")";var m=d++;a[m]="(?:"+a[b]+"|"+a[h]+")";var y=d++;a[y]="(?:"+a[w]+"|"+a[h]+")";var c=d++;a[c]="(?:-("+a[m]+"(?:\\."+a[m]+")*))";var u=d++;a[u]="(?:-?("+a[y]+"(?:\\."+a[y]+")*))";var g=d++;a[g]="[0-9A-Za-z-]+";var l=d++;a[l]="(?:\\+("+a[g]+"(?:\\."+a[g]+")*))";var s=d++,e="v?"+a[v]+a[c]+"?"+a[l]+"?";a[s]="^"+e+"$";var n="[v=\\s]*"+a[f]+a[u]+"?"+a[l]+"?",t=d++;a[t]="^"+n+"$";var r=d++;a[r]="((?:<|>)?=?)";var o=d++;a[o]=a[w]+"|x|X|\\*";var S=d++;a[S]=a[b]+"|x|X|\\*";var E=d++;a[E]="[v=\\s]*("+a[S]+")(?:\\.("+a[S]+")(?:\\.("+a[S]+")(?:"+a[c]+")?"+a[l]+"?)?)?";var I=d++;a[I]="[v=\\s]*("+a[o]+")(?:\\.("+a[o]+")(?:\\.("+a[o]+")(?:"+a[u]+")?"+a[l]+"?)?)?";var O=d++;a[O]="^"+a[r]+"\\s*"+a[E]+"$";var W=d++;a[W]="^"+a[r]+"\\s*"+a[I]+"$";var _=d++;a[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=d++;a[Y]="(?:~>?)";var X=d++;a[X]="(\\s*)"+a[Y]+"\\s+",p[X]=new RegExp(a[X],"g");var re=d++;a[re]="^"+a[Y]+a[E]+"$";var se=d++;a[se]="^"+a[Y]+a[I]+"$";var ne=d++;a[ne]="(?:\\^)";var fe=d++;a[fe]="(\\s*)"+a[ne]+"\\s+",p[fe]=new RegExp(a[fe],"g");var le=d++;a[le]="^"+a[ne]+a[E]+"$";var ie=d++;a[ie]="^"+a[ne]+a[I]+"$";var V=d++;a[V]="^"+a[r]+"\\s*("+n+")$|^$";var N=d++;a[N]="^"+a[r]+"\\s*("+e+")$|^$";var F=d++;a[F]="(\\s*)"+a[r]+"\\s*("+n+"|"+a[E]+")",p[F]=new RegExp(a[F],"g");var z=d++;a[z]="^\\s*("+a[E]+")\\s+-\\s+("+a[E]+")\\s*$";var $=d++;a[$]="^\\s*("+a[I]+")\\s+-\\s+("+a[I]+")\\s*$";var J=d++;a[J]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)P(A,a[A]),p[A]||(p[A]=new RegExp(a[A]));function U(x,G){if(x instanceof R)return x;if(typeof x!="string"||x.length>T||!(G?p[t]:p[s]).test(x))return null;try{return new R(x,G)}catch{return null}}function R(x,G){if(x instanceof R){if(x.loose===G)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof R))return new R(x,G);P("SemVer",x,G),this.loose=G;var K=x.trim().match(G?p[t]:p[s]);if(!K)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<L)return me}return ue}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}i.parse=U,i.valid=function(x,G){var K=U(x,G);return K?K.version:null},i.clean=function(x,G){var K=U(x.trim().replace(/^[=v]+/,""),G);return K?K.version:null},i.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(x){return P("SemVer.compare",this.version,this.loose,x),x instanceof R||(x=new R(x,this.loose)),this.compareMain(x)||this.comparePre(x)},R.prototype.compareMain=function(x){return x instanceof R||(x=new R(x,this.loose)),M(this.major,x.major)||M(this.minor,x.minor)||M(this.patch,x.patch)},R.prototype.comparePre=function(x){if(x instanceof R||(x=new R(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],ue=x.prerelease[G];if(P("prerelease compare",G,K,ue),K===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(K===void 0)return-1;if(K!==ue)return M(K,ue)}while(++G)},R.prototype.inc=function(x,G){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},i.inc=function(x,G,K,ue){typeof K=="string"&&(ue=K,K=void 0);try{return new R(x,K).inc(G,ue).version}catch{return null}},i.diff=function(x,G){if(ae(x,G))return null;var K=U(x),ue=U(G);if(K.prerelease.length||ue.prerelease.length){for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==ue[me])return me},i.compareIdentifiers=M;var k=/^[0-9]+$/;function M(x,G){var K=k.test(x),ue=k.test(G);return K&&ue&&(x=+x,G=+G),K&&!ue?-1:ue&&!K?1:x<G?-1:x>G?1:0}function j(x,G,K){return new R(x,K).compare(new R(G,K))}function q(x,G,K){return j(x,G,K)>0}function H(x,G,K){return j(x,G,K)<0}function ae(x,G,K){return j(x,G,K)===0}function ce(x,G,K){return j(x,G,K)!==0}function pe(x,G,K){return j(x,G,K)>=0}function Se(x,G,K){return j(x,G,K)<=0}function te(x,G,K,ue){var me;switch(G){case"===":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),me=x===K;break;case"!==":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),me=x!==K;break;case"":case"=":case"==":me=ae(x,K,ue);break;case"!=":me=ce(x,K,ue);break;case">":me=q(x,K,ue);break;case">=":me=pe(x,K,ue);break;case"<":me=H(x,K,ue);break;case"<=":me=Se(x,K,ue);break;default:throw new TypeError("Invalid operator: "+G)}return me}function oe(x,G){if(x instanceof oe){if(x.loose===G)return x;x=x.value}if(!(this instanceof oe))return new oe(x,G);P("comparator",x,G),this.loose=G,this.parse(x),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}i.rcompareIdentifiers=function(x,G){return M(G,x)},i.major=function(x,G){return new R(x,G).major},i.minor=function(x,G){return new R(x,G).minor},i.patch=function(x,G){return new R(x,G).patch},i.compare=j,i.compareLoose=function(x,G){return j(x,G,!0)},i.rcompare=function(x,G,K){return j(G,x,K)},i.sort=function(x,G){return x.sort(function(K,ue){return i.compare(K,ue,G)})},i.rsort=function(x,G){return x.sort(function(K,ue){return i.rcompare(K,ue,G)})},i.gt=q,i.lt=H,i.eq=ae,i.neq=ce,i.gte=pe,i.lte=Se,i.cmp=te,i.Comparator=oe;var de={};function he(x,G){if(x instanceof he)return x.loose===G?x:new he(x.raw,G);if(x instanceof oe)return new he(x.value,G);if(!(this instanceof he))return new he(x,G);if(this.loose=G,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function ve(x){return!x||x.toLowerCase()==="x"||x==="*"}function Te(x,G,K,ue,me,Ce,we,Le,be,De,Me,Re,Oe){return((G=ve(K)?"":ve(ue)?">="+K+".0.0":ve(me)?">="+K+"."+ue+".0":">="+G)+" "+(Le=ve(be)?"":ve(De)?"<"+(+be+1)+".0.0":ve(Me)?"<"+be+"."+(+De+1)+".0":Re?"<="+be+"."+De+"."+Me+"-"+Re:"<="+Le)).trim()}function Fe(x,G){for(var K=0;K<x.length;K++)if(!x[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<x.length;K++)if(P(x[K].semver),x[K].semver!==de&&x[K].semver.prerelease.length>0){var ue=x[K].semver;if(ue.major===G.major&&ue.minor===G.minor&&ue.patch===G.patch)return!0}return!1}return!0}function Ue(x,G,K){try{G=new he(G,K)}catch{return!1}return G.test(x)}function xe(x,G,K,ue){var me,Ce,we,Le,be;switch(x=new R(x,ue),G=new he(G,ue),K){case">":me=q,Ce=Se,we=H,Le=">",be=">=";break;case"<":me=H,Ce=pe,we=q,Le="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,G,ue))return!1;for(var De=0;De<G.set.length;++De){var Me=G.set[De],Re=null,Oe=null;if(Me.forEach(function(Ae){Ae.semver===de&&(Ae=new oe(">=0.0.0")),Re=Re||Ae,Oe=Oe||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Oe.semver,ue)&&(Oe=Ae)}),Re.operator===Le||Re.operator===be||(!Oe.operator||Oe.operator===Le)&&Ce(x,Oe.semver)||Oe.operator===be&&we(x,Oe.semver))return!1}return!0}oe.prototype.parse=function(x){var G=this.loose?p[V]:p[N],K=x.match(G);if(!K)throw new TypeError("Invalid comparator: "+x);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new R(K[2],this.loose):this.semver=de},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(x){return P("Comparator.test",x,this.loose),this.semver===de||(typeof x=="string"&&(x=new R(x,this.loose)),te(x,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(x,G){if(!(x instanceof oe))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new he(x.value,G),Ue(this.value,K,G);if(x.operator==="")return K=new he(this.value,G),Ue(x.semver,K,G);var ue=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Ce=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=te(this.semver,"<",x.semver,G)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),be=te(this.semver,">",x.semver,G)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ue||me||Ce&&we||Le||be},i.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(x){var G=this.loose;x=x.trim(),P("range",x,G);var K=G?p[$]:p[z];x=x.replace(K,Te),P("hyphen replace",x),x=x.replace(p[F],"$1$2$3"),P("comparator trim",x,p[F]),x=(x=(x=x.replace(p[X],"$1~")).replace(p[fe],"$1^")).split(/\s+/).join(" ");var ue=G?p[V]:p[N],me=x.split(" ").map(function(Ce){return function(we,Le){return P("comp",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){P("caret",Re,Oe);var Ae=Oe?p[ie]:p[le];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return P("caret",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?ke="":ve(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?ke=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(P("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(P("no pr"),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),P("caret return",ke),ke})}(Me,De)}).join(" ")}(we,Le),P("caret",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){var Ae=Oe?p[se]:p[re];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return P("tilde",Re,Ne,ye,Ee,Pe,Ie),ve(ye)?ke="":ve(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":ve(Pe)?ke=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(P("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):ke=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",P("tilde return",ke),ke})}(Me,De)}).join(" ")}(we,Le),P("tildes",we),we=function(be,De){return P("replaceXRanges",be,De),be.split(/\s+/).map(function(Me){return function(Re,Oe){Re=Re.trim();var Ae=Oe?p[W]:p[O];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,ke){P("xRange",Re,Ne,ye,Ee,Pe,Ie,ke);var We=ve(Ee),ze=We||ve(Pe),je=ze||ve(Ie);return ye==="="&&je&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),P("xRange return",Ne),Ne})}(Me,De)}).join(" ")}(we,Le),P("xrange",we),we=function(be,De){return P("replaceStars",be,De),be.trim().replace(p[J],"")}(we,Le),P("stars",we),we}(Ce,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(ue)})),me=me.map(function(Ce){return new oe(Ce,G)})},he.prototype.intersects=function(x,G){if(!(x instanceof he))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ue){return x.set.some(function(me){return me.every(function(Ce){return ue.intersects(Ce,G)})})})})},i.toComparators=function(x,G){return new he(x,G).set.map(function(K){return K.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},he.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new R(x,this.loose));for(var G=0;G<this.set.length;G++)if(Fe(this.set[G],x))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(x,G,K){var ue=null,me=null;try{var Ce=new he(G,K)}catch{return null}return x.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==-1||(me=new R(ue=we,K)))}),ue},i.minSatisfying=function(x,G,K){var ue=null,me=null;try{var Ce=new he(G,K)}catch{return null}return x.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==1||(me=new R(ue=we,K)))}),ue},i.validRange=function(x,G){try{return new he(x,G).range||"*"}catch{return null}},i.ltr=function(x,G,K){return xe(x,G,"<",K)},i.gtr=function(x,G,K){return xe(x,G,">",K)},i.outside=xe,i.prerelease=function(x,G){var K=U(x,G);return K&&K.prerelease.length?K.prerelease:null},i.intersects=function(x,G,K){return x=new he(x,K),G=new he(G,K),x.intersects(G)},i.coerce=function(x){if(x instanceof R)return x;if(typeof x!="string")return null;var G=x.match(p[_]);return G==null?null:U((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,D(1))},function(B,i){var D,C,P=B.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function p(y){if(D===setTimeout)return setTimeout(y,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch{D=T}try{C=typeof clearTimeout=="function"?clearTimeout:L}catch{C=L}})();var a,d=[],b=!1,w=-1;function h(){b&&a&&(b=!1,a.length?d=a.concat(d):w=-1,d.length&&v())}function v(){if(!b){var y=p(h);b=!0;for(var c=d.length;c;){for(a=d,d=[];++w<c;)a&&a[w].run();w=-1,c=d.length}a=null,b=!1,function(u){if(C===clearTimeout)return clearTimeout(u);if((C===L||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(u);try{C(u)}catch{try{return C.call(null,u)}catch{return C.call(this,u)}}}(y)}}function f(y,c){this.fun=y,this.array=c}function m(){}P.nextTick=function(y){var c=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)c[u-1]=arguments[u];d.push(new f(y,c)),d.length!==1||b||p(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=m,P.addListener=m,P.once=m,P.off=m,P.removeListener=m,P.removeAllListeners=m,P.emit=m,P.prependListener=m,P.prependOnceListener=m,P.listeners=function(y){return[]},P.binding=function(y){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(y){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(B,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class C{constructor(p,a,d){this.level=p,this.key=a,this.value=d,this.forward=[]}}const P=void 0;class T{constructor(p,a=2**16){this.comparator=p,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(a)|0),this._header=new C(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new C(this._maxLevel,P,P)}has(p){return Boolean(T._search(this,p,this.comparator))}get(p){return T._search(this,p,this.comparator)?.value}set(p,a){return T._insert(this,p,a,this.comparator)&&(this._size+=1),this}delete(p){const a=T._delete(this,p,this.comparator);return a&&(this._size-=1),a}forEach(p,a){let d=this._header.forward[0];for(;d;)p.call(a,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",a=this._header.forward[0];for(;a;)p+=`node(${a.key}, ${a.value}, lvl:${a.level})`,a=a.forward[0];return p}static _search(p,a,d){let b=p._header;for(let w=p._level-1;w>=0;w--)for(;b.forward[w]&&d(b.forward[w].key,a)<0;)b=b.forward[w];if(b=b.forward[0],b&&d(b.key,a)===0)return b}static _insert(p,a,d,b){const w=[];let h=p._header;for(let v=p._level-1;v>=0;v--){for(;h.forward[v]&&b(h.forward[v].key,a)<0;)h=h.forward[v];w[v]=h}if(h=h.forward[0],h&&b(h.key,a)===0)return h.value=d,!1;{const v=T._randomLevel(p);if(v>p._level){for(let f=p._level;f<v;f++)w[f]=p._header;p._level=v}h=new C(v,a,d);for(let f=0;f<v;f++)h.forward[f]=w[f].forward[f],w[f].forward[f]=h;return!0}}static _randomLevel(p,a=.5){let d=1;for(;Math.random()<a&&d<p._maxLevel;)d+=1;return d}static _delete(p,a,d){const b=[];let w=p._header;for(let h=p._level-1;h>=0;h--){for(;w.forward[h]&&d(w.forward[h].key,a)<0;)w=w.forward[h];b[h]=w}if(w=w.forward[0],!w||d(w.key,a)!==0)return!1;for(let h=0;h<p._level&&b[h].forward[h]===w;h++)b[h].forward[h]=w.forward[h];for(;p._level>0&&p._header.forward[p._level-1]===P;)p._level-=1;return!0}}i.SkipList=T}),define(Q[43],Z([0,1,11,2]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function P(l){const s=l;return s?typeof s.read=="function":!1}i.isReadable=P;function T(l){const s=l;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=T;function L(l){const s=l;return s?T(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=L;function p(l,s){return new a(l,s)}i.newWriteableStream=p;class a{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(e);t>=0&&n.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(l,s){const e=[];let n;for(;(n=l.read())!==null;)e.push(n);return s(e)}i.consumeReadable=d;function b(l,s,e){const n=[];let t;for(;(t=l.read())!==null&&n.length<e;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return l.read()}}}i.peekReadable=b;function w(l,s){return new Promise((e,n)=>{const t=[];h(l,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=w;function h(l,s){let e=!1;return l.on("error",n=>{e||s.onError(n)}),l.on("end",()=>{e||s.onEnd()}),l.on("data",n=>{e||s.onData(n)}),(0,C.toDisposable)(()=>e=!0)}i.listenStream=h;function v(l,s){return new Promise((e,n)=>{const t=new C.DisposableStore,r=[],o=I=>{if(r.push(I),r.length>s)return t.dispose(),l.pause(),e({stream:l,buffer:r,ended:!1})},S=I=>n(I),E=()=>e({stream:l,buffer:r,ended:!0});t.add((0,C.toDisposable)(()=>l.removeListener("error",S))),l.on("error",S),t.add((0,C.toDisposable)(()=>l.removeListener("end",E))),l.on("end",E),t.add((0,C.toDisposable)(()=>l.removeListener("data",o))),l.on("data",o)})}i.peekStream=v;function f(l,s){const e=p(s);return e.end(l),e}i.toStream=f;function m(){const l=p(()=>{throw new Error("not supported")});return l.end(),l}i.emptyStream=m;function y(l){let s=!1;return{read:()=>s?null:(s=!0,l)}}i.toReadable=y;function c(l,s,e){const n=p(e);return h(l,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}i.transform=c;function u(l,s,e){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?e([l,t]):l)}}}i.prefixedReadable=u;function g(l,s,e){let n=!1;const t=p(e);return h(s,{onData:r=>n?t.write(r):(n=!0,t.write(e([l,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(l)),t.end()}}),t}i.prefixedStream=g}),define(Q[15],Z([0,1,43]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const C=typeof Buffer<"u";let P,T;class L{constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}static alloc(I){return C?new L(Buffer.allocUnsafe(I)):new L(new Uint8Array(I))}static wrap(I){return C&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new L(I)}static fromString(I,O){return!(O?.dontUseNodeBuffer||!1)&&C?new L(Buffer.from(I)):(P||(P=new TextEncoder),new L(P.encode(I)))}static fromByteArray(I){const O=L.alloc(I.length);for(let W=0,_=I.length;W<_;W++)O.buffer[W]=I[W];return O}static concat(I,O){if(typeof O>"u"){O=0;for(let Y=0,X=I.length;Y<X;Y++)O+=I[Y].byteLength}const W=L.alloc(O);let _=0;for(let Y=0,X=I.length;Y<X;Y++){const re=I[Y];W.set(re,_),_+=re.byteLength}return W}clone(){const I=L.alloc(this.byteLength);return I.set(this),I}toString(){return C?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(I,O){return new L(this.buffer.subarray(I,O))}set(I,O){if(I instanceof L)this.buffer.set(I.buffer,O);else if(I instanceof Uint8Array)this.buffer.set(I,O);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),O);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),O);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return d(this.buffer,I)}writeUInt32BE(I,O){b(this.buffer,I,O)}readUInt32LE(I){return w(this.buffer,I)}writeUInt32LE(I,O){h(this.buffer,I,O)}readUInt8(I){return v(this.buffer,I)}writeUInt8(I,O){f(this.buffer,I,O)}}i.VSBuffer=L;function p(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0}i.readUInt16LE=p;function a(E,I,O){E[O+0]=I&255,I=I>>>8,E[O+1]=I&255}i.writeUInt16LE=a;function d(E,I){return E[I]*2**24+E[I+1]*2**16+E[I+2]*2**8+E[I+3]}i.readUInt32BE=d;function b(E,I,O){E[O+3]=I,I=I>>>8,E[O+2]=I,I=I>>>8,E[O+1]=I,I=I>>>8,E[O]=I}i.writeUInt32BE=b;function w(E,I){return E[I+0]<<0>>>0|E[I+1]<<8>>>0|E[I+2]<<16>>>0|E[I+3]<<24>>>0}i.readUInt32LE=w;function h(E,I,O){E[O+0]=I&255,I=I>>>8,E[O+1]=I&255,I=I>>>8,E[O+2]=I&255,I=I>>>8,E[O+3]=I&255}i.writeUInt32LE=h;function v(E,I){return E[I]}i.readUInt8=v;function f(E,I,O){E[O]=I}i.writeUInt8=f;function m(E){return D.consumeReadable(E,I=>L.concat(I))}i.readableToBuffer=m;function y(E){return D.toReadable(E)}i.bufferToReadable=y;function c(E){return D.consumeStream(E,I=>L.concat(I))}i.streamToBuffer=c;async function u(E){return E.ended?L.concat(E.buffer):L.concat([...E.buffer,await c(E.stream)])}i.bufferedStreamToBuffer=u;function g(E){return D.toStream(E,I=>L.concat(I))}i.bufferToStream=g;function l(E){return D.transform(E,{data:I=>typeof I=="string"?L.fromString(I):L.wrap(I)},I=>L.concat(I))}i.streamToBufferReadableStream=l;function s(E){return D.newWriteableStream(I=>L.concat(I),E)}i.newWriteableBufferStream=s;function e(E,I){return D.prefixedReadable(E,I,O=>L.concat(O))}i.prefixedBufferReadable=e;function n(E,I){return D.prefixedStream(E,I,O=>L.concat(O))}i.prefixedBufferStream=n;function t(E){let I=0,O=0,W=0;const _=new Uint8Array(Math.floor(E.length/4*3)),Y=re=>{switch(O){case 3:_[W++]=I|re,O=0;break;case 2:_[W++]=I|re>>>2,I=re<<6,O=3;break;case 1:_[W++]=I|re>>>4,I=re<<4,O=2;break;default:I=re<<2,O=1}};for(let re=0;re<E.length;re++){const se=E.charCodeAt(re);if(se>=65&&se<=90)Y(se-65);else if(se>=97&&se<=122)Y(se-97+26);else if(se>=48&&se<=57)Y(se-48+52);else if(se===43||se===45)Y(62);else if(se===47||se===95)Y(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${E[re]}`)}}const X=W;for(;O>0;)Y(0);return L.wrap(_).slice(0,X)}i.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:E},I=!0,O=!1){const W=O?o:r;let _="";const Y=E.byteLength%3;let X=0;for(;X<E.byteLength-Y;X+=3){const re=E[X+0],se=E[X+1],ne=E[X+2];_+=W[re>>>2],_+=W[(re<<4|se>>>4)&63],_+=W[(se<<2|ne>>>6)&63],_+=W[ne&63]}if(Y===1){const re=E[X+0];_+=W[re>>>2],_+=W[re<<4&63],I&&(_+="==")}else if(Y===2){const re=E[X+0],se=E[X+1];_+=W[re>>>2],_+=W[(re<<4|se>>>4)&63],_+=W[se<<2&63],I&&(_+="=")}return _}i.encodeBase64=S}),define(Q[26],Z([0,1,5]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createProxyObject=i.getAllMethodNames=i.getAllPropertyNames=i.filter=i.getCaseInsensitive=i.distinct=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const u=Array.isArray(c)?[]:{};return Object.keys(c).forEach(g=>{c[g]&&typeof c[g]=="object"?u[g]=C(c[g]):u[g]=c[g]}),u}i.deepClone=C;function P(c){if(!c||typeof c!="object")return c;const u=[c];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const l in g)if(T.call(g,l)){const s=g[l];typeof s=="object"&&!Object.isFrozen(s)&&!(0,D.isTypedArray)(s)&&u.push(s)}}return c}i.deepFreeze=P;const T=Object.prototype.hasOwnProperty;function L(c,u){return p(c,u,new Set)}i.cloneAndChange=L;function p(c,u,g){if((0,D.isUndefinedOrNull)(c))return c;const l=u(c);if(typeof l<"u")return l;if(Array.isArray(c)){const s=[];for(const e of c)s.push(p(e,u,g));return s}if((0,D.isObject)(c)){if(g.has(c))throw new Error("Cannot clone recursive data-structure");g.add(c);const s={};for(const e in c)T.call(c,e)&&(s[e]=p(c[e],u,g));return g.delete(c),s}return c}function a(c,u,g=!0){return(0,D.isObject)(c)?((0,D.isObject)(u)&&Object.keys(u).forEach(l=>{l in c?g&&((0,D.isObject)(c[l])&&(0,D.isObject)(u[l])?a(c[l],u[l],g):c[l]=u[l]):c[l]=u[l]}),c):u}i.mixin=a;function d(c,u){if(c===u)return!0;if(c==null||u===null||u===void 0||typeof c!=typeof u||typeof c!="object"||Array.isArray(c)!==Array.isArray(u))return!1;let g,l;if(Array.isArray(c)){if(c.length!==u.length)return!1;for(g=0;g<c.length;g++)if(!d(c[g],u[g]))return!1}else{const s=[];for(l in c)s.push(l);s.sort();const e=[];for(l in u)e.push(l);if(e.sort(),!d(s,e))return!1;for(g=0;g<s.length;g++)if(!d(c[s[g]],u[s[g]]))return!1}return!0}i.equals=d;function b(c){const u=new Set;return JSON.stringify(c,(g,l)=>{if((0,D.isObject)(l)||Array.isArray(l)){if(u.has(l))return"[Circular]";u.add(l)}return l})}i.safeStringify=b;function w(c,u){const g=Object.create(null);return!c||!u||Object.keys(u).forEach(s=>{const e=c[s],n=u[s];d(e,n)||(g[s]=n)}),g}i.distinct=w;function h(c,u){const g=u.toLowerCase(),l=Object.keys(c).find(s=>s.toLowerCase()===g);return l?c[l]:c[u]}i.getCaseInsensitive=h;function v(c,u){const g=Object.create(null);for(const[l,s]of Object.entries(c))u(l,s)&&(g[l]=s);return g}i.filter=v;function f(c){let u=[],g=Object.getPrototypeOf(c);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}i.getAllPropertyNames=f;function m(c){const u=[];for(const g of f(c))typeof c[g]=="function"&&u.push(g);return u}i.getAllMethodNames=m;function y(c,u){const g=s=>function(){const e=Array.prototype.slice.call(arguments,0);return u(s,e)},l={};for(const s of c)l[s]=g(s);return l}i.createProxyObject=y}),define(Q[30],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(P){return D.test(P)}i.isUUID=C,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(p){for(let a=0;a<p.length;a++)p[a]=Math.floor(Math.random()*256);return p};const T=new Uint8Array(16),L=[];for(let p=0;p<256;p++)L.push(p.toString(16).padStart(2,"0"));return function(){P(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let a=0,d="";return d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+="-",d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d+=L[T[a++]],d}}()}),define(Q[70],Z([6,7]),function(B,i){return B.create("vs/base/common/date",i)}),define(Q[71],Z([0,1,70]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const C=60,P=C*60,T=P*24,L=T*7,p=T*30,a=T*365;function d(w,h,v){typeof w!="number"&&(w=w.getTime());const f=Math.round((new Date().getTime()-w)/1e3);if(f<-30)return(0,D.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let m;return f<C?(m=f,h?m===1?v?(0,D.localize)(2,null,m):(0,D.localize)(3,null,m):v?(0,D.localize)(4,null,m):(0,D.localize)(5,null,m):m===1?v?(0,D.localize)(6,null,m):(0,D.localize)(7,null,m):v?(0,D.localize)(8,null,m):(0,D.localize)(9,null,m)):f<P?(m=Math.floor(f/C),h?m===1?v?(0,D.localize)(10,null,m):(0,D.localize)(11,null,m):v?(0,D.localize)(12,null,m):(0,D.localize)(13,null,m):m===1?v?(0,D.localize)(14,null,m):(0,D.localize)(15,null,m):v?(0,D.localize)(16,null,m):(0,D.localize)(17,null,m)):f<T?(m=Math.floor(f/P),h?m===1?v?(0,D.localize)(18,null,m):(0,D.localize)(19,null,m):v?(0,D.localize)(20,null,m):(0,D.localize)(21,null,m):m===1?v?(0,D.localize)(22,null,m):(0,D.localize)(23,null,m):v?(0,D.localize)(24,null,m):(0,D.localize)(25,null,m)):f<L?(m=Math.floor(f/T),h?m===1?(0,D.localize)(26,null,m):(0,D.localize)(27,null,m):m===1?(0,D.localize)(28,null,m):(0,D.localize)(29,null,m)):f<p?(m=Math.floor(f/L),h?m===1?v?(0,D.localize)(30,null,m):(0,D.localize)(31,null,m):v?(0,D.localize)(32,null,m):(0,D.localize)(33,null,m):m===1?v?(0,D.localize)(34,null,m):(0,D.localize)(35,null,m):v?(0,D.localize)(36,null,m):(0,D.localize)(37,null,m)):f<a?(m=Math.floor(f/p),h?m===1?v?(0,D.localize)(38,null,m):(0,D.localize)(39,null,m):v?(0,D.localize)(40,null,m):(0,D.localize)(41,null,m):m===1?v?(0,D.localize)(42,null,m):(0,D.localize)(43,null,m):v?(0,D.localize)(44,null,m):(0,D.localize)(45,null,m)):(m=Math.floor(f/a),h?m===1?v?(0,D.localize)(46,null,m):(0,D.localize)(47,null,m):v?(0,D.localize)(48,null,m):(0,D.localize)(49,null,m):m===1?v?(0,D.localize)(50,null,m):(0,D.localize)(51,null,m):v?(0,D.localize)(52,null,m):(0,D.localize)(53,null,m))}i.fromNow=d;function b(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=b}),define(Q[72],Z([6,7]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(Q[31],Z([0,1,19,5,72]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function T(w,h){return h&&(w.stack||w.stacktrace)?P.localize(0,null,p(w),L(w.stack)||L(w.stacktrace)):p(w)}function L(w){return Array.isArray(w)?w.join(`
`):w}function p(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?P.localize(1,null,w.message):w.message||P.localize(2,null)}function a(w=null,h=!1){if(!w)return P.localize(3,null);if(Array.isArray(w)){const v=D.coalesce(w),f=a(v[0],h);return v.length>1?P.localize(4,null,f,v.length):f}if(C.isString(w))return w;if(w.detail){const v=w.detail;if(v.error)return T(v.error,h);if(v.exception)return T(v.exception,h)}return w.stack?T(w,h):w.message?w.message:P.localize(5,null)}i.toErrorMessage=a;function d(w){const h=w;return h instanceof Error&&Array.isArray(h.actions)}i.isErrorWithActions=d;function b(w,h){let v;return typeof w=="string"?v=new Error(w):v=w,v.actions=h,v}i.createErrorWithActions=b}),define(Q[73],Z([6,7]),function(B,i){return B.create("vs/base/common/jsonErrorMessages",i)}),define(Q[74],Z([0,1,73]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function C(P){switch(P){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}i.getParseErrorMessage=C}),define(Q[51],Z([0,1,13]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var C;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(C=i.Source||(i.Source={}));var P;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(P=i.TerminateResponseCode||(i.TerminateResponseCode={}));function T(p,...a){const d=a.reduce((h,v)=>(h[v]=!0,h),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(h=>!d[h]).forEach(h=>{for(let v=0;v<b.length;v++)if(h.search(b[v])!==-1){delete p[h];break}})}i.sanitizeProcessEnvironment=T;function L(p){!p||(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}i.removeDangerousEnvVariables=L}),define(Q[52],Z([0,1,4,2]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const P=L=>({onDidChange:D.Event.None,value:L});i.staticObservableValue=P;class T extends C.Disposable{constructor(p){super(),this._value=p,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}}i.MutableObservableValue=T}),define(Q[53],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function C(c){return P(c,0)}i.hash=C;function P(c,u){switch(typeof c){case"object":return c===null?T(349,u):Array.isArray(c)?a(c,u):d(c,u);case"string":return p(c,u);case"boolean":return L(c,u);case"number":return T(c,u);case"undefined":return T(937,u);default:return T(617,u)}}i.doHash=P;function T(c,u){return(u<<5)-u+c|0}i.numberHash=T;function L(c,u){return T(c?433:863,u)}function p(c,u){u=T(149417,u);for(let g=0,l=c.length;g<l;g++)u=T(c.charCodeAt(g),u);return u}i.stringHash=p;function a(c,u){return u=T(104579,u),c.reduce((g,l)=>P(l,g),u)}function d(c,u){return u=T(181387,u),Object.keys(c).sort().reduce((g,l)=>(g=p(l,g),P(c[l],g)),u)}class b{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=P(u,this._value),this._value}}i.Hasher=b;var w;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function h(c,u,g=32){const l=g-u,s=~((1<<l)-1);return(c<<u|(s&c)>>>l)>>>0}function v(c,u=0,g=c.byteLength,l=0){for(let s=0;s<g;s++)c[u+s]=l}function f(c,u,g="0"){for(;c.length<u;)c=g+c;return c}function m(c,u=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(g=>g.toString(16).padStart(2,"0")).join(""):f((c>>>0).toString(16),u/4)}i.toHexString=m;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const l=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,n,t;for(e!==0?(n=e,t=-1,e=0):(n=u.charCodeAt(0),t=0);;){let r=n;if(D.isHighSurrogate(n))if(t+1<g){const o=u.charCodeAt(t+1);D.isLowSurrogate(o)?(t++,r=D.computeCodePoint(n,o)):r=65533}else{e=n;break}else D.isLowSurrogate(n)&&(r=65533);if(s=this._push(l,s,r),t++,t<g)n=u.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(u,g,l){return l<128?u[g++]=l:l<2048?(u[g++]=192|(l&1984)>>>6,u[g++]=128|(l&63)>>>0):l<65536?(u[g++]=224|(l&61440)>>>12,u[g++]=128|(l&4032)>>>6,u[g++]=128|(l&63)>>>0):(u[g++]=240|(l&1835008)>>>18,u[g++]=128|(l&258048)>>>12,u[g++]=128|(l&4032)>>>6,u[g++]=128|(l&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=y._bigBlock32,g=this._buffDV;for(let E=0;E<64;E+=4)u.setUint32(E,g.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)u.setUint32(E,h(u.getUint32(E-12,!1)^u.getUint32(E-32,!1)^u.getUint32(E-56,!1)^u.getUint32(E-64,!1),1),!1);let l=this._h0,s=this._h1,e=this._h2,n=this._h3,t=this._h4,r,o,S;for(let E=0;E<80;E++)E<20?(r=s&e|~s&n,o=1518500249):E<40?(r=s^e^n,o=1859775393):E<60?(r=s&e|s&n|e&n,o=2400959708):(r=s^e^n,o=3395469782),S=h(l,5)+r+t+o+u.getUint32(E*4,!1)&4294967295,t=n,n=e,e=h(s,30),s=l,l=S;this._h0=this._h0+l&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const T="error",L="warning",p="warn",a="info",d="ignore";function b(h){return h?D.equalsIgnoreCase(T,h)?P.Error:D.equalsIgnoreCase(L,h)||D.equalsIgnoreCase(p,h)?P.Warning:D.equalsIgnoreCase(a,h)?P.Info:P.Ignore:P.Ignore}P.fromValue=b;function w(h){switch(h){case P.Error:return T;case P.Warning:return L;case P.Info:return a;default:return d}}P.toString=w}(C||(C={})),i.default=C}),define(Q[75],Z([0,1,10]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function C(d){const b=d;return b&&typeof b.type=="string"&&typeof b.severity=="string"}i.isRemoteConsoleLog=C;function P(d){const b=[];let w;try{const h=JSON.parse(d.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),w=v.__$stack),b.push(...h)}catch{b.push("Unable to log remote console arguments",d.arguments)}return{args:b,stack:w}}i.parse=P;function T(d){if(typeof d!="string")return T(P(d).stack);const b=d;if(b){const w=L(b),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}i.getFirstFrame=T;function L(d){if(!d)return d;const b=d.indexOf(`
`);return b===-1?d:d.substring(0,b)}function p(d,b){const{args:w,stack:h}=P(d),v=typeof w[0]=="string"&&w.length===1;let f=L(h);f&&(f=`(${f.trim()})`);let m=[];if(typeof w[0]=="string"?f&&v?m=[`%c[${b}] %c${w[0]} %c${f}`,a("blue"),a(""),a("grey")]:m=[`%c[${b}] %c${w[0]}`,a("blue"),a(""),...w.slice(1)]:m=[`%c[${b}]%`,a("blue"),...w],f&&!v&&m.push(f),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,m)}i.log=p;function a(d){return`color: ${d}`}}),define(Q[44],Z([0,1,15,27,10]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function T(d){return JSON.stringify(d,p)}i.stringify=T;function L(d){let b=JSON.parse(d);return b=a(b),b}i.parse=L;function p(d,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,C.regExpFlags)(b)}:b}function a(d,b=0){if(!d||b>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return P.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof D.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let w=0;w<d.length;++w)d[w]=a(d[w],b+1);else for(const w in d)Object.hasOwnProperty.call(d,w)&&(d[w]=a(d[w],b+1))}return d}i.revive=a}),define(Q[76],Z([0,1,38,14,20]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,L=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var a;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(a||(a={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class w{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:l=!1}={}){return l?d===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:l=!1,findPreview:s=!1}={}){const e=h({useAlternateBitness:l});if(!e)return null;const n=C.join(e,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const E of await P.Promises.readdir(n)){let I=-1;if(s){const W=E.indexOf("-");if(W<0)continue;const _=E.substring(0,W);if(!T.test(_)||E.substring(W+1)!=="preview")continue;I=parseInt(_,10)}else{if(!T.test(E))continue;I=parseInt(E,10)}if(I<=t)continue;const O=C.join(n,E,"pwsh.exe");!await P.SymlinkSupport.existsFile(O)||(r=O,t=I)}if(!r)return null;const o=e.includes("x86")?" (x86)":"",S=s?" Preview":"";return new w(r,`PowerShell${S}${o}`,!0)}async function f({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const s=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=l?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await P.Promises.readdir(s))if(e.test(t)){const r=C.join(s,t,"pwsh.exe");return new w(r,n)}return null}function m(){const l=C.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(l,".NET Core PowerShell Global Tool")}function y(){const l=C.join(process.env.windir,d===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(l,"Windows PowerShell",!0)}async function*c(){let l=await v();l&&(yield l),l=await v({useAlternateBitness:!0}),l&&(yield l),l=await f(),l&&(yield l),l=m(),l&&(yield l),l=await v({findPreview:!0}),l&&(yield l),l=await f({findPreview:!0}),l&&(yield l),l=await v({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=y(),l&&(yield l)}async function*u(){for await(const l of c())await l.exists()&&(yield l)}i.enumeratePowerShellInstallations=u;async function g(){for await(const l of u())return l;return null}i.getFirstAvailablePowerShellInstallation=g}),define(Q[55],Z([0,1,14,13,32,51,5,20]),function(B,i,D,C,P,T,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function a(w=P.env){return w.comspec||"cmd.exe"}i.getWindowsShell=a;function d(w){let h=[],v=!1;const f=function(m){if(v){h.push(m);return}(!w.send(m,c=>{if(c&&console.error(c),v=!1,h.length>0){const u=h.slice(0);h=[],u.forEach(g=>f(g))}})||C.isWindows)&&(v=!0)};return{send:f}}i.createQueuedSender=d;var b;(function(w){async function h(v,f,m){if(D.isAbsolute(v))return v;if(f===void 0&&(f=P.cwd()),D.dirname(v)!=="."||(m===void 0&&L.isString(P.env.PATH)&&(m=P.env.PATH.split(D.delimiter)),m===void 0||m.length===0))return D.join(f,v);async function c(u){if(await p.Promises.exists(u)){let g;try{g=await p.Promises.stat(u)}catch(l){l.message.startsWith("EACCES")&&(g=await p.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of m){let g;if(D.isAbsolute(u)?g=D.join(u,v):g=D.join(f,u,v),await c(g))return g;let l=g+".com";if(await c(l)||(l=g+".exe",await c(l)))return l}return D.join(f,v)}w.findExecutable=h})(b=i.win32||(i.win32={}))}),define(Q[77],Z([0,1,38,13,76,55]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(v,f){return v===1?C.isWindows?w():T.getWindowsShell(f):d(v,f)}i.getSystemShell=L;function p(v,f){return v===1?C.isWindows?h(f):T.getWindowsShell(f):d(v,f)}i.getSystemShellSync=p;let a=null;function d(v,f){if(C.isLinux&&v===2||C.isMacintosh&&v===3)return"/bin/bash";if(!a){let m;if(C.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,D.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}a=m}return a}let b=null;async function w(){return b||(b=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),b}function h(v){if(b)return b;const f=C.isWindows&&parseFloat((0,D.release)())>=10,m=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:T.getWindowsShell(v)}});var ge=this&&this.__decorate||function(B,i,D,C){var P=arguments.length,T=P<3?i:C===null?C=Object.getOwnPropertyDescriptor(i,D):C,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(B,i,D,C);else for(var p=B.length-1;p>=0;p--)(L=B[p])&&(T=(P<3?L(T):P>3?L(i,D,T):L(i,D))||T);return P>3&&T&&Object.defineProperty(i,D,T),T};define(Q[56],Z([0,1,19,3,15,24,49,11,4,2,44,27,5]),function(B,i,D,C,P,T,L,p,a,d,b,w,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var v;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(v=i.RequestType||(i.RequestType={}));function f(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(m=i.ResponseType||(i.ResponseType={}));function y(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(c||(c={}));class u{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class g{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var l;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(l||(l={}));function s(N){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(N,0),F}function e(N){return N.read(4).readUInt32BE(0)}function n(N){const F=P.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const t={Undefined:n(l.Undefined),String:n(l.String),Buffer:n(l.Buffer),VSBuffer:n(l.VSBuffer),Array:n(l.Array),Object:n(l.Object)},r=typeof Buffer<"u";function o(N,F){if(typeof F>"u")N.write(t.Undefined);else if(typeof F=="string"){const z=P.VSBuffer.fromString(F);N.write(t.String),N.write(s(z.byteLength)),N.write(z)}else if(r&&Buffer.isBuffer(F)){const z=P.VSBuffer.wrap(F);N.write(t.Buffer),N.write(s(z.byteLength)),N.write(z)}else if(F instanceof P.VSBuffer)N.write(t.VSBuffer),N.write(s(F.byteLength)),N.write(F);else if(Array.isArray(F)){N.write(t.Array),N.write(s(F.length));for(const z of F)o(N,z)}else{const z=P.VSBuffer.fromString(JSON.stringify(F));N.write(t.Object),N.write(s(z.byteLength)),N.write(z)}}function S(N){switch(N.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return N.read(e(N)).toString();case l.Buffer:return N.read(e(N)).buffer;case l.VSBuffer:return N.read(e(N));case l.Array:{const z=e(N),$=[];for(let J=0;J<z;J++)$.push(S(N));return $}case l.Object:return JSON.parse(N.read(e(N)).toString())}}class E{constructor(F,z,$=null,J=1e3){this.protocol=F,this.ctx=z,this.logger=$,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger?.logOutgoing(z,0,1,y(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(z,F.id,1,y(F.type),F.data);return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const z=new u(F),$=S(z),J=S(z),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,J),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:J});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,J),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:J});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=new T.CancellationTokenSource;let J;try{J=z.call(this.ctx,F.name,F.arg,$.token)}catch(R){J=Promise.reject(R)}const A=F.id;J.then(R=>{this.sendResponse({id:A,data:R,type:201}),this.activeRequests.delete(F.id)},R=>{R instanceof Error?this.sendResponse({id:A,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:A,data:R,type:203}),this.activeRequests.delete(F.id)});const U=(0,d.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,U)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=F.id,A=z.listen(this.ctx,F.name,F.arg)(U=>this.sendResponse({id:$,data:U,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=E;var I;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(I=i.RequestInitiator||(i.RequestInitiator={}));class O{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=c.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new a.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=z}getChannel(F){const z=this;return{call($,J,A){return z.isDisposed?Promise.reject(new p.CancellationError):z.requestPromise(F,$,J,A)},listen($,J){return z.isDisposed?a.Event.None:z.requestEvent(F,$,J)}}}requestPromise(F,z,$,J=T.CancellationToken.None){const A=this.lastRequestId++,R={id:A,type:100,channelName:F,name:z,arg:$};if(J.isCancellationRequested)return Promise.reject(new p.CancellationError);let k;return new Promise((j,q)=>{if(J.isCancellationRequested)return q(new p.CancellationError);const H=()=>{const Se=te=>{switch(te.type){case 201:this.handlers.delete(A),j(te.data);break;case 202:{this.handlers.delete(A);const oe=new Error(te.data.message);oe.stack=te.data.stack,oe.name=te.data.name,q(oe);break}case 203:this.handlers.delete(A),q(te.data);break}};this.handlers.set(A,Se),this.sendRequest(R)};let ae=null;this.state===c.Idle?H():(ae=(0,C.createCancelablePromise)(Se=>this.whenInitialized()),ae.then(()=>{ae=null,H()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:A,type:101}),q(new p.CancellationError)},pe=J.onCancellationRequested(ce);k=(0,d.combinedDisposable)((0,d.toDisposable)(ce),pe),this.activeRequests.add(k)}).finally(()=>{this.activeRequests.delete(k)})}requestEvent(F,z,$){const J=this.lastRequestId++,U={id:J,type:102,channelName:F,name:z,arg:$};let R=null;const k=new a.Emitter({onFirstListenerAdd:()=>{R=(0,C.createCancelablePromise)(j=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(k),this.sendRequest(U)})},onLastListenerRemove:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(k),this.sendRequest({id:J,type:103}))}}),M=j=>k.fire(j.data);return this.handlers.set(J,M),k.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(z,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger?.logOutgoing(z,F.id,0,f(F.type));return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const z=new u(F),$=S(z),J=S(z),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,y(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,y(A),J),this.onResponse({type:$[0],id:$[1],data:J})}}onResponse(F){if(F.type===200){this.state=c.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return a.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([L.memoize],O.prototype,"onDidInitializePromise",null),i.ChannelClient=O;class W{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new a.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new a.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:$})=>{a.Event.once(z.onMessage)(A=>{const U=new u(A),R=S(U),k=new E(z,R),M=new O(z);this.channels.forEach((q,H)=>k.registerChannel(H,q));const j={channelServer:k,channelClient:M,ctx:R};this._connections.add(j),this._onDidAddConnection.fire(j),$(()=>{k.dispose(),M.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}getChannel(F,z){const $=this;return{call(J,A,U){let R;if((0,h.isFunction)(z)){const M=(0,D.getRandomElement)($.connections.filter(z));R=M?Promise.resolve(M):a.Event.toPromise(a.Event.filter($.onDidAddConnection,z))}else R=z.routeCall($,J,A);const k=R.then(M=>M.channelClient.getChannel(F));return Y(k).call(J,A,U)},listen(J,A){if((0,h.isFunction)(z))return $.getMulticastEvent(F,z,J,A);const U=z.routeEvent($,J,A).then(R=>R.channelClient.getChannel(F));return Y(U).listen(J,A)}}}getMulticastEvent(F,z,$,J){const A=this;let U=new d.DisposableStore;const R=new a.Emitter({onFirstListenerAdd:()=>{U=new d.DisposableStore;const k=new a.EventMultiplexer,M=new Map,j=H=>{const ce=H.channelClient.getChannel(F).listen($,J),pe=k.add(ce);M.set(H,pe)},q=H=>{const ae=M.get(H);!ae||(ae.dispose(),M.delete(H))};A.connections.filter(z).forEach(j),a.Event.filter(A.onDidAddConnection,z)(j,void 0,U),A.onDidRemoveConnection(q,void 0,U),k.event(R.fire,R,U),U.add(k)},onLastListenerRemove:()=>{U.dispose()}});return R.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach($=>{$.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=W;class _{constructor(F,z,$=null){const J=new g;o(J,z),F.send(J.buffer),this.channelClient=new O(F,$),this.channelServer=new E(F,z,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=_;function Y(N){return{call(F,z,$){return N.then(J=>J.call(F,z,$))},listen(F,z){const $=new a.Relay;return N.then(J=>$.input=J.listen(F,z)),$.event}}}i.getDelayedChannel=Y;function X(N){let F=!1;return{call(z,$,J){return F?N.call(z,$,J):(0,C.timeout)(0).then(()=>F=!0).then(()=>N.call(z,$,J))},listen(z,$){if(F)return N.listen(z,$);const J=new a.Relay;return(0,C.timeout)(0).then(()=>F=!0).then(()=>J.input=N.listen(z,$)),J.event}}}i.getNextTickChannel=X;class re{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await a.Event.toPromise(F.onDidAddConnection),await this.route(F)}}i.StaticRouter=re;var se;(function(N){function F(A,U){const R=A,k=U&&U.disableMarshalling,M=new Map;for(const j in R)$(j)&&M.set(j,a.Event.buffer(R[j],!0));return new class{listen(j,q,H){const ae=M.get(q);if(ae)return ae;if(J(q)){const ce=R[q];if(typeof ce=="function")return ce.call(R,H)}throw new Error(`Event not found: ${q}`)}call(j,q,H){const ae=R[q];if(typeof ae=="function"){if(!k&&Array.isArray(H))for(let ce=0;ce<H.length;ce++)H[ce]=(0,b.revive)(H[ce]);return ae.apply(R,H)}throw new Error(`Method not found: ${q}`)}}}N.fromService=F;function z(A,U){const R=U&&U.disableMarshalling;return new Proxy({},{get(k,M){if(typeof M=="string")return U?.properties?.has(M)?U.properties.get(M):J(M)?function(j){return A.listen(M,j)}:$(M)?A.listen(M):async function(...j){let q;U&&!(0,h.isUndefinedOrNull)(U.context)?q=[U.context,...j]:q=j;const H=await A.call(M,q);return R?H:(0,b.revive)(H)};throw new Error(`Property not found: ${String(M)}`)}})}N.toService=z;function $(A){return A[0]==="o"&&A[1]==="n"&&w.isUpperAsciiLetter(A.charCodeAt(2))}function J(A){return/^onDynamic/.test(A)&&w.isUpperAsciiLetter(A.charCodeAt(9))}})(se=i.ProxyChannel||(i.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function le(N){return Array.isArray(N)?N.map(fe):fe(N)}function ie(N,F,z,$,J,A,U){U=le(U);const R=ne[J],k=R[$%R.length];let M=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(A)?(M=M.concat(U),M.push(")")):M.push(U),console.log.apply(console,M)}i.logWithColors=ie;class V{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,$,J,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,z,$,J,A)}logIncoming(F,z,$,J,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,z,$,J,A)}}i.IPCLogger=V}),define(Q[78],Z([0,1,57,3,15,24,75,11,4,2,26,55,51,56]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class f extends v.ChannelServer{constructor(c){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:a.Event.fromNodeEventEmitter(process,"message",u=>P.VSBuffer.wrap(Buffer.from(u,"base64")))},c),process.once("disconnect",()=>this.dispose())}}i.Server=f;class m{constructor(c,u){this.modulePath=c,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new a.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new C.Delayer(g),this.child=null,this._client=null}getChannel(c){const u=this;return{call(g,l,s){return u.requestPromise(c,g,l,s)},listen(g,l){return u.requestEvent(c,g,l)}}}requestPromise(c,u,g,l=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(c),e=(0,C.createCancelablePromise)(r=>s.call(u,g,r)),n=l.onCancellationRequested(()=>e.cancel()),t=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{n.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(c,u,g){if(!this.disposeDelayer)return a.Event.None;this.disposeDelayer.cancel();let l;const s=new a.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(c).listen(u,g)(s.fire,s),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const c=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,h.removeDangerousEnvVariables)(u.env),this.child=(0,D.fork)(this.modulePath,c,u);const g=new a.Emitter;a.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(P.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=g.event,t={send:e,onMessage:n};this._client=new v.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,S)=>{process.removeListener("exit",r),this.activeRequests.forEach(E=>(0,d.dispose)(E)),this.activeRequests.clear(),o!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+S),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:S})})}return this._client}getCachedChannel(c){let u=this.channels.get(c);return u||(u=this.client.getChannel(c),this.channels.set(c,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=m}),define(Q[79],Z([0,1,3,4,2,5]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function p(w){const h=w;return h?.changed instanceof Map||h?.deleted instanceof Set}i.isStorageItemsChangeEvent=p;var a;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(a=i.StorageState||(i.StorageState={}));class d extends P.Disposable{constructor(h,v=Object.create(null)){super(),this.database=h,this.options=v,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=a.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,f)=>this.accept(f,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===a.Closed)return;let f=!1;(0,T.isUndefinedOrNull)(v)?f=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),f=!0),f&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===a.None&&(this.state=a.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const f=this.cache.get(h);return(0,T.isUndefinedOrNull)(f)?v:f}getBoolean(h,v){const f=this.get(h);return(0,T.isUndefinedOrNull)(f)?v:f==="true"}getNumber(h,v){const f=this.get(h);return(0,T.isUndefinedOrNull)(f)?v:parseInt(f,10)}async set(h,v){if(this.state===a.Closed)return;if((0,T.isUndefinedOrNull)(v))return this.delete(h);const f=String(v);if(this.cache.get(h)!==f)return this.cache.set(h,f),this.pendingInserts.set(h,f),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===a.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=a.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((v,f)=>this.items.set(f,v)),h.delete?.forEach(v=>this.items.delete(v))}async close(){}}i.InMemoryStorageDatabase=b}),define(Q[80],Z([6,7]),function(B,i){return B.create("vs/base/node/zip",i)}),define(Q[81],Z([6,7]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[82],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[83],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[84],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLI",i)}),define(Q[85],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionNls",i)}),define(Q[86],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(Q[87],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[88],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[89],Z([6,7]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[90],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(Q[91],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(Q[92],Z([6,7]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[93],Z([6,7]),function(B,i){return B.create("vs/platform/languagePacks/common/languagePacks",i)}),define(Q[94],Z([6,7]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(Q[95],Z([6,7]),function(B,i){return B.create("vs/platform/shell/node/shellEnv",i)}),define(Q[96],Z([6,7]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[97],Z([6,7]),function(B,i){return B.create("vs/platform/userDataProfile/common/userDataProfile",i)}),define(Q[98],Z([6,7]),function(B,i){return B.create("vs/platform/workspace/common/workspace",i)}),define(Q[99],Z([0,1,71,49,16,14,32,17,10]),function(B,i,D,C,P,T,L,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class d{constructor(m,y,c){this._args=m,this.paths=y,this.productService=c,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,T.dirname)(P.FileAccess.asFileUri("",B).fsPath)}get userHome(){return a.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return a.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return a.URI.file(this.paths.tmpDir)}get cacheHome(){return a.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return a.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return a.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(a.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=L.env.VSCODE_PORTABLE;return m?a.URI.file((0,T.join)(m,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return a.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,T.resolve)(m):(0,T.normalize)((0,T.join)(P.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,T.resolve)(m):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,T.resolve)(m);const y=L.env.VSCODE_EXTENSIONS;if(y)return y;const c=L.env.VSCODE_PORTABLE;return c?(0,T.join)(c,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(y=>/^[^:/?#]+?:\/\//.test(y)?a.URI.parse(y):a.URI.file((0,T.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?a.URI.parse(m):a.URI.file((0,T.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(a.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return a.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return a.URI.file((0,T.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=L.env.VSCODE_PORTABLE;return m?a.URI.file((0,T.join)(m,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ge([C.memoize],d.prototype,"appRoot",null),ge([C.memoize],d.prototype,"userHome",null),ge([C.memoize],d.prototype,"userDataPath",null),ge([C.memoize],d.prototype,"appSettingsHome",null),ge([C.memoize],d.prototype,"tmpDir",null),ge([C.memoize],d.prototype,"cacheHome",null),ge([C.memoize],d.prototype,"stateResource",null),ge([C.memoize],d.prototype,"userRoamingDataHome",null),ge([C.memoize],d.prototype,"userDataSyncHome",null),ge([C.memoize],d.prototype,"userDataSyncLogResource",null),ge([C.memoize],d.prototype,"editSessionsLogResource",null),ge([C.memoize],d.prototype,"sync",null),ge([C.memoize],d.prototype,"machineSettingsResource",null),ge([C.memoize],d.prototype,"workspaceStorageHome",null),ge([C.memoize],d.prototype,"localHistoryHome",null),ge([C.memoize],d.prototype,"keyboardLayoutResource",null),ge([C.memoize],d.prototype,"argvResource",null),ge([C.memoize],d.prototype,"isExtensionDevelopment",null),ge([C.memoize],d.prototype,"untitledWorkspacesHome",null),ge([C.memoize],d.prototype,"installSourcePath",null),ge([C.memoize],d.prototype,"builtinExtensionsPath",null),ge([C.memoize],d.prototype,"extensionsPath",null),ge([C.memoize],d.prototype,"extensionDevelopmentLocationURI",null),ge([C.memoize],d.prototype,"extensionDevelopmentKind",null),ge([C.memoize],d.prototype,"extensionTestsLocationURI",null),ge([C.memoize],d.prototype,"debugExtensionHost",null),ge([C.memoize],d.prototype,"serviceMachineIdResource",null),ge([C.memoize],d.prototype,"telemetryLogResource",null),ge([C.memoize],d.prototype,"disableWorkspaceTrust",null),ge([C.memoize],d.prototype,"policyFile",null),i.AbstractNativeEnvironmentService=d;function b(f,m){return v(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}i.parseExtensionHostPort=b;function w(f,m){return v(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}i.parseSearchPort=w;function h(f,m){return v(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}i.parsePtyHostPort=h;function v(f,m,y,c,u,g){const s=Number(m||f)||(c?null:y),e=s?Boolean(!!m):!1;let n;if(g)try{n=JSON.parse(g)}catch{}return{port:s,break:e,debugId:u,env:n}}}),function(){"use strict";function B(i,D,C,P){function T(p){const a=L(p),d=[a];return i.isAbsolute(a)||d.unshift(P),i.resolve(...d)}function L(p){const a=process.env.VSCODE_PORTABLE;if(a)return i.join(a,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return i.join(d,C);const b=p["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=i.join(w,"AppData","Roaming")}break;case"darwin":d=i.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(d,C)}return{getUserDataPath:T}}if(typeof define=="function")define(Q[100],Z([0,149,38,16,17,32]),function(i,D,C,P,T,L){const p=T.dirname(P.FileAccess.asFileUri("",i)),a=i.__$__nodeRequire(T.joinPath(p,"package.json").fsPath);return B(D,C,a.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),D=require("path"),C=require("os");module.exports=B(D,C,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,38,99,100]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class T extends C.AbstractNativeEnvironmentService{constructor(p,a){super(p,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,P.getUserDataPath)(p)},a)}}i.NativeEnvironmentService=T}),define(Q[102],Z([0,1,5,85]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;function P(L,p,a){try{T(L,p,a)}catch{}return L}i.localizeManifest=P;function T(L,p,a){const d=(b,w,h)=>{const v=b[w];if((0,D.isString)(v)){const f=v,m=f.length;if(m>1&&f[0]==="%"&&f[m-1]==="%"){const y=f.substr(1,m-2);let c=p[y];c===void 0&&a&&(c=a[y]);const u=typeof c=="string"?c:c.message;if(u!==void 0){const g=a?.[y],l=typeof g=="string"?g:g?.message;if(h&&(w==="title"||w==="category")&&l&&l!==u){const s={value:u,original:l};b[w]=s}else b[w]=u}else console.warn(`[${L.name}]: ${(0,C.localize)(0,null,y)}`)}}else if((0,D.isObject)(v))for(const f in v)v.hasOwnProperty(f)&&(f==="commands"?d(v,f,!0):d(v,f,h));else if(Array.isArray(v))for(let f=0;f<v.length;f++)d(v,f,h)};for(const b in L)L.hasOwnProperty(b)&&d(L,b)}}),define(Q[45],Z([0,1,17,54,89,39]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function a(c){return c=c.trim(),c==="*"||L.test(c)}i.isValidVersionStr=a;function d(c){if(!a(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=c.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}i.parseVersion=d;function b(c){if(!c)return null;const u=c.majorBase,g=c.majorMustEqual,l=c.minorBase;let s=c.minorMustEqual;const e=c.patchBase;let n=c.patchMustEqual;c.hasCaret&&(u===0||(s=!1),n=!1);let t=0;if(c.preRelease){const r=p.exec(c.preRelease);if(r){const[,o,S,E]=r;t=Date.UTC(Number(o),Number(S)-1,Number(E))}}return{majorBase:u,majorMustEqual:g,minorBase:l,minorMustEqual:s,patchBase:e,patchMustEqual:n,isMinimum:c.hasGreaterEquals,notBefore:t}}i.normalizeVersion=b;function w(c,u,g){let l;typeof c=="string"?l=b(d(c)):l=c;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let e;if(typeof g=="string"?e=b(d(g)):e=g,!l||!e)return!1;const n=l.majorBase,t=l.minorBase,r=l.patchBase;let o=e.majorBase,S=e.minorBase,E=e.patchBase;const I=e.notBefore;let O=e.majorMustEqual,W=e.minorMustEqual,_=e.patchMustEqual;return e.isMinimum?n>o?!0:n<o?!1:t>S?!0:t<S||s&&s<I?!1:r>=E:(n===1&&o===0&&(!O||!W||!_)&&(o=1,S=0,E=0,O=!0,W=!1,_=!1),n<o?!1:n>o?!O:t<S?!1:t>S?!W:r<E?!1:r>E?!_:!(s&&s<I))}i.isValidVersion=w;function h(c,u,g,l,s){const e=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return e.push([C.default.Error,P.localize(0,null)]),e;if(typeof l.name!="string")return e.push([C.default.Error,P.localize(1,null,"name")]),e;if(typeof l.version!="string")return e.push([C.default.Error,P.localize(2,null,"version")]),e;if(!l.engines)return e.push([C.default.Error,P.localize(3,null,"engines")]),e;if(typeof l.engines.vscode!="string")return e.push([C.default.Error,P.localize(4,null,"engines.vscode")]),e;if(typeof l.extensionDependencies<"u"&&!y(l.extensionDependencies))return e.push([C.default.Error,P.localize(5,null,"extensionDependencies")]),e;if(typeof l.activationEvents<"u"){if(!y(l.activationEvents))return e.push([C.default.Error,P.localize(6,null,"activationEvents")]),e;if(typeof l.main>"u"&&typeof l.browser>"u")return e.push([C.default.Error,P.localize(7,null,"activationEvents","main")]),e}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&e.push([C.default.Warning,P.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return e.push([C.default.Error,P.localize(9,null,"main")]),e;{const r=(0,D.joinPath)(g,l.main);(0,D.isEqualOrParent)(r,g)||e.push([C.default.Warning,P.localize(10,null,r.path,g.path)])}if(typeof l.activationEvents>"u")return e.push([C.default.Error,P.localize(11,null,"activationEvents","main")]),e}if(typeof l.browser<"u"){if(typeof l.browser!="string")return e.push([C.default.Error,P.localize(12,null,"browser")]),e;{const r=(0,D.joinPath)(g,l.browser);(0,D.isEqualOrParent)(r,g)||e.push([C.default.Warning,P.localize(13,null,r.path,g.path)])}if(typeof l.activationEvents>"u")return e.push([C.default.Error,P.localize(14,null,"activationEvents","browser")]),e}if(!T.valid(l.version))return e.push([C.default.Error,P.localize(15,null)]),e;const n=[];if(!v(c,u,l,s,n))for(const r of n)e.push([C.default.Error,r]);return e}i.validateExtensionManifest=h;function v(c,u,g,l,s){return l||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(c,u,g.engines.vscode,s)}i.isValidExtensionVersion=v;function f(c,u,g){return c==="*"||m(u,g,c)}i.isEngineValid=f;function m(c,u,g,l=[]){const s=b(d(g));if(!s)return l.push(P.localize(16,null,g)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return l.push(P.localize(17,null,g)),!1}else if(!s.majorMustEqual)return l.push(P.localize(18,null,g)),!1;return w(c,u,s)?!0:(l.push(P.localize(19,null,c,g)),!1)}function y(c){if(!Array.isArray(c))return!1;for(let u=0,g=c.length;u<g;u++)if(typeof c[u]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function P(T,L,p){let a=p&&p.get("storage.serviceMachineId",-1)||null;if(a)return a;try{const b=(await L.readFile(T.serviceMachineIdResource)).value.toString();a=(0,C.isUUID)(b)?b:null}catch{a=null}if(!a){a=(0,C.generateUuid)();try{await L.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(a))}catch{}}return p?.store("storage.serviceMachineId",a,-1,1),a}i.getServiceMachineId=P}),define(Q[46],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(P,T=[],L=!1){this.ctor=P,this.staticArguments=T,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=D}),define(Q[104],Z([0,1,46]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=i.InstantiationType=void 0;const C=[];var P;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(P=i.InstantiationType||(i.InstantiationType={}));function T(p,a,d){a instanceof D.SyncDescriptor||(a=new D.SyncDescriptor(a,[],Boolean(d))),C.push([p,a])}i.registerSingleton=T;function L(){return C}i.getSingletonServiceDescriptors=L}),define(Q[105],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}i.Node=D;class C{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const L of this._nodes.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const p=this.lookupOrInsertNode(T),a=this.lookupOrInsertNode(L);p.outgoing.set(a.key,a),a.incoming.set(p.key,p)}removeNode(T){const L=this._hashFn(T);this._nodes.delete(L);for(const p of this._nodes.values())p.outgoing.delete(L),p.incoming.delete(L)}lookupOrInsertNode(T){const L=this._hashFn(T);let p=this._nodes.get(L);return p||(p=new D(L,T),this._nodes.set(L,p)),p}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[L,p]of this._nodes)T.push(`${L}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this._nodes){const p=new Set([T]),a=this._findCycle(L,p);if(a)return a}}_findCycle(T,L){for(const[p,a]of T.outgoing){if(L.has(p))return[...L,p].join(" -> ");L.add(p);const d=this._findCycle(a,L);if(d)return d;L.delete(p)}}}i.Graph=C}),define(Q[21],Z([0,1,5,10,8]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,P.createDecorator)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof C.URI)}i.isConfigurationOverrides=T;function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof C.URI)}i.isConfigurationUpdateOverrides=L;var p;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(p=i.ConfigurationTarget||(i.ConfigurationTarget={}));function a(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}i.ConfigurationTargetToString=a;function d(c,u){const g=Object.create(null);for(const l in c)b(g,l,c[l],u);return g}i.toValuesTree=d;function b(c,u,g,l){const s=u.split("."),e=s.pop();let n=c;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:l(`Ignoring ${u} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[e]=g}catch{l(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}else l(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=b;function w(c,u){const g=u.split(".");h(c,g)}i.removeFromValueTree=w;function h(c,u){const g=u.shift();if(u.length===0){delete c[g];return}if(Object.keys(c).indexOf(g)!==-1){const l=c[g];typeof l=="object"&&!Array.isArray(l)&&(h(l,u),Object.keys(l).length===0&&delete c[g])}}function v(c,u,g){function l(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=u.split("."),e=l(c,s);return typeof e>"u"?g:e}i.getConfigurationValue=v;function f(c,u,g){Object.keys(u).forEach(l=>{l!=="__proto__"&&(l in c?D.isObject(c[l])&&D.isObject(u[l])?f(c[l],u[l],g):g&&(c[l]=u[l]):c[l]=u[l])})}i.merge=f;function m(c,u,g){const l=c.inspect(u),s=c.inspect(g);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:l.defaultValue}i.getMigratedSettingValue=m;function y(c){return c.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=y}),define(Q[58],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Q[18],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[22],Z([0,1,83,8]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function P(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=P;function T(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=T;function L(c,u){switch(c){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=L;function p(c,u){return u==="web"&&!c.includes("web")}i.isNotWebExtensionInWebTargetPlatform=p;function a(c,u,g){return p(u,g)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===g?!0:d(g).includes(c)}i.isTargetPlatformCompatible=a;function d(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=d;function b(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}i.isIExtensionIdentifier=b;var w;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(w=i.SortBy||(i.SortBy={}));var h;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(h=i.SortOrder||(i.SortOrder={}));var v;(function(c){c.Install="install",c.Uninstall="uninstall"})(v=i.StatisticType||(i.StatisticType={}));var f;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(f=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var m;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class y extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}i.ExtensionManagementError=y,i.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,15,11,91,12]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(b,w,h,v,f,m){let y;try{await p(b,w,h,v,f,m)}catch(c){y=c}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&h.error(y),h.end()}}i.readFileIntoStream=L;async function p(b,w,h,v,f,m){a(m);const y=await b.open(w,{create:!1});try{a(m);let c=0,u=0,g=f&&typeof f.length=="number"?f.length:void 0,l=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),s=f&&typeof f.position=="number"?f.position:0,e=0;do u=await b.read(y,s,l.buffer,e,l.byteLength-e),s+=u,e+=u,c+=u,typeof g=="number"&&(g-=u),e===l.byteLength&&(await h.write(v(l)),l=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),e=0);while(u>0&&(typeof g!="number"||g>0)&&a(m)&&d(c,f));if(e>0){let n=e;typeof g=="number"&&(n=Math.min(e,g)),h.write(v(l.slice(0,n)))}}catch(c){throw(0,T.ensureFileSystemProviderError)(c)}finally{await b.close(y)}}function a(b){if(b.isCancellationRequested)throw(0,C.canceled)();return!0}function d(b,w){if(w?.limits){if(typeof w.limits.memory=="number"&&b>w.limits.memory)throw(0,T.createFileSystemProviderError)((0,P.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&b>w.limits.size)throw(0,T.createFileSystemProviderError)((0,P.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,150,2,13,151]),function(B,i,D,C,P,T,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class p extends P.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const b=this.normalizeRequests(d),w=b.filter(v=>{const f=this.watchers.get(v.path);return f?!(0,C.patternsEquals)(f.request.excludes,v.excludes)||!(0,C.patternsEquals)(f.request.includes,v.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:v})=>!b.find(f=>f.path===v.path&&(0,C.patternsEquals)(f.excludes,v.excludes)&&(0,C.patternsEquals)(f.includes,v.includes))).map(({request:v})=>v.path);w.length&&this.trace(`Request to start watching: ${w.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const v of h)this.stopWatching(v);for(const v of w)this.startWatching(v)}startWatching(d){const b=new L.NodeJSFileWatcherLibrary(d,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),w={request:d,instance:b};this.watchers.set(d.path,w)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const b=this.watchers.get(d);b&&(this.watchers.delete(d),b.instance.dispose())}normalizeRequests(d){const b=new Map;for(const w of d){const h=T.isLinux?w.path:w.path.toLowerCase();b.set(h,w)}return Array.from(b.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,b]of this.watchers)b.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,b){return b?`[File Watcher (node.js)] ${d} (path: ${b.request.path})`:`[File Watcher (node.js)] ${d}`}}i.NodeJSWatcher=p}),define(Q[107],Z([0,1,60,106]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class P extends D.AbstractNonRecursiveWatcherClient{constructor(L,p,a){super(L,p,a),this.init()}createWatcher(){return new C.NodeJSWatcher}}i.NodeJSWatcherClient=P}),define(Q[108],Z([0,1,16,56,78,60]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends T.AbstractUniversalWatcherClient{constructor(a,d,b){super(a,d,b),this.init()}createWatcher(a){const d=a.add(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return a.add(d.onDidProcessExit(({code:b,signal:w})=>this.onError(`terminated by itself with code ${b}, signal: ${w}`))),C.ProxyChannel.toService((0,C.getNextTickChannel)(d.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Q[61],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...P){this._entries=new Map;for(const[T,L]of P)this.set(T,L)}set(P,T){const L=this._entries.get(P);return this._entries.set(P,T),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}i.ServiceCollection=D}),define(Q[109],Z([0,1,3,11,46,105,8,61]),function(B,i,D,C,P,T,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const a=!1;class d extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class b{constructor(f=new p.ServiceCollection,m=!1,y,c=a){this._services=f,this._strict=m,this._parent=y,this._enableTracing=c,this._activeInstantiations=new Set,this._services.set(L.IInstantiationService,this),this._globalGraph=c?y?._globalGraph??new T.Graph(u=>u):void 0}createChild(f){return new b(f,this._strict,this,this._enableTracing)}invokeFunction(f,...m){const y=h.traceInvocation(this._enableTracing,f);let c=!1;try{return f({get:g=>{if(c)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(g,y);if(!l)throw new Error(`[invokeFunction] unknown service '${g}'`);return l}},...m)}finally{c=!0,y.stop()}}createInstance(f,...m){let y,c;return f instanceof P.SyncDescriptor?(y=h.traceCreation(this._enableTracing,f.ctor),c=this._createInstance(f.ctor,f.staticArguments.concat(m),y)):(y=h.traceCreation(this._enableTracing,f),c=this._createInstance(f,m,y)),y.stop(),c}_createInstance(f,m=[],y){const c=L._util.getServiceDependencies(f).sort((l,s)=>l.index-s.index),u=[];for(const l of c){const s=this._getOrCreateServiceInstance(l.id,y);s||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),u.push(s)}const g=c.length>0?c[0].index:m.length;if(m.length!==g){console.trace(`[createInstance] First service dependency of ${f.name} at position ${g+1} conflicts with ${m.length} static arguments`);const l=g-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,g)}return new f(...m,...u)}_setServiceInstance(f,m){if(this._services.get(f)instanceof P.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const y=this._getServiceInstanceOrDescriptor(f);return y instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,y,m.branch(f,!0)):(m.branch(f,!1),y)}_safeCreateAndCacheServiceInstance(f,m,y){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,y)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,y){const c=new T.Graph(l=>l.id.toString());let u=0;const g=[{id:f,desc:m,_trace:y}];for(;g.length;){const l=g.pop();if(c.lookupOrInsertNode(l),u++>1e3)throw new d(c);for(const s of L._util.getServiceDependencies(l.desc.ctor)){const e=this._getServiceInstanceOrDescriptor(s.id);if(e||this._throwIfStrict(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(s.id)),e instanceof P.SyncDescriptor){const n={id:s.id,desc:e,_trace:l._trace.branch(s.id,!0)};c.insertEdge(l,n),g.push(n)}}}for(;;){const l=c.roots();if(l.length===0){if(!c.isEmpty())throw new d(c);break}for(const{data:s}of l){if(this._getServiceInstanceOrDescriptor(s.id)instanceof P.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}c.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,y=[],c,u){if(this._services.get(f)instanceof P.SyncDescriptor)return this._createServiceInstance(f,m,y,c,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,y,c,u);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m,y=[],c,u){if(c){const g=new b(void 0,this._strict,this,this._enableTracing);g._globalGraphImplicitDependency=String(f);const l=new D.IdleValue(()=>g._createInstance(m,y,u));return new Proxy(Object.create(null),{get(s,e){if(e in s)return s[e];const n=l.value;let t=n[e];return typeof t!="function"||(t=t.bind(n),s[e]=t),t},set(s,e,n){return l.value[e]=n,!0}})}else return this._createInstance(m,y,u)}_throwIfStrict(f,m){if(m&&console.warn(f),this._strict)throw new Error(f)}}i.InstantiationService=b;var w;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(w||(w={}));class h{constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(f,m){return f?new h(1,m.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h._None}static traceCreation(f,m){return f?new h(0,m.name):h._None}branch(f,m){const y=new h(2,f.toString());return this._dep.push([f,m,y]),y}stop(){const f=Date.now()-this._start;h._totals+=f;let m=!1;function y(u,g){const l=[],s=new Array(u+1).join("	");for(const[e,n,t]of g._dep)if(n&&t){m=!0,l.push(`${s}CREATES -> ${e}`);const r=y(u+1,t);r&&l.push(r)}else l.push(`${s}uses -> ${e}`);return l.join(`
`)}const c=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||m)&&h.all.add(c.join(`
`))}}i.Trace=h,h.all=new Set,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0});var ee=this&&this.__param||function(B,i){return function(D,C){i(D,C,B)}};define(Q[62],Z([0,1,24,2,13,93,22,8]),function(B,i,D,C,P,T,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,p.createDecorator)("languagePackService");let a=class extends C.Disposable{constructor(b){super(),this.extensionGalleryService=b}async getAvailableLanguages(){const b=new D.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const v=w.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,m,f),extensionId:f.identifier.id,galleryExtension:f}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(b){return b.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(b,w,h){const v=w??b;let f;if(v!==b&&(f=`(${b})`),b.toLowerCase()===P.language.toLowerCase()&&(f??="",f+=(0,T.localize)(0,null)),h?.installCount){f??="";const m=h.installCount;let y;m>1e6?y=`${Math.floor(m/1e5)/10}M`:m>1e3?y=`${Math.floor(m/1e3)}K`:y=String(m),f+=` $(cloud-download) ${y}`}return{id:b,label:v,description:f}}};a=ge([ee(0,L.IExtensionGalleryService)],a),i.LanguagePackBaseService=a}),define(Q[9],Z([0,1,31,4,2,13,8]),function(B,i,D,C,P,T,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function p(){return new Date().toISOString()}var a;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(a=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=a.Info;function d(n,t,r){switch(t){case a.Trace:n.trace(r);break;case a.Debug:n.debug(r);break;case a.Info:n.info(r);break;case a.Warning:n.warn(r);break;case a.Error:n.error(r);break;case a.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}i.log=d;function b(n){let t="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(r>0?" ":"")+o}return t}i.format=b;class w extends P.Disposable{constructor(){super(...arguments),this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=w;class h extends w{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(a.Trace)&&this.log(a.Trace,b([t,...r]))}debug(t,...r){this.checkLogLevel(a.Debug)&&this.log(a.Debug,b([t,...r]))}info(t,...r){this.checkLogLevel(a.Info)&&this.log(a.Info,b([t,...r]))}warn(t,...r){this.checkLogLevel(a.Warning)&&this.log(a.Warning,b([t,...r]))}error(t,...r){if(this.checkLogLevel(a.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(a.Error,b(o))}else this.log(a.Error,b([t,...r]))}critical(t,...r){this.checkLogLevel(a.Critical)&&this.log(a.Critical,b([t,...r]))}flush(){}}i.AbstractMessageLogger=h;class v extends w{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!T.isWindows}trace(t,...r){this.getLevel()<=a.Trace&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.log(`[main ${p()}]`,t,...r))}debug(t,...r){this.getLevel()<=a.Debug&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.log(`[main ${p()}]`,t,...r))}info(t,...r){this.getLevel()<=a.Info&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.log(`[main ${p()}]`,t,...r))}warn(t,...r){this.getLevel()<=a.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,t,...r):console.warn(`[main ${p()}]`,t,...r))}error(t,...r){this.getLevel()<=a.Error&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,t,...r):console.error(`[main ${p()}]`,t,...r))}critical(t,...r){this.getLevel()<=a.Critical&&(this.useColors?console.error(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.error(`[main ${p()}]`,t,...r))}dispose(){}flush(){}}i.ConsoleMainLogger=v;class f extends w{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...r){this.getLevel()<=a.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=a.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=a.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=a.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=a.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=a.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}i.ConsoleLogger=f;class m extends w{constructor(t,r=i.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=a.Trace&&this.adapter.log(a.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=a.Debug&&this.adapter.log(a.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=a.Info&&this.adapter.log(a.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=a.Warning&&this.adapter.log(a.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=a.Error&&this.adapter.log(a.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=a.Critical&&this.adapter.log(a.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=a.Trace)}dispose(){}flush(){}}i.AdapterLogger=m;class y extends w{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=y;class c extends P.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}i.LogService=c;class u extends P.Disposable{constructor(t,r){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(S=>S.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?a.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=u;class g{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(t){}getLevel(){return a.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}i.NullLogService=g;function l(n){if(n.verbose)return a.Trace;if(typeof n.logLevel=="string"){const t=s(n.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=l;function s(n){switch(n){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Critical;case"off":return a.Off}}i.parseLogLevel=s;function e(n){switch(n){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Critical:return"critical";case a.Off:return"off"}}i.LogLevelToString=e}),define(Q[110],Z([0,1,19,3,11,4,2,14,60,9]),function(B,i,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class b extends L.Disposable{constructor(h,v){super(),this.logService=h,this.options=v,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new C.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}watch(h,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,v):this.watchNonRecursive(h,v)}watchUniversal(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:v.recursive},m=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,a.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const v of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const v of this.universalPathsToWatch)(0,a.isRecursiveWatchRequest)(v)&&h.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:!1},m=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,P.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,a.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,p.normalize)(h.fsPath)}}i.AbstractDiskFileSystemProvider=b}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,36,16,112,17,43,90,12,59,9]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let g=class extends d.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const n=new d.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),n.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new y.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&n.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,d.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){e.push(n)}}),!this.provider.has(s)&&await C.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&e)}listCapabilities(){return a.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,v.isAbsolutePath)(s))throw new y.FileOperationError((0,m.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const n=new Error;throw n.name="ENOPRO",n.message=(0,m.localize)(1,null,s.toString()),n}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e)||(0,y.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(n){throw(0,y.toFileSystemProviderErrorCode)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,m.localize)(2,null,this.resourceForError(s)),1):(0,y.ensureFileSystemProviderError)(n)}}async doResolveFile(s,e){const n=await this.withProvider(s),t=this.isPathCaseSensitive(n),r=e?.resolveTo,o=e?.resolveSingleChildDescendants,S=e?.resolveMetadata,E=await n.stat(s);let I;return this.toFileStat(n,s,E,void 0,!!S,(O,W)=>(I||(I=b.TernarySearchTree.forUris(()=>!t),I.set(s,!0),r&&I.fill(!0,r)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&o?W===1:!1))}async toFileStat(s,e,n,t,r,o){const{providerExtUri:S}=this.getExtUri(s),E={resource:e,name:S.basename(e),isFile:(n.type&y.FileType.File)!==0,isDirectory:(n.type&y.FileType.Directory)!==0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(E.isDirectory&&o(E,t)){try{const I=await s.readdir(e),O=await C.Promises.settled(I.map(async([W,_])=>{try{const Y=S.joinPath(e,W),X=r?await s.stat(Y):{type:_};return await this.toFileStat(s,Y,X,I.length,r,o)}catch(Y){return this.logService.trace(Y),null}}));E.children=(0,D.coalesce)(O)}catch(I){this.logService.trace(I),E.children=[]}return E}return E}async resolveAll(s){return C.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),n=await e.stat(s);return this.toFileStat(e,s,n,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(n){return n}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,m.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=P.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,t)),t}async writeFile(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,s,n)||await this.mkdirp(t,r.dirname(s));let S;if((0,y.hasReadWriteCapability)(t)&&!(e instanceof P.VSBuffer))if((0,f.isReadableStream)(e)){const E=await(0,f.peekStream)(e,3);E.ended?S=P.VSBuffer.concat(E.buffer):S=E}else S=(0,f.peekReadable)(e,E=>P.VSBuffer.concat(E),3);else S=e;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&S instanceof P.VSBuffer?await this.doWriteUnbuffered(t,s,n,S):await this.doWriteBuffered(t,s,n,S instanceof P.VSBuffer?(0,P.bufferToReadable)(S):S),this._onDidRunOperation.fire(new y.FileOperationEvent(s,4))}catch(o){throw new y.FileOperationError((0,m.localize)(4,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(e)));let r;try{r=await s.stat(e)}catch{return}if((r.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,m.localize)(6,null,this.resourceForError(e)),0,n);if(this.throwIfFileIsReadonly(e,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,y.etag)({mtime:n.mtime,size:r.size}))throw new y.FileOperationError((0,m.localize)(7,null),3,n);return r}async readFile(s,e,n){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,n):this.doReadFile(t,s,e,n)}async doReadFileAtomic(s,e,n,t){return new Promise((r,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const S=await this.doReadFile(s,e,n,t);r(S)}catch(S){o(S)}})})}async doReadFile(s,e,n,t){const r=await this.doReadFileStream(s,e,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,P.streamToBuffer)(r.value)}}async readFileStream(s,e,n){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,n)}async doReadFileStream(s,e,n,t){const r=new T.CancellationTokenSource(t),o=this.validateReadFile(e,n).then(E=>E,E=>{throw r.cancel(),E});let S;try{return typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&await o,n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)||!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&n?.preferUnbuffered?S=this.readFileUnbuffered(s,e,n):(0,y.hasFileReadStreamCapability)(s)?S=this.readFileStreamed(s,e,r.token,n):S=this.readFileBuffered(s,e,r.token,n),{...await o,value:S}}catch(E){S&&await(0,f.consumeStream)(S);const I=(0,m.localize)(8,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(E).toString());throw E instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(I,E.stat,n):new y.FileOperationError(I,(0,y.toFileOperationResult)(E),n)}}readFileStreamed(s,e,n,t=Object.create(null)){const r=s.readFileStream(e,t,n);return(0,f.transform)(r,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,m.localize)(9,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},o=>P.VSBuffer.concat(o))}readFileBuffered(s,e,n,t=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,c.readFileIntoStream)(s,e,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new y.FileOperationError((0,m.localize)(10,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},n),r}readFileUnbuffered(s,e,n){const t=(0,f.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)?r=await s.readFile(e,{atomic:!0}):r=await s.readFile(e),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(e,r.byteLength,n),t.end(P.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(s,e){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new y.FileOperationError((0,m.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==y.ETAG_DISABLED&&e.etag===n.etag)throw new y.NotModifiedSinceFileOperationError((0,m.localize)(12,null),n,e);return this.validateReadFileLimits(s,n.size,e),n}validateReadFileLimits(s,e,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&e>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&e>n.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,m.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,n){return this.doCanMoveCopy(s,e,"move",n)}async canCopy(s,e,n){return this.doCanMoveCopy(s,e,"copy",n)}async doCanMoveCopy(s,e,n,t){if(s.toString()!==e.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(r,s,o,e,n,t)}catch(r){return r}return!0}async move(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"move",!!n),S=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="move"?2:3,S)),S}async copy(s,e,n){const t=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"copy",!!n),S=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="copy"?3:2,S)),S}async doMoveCopy(s,e,n,t,r,o){if(e.toString()===t.toString())return r;const{exists:S,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(s,e,n,t,r,o);if(S&&!E&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const I=await this.resolve(e);I.isDirectory?await this.doCopyFolder(s,I,n,t):await this.doCopyFile(s,e,n,t)}return r}else return s===n?(await s.rename(e,t,{overwrite:o}),r):(await this.doMoveCopy(s,e,n,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,n,t){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,e,n,t);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,e,n,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,e,n,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,e,n,t)}async doCopyFolder(s,e,n,t){await n.mkdir(t),Array.isArray(e.children)&&await C.Promises.settled(e.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,e,n,t,r,o){let S=!1;if(s===n){const{providerExtUri:I,isPathCaseSensitive:O}=this.getExtUri(s);if(O||(S=I.isEqual(e,t)),S&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!S&&I.isEqualOrParent(t,e))throw new Error((0,m.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const E=await this.exists(t);if(E&&!S){if(!o)throw new y.FileOperationError((0,m.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===n){const{providerExtUri:I}=this.getExtUri(s);if(I.isEqualOrParent(e,t))throw new Error((0,m.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:E,isSameResourceWithDifferentPathCase:S}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,n)),n}async mkdirp(s,e){const n=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&y.FileType.Directory)===0)throw new Error((0,m.localize)(18,null,this.resourceForError(e)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(e)),e=t.dirname(e)}for(let r=n.length-1;r>=0;r--){e=t.joinPath(e,n[r]);try{await s.mkdir(e)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(n){return n}return!0}async doValidateDelete(s,e){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(n.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new y.FileOperationError((0,m.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const S=await this.resolve(s);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(s)))}return n}async del(s,e){const n=await this.doValidateDelete(s,e),t=!!e?.useTrash,r=!!e?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}async cloneFile(s,e){const n=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(s,e))return;if(n===t&&(0,y.hasFileCloneCapability)(n))return n.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===t&&(0,y.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,e,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const n=new d.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,e){const n=await this.withProvider(s),t=(0,p.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),e]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:n.watch(s,e)},this.activeWatchers.set(t,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(e,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,r,t):await this.doWriteReadableBufferedQueued(s,r,t)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,e,n){let t=0,r;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=P.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,S)=>{(0,f.listenStream)(r,{onData:async E=>{r.pause();try{await this.doWriteBuffer(s,e,E,E.byteLength,t,0)}catch(I){return S(I)}t+=E.byteLength,setTimeout(()=>r.resume())},onError:E=>S(E),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,n){let t=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,e,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(s,e,n,t,r,o){let S=0;for(;S<t;)S+=await s.write(e,r+S,n.buffer,o+S,t-S)}async doWriteUnbuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,n,t))}async doWriteUnbufferedQueued(s,e,n,t){let r;t instanceof P.VSBuffer?r=t:(0,f.isReadableStream)(t)?r=await(0,P.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?r=await(0,P.bufferedStreamToBuffer)(t):r=(0,P.readableToBuffer)(t),await s.writeFile(e,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,n,t))}async doPipeBufferedQueued(s,e,n,t){let r,o;try{r=await s.open(e,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const S=P.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,I=0,O=0;do O=await s.read(r,E,S.buffer,I,S.byteLength-I),await this.doWriteBuffer(n,o,S,O,E,I),E+=O,I+=O,I===S.byteLength&&(I=0);while(O>0)}catch(S){throw(0,y.ensureFileSystemProviderError)(S)}finally{await C.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,n,t))}async doPipeUnbufferedQueued(s,e,n,t){return n.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,n,t))}async doPipeUnbufferedToBufferedQueued(s,e,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(n,r,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,e,n,t){const r=await(0,P.streamToBuffer)(this.readFileBuffered(s,e,T.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,r)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new y.FileOperationError((0,m.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,m.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===w.Schemas.file?s.fsPath:s.toString(!0)}};g=ge([ee(0,u.ILogService)],g),i.FileService=g}),define(Q[113],Z([0,1,114,152,3,36,15,4,153,2,14,13,17,43,20,92,12,59,110,31,108,107]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c,u,g,l,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,C.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(n)}`)}})();class e extends u.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new T.ResourceMap(o=>h.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async S=>{try{let E;S.isSymbolicLink()?E=(await this.stat((0,h.joinPath)(t,S.name))).type:E=this.toType(S),o.push([S.name,E])}catch(E){this.logService.trace(E)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=y.FileType.Unknown:t.isFile()?o=y.FileType.File:t.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,r&&(o|=y.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const S=new P.Barrier;return this.resourceLocks.set(t,S),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===S&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),S.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const S=this.toFilePath(t);return await f.Promises.readFile(S)}catch(S){throw this.toFileSystemProviderError(S)}finally{o?.dispose()}}readFileStream(t,r,o){const S=(0,v.newWriteableStream)(E=>L.VSBuffer.concat(E.map(I=>L.VSBuffer.wrap(I))).buffer);return(0,c.readFileIntoStream)(this,t,S,E=>E.buffer,{...r,bufferSize:256*1024},o),S}async writeFile(t,r,o){let S;try{const E=this.toFilePath(t);if(!o.create||!o.overwrite){if(await f.Promises.exists(E)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,m.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,m.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(S,0,r,0,r.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(t,E)}finally{typeof S=="number"&&await this.close(S)}}static configureFlushOnWrite(t){e.canFlush=t}async open(t,r){const o=this.toFilePath(t);let S;(0,y.isFileOpenForWriteOptions)(r)&&(S=await this.createResourceLock(t));let E;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:O}=await f.SymlinkSupport.stat(o);O.mode&128||await f.Promises.chmod(o,O.mode|128)}catch(O){this.logService.trace(O)}let I;if((0,y.isFileOpenForWriteOptions)(r)){if(w.isWindows)try{await f.Promises.truncate(o,0),I="r+"}catch(O){O.code!=="ENOENT"&&this.logService.trace(O)}I||(I="w")}else I="r";E=await f.Promises.open(o,I)}catch(I){throw S?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,I):this.toFileSystemProviderError(I)}if(this.mapHandleToPos.set(E,0),(0,y.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(E,t),S){const I=this.mapHandleToLock.get(E);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${o})`),this.mapHandleToLock.set(E,S),I&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${o})`),I.dispose())}return E}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&e.canFlush)try{await f.Promises.fdatasync(t)}catch(o){e.configureFlushOnWrite(!1),this.logService.error(o)}return await f.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,S,E){const I=this.normalizePos(t,r);let O=null;try{O=(await f.Promises.read(t,o,S,E,I)).bytesRead}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(t,I,O)}return O}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const S=this.mapHandleToPos.get(t);typeof S=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,S+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,S,E){return(0,P.retry)(()=>this.doWrite(t,r,o,S,E),100,3)}async doWrite(t,r,o,S,E){const I=this.normalizePos(t,r);let O=null;try{O=(await f.Promises.write(t,o,S,E,I)).bytesWritten}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),W)}finally{this.updatePos(t,I,O)}return O}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const S=this.toFilePath(t),E=this.toFilePath(r);if(S!==E)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await f.Promises.move(S,E)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,m.localize)(2,null,(0,b.basename)(S),(0,b.basename)((0,b.dirname)(E)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(t,r,o){const S=this.toFilePath(t),E=this.toFilePath(r);if(S!==E)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await f.Promises.copy(S,E,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,m.localize)(3,null,(0,b.basename)(S),(0,b.basename)((0,b.dirname)(E)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(t,r,o,S){const E=this.toFilePath(t),I=this.toFilePath(r);let O=!1;if(!!(this.capabilities&1024)||(O=(0,a.isEqual)(E,I,!0)),O&&o==="copy")throw(0,y.createFileSystemProviderError)((0,m.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!O&&await f.Promises.exists(I)){if(!S)throw(0,y.createFileSystemProviderError)((0,m.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const S=this.toFilePath(t),E=this.toFilePath(r),I=!!(this.capabilities&1024);if((0,a.isEqual)(S,E,!I))return;const O=new d.DisposableStore;try{const[W,_]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);O.add(W),O.add(_),o&&await f.Promises.mkdir((0,b.dirname)(E),{recursive:!0}),await f.Promises.copyFile(S,E)}catch(W){if(W.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(W)}finally{O.dispose()}}createUniversalWatcher(t,r,o){return new l.UniversalWatcherClient(S=>t(S),S=>r(S),o)}createNonRecursiveWatcher(t,r,o){return new s.NodeJSWatcherClient(S=>t(S),S=>r(S),o)}toFileSystemProviderError(t){if(t instanceof y.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await f.SymlinkSupport.stat(this.toFilePath(t));S.mode&128||(o=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return o}}i.DiskFileSystemProvider=e,e.canFlush=!0}),define(Q[115],Z([0,1,12,9]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function P(p,a,d,b,w){try{const h=await new Promise((f,m)=>{B(["spdlog"],f,m)});h.setFlushOn(C.LogLevel.Trace);const v=await h.createAsyncRotatingLogger(p,a,d,b);return w&&v.clearFormatters(),v}catch(h){console.error(h)}return null}function T(p,a,d){switch(a){case C.LogLevel.Trace:p.trace(d);break;case C.LogLevel.Debug:p.debug(d);break;case C.LogLevel.Info:p.info(d);break;case C.LogLevel.Warning:p.warn(d);break;case C.LogLevel.Error:p.error(d);break;case C.LogLevel.Critical:p.critical(d);break;default:throw new Error("Invalid log level")}}class L extends C.AbstractMessageLogger{constructor(a,d,b,w,h){super(),this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(a,d,b,w),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(a,d,b,w){const h=b?6:1,v=30/h*D.ByteSize.MB,f=await P(a,d,v,h,w);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:m,message:y}of this.buffer)T(this._logger,m,y);this.buffer=[]}}log(a,d){this._logger?T(this._logger,a,d):this.getLevel()<=a&&this.buffer.push({level:a,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Q[37],Z([0,1,4,63,2,8]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,T.createDecorator)("policy");class L extends P.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const b=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},b!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),C.Iterable.reduce(this.policies.entries(),(w,[h,v])=>({...w,[h]:v}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return C.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[b,w])=>({...d,[b]:{definition:w,value:this.policies.get(b)}}),{})}}i.AbstractPolicyService=L;class p{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=p}),define(Q[116],Z([0,1,3,4,63,5,12,9,37]),function(B,i,D,C,P,T,L,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function d(w,h){const v=[];for(const f of P.Iterable.concat(w.keys(),h.keys()))w.get(f)!==h.get(f)&&v.push(f);return v}let b=class extends a.AbstractPolicyService{constructor(h,v,f){super(),this.file=h,this.fileService=v,this.logService=f,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const m=C.Event.filter(v.onDidFilesChange,y=>y.affects(h));this._register(v.watch(h)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(h){await this.refresh()}async read(){const h=new Map;try{const v=await this.fileService.readFile(this.file),f=JSON.parse(v.value.toString());if(!(0,T.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(f))this.policyDefinitions[m]&&h.set(m,f[m])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return h}async refresh(){const h=await this.read(),v=d(this.policies,h);this.policies=h,v.length>0&&this._onDidChange.fire(v)}};b=ge([ee(1,L.IFileService),ee(2,p.ILogService)],b),i.FilePolicyService=b}),define(Q[28],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,68,5]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class P{constructor(){this.data=new Map}add(L,p){D.ok(C.isString(L)),D.ok(C.isObject(p)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,p)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new P}),define(Q[117],Z([0,1,4,33]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function P(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(a,d){this.schemasById[P(a)]=d,this._onDidChangeSchema.fire(a)}notifySchemaChanged(a){this._onDidChangeSchema.fire(a)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new T;C.Registry.add(i.Extensions.JSONContribution,L)}),define(Q[40],Z([0,1,19,4,5,81,21,117,33]),function(B,i,D,C,P,T,L,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=a.Registry.as(p.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,n=!0){this.registerConfigurations([e],n)}registerConfigurations(e,n=!0){const t=this.doRegisterConfigurations(e,n);w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const n=this.doDeregisterConfigurations(e);w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:e,remove:n}){const t=[];t.push(...this.doDeregisterConfigurations(n)),t.push(...this.doRegisterConfigurations(e,!1)),w.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(e){const n=[],t=[];for(const{overrides:r,source:o}of e)for(const S in r)if(n.push(S),i.OVERRIDE_PROPERTY_REGEX.test(S)){const E=this.configurationDefaultsOverrides.get(S),I=E?.valuesSources??new Map;if(o)for(const Y of Object.keys(r[S]))I.set(Y,o);const O={...E?.value||{},...r[S]};this.configurationDefaultsOverrides.set(S,{source:o,value:O,valuesSources:I});const W=(0,L.getLanguageTagSettingPlainKey)(S),_={type:"object",default:O,description:T.localize(1,null,W),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:O,source:P.isString(o)?void 0:o,defaultValueSource:o};t.push(...m(S)),this.configurationProperties[S]=_,this.defaultLanguageConfigurationOverridesNode.properties[S]=_}else{this.configurationDefaultsOverrides.set(S,{value:r[S],source:o});const E=this.configurationProperties[S];E&&(this.updatePropertyDefaultValue(S,E),this.updateSchema(S,E))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const n=[];for(const{overrides:t,source:r}of e)for(const o in t){const S=this.configurationDefaultsOverrides.get(o),E=P.isString(r)?r:r?.id,I=P.isString(S?.source)?S?.source:S?.source?.id;if(E===I)if(n.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const O=this.configurationProperties[o];O&&(this.updatePropertyDefaultValue(o,O),this.updateSchema(o,O))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const n of e)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,n){const t=[];return e.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(e){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const S=this.configurationProperties[o];S?.policy?.name&&this.policyConfigurations.delete(S.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of e){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(e,n=!0,t,r,o=3){o=P.isUndefinedOrNull(e.scope)?o:e.scope;const S=[],E=e.properties;if(E)for(const O in E){const W=E[O];if(n&&g(O,W)){delete E[O];continue}if(W.source=t,W.defaultDefaultValue=E[O].default,this.updatePropertyDefaultValue(O,W),i.OVERRIDE_PROPERTY_REGEX.test(O)?W.scope=void 0:(W.scope=P.isUndefinedOrNull(W.scope)?o:W.scope,W.restricted=P.isUndefinedOrNull(W.restricted)?!!r?.includes(O):W.restricted),E[O].hasOwnProperty("included")&&!E[O].included){this.excludedConfigurationProperties[O]=E[O],delete E[O];continue}else this.configurationProperties[O]=E[O],E[O].policy?.name&&this.policyConfigurations.set(E[O].policy.name,O);!E[O].deprecationMessage&&E[O].markdownDeprecationMessage&&(E[O].deprecationMessage=E[O].markdownDeprecationMessage),S.push(O)}const I=e.allOf;if(I)for(const O of I)S.push(...this.validateAndRegisterProperties(O,n,t,r,o));return S}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const n=t=>{const r=t.properties;if(r)for(const S in r)this.updateSchema(S,r[S]);t.allOf?.forEach(n)};n(e)}updateSchema(e,n){switch(i.allSettings.properties[e]=n,n.scope){case 1:i.applicationSettings.properties[e]=n;break;case 2:i.machineSettings.properties[e]=n;break;case 6:i.machineOverridableSettings.properties[e]=n;break;case 3:i.windowSettings.properties[e]=n;break;case 4:i.resourceSettings.properties[e]=n;break;case 5:i.resourceSettings.properties[e]=n,this.resourceLanguageSettingsSchema.properties[e]=n;break}}removeFromSchema(e,n){switch(delete i.allSettings.properties[e],n.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const n=`[${e}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,t),i.allSettings.properties[n]=t,i.applicationSettings.properties[n]=t,i.machineSettings.properties[n]=t,i.machineOverridableSettings.properties[n]=t,i.windowSettings.properties[n]=t,i.resourceSettings.properties[n]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,n){const t=this.configurationDefaultsOverrides.get(e);let r=t?.value,o=t?.source;P.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),P.isUndefined(r)&&(r=c(n.type)),n.default=r,n.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function m(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=f.exec(s);for(;n?.length;){const t=n[1].trim();t&&e.push(t),n=f.exec(s)}}return(0,D.distinct)(e)}i.overrideIdentifiersFromKey=m;function y(s){return s.reduce((e,n)=>`${e}[${n}]`,"")}i.keyFromOverrideIdentifiers=y;function c(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=c;const u=new h;a.Registry.add(i.Extensions.Configuration,u);function g(s,e){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?T.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?T.localize(8,null,s):e.policy?.name&&u.getPolicyConfigurations().get(e.policy?.name)!==void 0?T.localize(9,null,s,e.policy?.name,u.getPolicyConfigurations().get(e.policy?.name)):null:T.localize(6,null)}i.validateProperty=g;function l(){const s=[],e=u.getConfigurationProperties();for(const n of Object.keys(e))s.push([n,e[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=l}),define(Q[64],Z([0,1,19,4,50,2,36,26,5,10,21,40,33]),function(B,i,D,C,P,T,L,p,a,d,b,w,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class v{constructor(e={},n=[],t=[]){this._contents=e,this._keys=n,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,b.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const t=this.getContentsForOverrideIdentifer(n);return t?e?(0,b.getConfigurationValue)(t,e):t:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const t of this.overrides)t.identifiers.includes(e)&&n.push(...t.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return D.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=p.deepClone(this.contents),t=p.deepClone(this.overrides),r=[...this.keys];for(const o of e)if(!o.isEmpty()){this.mergeContents(n,o.contents);for(const S of o.overrides){const[E]=t.filter(I=>D.equals(I.identifiers,S.identifiers));E?(this.mergeContents(E.contents,S.contents),E.keys.push(...S.keys),E.keys=D.distinct(E.keys)):t.push(p.deepClone(S))}for(const S of o.keys)r.indexOf(S)===-1&&r.push(S)}return new v(n,r,t)}freeze(){return this.frozen=!0,this}clone(){return new v(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const t={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r];const S=n[r];S&&(typeof o=="object"&&typeof S=="object"?(o=p.deepClone(o),this.mergeContents(o,S)):o=S),t[r]=o}return new v(t,this.keys,this.overrides)}mergeContents(e,n){for(const t of Object.keys(n)){if(t in e&&a.isObject(e[t])&&a.isObject(n[t])){this.mergeContents(e[t],n[t]);continue}e[t]=p.deepClone(n[t])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?p.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,t=null;const r=o=>{o&&(t?this.mergeContents(t,o):t=p.deepClone(o))};for(const o of this.overrides)D.equals(o.identifiers,[e])?n=o.contents:o.identifiers.includes(e)&&r(o.contents);return r(n),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,b.addToValueTree)(this.contents,e,n,t=>{throw new Error(t)})}removeValue(e){this.removeKey(e)&&(0,b.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let t=0;t<n;t++)e.indexOf(this.keys[t])===0&&(n=t);this.keys.splice(n,1,e)}removeKey(e){const n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=v;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!a.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:t,keys:r,overrides:o,restricted:S}=this.doParseRaw(e,n);this._configurationModel=new v(t,r,o),this._restrictedConfigurations=S||[]}doParseContent(e){let n={},t=null,r=[];const o=[],S=[];function E(O){Array.isArray(r)?r.push(O):t!==null&&(r[t]=O)}const I={onObjectBegin:()=>{const O={};E(O),o.push(r),r=O,t=null},onObjectProperty:O=>{t=O},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const O=[];E(O),o.push(r),r=O,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:E,onError:(O,W,_)=>{S.push({error:O,offset:W,length:_})}};if(e)try{P.visit(e,I),n=r[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return n}doParseRaw(e,n){const t=h.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,t,!0,n);e=r.raw;const o=(0,b.toValuesTree)(e,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),S=Object.keys(e),E=this.toOverrides(e,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:o,keys:S,overrides:E,restricted:r.restricted}}filter(e,n,t,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const o={},S=[];for(const E in e)if(w.OVERRIDE_PROPERTY_REGEX.test(E)&&t){const I=this.filter(e[E],n,!1,r);o[E]=I.raw,S.push(...I.restricted)}else{const I=n[E],O=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&S.push(E),(O===void 0||r.scopes===void 0||r.scopes.includes(O))&&(r.skipRestricted&&I?.restricted||(o[E]=e[E]))}return{raw:o,restricted:S}}toOverrides(e,n){const t=[];for(const r of Object.keys(e))if(w.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const S in e[r])o[S]=e[r][S];t.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,b.toValuesTree)(o,n)})}return t}}i.ConfigurationModelParser=f;class m extends T.Disposable{constructor(e,n,t,r){super(),this.userSettingsResource=e,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=m;class y{constructor(e,n,t,r,o=new v,S=new v,E=new L.ResourceMap,I=new v,O=new L.ResourceMap,W=!0){this._defaultConfiguration=e,this._policyConfiguration=n,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=S,this._folderConfigurations=E,this._memoryConfiguration=I,this._memoryConfigurationByResource=O,this._freeze=W,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,n,t){return this.getConsolidatedConfigurationModel(e,n,t).getValue(e)}updateValue(e,n,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new v,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(e):r.setValue(e,n),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,t){const r=this.getConsolidatedConfigurationModel(e,n,t),o=this.getFolderConfigurationModelForResource(n.resource,t),S=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,E=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),I=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(e),O=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(e),W=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),_=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),Y=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),X=t?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,re=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,se=n.overrideIdentifier?S.override(n.overrideIdentifier).getValue(e):S.getValue(e),ne=r.getValue(e),fe=D.distinct(r.overrides.map(le=>le.identifiers).flat()).filter(le=>r.getOverrideValue(e,le)!==void 0);return{defaultValue:E,policyValue:I,applicationValue:O,userValue:W,userLocalValue:_,userRemoteValue:Y,workspaceValue:X,workspaceFolderValue:re,memoryValue:se,value:ne,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,policy:I!==void 0?{value:I}:void 0,application:O!==void 0?{value:O,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:W!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:Y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:X!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:o?.freeze().getValue(e),override:n.overrideIdentifier?o?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:se!==void 0?{value:S.getValue(e),override:n.overrideIdentifier?S.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const t=[];if(!n){const{added:r,updated:o,removed:S}=g(this._defaultConfiguration,e);n=[...r,...o,...S]}for(const r of n)for(const o of(0,w.overrideIdentifiersFromKey)(r)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(o),E=e.getKeysForOverrideIdentifier(o),I=[...E.filter(O=>S.indexOf(O)===-1),...S.filter(O=>E.indexOf(O)===-1),...S.filter(O=>!p.equals(this._defaultConfiguration.override(o).getValue(O),e.override(o).getValue(O)))];t.push([o,I])}return this.updateDefaultConfiguration(e),{keys:n,overrides:t}}compareAndUpdatePolicyConfiguration(e){const{added:n,updated:t,removed:r}=g(this._policyConfiguration,e),o=[...n,...t,...r];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.applicationConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateApplicationConfiguration(e),{keys:S,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.localUserConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateLocalUserConfiguration(e),{keys:S,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.remoteUserConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateRemoteUserConfiguration(e),{keys:S,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.workspaceConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateWorkspaceConfiguration(e),{keys:S,overrides:o}}compareAndUpdateFolderConfiguration(e,n){const t=this.folderConfigurations.get(e),{added:r,updated:o,removed:S,overrides:E}=g(t,n),I=[...r,...o,...S];return(I.length||!t)&&this.updateFolderConfiguration(e,n),{keys:I,overrides:E}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:t,updated:r,removed:o,overrides:S}=g(n,void 0);return{keys:[...t,...r,...o],overrides:S}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,n,t){let r=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:e},n){let t=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const r=n.getFolder(e);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const o=this._memoryConfigurationByResource.get(e);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(n=t.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=t}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const t=n.getFolder(e);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:t,overrides:r,keys:o}=this._folderConfigurations.get(n);return e.push([n,{contents:t,overrides:r,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>n.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>n.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),t=this.parseConfigurationModel(e.policy),r=this.parseConfigurationModel(e.application),o=this.parseConfigurationModel(e.user),S=this.parseConfigurationModel(e.workspace),E=e.folders.reduce((I,O)=>(I.set(d.URI.revive(O[0]),this.parseConfigurationModel(O[1])),I),new L.ResourceMap);return new y(n,t,r,o,new v,S,E,new v,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new v(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=y;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const r of s)r.keys.forEach(o=>e.add(o)),r.overrides.forEach(([o,S])=>{const E=(0,L.getOrSet)(n,o,new Set);S.forEach(I=>E.add(I))});const t=[];return n.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...e.values()],overrides:t}}i.mergeChanges=c;class u{constructor(e,n,t,r){this.change=e,this.previous=n,this.currentConfiguraiton=t,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(E=>o.add(E)),e.overrides.forEach(([,E])=>E.forEach(I=>o.add(I))),this.affectedKeys=[...o.values()];const S=new v;this.affectedKeys.forEach(E=>S.setValue(E,{})),this.affectedKeysTree=S.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const t=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!p.equals(t,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let t=(0,b.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof t=="object"&&(r=Object.keys(t)[0]);){if(e=e[r],!e)return!1;t=t[r]}return!0}}i.ConfigurationChangeEvent=u;function g(s,e){const{added:n,removed:t,updated:r}=l(e,s),o=[],S=s?.getAllOverrideIdentifiers()||[],E=e?.getAllOverrideIdentifiers()||[];if(e){const I=E.filter(O=>!S.includes(O));for(const O of I)o.push([O,e.getKeysForOverrideIdentifier(O)])}if(s){const I=S.filter(O=>!E.includes(O));for(const O of I)o.push([O,s.getKeysForOverrideIdentifier(O)])}if(e&&s){for(const I of S)if(E.includes(I)){const O=l({contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)},{contents:e.getOverrideValue(void 0,I)||{},keys:e.getKeysForOverrideIdentifier(I)});o.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:t,updated:r,overrides:o}}function l(s,e){const n=s?e?s.keys.filter(o=>e.keys.indexOf(o)===-1):[...s.keys]:[],t=e?s?e.keys.filter(o=>s.keys.indexOf(o)===-1):[...e.keys]:[],r=[];if(s&&e){for(const o of e.keys)if(s.keys.indexOf(o)!==-1){const S=(0,b.getConfigurationValue)(e.contents,o),E=(0,b.getConfigurationValue)(s.contents,o);p.equals(S,E)||r.push(o)}}return{added:n,removed:t,updated:r}}}),define(Q[118],Z([0,1,19,4,2,26,5,21,64,40,9,37,33]),function(B,i,D,C,P,T,L,p,a,d,b,w,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class v extends P.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.onDidUpdateConfiguration(u,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(u,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=v;class f extends a.ConfigurationModel{constructor(u={}){const g=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(g),s=Object.create(null),e=[];for(const n in g){const t=u[n],r=t!==void 0?t:g[n].default;(0,p.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(n)&&e.push({identifiers:(0,d.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,p.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,l,e)}}i.DefaultConfigurationModel=f;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new a.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=m;let y=class extends P.Disposable{constructor(u,g,l){super(),this.defaultConfiguration=u,this.policyService=g,this.logService=l,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new a.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.registerPolicyDefinitions(u),!0))),this._configurationModel}async registerPolicyDefinitions(u){const g={},l=[],s=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const e of u){const n=s[e];if(!n){l.push(e);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}l.push(e),g[n.policy.name]={type:n.type}}}return(0,L.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),l}onDidChangePolicies(u){const g=h.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),l=(0,D.coalesce)(u.map(s=>g.get(s)));this.update(l,!0)}update(u,g){const l=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const n of u){const t=l[n]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(e?r!==void 0:!(0,T.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new a.ConfigurationModel;for(const t of n.keys)this._configurationModel.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=ge([ee(1,w.IPolicyService),ee(2,b.ILogService)],y),i.PolicyConfiguration=y}),define(Q[119],Z([0,1,3,4,2,17,21,64,118,37]),function(B,i,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class b extends P.Disposable{constructor(h,v,f,m){super(),this.settingsResource=h,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new a.DefaultConfiguration),this.policyConfiguration=f instanceof d.NullPolicyService?new a.NullPolicyConfiguration:this._register(new a.PolicyConfiguration(this.defaultConfiguration,f,m)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,v)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:c})=>this.onDidDefaultConfigurationChange(y,c))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,v,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(h,v,new p.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const f=typeof h=="string"?h:void 0,m=(0,L.isConfigurationOverrides)(h)?h:(0,L.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(f,m,void 0)}updateValue(h,v,f,m){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,v,2)}onDidDefaultConfigurationChange(h,v){const f=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(h,v);this.trigger(m,f,7)}onDidPolicyConfigurationChange(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(f,v,7)}trigger(h,v,f){const m=new p.ConfigurationChangeEvent(h,{data:v},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=b}),define(Q[120],Z([0,1,16]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parseAuthorityWithOptionalPort=i.parseAuthorityWithPort=i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function C(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}i.getRemoteAuthority=C;function P(d){if(!d)return;const b=d.indexOf("+");return b<0?d:d.substr(0,b)}i.getRemoteName=P;function T(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}i.getRemoteServerRootPath=T;function L(d){const{host:b,port:w}=a(d);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:w}}i.parseAuthorityWithPort=L;function p(d,b){let{host:w,port:h}=a(d);return typeof h>"u"&&(h=b),{host:w,port:h}}i.parseAuthorityWithOptionalPort=p;function a(d){const b=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const w=d.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const h=d.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:d,port:void 0}}}),define(Q[34],Z([0,1,27,8,120]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.isApplicationScopedExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}i.getWorkspaceSupportTypeMessage=T;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(p=i.ExtensionType||(i.ExtensionType={}));var a;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(a=i.TargetPlatform||(i.TargetPlatform={}));class d{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,y){if(typeof m>"u"||m===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof m=="string"||typeof y=="string"){const c=typeof m=="string"?m:m.value,u=typeof y=="string"?y:y.value;return D.equalsIgnoreCase(c,u)}return m._lower===y._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}i.ExtensionIdentifier=d;function b(f){return w(f)}i.isApplicationScopedExtension=b;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}i.isLanguagePackExtension=w;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=h;function v(f,m){if(m){const y=`onResolveRemoteAuthority:${(0,P.getRemoteName)(m)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}i.isResolverExtension=v,i.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,13,10,11,32]),function(B,i,D,C,P,T,L,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function d(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,D.compareIgnoreCase)(n.id,t.id)===0}i.areSameExtensions=d;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,r,o)}static parse(t){const r=b.exec(t);return r&&r[1]&&r[2]?new w({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?d(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}i.ExtensionKey=w;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(n){const t=h.exec(n);return t&&t[1]?[m(t[1]),t[2]]:[m(n),void 0]}i.getIdAndVersion=v;function f(n,t){return`${n}.${t}`}i.getExtensionId=f;function m(n){return n.toLocaleLowerCase()}i.adoptToGalleryExtensionId=m;function y(n,t){return m(f(n,t))}i.getGalleryExtensionId=y;function c(n,t){const r=[],o=S=>{for(const E of r)if(E.some(I=>d(t(I),t(S))))return E;return null};for(const S of n){const E=o(S);E?E.push(S):r.push([S])}return r}i.groupByExtension=c;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=u;function g(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}i.getGalleryExtensionTelemetryData=g,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function l(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const S=o.shift();if(S&&r.every(E=>!d(E.identifier,{id:S}))){const E=n.filter(I=>d(I.identifier,{id:S}));E.length===1&&(r.push(E[0]),o.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}i.getExtensionDependencies=l;async function s(n,t){if(!T.isLinux)return!1;let r;try{r=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){t.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(S))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=s;async function e(n,t){const r=await s(n,t),o=(0,C.getTargetPlatform)(r?"alpine":T.platform,a.arch);return t.debug("ComputeTargetPlatform:",o),o}i.computeTargetPlatform=e}),define(Q[121],Z([0,1,24,11,16,17,39,10,84,22,23,34]),function(B,i,D,C,P,T,L,p,a,d,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLI=void 0;const h=y=>(0,a.localize)(0,null,y),v=(0,a.localize)(1,null,"ms-dotnettools.csharp");function f(y,c){return c?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let m=class{constructor(c,u){this.extensionManagementService=c,this.extensionGalleryService=u}get location(){}async listExtensions(c,u,g,l=console){let s=await this.extensionManagementService.getInstalled(1,g);const e=w.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(u&&u!==""){if(e.indexOf(u.toLowerCase())<0){l.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(t=>t.manifest.categories?t.manifest.categories.map(o=>o.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){l.log("Possible Categories: "),e.forEach(t=>{l.log(t)});return}this.location&&l.log((0,a.localize)(2,null,this.location)),s=s.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let n;for(const t of s)n!==t.identifier.id&&(n=t.identifier.id,l.log(f(t.manifest,c)))}async installExtensions(c,u,g,l,s=console){const e=[],n=[];c.length&&s.log(this.location?(0,a.localize)(3,null,this.location):(0,a.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1,g.profileLocation),r=(I,O)=>{const W=t.find(_=>(0,b.areSameExtensions)(_.identifier,{id:I}));if(W){if(!l&&(!O||O==="prerelease"&&W.preRelease))return s.log((0,a.localize)(5,null,I,W.manifest.version,I)),!1;if(O&&W.manifest.version===O)return s.log((0,a.localize)(6,null,`${I}@${O}`)),!1}return!0},o=(I,O,W)=>{E.push({id:I,version:O!=="prerelease"?O:void 0,installOptions:{...g,isBuiltin:W,installPreReleaseVersion:O==="prerelease"||g.installPreReleaseVersion}})},S=[],E=[];for(const I of c)if(I instanceof p.URI)S.push(I);else{const[O,W]=(0,b.getIdAndVersion)(I);r(O,W)&&o(O,W,!1)}for(const I of u){const[O,W]=(0,b.getIdAndVersion)(I);r(O,W)&&o(O,W,!0)}if(S.length&&await Promise.all(S.map(async I=>{try{const O=await this.installVSIX(I,{...g,isBuiltin:!1},l,s);O&&n.push(O)}catch(O){s.error(O.message||O.stack||O),e.push(I.toString())}})),E.length){const I=await this.getGalleryExtensions(E);await Promise.all(E.map(async O=>{const W=I.get(O.id.toLowerCase());if(W)try{const _=await this.installFromGallery(O,W,t,l,s);_&&n.push(_)}catch(_){s.error(_.message||_.stack||_),e.push(O.id)}else s.error(`${h(O.version?`${O.id}@${O.version}`:O.id)}
${v}`),e.push(O.id)}))}if(e.length)throw new Error((0,a.localize)(7,null,e.join(", ")))}async installVSIX(c,u,g,l){const s=await this.extensionManagementService.getManifest(c);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,g,u.profileLocation,l))try{return await this.extensionManagementService.install(c,u),l.log((0,a.localize)(8,null,(0,T.basename)(c))),s}catch(n){if((0,C.isCancellationError)(n))return l.log((0,a.localize)(9,null,(0,T.basename)(c))),null;throw n}return null}async getGalleryExtensions(c){const u=new Map,g=c.some(s=>s.installOptions.installPreReleaseVersion),l=await this.extensionGalleryService.getExtensions(c.map(s=>({...s,preRelease:g})),D.CancellationToken.None);for(const s of l)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:c,version:u,installOptions:g},l,s,e,n){const t=await this.extensionGalleryService.getManifest(l,D.CancellationToken.None);if(t&&!this.validateExtensionKind(t,n))return null;const r=s.find(o=>(0,b.areSameExtensions)(o.identifier,l.identifier));if(r){if(l.version===r.manifest.version)return n.log((0,a.localize)(10,null,u?`${c}@${u}`:c)),null;n.log((0,a.localize)(11,null,c,l.version))}try{g.isBuiltin?n.log(u?(0,a.localize)(12,null,c,u):(0,a.localize)(13,null,c)):n.log(u?(0,a.localize)(14,null,c,u):(0,a.localize)(15,null,c));const o=await this.extensionManagementService.installFromGallery(l,{...g,installGivenVersion:!!u});return n.log((0,a.localize)(16,null,c,o.manifest.version)),t}catch(o){if((0,C.isCancellationError)(o))return n.log((0,a.localize)(17,null,c)),null;throw o}}validateExtensionKind(c,u){return!0}async validateVSIX(c,u,g,l){const s={id:(0,b.getGalleryExtensionId)(c.publisher,c.name)},n=(await this.extensionManagementService.getInstalled(1,g)).find(t=>(0,b.areSameExtensions)(s,t.identifier)&&(0,L.gt)(t.manifest.version,c.version));return n&&!u?(l.log((0,a.localize)(18,null,n.identifier.id,n.manifest.version,c.version)),!1):this.validateExtensionKind(c,l)}async uninstallExtensions(c,u,g,l=console){const s=async n=>{if(n instanceof p.URI){const t=await this.extensionManagementService.getManifest(n);return f(t)}return n},e=[];for(const n of c){const t=await s(n),o=(await this.extensionManagementService.getInstalled(void 0,g)).filter(S=>(0,b.areSameExtensions)(S.identifier,{id:t}));if(!o.length)throw new Error(`${this.notInstalled(t)}
${v}`);if(o.some(S=>S.type===0)){l.log((0,a.localize)(19,null,t));return}if(!u&&o.some(S=>S.isBuiltin)){l.log((0,a.localize)(20,null,t));return}l.log((0,a.localize)(21,null,t));for(const S of o)await this.extensionManagementService.uninstall(S,{profileLocation:g}),e.push(S);this.location?l.log((0,a.localize)(22,null,t,this.location)):l.log((0,a.localize)(23,null,t))}}async locateExtension(c,u=console){const g=await this.extensionManagementService.getInstalled();c.forEach(l=>{g.forEach(s=>{if(s.identifier.id===l&&s.location.scheme===P.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(c){return this.location?(0,a.localize)(24,null,c,this.location):(0,a.localize)(25,null,c)}};m=ge([ee(0,d.IExtensionManagementService),ee(1,d.IExtensionGalleryService)],m),i.ExtensionManagementCLI=m}),define(Q[41],Z([0,1,3,15,2,36,10,23,12,8,9]),function(B,i,D,C,P,T,L,p,a,d,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsProfileScannerService=i.IExtensionsProfileScannerService=void 0,i.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let w=class extends P.Disposable{constructor(v,f){super(),this.fileService=v,this.logService=f,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,f){return this.withProfileExtensions(f,m=>(m=m.filter(y=>v.some(([c])=>!(0,p.areSameExtensions)(y.identifier,c.identifier))),m.push(...v.map(([y,c])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:c}))),m))}removeExtensionFromProfile(v,f){return this.withProfileExtensions(f,m=>m.filter(y=>!(0,p.areSameExtensions)(y.identifier,v)))}async withProfileExtensions(v,f){return this.getResourceAccessQueue(v).queue(async()=>{let m=[];try{const y=await this.fileService.readFile(v),c=JSON.parse(y.value.toString());for(const u of c){if(!u.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",u);continue}if(!u.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",u);continue}if(!u.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",u);continue}m.push({identifier:u.identifier,location:L.URI.revive(u.location),version:u.version,metadata:u.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(f){m=f(m);const y=m.map(c=>({identifier:c.identifier,version:c.version,location:c.location.toJSON(),metadata:c.metadata}));await this.fileService.writeFile(v,C.VSBuffer.fromString(JSON.stringify(y)))}return m})}getResourceAccessQueue(v){let f=this.resourcesAccessQueueMap.get(v);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(v,f)),f}};w=ge([ee(0,a.IFileService),ee(1,b.ILogService)],w),i.ExtensionsProfileScannerService=w}),define(Q[122],Z([0,1,3,11,2,13,17,39,10,30,20,18,22,23,12,9]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let y=class extends P.Disposable{constructor(u,g,l,s){super(),this.fileService=g,this.extensionGalleryService=l,this.logService=s,this.extensionsDownloadDir=a.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,g){await this.cleanUpPromise;const l=this.getName(u),s=(0,L.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(s)){const e=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(u,e,g);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(e)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,e.path),n}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,g,l){try{await b.Promises.rename(u.fsPath,g.fsPath)}catch(s){if(T.isWindows&&s&&s.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${u} to ${g} with 'EPERM' error. Trying again...`),this.rename(u,g,l);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const g=[],l=[];for(const n of u.children){const t=v.ExtensionKey.parse(n.name);t&&l.push([t,n])}const s=(0,v.groupByExtension)(l,([n])=>n),e=[];for(const n of s)n.sort((t,r)=>p.rcompare(t[0].version,r[0].version)),g.push(...n.slice(1).map(t=>t[1].resource)),e.push(n[0][1]);e.sort((n,t)=>n.mtime-t.mtime),g.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(g.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?v.ExtensionKey.create(u).toString().toLowerCase():(0,d.generateUuid)()}};y=ge([ee(0,w.INativeEnvironmentService),ee(1,f.IFileService),ee(2,h.IExtensionGalleryService),ee(3,m.ILogService)],y),i.ExtensionsDownloader=y}),define(Q[123],Z([0,1,2,14,20,34]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(a,d){super(),this.environmentService=a,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(d.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(a){a.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(a){a.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Q[124],Z([0,1,154,19,3,2,16,14,20,18,22,23,9,62]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let f=class extends v.LanguagePackBaseService{constructor(u,g,l,s){super(l),this.extensionManagementService=u,this.logService=s,this.cache=this._register(new m(g,s)),this.extensionManagementService.registerParticipant({postInstall:async e=>this.postInstallExtension(e),postUninstall:async e=>this.postUninstallExtension(e)})}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),g=Object.keys(u).map(l=>{const s=u[l];return{...this.createQuickPickItem(l,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),g.sort((l,s)=>l.label.localeCompare(s.label)),g}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const g=await this.cache.getLanguagePacks();Object.keys(g).some(l=>g[l]&&g[l].extensions.some(s=>(0,w.areSameExtensions)(s.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(g);return!(0,C.equals)(Object.keys(u),Object.keys(l))}};f=ge([ee(0,b.IExtensionManagementService),ee(1,d.INativeEnvironmentService),ee(2,b.IExtensionGalleryService),ee(3,h.ILogService)],f),i.NativeLanguagePackService=f;let m=class extends T.Disposable{constructor(u,g){super(),this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(g=>{Object.keys(g).forEach(l=>delete g[l]),this.createLanguagePacksFromExtensions(g,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...g){for(const l of g)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,l);Object.keys(u).forEach(l=>this.updateHash(u[l]))}createLanguagePacksFromExtension(u,g){const l=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const e of s)if(g.location.scheme===L.Schemas.file&&y(e)){let n=u[e.languageId];n||(n={hash:"",extensions:[],translations:{},label:e.localizedLanguageName??e.languageName},u[e.languageId]=n);const t=n.extensions.filter(r=>(0,w.areSameExtensions)(r.extensionIdentifier,l))[0];t?t.version=g.manifest.version:n.extensions.push({extensionIdentifier:l,version:g.manifest.version});for(const r of e.translations)n.translations[r.id]=(0,p.join)(g.location.fsPath,r.path)}}updateHash(u){if(u){const g=(0,D.createHash)("md5");for(const l of u.extensions)g.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);u.hash=g.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return a.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(g=u(l),l)).then(l=>{for(const e of Object.keys(l))l[e]||delete l[e];this.languagePacks=l,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),a.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>g,l=>this.logService.error(l))})}};m=ge([ee(0,d.INativeEnvironmentService),ee(1,h.ILogService)],m);function y(c){if(typeof c.languageId!="string"||!Array.isArray(c.translations)||c.translations.length===0)return!1;for(const u of c.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(c.languageName&&typeof c.languageName!="string"||c.localizedLanguageName&&typeof c.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,8,33]),function(B,i,D,C,P,T,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,T.createDecorator)("requestService");function p(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}i.isSuccess=p;function a(m){return m.res.statusCode===204}async function d(m){return a(m)?null:(await(0,D.streamToBuffer)(m.stream)).toString()}i.asText=d;async function b(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);return d(m)}i.asTextOrError=b;async function w(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);if(a(m))return null;const c=(await(0,D.streamToBuffer)(m.stream)).toString();try{return JSON.parse(c)}catch(u){throw u.message+=`:
`+c,u}}i.asJson=w;function h(m){f(m)}i.updateProxyConfigurationsScope=h;let v;function f(m){const y=L.Registry.as(P.Extensions.Configuration),c=v;v={id:"http",order:15,title:(0,C.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(4,null),(0,C.localize)(5,null),(0,C.localize)(6,null),(0,C.localize)(7,null)],default:"override",description:(0,C.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[v],remove:c?[c]:[]})}f(2)}),define(Q[125],Z([0,1,24,16,12,47]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(a,d){this.requestService=a,this.fileService=d}async download(a,d,b=D.CancellationToken.None){if(a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote){await this.fileService.copy(a,d);return}const w={type:"GET",url:a.toString(!0)},h=await this.requestService.request(w,b);if(h.res.statusCode===200)await this.fileService.writeFile(d,h.stream);else{const v=await(0,T.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};L=ge([ee(0,T.IRequestService),ee(1,P.IFileService)],L),i.DownloadService=L}),define(Q[126],Z([0,1,127,5]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function P(L,p){return L.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:L.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function T(L,p,a={}){const d=(0,D.parse)(L),b=a.proxyUrl||P(d,p);if(!b)return null;const w=(0,D.parse)(b);if(!/^https?:$/.test(w.protocol||""))return null;const h={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,C.isBoolean)(a.strictSSL)?a.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((v,f)=>{B(["http-proxy-agent"],v,f)}))(h):new(await new Promise((v,f)=>{B(["https-proxy-agent"],v,f)}))(h)}i.getProxyAgent=T}),define(Q[128],Z([0,1,57,14,95,24,31,11,13,30,77,155,3]),function(B,i,D,C,P,T,L,p,a,d,b,w,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const v=1e4;let f;async function m(c,u,g){return u["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):a.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(g)&&!u["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(g)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=h.Promises.withAsyncBody(async(l,s)=>{const e=new T.CancellationTokenSource,n=setTimeout(()=>{e.dispose(!0),s(new Error((0,P.localize)(0,null)))},v);try{l(await y(c,e.token))}catch(t){!(0,p.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,P.localize)(1,null,(0,L.toErrorMessage)(t)))):l({})}finally{clearTimeout(n),e.dispose()}})),f)}i.getResolvedShellEnv=m;async function y(c,u){const g=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",g);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",l);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};c.trace("getUnixShellEnvironment#env",n);const t=await(0,b.getSystemShell)(a.OS,n);return c.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(u.isCancellationRequested)return o((0,p.canceled)());const S=(0,C.basename)(t);let E,I;const O=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(S)?(E=`& '${process.execPath}' ${O} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,I=["-Login","-Command"]):(E=`'${process.execPath}' ${O} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,S==="tcsh"?I=["-ic"]:I=["-ilc"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),E);const W=(0,D.spawn)(t,[...I,E],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(W.kill(),o((0,p.canceled)()))),W.on("error",X=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(X)),o(X)});const _=[];W.stdout.on("data",X=>_.push(X));const Y=[];W.stderr.on("data",X=>Y.push(X)),W.on("close",(X,re)=>{const se=Buffer.concat(_).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&c.trace("getUnixShellEnvironment#stderr",ne),X||re)return o(new Error((0,P.localize)(2,null,X,re)));const fe=e.exec(se),le=fe?fe[1]:"{}";try{const ie=JSON.parse(le);g?ie.ELECTRON_RUN_AS_NODE=g:delete ie.ELECTRON_RUN_AS_NODE,l?ie.ELECTRON_NO_ATTACH_CONSOLE=l:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ie),r(ie)}catch(ie){c.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[65],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IStateService=void 0,i.IStateService=(0,D.createDecorator)("stateService")}),define(Q[129],Z([0,1,3,15,5,18,12,9]),function(B,i,D,C,P,T,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StateService=i.FileStorage=void 0;class a{constructor(w,h,v){this.storagePath=w,this.logService=h,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,h){const v=this.storage[w];return(0,P.isUndefinedOrNull)(v)?h:v}setItem(w,h){this.setItems([{key:w,data:h}])}setItems(w){let h=!1;for(const{key:v,data:f}of w)this.storage[v]!==f&&((0,P.isUndefinedOrNull)(f)?(0,P.isUndefined)(this.storage[v])||(this.storage[v]=void 0,h=!0):(this.storage[v]=f,h=!0));h&&this.save()}removeItem(w){(0,P.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,C.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}i.FileStorage=a;let d=class{constructor(w,h,v){this.fileStorage=new a(w.stateResource,h,v)}async init(){await this.fileStorage.init()}getItem(w,h){return this.fileStorage.getItem(w,h)}};d=ge([ee(0,T.IEnvironmentService),ee(1,p.ILogService),ee(2,L.IFileService)],d),i.StateService=d}),define(Q[66],Z([0,1,13,32,10,30]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(d){if(D.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function p(d,b,w,h,v,f,m,y,c,u){const g=Object.create(null);g["common.machineId"]=m,g.sessionID=(0,T.generateUuid)()+Date.now(),g.commitHash=v,g.version=f,g["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,D.PlatformToString)(D.platform),g["common.nodePlatform"]=C.platform,g["common.nodeArch"]=h,g["common.product"]=u||"desktop",y&&(g["common.msftInternal"]=y);let l=0;const s=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(g["common.snap"]="true");const e=L(w);e&&(g["common.platformDetail"]=e);try{const n=await d.readFile(P.URI.file(c));g["common.source"]=n.value.toString().slice(0,30)}catch{}return g}i.resolveCommonProperties=p;function a(d){const b=C.env.USERDNSDOMAIN;if(!b)return!1;const w=b.toLowerCase();return d.some(h=>w===h)}i.verifyMicrosoftInternalDomain=a}),define(Q[35],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(C=i.TelemetryLevel||(i.TelemetryLevel={}));var P;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(P=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,35]),function(B,i,D,C,P,T,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.isInternalTelemetry=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class a{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,C.staticObservableValue)(0)}publicLog(e,n){return Promise.resolve(void 0)}publicLog2(e,n){return this.publicLog(e,n)}publicLogError(e,n){return Promise.resolve(void 0)}publicLogError2(e,n){return this.publicLogError(e,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=a,i.NullTelemetryService=new a;class d{async publicLog(e,n,t){}async publicLogError(e,n,t){}}i.NullEndpointTelemetryService=d,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(s,e){return e.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(n.source),configurationKeys:c(n.sourceConfig)})})}i.configurationTelemetry=b;function w(s,e){return!(e.disableTelemetry||!s.enableTelemetry||e.extensionTestsLocationURI)}i.supportsTelemetry=w;function h(s){const e=s.getValue(p.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(e??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=h;function v(s){const e={},n={},t={};y(s,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const o=t[r];typeof o=="number"?n[r]=o:typeof o=="boolean"?n[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),e[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(e[r]=o)}return{properties:e,measurements:n}}i.validateTelemetryData=v;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(s){if(!s)return"none";for(const e of f)if(s.startsWith(`${e}+`))return e;return"other"}i.cleanRemoteAuthority=m;function y(s,e,n=0,t){if(!!s)for(const r of Object.getOwnPropertyNames(s)){const o=s[r],S=t?t+r:r;Array.isArray(o)?e[S]=(0,D.safeStringify)(o):o instanceof Date?e[S]=o.toISOString():(0,P.isObject)(o)?n<2?y(o,e,n+1,S+"."):e[S]=(0,D.safeStringify)(o):e[S]=o}}function c(s){if(!s)return[];const e=[];return u(e,"",s),e}function u(s,e,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(t=>u(s,e?`${e}.${t}`:t,n[t])):s.push(e)}function g(s,e){const n=s.msftInternalDomains||[],t=e.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(n)||t}i.isInternalTelemetry=g;function l(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}i.getPiiPathsFromEnvironment=l}),define(Q[130],Z([0,1,103,42]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function P(T,L,p,a,d,b,w){const h={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${L.nameShort})`};if((0,C.supportsTelemetry)(L,p)&&(0,C.getTelemetryLevel)(a)===3){const v=await(0,D.getServiceMachineId)(p,d,b),{sessionId:f}=await w.getTelemetryInfo();h["X-Market-User-Id"]=v,h["VSCode-SessionId"]=f}return h}i.resolveMarketplaceHeaders=P}),define(Q[131],Z([0,1,11,26,42]),function(B,i,D,C,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(a,d,b){const w=await new Promise((y,c)=>{B(["@microsoft/1ds-core-js"],y,c)}),h=await new Promise((y,c)=>{B(["@microsoft/1ds-post-js"],y,c)}),v=new w.AppInsightsCore,f=new h.PostChannel,m={instrumentationKey:a,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(b){m.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:b};m.extensionConfig[f.identifier]=y}return v.initialize(m,[]),v.addTelemetryInitializer(y=>{d&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),v}class p{constructor(d,b,w,h,v){this._isInternalTelemetry=d,this._eventPrefix=b,this._defaultData=w,this._xhrOverride=v,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(d){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){d(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(b=>{d(b)},b=>{(0,D.onUnexpectedError)(b),console.error(b)})}}log(d,b){if(!this._aiCoreOrKey)return;b=(0,C.mixin)(b,this._defaultData),b=(0,P.validateTelemetryData)(b);const w=this._eventPrefix+"/"+d;try{this._withAIClient(h=>{h.pluginVersionString=b?.properties.version??"Unknown",h.track({name:w,baseData:{name:w,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(d=>{this._withAIClient(b=>{b.unload(!0,()=>{this._aiCoreOrKey=void 0,d(void 0)})})}):Promise.resolve(void 0)}}i.AbstractOneDataSystemAppender=p}),define(Q[132],Z([0,1,2,26,52,13,27,96,21,40,133,28,33,35,42]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let m=class{constructor(u,g,l){this._configurationService=g,this._productService=l,this._experimentProperties={},this.telemetryLevel=new P.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,g){this._experimentProperties[u]=g}_updateTelemetryLevel(){let u=(0,f.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const l=g.usage?3:g.error?2:0;u=Math.min(u,l)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties,g=u.sessionID,l=u["common.machineId"],s=u["common.firstSessionDate"],e=u["common.msftInternal"];return{sessionId:g,machineId:l,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(u,g,l,s){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(e=>{l=(0,C.mixin)(l,e),l=(0,C.mixin)(l,this._experimentProperties),l=(0,C.cloneAndChange)(l,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(u,l))},e=>{console.error(e)})}publicLog(u,g,l){return this._log(u,3,g,l)}publicLog2(u,g,l){return this.publicLog(u,g,l)}publicLogError(u,g){return this._sendErrorTelemetry?this._log(u,2,g,!0):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}_anonymizeFilePaths(u){let g=u;const l=[];for(const t of this._cleanupPatterns)for(;;){const r=t.exec(u);if(!r)break;l.push([r.index,t.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(g="";;){const t=e.exec(u);if(!t)break;!s.test(t[0])&&l.every(([r,o])=>t.index<r||t.index>=o)&&(g+=u.substring(n,t.index)+"<REDACTED: user-file-path>",n=e.lastIndex)}return n<u.length&&(g+=u.substr(n)),g}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const g=u.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of l)if(s.regex.test(g))return`<REDACTED: ${s.label}>`;return u}_cleanupInfo(u,g){let l=u;g&&(l=this._anonymizeFilePaths(l));for(const s of this._cleanupPatterns)l=l.replace(s,"");return l=this._removePropertiesWithPossibleUserInfo(l),l}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ge([ee(1,a.IConfigurationService),ee(2,w.IProductService)],m),i.TelemetryService=m;function y(){const c=(0,p.localize)(0,null,b.default.nameLong),u=b.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=T.isWeb?"":(0,p.localize)(3,null),l=(0,p.localize)(4,null),s=(0,p.localize)(5,null),e=(0,p.localize)(6,null),n=(0,p.localize)(7,null),t=`
|       | ${l} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,p.localize)(8,null);return`
${c} ${u} ${g}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,p.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,p.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[134],Z([0,1,156,131]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OneDataSystemAppender=void 0;class P extends C.AbstractOneDataSystemAppender{constructor(L,p,a,d){const b={sendPOST:(w,h)=>{const v={method:"POST",headers:{...w.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(w.data)}};try{const f=D.request(w.urlString,v,m=>{m.on("data",function(y){h(m.statusCode??200,m.headers,y.toString())}),m.on("error",function(y){h(0,{})})});f.write(w.data),f.end()}catch{h(0,{})}}};super(L,p,a,d,b)}}i.OneDataSystemAppender=P}),define(Q[135],Z([0,1,14,20]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function P(T,L){const p=Object.create(null),a=(b,w)=>{const h=JSON.parse(b);p[w]=h};if(L){const b=[],w=await C.Promises.readdir(L);for(const v of w)try{(await C.Promises.stat((0,D.join)(L,v))).isDirectory()&&b.push(v)}catch{}const h=[];for(const v of b)(await C.Promises.readdir((0,D.join)(L,v))).filter(m=>m==="telemetry.json").length===1&&h.push(v);for(const v of h){const f=(await C.Promises.readFile((0,D.join)(L,v,"telemetry.json"))).toString();a(f,v)}}let d=(await C.Promises.readFile((0,D.join)(T,"telemetry-core.json"))).toString();return a(d,"vscode-core"),d=(await C.Promises.readFile((0,D.join)(T,"telemetry-extensions.json"))).toString(),a(d,"vscode-extensions"),JSON.stringify(p,null,4)}i.buildTelemetryMessage=P}),define(Q[29],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Q[136],Z([0,1,4,2,10,18,23,12,9,29]),function(B,i,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let b=class extends C.Disposable{constructor(h,v,f,m,y){super(),this.extensionsManagementService=h,this.logService=m,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(u=>this.onInstallExtension(u))),this._register(h.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(h.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const c=P.URI.file(f.extensionsPath);this._register(v.watch(c)),this._register(D.Event.filter(v.onDidFilesChange,u=>u.rawChanges.some(g=>this.doesChangeAffects(g,c)))(()=>this.onDidChange()))}doesChangeAffects(h,v){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),v)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,L.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,L.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),v=h.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,L.areSameExtensions)(y,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),f=this.installedExtensions.filter(m=>this.installingExtensions.some(y=>(0,L.areSameExtensions)(y,m))?!1:h.every(y=>!(0,L.areSameExtensions)(y.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=h.map(m=>m.identifier),(v.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:f})}}};b=ge([ee(1,p.IFileService),ee(2,T.INativeEnvironmentService),ee(3,a.ILogService),ee(4,d.IUriIdentityService)],b),i.ExtensionsWatcher=b}),define(Q[137],Z([0,1,29,104,12,17,69,4,2]),function(B,i,D,C,P,T,L,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class d{constructor(h){this.uri=h,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let b=class{constructor(h){this._fileService=h,this._dispooables=new a.DisposableStore,this._limit=2**16;const v=new Map,f=m=>{let y=v.get(m.scheme);return y===void 0&&(y=h.hasProvider(m)&&!this._fileService.hasCapability(m,1024),v.set(m.scheme,y)),y};this._dispooables.add(p.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{v.delete(m.scheme)})),this.extUri=new T.ExtUri(f),this._canonicalUris=new L.SkipList((m,y)=>this.extUri.compare(m,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,T.normalizePath)(h));const v=this._canonicalUris.get(h);return v?v.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new d(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let f=0;f<v;f++)this._canonicalUris.set(h[f][0],h[f][1].touch())}};b=ge([ee(0,P.IFileService)],b),i.UriIdentityService=b,(0,C.registerSingleton)(D.IUriIdentityService,b,!0)}),define(Q[138],Z([0,1,98,14,36,17,10,8,16]),function(B,i,D,C,P,T,L,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.hasWorkspaceFileExtension=i.isSavedWorkspace=i.isTemporaryWorkspace=i.isUntitledWorkspace=i.UNTITLED_WORKSPACE_NAME=i.WORKSPACE_FILTER=i.WORKSPACE_SUFFIX=i.WORKSPACE_EXTENSION=i.toWorkspaceFolder=i.WorkspaceFolder=i.Workspace=i.isWorkspaceFolder=i.isWorkspace=i.WorkbenchState=i.reviveIdentifier=i.isWorkspaceIdentifier=i.toWorkspaceIdentifier=i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=i.isSingleFolderWorkspaceIdentifier=i.IWorkspaceContextService=void 0,i.IWorkspaceContextService=(0,p.createDecorator)("contextService");function d(n){const t=n;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}i.isSingleFolderWorkspaceIdentifier=d,i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function b(n,t){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,C.basename)(n)}:t?i.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}i.toWorkspaceIdentifier=b;function w(n){const t=n;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}i.isWorkspaceIdentifier=w;function h(n){const t=n;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}i.reviveIdentifier=h;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v=i.WorkbenchState||(i.WorkbenchState={}));function f(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}i.isWorkspace=f;function m(n){const t=n;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}i.isWorkspaceFolder=m;class y{constructor(t,r,o,S,E){this._id=t,this._transient=o,this._configuration=S,this._ignorePathCasing=E,this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=P.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}i.Workspace=y;class c{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,T.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}i.WorkspaceFolder=c;function u(n){return new c({uri:n,index:0,name:(0,T.basenameOrAuthority)(n)},{uri:n.toString()})}i.toWorkspaceFolder=u,i.WORKSPACE_EXTENSION="code-workspace",i.WORKSPACE_SUFFIX=`.${i.WORKSPACE_EXTENSION}`,i.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[i.WORKSPACE_EXTENSION]}],i.UNTITLED_WORKSPACE_NAME="workspace.json";function g(n,t){return T.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}i.isUntitledWorkspace=g;function l(n){let t;return L.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===a.Schemas.tmp}i.isTemporaryWorkspace=l;function s(n,t){return!g(n,t)&&!l(n)}i.isSavedWorkspace=s;function e(n){return(typeof n=="string"?(0,C.extname)(n):(0,T.extname)(n))===i.WORKSPACE_SUFFIX}i.hasWorkspaceFileExtension=e}),define(Q[25],Z([0,1,53,4,2,17,5,10,97,18,12,8,9,138,36,29,3,30,27]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=i.toUserDataProfile=i.EXTENSIONS_RESOURCE_NAME=i.reviveProfile=i.IUserDataProfilesService=i.PROFILES_ENABLEMENT_CONFIG=i.isUserDataProfile=void 0;function g(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&p.URI.isUri(t.location)&&p.URI.isUri(t.globalStorageHome)&&p.URI.isUri(t.settingsResource)&&p.URI.isUri(t.keybindingsResource)&&p.URI.isUri(t.tasksResource)&&p.URI.isUri(t.snippetsHome)&&((0,L.isUndefined)(t.extensionsResource)||p.URI.isUri(t.extensionsResource)))}i.isUserDataProfile=g,i.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",i.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function l(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,location:p.URI.revive(n.location).with({scheme:t}),globalStorageHome:p.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:p.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:p.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:p.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:p.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:p.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}i.reviveProfile=l,i.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(n,t,r,o,S){return{id:n,name:t,location:r,isDefault:!1,globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:(0,T.joinPath)(r,i.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:o,isTransient:S}}i.toUserDataProfile=s;let e=class extends P.Disposable{constructor(t,r,o,S){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=o,this.logService=S,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new C.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new C.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new C.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new C.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(E=>s((0,T.basename)(E.location),E.name,E.location,E.useDefaultFlags)):[];let r;const o=new f.ResourceMap,S=s((0,D.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,a.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...S,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||t.length>0||this.transientProfilesObject.profiles.length>0?S.extensionsResource:void 0}),t.length){const E=this.getStoredProfileAssociations();if(E.workspaces)for(const[I,O]of Object.entries(E.workspaces)){const W=p.URI.parse(I),_=p.URI.parse(O),Y=t.find(X=>this.uriIdentityService.extUri.isEqual(X.location,_));Y&&o.set(W,Y)}if(E.emptyWindow){const I=p.URI.parse(E.emptyWindow);r=t.find(O=>this.uriIdentityService.extUri.isEqual(O.location,I))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:r}}return this._profilesObject}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let S=0;for(const I of this.profiles){const O=o.exec(I.name),W=O?parseInt(O[1]):0;S=W>S?W:S}const E=`${r} ${S+1}`;return this.createProfile((0,D.hash)((0,c.generateUuid)()).toString(16),E,void 0,!0,t)}async createNamedProfile(t,r,o){return this.createProfile((0,D.hash)((0,c.generateUuid)()).toString(16),t,r,!1,o)}async createProfile(t,r,o,S,E){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const I=await this.doCreateProfile(t,r,o,!!S);return E&&await this.setProfileForWorkspace(E,I),I}async doCreateProfile(t,r,o,S){let E=this.profileCreationPromises.get(r);return E||(E=(async()=>{try{const I=this.profiles.find(_=>_.name===r||_.id===t);if(I)return I;const O=s(t,r,(0,T.joinPath)(this.profilesHome,t),o,S);await this.fileService.createFolder(O.location);const W=[];return this._onWillCreateProfile.fire({profile:O,join(_){W.push(_)}}),await y.Promises.settled(W),this.updateProfiles([O],[],[]),O}finally{this.profileCreationPromises.delete(r)}})(),this.profileCreationPromises.set(r,E)),E}async updateProfile(t,r,o,S){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);let E=this.profiles.find(I=>I.id===t.id);if(!E)throw new Error(`Profile '${t.name}' does not exist`);return E=s(E.id,r,E.location,o,S??E.isTransient),this.updateProfiles([],[],[E]),E}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(S=>S.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(S){o.push(S)}}),await y.Promises.settled(o),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const S of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(S)?.id&&this.profilesObject.workspaces.delete(S);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(S){this.logService.error(S)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(S=>S.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return p.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,v.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,v.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,o){const S=[...this.profiles,...t],E=[];this.transientProfilesObject.profiles=[];for(let I of S)I.isDefault||r.some(O=>I.id===O.id)||(I=o.find(O=>I.id===O.id)??I,I.isTransient?this.transientProfilesObject.profiles.push(I):E.push({location:I.location,name:I.name,useDefaultFlags:I.useDefaultFlags}));this.saveStoredProfiles(E),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,o)}triggerProfilesChanges(t,r,o){this._onDidChangeProfiles.fire({added:t,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const S=this.getWorkspace(t),E=o?this.transientProfilesObject:this.profilesObject;p.URI.isUri(S)?(E.workspaces.delete(S),r&&E.workspaces.set(S,r)):E.emptyWindow=r,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,S]of this.profilesObject.workspaces.entries())t[o.toString()]=S.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};e.PROFILES_KEY="userDataProfiles",e.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e=ge([ee(0,d.IEnvironmentService),ee(1,b.IFileService),ee(2,m.IUriIdentityService),ee(3,h.ILogService)],e),i.UserDataProfilesService=e}),define(Q[139],Z([0,1,19,3,24,11,4,2,13,10,82,22,23,34,9,28,35,25]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let u=class extends p.Disposable{constructor(t,r,o,S,E){super(),this.galleryService=t,this.telemetryService=r,this.logService=o,this.productService=S,this.userDataProfilesService=E,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(({task:I})=>I.cancel()),this.uninstallingExtensions.forEach(I=>I.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(b.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),l(o)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},P.CancellationToken.None);if(!o)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,o){const S=Y=>`${h.ExtensionKey.create(Y).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!d.URI.isUri(r)){const Y=this.installingExtensions.get(S(r));if(Y){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:X}=await Y.task.waitUntilTaskIsFinished();return X}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const E=[],I=[],O=[],W=this.createInstallExtensionTask(t,r,o);d.URI.isUri(r)||this.installingExtensions.set(S(r),{task:W,waitingTasks:[]}),this._onInstallExtension.fire({identifier:W.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",W.identifier.id),E.push({task:W,manifest:t});let _=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",W.identifier.id);else try{const X=await this.getAllDepsAndPackExtensions(W.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),re=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:se,manifest:ne}of X){_=_||!!ne.extensionDependencies?.some(ie=>(0,h.areSameExtensions)({id:ie},W.identifier));const fe=S(se),le=this.installingExtensions.get(fe);if(le){if(this.canWaitForTask(W,le.task)){this.logService.info("Waiting for already requested installing extension",se.identifier.id,W.identifier.id),le.waitingTasks.push(W);const ie=le.task.identifier;I.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,V=>V.some(N=>(0,h.areSameExtensions)(N.identifier,ie)))).then(V=>{if(!V.find(F=>(0,h.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!re.some(({identifier:ie})=>(0,h.areSameExtensions)(ie,se.identifier))){const ie=this.createInstallExtensionTask(ne,se,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(fe,{task:ie,waitingTasks:[W]}),this._onInstallExtension.fire({identifier:ie.identifier,source:se,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,W.identifier.id),E.push({task:ie,manifest:ne})}}}catch(X){if(d.URI.isUri(W.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",W.identifier.id,X.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",W.identifier.id,X.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",W.identifier.id),X}const Y=E.reduce((X,{task:re,manifest:se})=>(X.set(re.identifier.id.toLowerCase(),{task:re,manifest:se}),X),new Map);for(;Y.size;){let X;const re=[...Y.values()].filter(({manifest:se})=>!se.extensionDependencies?.some(ne=>Y.has(ne.toLowerCase())));re.length?X=Y.size===1?re:re.filter(({task:se})=>!(se===W&&!_)):(this.logService.info("Found extensions with circular dependencies",re.map(({task:se})=>se.identifier.id)),X=[...Y.values()]),await this.joinAllSettled(X.map(async({task:se})=>{const ne=new Date().getTime();try{const{local:fe}=await se.run();if(await this.joinAllSettled(this.participants.map(le=>le.postInstall(fe,se.source,o,P.CancellationToken.None))),!d.URI.isUri(se.source)){const le=se.operation===3,ie=le?void 0:(new Date().getTime()-se.source.lastUpdated)/1e3;if(s(this.telemetryService,le?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(se.source),duration:new Date().getTime()-ne,durationSinceUpdate:ie}),a.isWeb&&se.operation!==3)try{await this.galleryService.reportStatistic(fe.manifest.publisher,fe.manifest.name,fe.manifest.version,"install")}catch{}}O.push({local:fe,identifier:se.identifier,operation:se.operation,source:se.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:fe.isApplicationScoped})}catch(fe){throw d.URI.isUri(se.source)||s(this.telemetryService,se.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(se.source),duration:new Date().getTime()-ne,error:fe}),this.logService.error("Error while installing the extension:",se.identifier.id),fe}finally{Y.delete(se.identifier.id.toLowerCase())}}))}return I.length&&await this.joinAllSettled(I),O.forEach(({identifier:X})=>this.logService.info("Extension installed successfully:",X.id)),this._onDidInstallExtensions.fire(O),O.filter(({identifier:X})=>(0,h.areSameExtensions)(X,W.identifier))[0].local}catch(Y){if(E.forEach(({task:X})=>X.cancel()),O.length)try{const X=await Promise.allSettled(O.map(({local:re})=>this.createUninstallExtensionTask(re,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let re=0;re<X.length;re++){const se=X[re],{identifier:ne}=O[re];se.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ne.id):this.logService.warn("Rollback: Error while uninstalling extension",ne.id,(0,T.getErrorMessage)(se.reason))}}catch(X){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(X),O.map(({identifier:re})=>re.id))}throw this._onDidInstallExtensions.fire(E.map(({task:X})=>({identifier:X.identifier,operation:2,source:X.source,context:o.context,profileLocation:o.profileLocation}))),Y}finally{for(const[Y,{task:X,waitingTasks:re}]of this.installingExtensions.entries()){const se=re.indexOf(W);se!==-1&&re.splice(se,1),re.length===0&&(X===W||se!==-1)&&this.installingExtensions.delete(Y)}}}canWaitForTask(t,r){for(const[,{task:o,waitingTasks:S}]of this.installingExtensions.entries())if(o===t&&(S.includes(r)||S.some(E=>this.canWaitForTask(E,r)))||o===r&&S[0]&&!this.canWaitForTask(t,S[0]))return!1;return!0}async joinAllSettled(t){const r=[],o=[],S=await Promise.allSettled(t);for(const E of S)E.status==="fulfilled"?r.push(E.value):o.push(E.reason);if(o.length)throw g(o);return r}async getAllDepsAndPackExtensions(t,r,o,S,E){if(!this.galleryService.isEnabled())return[];const I=await this.getInstalled(void 0,E),O=[t],W=[],_=async(Y,X)=>{const re=X.extensionDependencies||[],se=[...re];if(X.extensionPack){const ne=o?I.find(fe=>(0,h.areSameExtensions)(fe.identifier,Y)):void 0;for(const fe of X.extensionPack)ne&&ne.manifest.extensionPack&&ne.manifest.extensionPack.some(le=>(0,h.areSameExtensions)({id:le},{id:fe}))||se.every(le=>!(0,h.areSameExtensions)({id:le},{id:fe}))&&se.push(fe)}if(se.length){const ne=[...O,...W.map(le=>le.gallery.identifier)],fe=se.filter(le=>ne.every(ie=>!(0,h.areSameExtensions)(ie,{id:le})));if(fe.length){const le=await this.galleryService.getExtensions(fe.map(ie=>({id:ie,preRelease:S})),P.CancellationToken.None);for(const ie of le){if(ne.find(F=>(0,h.areSameExtensions)(F,ie.identifier)))continue;const V=re.some(F=>(0,h.areSameExtensions)({id:F},ie.identifier));let N;try{N=await this.checkAndGetCompatibleVersion(ie,!1,S)}catch(F){if(F instanceof w.ExtensionManagementError&&F.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!V){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}W.push({gallery:N.extension,manifest:N.manifest}),await _(N.extension.identifier,N.manifest)}}}};return await _(t,r),W}async checkAndGetCompatibleVersion(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(O=>(0,h.areSameExtensions)(t.identifier,O)))throw new w.ExtensionManagementError(b.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const O=await this.getTargetPlatform();throw new w.ExtensionManagementError(b.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(O)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const E=await this.getCompatibleVersion(t,r,o);if(E){if(o&&!r&&t.hasPreReleaseVersion&&!E.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(b.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],P.CancellationToken.None))[0]?new w.ExtensionManagementError(b.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(b.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",E.identifier.id);const I=await this.galleryService.getManifest(E,P.CancellationToken.None);if(I===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(I.version!==E.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:I}}async getCompatibleVersion(t,r,o){const S=await this.getTargetPlatform();let E=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(E=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:S,compatible:!0},P.CancellationToken.None))[0]||null),!E&&await this.galleryService.isExtensionCompatible(t,o,S)&&(E=t),E||(r?E=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:S,compatible:!0},P.CancellationToken.None))[0]||null:E=await this.galleryService.getCompatibleExtension(t,o,S)),E}async uninstallExtension(t,r){const o=_=>`${_.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,S=this.uninstallingExtensions.get(o(t.identifier));if(S)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),S.waitUntilTaskIsFinished();const E=(_,Y)=>{const X=this.createUninstallExtensionTask(_,Y);return this.uninstallingExtensions.set(o(X.extension.identifier),X),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped}),X},I=(_,Y)=>{Y?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString(),Y.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,Y.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(_),error:Y}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:Y?.code,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped})},O=[],W=[];try{O.push(E(t,r));const _=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const Y=this.getAllPackExtensionsToUninstall(t,_);for(const X of Y)this.uninstallingExtensions.has(o(X.identifier))?this.logService.info("Extensions is already requested to uninstall",X.identifier.id):O.push(E(X,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(O.map(Y=>Y.extension),_,t),await this.joinAllSettled(O.map(async Y=>{try{if(await Y.run(),await this.joinAllSettled(this.participants.map(X=>X.postUninstall(Y.extension,r,P.CancellationToken.None))),Y.extension.identifier.uuid)try{await this.galleryService.reportStatistic(Y.extension.manifest.publisher,Y.extension.manifest.name,Y.extension.manifest.version,"uninstall")}catch{}I(Y.extension)}catch(X){const re=X instanceof w.ExtensionManagementError?X:new w.ExtensionManagementError((0,T.getErrorMessage)(X),w.ExtensionManagementErrorCode.Internal);throw I(Y.extension,re),re}finally{W.push(Y)}}))}catch(_){const Y=_ instanceof w.ExtensionManagementError?_:new w.ExtensionManagementError((0,T.getErrorMessage)(_),w.ExtensionManagementErrorCode.Internal);for(const X of O){try{X.cancel()}catch{}W.includes(X)||I(X.extension,Y)}throw Y}finally{for(const _ of O)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(t,r,o){for(const S of t){const E=this.getDependents(S,r);if(E.length){const I=E.filter(O=>!t.some(W=>(0,h.areSameExtensions)(W.identifier,O.identifier)));if(I.length)throw new Error(this.getDependentsErrorMessage(S,I,o))}}}getDependentsErrorMessage(t,r,o){return o===t?r.length===1?b.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?b.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?b.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):b.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const S=t.manifest.extensionPack?t.manifest.extensionPack:[];if(S.length){const E=r.filter(O=>!O.isBuiltin&&S.some(W=>(0,h.areSameExtensions)({id:W},O.identifier))),I=[];for(const O of E)I.push(...this.getAllPackExtensionsToUninstall(O,r,o));return[...E,...I]}return[]}getDependents(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(S=>(0,h.areSameExtensions)({id:S},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,r,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,r,o)}createUninstallExtensionTask(t,r){return r.profileLocation&&t.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,r)}};u=ge([ee(0,w.IExtensionGalleryService),ee(1,y.ITelemetryService),ee(2,f.ILogService),ee(3,m.IProductService),ee(4,c.IUserDataProfilesService)],u),i.AbstractExtensionManagementService=u;function g(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}i.joinErrors=g;function l(n){if(n instanceof w.ExtensionManagementError)return n;const t=new w.ExtensionManagementError(n.message,w.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,duration:o,error:S,durationSinceUpdate:E}){const I=S?S instanceof w.ExtensionManagementError?S.code:w.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(t,{...r,success:!S,duration:o,errorcode:I,durationSinceUpdate:E})}i.reportTelemetry=s;class e{constructor(){this.barrier=new C.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(t=>new Promise((r,o)=>{const S=t.onCancellationRequested(()=>{S.dispose(),o(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=e}),define(Q[48],Z([0,1,19,3,26,15,11,50,74,2,16,14,13,17,39,54,5,10,86,18,23,34,45,12,8,9,28,4,44,41,25,29,102]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c,u,g,l,s,e,n,t,r,o,S,E,I,O,W,_){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var Y;(function(ie){function V(N,F){if(N===F)return!0;const z=Object.keys(N),$=new Set;for(const J of Object.keys(F))$.add(J);if(z.length!==$.size)return!1;for(const J of z){if(N[J]!==F[J])return!1;$.delete(J)}return $.size===0}ie.equals=V})(Y=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let X=class extends d.Disposable{constructor(V,N,F,z,$,J,A,U,R,k,M){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=N,this.extensionsControlLocation=F,this.cacheLocation=z,this.userDataProfilesService=$,this.extensionsProfileScannerService=J,this.fileService=A,this.logService=U,this.environmentService=R,this.productService=k,this.instantiationService=M,this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,v.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,v.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(se,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,l.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(V,N,F){const[z,$]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(N)]),J=F?await this.scanExtensionsUnderDevelopment(V,[...z,...$]):[];return this.dedupExtensions(z,$,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const N=[];N.push(this.scanDefaultSystemExtensions(!!V.useCache,V.language)),N.push(this.scanDevSystemExtensions(V.language,!!V.checkControlFile));const[F,z]=await Promise.all(N);return this.applyScanOptions([...F,...z],0,V,!1)}async scanUserExtensions(V){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(V.profileLocation??this.userExtensionsLocation,!!V.profileLocation,1,!V.includeUninstalled,V.language);let z=await(V.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return z=await this.applyScanOptions(z,1,V,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(V,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===b.Schemas.file).map(async z=>{const $=await this.createExtensionScannerInput(z,!1,1,!0,V.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=N.find(U=>(0,l.areSameExtensions)(U.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",V,!0)}return[]}async scanExistingExtension(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanExtension(z);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(V,N,F){const z=await this.createExtensionScannerInput(V,!1,N,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions($,N,F,!0)}async scanMetadata(V){const N=(0,v.joinPath)(V,"package.json"),F=(await this.fileService.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(V,N){const F=(0,v.joinPath)(V,"package.json"),z=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(z);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,$.__metadata={...$.__metadata,...N},await this.fileService.writeFile((0,v.joinPath)(V,"package.json"),T.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(V,N,F,z){return F.includeAllVersions||(V=this.dedupExtensions(N===0?V:void 0,N===1?V:void 0,N==="development"?V:void 0,await this.getTargetPlatform(),z)),F.includeInvalid||(V=V.filter($=>$.isValid)),V.sort(($,J)=>{const A=w.basename($.location.fsPath),U=w.basename(J.location.fsPath);return A<U?-1:A>U?1:0})}dedupExtensions(V,N,F,z,$){const J=(U,R,k)=>{if(U.isValid&&!R.isValid)return!1;if(U.isValid===R.isValid){if($&&f.gt(U.manifest.version,R.manifest.version))return this.logService.debug(`Skipping extension ${R.location.path} with lower version ${R.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(f.eq(U.manifest.version,R.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${R.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===z)return this.logService.debug(`Skipping extension ${R.location.path} from different target platform ${R.targetPlatform}`),!1}}return k?this.logService.warn(`Overwriting user extension ${U.location.path} with ${R.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${R.location.path}.`),!0},A=new Map;return V?.forEach(U=>{const R=s.ExtensionIdentifier.toKey(U.identifier.id),k=A.get(R);(!k||J(k,U,!1))&&A.set(R,U)}),N?.forEach(U=>{const R=s.ExtensionIdentifier.toKey(U.identifier.id),k=A.get(R);if(!k&&V&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!k||J(k,U,!1))&&A.set(R,U)}),F?.forEach(U=>{const R=s.ExtensionIdentifier.toKey(U.identifier.id),k=A.get(R);(!k||J(k,U,!0))&&A.set(R,U),A.set(R,U)}),[...A.values()]}async scanDefaultSystemExtensions(V,N){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),$=await(V&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(V,N){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=N?await this.getBuiltInExtensionControl():{},$=[],J=c.URI.file(w.normalize(w.join(b.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const U of F){const R=z[U.name]||"marketplace";switch(R){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(J,U.name));break;default:$.push(c.URI.file(R));break}}const A=await Promise.all($.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,V))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,D.coalesce)(A)}async getBuiltInExtensionControl(){try{const V=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(V.value.toString())}catch{return{}}}async createExtensionScannerInput(V,N,F,z,$,J=!0){const A=await this.getTranslations($??h.language),U=await this.getMtime(V),R=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,k=R?await this.getMtime(R):void 0;return new re(V,U,R,k,N,F,z,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(V){try{const N=await this.fileService.stat(V);if(typeof N.mtime=="number")return N.mtime}catch{}}};X=ge([ee(4,O.IUserDataProfilesService),ee(5,I.IExtensionsProfileScannerService),ee(6,n.IFileService),ee(7,r.ILogService),ee(8,g.IEnvironmentService),ee(9,o.IProductService),ee(10,t.IInstantiationService)],X),i.AbstractExtensionsScannerService=X;class re{constructor(V,N,F,z,$,J,A,U,R,k,M,j,q,H){this.location=V,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=J,this.excludeObsolete=A,this.validate=U,this.productVersion=R,this.productDate=k,this.productCommit=M,this.devMode=j,this.language=q,this.translations=H}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,N){return(0,v.isEqual)(V.location,N.location)&&V.mtime===N.mtime&&(0,v.isEqual)(V.applicationExtensionslocation,N.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&V.profile===N.profile&&V.type===N.type&&V.excludeObsolete===N.excludeObsolete&&V.validate===N.validate&&V.productVersion===N.productVersion&&V.productDate===N.productDate&&V.productCommit===N.productCommit&&V.devMode===N.devMode&&V.language===N.language&&Y.equals(V.translations,N.translations)}}let se=class extends d.Disposable{constructor(V,N,F,z,$){super(),this.obsoleteFile=V,this.extensionsProfileScannerService=N,this.uriIdentityService=F,this.fileService=z,this.logService=$}async scanExtensions(V){const N=V.profile?await this.scanExtensionsFromProfile(V):await this.scanExtensionsFromLocation(V);let F={};if(V.excludeObsolete&&V.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(z)}catch{}return(0,y.isEmptyObject)(F)?N:N.filter(z=>!F[l.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(V){const N=await this.fileService.resolve(V.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async z=>{if(!z.isDirectory||V.type===1&&(0,v.basename)(z.resource).indexOf(".")===0)return null;const $=new re(z.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension($)}));return(0,D.coalesce)(F).sort((z,$)=>z.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(V){let N=await this.scanExtensionsFromProfileResource(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(V.location,V.applicationExtensionslocation)){N=N.filter(z=>!z.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(V.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,V);N.push(...F)}return N}async scanExtensionsFromProfileResource(V,N,F){const z=await this.extensionsProfileScannerService.scanProfileExtensions(V);if(!z.length)return[];const $=await Promise.all(z.map(async J=>{if(N(J)){const A=new re(J.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,J.metadata)}return null}));return(0,D.coalesce)($)}async scanOneOrMultipleExtensions(V){try{if(await this.fileService.exists((0,v.joinPath)(V.location,"package.json"))){const N=await this.scanExtension(V);return N?[N]:[]}else return await this.scanExtensions(V)}catch(N){return this.logService.error(`Error scanning extensions at ${V.location.path}:`,(0,L.getErrorMessage)(N)),[]}}async scanExtension(V,N){try{let F=await this.scanExtensionManifest(V.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const z=(0,l.getGalleryExtensionId)(F.publisher,F.name),$=N?.id?{id:z,uuid:N.id}:{id:z},J=N?.isSystem?0:V.type,A=J===0||!!N?.isBuiltin;F=await this.translateManifest(V.location,F,re.createNlsConfiguration(V));const U={type:J,identifier:$,manifest:F,location:V.location,isBuiltin:A,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return V.validate?this.validate(U,V):U}}catch(F){V.type!==0&&this.logService.error(F)}return null}validate(V,N){let F=!0;const z=(0,e.validateExtensionManifest)(N.productVersion,N.productDate,N.location,V.manifest,V.isBuiltin);for(const[$,J]of z)$===m.default.Error&&(F=!1,this.logService.error(this.formatMessage(N.location,J)));return V.isValid=F,V.validations=z,V}async scanExtensionManifest(V){const N=(0,v.joinPath)(V,"package.json");let F;try{F=(await this.fileService.readFile(N)).value.toString()}catch($){return(0,n.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(V,(0,u.localize)(0,null,N.path,$.message))),null}let z;try{z=JSON.parse(F)}catch{const J=[];(0,p.parse)(F,J);for(const A of J)this.logService.error(this.formatMessage(V,(0,u.localize)(1,null,N.path,A.offset,A.length,(0,a.getParseErrorMessage)(A.error))));return null}return(0,p.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(V,(0,u.localize)(2,null,N.path))),null):z}async translateManifest(V,N,F){const z=await this.getLocalizedMessages(V,N,F);if(z)try{const $=[],J=await this.resolveOriginalMessageBundle(z.default,$);if($.length>0)return $.forEach(U=>{this.logService.error(this.formatMessage(V,(0,u.localize)(3,null,z.default?.path,(0,a.getParseErrorMessage)(U.error))))}),N;if((0,p.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(V,(0,u.localize)(4,null,z.default?.path))),N;const A=z.values||Object.create(null);return(0,_.localizeManifest)(N,A,J)}catch{}return N}async getLocalizedMessages(V,N,F){const z=(0,v.joinPath)(V,"package.nls.json"),$=(R,k)=>{k.forEach(M=>{this.logService.error(this.formatMessage(V,(0,u.localize)(5,null,R?.path,(0,a.getParseErrorMessage)(M.error))))})},J=R=>{this.logService.error(this.formatMessage(V,(0,u.localize)(6,null,R?.path)))},A=`${N.publisher}.${N.name}`,U=F.translations[A];if(U)try{const R=c.URI.file(U),k=(await this.fileService.readFile(R)).value.toString(),M=[],j=(0,p.parse)(k,M);return M.length>0?($(R,M),{values:void 0,default:z}):(0,p.getNodeType)(j)!=="object"?(J(R),{values:void 0,default:z}):{values:j.contents?j.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let k;try{k=await this.findMessageBundles(V,F)}catch{return}if(!k.localized)return{values:void 0,default:k.original};try{const M=(await this.fileService.readFile(k.localized)).value.toString(),j=[],q=(0,p.parse)(M,j);return j.length>0?($(k.localized,j),{values:void 0,default:k.original}):(0,p.getNodeType)(q)!=="object"?(J(k.localized),{values:void 0,default:k.original}):{values:q,default:k.original}}catch{return{values:void 0,default:k.original}}}}async resolveOriginalMessageBundle(V,N){if(V)try{const F=(await this.fileService.readFile(V)).value.toString();return(0,p.parse)(F,N)}catch{}}findMessageBundles(V,N){return new Promise((F,z)=>{const $=J=>{const A=(0,v.joinPath)(V,`package.nls.${J}.json`);this.fileService.exists(A).then(U=>{U&&F({localized:A,original:(0,v.joinPath)(V,"package.nls.json")});const R=J.lastIndexOf("-");R===-1?F({localized:(0,v.joinPath)(V,"package.nls.json"),original:null}):(J=J.substring(0,R),$(J))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,v.joinPath)(V,"package.nls.json"),original:null});$(N.language)})}formatMessage(V,N){return`[${V.path}]: ${N}`}};se=ge([ee(1,I.IExtensionsProfileScannerService),ee(2,W.IUriIdentityService),ee(3,n.IFileService),ee(4,r.ILogService)],se);let ne=class extends se{constructor(V,N,F,z,$,J){super(N,F,z,$,J),this.cacheFile=V,this.cacheValidatorThrottler=this._register(new C.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(V){const N=await this.readExtensionCache();if(this.input=V,N&&N.input&&re.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(z=>(z.location=c.URI.revive(z.location),z));const F=await super.scanExtensions(V);return await this.writeExtensionCache({input:V,result:F}),F}async readExtensionCache(){try{const V=await this.fileService.readFile(this.cacheFile),N=JSON.parse(V.value.toString());return{result:N.result,input:(0,E.revive)(N.input)}}catch(V){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(V))}return null}async writeExtensionCache(V){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify(V)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const V=await this.readExtensionCache();if(!V)return;const N=V.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!P.equals(F,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};ne=ge([ee(2,I.IExtensionsProfileScannerService),ee(3,W.IUriIdentityService),ee(4,n.IFileService),ee(5,r.ILogService)],ne);function fe(ie,V){const N=(0,l.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:V,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}i.toExtensionDescription=fe;class le extends X{constructor(V,N,F,z,$,J,A,U,R,k,M){super(V,N,(0,v.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,J,A,U,R,k,M),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const j=await this.fileService.readFile(c.URI.file(h.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(V){return this.translationsPromise}}i.NativeExtensionsScannerService=le}),define(Q[140],Z([0,1,57,3,31,4,2,16,14,20,9,25]),function(B,i,D,C,P,T,L,p,a,d,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let h=class extends L.Disposable{constructor(f,m){super(),this.userDataProfilesService=f,this.logService=m,this.processesLimiter=new C.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),d.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,m){const y=`vscode:${m}`;if(f.location.scheme===p.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const c=f.manifest.scripts[y].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,a.join)(f.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}runLifecycleHook(f,m,y,c,u){return new Promise((g,l)=>{const s=this.start(f,m,y,u);let e;const n=t=>{e&&(clearTimeout(e),e=null),t?l(t):g(void 0)};s.on("error",t=>{n((0,P.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${m} process exited with code ${t}`:void 0)}),c&&(e=setTimeout(()=>{e=null,s.kill(),l("timed out")},5e3))})}start(f,m,y,c){const u={silent:!0,execArgv:void 0},g=(0,D.fork)(f,[`--type=extension-post-${m}`,...y],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const l=T.Event.fromNodeEventEmitter(g.stdout,"data"),s=T.Event.fromNodeEventEmitter(g.stderr,"data");l(t=>this.logService.info(c.identifier.id,c.manifest.version,`post-${m}`,t)),s(t=>this.logService.error(c.identifier.id,c.manifest.version,`post-${m}`,t));const e=T.Event.any(T.Event.map(l,t=>({data:`%c${t}`,format:[""]})),T.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(e,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),g}getExtensionStoragePath(f){return(0,a.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=ge([ee(0,w.IUserDataProfilesService),ee(1,b.ILogService)],h),i.ExtensionsLifecycle=h}),define(Q[141],Z([0,1,10,18,41,48,12,8,9,28,25]),function(B,i,D,C,P,T,L,p,a,d,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let w=class extends T.NativeExtensionsScannerService{constructor(v,f,m,y,c,u,g){super(D.URI.file(c.builtinExtensionsPath),D.URI.file(c.extensionsPath),c.userHome,D.URI.file(c.userDataPath),v,f,m,y,c,u,g)}};w=ge([ee(0,b.IUserDataProfilesService),ee(1,P.IExtensionsProfileScannerService),ee(2,L.IFileService),ee(3,a.ILogService),ee(4,C.INativeEnvironmentService),ee(5,d.IProductService),ee(6,p.IInstantiationService)],w),i.ExtensionsScannerService=w}),define(Q[142],Z([0,1,3,4,2,112,5,79,8,25]),function(B,i,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.isProfileUsingDefaultStorage=i.AbstractStorageService=i.loadKeyTargets=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.TARGET_KEY=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker",i.TARGET_KEY="__$__targetStorageMarker",i.IStorageService=(0,a.createDecorator)("storageService");var b;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(b=i.WillSaveStateReason||(i.WillSaveStateReason={}));var w;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(w=i.StorageScope||(i.StorageScope={}));var h;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(h=i.StorageTarget||(i.StorageTarget={}));function v(u){const g=u.get(i.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}i.loadKeyTargets=v;class f extends P.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,l){if(l===i.TARGET_KEY){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:l,target:this.getKeyTargets(g)[l]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,l,s){return this.getStorage(l)?.get(g,s)}getBoolean(g,l,s){return this.getStorage(l)?.getBoolean(g,s)}getNumber(g,l,s){return this.getStorage(l)?.getNumber(g,s)}store(g,l,s,e){if((0,L.isUndefinedOrNull)(l)){this.remove(g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,s,e),this.getStorage(s)?.set(g,l)})}remove(g,l){this.withPausedEmitters(()=>{this.updateKeyTarget(g,l,void 0),this.getStorage(l)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,l){const s=[],e=this.getKeyTargets(g);for(const n of Object.keys(e))e[n]===l&&s.push(n);return s}updateKeyTarget(g,l,s){const e=this.getKeyTargets(l);typeof s=="number"?e[g]!==s&&(e[g]=s,this.getStorage(l)?.set(i.TARGET_KEY,JSON.stringify(e))):typeof e[g]=="number"&&(delete e[g],this.getStorage(l)?.set(i.TARGET_KEY,JSON.stringify(e)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const l=this.getStorage(g);return l?v(l):Object.create(null)}isNew(g){return this.getBoolean(i.IS_NEW_KEY,g)===!0}async flush(g=b.NONE){this._onWillSaveState.fire({reason:g});const l=this.getStorage(-1),s=this.getStorage(0),e=this.getStorage(1);switch(g){case b.NONE:await D.Promises.settled([l?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await D.Promises.settled([l?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,l=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return c(g,l,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,l){return this.emitWillSaveState(b.NONE),(0,d.isUserDataProfile)(g)?this.switchToProfile(g,l):this.switchToWorkspace(g,l)}canSwitchProfile(g,l){return!(g.id===l.id||m(l)&&m(g))}switchData(g,l,s,e){this.withPausedEmitters(()=>{if(e)for(const[n,t]of g)l.set(n,t);else{const n=new Set;for(const[t,r]of g)n.add(t),l.get(t)!==r&&this.emitDidChangeValue(s,t);for(const[t]of l.items)n.has(t)||this.emitDidChangeValue(s,t)}})}}i.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(u){return u.isDefault||!!u.useDefaultFlags?.uiState}i.isProfileUsingDefaultStorage=m;class y extends f{constructor(){super(),this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(g){return!1}}i.InMemoryStorageService=y;async function c(u,g,l,s,e,n){const t=Y=>{try{return JSON.parse(Y)}catch{return Y}},r=new Map,o=new Map;u.forEach((Y,X)=>{r.set(X,Y),o.set(X,t(Y))});const S=new Map,E=new Map;g.forEach((Y,X)=>{S.set(X,Y),E.set(X,t(Y))});const I=new Map,O=new Map;l.forEach((Y,X)=>{I.set(X,Y),O.set(X,t(Y))}),console.group(s!==e?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const W=[];if(r.forEach((Y,X)=>{W.push({key:X,value:Y})}),console.table(W),console.groupEnd(),console.log(o),s!==e){console.group(`Storage: Profile (path: ${e}, profile specific)`);const Y=[];S.forEach((X,re)=>{Y.push({key:re,value:X})}),console.table(Y),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${n})`);const _=[];I.forEach((Y,X)=>{_.push({key:X,value:Y})}),console.table(_),console.groupEnd(),console.log(O)}i.logStorage=c}),define(Q[143],Z([0,1,19,24,11,13,32,5,10,21,18,22,23,45,12,9,28,47,130,142,35]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c,u,g,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const s=T.isWeb?"web":(0,w.getTargetPlatform)(T.platform,L.arch);var e;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function n(...R){return String(R.reduce((k,M)=>k|M,0))}var t;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class I{constructor(k=E){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,M=this.state.pageSize){return new I({...this.state,pageNumber:k,pageSize:M})}withFilter(k,...M){const j=[...this.state.criteria,...M.length?M.map(q=>({filterType:k,value:q})):[{filterType:k}]];return new I({...this.state,criteria:j})}withSortBy(k){return new I({...this.state,sortBy:k})}withSortOrder(k){return new I({...this.state,sortOrder:k})}withFlags(...k){return new I({...this.state,flags:k.reduce((M,j)=>M|j,0)})}withAssetTypes(...k){return new I({...this.state,assetTypes:k})}withSource(k){return new I({...this.state,source:k})}get raw(){const{criteria:k,pageNumber:M,pageSize:j,sortBy:q,sortOrder:H,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:k,pageNumber:M,pageSize:j,sortBy:q,sortOrder:H}],assetTypes:ce,flags:ae}}get searchText(){const k=this.state.criteria.filter(M=>M.filterType===t.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function O(R,k){const M=(R||[]).filter(j=>j.statisticName===k)[0];return M?M.value:0}function W(R){const k="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(j=>j.assetType.indexOf(k)===0).reduce((j,q)=>{const H=X(R,q.assetType);return H&&j.push([q.assetType.substring(k.length),H]),j},[])}function _(R){if(R.properties){const k=R.properties.filter(q=>q.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=k.filter(q=>M.test(q.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return X(R,r.Repository)}function Y(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function X(R,k){return R.files.filter(j=>j.assetType===k)[0]?{uri:`${R.assetUri}/${k}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${k}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function re(R,k){const M=R.properties?R.properties.filter(q=>q.key===k):[],j=M.length>0&&M[0].value;return j?j.split(",").map(q=>(0,h.adoptToGalleryExtensionId)(q)):[]}function se(R){const k=R.properties?R.properties.filter(M=>M.key===o.Engine):[];return k.length>0&&k[0].value||""}function ne(R){const k=R.properties?R.properties.filter(M=>M.key===o.PreRelease):[];return k.length>0&&k[0].value==="true"}function fe(R){const k=R.properties?R.properties.filter(j=>j.key===o.LocalizedLanguages):[],M=k.length>0&&k[0].value||"";return M?M.split(","):[]}function le(R){return R.properties?.find(k=>k.key===o.SponsorLink)?.value}function ie(R){return R.indexOf("preview")!==-1}function V(R){return R.targetPlatform?(0,w.toTargetPlatform)(R.targetPlatform):"undefined"}function N(R){const k=(0,D.distinct)(R.versions.map(V)),M=!!R.tags?.includes(w.WEB_EXTENSION_TAG),j=k.indexOf("web");return M?j===-1&&k.push("web"):j!==-1&&k.splice(j,1),k}function F(R,k){const M=(0,w.getFallbackTargetPlarforms)(k);for(let j=0;j<R.length;j++){const q=R[j];if(q.version===R[j-1]?.version){let H=j;const ae=V(q);if(ae===k)for(;H>0&&R[H-1].version===q.version;)H--;else if(M.includes(ae))for(;H>0&&R[H-1].version===q.version&&V(R[H-1])!==k;)H--;H!==j&&(R.splice(j,1),R.splice(H,0,q))}}return R}i.sortExtensionVersions=F;function z(R,k,M){R.telemetryData={index:k,querySource:M}}function $(R,k,M){const j=R.versions[0],q={manifest:X(k,r.Manifest),readme:X(k,r.Details),changelog:X(k,r.Changelog),license:X(k,r.License),repository:_(k),download:Y(k),icon:X(k,r.Icon),coreTranslations:W(k)};return{identifier:{id:(0,h.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:k.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(j),description:R.shortDescription||"",installCount:O(R.statistics,"install"),rating:O(R.statistics,"averagerating"),ratingCount:O(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:M,assets:q,properties:{dependencies:re(k,o.Dependency),extensionPack:re(k,o.ExtensionPack),engine:se(k),localizedLanguages:fe(k),targetPlatform:V(k),isPreReleaseVersion:ne(k)},hasPreReleaseVersion:ne(j),hasReleaseVersion:!0,preview:ie(R.flags)}}let J=class{constructor(k,M,j,q,H,ae,ce,pe){this.requestService=M,this.logService=j,this.environmentService=q,this.telemetryService=H,this.fileService=ae,this.productService=ce,this.configurationService=pe;const Se=ce.extensionsGallery;this.extensionsGalleryUrl=Se&&Se.serviceUrl,this.extensionsControlUrl=Se&&Se.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,k,this.telemetryService)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,M,j){const q=C.CancellationToken.isCancellationToken(M)?{}:M,H=C.CancellationToken.isCancellationToken(M)?M:j,ae=[],ce=[],pe=[],Se=[];let te=!0;for(const he of k){he.uuid?ce.push(he.uuid):ae.push(he.id);const ve=!!(he.version||he.preRelease);pe.push({id:he.id,uuid:he.uuid,includePreRelease:ve}),he.version&&Se.push({id:he.id,uuid:he.uuid,version:he.version}),te=te&&!!he.hasPreRelease&&!ve}if(!ce.length&&!ae.length)return[];let oe=new I().withPage(1,k.length);ce.length&&(oe=oe.withFilter(t.ExtensionId,...ce)),ae.length&&(oe=oe.withFilter(t.ExtensionName,...ae)),(q.queryAllVersions||te)&&(oe=oe.withFlags(oe.flags,e.IncludeVersions)),q.source&&(oe=oe.withSource(q.source));const{extensions:de}=await this.queryGalleryExtensions(oe,{targetPlatform:q.targetPlatform??s,includePreRelease:pe,versions:Se,compatible:!!q.compatible},H);return q.source&&de.forEach((he,ve)=>z(he,ve,q.source)),de}async getCompatibleExtension(k,M,j){if((0,w.isNotWebExtensionInWebTargetPlatform)(k.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(k,M,j))return k;const q=new I().withFlags(e.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,k.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(q,{targetPlatform:j,compatible:!0,includePreRelease:M},C.CancellationToken.None);return H[0]||null}async isExtensionCompatible(k,M,j){if(!(0,w.isTargetPlatformCompatible)(k.properties.targetPlatform,k.allTargetPlatforms,j)||!M&&k.properties.isPreReleaseVersion)return!1;let q=k.properties.engine;if(!q){const H=await this.getManifest(k,C.CancellationToken.None);if(!H)throw new Error("Manifest was not found");q=H.engines.vscode}return(0,v.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(k,M,j,q,H){if(!(0,w.isTargetPlatformCompatible)(V(k),q,H)||M!=="any"&&ne(k)!==(M==="prerelease"))return!1;if(j)try{const ae=await this.getEngine(k);if(!(0,v.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${k.version}.`,(0,P.getErrorMessage)(ae)),!1}return!0}async query(k,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=k.text||"";const q=k.pageSize??50;let H=new I().withPage(1,q);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(H=H.withFilter(t.Category,de||oe),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,oe,de)=>(H=H.withFilter(t.Tag,de||oe),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),H=H.withFilter(t.SearchText,j)),H=H.withSortBy(0)):k.ids?H=H.withFilter(t.ExtensionId,...k.ids):k.names?H=H.withFilter(t.ExtensionName,...k.names):H=H.withSortBy(4),typeof k.sortBy=="number"&&(H=H.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(H=H.withSortOrder(k.sortOrder)),k.source&&(H=H.withSource(k.source));const ae=async(te,oe)=>{const{extensions:de,total:he}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!k.includePreRelease},oe);return de.forEach((ve,Te)=>z(ve,(te.pageNumber-1)*te.pageSize+Te,k.source)),{extensions:de,total:he}},{extensions:ce,total:pe}=await ae(H,M),Se=async(te,oe)=>{if(oe.isCancellationRequested)throw new P.CancellationError;const{extensions:de}=await ae(H.withPage(te+1),oe);return de};return{firstPage:ce,total:pe,pageSize:H.pageSize,getPage:Se}}async queryGalleryExtensions(k,M,j){const q=k.flags;!!(k.flags&e.IncludeLatestVersionOnly)&&!!(k.flags&e.IncludeVersions)&&(k=k.withFlags(k.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(k.flags&e.IncludeLatestVersionOnly)&&!(k.flags&e.IncludeVersions)&&(k=k.withFlags(k.flags,e.IncludeLatestVersionOnly)),M.versions?.length&&(k=k.withFlags(k.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),k=k.withFlags(k.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:H,total:ae}=await this.queryRawGalleryExtensions(k,j);if(!(k.flags&e.IncludeLatestVersionOnly)){const te=[];for(const oe of H){const de=await this.toGalleryExtensionWithCriteria(oe,M);de&&te.push(de)}return{extensions:te,total:ae}}const pe=[],Se=new Map;for(let te=0;te<H.length;te++){const oe=H[te],de={id:(0,h.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName),uuid:oe.extensionId},he=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Te=>(0,h.areSameExtensions)(Te,de))?.includePreRelease;if(M.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(N(oe),M.targetPlatform))continue;const ve=await this.toGalleryExtensionWithCriteria(oe,M);!ve||ve.properties.isPreReleaseVersion&&(!he||!ve.hasReleaseVersion)||!ve.properties.isPreReleaseVersion&&ve.properties.targetPlatform!==M.targetPlatform&&ve.hasPreReleaseVersion?Se.set(oe.extensionId,te):pe.push([te,ve])}if(Se.size){const te=new Date().getTime(),oe=new I().withFlags(q&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,Se.size).withFilter(t.ExtensionId,...Se.keys()),{extensions:de}=await this.queryGalleryExtensions(oe,M,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:Se.size});for(const he of de){const ve=Se.get(he.identifier.uuid);pe.push([ve,he])}}return{extensions:pe.sort((te,oe)=>te[0]-oe[0]).map(([,te])=>te),total:ae}}async toGalleryExtensionWithCriteria(k,M){const j={id:(0,h.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},q=M.versions?.find(pe=>(0,h.areSameExtensions)(pe,j))?.version,H=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(pe=>(0,h.areSameExtensions)(pe,j))?.includePreRelease,ae=N(k),ce=F(k.versions,M.targetPlatform);if(M.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(ae,M.targetPlatform))return null;for(let pe=0;pe<ce.length;pe++){const Se=ce[pe];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,H?"any":"release",M.compatible,ae,M.targetPlatform))return $(k,Se,ae);if(q&&Se.version===q)return null}}return q||M.compatible?null:$(k,k.versions[0],ae)}async queryRawGalleryExtensions(k,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,e.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(e.Unpublished));const j=await this.commonHeadersPromise,q=JSON.stringify(k.raw),H={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ae=new Date().getTime();let ce,pe,Se=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:q,headers:H},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:Se};const te=await(0,c.asJson)(ce);if(te){const oe=te.results[0],de=oe.extensions,he=oe.resultMetadata&&oe.resultMetadata.filter(ve=>ve.metadataType==="ResultCount")[0];return Se=he&&he.metadataItems.filter(ve=>ve.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:Se}}return{galleryExtensions:[],total:Se}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...k.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-ae,success:!!ce&&(0,c.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:pe?(0,P.isCancellationError)(pe)?"canceled":(0,P.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(k,M,j,q){if(!this.isEnabled())return;const H=T.isWeb?this.api(`/itemName/${k}.${M}/version/${j}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${k}/extensions/${M}/${j}/stats?statType=${q}`),ae=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:H,headers:pe},C.CancellationToken.None)}catch{}}async download(k,M,j){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const q=(0,h.getGalleryExtensionTelemetryData)(k),H=new Date().getTime(),ae=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:te}),ce=j===2?"install":j===3?"update":"",pe=ce?{uri:`${k.assets.download.uri}${a.URI.parse(k.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${k.assets.download.fallbackUri}${a.URI.parse(k.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:k.assets.download,Se=await this.getAsset(pe);await this.fileService.writeFile(M,Se.stream),ae(new Date().getTime()-H)}async getReadme(k,M){if(k.assets.readme){const j=await this.getAsset(k.assets.readme,{},M);return await(0,c.asTextOrError)(j)||""}return""}async getManifest(k,M){if(k.assets.manifest){const j=await this.getAsset(k.assets.manifest,{},M),q=await(0,c.asTextOrError)(j);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(k,M){const j=X(k,r.Manifest);if(!j)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},H=await this.getAsset(j,{headers:q});return await(0,c.asJson)(H)}async getCoreTranslation(k,M){const j=k.assets.coreTranslations.filter(q=>q[0]===M.toUpperCase())[0];if(j){const q=await this.getAsset(j[1]),H=await(0,c.asTextOrError)(q);return H?JSON.parse(H):null}return null}async getChangelog(k,M){if(k.assets.changelog){const j=await this.getAsset(k.assets.changelog,{},M);return await(0,c.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(k,M,j){let q=new I().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);k.identifier.uuid?q=q.withFilter(t.ExtensionId,k.identifier.uuid):q=q.withFilter(t.ExtensionName,k.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(q,C.CancellationToken.None);if(!H.length)return[];const ae=N(H[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(ae,j))return[];const ce=[];await Promise.all(H[0].versions.map(async te=>{try{await this.isValidVersion(te,M?"any":"release",!0,ae,j)&&ce.push(te)}catch{}}));const pe=[],Se=new Set;for(const te of F(ce,j))Se.has(te.version)||(Se.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:ne(te)}));return pe}async getAsset(k,M={},j=C.CancellationToken.None){const q=await this.commonHeadersPromise,H={type:"GET"},ae={...q,...M.headers||{}};M={...M,...H,headers:ae};const ce=k.uri,pe=k.fallbackUri,Se={...M,url:ce};try{const te=await this.requestService.request(Se,j);if(te.res.statusCode===200)return te;const oe=await(0,c.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${oe}`)}catch(te){if((0,P.isCancellationError)(te))throw te;const oe=(0,P.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:oe});const de={...M,url:pe};return this.requestService.request(de,j)}}async getEngine(k){let M=se(k);if(!M){const j=await this.getManifestFromRawExtensionVersion(k,C.CancellationToken.None);if(!j)throw new Error("Manifest was not found");M=j.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.asJson)(k),j=[],q={};if(M){for(const H of M.malicious)j.push({id:H});if(M.migrateToPreRelease)for(const[H,ae]of Object.entries(M.migrateToPreRelease))(!ae.engine||(0,v.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(q[H.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[H,ae]of Object.entries(M.deprecated))ae&&(q[H.toLowerCase()]=(0,p.isBoolean)(ae)?{}:ae)}return{malicious:j,deprecated:q}}};J=ge([ee(1,c.IRequestService),ee(2,m.ILogService),ee(3,b.IEnvironmentService),ee(4,l.ITelemetryService),ee(5,f.IFileService),ee(6,y.IProductService),ee(7,d.IConfigurationService)],J);let A=class extends J{constructor(k,M,j,q,H,ae,ce,pe){super(k,M,j,q,H,ae,ce,pe)}};A=ge([ee(0,g.IStorageService),ee(1,c.IRequestService),ee(2,m.ILogService),ee(3,b.IEnvironmentService),ee(4,l.ITelemetryService),ee(5,f.IFileService),ee(6,y.IProductService),ee(7,d.IConfigurationService)],A),i.ExtensionGalleryService=A;let U=class extends J{constructor(k,M,j,q,H,ae,ce){super(void 0,k,M,j,q,H,ae,ce)}};U=ge([ee(0,c.IRequestService),ee(1,m.ILogService),ee(2,b.IEnvironmentService),ee(3,l.ITelemetryService),ee(4,f.IFileService),ee(5,y.IProductService),ee(6,d.IConfigurationService)],U),i.ExtensionGalleryServiceWithNoStorageService=U}),define(Q[144],Z([0,1,44,18,12,9,65,29,25]),function(B,i,D,C,P,T,L,p,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=void 0;let d=class Ve extends a.UserDataProfilesService{constructor(w,h,v,f,m){super(v,f,h,m),this.stateService=w}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(Ve.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(Ve.PROFILE_ASSOCIATIONS_KEY,{}))}};d=ge([ee(0,L.IStateService),ee(1,p.IUriIdentityService),ee(2,C.IEnvironmentService),ee(3,P.IFileService),ee(4,T.ILogService)],d),i.UserDataProfilesService=d}),define(Q[145],Z([0,1,37,3,157,2]),function(B,i,D,C,P,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class L extends D.AbstractPolicyService{constructor(a){super(),this.productName=a,this.throttler=new C.Throttler,this.watcher=this._register(new T.MutableDisposable)}async initializePolicies(a){await this.throttler.queue(()=>new Promise((d,b)=>{try{this.watcher.value=(0,P.createWatcher)(this.productName,a,w=>{for(const h in w){const v=w[h];v===void 0?this.policies.delete(h):this.policies.set(h,v)}this._onDidChange.fire(Object.keys(w)),d()})}catch(w){b(w)}}))}}i.NativePolicyService=L}),define(Q[67],Z([0,1,114,3,14,5,20,80,158,159]),function(B,i,D,C,P,T,L,p,a,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class b extends Error{constructor(e,n){let t=n.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=e,this.cause=n}}i.ExtractError=b;function w(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,t)=>n+t,e&61440)}function h(s){if(s instanceof b)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new b(e,s)}function v(s,e,n,t,r,o){const S=P.dirname(e),E=P.join(t,S);if(!E.startsWith(t))return Promise.reject(new Error(p.localize(0,null,e)));const I=P.join(t,e);let O;return o.onCancellationRequested(()=>{O?.destroy()}),Promise.resolve(L.Promises.mkdir(E,{recursive:!0})).then(()=>new Promise((W,_)=>{if(!o.isCancellationRequested)try{O=(0,D.createWriteStream)(I,{mode:n}),O.once("close",()=>W()),O.once("error",_),s.once("error",_),s.pipe(O)}catch(Y){_(Y)}}))}function f(s,e,n,t){let r=(0,C.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((S,E)=>{const I=new C.Sequencer,O=W=>{W.isCancellationRequested||(o++,s.readEntry())};s.once("error",E),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?S():E(new b("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},E)),s.readEntry(),s.on("entry",W=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(W.fileName)){O(t);return}const _=W.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(_)){const re=P.join(e,_);r=(0,C.createCancelablePromise)(se=>L.Promises.mkdir(re,{recursive:!0}).then(()=>O(se)).then(void 0,E));return}const Y=y(s,W),X=w(W);r=(0,C.createCancelablePromise)(re=>I.queue(()=>Y.then(se=>v(se,_,X,e,n,re).then(()=>O(re)))).then(null,E))})})}function m(s,e=!1){return new Promise((n,t)=>{(0,a.open)(s,e?{lazyEntries:!0}:void 0,(r,o)=>{r?t(h(r)):n((0,T.assertIsDefined)(o))})})}function y(s,e){return new Promise((n,t)=>{s.openReadStream(e,(r,o)=>{r?t(h(r)):n((0,T.assertIsDefined)(o))})})}function c(s,e){return new Promise((n,t)=>{const r=new d.ZipFile;e.forEach(S=>{S.contents?r.addBuffer(typeof S.contents=="string"?Buffer.from(S.contents,"utf8"):S.contents,S.path):S.localPath&&r.addFile(S.localPath,S.path)}),r.end();const o=(0,D.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}i.zip=c;function u(s,e,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=m(s,!0);return n.overwrite&&(o=o.then(S=>L.Promises.rm(e).then(()=>S))),o.then(S=>f(S,e,{sourcePathRegex:r},t))}i.extract=u;function g(s,e){return m(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===e&&y(n,o).then(S=>t(S),S=>r(S))}),n.once("close",()=>r(new Error(p.localize(2,null,e))))}))}function l(s,e){return g(s,e).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",S=>o.push(S)),n.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=l}),define(Q[146],Z([0,1,67,88]),function(B,i,D,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function P(T){return(0,D.buffer)(T,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}i.getManifest=P}),define(Q[147],Z([0,1,3,31,11,2,16,14,13,17,39,5,10,30,20,67,87,58,18,139,22,23,41,48,122,140,146,123,136,34,45,12,8,9,28,35,29,25]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c,u,g,l,s,e,n,t,r,o,S,E,I,O,W,_,Y,X,re,se,ne){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=i.INativeServerExtensionManagementService=void 0,i.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(l.IExtensionManagementService);let fe=class extends g.AbstractExtensionManagementService{constructor(A,U,R,k,M,j,q,H,ae,ce,pe,Se){super(A,U,R,ce,Se),this.extensionsScannerService=M,this.extensionsProfileScannerService=j,this.downloadService=q,this.fileService=ae,this.installGalleryExtensionsTasks=new Map;const te=this._register(H.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(le,de=>te.postUninstall(de))),this.manifestCache=this._register(new S.ExtensionsManifestCache(k,this)),this.extensionsDownloader=this._register(H.createInstance(t.ExtensionsDownloader));const oe=this._register(new E.ExtensionsWatcher(this,ae,k,R,pe));this._register(oe.onDidChangeExtensionsByAnotherSource(({added:de,removed:he})=>{de.length&&this._onDidInstallExtensions.fire(de.map(ve=>({identifier:ve.identifier,operation:1,local:ve}))),he.forEach(ve=>this._onDidUninstallExtension.fire({identifier:ve}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const U=await this.collectFiles(A),R=await(0,m.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,U);return h.URI.file(R)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:U,cleanup:R}=await this.downloadVsix(A),k=p.resolve(U.fsPath);try{return await(0,o.getManifest)(k)}finally{await R()}}getInstalled(A,U){return this.extensionsScanner.scanExtensions(A??null,U)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,U={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:R,cleanup:k}=await this.downloadVsix(A);try{const M=await(0,o.getManifest)(p.resolve(R.fsPath));if(M.engines&&M.engines.vscode&&!(0,O.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,s.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return await this.installExtension(M,R,U)}finally{await k()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,U){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const R={...U};return U.isPreReleaseVersion&&(R.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,R),this.manifestCache.invalidate(),A}async updateExtensionScope(A,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:U}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===L.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const U=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(A,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(k){this.logService.error(k)}}}}doCreateInstallExtensionTask(A,U,R){let k;if(h.URI.isUri(U))k=new N(A,U,R,this.galleryService,this.extensionsScanner,this.logService);else{const M=s.ExtensionKey.create(U).toString();k=this.installGalleryExtensionsTasks.get(M),k||(this.installGalleryExtensionsTasks.set(M,k=new V(A,U,R,this.extensionsDownloader,this.extensionsScanner,this.logService)),k.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(M)))}return R.profileLocation?new F(k,R.profileLocation,this.extensionsProfileScannerService):k}doCreateUninstallExtensionTask(A,U){return U.profileLocation?new $(A,U.profileLocation,this.extensionsProfileScannerService):new z(A,U,this.extensionsScanner)}async collectFiles(A){const U=async k=>{let M=await f.Promises.readdir(k);M=M.map(H=>p.join(k,H));const j=await Promise.all(M.map(H=>f.Promises.stat(H)));let q=Promise.resolve([]);return j.forEach((H,ae)=>{const ce=M[ae];H.isFile()&&(q=q.then(pe=>[...pe,ce])),H.isDirectory()&&(q=q.then(pe=>U(ce).then(Se=>[...pe,...Se])))}),q};return(await U(A.location.fsPath)).map(k=>({path:`extension/${p.relative(A.location.fsPath,k)}`,localPath:k}))}};fe=ge([ee(0,l.IExtensionGalleryService),ee(1,re.ITelemetryService),ee(2,Y.ILogService),ee(3,u.INativeEnvironmentService),ee(4,n.IExtensionsScannerService),ee(5,e.IExtensionsProfileScannerService),ee(6,c.IDownloadService),ee(7,_.IInstantiationService),ee(8,W.IFileService),ee(9,X.IProductService),ee(10,se.IUriIdentityService),ee(11,ne.IUserDataProfilesService)],fe),i.ExtensionManagementService=fe;let le=class extends T.Disposable{constructor(A,U,R,k){super(),this.beforeRemovingExtension=A,this.fileService=U,this.extensionsScannerService=R,this.logService=k,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,U){const R={includeInvalid:!0,profileLocation:U};let k=[];return A===null||A===0?k.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},R,!1)):A===1&&k.push(...await this.extensionsScannerService.scanUserExtensions(R)),k=A!==null?k.filter(M=>M.type===A):k,Promise.all(k.map(M=>this.toLocalExtension(M)))}async scanUserExtensions(A){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(U.map(R=>this.toLocalExtension(R)))}async extractUserExtension(A,U,R,k){const M=A.toString(),j=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),q=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M);try{await f.Promises.rm(q)}catch{throw new l.ExtensionManagementError(y.localize(1,null,q,A.id),l.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,U,j,k),R={...R,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(h.URI.file(j),R);try{await this.rename(A,j,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(H){try{await f.Promises.rm(j)}catch{}if(H.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(H)}. Deleted from extracted location`,j),H}return this.scanLocalExtension(h.URI.file(q),1)}async updateMetadata(A,U){return await this.extensionsScannerService.updateMetadata(A.location,U),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(R=>s.ExtensionKey.create(R));await this.withUninstalledExtensions(R=>{U.forEach(k=>R[k.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(k=>delete k[A.toString()]);const R=(await this.scanUserExtensions(!0)).find(k=>s.ExtensionKey.create(k).equals(A))||null;return R?this.updateMetadata(R,{installedTimestamp:Date.now()}):null}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await f.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(k){if(k.code!=="ENOENT")throw k}let R={};if(U)try{R=JSON.parse(U)}catch{}return A&&(A(R),Object.keys(R).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(R)):await f.Promises.rm(this.uninstalledPath)),R})}async extractAtLocation(A,U,R,k){this.logService.trace(`Started extracting the extension from ${U} to ${R}`);try{await f.Promises.rm(R)}catch(M){throw new l.ExtensionManagementError(this.joinErrors(M).message,l.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(U,R,{sourcePath:"extension",overwrite:!0},k),this.logService.info(`Extracted extension to ${R}:`,A.id)}catch(M){try{await f.Promises.rm(R)}catch{}let j=l.ExtensionManagementErrorCode.Extract;throw M instanceof m.ExtractError&&(M.type==="CorruptZip"?j=l.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(j=l.ExtensionManagementErrorCode.IncompleteZip)),new l.ExtensionManagementError(M.message,j)}}async rename(A,U,R,k){try{await f.Promises.rename(U,R)}catch(M){if(a.isWindows&&M&&M.code==="EPERM"&&Date.now()<k)return this.logService.info(`Failed renaming ${U} to ${R} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,R,k);throw new l.ExtensionManagementError(M.message||y.localize(2,null,U,R),M.code||l.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,U){const R=await this.extensionsScannerService.scanExistingExtension(A,U,{includeInvalid:!0});if(R)return this.toLocalExtension(R);throw new Error(y.localize(3,null,A.path))}async toLocalExtension(A){const U=await this.fileService.resolve(A.location);let R,k;return U.children&&(R=U.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,k=U.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:R,changelogUrl:k,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const j of U)A[s.ExtensionKey.create(j).toString()]||R.add(j.identifier.id.toLowerCase());const k=(0,s.groupByExtension)(U,j=>j.identifier);await D.Promises.settled(k.map(async j=>{const q=j.sort((H,ae)=>b.rcompare(H.manifest.version,ae.manifest.version))[0];R.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}));const M=U.filter(j=>A[s.ExtensionKey.create(j).toString()]);await D.Promises.settled(M.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=[],k=await this.extensionsScannerService.getTargetPlatform(),M=(0,s.groupByExtension)(U,j=>j.identifier);for(const j of M)if(j.length>1&&R.push(...j.sort((q,H)=>{const ae=b.rcompare(q.manifest.version,H.manifest.version);return ae!==0?ae:q.targetPlatform===k?-1:1}).slice(1)),j[0].type===0){const q=A.find(H=>(0,s.areSameExtensions)(H.identifier,j[0].identifier));(!q||b.gte(q.manifest.version,j[0].manifest.version))&&R.push(j[0])}await D.Promises.settled(R.map(j=>this.removeExtension(j,"outdated")))}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((R,k)=>new Error(`${R.message}${R.message?",":""}${k instanceof Error?k.message:k}`),new Error(""))}};le=ge([ee(1,W.IFileService),ee(2,n.IExtensionsScannerService),ee(3,Y.ILogService)],le);class ie extends g.AbstractExtensionTask{constructor(A,U,R,k,M){super(),this.identifier=A,this.source=U,this.options=R,this.extensionsScanner=k,this.logService=M,this._operation=2}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(A,U){try{const R=await this.unsetUninstalledAndGetLocal(A.key);if(R)return A.metadata?this.extensionsScanner.updateMetadata(R,A.metadata):R}catch{throw a.isMacintosh?new l.ExtensionManagementError(y.localize(4,null),l.ExtensionManagementErrorCode.Internal):new l.ExtensionManagementError(y.localize(5,null),l.ExtensionManagementErrorCode.Internal)}return this.extract(A,U)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const R=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),R}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:U,metadata:R},k){const M=await this.extensionsScanner.extractUserExtension(U,A,R,k);return this.logService.info("Extracting completed.",U.id),M}}class V extends ie{constructor(A,U,R,k,M,j){super(U.identifier,U,R,M,j),this.manifest=A,this.gallery=U,this.extensionsDownloader=k}async doRun(A){const R=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,s.areSameExtensions)(j.identifier,this.gallery.identifier));R&&(this._operation=3);const k={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,I.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(R,k),metadata:k};const M=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:M,key:s.ExtensionKey.create(this.gallery),metadata:k},A);return R&&!this.options.profileLocation&&(R.targetPlatform!==j.targetPlatform||b.neq(R.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(R),{local:j,metadata:k}}catch(j){throw await this.deleteDownloadedVSIX(M),j}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(h.URI.file(A))}catch(U){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,P.getErrorMessage)(U))}}async downloadExtension(A,U){let R;try{this.logService.trace("Started downloading extension:",A.identifier.id),R=(await this.extensionsDownloader.downloadExtension(A,U)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,R)}catch(k){throw new l.ExtensionManagementError((0,g.joinErrors)(k).message,l.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(R),R}catch(k){throw await this.deleteDownloadedVSIX(R),new l.ExtensionManagementError((0,g.joinErrors)(k).message,l.ExtensionManagementErrorCode.Invalid)}}}class N extends ie{constructor(A,U,R,k,M,j){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},U,R,M,j),this.manifest=A,this.location=U,this.galleryService=k}async doRun(A){const U=new s.ExtensionKey(this.identifier,this.manifest.version),k=(await this.extensionsScanner.scanExtensions(1,void 0)).find(q=>(0,s.areSameExtensions)(this.identifier,q.identifier)),M=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(M.isApplicationScoped=(0,I.isApplicationScopedExtension)(this.manifest),M.isMachineScoped=this.options.isMachineScoped||k?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||k?.isBuiltin,k)if(this._operation=3,U.equals(new s.ExtensionKey(k.identifier,k.manifest.version)))try{await this.extensionsScanner.removeExtension(k,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&b.gt(k.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(k);else{const q=await this.unsetUninstalledAndGetLocal(U);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:U,metadata:M},A),metadata:M}}async getMetadata(A,U,R){try{let[k]=await this.galleryService.getExtensions([{id:A,version:U}],R);if(k||([k]=await this.galleryService.getExtensions([{id:A}],R)),k)return{id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,U,R){this.task=A,this.profileLocation=U,this.extensionsProfileScannerService=R,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class z extends g.AbstractExtensionTask{constructor(A,U,R){super(),this.extension=A,this.options=U,this.extensionsScanner=R}async doRun(A){const U=[],R=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const k=s.ExtensionKey.create(this.extension);U.push(...R.filter(M=>k.equals(s.ExtensionKey.create(M))))}else U.push(...R.filter(k=>(0,s.areSameExtensions)(k.identifier,this.extension.identifier)));if(!U.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...U),this.options.remove)for(const k of U)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(k)}catch(M){throw new Error(y.localize(9,null,(0,C.toErrorMessage)(M)))}}}class $ extends g.AbstractExtensionTask{constructor(A,U,R){super(),this.extension=A,this.profileLocation=U,this.extensionsProfileScannerService=R}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[148],Z([0,1,127,3,15,11,2,5,21,18,128,9,126,160]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let f=class extends L.Disposable{constructor(y,c,u){super(),this.environmentService=c,this.logService=u,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,c){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:u,strictSSL:g}=this;let l;try{l=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...l},e=y.agent?y.agent:await(0,h.getProxyAgent)(y.url||"",s,{proxyUrl:u,strictSSL:g});y.agent=e,y.strictSSL=g,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(y,c);return this.logService.trace("RequestService#request (node) - success",y.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",y.url,n),n}}async getNodeRequest(y){return((0,D.parse)(y.url).protocol==="https:"?await new Promise((g,l)=>{B(["https"],g,l)}):await new Promise((g,l)=>{B(["http"],g,l)})).request}_request(y,c){return C.Promises.withAsyncBody(async(u,g)=>{const l=(0,D.parse)(y.url),s=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),e={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,p.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(e.auth=y.user+":"+y.password);const n=s(e,t=>{const r=(0,p.isNumber)(y.followRedirects)?y.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this._request({...y,url:t.headers.location,followRedirects:r-1},c).then(u,g);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,v.createGunzip)())),u({res:t,stream:(0,P.streamToBufferReadableStream)(o)})}});n.on("error",g),y.timeout&&n.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&n.write(y.data),n.end(),c.onCancellationRequested(()=>{n.abort(),g(new T.CancellationError)})})}async resolveProxy(y){}};f=ge([ee(0,a.IConfigurationService),ee(1,d.INativeEnvironmentService),ee(2,w.ILogService)],f),i.RequestService=f}),define(Q[161],Z([0,1,38,3,15,31,11,2,16,14,13,32,10,20,21,119,58,125,18,101,143,22,121,41,48,147,141,12,111,113,46,109,61,62,124,9,115,116,37,145,133,28,47,148,65,129,66,35,132,42,134,135,29,137,25,144]),function(B,i,D,C,P,T,L,p,a,d,b,w,h,v,f,m,y,c,u,g,l,s,e,n,t,r,o,S,E,I,O,W,_,Y,X,re,se,ne,fe,le,ie,V,N,F,z,$,J,A,U,R,k,M,j,q,H,ae){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class ce extends p.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,oe]=await this.initServices();return te.invokeFunction(async de=>{const he=de.get(re.ILogService),ve=de.get(S.IFileService),Te=de.get(u.INativeEnvironmentService),Fe=de.get(H.IUserDataProfilesService);he.info("CLI main",this.argv),this.registerErrorHandler(he),await this.doRun(Te,ve,Fe,te),await Promise.all(oe.map(Ue=>{(0,C.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new _.ServiceCollection,oe={_serviceBrand:void 0,...ie.default};te.set(V.IProductService,oe);const de=new g.NativeEnvironmentService(this.argv,oe);te.set(u.INativeEnvironmentService,de),await Promise.all([de.appSettingsHome.fsPath,de.extensionsPath].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0));const he=(0,re.getLogLevel)(de),ve=[];ve.push(new se.SpdLogLogger("cli",(0,d.join)(de.logsPath,"cli.log"),!0,!1,he)),he===re.LogLevel.Trace&&ve.push(new re.ConsoleLogger(he));const Te=this._register(new re.MultiplexLogService(ve));te.set(re.ILogService,Te);const Fe=this._register(new E.FileService(Te));te.set(S.IFileService,Fe);const Ue=this._register(new I.DiskFileSystemProvider(Te));Fe.registerProvider(a.Schemas.file,Ue);const xe=new $.StateService(de,Te,Fe);te.set(z.IStateService,xe);const x=new q.UriIdentityService(Fe);te.set(j.IUriIdentityService,x);const G=new ae.UserDataProfilesService(xe,x,de,Fe,Te);te.set(H.IUserDataProfilesService,G);const K=b.isWindows&&oe.win32RegValueName?this._register(new le.NativePolicyService(oe.win32RegValueName)):de.policyFile?this._register(new ne.FilePolicyService(de.policyFile,Fe,Te)):new fe.NullPolicyService;te.set(fe.IPolicyService,K);const ue=this._register(new m.ConfigurationService(G.defaultProfile.settingsResource,Fe,K,Te));te.set(f.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),G.setEnablement(oe.quality!=="stable"||ue.getValue(H.PROFILES_ENABLEMENT_CONFIG)),te.set(j.IUriIdentityService,new q.UriIdentityService(Fe)),te.set(N.IRequestService,new O.SyncDescriptor(F.RequestService,void 0,!0)),te.set(y.IDownloadService,new O.SyncDescriptor(c.DownloadService,void 0,!0)),te.set(n.IExtensionsProfileScannerService,new O.SyncDescriptor(n.ExtensionsProfileScannerService,void 0,!0)),te.set(t.IExtensionsScannerService,new O.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),te.set(r.INativeServerExtensionManagementService,new O.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new O.SyncDescriptor(l.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(Y.ILanguagePackService,new O.SyncDescriptor(X.NativeLanguagePackService,void 0,!1));const me=[],Ce=(0,R.isInternalTelemetry)(oe,ue);if((0,R.supportsTelemetry)(oe,de)){oe.aiConfig&&oe.aiConfig.ariaKey&&me.push(new k.OneDataSystemAppender(Ce,"monacoworkbench",null,oe.aiConfig.ariaKey));const{installSourcePath:we}=de,Le={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const De=await v.Promises.readFile(de.stateResource.fsPath);be=JSON.parse(De.toString())[A.machineIdKey]}catch(De){De.code!=="ENOENT"&&Te.error(De)}return(0,J.resolveCommonProperties)(Fe,(0,D.release)(),(0,D.hostname)(),process.arch,oe.commit,oe.version,be,Ce,we)})(),piiPaths:(0,R.getPiiPathsFromEnvironment)(de)};te.set(A.ITelemetryService,new O.SyncDescriptor(U.TelemetryService,[Le],!1))}else te.set(A.ITelemetryService,R.NullTelemetryService);return[new W.InstantiationService(te),me]}registerErrorHandler(te){(0,L.setUnexpectedErrorHandler)(oe=>{const de=(0,T.toErrorMessage)(oe,!0);!de||te.error(`[uncaught exception in CLI]: ${de}`)}),process.on("uncaughtException",oe=>(0,L.onUnexpectedError)(oe)),process.on("unhandledRejection",oe=>(0,L.onUnexpectedError)(oe))}async doRun(te,oe,de,he){const ve=te.args.profile?de.profiles.find(Te=>Te.name===te.args.profile)?.extensionsResource:de.defaultProfile.extensionsResource;if(this.argv["install-source"])return this.setInstallSource(te,oe,this.argv["install-source"]);if(this.argv["list-extensions"])return he.createInstance(e.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,ve);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Te={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:ve};return he.createInstance(e.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],Te,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return he.createInstance(e.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,ve);if(this.argv["locate-extension"])return he.createInstance(e.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(oe=>/\.vsix$/i.test(oe)?h.URI.file((0,d.isAbsolute)(oe)?oe:(0,d.join)((0,w.cwd)(),oe)):oe)}async setInstallSource(te,oe,de){await oe.writeFile(h.URI.file(te.installSourcePath),P.VSBuffer.fromString(de.slice(0,30)))}}async function pe(Se){const te=new ce(Se);try{await te.run()}finally{te.dispose()}}i.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b3546b4bb5aff5254ef857cfd68a3da8534c068f/core/vs/code/node/cliProcessMain.js.map
