/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ne){for(var e=[],r=0,y=ne.length;r<y;r++)e[r]=Ce[ne[r]];return e};define(Ce[72],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function r(_,A){const E=Object.create(null);for(const k of _){const O=A(k);let b=E[O];b||(b=E[O]=[]),b.push(k)}return E}e.groupBy=r;function y(_,A){const E=[],k=[];for(const O of _)A.has(O)||E.push(O);for(const O of A)_.has(O)||k.push(O);return{removed:E,added:k}}e.diffSets=y;function S(_,A){const E=[],k=[];for(const[O,b]of _)A.has(O)||E.push(b);for(const[O,b]of A)_.has(O)||k.push(b);return{removed:E,added:k}}e.diffMaps=S;class M{constructor(){this.map=new Map}add(A,E){let k=this.map.get(A);k||(k=new Set,this.map.set(A,k)),k.add(E)}delete(A,E){const k=this.map.get(A);!k||(k.delete(E),k.size===0&&this.map.delete(A))}forEach(A,E){const k=this.map.get(A);!k||k.forEach(E)}}e.SetMap=M}),define(Ce[55],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(_){return(A,E,k)=>{let O=null,b=null;if(typeof k.value=="function"?(O="value",b=k.value):typeof k.get=="function"&&(O="get",b=k.get),!b)throw new Error("not supported");k[O]=_(b,E)}}e.createDecorator=r;function y(_,A,E){let k=null,O=null;if(typeof E.value=="function"?(k="value",O=E.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",O=E.get),!O)throw new Error("not supported");const b=`$memoize$${A}`;E[k]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,m)}),this[b]}}e.memoize=y;function S(_,A,E){return r((k,O)=>{const b=`$debounce$${O}`,m=`$debounce$result$${O}`;return function(...T){this[m]||(this[m]=E?E():void 0),clearTimeout(this[b]),A&&(this[m]=A(this[m],...T),T=[this[m]]),this[b]=setTimeout(()=>{k.apply(this,T),this[m]=E?E():void 0},_)}})}e.debounce=S;function M(_,A,E){return r((k,O)=>{const b=`$throttle$timer$${O}`,m=`$throttle$result$${O}`,T=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...c){if(this[m]||(this[m]=E?E():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...c)),this[f])return;const h=this[T]+_;h<=Date.now()?(this[T]=Date.now(),k.apply(this,[this[m]]),this[m]=E?E():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[T]=Date.now(),k.apply(this,[this[m]]),this[m]=E?E():void 0},h-Date.now()))}})}e.throttle=M}),define(Ce[73],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(Ce[105],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var y;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(y=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function _(t,d=!1){let i=0;const n=t.length;let s="",a=0,o=16,g=0;function p(L){let R=0,K=0;for(;R<L;){const W=t.charCodeAt(i);if(W>=48&&W<=57)K=K*16+W-48;else if(W>=65&&W<=70)K=K*16+W-65+10;else if(W>=97&&W<=102)K=K*16+W-97+10;else break;i++,R++}return R<L&&(K=-1),K}function P(L){i=L,s="",a=0,o=16,g=0}function N(){const L=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&k(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&k(t.charCodeAt(i)))for(i++;i<t.length&&k(t.charCodeAt(i));)i++;else return g=3,t.substring(L,i);let R=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&k(t.charCodeAt(i))){for(i++;i<t.length&&k(t.charCodeAt(i));)i++;R=i}else g=3;return t.substring(L,R)}function V(){let L="",R=i;for(;;){if(i>=n){L+=t.substring(R,i),g=2;break}const K=t.charCodeAt(i);if(K===34){L+=t.substring(R,i),i++;break}if(K===92){if(L+=t.substring(R,i),i++,i>=n){g=2;break}switch(t.charCodeAt(i++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const $=p(4);$>=0?L+=String.fromCharCode($):g=4;break}default:g=5}R=i;continue}if(K>=0&&K<=31)if(E(K)){L+=t.substring(R,i),g=2;break}else g=6;i++}return L}function U(){if(s="",g=0,a=i,i>=n)return a=n,o=17;let L=t.charCodeAt(i);if(A(L)){do i++,s+=String.fromCharCode(L),L=t.charCodeAt(i);while(A(L));return o=15}if(E(L))return i++,s+=String.fromCharCode(L),L===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),o=14;switch(L){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,s=V(),o=10;case 47:{const R=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!E(t.charCodeAt(i));)i++;return s=t.substring(R,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const K=n-1;let W=!1;for(;i<K;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,g=1),s=t.substring(R,i),o=13}return s+=String.fromCharCode(L),i++,o=16}case 45:if(s+=String.fromCharCode(L),i++,i===n||!k(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=N(),o=11;default:for(;i<n&&D(L);)i++,L=t.charCodeAt(i);if(a!==i){switch(s=t.substring(a,i),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(L),i++,o=16}}function D(L){if(A(L)||E(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let L;do L=U();while(L>=12&&L<=15);return L}return{setPosition:P,getPosition:()=>i,scan:d?x:U,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>g}}e.createScanner=_;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function b(t,d){const i=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function g(p,P,N,V){a.value=p,a.offset=P,a.length=N,a.type=V,a.colonOffset=void 0,s=a}try{I(t,{onObjectBegin:(p,P)=>{if(d<=p)throw n;s=void 0,o=d>p,i.push("")},onObjectProperty:(p,P,N)=>{if(d<P||(g(p,P,N,"property"),i[i.length-1]=p,d<=P+N))throw n},onObjectEnd:(p,P)=>{if(d<=p)throw n;s=void 0,i.pop()},onArrayBegin:(p,P)=>{if(d<=p)throw n;s=void 0,i.push(0)},onArrayEnd:(p,P)=>{if(d<=p)throw n;s=void 0,i.pop()},onLiteralValue:(p,P,N)=>{if(d<P||(g(p,P,N,w(p)),d<=P+N))throw n},onSeparator:(p,P,N)=>{if(d<=P)throw n;if(p===":"&&s&&s.type==="property")s.colonOffset=P,o=!1,s=void 0;else if(p===","){const V=i[i.length-1];typeof V=="number"?i[i.length-1]=V+1:(o=!0,i[i.length-1]=""),s=void 0}}})}catch(p){if(p!==n)throw p}return{path:i,previousNode:s,isAtPropertyKey:o,matches:p=>{let P=0;for(let N=0;P<p.length&&N<i.length;N++)if(p[P]===i[N]||p[P]==="*")P++;else if(p[P]!=="**")return!1;return P===p.length}}}e.getLocation=b;function m(t,d=[],i=M.DEFAULT){let n=null,s=[];const a=[];function o(p){Array.isArray(s)?s.push(p):n!==null&&(s[n]=p)}return I(t,{onObjectBegin:()=>{const p={};o(p),a.push(s),s=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const p=[];o(p),a.push(s),s=p,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:o,onError:(p,P,N)=>{d.push({error:p,offset:P,length:N})}},i),s[0]}e.parse=m;function T(t,d=[],i=M.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){n.type==="property"&&(n.length=p-n.offset,n=n.parent)}function a(p){return n.children.push(p),p}I(t,{onObjectBegin:p=>{n=a({type:"object",offset:p,length:-1,parent:n,children:[]})},onObjectProperty:(p,P,N)=>{n=a({type:"property",offset:P,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:p,offset:P,length:N,parent:n})},onObjectEnd:(p,P)=>{n.length=p+P-n.offset,n=n.parent,s(p+P)},onArrayBegin:(p,P)=>{n=a({type:"array",offset:p,length:-1,parent:n,children:[]})},onArrayEnd:(p,P)=>{n.length=p+P-n.offset,n=n.parent,s(p+P)},onLiteralValue:(p,P,N)=>{a({type:w(p),offset:P,length:N,parent:n,value:p}),s(P+N)},onSeparator:(p,P,N)=>{n.type==="property"&&(p===":"?n.colonOffset=P:p===","&&s(P))},onError:(p,P,N)=>{d.push({error:p,offset:P,length:N})}},i);const g=n.children[0];return g&&delete g.parent,g}e.parseTree=T;function f(t,d){if(!t)return;let i=t;for(const n of d)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=f;function c(t){if(!t.parent||!t.parent.children)return[];const d=c(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;d.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&d.push(i)}return d}e.getNodePath=c;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const d=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(d[i.children[0].value]=h(n))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=h;function u(t,d,i=!1){return d>=t.offset&&d<t.offset+t.length||i&&d===t.offset+t.length}e.contains=u;function v(t,d,i=!1){if(u(t,d,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=d;s++){const a=v(n[s],d,i);if(a)return a}return t}}e.findNodeAtOffset=v;function I(t,d,i=M.DEFAULT){const n=_(t,!1);function s(pe){return pe?()=>pe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(pe){return pe?be=>pe(be,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=s(d.onObjectBegin),g=a(d.onObjectProperty),p=s(d.onObjectEnd),P=s(d.onArrayBegin),N=s(d.onArrayEnd),V=a(d.onLiteralValue),U=a(d.onSeparator),D=s(d.onComment),x=a(d.onError),L=i&&i.disallowComments,R=i&&i.allowTrailingComma;function K(){for(;;){const pe=n.scan();switch(n.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:L||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(pe){case 12:case 13:L?W(10):D();break;case 16:W(1);break;case 15:case 14:break;default:return pe}}}function W(pe,be=[],re=[]){if(x(pe),be.length+re.length>0){let Ee=n.getToken();for(;Ee!==17;){if(be.indexOf(Ee)!==-1){K();break}else if(re.indexOf(Ee)!==-1)break;Ee=K()}}}function $(pe){const be=n.getTokenValue();return pe?V(be):g(be),K(),!0}function fe(){switch(n.getToken()){case 11:{let pe=0;try{pe=JSON.parse(n.getTokenValue()),typeof pe!="number"&&(W(2),pe=0)}catch{W(2)}V(pe);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return K(),!0}function J(){return n.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),n.getToken()===6?(U(":"),K(),te()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){o(),K();let pe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(pe||W(4,[],[]),U(","),K(),n.getToken()===2&&R)break}else pe&&W(6,[],[]);J()||W(4,[],[2,5]),pe=!0}return p(),n.getToken()!==2?W(7,[2],[]):K(),!0}function ce(){P(),K();let pe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(pe||W(4,[],[]),U(","),K(),n.getToken()===4&&R)break}else pe&&W(6,[],[]);te()||W(4,[],[4,5]),pe=!0}return N(),n.getToken()!==4?W(8,[4],[]):K(),!0}function te(){switch(n.getToken()){case 3:return ce();case 1:return Q();case 10:return $(!0);default:return fe()}}return K(),n.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):te()?(n.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=I;function l(t,d){const i=_(t),n=[];let s,a=0,o;do switch(o=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:a!==o&&n.push(t.substring(a,o)),d!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,d)),a=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=l;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[106],Ie([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(Te,_e){for(var ye=0;ye<_e.length;ye++){var ae=_e[ye];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Te,ae.key,ae)}}function r(Te,_e,ye){return _e&&e(Te.prototype,_e),ye&&e(Te,ye),Object.defineProperty(Te,"prototype",{writable:!1}),Te}function y(Te,_e){if(!!Te){if(typeof Te=="string")return S(Te,_e);var ye=Object.prototype.toString.call(Te).slice(8,-1);if(ye==="Object"&&Te.constructor&&(ye=Te.constructor.name),ye==="Map"||ye==="Set")return Array.from(Te);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return S(Te,_e)}}function S(Te,_e){(_e==null||_e>Te.length)&&(_e=Te.length);for(var ye=0,ae=new Array(_e);ye<_e;ye++)ae[ye]=Te[ye];return ae}function M(Te,_e){var ye=typeof Symbol<"u"&&Te[Symbol.iterator]||Te["@@iterator"];if(ye)return(ye=ye.call(Te)).next.bind(ye);if(Array.isArray(Te)||(ye=y(Te))||_e&&Te&&typeof Te.length=="number"){ye&&(Te=ye);var ae=0;return function(){return ae>=Te.length?{done:!0}:{done:!1,value:Te[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=_();function A(Te){ne.defaults=Te}var E=/[&<>"']/,k=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(_e){return m[_e]};function f(Te,_e){if(_e){if(E.test(Te))return Te.replace(k,T)}else if(O.test(Te))return Te.replace(b,T);return Te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(Te){return Te.replace(c,function(_e,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var u=/(^|[^\[])\^/g;function v(Te,_e){Te=typeof Te=="string"?Te:Te.source,_e=_e||"";var ye={replace:function(ue,Y){return Y=Y.source||Y,Y=Y.replace(u,"$1"),Te=Te.replace(ue,Y),ye},getRegex:function(){return new RegExp(Te,_e)}};return ye}var I=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(Te,_e,ye){if(Te){var ae;try{ae=decodeURIComponent(h(ye)).replace(I,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}_e&&!l.test(ye)&&(ye=s(_e,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var t={},d=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Te,_e){t[" "+Te]||(d.test(Te)?t[" "+Te]=Te+"/":t[" "+Te]=p(Te,"/",!0)),Te=t[" "+Te];var ye=Te.indexOf(":")===-1;return _e.substring(0,2)==="//"?ye?_e:Te.replace(i,"$1")+_e:_e.charAt(0)==="/"?ye?_e:Te.replace(n,"$1")+_e:Te+_e}var a={exec:function(){}};function o(Te){for(var _e=1,ye,ae;_e<arguments.length;_e++){ye=arguments[_e];for(ae in ye)Object.prototype.hasOwnProperty.call(ye,ae)&&(Te[ae]=ye[ae])}return Te}function g(Te,_e){var ye=Te.replace(/\|/g,function(Y,ee,C){for(var B=!1,H=ee;--H>=0&&C[H]==="\\";)B=!B;return B?"|":" |"}),ae=ye.split(/ \|/),ue=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>_e)ae.splice(_e);else for(;ae.length<_e;)ae.push("");for(;ue<ae.length;ue++)ae[ue]=ae[ue].trim().replace(/\\\|/g,"|");return ae}function p(Te,_e,ye){var ae=Te.length;if(ae===0)return"";for(var ue=0;ue<ae;){var Y=Te.charAt(ae-ue-1);if(Y===_e&&!ye)ue++;else if(Y!==_e&&ye)ue++;else break}return Te.slice(0,ae-ue)}function P(Te,_e){if(Te.indexOf(_e[1])===-1)return-1;for(var ye=Te.length,ae=0,ue=0;ue<ye;ue++)if(Te[ue]==="\\")ue++;else if(Te[ue]===_e[0])ae++;else if(Te[ue]===_e[1]&&(ae--,ae<0))return ue;return-1}function N(Te){Te&&Te.sanitize&&!Te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(Te,_e){if(_e<1)return"";for(var ye="";_e>1;)_e&1&&(ye+=Te),_e>>=1,Te+=Te;return ye+Te}function U(Te,_e,ye,ae){var ue=_e.href,Y=_e.title?f(_e.title):null,ee=Te[1].replace(/\\([\[\]])/g,"$1");if(Te[0].charAt(0)!=="!"){ae.state.inLink=!0;var C={type:"link",raw:ye,href:ue,title:Y,text:ee,tokens:ae.inlineTokens(ee)};return ae.state.inLink=!1,C}return{type:"image",raw:ye,href:ue,title:Y,text:f(ee)}}function D(Te,_e){var ye=Te.match(/^(\s+)(?:```)/);if(ye===null)return _e;var ae=ye[1];return _e.split(`
`).map(function(ue){var Y=ue.match(/^\s+/);if(Y===null)return ue;var ee=Y[0];return ee.length>=ae.length?ue.slice(ae.length):ue}).join(`
`)}var x=function(){function Te(ye){this.options=ye||ne.defaults}var _e=Te.prototype;return _e.space=function(ae){var ue=this.rules.block.newline.exec(ae);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},_e.code=function(ae){var ue=this.rules.block.code.exec(ae);if(ue){var Y=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:p(Y,`
`)}}},_e.fences=function(ae){var ue=this.rules.block.fences.exec(ae);if(ue){var Y=ue[0],ee=D(Y,ue[3]||"");return{type:"code",raw:Y,lang:ue[2]?ue[2].trim():ue[2],text:ee}}},_e.heading=function(ae){var ue=this.rules.block.heading.exec(ae);if(ue){var Y=ue[2].trim();if(/#$/.test(Y)){var ee=p(Y,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(Y=ee.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:Y,tokens:this.lexer.inline(Y)}}},_e.hr=function(ae){var ue=this.rules.block.hr.exec(ae);if(ue)return{type:"hr",raw:ue[0]}},_e.blockquote=function(ae){var ue=this.rules.block.blockquote.exec(ae);if(ue){var Y=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},_e.list=function(ae){var ue=this.rules.block.list.exec(ae);if(ue){var Y,ee,C,B,H,j,oe,le,Z,ve,ge,Ne,xe=ue[1].trim(),Ye=xe.length>1,Ge={type:"list",raw:"",ordered:Ye,start:Ye?+xe.slice(0,-1):"",loose:!1,items:[]};xe=Ye?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=Ye?xe:"[*+-]");for(var ke=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ue=ke.exec(ae))||this.rules.block.hr.test(ae)));){if(Y=ue[0],ae=ae.substring(Y.length),le=ue[2].split(`
`,1)[0],Z=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ge=le.trimLeft()):(B=ue[2].search(/[^ ]/),B=B>4?1:B,ge=le.slice(B),B+=ue[1].length),j=!1,!le&&/^ *$/.test(Z)&&(Y+=Z+`
`,ae=ae.substring(Z.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),G=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),X=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:```|~~~)"),he=new RegExp("^ {0,"+Math.min(3,B-1)+"}#");ae&&(ve=ae.split(`
`,1)[0],le=ve,this.options.pedantic&&(le=le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(X.test(le)||he.test(le)||nt.test(le)||G.test(ae)));){if(le.search(/[^ ]/)>=B||!le.trim())ge+=`
`+le.slice(B);else if(!j)ge+=`
`+le;else break;!j&&!le.trim()&&(j=!0),Y+=ve+`
`,ae=ae.substring(ve.length+1)}Ge.loose||(oe?Ge.loose=!0:/\n *\n *$/.test(Y)&&(oe=!0)),this.options.gfm&&(ee=/^\[[ xX]\] /.exec(ge),ee&&(C=ee[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:Y,task:!!ee,checked:C,loose:!1,text:ge}),Ge.raw+=Y}Ge.items[Ge.items.length-1].raw=Y.trimRight(),Ge.items[Ge.items.length-1].text=ge.trimRight(),Ge.raw=Ge.raw.trimRight();var Ue=Ge.items.length;for(H=0;H<Ue;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var Ve=Ge.items[H].tokens.filter(function(Ke){return Ke.type==="space"}),Ze=Ve.every(function(Ke){for(var je=Ke.raw.split(""),tt=0,st=M(je),dt;!(dt=st()).done;){var at=dt.value;if(at===`
`&&(tt+=1),tt>1)return!0}return!1});!Ge.loose&&Ve.length&&Ze&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},_e.html=function(ae){var ue=this.rules.block.html.exec(ae);if(ue){var Y={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var ee=this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]);Y.type="paragraph",Y.text=ee,Y.tokens=this.lexer.inline(ee)}return Y}},_e.def=function(ae){var ue=this.rules.block.def.exec(ae);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var Y=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:ue[0],href:ue[2],title:ue[3]}}},_e.table=function(ae){var ue=this.rules.block.table.exec(ae);if(ue){var Y={type:"table",header:g(ue[1]).map(function(oe){return{text:oe}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=ue[0];var ee=Y.align.length,C,B,H,j;for(C=0;C<ee;C++)/^ *-+: *$/.test(Y.align[C])?Y.align[C]="right":/^ *:-+: *$/.test(Y.align[C])?Y.align[C]="center":/^ *:-+ *$/.test(Y.align[C])?Y.align[C]="left":Y.align[C]=null;for(ee=Y.rows.length,C=0;C<ee;C++)Y.rows[C]=g(Y.rows[C],Y.header.length).map(function(oe){return{text:oe}});for(ee=Y.header.length,B=0;B<ee;B++)Y.header[B].tokens=this.lexer.inline(Y.header[B].text);for(ee=Y.rows.length,B=0;B<ee;B++)for(j=Y.rows[B],H=0;H<j.length;H++)j[H].tokens=this.lexer.inline(j[H].text);return Y}}},_e.lheading=function(ae){var ue=this.rules.block.lheading.exec(ae);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},_e.paragraph=function(ae){var ue=this.rules.block.paragraph.exec(ae);if(ue){var Y=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:Y,tokens:this.lexer.inline(Y)}}},_e.text=function(ae){var ue=this.rules.block.text.exec(ae);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},_e.escape=function(ae){var ue=this.rules.inline.escape.exec(ae);if(ue)return{type:"escape",raw:ue[0],text:f(ue[1])}},_e.tag=function(ae){var ue=this.rules.inline.tag.exec(ae);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):f(ue[0]):ue[0]}},_e.link=function(ae){var ue=this.rules.inline.link.exec(ae);if(ue){var Y=ue[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var ee=p(Y.slice(0,-1),"\\");if((Y.length-ee.length)%2===0)return}else{var C=P(ue[2],"()");if(C>-1){var B=ue[0].indexOf("!")===0?5:4,H=B+ue[1].length+C;ue[2]=ue[2].substring(0,C),ue[0]=ue[0].substring(0,H).trim(),ue[3]=""}}var j=ue[2],oe="";if(this.options.pedantic){var le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);le&&(j=le[1],oe=le[3])}else oe=ue[3]?ue[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(Y)?j=j.slice(1):j=j.slice(1,-1)),U(ue,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},_e.reflink=function(ae,ue){var Y;if((Y=this.rules.inline.reflink.exec(ae))||(Y=this.rules.inline.nolink.exec(ae))){var ee=(Y[2]||Y[1]).replace(/\s+/g," ");if(ee=ue[ee.toLowerCase()],!ee||!ee.href){var C=Y[0].charAt(0);return{type:"text",raw:C,text:C}}return U(Y,ee,Y[0],this.lexer)}},_e.emStrong=function(ae,ue,Y){Y===void 0&&(Y="");var ee=this.rules.inline.emStrong.lDelim.exec(ae);if(!!ee&&!(ee[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var C=ee[1]||ee[2]||"";if(!C||C&&(Y===""||this.rules.inline.punctuation.exec(Y))){var B=ee[0].length-1,H,j,oe=B,le=0,Z=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,ue=ue.slice(-1*ae.length+B);(ee=Z.exec(ue))!=null;)if(H=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!H){if(j=H.length,ee[3]||ee[4]){oe+=j;continue}else if((ee[5]||ee[6])&&B%3&&!((B+j)%3)){le+=j;continue}if(oe-=j,!(oe>0)){if(j=Math.min(j,j+oe+le),Math.min(B,j)%2){var ve=ae.slice(1,B+ee.index+j);return{type:"em",raw:ae.slice(0,B+ee.index+j+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var ge=ae.slice(2,B+ee.index+j-1);return{type:"strong",raw:ae.slice(0,B+ee.index+j+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}}}}},_e.codespan=function(ae){var ue=this.rules.inline.code.exec(ae);if(ue){var Y=ue[2].replace(/\n/g," "),ee=/[^ ]/.test(Y),C=/^ /.test(Y)&&/ $/.test(Y);return ee&&C&&(Y=Y.substring(1,Y.length-1)),Y=f(Y,!0),{type:"codespan",raw:ue[0],text:Y}}},_e.br=function(ae){var ue=this.rules.inline.br.exec(ae);if(ue)return{type:"br",raw:ue[0]}},_e.del=function(ae){var ue=this.rules.inline.del.exec(ae);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},_e.autolink=function(ae,ue){var Y=this.rules.inline.autolink.exec(ae);if(Y){var ee,C;return Y[2]==="@"?(ee=f(this.options.mangle?ue(Y[1]):Y[1]),C="mailto:"+ee):(ee=f(Y[1]),C=ee),{type:"link",raw:Y[0],text:ee,href:C,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.url=function(ae,ue){var Y;if(Y=this.rules.inline.url.exec(ae)){var ee,C;if(Y[2]==="@")ee=f(this.options.mangle?ue(Y[0]):Y[0]),C="mailto:"+ee;else{var B;do B=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(B!==Y[0]);ee=f(Y[0]),Y[1]==="www."?C="http://"+ee:C=ee}return{type:"link",raw:Y[0],text:ee,href:C,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.inlineText=function(ae,ue){var Y=this.rules.inline.text.exec(ae);if(Y){var ee;return this.lexer.state.inRawBlock?ee=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]:ee=f(this.options.smartypants?ue(Y[0]):Y[0]),{type:"text",raw:Y[0],text:ee}}},Te}(),L={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};L._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,L._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,L.def=v(L.def).replace("label",L._label).replace("title",L._title).getRegex(),L.bullet=/(?:[*+-]|\d{1,9}[.)])/,L.listItemStart=v(/^( *)(bull) */).replace("bull",L.bullet).getRegex(),L.list=v(L.list).replace(/bull/g,L.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+L.def.source+")").getRegex(),L._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",L._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,L.html=v(L.html,"i").replace("comment",L._comment).replace("tag",L._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),L.paragraph=v(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.blockquote=v(L.blockquote).replace("paragraph",L.paragraph).getRegex(),L.normal=o({},L),L.gfm=o({},L.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),L.gfm.table=v(L.gfm.table).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.gfm.paragraph=v(L._paragraph).replace("hr",L.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",L.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",L._tag).getRegex(),L.pedantic=o({},L.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",L._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:v(L.normal._paragraph).replace("hr",L.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",L.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=v(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=v(L._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=v(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=v(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=v(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=v(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=v(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=v(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=v(R.reflink).replace("label",R._label).replace("ref",L._label).getRegex(),R.nolink=v(R.nolink).replace("ref",L._label).getRegex(),R.reflinkSearch=v(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=o({},R),R.pedantic=o({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=o({},R.normal,{escape:v(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=v(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=o({},R.gfm,{br:v(R.br).replace("{2,}","*").getRegex(),text:v(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Te){return Te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Te){var _e="",ye,ae,ue=Te.length;for(ye=0;ye<ue;ye++)ae=Te.charCodeAt(ye),Math.random()>.5&&(ae="x"+ae.toString(16)),_e+="&#"+ae+";";return _e}var $=function(){function Te(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ne.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:L.normal,inline:R.normal};this.options.pedantic?(ae.block=L.pedantic,ae.inline=R.pedantic):this.options.gfm&&(ae.block=L.gfm,this.options.breaks?ae.inline=R.breaks:ae.inline=R.gfm),this.tokenizer.rules=ae}Te.lex=function(ae,ue){var Y=new Te(ue);return Y.lex(ae)},Te.lexInline=function(ae,ue){var Y=new Te(ue);return Y.inlineTokens(ae)};var _e=Te.prototype;return _e.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},_e.blockTokens=function(ae,ue){var Y=this;ue===void 0&&(ue=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(oe,le,Z){return le+"    ".repeat(Z.length)});for(var ee,C,B,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(ee=oe.call({lexer:Y},ae,ue))?(ae=ae.substring(ee.raw.length),ue.push(ee),!0):!1}))){if(ee=this.tokenizer.space(ae)){ae=ae.substring(ee.raw.length),ee.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(ee);continue}if(ee=this.tokenizer.code(ae)){ae=ae.substring(ee.raw.length),C=ue[ue.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+ee.raw,C.text+=`
`+ee.text,this.inlineQueue[this.inlineQueue.length-1].src=C.text):ue.push(ee);continue}if(ee=this.tokenizer.fences(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.heading(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.hr(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.blockquote(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.list(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.html(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.def(ae)){ae=ae.substring(ee.raw.length),C=ue[ue.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+ee.raw,C.text+=`
`+ee.raw,this.inlineQueue[this.inlineQueue.length-1].src=C.text):this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.lheading(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,le=ae.slice(1),Z=void 0;Y.options.extensions.startBlock.forEach(function(ve){Z=ve.call({lexer:this},le),typeof Z=="number"&&Z>=0&&(oe=Math.min(oe,Z))}),oe<1/0&&oe>=0&&(B=ae.substring(0,oe+1))}(),this.state.top&&(ee=this.tokenizer.paragraph(B))){C=ue[ue.length-1],H&&C.type==="paragraph"?(C.raw+=`
`+ee.raw,C.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ue.push(ee),H=B.length!==ae.length,ae=ae.substring(ee.raw.length);continue}if(ee=this.tokenizer.text(ae)){ae=ae.substring(ee.raw.length),C=ue[ue.length-1],C&&C.type==="text"?(C.raw+=`
`+ee.raw,C.text+=`
`+ee.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ue.push(ee);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ue},_e.inline=function(ae,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ae,tokens:ue}),ue},_e.inlineTokens=function(ae,ue){var Y=this;ue===void 0&&(ue=[]);var ee,C,B,H=ae,j,oe,le;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Z.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(oe||(le=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(ee=ge.call({lexer:Y},ae,ue))?(ae=ae.substring(ee.raw.length),ue.push(ee),!0):!1}))){if(ee=this.tokenizer.escape(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.tag(ae)){ae=ae.substring(ee.raw.length),C=ue[ue.length-1],C&&ee.type==="text"&&C.type==="text"?(C.raw+=ee.raw,C.text+=ee.text):ue.push(ee);continue}if(ee=this.tokenizer.link(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(ee.raw.length),C=ue[ue.length-1],C&&ee.type==="text"&&C.type==="text"?(C.raw+=ee.raw,C.text+=ee.text):ue.push(ee);continue}if(ee=this.tokenizer.emStrong(ae,H,le)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.codespan(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.br(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.del(ae)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(ee=this.tokenizer.autolink(ae,W)){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(!this.state.inLink&&(ee=this.tokenizer.url(ae,W))){ae=ae.substring(ee.raw.length),ue.push(ee);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),xe=void 0;Y.options.extensions.startInline.forEach(function(Ye){xe=Ye.call({lexer:this},Ne),typeof xe=="number"&&xe>=0&&(ge=Math.min(ge,xe))}),ge<1/0&&ge>=0&&(B=ae.substring(0,ge+1))}(),ee=this.tokenizer.inlineText(B,K)){ae=ae.substring(ee.raw.length),ee.raw.slice(-1)!=="_"&&(le=ee.raw.slice(-1)),oe=!0,C=ue[ue.length-1],C&&C.type==="text"?(C.raw+=ee.raw,C.text+=ee.text):ue.push(ee);continue}if(ae){var ve="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},r(Te,null,[{key:"rules",get:function(){return{block:L,inline:R}}}]),Te}(),fe=function(){function Te(ye){this.options=ye||ne.defaults}var _e=Te.prototype;return _e.code=function(ae,ue,Y){var ee=(ue||"").match(/\S*/)[0];if(this.options.highlight){var C=this.options.highlight(ae,ee);C!=null&&C!==ae&&(Y=!0,ae=C)}return ae=ae.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+f(ee,!0)+'">'+(Y?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(Y?ae:f(ae,!0))+`</code></pre>
`},_e.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},_e.html=function(ae){return ae},_e.heading=function(ae,ue,Y,ee){if(this.options.headerIds){var C=this.options.headerPrefix+ee.slug(Y);return"<h"+ue+' id="'+C+'">'+ae+"</h"+ue+`>
`}return"<h"+ue+">"+ae+"</h"+ue+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(ae,ue,Y){var ee=ue?"ol":"ul",C=ue&&Y!==1?' start="'+Y+'"':"";return"<"+ee+C+`>
`+ae+"</"+ee+`>
`},_e.listitem=function(ae){return"<li>"+ae+`</li>
`},_e.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(ae){return"<p>"+ae+`</p>
`},_e.table=function(ae,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ue+`</table>
`},_e.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},_e.tablecell=function(ae,ue){var Y=ue.header?"th":"td",ee=ue.align?"<"+Y+' align="'+ue.align+'">':"<"+Y+">";return ee+ae+("</"+Y+`>
`)},_e.strong=function(ae){return"<strong>"+ae+"</strong>"},_e.em=function(ae){return"<em>"+ae+"</em>"},_e.codespan=function(ae){return"<code>"+ae+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(ae){return"<del>"+ae+"</del>"},_e.link=function(ae,ue,Y){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Y;var ee='<a href="'+f(ae)+'"';return ue&&(ee+=' title="'+ue+'"'),ee+=">"+Y+"</a>",ee},_e.image=function(ae,ue,Y){if(ae=w(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Y;var ee='<img src="'+ae+'" alt="'+Y+'"';return ue&&(ee+=' title="'+ue+'"'),ee+=this.options.xhtml?"/>":">",ee},_e.text=function(ae){return ae},Te}(),J=function(){function Te(){}var _e=Te.prototype;return _e.strong=function(ae){return ae},_e.em=function(ae){return ae},_e.codespan=function(ae){return ae},_e.del=function(ae){return ae},_e.html=function(ae){return ae},_e.text=function(ae){return ae},_e.link=function(ae,ue,Y){return""+Y},_e.image=function(ae,ue,Y){return""+Y},_e.br=function(){return""},Te}(),Q=function(){function Te(){this.seen={}}var _e=Te.prototype;return _e.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(ae,ue){var Y=ae,ee=0;if(this.seen.hasOwnProperty(Y)){ee=this.seen[ae];do ee++,Y=ae+"-"+ee;while(this.seen.hasOwnProperty(Y))}return ue||(this.seen[ae]=ee,this.seen[Y]=0),Y},_e.slug=function(ae,ue){ue===void 0&&(ue={});var Y=this.serialize(ae);return this.getNextSafeSlug(Y,ue.dryrun)},Te}(),ce=function(){function Te(ye){this.options=ye||ne.defaults,this.options.renderer=this.options.renderer||new fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new Q}Te.parse=function(ae,ue){var Y=new Te(ue);return Y.parse(ae)},Te.parseInline=function(ae,ue){var Y=new Te(ue);return Y.parseInline(ae)};var _e=Te.prototype;return _e.parse=function(ae,ue){ue===void 0&&(ue=!0);var Y="",ee,C,B,H,j,oe,le,Z,ve,ge,Ne,xe,Ye,Ge,ke,nt,G,X,he,Ue=ae.length;for(ee=0;ee<Ue;ee++){if(ge=ae[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(he=this.options.extensions.renderers[ge.type].call({parser:this},ge),he!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){Y+=he||"";continue}switch(ge.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,h(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(Z="",le="",H=ge.header.length,C=0;C<H;C++)le+=this.renderer.tablecell(this.parseInline(ge.header[C].tokens),{header:!0,align:ge.align[C]});for(Z+=this.renderer.tablerow(le),ve="",H=ge.rows.length,C=0;C<H;C++){for(oe=ge.rows[C],le="",j=oe.length,B=0;B<j;B++)le+=this.renderer.tablecell(this.parseInline(oe[B].tokens),{header:!1,align:ge.align[B]});ve+=this.renderer.tablerow(le)}Y+=this.renderer.table(Z,ve);continue}case"blockquote":{ve=this.parse(ge.tokens),Y+=this.renderer.blockquote(ve);continue}case"list":{for(Ne=ge.ordered,xe=ge.start,Ye=ge.loose,H=ge.items.length,ve="",C=0;C<H;C++)ke=ge.items[C],nt=ke.checked,G=ke.task,Ge="",ke.task&&(X=this.renderer.checkbox(nt),Ye?ke.tokens.length>0&&ke.tokens[0].type==="paragraph"?(ke.tokens[0].text=X+" "+ke.tokens[0].text,ke.tokens[0].tokens&&ke.tokens[0].tokens.length>0&&ke.tokens[0].tokens[0].type==="text"&&(ke.tokens[0].tokens[0].text=X+" "+ke.tokens[0].tokens[0].text)):ke.tokens.unshift({type:"text",text:X}):Ge+=X),Ge+=this.parse(ke.tokens,Ye),ve+=this.renderer.listitem(Ge,G,nt);Y+=this.renderer.list(ve,Ne,xe);continue}case"html":{Y+=this.renderer.html(ge.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(ve=ge.tokens?this.parseInline(ge.tokens):ge.text;ee+1<Ue&&ae[ee+1].type==="text";)ge=ae[++ee],ve+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);Y+=ue?this.renderer.paragraph(ve):ve;continue}default:{var Ve='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return Y},_e.parseInline=function(ae,ue){ue=ue||this.renderer;var Y="",ee,C,B,H=ae.length;for(ee=0;ee<H;ee++){if(C=ae[ee],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[C.type]&&(B=this.options.extensions.renderers[C.type].call({parser:this},C),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(C.type))){Y+=B||"";continue}switch(C.type){case"escape":{Y+=ue.text(C.text);break}case"html":{Y+=ue.html(C.text);break}case"link":{Y+=ue.link(C.href,C.title,this.parseInline(C.tokens,ue));break}case"image":{Y+=ue.image(C.href,C.title,C.text);break}case"strong":{Y+=ue.strong(this.parseInline(C.tokens,ue));break}case"em":{Y+=ue.em(this.parseInline(C.tokens,ue));break}case"codespan":{Y+=ue.codespan(C.text);break}case"br":{Y+=ue.br();break}case"del":{Y+=ue.del(this.parseInline(C.tokens,ue));break}case"text":{Y+=ue.text(C.text);break}default:{var j='Token with "'+C.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return Y},Te}();function te(Te,_e,ye){if(typeof Te>"u"||Te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");if(typeof _e=="function"&&(ye=_e,_e=null),_e=o({},te.defaults,_e||{}),N(_e),ye){var ae=_e.highlight,ue;try{ue=$.lex(Te,_e)}catch(H){return ye(H)}var Y=function(j){var oe;if(!j)try{_e.walkTokens&&te.walkTokens(ue,_e.walkTokens),oe=ce.parse(ue,_e)}catch(le){j=le}return _e.highlight=ae,j?ye(j):ye(null,oe)};if(!ae||ae.length<3||(delete _e.highlight,!ue.length))return Y();var ee=0;te.walkTokens(ue,function(H){H.type==="code"&&(ee++,setTimeout(function(){ae(H.text,H.lang,function(j,oe){if(j)return Y(j);oe!=null&&oe!==H.text&&(H.text=oe,H.escaped=!0),ee--,ee===0&&Y()})},0))}),ee===0&&Y();return}function C(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(H.message+"",!0)+"</pre>";throw H}try{var B=$.lex(Te,_e);if(_e.walkTokens){if(_e.async)return Promise.all(te.walkTokens(B,_e.walkTokens)).then(function(){return ce.parse(B,_e)}).catch(C);te.walkTokens(B,_e.walkTokens)}return ce.parse(B,_e)}catch(H){C(H)}}te.options=te.setOptions=function(Te){return o(te.defaults,Te),A(te.defaults),te},te.getDefaults=_,te.defaults=ne.defaults,te.use=function(){for(var Te=arguments.length,_e=new Array(Te),ye=0;ye<Te;ye++)_e[ye]=arguments[ye];var ae=o.apply(void 0,[{}].concat(_e)),ue=te.defaults.extensions||{renderers:{},childTokens:{}},Y;_e.forEach(function(ee){if(ee.extensions&&(Y=!0,ee.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=ue.renderers?ue.renderers[B.name]:null;H?ue.renderers[B.name]=function(){for(var j=arguments.length,oe=new Array(j),le=0;le<j;le++)oe[le]=arguments[le];var Z=B.renderer.apply(this,oe);return Z===!1&&(Z=H.apply(this,oe)),Z}:ue.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[B.level]?ue[B.level].unshift(B.tokenizer):ue[B.level]=[B.tokenizer],B.start&&(B.level==="block"?ue.startBlock?ue.startBlock.push(B.start):ue.startBlock=[B.start]:B.level==="inline"&&(ue.startInline?ue.startInline.push(B.start):ue.startInline=[B.start]))}B.childTokens&&(ue.childTokens[B.name]=B.childTokens)})),ee.renderer&&function(){var B=te.defaults.renderer||new fe,H=function(le){var Z=B[le];B[le]=function(){for(var ve=arguments.length,ge=new Array(ve),Ne=0;Ne<ve;Ne++)ge[Ne]=arguments[Ne];var xe=ee.renderer[le].apply(B,ge);return xe===!1&&(xe=Z.apply(B,ge)),xe}};for(var j in ee.renderer)H(j);ae.renderer=B}(),ee.tokenizer&&function(){var B=te.defaults.tokenizer||new x,H=function(le){var Z=B[le];B[le]=function(){for(var ve=arguments.length,ge=new Array(ve),Ne=0;Ne<ve;Ne++)ge[Ne]=arguments[Ne];var xe=ee.tokenizer[le].apply(B,ge);return xe===!1&&(xe=Z.apply(B,ge)),xe}};for(var j in ee.tokenizer)H(j);ae.tokenizer=B}(),ee.walkTokens){var C=te.defaults.walkTokens;ae.walkTokens=function(B){var H=[];return H.push(ee.walkTokens.call(this,B)),C&&(H=H.concat(C.call(this,B))),H}}Y&&(ae.extensions=ue),te.setOptions(ae)})},te.walkTokens=function(Te,_e){for(var ye=[],ae=function(){var C=Y.value;switch(ye=ye.concat(_e.call(te,C)),C.type){case"table":{for(var B=M(C.header),H;!(H=B()).done;){var j=H.value;ye=ye.concat(te.walkTokens(j.tokens,_e))}for(var oe=M(C.rows),le;!(le=oe()).done;)for(var Z=le.value,ve=M(Z),ge;!(ge=ve()).done;){var Ne=ge.value;ye=ye.concat(te.walkTokens(Ne.tokens,_e))}break}case"list":{ye=ye.concat(te.walkTokens(C.items,_e));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[C.type]?te.defaults.extensions.childTokens[C.type].forEach(function(xe){ye=ye.concat(te.walkTokens(C[xe],_e))}):C.tokens&&(ye=ye.concat(te.walkTokens(C.tokens,_e)))}},ue=M(Te),Y;!(Y=ue()).done;)ae();return ye},te.parseInline=function(Te,_e){if(typeof Te>"u"||Te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Te)+", string expected");_e=o({},te.defaults,_e||{}),N(_e);try{var ye=$.lexInline(Te,_e);return _e.walkTokens&&te.walkTokens(ye,_e.walkTokens),ce.parseInline(ye,_e)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},te.Parser=ce,te.parser=ce.parse,te.Renderer=fe,te.TextRenderer=J,te.Lexer=$,te.lexer=$.lex,te.Tokenizer=x,te.Slugger=Q,te.parse=te;var pe=te.options,be=te.setOptions,re=te.use,Ee=te.walkTokens,Pe=te.parseInline,Fe=te,We=ce.parse,Xe=$.lex;ne.Lexer=$,ne.Parser=ce,ne.Renderer=fe,ne.Slugger=Q,ne.TextRenderer=J,ne.Tokenizer=x,ne.getDefaults=_,ne.lexer=Xe,ne.marked=te,ne.options=pe,ne.parse=Fe,ne.parseInline=Pe,ne.parser=We,ne.setOptions=be,ne.use=re,ne.walkTokens=Ee,Object.defineProperty(ne,"__esModule",{value:!0})}),define(Ce[107],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(A,E,k){return Math.min(Math.max(A,E),k)}e.clamp=r;function y(A,E){return(E+A%E)%E}e.rot=y;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class M{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class _{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const k=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=k,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=_}),function(){function ne(S){const M=[];typeof S=="number"&&M.push("code/timeOrigin",S);function _(E){M.push(E,Date.now())}function A(){const E=[];for(let k=0;k<M.length;k+=2)E.push({name:M[k],startTime:M[k+1]});return E}return{mark:_,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const _ of performance.getEntriesByType("mark"))M.push({name:_.name,startTime:Math.round(S+_.startTime)});return M}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function r(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var y;typeof global=="object"?y=global:typeof self=="object"?y=self:y={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(y)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(y):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),y.perf=r(y))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var y in r)(typeof exports=="object"?exports:ne)[y]=r[y]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function r(y){if(e[y])return e[y].exports;var S=e[y]={i:y,l:!1,exports:{}};return ne[y].call(S.exports,S,S.exports,r),S.l=!0,S.exports}return r.m=ne,r.c=e,r.d=function(y,S,M){r.o(y,S)||Object.defineProperty(y,S,{enumerable:!0,get:M})},r.r=function(y){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(y,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(y,"__esModule",{value:!0})},r.t=function(y,S){if(1&S&&(y=r(y)),8&S||4&S&&typeof y=="object"&&y&&y.__esModule)return y;var M=Object.create(null);if(r.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:y}),2&S&&typeof y!="string")for(var _ in y)r.d(M,_,function(A){return y[A]}.bind(null,_));return M},r.n=function(y){var S=y&&y.__esModule?function(){return y.default}:function(){return y};return r.d(S,"a",S),S},r.o=function(y,S){return Object.prototype.hasOwnProperty.call(y,S)},r.p="",r(r.s=0)}([function(ne,e,r){(function(y){var S;e=ne.exports=re,S=typeof y=="object"&&y.env&&y.env.NODE_DEBUG&&/\bsemver\b/i.test(y.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,_=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],E=e.src=[],k=0,O=k++;E[O]="0|[1-9]\\d*";var b=k++;E[b]="[0-9]+";var m=k++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=k++;E[T]="("+E[O]+")\\.("+E[O]+")\\.("+E[O]+")";var f=k++;E[f]="("+E[b]+")\\.("+E[b]+")\\.("+E[b]+")";var c=k++;E[c]="(?:"+E[O]+"|"+E[m]+")";var h=k++;E[h]="(?:"+E[b]+"|"+E[m]+")";var u=k++;E[u]="(?:-("+E[c]+"(?:\\."+E[c]+")*))";var v=k++;E[v]="(?:-?("+E[h]+"(?:\\."+E[h]+")*))";var I=k++;E[I]="[0-9A-Za-z-]+";var l=k++;E[l]="(?:\\+("+E[I]+"(?:\\."+E[I]+")*))";var w=k++,t="v?"+E[T]+E[u]+"?"+E[l]+"?";E[w]="^"+t+"$";var d="[v=\\s]*"+E[f]+E[v]+"?"+E[l]+"?",i=k++;E[i]="^"+d+"$";var n=k++;E[n]="((?:<|>)?=?)";var s=k++;E[s]=E[b]+"|x|X|\\*";var a=k++;E[a]=E[O]+"|x|X|\\*";var o=k++;E[o]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[u]+")?"+E[l]+"?)?)?";var g=k++;E[g]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[v]+")?"+E[l]+"?)?)?";var p=k++;E[p]="^"+E[n]+"\\s*"+E[o]+"$";var P=k++;E[P]="^"+E[n]+"\\s*"+E[g]+"$";var N=k++;E[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=k++;E[V]="(?:~>?)";var U=k++;E[U]="(\\s*)"+E[V]+"\\s+",A[U]=new RegExp(E[U],"g");var D=k++;E[D]="^"+E[V]+E[o]+"$";var x=k++;E[x]="^"+E[V]+E[g]+"$";var L=k++;E[L]="(?:\\^)";var R=k++;E[R]="(\\s*)"+E[L]+"\\s+",A[R]=new RegExp(E[R],"g");var K=k++;E[K]="^"+E[L]+E[o]+"$";var W=k++;E[W]="^"+E[L]+E[g]+"$";var $=k++;E[$]="^"+E[n]+"\\s*("+d+")$|^$";var fe=k++;E[fe]="^"+E[n]+"\\s*("+t+")$|^$";var J=k++;E[J]="(\\s*)"+E[n]+"\\s*("+d+"|"+E[o]+")",A[J]=new RegExp(E[J],"g");var Q=k++;E[Q]="^\\s*("+E[o]+")\\s+-\\s+("+E[o]+")\\s*$";var ce=k++;E[ce]="^\\s*("+E[g]+")\\s+-\\s+("+E[g]+")\\s*$";var te=k++;E[te]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)S(pe,E[pe]),A[pe]||(A[pe]=new RegExp(E[pe]));function be(Z,ve){if(Z instanceof re)return Z;if(typeof Z!="string"||Z.length>M||!(ve?A[i]:A[w]).test(Z))return null;try{return new re(Z,ve)}catch{return null}}function re(Z,ve){if(Z instanceof re){if(Z.loose===ve)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof re))return new re(Z,ve);S("SemVer",Z,ve),this.loose=ve;var ge=Z.trim().match(ve?A[i]:A[w]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>_||this.major<0)throw new TypeError("Invalid major version");if(this.minor>_||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>_||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var xe=+Ne;if(xe>=0&&xe<_)return xe}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(Z,ve){var ge=be(Z,ve);return ge?ge.version:null},e.clean=function(Z,ve){var ge=be(Z.trim().replace(/^[=v]+/,""),ve);return ge?ge.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(Z){return S("SemVer.compare",this.version,this.loose,Z),Z instanceof re||(Z=new re(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},re.prototype.compareMain=function(Z){return Z instanceof re||(Z=new re(Z,this.loose)),Pe(this.major,Z.major)||Pe(this.minor,Z.minor)||Pe(this.patch,Z.patch)},re.prototype.comparePre=function(Z){if(Z instanceof re||(Z=new re(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var ve=0;do{var ge=this.prerelease[ve],Ne=Z.prerelease[ve];if(S("prerelease compare",ve,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Pe(ge,Ne)}while(++ve)},re.prototype.inc=function(Z,ve){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,ve,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new re(Z,ge).inc(ve,Ne).version}catch{return null}},e.diff=function(Z,ve){if(Te(Z,ve))return null;var ge=be(Z),Ne=be(ve);if(ge.prerelease.length||Ne.prerelease.length){for(var xe in ge)if((xe==="major"||xe==="minor"||xe==="patch")&&ge[xe]!==Ne[xe])return"pre"+xe;return"prerelease"}for(var xe in ge)if((xe==="major"||xe==="minor"||xe==="patch")&&ge[xe]!==Ne[xe])return xe},e.compareIdentifiers=Pe;var Ee=/^[0-9]+$/;function Pe(Z,ve){var ge=Ee.test(Z),Ne=Ee.test(ve);return ge&&Ne&&(Z=+Z,ve=+ve),ge&&!Ne?-1:Ne&&!ge?1:Z<ve?-1:Z>ve?1:0}function Fe(Z,ve,ge){return new re(Z,ge).compare(new re(ve,ge))}function We(Z,ve,ge){return Fe(Z,ve,ge)>0}function Xe(Z,ve,ge){return Fe(Z,ve,ge)<0}function Te(Z,ve,ge){return Fe(Z,ve,ge)===0}function _e(Z,ve,ge){return Fe(Z,ve,ge)!==0}function ye(Z,ve,ge){return Fe(Z,ve,ge)>=0}function ae(Z,ve,ge){return Fe(Z,ve,ge)<=0}function ue(Z,ve,ge,Ne){var xe;switch(ve){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),xe=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),xe=Z!==ge;break;case"":case"=":case"==":xe=Te(Z,ge,Ne);break;case"!=":xe=_e(Z,ge,Ne);break;case">":xe=We(Z,ge,Ne);break;case">=":xe=ye(Z,ge,Ne);break;case"<":xe=Xe(Z,ge,Ne);break;case"<=":xe=ae(Z,ge,Ne);break;default:throw new TypeError("Invalid operator: "+ve)}return xe}function Y(Z,ve){if(Z instanceof Y){if(Z.loose===ve)return Z;Z=Z.value}if(!(this instanceof Y))return new Y(Z,ve);S("comparator",Z,ve),this.loose=ve,this.parse(Z),this.semver===ee?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(Z,ve){return Pe(ve,Z)},e.major=function(Z,ve){return new re(Z,ve).major},e.minor=function(Z,ve){return new re(Z,ve).minor},e.patch=function(Z,ve){return new re(Z,ve).patch},e.compare=Fe,e.compareLoose=function(Z,ve){return Fe(Z,ve,!0)},e.rcompare=function(Z,ve,ge){return Fe(ve,Z,ge)},e.sort=function(Z,ve){return Z.sort(function(ge,Ne){return e.compare(ge,Ne,ve)})},e.rsort=function(Z,ve){return Z.sort(function(ge,Ne){return e.rcompare(ge,Ne,ve)})},e.gt=We,e.lt=Xe,e.eq=Te,e.neq=_e,e.gte=ye,e.lte=ae,e.cmp=ue,e.Comparator=Y;var ee={};function C(Z,ve){if(Z instanceof C)return Z.loose===ve?Z:new C(Z.raw,ve);if(Z instanceof Y)return new C(Z.value,ve);if(!(this instanceof C))return new C(Z,ve);if(this.loose=ve,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function B(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function H(Z,ve,ge,Ne,xe,Ye,Ge,ke,nt,G,X,he,Ue){return((ve=B(ge)?"":B(Ne)?">="+ge+".0.0":B(xe)?">="+ge+"."+Ne+".0":">="+ve)+" "+(ke=B(nt)?"":B(G)?"<"+(+nt+1)+".0.0":B(X)?"<"+nt+"."+(+G+1)+".0":he?"<="+nt+"."+G+"."+X+"-"+he:"<="+ke)).trim()}function j(Z,ve){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(ve))return!1;if(ve.prerelease.length){for(ge=0;ge<Z.length;ge++)if(S(Z[ge].semver),Z[ge].semver!==ee&&Z[ge].semver.prerelease.length>0){var Ne=Z[ge].semver;if(Ne.major===ve.major&&Ne.minor===ve.minor&&Ne.patch===ve.patch)return!0}return!1}return!0}function oe(Z,ve,ge){try{ve=new C(ve,ge)}catch{return!1}return ve.test(Z)}function le(Z,ve,ge,Ne){var xe,Ye,Ge,ke,nt;switch(Z=new re(Z,Ne),ve=new C(ve,Ne),ge){case">":xe=We,Ye=ae,Ge=Xe,ke=">",nt=">=";break;case"<":xe=Xe,Ye=ye,Ge=We,ke="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(oe(Z,ve,Ne))return!1;for(var G=0;G<ve.set.length;++G){var X=ve.set[G],he=null,Ue=null;if(X.forEach(function(Ve){Ve.semver===ee&&(Ve=new Y(">=0.0.0")),he=he||Ve,Ue=Ue||Ve,xe(Ve.semver,he.semver,Ne)?he=Ve:Ge(Ve.semver,Ue.semver,Ne)&&(Ue=Ve)}),he.operator===ke||he.operator===nt||(!Ue.operator||Ue.operator===ke)&&Ye(Z,Ue.semver)||Ue.operator===nt&&Ge(Z,Ue.semver))return!1}return!0}Y.prototype.parse=function(Z){var ve=this.loose?A[$]:A[fe],ge=Z.match(ve);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new re(ge[2],this.loose):this.semver=ee},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(Z){return S("Comparator.test",Z,this.loose),this.semver===ee||(typeof Z=="string"&&(Z=new re(Z,this.loose)),ue(Z,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(Z,ve){if(!(Z instanceof Y))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new C(Z.value,ve),oe(this.value,ge,ve);if(Z.operator==="")return ge=new C(this.value,ve),oe(Z.semver,ge,ve);var Ne=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Ye=this.semver.version===Z.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),ke=ue(this.semver,"<",Z.semver,ve)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),nt=ue(this.semver,">",Z.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ne||xe||Ye&&Ge||ke||nt},e.Range=C,C.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},C.prototype.toString=function(){return this.range},C.prototype.parseRange=function(Z){var ve=this.loose;Z=Z.trim(),S("range",Z,ve);var ge=ve?A[ce]:A[Q];Z=Z.replace(ge,H),S("hyphen replace",Z),Z=Z.replace(A[J],"$1$2$3"),S("comparator trim",Z,A[J]),Z=(Z=(Z=Z.replace(A[U],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Ne=ve?A[$]:A[fe],xe=Z.split(" ").map(function(Ye){return function(Ge,ke){return S("comp",Ge),Ge=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(he,Ue){S("caret",he,Ue);var Ve=Ue?A[W]:A[K];return he.replace(Ve,function(Ze,Ke,je,tt,st){var dt;return S("caret",he,Ze,Ke,je,tt,st),B(Ke)?dt="":B(je)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(tt)?dt=Ke==="0"?">="+Ke+"."+je+".0 <"+Ke+"."+(+je+1)+".0":">="+Ke+"."+je+".0 <"+(+Ke+1)+".0.0":st?(S("replaceCaret pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=Ke==="0"?je==="0"?">="+Ke+"."+je+"."+tt+st+" <"+Ke+"."+je+"."+(+tt+1):">="+Ke+"."+je+"."+tt+st+" <"+Ke+"."+(+je+1)+".0":">="+Ke+"."+je+"."+tt+st+" <"+(+Ke+1)+".0.0"):(S("no pr"),dt=Ke==="0"?je==="0"?">="+Ke+"."+je+"."+tt+" <"+Ke+"."+je+"."+(+tt+1):">="+Ke+"."+je+"."+tt+" <"+Ke+"."+(+je+1)+".0":">="+Ke+"."+je+"."+tt+" <"+(+Ke+1)+".0.0"),S("caret return",dt),dt})}(X,G)}).join(" ")}(Ge,ke),S("caret",Ge),Ge=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(he,Ue){var Ve=Ue?A[x]:A[D];return he.replace(Ve,function(Ze,Ke,je,tt,st){var dt;return S("tilde",he,Ze,Ke,je,tt,st),B(Ke)?dt="":B(je)?dt=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":B(tt)?dt=">="+Ke+"."+je+".0 <"+Ke+"."+(+je+1)+".0":st?(S("replaceTilde pr",st),st.charAt(0)!=="-"&&(st="-"+st),dt=">="+Ke+"."+je+"."+tt+st+" <"+Ke+"."+(+je+1)+".0"):dt=">="+Ke+"."+je+"."+tt+" <"+Ke+"."+(+je+1)+".0",S("tilde return",dt),dt})}(X,G)}).join(" ")}(Ge,ke),S("tildes",Ge),Ge=function(nt,G){return S("replaceXRanges",nt,G),nt.split(/\s+/).map(function(X){return function(he,Ue){he=he.trim();var Ve=Ue?A[P]:A[p];return he.replace(Ve,function(Ze,Ke,je,tt,st,dt){S("xRange",he,Ze,Ke,je,tt,st,dt);var at=B(je),rt=at||B(tt),_t=rt||B(st);return Ke==="="&&_t&&(Ke=""),at?Ze=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&_t?(rt&&(tt=0),_t&&(st=0),Ke===">"?(Ke=">=",rt?(je=+je+1,tt=0,st=0):_t&&(tt=+tt+1,st=0)):Ke==="<="&&(Ke="<",rt?je=+je+1:tt=+tt+1),Ze=Ke+je+"."+tt+"."+st):rt?Ze=">="+je+".0.0 <"+(+je+1)+".0.0":_t&&(Ze=">="+je+"."+tt+".0 <"+je+"."+(+tt+1)+".0"),S("xRange return",Ze),Ze})}(X,G)}).join(" ")}(Ge,ke),S("xrange",Ge),Ge=function(nt,G){return S("replaceStars",nt,G),nt.trim().replace(A[te],"")}(Ge,ke),S("stars",Ge),Ge}(Ye,ve)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(Ye){return!!Ye.match(Ne)})),xe=xe.map(function(Ye){return new Y(Ye,ve)})},C.prototype.intersects=function(Z,ve){if(!(Z instanceof C))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return Z.set.some(function(xe){return xe.every(function(Ye){return Ne.intersects(Ye,ve)})})})})},e.toComparators=function(Z,ve){return new C(Z,ve).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},C.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new re(Z,this.loose));for(var ve=0;ve<this.set.length;ve++)if(j(this.set[ve],Z))return!0;return!1},e.satisfies=oe,e.maxSatisfying=function(Z,ve,ge){var Ne=null,xe=null;try{var Ye=new C(ve,ge)}catch{return null}return Z.forEach(function(Ge){Ye.test(Ge)&&(Ne&&xe.compare(Ge)!==-1||(xe=new re(Ne=Ge,ge)))}),Ne},e.minSatisfying=function(Z,ve,ge){var Ne=null,xe=null;try{var Ye=new C(ve,ge)}catch{return null}return Z.forEach(function(Ge){Ye.test(Ge)&&(Ne&&xe.compare(Ge)!==1||(xe=new re(Ne=Ge,ge)))}),Ne},e.validRange=function(Z,ve){try{return new C(Z,ve).range||"*"}catch{return null}},e.ltr=function(Z,ve,ge){return le(Z,ve,"<",ge)},e.gtr=function(Z,ve,ge){return le(Z,ve,">",ge)},e.outside=le,e.prerelease=function(Z,ve){var ge=be(Z,ve);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,ve,ge){return Z=new C(Z,ge),ve=new C(ve,ge),Z.intersects(ve)},e.coerce=function(Z){if(Z instanceof re)return Z;if(typeof Z!="string")return null;var ve=Z.match(A[N]);return ve==null?null:be((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,r(1))},function(ne,e){var r,y,S=ne.exports={};function M(){throw new Error("setTimeout has not been defined")}function _(){throw new Error("clearTimeout has not been defined")}function A(h){if(r===setTimeout)return setTimeout(h,0);if((r===M||!r)&&setTimeout)return r=setTimeout,setTimeout(h,0);try{return r(h,0)}catch{try{return r.call(null,h,0)}catch{return r.call(this,h,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:M}catch{r=M}try{y=typeof clearTimeout=="function"?clearTimeout:_}catch{y=_}})();var E,k=[],O=!1,b=-1;function m(){O&&E&&(O=!1,E.length?k=E.concat(k):b=-1,k.length&&T())}function T(){if(!O){var h=A(m);O=!0;for(var u=k.length;u;){for(E=k,k=[];++b<u;)E&&E[b].run();b=-1,u=k.length}E=null,O=!1,function(v){if(y===clearTimeout)return clearTimeout(v);if((y===_||!y)&&clearTimeout)return y=clearTimeout,clearTimeout(v);try{y(v)}catch{try{return y.call(null,v)}catch{return y.call(this,v)}}}(h)}}function f(h,u){this.fun=h,this.array=u}function c(){}S.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)u[v-1]=arguments[v];k.push(new f(h,u)),k.length!==1||O||A(T)},f.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=c,S.addListener=c,S.once=c,S.off=c,S.removeListener=c,S.removeAllListeners=c,S.emit=c,S.prependListener=c,S.prependOnceListener=c,S.listeners=function(h){return[]},S.binding=function(h){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(h){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Ce[108],Ie([1,0,11,7]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function S(l){const w=l;return w?typeof w.read=="function":!1}e.isReadable=S;function M(l){const w=l;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function _(l){const w=l;return w?M(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=_;function A(l,w){return new E(l,w)}e.newWriteableStream=A;class E{constructor(w,t){this.reducer=w,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w<"u"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(t=>t(w))}emitError(w){this.listeners.error.length===0?(0,r.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(t=>t(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,t){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(w,t){if(this.state.destroyed)return;let d;switch(w){case"data":d=this.listeners.data;break;case"end":d=this.listeners.end;break;case"error":d=this.listeners.error;break}if(d){const i=d.indexOf(t);i>=0&&d.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(d=>d())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function k(l,w){const t=[];let d;for(;(d=l.read())!==null;)t.push(d);return w(t)}e.consumeReadable=k;function O(l,w,t){const d=[];let i;for(;(i=l.read())!==null&&d.length<t;)d.push(i);return i===null&&d.length>0?w(d):{read:()=>{if(d.length>0)return d.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return l.read()}}}e.peekReadable=O;function b(l,w){return new Promise((t,d)=>{const i=[];m(l,{onData:n=>{w&&i.push(n)},onError:n=>{w?d(n):t(void 0)},onEnd:()=>{t(w?w(i):void 0)}})})}e.consumeStream=b;function m(l,w){let t=!1;return l.on("error",d=>{t||w.onError(d)}),l.on("end",()=>{t||w.onEnd()}),l.on("data",d=>{t||w.onData(d)}),(0,y.toDisposable)(()=>t=!0)}e.listenStream=m;function T(l,w){return new Promise((t,d)=>{const i=new y.DisposableStore,n=[],s=g=>{if(n.push(g),n.length>w)return i.dispose(),l.pause(),t({stream:l,buffer:n,ended:!1})},a=g=>d(g),o=()=>t({stream:l,buffer:n,ended:!0});i.add((0,y.toDisposable)(()=>l.removeListener("error",a))),l.on("error",a),i.add((0,y.toDisposable)(()=>l.removeListener("end",o))),l.on("end",o),i.add((0,y.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=T;function f(l,w){const t=A(w);return t.end(l),t}e.toStream=f;function c(){const l=A(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=c;function h(l){let w=!1;return{read:()=>w?null:(w=!0,l)}}e.toReadable=h;function u(l,w,t){const d=A(t);return m(l,{onData:i=>d.write(w.data(i)),onError:i=>d.error(w.error?w.error(i):i),onEnd:()=>d.end()}),d}e.transform=u;function v(l,w,t){let d=!1;return{read:()=>{const i=w.read();return d?i:(d=!0,i!==null?t([l,i]):l)}}}e.prefixedReadable=v;function I(l,w,t){let d=!1;const i=A(t);return m(w,{onData:n=>d?i.write(n):(d=!0,i.write(t([l,n]))),onError:n=>i.error(n),onEnd:()=>{d||(d=!0,i.write(l)),i.end()}}),i}e.prefixedStream=I}),define(Ce[23],Ie([1,0,108]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const y=typeof Buffer<"u";let S,M;class _{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return y?new _(Buffer.allocUnsafe(g)):new _(new Uint8Array(g))}static wrap(g){return y&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new _(g)}static fromString(g,p){return!(p?.dontUseNodeBuffer||!1)&&y?new _(Buffer.from(g)):(S||(S=new TextEncoder),new _(S.encode(g)))}static fromByteArray(g){const p=_.alloc(g.length);for(let P=0,N=g.length;P<N;P++)p.buffer[P]=g[P];return p}static concat(g,p){if(typeof p>"u"){p=0;for(let V=0,U=g.length;V<U;V++)p+=g[V].byteLength}const P=_.alloc(p);let N=0;for(let V=0,U=g.length;V<U;V++){const D=g[V];P.set(D,N),N+=D.byteLength}return P}clone(){const g=_.alloc(this.byteLength);return g.set(this),g}toString(){return y?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(g,p){return new _(this.buffer.subarray(g,p))}set(g,p){if(g instanceof _)this.buffer.set(g.buffer,p);else if(g instanceof Uint8Array)this.buffer.set(g,p);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),p);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return k(this.buffer,g)}writeUInt32BE(g,p){O(this.buffer,g,p)}readUInt32LE(g){return b(this.buffer,g)}writeUInt32LE(g,p){m(this.buffer,g,p)}readUInt8(g){return T(this.buffer,g)}writeUInt8(g,p){f(this.buffer,g,p)}}e.VSBuffer=_;function A(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0}e.readUInt16LE=A;function E(o,g,p){o[p+0]=g&255,g=g>>>8,o[p+1]=g&255}e.writeUInt16LE=E;function k(o,g){return o[g]*2**24+o[g+1]*2**16+o[g+2]*2**8+o[g+3]}e.readUInt32BE=k;function O(o,g,p){o[p+3]=g,g=g>>>8,o[p+2]=g,g=g>>>8,o[p+1]=g,g=g>>>8,o[p]=g}e.writeUInt32BE=O;function b(o,g){return o[g+0]<<0>>>0|o[g+1]<<8>>>0|o[g+2]<<16>>>0|o[g+3]<<24>>>0}e.readUInt32LE=b;function m(o,g,p){o[p+0]=g&255,g=g>>>8,o[p+1]=g&255,g=g>>>8,o[p+2]=g&255,g=g>>>8,o[p+3]=g&255}e.writeUInt32LE=m;function T(o,g){return o[g]}e.readUInt8=T;function f(o,g,p){o[p]=g}e.writeUInt8=f;function c(o){return r.consumeReadable(o,g=>_.concat(g))}e.readableToBuffer=c;function h(o){return r.toReadable(o)}e.bufferToReadable=h;function u(o){return r.consumeStream(o,g=>_.concat(g))}e.streamToBuffer=u;async function v(o){return o.ended?_.concat(o.buffer):_.concat([...o.buffer,await u(o.stream)])}e.bufferedStreamToBuffer=v;function I(o){return r.toStream(o,g=>_.concat(g))}e.bufferToStream=I;function l(o){return r.transform(o,{data:g=>typeof g=="string"?_.fromString(g):_.wrap(g)},g=>_.concat(g))}e.streamToBufferReadableStream=l;function w(o){return r.newWriteableStream(g=>_.concat(g),o)}e.newWriteableBufferStream=w;function t(o,g){return r.prefixedReadable(o,g,p=>_.concat(p))}e.prefixedBufferReadable=t;function d(o,g){return r.prefixedStream(o,g,p=>_.concat(p))}e.prefixedBufferStream=d;function i(o){let g=0,p=0,P=0;const N=new Uint8Array(Math.floor(o.length/4*3)),V=D=>{switch(p){case 3:N[P++]=g|D,p=0;break;case 2:N[P++]=g|D>>>2,g=D<<6,p=3;break;case 1:N[P++]=g|D>>>4,g=D<<4,p=2;break;default:g=D<<2,p=1}};for(let D=0;D<o.length;D++){const x=o.charCodeAt(D);if(x>=65&&x<=90)V(x-65);else if(x>=97&&x<=122)V(x-97+26);else if(x>=48&&x<=57)V(x-48+52);else if(x===43||x===45)V(62);else if(x===47||x===95)V(63);else{if(x===61)break;throw new SyntaxError(`Unexpected base64 character ${o[D]}`)}}const U=P;for(;p>0;)V(0);return _.wrap(N).slice(0,U)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},g=!0,p=!1){const P=p?s:n;let N="";const V=o.byteLength%3;let U=0;for(;U<o.byteLength-V;U+=3){const D=o[U+0],x=o[U+1],L=o[U+2];N+=P[D>>>2],N+=P[(D<<4|x>>>4)&63],N+=P[(x<<2|L>>>6)&63],N+=P[L&63]}if(V===1){const D=o[U+0];N+=P[D>>>2],N+=P[D<<4&63],g&&(N+="==")}else if(V===2){const D=o[U+0],x=o[U+1];N+=P[D>>>2],N+=P[(D<<4|x>>>4)&63],N+=P[x<<2&63],g&&(N+="=")}return N}e.encodeBase64=a}),define(Ce[42],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function y(S){return r.test(S)}e.isUUID=y,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let E=0;E<A.length;E++)A[E]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),_=[];for(let A=0;A<256;A++)_.push(A.toString(16).padStart(2,"0"));return function(){S(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,k="";return k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+="-",k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k+=_[M[E++]],k}}()}),define(Ce[109],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[110],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class y{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let E=0,k=A.notIn.length;E<k;E++)switch(A.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,E){if(A.getTokenCount()===0)return!0;const k=A.findTokenIndexAtOffset(E-2),O=A.getStandardTokenType(k);return this.isOK(O)}_findNeutralCharacterInRange(A,E){for(let k=A;k<=E;k++){const O=String.fromCharCode(k);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=y;class S{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of A)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=S;function M(_,A,E){_.has(A)?_.get(A).push(E):_.set(A,[E])}}),define(Ce[111],Ie([17,18]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(Ce[112],Ie([1,0,111]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const y=60,S=y*60,M=S*24,_=M*7,A=M*30,E=M*365;function k(b,m,T){typeof b!="number"&&(b=b.getTime());const f=Math.round((new Date().getTime()-b)/1e3);if(f<-30)return(0,r.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(f<30)return(0,r.localize)(1,null);let c;return f<y?(c=f,m?c===1?T?(0,r.localize)(2,null,c):(0,r.localize)(3,null,c):T?(0,r.localize)(4,null,c):(0,r.localize)(5,null,c):c===1?T?(0,r.localize)(6,null,c):(0,r.localize)(7,null,c):T?(0,r.localize)(8,null,c):(0,r.localize)(9,null,c)):f<S?(c=Math.floor(f/y),m?c===1?T?(0,r.localize)(10,null,c):(0,r.localize)(11,null,c):T?(0,r.localize)(12,null,c):(0,r.localize)(13,null,c):c===1?T?(0,r.localize)(14,null,c):(0,r.localize)(15,null,c):T?(0,r.localize)(16,null,c):(0,r.localize)(17,null,c)):f<M?(c=Math.floor(f/S),m?c===1?T?(0,r.localize)(18,null,c):(0,r.localize)(19,null,c):T?(0,r.localize)(20,null,c):(0,r.localize)(21,null,c):c===1?T?(0,r.localize)(22,null,c):(0,r.localize)(23,null,c):T?(0,r.localize)(24,null,c):(0,r.localize)(25,null,c)):f<_?(c=Math.floor(f/M),m?c===1?(0,r.localize)(26,null,c):(0,r.localize)(27,null,c):c===1?(0,r.localize)(28,null,c):(0,r.localize)(29,null,c)):f<A?(c=Math.floor(f/_),m?c===1?T?(0,r.localize)(30,null,c):(0,r.localize)(31,null,c):T?(0,r.localize)(32,null,c):(0,r.localize)(33,null,c):c===1?T?(0,r.localize)(34,null,c):(0,r.localize)(35,null,c):T?(0,r.localize)(36,null,c):(0,r.localize)(37,null,c)):f<E?(c=Math.floor(f/A),m?c===1?T?(0,r.localize)(38,null,c):(0,r.localize)(39,null,c):T?(0,r.localize)(40,null,c):(0,r.localize)(41,null,c):c===1?T?(0,r.localize)(42,null,c):(0,r.localize)(43,null,c):T?(0,r.localize)(44,null,c):(0,r.localize)(45,null,c)):(c=Math.floor(f/E),m?c===1?T?(0,r.localize)(46,null,c):(0,r.localize)(47,null,c):T?(0,r.localize)(48,null,c):(0,r.localize)(49,null,c):c===1?T?(0,r.localize)(50,null,c):(0,r.localize)(51,null,c):T?(0,r.localize)(52,null,c):(0,r.localize)(53,null,c))}e.fromNow=k;function O(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ce[113],Ie([17,18]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(Ce[43],Ie([1,0,16,10,113]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(b,m){return m&&(b.stack||b.stacktrace)?S.localize(0,null,A(b),_(b.stack)||_(b.stacktrace)):A(b)}function _(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?S.localize(1,null,b.message):b.message||S.localize(2,null)}function E(b=null,m=!1){if(!b)return S.localize(3,null);if(Array.isArray(b)){const T=r.coalesce(b),f=E(T[0],m);return T.length>1?S.localize(4,null,f,T.length):f}if(y.isString(b))return b;if(b.detail){const T=b.detail;if(T.error)return M(T.error,m);if(T.exception)return M(T.exception,m)}return b.stack?M(b,m):b.message?b.message:S.localize(5,null)}e.toErrorMessage=E;function k(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=k;function O(b,m){let T;return typeof b=="string"?T=new Error(b):T=b,T.actions=m,T}e.createErrorWithActions=O}),define(Ce[74],Ie([1,0,19]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const b=(0,r.extname)(O),m=y[b.toLowerCase()];return m!==void 0?m:_(O)}e.getMediaOrTextMime=M;function _(O){const b=(0,r.extname)(O);return S[b.toLowerCase()]}e.getMediaMime=_;function A(O){for(const b in S)if(S[b]===O)return b}e.getExtensionForMimeType=A;const E=/^(.+)\/(.+?)(;.+)?$/;function k(O,b){const m=E.exec(O);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:O}e.normalizeMimeType=k}),define(Ce[37],Ie([1,0,19,21,9,10]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(s){return s===47||s===92}e.isPathSeparator=_;function A(s){return s.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=A;function E(s){return s.indexOf("/")===-1&&(s=A(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=E;function k(s,a=r.posix.sep){if(!s)return"";const o=s.length,g=s.charCodeAt(0);if(_(g)){if(_(s.charCodeAt(1))&&!_(s.charCodeAt(2))){let P=3;const N=P;for(;P<o&&!_(s.charCodeAt(P));P++);if(N!==P&&!_(s.charCodeAt(P+1))){for(P+=1;P<o;P++)if(_(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,a)}}return a}else if(u(g)&&s.charCodeAt(1)===58)return _(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<o;p++)if(_(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=k;function O(s){if(!y.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let o=2;const g=o;for(;o<s.length&&(a=s.charCodeAt(o),a!==92);o++);return!(g===o||(a=s.charCodeAt(o+1),isNaN(a)||a===92))}e.isUNC=O;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,a=y.isWindows){const o=a?b:m;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||a&&T.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function c(s,a,o){const g=s===a;return!o||g?g:!s||!a?!1:(0,S.equalsIgnoreCase)(s,a)}e.isEqual=c;function h(s,a,o,g=r.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(o){if(!(0,S.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let P=a.length;return a.charAt(a.length-1)===g&&P--,s.charAt(P)===g}return a.charAt(a.length-1)!==g&&(a+=g),s.indexOf(a)===0}e.isEqualOrParent=h;function u(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=u;function v(s,a){return y.isWindows&&s.endsWith(":")&&(s+=r.sep),(0,r.isAbsolute)(s)||(s=(0,r.join)(a,s)),s=(0,r.normalize)(s),y.isWindows?(s=(0,S.rtrim)(s,r.sep),s.endsWith(":")&&(s+=r.sep)):(s=(0,S.rtrim)(s,r.sep),s||(s=r.sep)),s}e.sanitizeFilePath=v;function I(s){const a=(0,r.normalize)(s);return y.isWindows?s.length>3?!1:l(a)&&(s.length===2||a.charCodeAt(2)===92):a===r.posix.sep}e.isRootOrDriveLetter=I;function l(s,a=y.isWindows){return a?u(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function w(s){return l(s)?s[0]:void 0}e.getDriveLetter=w;function t(s,a,o){return a.length>s.length?-1:s===a?0:(o&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}e.indexOfPath=t;function d(s){const a=s.split(":");let o,g,p;for(const P of a){const N=Number(P);(0,M.isNumber)(N)?g===void 0?g=N:p===void 0&&(p=N):o=o?[o,P].join(":"):P}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:g!==void 0?g:void 0,column:p!==void 0?p:g!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,o=8){let g="";for(let P=0;P<o;P++)g+=i.charAt(Math.floor(Math.random()*i.length));let p;return a?p=`${a}-${g}`:p=g,s?(0,r.join)(s,p):p}e.randomPath=n}),define(Ce[24],Ie([1,0,16,9]),function(ne,e,r,y){"use strict";var S,M,_;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(i,n,s){let a=i.get(n);return a===void 0&&(a=s,i.set(n,a)),a}e.getOrSet=A;function E(i){const n=[];return i.forEach((s,a)=>{n.push(`${a} => ${s}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.mapToString=E;function k(i){const n=[];return i.forEach(s=>{n.push(s)}),`Set(${i.size}) {${n.join(", ")}}`}e.setToString=k;class O{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=O;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,y.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class m{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,y.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,y.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var T;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(T||(T={}));class f{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,y.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,y.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,y.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,y.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(h||(h={}));class u{constructor(n){this._iter=n}static forUris(n=()=>!1,s=()=>!1){return new u(new f(n,s))}static forPaths(n=!1){return new u(new m(void 0,!n))}static forStrings(){return new u(new O)}static forConfigKeys(){return new u(new b)}clear(){this._root=void 0}fill(n,s){if(s){const a=s.slice(0);(0,r.shuffle)(a);for(const o of a)this.set(o,n)}else{const a=n.slice(0);(0,r.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(n,s){const a=this._iter.reset(n);let o;this._root||(this._root=new c,this._root.segment=a.value());const g=[];for(o=this._root;;){const P=a.cmp(o.segment);if(P>0)o.left||(o.left=new c,o.left.segment=a.value()),g.push([-1,o]),o=o.left;else if(P<0)o.right||(o.right=new c,o.right.segment=a.value()),g.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new c,o.mid.segment=a.value()),g.push([0,o]),o=o.mid;else break}const p=o.value;o.value=s,o.key=n;for(let P=g.length-1;P>=0;P--){const N=g[P][1];N.updateHeight();const V=N.balanceFactor();if(V<-1||V>1){const U=g[P][0],D=g[P+1][0];if(U===1&&D===1)g[P][1]=N.rotateLeft();else if(U===-1&&D===-1)g[P][1]=N.rotateRight();else if(U===1&&D===-1)N.right=g[P+1][1]=g[P+1][1].rotateRight(),g[P][1]=N.rotateLeft();else if(U===-1&&D===1)N.left=g[P+1][1]=g[P+1][1].rotateLeft(),g[P][1]=N.rotateRight();else throw new Error;if(P>0)switch(g[P-1][0]){case-1:g[P-1][1].left=g[P][1];break;case 1:g[P-1][1].right=g[P][1];break;case 0:g[P-1][1].mid=g[P][1];break}else this._root=g[0][1]}}return p}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const a=this._iter.reset(n),o=[];let g=this._root;for(;g;){const p=a.cmp(g.segment);if(p>0)o.push([-1,g]),g=g.left;else if(p<0)o.push([1,g]),g=g.right;else if(a.hasNext())a.next(),o.push([0,g]),g=g.mid;else break}if(!!g){if(s?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const p=this._min(g.right),{key:P,value:N,segment:V}=p;this._delete(p.key,!1),g.key=P,g.value=N,g.segment=V}else{const p=g.left??g.right;if(o.length>0){const[P,N]=o[o.length-1];switch(P){case-1:N.left=p;break;case 0:N.mid=p;break;case 1:N.right=p;break}}else this._root=p}for(let p=o.length-1;p>=0;p--){const P=o[p][1];P.updateHeight();const N=P.balanceFactor();if(N>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),o[p][1]=P.rotateLeft()):N<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),o[p][1]=P.rotateRight()),p>0)switch(o[p-1][0]){case-1:o[p-1][1].left=o[p][1];break;case 1:o[p-1][1].right=o[p][1];break;case 0:o[p-1][1].mid=o[p][1];break}else this._root=o[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let a=this._root,o;for(;a;){const g=s.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(s.hasNext())s.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[s,a]of this)n(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}e.TernarySearchTree=u;class v{constructor(n,s){this.uri=n,this.value=s}}class I{constructor(n,s){this[S]="ResourceMap",n instanceof I?(this.map=new Map(n.map),this.toKey=s??I.defaultToKey):(this.map=new Map,this.toKey=n??I.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new v(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[a,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=I,I.defaultToKey=i=>i.toString();class l{constructor(n,s){this[M]="ResourceSet",!n||typeof n=="function"?this._map=new I(n):(this._map=new I(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((a,o)=>n.call(s,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var w;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class t{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const a=this._map.get(n);if(!!a)return s!==0&&this.touch(a,s),a.value}set(n,s,a=0){let o=this._map.get(n);if(o)o.value=s,a!==0&&this.touch(o,a);else{switch(o={key:n,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const a=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.key,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.value,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:[a.key,a.value],done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return o}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>n;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,a=n.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const a=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(a.previous=o,o.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const a=n.next,o=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=o,o.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,a)=>{n.push([a,s])}),n}fromJSON(n){this.clear();for(const[s,a]of n)this.set(s,a)}}e.LinkedMap=t;class d extends t{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d}),define(Ce[114],Ie([1,0,24,9]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...Y){return function(ee,C){for(let B=0,H=Y.length;B<H;B++){const j=Y[B](ee,C);if(j)return j}return null}}e.or=S,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Y,ee,C){if(!C||C.length<ee.length)return null;let B;return Y?B=y.startsWithIgnoreCase(C,ee):B=C.indexOf(ee)===0,B?ee.length>0?[{start:0,end:ee.length}]:[]:null}function _(Y,ee){const C=ee.toLowerCase().indexOf(Y.toLowerCase());return C===-1?null:[{start:C,end:C+Y.length}]}e.matchesContiguousSubString=_;function A(Y,ee){return E(Y.toLowerCase(),ee.toLowerCase(),0,0)}e.matchesSubString=A;function E(Y,ee,C,B){if(C===Y.length)return[];if(B===ee.length)return null;if(Y[C]===ee[B]){let H=null;return(H=E(Y,ee,C+1,B+1))?u({start:B,end:B+1},H):null}return E(Y,ee,C,B+1)}function k(Y){return 97<=Y&&Y<=122}function O(Y){return 65<=Y&&Y<=90}e.isUpper=O;function b(Y){return 48<=Y&&Y<=57}function m(Y){return Y===32||Y===9||Y===10||Y===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>T.add(Y.charCodeAt(0)));function f(Y){return m(Y)||T.has(Y)}function c(Y,ee){return Y===ee||f(Y)&&f(ee)}function h(Y){return k(Y)||O(Y)||b(Y)}function u(Y,ee){return ee.length===0?ee=[Y]:Y.end===ee[0].start?ee[0].start=Y.start:ee.unshift(Y),ee}function v(Y,ee){for(let C=ee;C<Y.length;C++){const B=Y.charCodeAt(C);if(O(B)||b(B)||C>0&&!h(Y.charCodeAt(C-1)))return C}return Y.length}function I(Y,ee,C,B){if(C===Y.length)return[];if(B===ee.length)return null;if(Y[C]!==ee[B].toLowerCase())return null;{let H=null,j=B+1;for(H=I(Y,ee,C+1,B+1);!H&&(j=v(ee,j))<ee.length;)H=I(Y,ee,C+1,j),j++;return H===null?null:u({start:B,end:B+1},H)}}function l(Y){let ee=0,C=0,B=0,H=0,j=0;for(let ge=0;ge<Y.length;ge++)j=Y.charCodeAt(ge),O(j)&&ee++,k(j)&&C++,h(j)&&B++,b(j)&&H++;const oe=ee/Y.length,le=C/Y.length,Z=B/Y.length,ve=H/Y.length;return{upperPercent:oe,lowerPercent:le,alphaPercent:Z,numericPercent:ve}}function w(Y){const{upperPercent:ee,lowerPercent:C}=Y;return C===0&&ee>.6}function t(Y){const{upperPercent:ee,lowerPercent:C,alphaPercent:B,numericPercent:H}=Y;return C>.2&&ee<.8&&B>.6&&H<.2}function d(Y){let ee=0,C=0,B=0,H=0;for(let j=0;j<Y.length;j++)B=Y.charCodeAt(j),O(B)&&ee++,k(B)&&C++,m(B)&&H++;return(ee===0||C===0)&&H===0?Y.length<=30:ee<=5}function i(Y,ee){if(!ee||(ee=ee.trim(),ee.length===0)||!d(Y)||ee.length>60)return null;const C=l(ee);if(!t(C)){if(!w(C))return null;ee=ee.toLowerCase()}let B=null,H=0;for(Y=Y.toLowerCase();H<ee.length&&(B=I(Y,ee,0,H))===null;)H=v(ee,H+1);return B}e.matchesCamelCase=i;function n(Y,ee,C=!1){if(!ee||ee.length===0)return null;let B=null,H=0;for(Y=Y.toLowerCase(),ee=ee.toLowerCase();H<ee.length&&(B=s(Y,ee,0,H,C))===null;)H=a(ee,H+1);return B}e.matchesWords=n;function s(Y,ee,C,B,H){if(C===Y.length)return[];if(B===ee.length)return null;if(c(Y.charCodeAt(C),ee.charCodeAt(B))){let j=null,oe=B+1;if(j=s(Y,ee,C+1,B+1,H),!H)for(;!j&&(oe=a(ee,oe))<ee.length;)j=s(Y,ee,C+1,oe,H),oe++;return j?Y.charCodeAt(C)!==ee.charCodeAt(B)?j:u({start:B,end:B+1},j):null}else return null}function a(Y,ee){for(let C=ee;C<Y.length;C++)if(f(Y.charCodeAt(C))||C>0&&f(Y.charCodeAt(C-1)))return C;return Y.length}const o=S(e.matchesPrefix,i,_),g=S(e.matchesPrefix,i,A),p=new r.LRUCache(1e4);function P(Y,ee,C=!1){if(typeof Y!="string"||typeof ee!="string")return null;let B=p.get(Y);B||(B=new RegExp(y.convertSimple2RegExpPattern(Y),"i"),p.set(Y,B));const H=B.exec(ee);return H?[{start:H.index,end:H.index+H[0].length}]:C?g(Y,ee):o(Y,ee)}e.matchesFuzzy=P;function N(Y,ee){const C=We(Y,Y.toLowerCase(),0,ee,ee.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return C?U(C):null}e.matchesFuzzy2=N;function V(Y,ee,C,B,H,j){const oe=Math.min(13,Y.length);for(;C<oe;C++){const le=We(Y,ee,C,B,H,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(le)return le}return[0,j]}e.anyScore=V;function U(Y){if(typeof Y>"u")return[];const ee=[],C=Y[1];for(let B=Y.length-1;B>1;B--){const H=Y[B]+C,j=ee[ee.length-1];j&&j.end===H?j.end=H+1:ee.push({start:H,end:H+1})}return ee}e.createMatches=U;const D=128;function x(){const Y=[],ee=[];for(let C=0;C<=D;C++)ee[C]=0;for(let C=0;C<=D;C++)Y.push(ee.slice(0));return Y}function L(Y){const ee=[];for(let C=0;C<=Y;C++)ee[C]=0;return ee}const R=L(2*D),K=L(2*D),W=x(),$=x(),fe=x(),J=!1;function Q(Y,ee,C,B,H){function j(le,Z,ve=" "){for(;le.length<Z;)le=ve+le;return le}let oe=` |   |${B.split("").map(le=>j(le,3)).join("|")}
`;for(let le=0;le<=C;le++)le===0?oe+=" |":oe+=`${ee[le-1]}|`,oe+=Y[le].slice(0,H+1).map(Z=>j(Z.toString(),3)).join("|")+`
`;return oe}function ce(Y,ee,C,B){Y=Y.substr(ee),C=C.substr(B),console.log(Q($,Y,Y.length,C,C.length)),console.log(Q(fe,Y,Y.length,C,C.length)),console.log(Q(W,Y,Y.length,C,C.length))}function te(Y,ee){if(ee<0||ee>=Y.length)return!1;const C=Y.codePointAt(ee);switch(C){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!y.isEmojiImprecise(C)}}function pe(Y,ee){if(ee<0||ee>=Y.length)return!1;switch(Y.charCodeAt(ee)){case 32:case 9:return!0;default:return!1}}function be(Y,ee,C){return ee[Y]!==C[Y]}function re(Y,ee,C,B,H,j,oe=!1){for(;ee<C&&H<j;)Y[ee]===B[H]&&(oe&&(R[ee]=H),ee+=1),H+=1;return ee===C}e.isPatternInWord=re;var Ee;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Pe;(function(Y){Y.Default=[-100,0];function ee(C){return!C||C.length===2&&C[0]===-100&&C[1]===0}Y.isDefault=ee})(Pe=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(ee,C){this.firstMatchCanBeWeak=ee,this.boostFullMatch=C}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function We(Y,ee,C,B,H,j,oe=Fe.default){const le=Y.length>D?D:Y.length,Z=B.length>D?D:B.length;if(C>=le||j>=Z||le-C>Z-j||!re(ee,C,le,H,j,Z,!0))return;Xe(le,Z,C,j,ee,H);let ve=1,ge=1,Ne=C,xe=j;const Ye=[!1];for(ve=1,Ne=C;Ne<le;ve++,Ne++){const X=R[Ne],he=K[Ne],Ue=Ne+1<le?K[Ne+1]:Z;for(ge=X-j+1,xe=X;xe<Ue;ge++,xe++){let Ve=Number.MIN_SAFE_INTEGER,Ze=!1;xe<=he&&(Ve=Te(Y,ee,Ne,C,B,H,xe,Z,j,W[ve-1][ge-1]===0,Ye));let Ke=0;Ve!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Ke=Ve+$[ve-1][ge-1]);const je=xe>X,tt=je?$[ve][ge-1]+(W[ve][ge-1]>0?-5:0):0,st=xe>X+1&&W[ve][ge-1]>0,dt=st?$[ve][ge-2]+(W[ve][ge-2]>0?-5:0):0;if(st&&(!je||dt>=tt)&&(!Ze||dt>=Ke))$[ve][ge]=dt,fe[ve][ge]=3,W[ve][ge]=0;else if(je&&(!Ze||tt>=Ke))$[ve][ge]=tt,fe[ve][ge]=2,W[ve][ge]=0;else if(Ze)$[ve][ge]=Ke,fe[ve][ge]=1,W[ve][ge]=W[ve-1][ge-1]+1;else throw new Error("not possible")}}if(J&&ce(Y,C,B,j),!Ye[0]&&!oe.firstMatchCanBeWeak)return;ve--,ge--;const Ge=[$[ve][ge],j];let ke=0,nt=0;for(;ve>=1;){let X=ge;do{const he=fe[ve][X];if(he===3)X=X-2;else if(he===2)X=X-1;else break}while(X>=1);ke>1&&ee[C+ve-1]===H[j+ge-1]&&!be(X+j-1,B,H)&&ke+1>W[ve][X]&&(X=ge),X===ge?ke++:ke=1,nt||(nt=X),ve--,ge=X-1,Ge.push(ge)}Z===le&&oe.boostFullMatch&&(Ge[0]+=2);const G=nt-le;return Ge[0]-=G,Ge}e.fuzzyScore=We;function Xe(Y,ee,C,B,H,j){let oe=Y-1,le=ee-1;for(;oe>=C&&le>=B;)H[oe]===j[le]&&(K[oe]=le,oe--),le--}function Te(Y,ee,C,B,H,j,oe,le,Z,ve,ge){if(ee[C]!==j[oe])return Number.MIN_SAFE_INTEGER;let Ne=1,xe=!1;return oe===C-B?Ne=Y[C]===H[oe]?7:5:be(oe,H,j)&&(oe===0||!be(oe-1,H,j))?(Ne=Y[C]===H[oe]?7:5,xe=!0):te(j,oe)&&(oe===0||!te(j,oe-1))?Ne=5:(te(j,oe-1)||pe(j,oe-1))&&(Ne=5,xe=!0),Ne>1&&C===B&&(ge[0]=!0),xe||(xe=be(oe,H,j)||te(j,oe-1)||pe(j,oe-1)),C===B?oe>Z&&(Ne-=xe?3:5):ve?Ne+=xe?2:0:Ne+=xe?0:1,oe+1===le&&(Ne-=xe?3:5),Ne}function _e(Y,ee,C,B,H,j,oe){return ae(Y,ee,C,B,H,j,!0,oe)}e.fuzzyScoreGracefulAggressive=_e;function ye(Y,ee,C,B,H,j,oe){return ae(Y,ee,C,B,H,j,!1,oe)}e.fuzzyScoreGraceful=ye;function ae(Y,ee,C,B,H,j,oe,le){let Z=We(Y,ee,C,B,H,j,le);if(Z&&!oe)return Z;if(Y.length>=3){const ve=Math.min(7,Y.length-1);for(let ge=C+1;ge<ve;ge++){const Ne=ue(Y,ge);if(Ne){const xe=We(Ne,Ne.toLowerCase(),C,B,H,j,le);xe&&(xe[0]-=3,(!Z||xe[0]>Z[0])&&(Z=xe))}}}return Z}function ue(Y,ee){if(ee+1>=Y.length)return;const C=Y[ee],B=Y[ee+1];if(C!==B)return Y.slice(0,ee)+B+C+Y.slice(ee+2)}}),define(Ce[115],Ie([1,0,116,114,9]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(r.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${M.source}`,"g");function E(h){return h.replace(A,(u,v)=>v?u:`\\${u}`)}e.escapeIcons=E;const k=new RegExp(`\\\\${M.source}`,"g");function O(h){return h.replace(k,u=>`\\${u}`)}e.markdownEscapeEscapedIcons=O;const b=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(b,(u,v,I,l)=>I?u:v||l||"")}e.stripIcons=m;function T(h){const u=h.indexOf(e.iconStartMarker);return u===-1?{text:h}:f(h,u)}e.parseLabelWithIcons=T;function f(h,u){const v=[];let I="";function l(o){if(o){I+=o;for(const g of o)v.push(d)}}let w=-1,t="",d=0,i,n,s=u;const a=h.length;for(l(h.substr(0,u));s<a;)i=h[s],n=h[s+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(w=s,l(t),t=e.iconStartMarker,s++):i===")"&&w!==-1?(d+=s-w+1,w=-1,t=""):w!==-1?_.test(i)?t+=i:(l(t),w=-1,t=""):l(i),s++;return l(t),{text:I,iconOffsets:v}}function c(h,u,v=!1){const{text:I,iconOffsets:l}=u;if(!l||l.length===0)return(0,y.matchesFuzzy)(h,I,v);const w=(0,S.ltrim)(I," "),t=I.length-w.length,d=(0,y.matchesFuzzy)(h,w,v);if(d)for(const i of d){const n=l[i.start+t]+t;i.start+=n,i.end+=n}return d}e.matchesFuzzyIconAware=c}),define(Ce[29],Ie([1,0,9]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var y;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(y||(y={})),function(S){const M="error",_="warning",A="warn",E="info",k="ignore";function O(m){return m?r.equalsIgnoreCase(M,m)?S.Error:r.equalsIgnoreCase(_,m)||r.equalsIgnoreCase(A,m)?S.Warning:r.equalsIgnoreCase(E,m)?S.Info:S.Ignore:S.Ignore}S.fromValue=O;function b(m){switch(m){case S.Error:return M;case S.Warning:return _;case S.Info:return E;default:return k}}S.toString=b}(y||(y={})),e.default=y}),define(Ce[75],Ie([1,0,23,9,2]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(k){return JSON.stringify(k,A)}e.stringify=M;function _(k){let O=JSON.parse(k);return O=E(O),O}e.parse=_;function A(k,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,y.regExpFlags)(O)}:O}function E(k,O=0){if(!k||O>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return S.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 14:return new Date(k.source)}if(k instanceof r.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let b=0;b<k.length;++b)k[b]=E(k[b],O+1);else for(const b in k)Object.hasOwnProperty.call(k,b)&&(k[b]=E(k[b],O+1))}return k}e.revive=E}),define(Ce[12],Ie([1,0,21,2]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var S;(function(E){E.inMemory="inmemory",E.vscode="vscode",E.internal="private",E.walkThrough="walkThrough",E.walkThroughSnippet="walkThroughSnippet",E.http="http",E.https="https",E.file="file",E.mailto="mailto",E.untitled="untitled",E.data="data",E.command="command",E.vscodeRemote="vscode-remote",E.vscodeRemoteResource="vscode-remote-resource",E.vscodeUserData="vscode-userdata",E.vscodeCustomEditor="vscode-custom-editor",E.vscodeNotebook="vscode-notebook",E.vscodeNotebookCell="vscode-notebook-cell",E.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",E.vscodeNotebookCellOutput="vscode-notebook-cell-output",E.vscodeInteractive="vscode-interactive",E.vscodeInteractiveInput="vscode-interactive-input",E.vscodeSettings="vscode-settings",E.vscodeWorkspaceTrust="vscode-workspace-trust",E.vscodeTerminal="vscode-terminal",E.webviewPanel="webview-panel",E.vscodeWebview="vscode-webview",E.extension="extension",E.vscodeFileResource="vscode-file",E.tmp="tmp",E.vsls="vsls",E.vscodeSourceControl="vscode-scm"})(S=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(k){this._preferredWebSchema=k}setDelegate(k){this._delegate=k}setServerRootPath(k){this._remoteResourcesPath=`${k}/${S.vscodeRemoteResource}`}set(k,O,b){this._hosts[k]=O,this._ports[k]=b}setConnectionToken(k,O){this._connectionTokens[k]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(k){if(this._delegate)return this._delegate(k);const O=k.authority;let b=this._hosts[O];b&&b.indexOf(":")!==-1&&(b=`[${b}]`);const m=this._ports[O],T=this._connectionTokens[O];let f=`path=${encodeURIComponent(k.path)}`;return typeof T=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(T)}`),y.URI.from({scheme:r.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${b}:${m}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new M;class _{asBrowserUri(k,O){const b=this.toUri(k,O);return b.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===S.file&&(r.isNative||r.isWebWorker&&r.globals.origin===`${S.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?b.with({scheme:S.vscodeFileResource,authority:b.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(k,O){const b=this.toUri(k,O);return b.scheme===S.vscodeFileResource?b.with({scheme:S.file,authority:b.authority!==_.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(k,O){return y.URI.isUri(k)?k:y.URI.parse(O.toUrl(k))}}_.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new _;var A;(function(E){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);E.CoopAndCoep=Object.freeze(k.get("3"));const O="vscode-coi";function b(T){let f;typeof T=="string"?f=new URL(T).searchParams:T instanceof URL?f=T.searchParams:y.URI.isUri(T)&&(f=new URL(T.toString(!0)).searchParams);const c=f?.get(O);if(!!c)return k.get(c)}E.getHeadersFromQuery=b;function m(T,f,c){if(!globalThis.crossOriginIsolated)return;const h=f&&c?"3":c?"2":"1";T instanceof URLSearchParams?T.set(O,h):T[O]=h}E.addSearchParam=m})(A=e.COI||(e.COI={}))}),define(Ce[22],Ie([1,0,37,12,19,21,9,2]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(T){return(0,A.uriToFsPath)(T,!0)}e.originalFSPath=E;class k{constructor(f){this._ignorePathCasing=f}compare(f,c,h=!1){return f===c?0:(0,_.compare)(this.getComparisonKey(f,h),this.getComparisonKey(c,h))}isEqual(f,c,h=!1){return f===c?!0:!f||!c?!1:this.getComparisonKey(f,h)===this.getComparisonKey(c,h)}getComparisonKey(f,c=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,c,h=!1){if(f.scheme===c.scheme){if(f.scheme===y.Schemas.file)return r.isEqualOrParent(E(f),E(c),this._ignorePathCasing(f))&&f.query===c.query&&(h||f.fragment===c.fragment);if((0,e.isEqualAuthority)(f.authority,c.authority))return r.isEqualOrParent(f.path,c.path,this._ignorePathCasing(f),"/")&&f.query===c.query&&(h||f.fragment===c.fragment)}return!1}joinPath(f,...c){return A.URI.joinPath(f,...c)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return S.posix.basename(f.path)}extname(f){return S.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let c;return f.scheme===y.Schemas.file?c=A.URI.file(S.dirname(E(f))).path:(c=S.posix.dirname(f.path),f.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),c="/")),f.with({path:c})}normalizePath(f){if(!f.path.length)return f;let c;return f.scheme===y.Schemas.file?c=A.URI.file(S.normalize(E(f))).path:c=S.posix.normalize(f.path),f.with({path:c})}relativePath(f,c){if(f.scheme!==c.scheme||!(0,e.isEqualAuthority)(f.authority,c.authority))return;if(f.scheme===y.Schemas.file){const v=S.relative(E(f),E(c));return M.isWindows?r.toSlashes(v):v}let h=f.path||"/";const u=c.path||"/";if(this._ignorePathCasing(f)){let v=0;for(const I=Math.min(h.length,u.length);v<I&&!(h.charCodeAt(v)!==u.charCodeAt(v)&&h.charAt(v).toLowerCase()!==u.charAt(v).toLowerCase());v++);h=u.substr(0,v)+h.substr(v)}return S.posix.relative(h,u)}resolvePath(f,c){if(f.scheme===y.Schemas.file){const h=A.URI.file(S.resolve(E(f),c));return f.with({authority:h.authority,path:h.path})}return c=r.toPosixPath(c),f.with({path:S.posix.resolve(f.path,c)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,c){return f===c||f!==void 0&&c!==void 0&&(0,_.equalsIgnoreCase)(f,c)}hasTrailingPathSeparator(f,c=S.sep){if(f.scheme===y.Schemas.file){const h=E(f);return h.length>r.getRoot(h).length&&h[h.length-1]===c}else{const h=f.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,c=S.sep){return(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,c=S.sep){let h=!1;if(f.scheme===y.Schemas.file){const u=E(f);h=u!==void 0&&u.length===r.getRoot(u).length&&u[u.length-1]===c}else{c="/";const u=f.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(f,c)?f.with({path:f.path+"/"}):f}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(T=>T.scheme===y.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new k(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(T,f){const c=[];for(let h=0;h<T.length;h++){const u=f(T[h]);T.some((v,I)=>I===h?!1:(0,e.isEqualOrParent)(u,f(v)))||c.push(T[h])}return c}e.distinctParents=O;var b;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function f(c){const h=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(I=>{const[l,w]=I.split(":");l&&w&&h.set(l,w)});const v=c.path.substring(0,c.path.indexOf(";"));return v&&h.set(T.META_DATA_MIME,v),h}T.parseMetaData=f})(b=e.DataUri||(e.DataUri={}));function m(T,f,c){if(f){let h=T.path;return h&&h[0]!==S.posix.sep&&(h=S.posix.sep+h),T.with({scheme:c,authority:f,path:h})}return T.with({scheme:c})}e.toLocalResource=m}),define(Ce[14],Ie([1,0,20,11,5,7,22,21]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(be){return!!be&&typeof be.then=="function"}e.isThenable=E;function k(be){const re=new r.CancellationTokenSource,Ee=be(re.token),Pe=new Promise((Fe,We)=>{const Xe=re.token.onCancellationRequested(()=>{Xe.dispose(),re.dispose(),We(new y.CancellationError)});Promise.resolve(Ee).then(Te=>{Xe.dispose(),re.dispose(),Fe(Te)},Te=>{Xe.dispose(),re.dispose(),We(Te)})});return new class{cancel(){re.cancel()}then(Fe,We){return Pe.then(Fe,We)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Pe.finally(Fe)}}}e.createCancelablePromise=k;function O(be,re,Ee){return new Promise((Pe,Fe)=>{const We=re.onCancellationRequested(()=>{We.dispose(),Pe(Ee)});be.then(Pe,Fe).finally(()=>We.dispose())})}e.raceCancellation=O;function b(be,re){return new Promise((Ee,Pe)=>{const Fe=re.onCancellationRequested(()=>{Fe.dispose(),Pe(new y.CancellationError)});be.then(Ee,Pe).finally(()=>Fe.dispose())})}e.raceCancellationError=b;async function m(be){let re=-1;const Ee=be.map((Fe,We)=>Fe.then(Xe=>(re=We,Xe))),Pe=await Promise.race(Ee);return be.forEach((Fe,We)=>{We!==re&&Fe.cancel()}),Pe}e.raceCancellablePromises=m;function T(be,re,Ee){let Pe;const Fe=setTimeout(()=>{Pe?.(void 0),Ee?.()},re);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise(We=>Pe=We)])}e.raceTimeout=T;function f(be){return new Promise((re,Ee)=>{const Pe=be();E(Pe)?Pe.then(re,Ee):re(Pe)})}e.asPromise=f;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(re){if(this.activePromise){if(this.queuedPromiseFactory=re,!this.queuedPromise){const Ee=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(Ee,Ee).then(Pe)})}return new Promise((Ee,Pe)=>{this.queuedPromise.then(Ee,Pe)})}return this.activePromise=re(),new Promise((Ee,Pe)=>{this.activePromise.then(Fe=>{this.activePromise=null,Ee(Fe)},Fe=>{this.activePromise=null,Pe(Fe)})})}}e.Throttler=c;class h{constructor(){this.current=Promise.resolve(null)}queue(re){return this.current=this.current.then(()=>re(),()=>re())}}e.Sequencer=h;class u{constructor(){this.promiseMap=new Map}queue(re,Ee){const Fe=(this.promiseMap.get(re)??Promise.resolve()).catch(()=>{}).then(Ee).finally(()=>{this.promiseMap.get(re)===Fe&&this.promiseMap.delete(re)});return this.promiseMap.set(re,Fe),Fe}}e.SequencerByKey=u;const v=(be,re)=>{let Ee=!0;const Pe=setTimeout(()=>{Ee=!1,re()},be);return{isTriggered:()=>Ee,dispose:()=>{clearTimeout(Pe),Ee=!1}}},I=be=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,be())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(re){this.defaultDelay=re,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(re,Ee=this.defaultDelay){this.task=re,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,We)=>{this.doResolve=Fe,this.doReject=We}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ee===e.MicrotaskDelay?I(Pe):v(Ee,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new y.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class w{constructor(re){this.delayer=new l(re),this.throttler=new c}trigger(re,Ee){return this.delayer.trigger(()=>this.throttler.queue(re),Ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class t{constructor(){this._isOpen=!1,this._promise=new Promise((re,Ee)=>{this._completePromise=re})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=t;class d extends t{constructor(re){super(),this._timeout=setTimeout(()=>this.open(),re)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function i(be,re){return re?new Promise((Ee,Pe)=>{const Fe=setTimeout(()=>{We.dispose(),Ee()},be),We=re.onCancellationRequested(()=>{clearTimeout(Fe),We.dispose(),Pe(new y.CancellationError)})}):k(Ee=>i(be,Ee))}e.timeout=i;function n(be,re=0){const Ee=setTimeout(be,re);return(0,M.toDisposable)(()=>clearTimeout(Ee))}e.disposableTimeout=n;function s(be){const re=[];let Ee=0;const Pe=be.length;function Fe(){return Ee<Pe?be[Ee++]():null}function We(Xe){Xe!=null&&re.push(Xe);const Te=Fe();return Te?Te.then(We):Promise.resolve(re)}return Promise.resolve(null).then(We)}e.sequence=s;function a(be,re=Pe=>!!Pe,Ee=null){let Pe=0;const Fe=be.length,We=()=>{if(Pe>=Fe)return Promise.resolve(Ee);const Xe=be[Pe++];return Promise.resolve(Xe()).then(_e=>re(_e)?Promise.resolve(_e):We())};return We()}e.first=a;function o(be,re=Pe=>!!Pe,Ee=null){if(be.length===0)return Promise.resolve(Ee);let Pe=be.length;const Fe=()=>{Pe=-1;for(const We of be)We.cancel?.()};return new Promise((We,Xe)=>{for(const Te of be)Te.then(_e=>{--Pe>=0&&re(_e)?(Fe(),We(_e)):Pe===0&&We(Ee)}).catch(_e=>{--Pe>=0&&(Fe(),Xe(_e))})})}e.firstParallel=o;class g{constructor(re){this._size=0,this.maxDegreeOfParalellism=re,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new S.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(re){return this._size++,new Promise((Ee,Pe)=>{this.outstandingPromises.push({factory:re,c:Ee,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const re=this.outstandingPromises.shift();this.runningPromises++;const Ee=re.factory();Ee.then(re.c,re.e),Ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=g;class p extends g{constructor(){super(1)}}e.Queue=p;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const re=new fe;return this.drainers.add(re),re.p}isDrained(){for(const[,re]of this.queues)if(re.size>0)return!1;return!0}queueFor(re,Ee=_.extUri){const Pe=Ee.getComparisonKey(re);let Fe=this.queues.get(Pe);return Fe||(Fe=new p,S.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Pe),this.onDidQueueDrain()}),this.queues.set(Pe,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const re of this.drainers)re.complete();this.drainers.clear()}dispose(){for(const[,re]of this.queues)re.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class N{constructor(re,Ee){this._token=-1,typeof re=="function"&&typeof Ee=="number"&&this.setIfNotSet(re,Ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(re,Ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,re()},Ee)}setIfNotSet(re,Ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,re()},Ee))}}e.TimeoutTimer=N;class V{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(re,Ee){this.cancel(),this._token=setInterval(()=>{re()},Ee)}}e.IntervalTimer=V;class U{constructor(re,Ee){this.timeoutToken=-1,this.runner=re,this.timeout=Ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(re=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,re)}get delay(){return this.timeout}set delay(re){this.timeout=re}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=U;class D{constructor(re,Ee){Ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.runner=re,this.timeout=Ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(re=this.timeout){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(re/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=D;class x extends U{constructor(re,Ee){super(re,Ee),this.units=[]}work(re){this.units.push(re),this.isScheduled()||this.schedule()}doRun(){const re=this.units;this.units=[],this.runner?.(re)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x;class L extends M.Disposable{constructor(re,Ee){super(),this.options=re,this.handler=Ee,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(re){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+re.length>this.options.maxBufferedWork)return!1}else if(this.pending+re.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...re),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new U(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,A.setTimeout0)(()=>{if(re)return;const Ee=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ee-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.runWhenIdle=(be,re)=>{const Ee=requestIdleCallback(be,typeof re=="number"?{timeout:re}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(Ee))}}}}();class R{constructor(re){this._didRun=!1,this._executor=()=>{try{this._value=re()}catch(Ee){this._error=Ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function K(be,re,Ee){let Pe;for(let Fe=0;Fe<Ee;Fe++)try{return await be()}catch(We){Pe=We,await i(re)}throw Pe}e.retry=K;class W{hasPending(re){return this._pending?typeof re=="number"?this._pending.taskId===re:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(re,Ee,Pe){return this._pending={taskId:re,cancel:()=>Pe?.(),promise:Ee},Ee.then(()=>this.donePending(re),()=>this.donePending(re)),Ee}donePending(re){this._pending&&re===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const re=this._next;this._next=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}setNext(re){if(this._next)this._next.run=re;else{let Ee,Pe;const Fe=new Promise((We,Xe)=>{Ee=We,Pe=Xe});this._next={run:re,promise:Fe,promiseResolve:Ee,promiseReject:Pe}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=W;class ${constructor(re,Ee=()=>Date.now()){this.interval=re,this.nowFn=Ee,this.lastIncrementTime=0,this.value=0}increment(){const re=this.nowFn();return re-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=re,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class fe{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((re,Ee)=>{this.completeCallback=re,this.errorCallback=Ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(re){return new Promise(Ee=>{this.completeCallback(re),this.resolved=!0,Ee()})}error(re){return new Promise(Ee=>{this.errorCallback(re),this.rejected=!0,Ee()})}cancel(){new Promise(re=>{this.errorCallback(new y.CancellationError),this.rejected=!0,re()})}}e.DeferredPromise=fe;var J;(function(be){async function re(Pe){let Fe;const We=await Promise.all(Pe.map(Xe=>Xe.then(Te=>Te,Te=>{Fe||(Fe=Te)})));if(typeof Fe<"u")throw Fe;return We}be.settled=re;function Ee(Pe){return new Promise(async(Fe,We)=>{try{await Pe(Fe,We)}catch(Xe){We(Xe)}})}be.withAsyncBody=Ee})(J=e.Promises||(e.Promises={}));var Q;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(Q||(Q={}));class ce{constructor(re){this._state=0,this._results=[],this._error=null,this._onStateChanged=new S.Emitter,queueMicrotask(async()=>{const Ee={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(re(Ee)),this.resolve()}catch(Pe){this.reject(Pe)}finally{Ee.emitOne=void 0,Ee.emitMany=void 0,Ee.reject=void 0}})}static fromArray(re){return new ce(Ee=>{Ee.emitMany(re)})}static fromPromise(re){return new ce(async Ee=>{Ee.emitMany(await re)})}static fromPromises(re){return new ce(async Ee=>{await Promise.all(re.map(async Pe=>Ee.emitOne(await Pe)))})}static merge(re){return new ce(async Ee=>{await Promise.all(re.map(async Pe=>{for await(const Fe of Pe)Ee.emitOne(Fe)}))})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(re<this._results.length)return{done:!1,value:this._results[re++]};if(this._state===1)return{done:!0,value:void 0};await S.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(re,Ee){return new ce(async Pe=>{for await(const Fe of re)Pe.emitOne(Ee(Fe))})}map(re){return ce.map(this,re)}static filter(re,Ee){return new ce(async Pe=>{for await(const Fe of re)Ee(Fe)&&Pe.emitOne(Fe)})}filter(re){return ce.filter(this,re)}static coalesce(re){return ce.filter(re,Ee=>!!Ee)}coalesce(){return ce.coalesce(this)}static async toPromise(re){const Ee=[];for await(const Pe of re)Ee.push(Pe);return Ee}toPromise(){return ce.toPromise(this)}emitOne(re){this._state===0&&(this._results.push(re),this._onStateChanged.fire())}emitMany(re){this._state===0&&(this._results=this._results.concat(re),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(re){this._state===0&&(this._state=2,this._error=re,this._onStateChanged.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class te extends ce{constructor(re,Ee){super(Ee),this._source=re}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function pe(be){const re=new r.CancellationTokenSource,Ee=be(re.token);return new te(re,async Pe=>{const Fe=re.token.onCancellationRequested(()=>{Fe.dispose(),re.dispose(),Pe.reject(new y.CancellationError)});try{for await(const We of Ee){if(re.token.isCancellationRequested)return;Pe.emitOne(We)}Fe.dispose(),re.dispose()}catch(We){Fe.dispose(),re.dispose(),Pe.reject(We)}})}e.createCancelableAsyncIterable=pe}),define(Ce[117],Ie([1,0,14,19]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new r.IdleValue(()=>{const p=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:p,collatorIsNumeric:p.resolvedOptions().numeric}}),M=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(p,P,N=!1){const V=p||"",U=P||"",D=S.value.collator.compare(V,U);return S.value.collatorIsNumeric&&D===0&&V!==U?V<U?-1:1:D}e.compareFileNames=A;function E(p,P){const N=M.value.collator;return p=p||"",P=P||"",w(N,p,P)}e.compareFileNamesDefault=E;function k(p,P){const N=M.value.collator;return p=p||"",P=P||"",n(p,P)||w(N,p,P)}e.compareFileNamesUpper=k;function O(p,P){const N=M.value.collator;return p=p||"",P=P||"",i(p,P)||w(N,p,P)}e.compareFileNamesLower=O;function b(p,P){return p=p||"",P=P||"",p===P?0:p<P?-1:1}e.compareFileNamesUnicode=b;function m(p,P,N=!1){N||(p=p&&p.toLowerCase(),P=P&&P.toLowerCase());const[V,U]=I(p),[D,x]=I(P);return V!==D?V<D?-1:1:U===x?0:U<x?-1:1}e.noIntlCompareFileNames=m;function T(p,P){const[N,V]=I(p),[U,D]=I(P);let x=S.value.collator.compare(V,D);if(x===0){if(S.value.collatorIsNumeric&&V!==D)return V<D?-1:1;if(x=S.value.collator.compare(N,U),S.value.collatorIsNumeric&&x===0&&N!==U)return N<U?-1:1}return x}e.compareFileExtensions=T;function f(p,P){p=p||"",P=P||"";const N=l(p),V=l(P),U=M.value.collator,D=_.value.collator;return w(D,N,V)||w(U,p,P)}e.compareFileExtensionsDefault=f;function c(p,P){p=p||"",P=P||"";const N=l(p),V=l(P),U=M.value.collator,D=_.value.collator;return w(D,N,V)||n(p,P)||w(U,p,P)}e.compareFileExtensionsUpper=c;function h(p,P){p=p||"",P=P||"";const N=l(p),V=l(P),U=M.value.collator,D=_.value.collator;return w(D,N,V)||i(p,P)||w(U,p,P)}e.compareFileExtensionsLower=h;function u(p,P){p=p||"",P=P||"";const N=l(p).toLowerCase(),V=l(P).toLowerCase();return N!==V?N<V?-1:1:p!==P?p<P?-1:1:0}e.compareFileExtensionsUnicode=u;const v=/^(.*?)(\.([^.]*))?$/;function I(p,P=!1){const N=p?v.exec(p):[];let V=[N&&N[1]||"",N&&N[3]||""];return P&&(!V[0]&&V[1]||V[0]&&V[0].charAt(0)===".")&&(V=[V[0]+"."+V[1],""]),V}function l(p){const P=p?v.exec(p):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function w(p,P,N){const V=p.compare(P,N);return V!==0?V:P.length!==N.length?P.length<N.length?-1:1:0}function t(p){const P=p.charAt(0);return P.toLocaleUpperCase()!==P}function d(p){const P=p.charAt(0);return P.toLocaleLowerCase()!==P}function i(p,P){return t(p)&&d(P)?-1:d(p)&&t(P)?1:0}function n(p,P){return d(p)&&t(P)?-1:t(p)&&d(P)?1:0}function s(p,P,N=!1){return N||(p=p&&p.toLowerCase(),P=P&&P.toLowerCase()),p===P?0:p<P?-1:1}function a(p,P,N=!1){const V=p.split(y.sep),U=P.split(y.sep),D=V.length-1,x=U.length-1;let L,R;for(let K=0;;K++){if(L=D===K,R=x===K,L&&R)return A(V[K],U[K],N);if(L)return-1;if(R)return 1;const W=s(V[K],U[K],N);if(W!==0)return W}}e.comparePaths=a;function o(p,P,N){const V=p.toLowerCase(),U=P.toLowerCase(),D=g(p,P,N);if(D)return D;const x=V.endsWith(N),L=U.endsWith(N);if(x!==L)return x?-1:1;const R=A(V,U);return R!==0?R:V.localeCompare(U)}e.compareAnything=o;function g(p,P,N){const V=p.toLowerCase(),U=P.toLowerCase(),D=V.startsWith(N),x=U.startsWith(N);if(D!==x)return D?-1:1;if(D&&x){if(V.length<U.length)return-1;if(V.length>U.length)return 1}return 0}e.compareByPrefix=g}),define(Ce[34],Ie([1,0,16,14,37,24,19,21,9]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",b="[^/\\\\]",m=/\//g;function T(fe,J){switch(fe){case 0:return"";case 1:return`${b}*?`;default:return`(?:${O}|${b}+${O}${J?`|${O}${b}+`:""})*?`}}function f(fe,J){if(!fe)return[];const Q=[];let ce=!1,te=!1,pe="";for(const be of fe){switch(be){case J:if(!ce&&!te){Q.push(pe),pe="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":te=!0;break;case"]":te=!1;break}pe+=be}return pe&&Q.push(pe),Q}e.splitGlobAware=f;function c(fe){if(!fe)return"";let J="";const Q=f(fe,e.GLOB_SPLIT);if(Q.every(ce=>ce===e.GLOBSTAR))J=".*";else{let ce=!1;Q.forEach((te,pe)=>{if(te===e.GLOBSTAR){if(ce)return;J+=T(2,pe===Q.length-1)}else{let be=!1,re="",Ee=!1,Pe="";for(const Fe of te){if(Fe!=="}"&&be){re+=Fe;continue}if(Ee&&(Fe!=="]"||!Pe)){let We;Fe==="-"?We=Fe:(Fe==="^"||Fe==="!")&&!Pe?We="^":Fe===e.GLOB_SPLIT?We="":We=(0,E.escapeRegExpCharacters)(Fe),Pe+=We;continue}switch(Fe){case"{":be=!0;continue;case"[":Ee=!0;continue;case"}":{J+=`(?:${f(re,",").map(Te=>c(Te)).join("|")})`,be=!1,re="";break}case"]":{J+="["+Pe+"]",Ee=!1,Pe="";break}case"?":J+=b;continue;case"*":J+=T(1);continue;default:J+=(0,E.escapeRegExpCharacters)(Fe)}}pe<Q.length-1&&(Q[pe+1]!==e.GLOBSTAR||pe+2<Q.length)&&(J+=O)}ce=te===e.GLOBSTAR})}return J}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,I=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),d=function(){return!1},i=function(){return null};function n(fe,J){if(!fe)return i;let Q;typeof fe!="string"?Q=fe.pattern:Q=fe,Q=Q.trim();const ce=`${Q}_${!!J.trimForExclusions}`;let te=t.get(ce);if(te)return s(te,fe);let pe;return h.test(Q)?te=o(Q.substr(4),Q):(pe=u.exec(a(Q,J)))?te=g(pe[1],Q):(J.trimForExclusions?I:v).test(Q)?te=p(Q,J):(pe=l.exec(a(Q,J)))?te=P(pe[1].substr(1),Q,!0):(pe=w.exec(a(Q,J)))?te=P(pe[1],Q,!1):te=N(Q),t.set(ce,te),s(te,fe)}function s(fe,J){if(typeof J=="string")return fe;const Q=function(ce,te){return(0,S.isEqualOrParent)(ce,J.base,!A.isLinux)?fe(ce.substr(J.base.length+1),te):null};return Q.allBasenames=fe.allBasenames,Q.allPaths=fe.allPaths,Q.basenames=fe.basenames,Q.patterns=fe.patterns,Q}function a(fe,J){return J.trimForExclusions&&fe.endsWith("/**")?fe.substr(0,fe.length-2):fe}function o(fe,J){return function(Q,ce){return typeof Q=="string"&&Q.endsWith(fe)?J:null}}function g(fe,J){const Q=`/${fe}`,ce=`\\${fe}`,te=function(be,re){return typeof be!="string"?null:re?re===fe?J:null:be===fe||be.endsWith(Q)||be.endsWith(ce)?J:null},pe=[fe];return te.basenames=pe,te.patterns=[J],te.allBasenames=pe,te}function p(fe,J){const Q=W(fe.slice(1,-1).split(",").map(re=>n(re,J)).filter(re=>re!==i),fe),ce=Q.length;if(!ce)return i;if(ce===1)return Q[0];const te=function(re,Ee){for(let Pe=0,Fe=Q.length;Pe<Fe;Pe++)if(Q[Pe](re,Ee))return fe;return null},pe=Q.find(re=>!!re.allBasenames);pe&&(te.allBasenames=pe.allBasenames);const be=Q.reduce((re,Ee)=>Ee.allPaths?re.concat(Ee.allPaths):re,[]);return be.length&&(te.allPaths=be),te}function P(fe,J,Q){const ce=_.sep===_.posix.sep,te=ce?fe:fe.replace(m,_.sep),pe=_.sep+te,be=_.posix.sep+fe;let re;return Q?re=function(Ee,Pe){return typeof Ee=="string"&&(Ee===te||Ee.endsWith(pe)||!ce&&(Ee===fe||Ee.endsWith(be)))?J:null}:re=function(Ee,Pe){return typeof Ee=="string"&&(Ee===te||!ce&&Ee===fe)?J:null},re.allPaths=[(Q?"*/":"./")+fe],re}function N(fe){try{const J=new RegExp(`^${c(fe)}$`);return function(Q){return J.lastIndex=0,typeof Q=="string"&&J.test(Q)?fe:null}}catch{return i}}function V(fe,J,Q){return!fe||typeof J!="string"?!1:U(fe)(J,void 0,Q)}e.match=V;function U(fe,J={}){if(!fe)return d;if(typeof fe=="string"||D(fe)){const Q=n(fe,J);if(Q===i)return d;const ce=function(te,pe){return!!Q(te,pe)};return Q.allBasenames&&(ce.allBasenames=Q.allBasenames),Q.allPaths&&(ce.allPaths=Q.allPaths),ce}return R(fe,J)}e.parse=U;function D(fe){const J=fe;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=D;function x(fe){return fe.allBasenames||[]}e.getBasenameTerms=x;function L(fe){return fe.allPaths||[]}e.getPathTerms=L;function R(fe,J){const Q=W(Object.getOwnPropertyNames(fe).map(re=>K(re,fe[re],J)).filter(re=>re!==i)),ce=Q.length;if(!ce)return i;if(!Q.some(re=>!!re.requiresSiblings)){if(ce===1)return Q[0];const re=function(Fe,We){let Xe;for(let Te=0,_e=Q.length;Te<_e;Te++){const ye=Q[Te](Fe,We);if(typeof ye=="string")return ye;(0,y.isThenable)(ye)&&(Xe||(Xe=[]),Xe.push(ye))}return Xe?(async()=>{for(const Te of Xe){const _e=await Te;if(typeof _e=="string")return _e}return null})():null},Ee=Q.find(Fe=>!!Fe.allBasenames);Ee&&(re.allBasenames=Ee.allBasenames);const Pe=Q.reduce((Fe,We)=>We.allPaths?Fe.concat(We.allPaths):Fe,[]);return Pe.length&&(re.allPaths=Pe),re}const te=function(re,Ee,Pe){let Fe,We;for(let Xe=0,Te=Q.length;Xe<Te;Xe++){const _e=Q[Xe];_e.requiresSiblings&&Pe&&(Ee||(Ee=(0,_.basename)(re)),Fe||(Fe=Ee.substr(0,Ee.length-(0,_.extname)(re).length)));const ye=_e(re,Ee,Fe,Pe);if(typeof ye=="string")return ye;(0,y.isThenable)(ye)&&(We||(We=[]),We.push(ye))}return We?(async()=>{for(const Xe of We){const Te=await Xe;if(typeof Te=="string")return Te}return null})():null},pe=Q.find(re=>!!re.allBasenames);pe&&(te.allBasenames=pe.allBasenames);const be=Q.reduce((re,Ee)=>Ee.allPaths?re.concat(Ee.allPaths):re,[]);return be.length&&(te.allPaths=be),te}function K(fe,J,Q){if(J===!1)return i;const ce=n(fe,Q);if(ce===i)return i;if(typeof J=="boolean")return ce;if(J){const te=J.when;if(typeof te=="string"){const pe=(be,re,Ee,Pe)=>{if(!Pe||!ce(be,re))return null;const Fe=te.replace("$(basename)",Ee),We=Pe(Fe);return(0,y.isThenable)(We)?We.then(Xe=>Xe?fe:null):We?fe:null};return pe.requiresSiblings=!0,pe}}return ce}function W(fe,J){const Q=fe.filter(re=>!!re.basenames);if(Q.length<2)return fe;const ce=Q.reduce((re,Ee)=>{const Pe=Ee.basenames;return Pe?re.concat(Pe):re},[]);let te;if(J){te=[];for(let re=0,Ee=ce.length;re<Ee;re++)te.push(J)}else te=Q.reduce((re,Ee)=>{const Pe=Ee.patterns;return Pe?re.concat(Pe):re},[]);const pe=function(re,Ee){if(typeof re!="string")return null;if(!Ee){let Fe;for(Fe=re.length;Fe>0;Fe--){const We=re.charCodeAt(Fe-1);if(We===47||We===92)break}Ee=re.substr(Fe)}const Pe=ce.indexOf(Ee);return Pe!==-1?te[Pe]:null};pe.basenames=ce,pe.patterns=te,pe.allBasenames=ce;const be=fe.filter(re=>!re.basenames);return be.push(pe),be}function $(fe,J){return(0,r.equals)(fe,J,(Q,ce)=>typeof Q=="string"&&typeof ce=="string"?Q===ce:typeof Q!="string"&&typeof ce!="string"?Q.base===ce.base&&Q.pattern===ce.pattern:!1)}e.patternsEquals=$}),define(Ce[76],Ie([1,0,11,115,22,9,2]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(u="",v=!1){if(this.value=u,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(u,v=0){return this.value+=m(this.supportThemeIcons?(0,y.escapeIcons)(u):u).replace(/([ \t]+)/g,(I,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,v){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(u,v,I){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(u),")"),I&&(this.value+=` "${this._escape(this._escape(I,'"'),")")}"`),this.value+=")",this}_escape(u,v){const I=new RegExp((0,M.escapeRegExpCharacters)(v),"g");return u.replace(I,(l,w)=>u.charAt(w-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=E;function k(h){return O(h)?!h.value:Array.isArray(h)?h.every(k):!0}e.isEmptyMarkdownString=k;function O(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function b(h,u){return h===u?!0:!h||!u?!1:h.value===u.value&&h.isTrusted===u.isTrusted&&h.supportThemeIcons===u.supportThemeIcons&&h.supportHtml===u.supportHtml&&(h.baseUri===u.baseUri||!!h.baseUri&&!!u.baseUri&&(0,S.isEqual)(_.URI.from(h.baseUri),_.URI.from(u.baseUri)))}e.markdownStringEqual=b;function m(h){return h.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function T(h){return h.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function f(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function c(h){const u=[],v=h.split("|").map(l=>l.trim());h=v[0];const I=v[1];if(I){const l=/height=(\d+)/.exec(I),w=/width=(\d+)/.exec(I),t=l?l[1]:"",d=w?w[1]:"",i=isFinite(parseInt(d)),n=isFinite(parseInt(t));i&&u.push(`width="${d}"`),n&&u.push(`height="${t}"`)}return{href:h,dimensions:u}}e.parseHrefAndDimensions=c}),define(Ce[77],Ie([1,0,16,37,19,21,22,9]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(i,n){const{os:s,tildify:a,relative:o}=n;if(o){const P=k(i,o,s);if(typeof P=="string")return P}let g=i.fsPath;if(s===1&&!M.isWindows?g=g.replace(/\//g,"\\"):s!==1&&M.isWindows&&(g=g.replace(/\\/g,"/")),s!==1&&a?.userHome){const P=a.userHome.fsPath;let N;i.scheme!==a.userHome.scheme&&i.path.startsWith(S.posix.sep)?N=a.userHome.with({path:i.path}).fsPath:N=i.fsPath,g=m(N,P,s)}return(s===1?S.win32:S.posix).normalize(O(g,s===1))}e.getPathLabel=E;function k(i,n,s){const a=s===1?S.win32:S.posix,o=s===3?_.extUri:_.extUriIgnorePathCase,g=n.getWorkspace(),p=(0,r.firstOrDefault)(g.folders);if(!p)return;i.scheme!==p.uri.scheme&&i.path.startsWith(S.posix.sep)&&(i=p.uri.with({path:i.path}));const P=n.getWorkspaceFolder(i);if(!P)return;let N;if(o.isEqual(P.uri,i)?N="":N=o.relativePath(P.uri,i)??"",N&&(N=a.normalize(N)),g.folders.length>1&&!n.noPrefix){const V=P.name?P.name:o.basenameOrAuthority(P.uri);N=N?`${V} \u2022 ${N}`:V}return N}function O(i,n=M.isWindows){return(0,y.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=O;let b=Object.create(null);function m(i,n,s=M.OS){if(s===1||!i||!n)return i;let a=b.original===n?b.normalized:void 0;a||(a=n,M.isWindows&&(a=(0,y.toSlashes)(a)),a=`${(0,A.rtrim)(a,S.posix.sep)}${S.posix.sep}`,b={original:n,normalized:a});let o=i;return M.isWindows&&(o=(0,y.toSlashes)(o)),(s===3?o.startsWith(a):(0,A.startsWithIgnoreCase)(o,a))?`~/${o.substr(a.length)}`:i}e.tildify=m;function T(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=T;const f="\u2026",c="\\\\",h="~";function u(i,n=S.sep){const s=new Array(i.length);let a=!1;for(let o=0;o<i.length;o++){const g=i[o];if(g===""){s[o]=`.${n}`;continue}if(!g){s[o]=g;continue}a=!0;let p="",P=g;P.indexOf(c)===0?(p=P.substr(0,P.indexOf(c)+c.length),P=P.substr(P.indexOf(c)+c.length)):P.indexOf(n)===0?(p=P.substr(0,P.indexOf(n)+n.length),P=P.substr(P.indexOf(n)+n.length)):P.indexOf(h)===0&&(p=P.substr(0,P.indexOf(h)+h.length),P=P.substr(P.indexOf(h)+h.length));const N=P.split(n);for(let V=1;a&&V<=N.length;V++)for(let U=N.length-V;a&&U>=0;U--){a=!1;let D=N.slice(U,U+V).join(n);for(let x=0;!a&&x<i.length;x++)if(x!==o&&i[x]&&i[x].indexOf(D)>-1){const L=U+V===N.length,R=U>0&&i[x].indexOf(n)>-1?n+D:D,K=i[x].endsWith(R);a=!L||K}if(!a){let x="";(N[0].endsWith(":")||p!=="")&&(U===1&&(U=0,V++,D=N[0]+n+D),U>0&&(x=N[0]+n),x=p+x),U>0&&(x=x+f+n),x=x+D,U+V<N.length&&(x=x+n+f),s[o]=x}}a&&(s[o]=g)}return s}e.shorten=u;var v;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function I(i,n=Object.create(null)){const s=[];let a=!1,o="";for(const g of i)if(g==="$"||a&&g==="{")o&&s.push({value:o,type:v.TEXT}),o="",a=!0;else if(g==="}"&&a){const p=n[o];if(typeof p=="string")p.length&&s.push({value:p,type:v.VARIABLE});else if(p){const P=s[s.length-1];(!P||P.type!==v.SEPARATOR)&&s.push({value:p.label,type:v.SEPARATOR})}o="",a=!1}else o+=g;return o&&!a&&s.push({value:o,type:v.TEXT}),s.filter((g,p)=>{if(g.type===v.SEPARATOR){const P=s[p-1],N=s[p+1];return[P,N].every(V=>V&&(V.type===v.VARIABLE||V.type===v.TEXT)&&V.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=I;function l(i,n){return M.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function w(i,n){return M.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,s=>s==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(i){const n=i.indexOf("/")!==-1?S.posix:S.win32,s=n.basename(i),a=n.dirname(i);return s.length?{name:s,parentPath:a}:{name:a,parentPath:""}}e.splitName=d}),define(Ce[118],Ie([1,0,2]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function y(O){return O.toJSON()}class S{constructor(b){this._uriTransformer=b}transformIncoming(b){const m=this._uriTransformer.transformIncoming(b);return m===b?b:y(r.URI.from(m))}transformOutgoing(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:y(r.URI.from(m))}transformOutgoingURI(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:r.URI.from(m)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,b,m){if(!O||m>200)return null;if(typeof O=="object"){if(O instanceof r.URI)return b.transformOutgoing(O);for(const T in O)if(Object.hasOwnProperty.call(O,T)){const f=M(O[T],b,m+1);f!==null&&(O[T]=f)}}return null}function _(O,b){const m=M(O,b,0);return m===null?O:m}e.transformOutgoingURIs=_;function A(O,b,m,T){if(!O||T>200)return null;if(typeof O=="object"){if(O.$mid===1)return m?r.URI.revive(b.transformIncoming(O)):b.transformIncoming(O);for(const f in O)if(Object.hasOwnProperty.call(O,f)){const c=A(O[f],b,m,T+1);c!==null&&(O[f]=c)}}return null}function E(O,b){const m=A(O,b,!1,0);return m===null?O:m}e.transformIncomingURIs=E;function k(O,b){const m=A(O,b,!0,0);return m===null?O:m}e.transformAndReviveIncomingURIs=k}),define(Ce[119],Ie([1,0,34,19]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(M,_,A,E,k,O){if(Array.isArray(M)){let b=0;for(const m of M){const T=S(m,_,A,E,k,O);if(T===10)return T;T>b&&(b=T)}return b}else{if(typeof M=="string")return E?M==="*"?5:M===A?10:0:0;if(M){const{language:b,pattern:m,scheme:T,hasAccessToAllModels:f,notebookType:c}=M;if(!E&&!f)return 0;c&&k&&(_=k);let h=0;if(T)if(T===_.scheme)h=10;else if(T==="*")h=5;else return 0;if(b)if(b===A)h=10;else if(b==="*")h=Math.max(h,5);else return 0;if(c)if(c===O)h=10;else if(c==="*"&&O!==void 0)h=Math.max(h,5);else return 0;if(m){let u;if(typeof m=="string"?u=m:u={...m,base:(0,y.normalize)(m.base)},u===_.fsPath||(0,r.match)(u,_.fsPath))h=10;else return 0}return h}else return 0}}e.score=S}),define(Ce[78],Ie([1,0,23,21]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(S||(S={}));function M(b){for(let m=0,T=b.length;m<T;m+=4){const f=b[m+0],c=b[m+1],h=b[m+2],u=b[m+3];b[m+0]=u,b[m+1]=h,b[m+2]=c,b[m+3]=f}}function _(b){const m=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return y.isLittleEndian()||M(m),r.VSBuffer.wrap(m)}function A(b){const m=b.buffer;if(y.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const T=new Uint8Array(m.byteLength);return T.set(m),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function E(b){const m=new Uint32Array(k(b));let T=0;if(m[T++]=b.id,b.type==="full")m[T++]=1,m[T++]=b.data.length,m.set(b.data,T),T+=b.data.length;else{m[T++]=2,m[T++]=b.deltas.length;for(const f of b.deltas)m[T++]=f.start,m[T++]=f.deleteCount,f.data?(m[T++]=f.data.length,m.set(f.data,T),T+=f.data.length):m[T++]=0}return _(m)}e.encodeSemanticTokensDto=E;function k(b){let m=0;if(m+=1+1,b.type==="full")m+=1+b.data.length;else{m+=1,m+=(1+1+1)*b.deltas.length;for(const T of b.deltas)T.data&&(m+=T.data.length)}return m}function O(b){const m=A(b);let T=0;const f=m[T++];if(m[T++]===1){const v=m[T++],I=m.subarray(T,T+v);return T+=v,{id:f,type:"full",data:I}}const h=m[T++],u=[];for(let v=0;v<h;v++){const I=m[T++],l=m[T++],w=m[T++];let t;w>0&&(t=m.subarray(T,T+w),T+=w),u[v]={start:I,deleteCount:l,data:t}}return{id:f,type:"delta",deltas:u}}e.decodeSemanticTokensDto=O}),define(Ce[120],Ie([17,18]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(Ce[121],Ie([1,0,120,21,122,16,26,109]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=k;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class b{constructor(X,he,Ue,Ve){this.id=X,this.name=he,this.defaultValue=Ue,this.schema=Ve}applyUpdate(X,he){return T(X,he)}compute(X,he,Ue){return Ue}}class m{constructor(X,he){this.newValue=X,this.didChange=he}}e.ApplyUpdateResult=m;function T(G,X){if(typeof G!="object"||typeof X!="object"||!G||!X)return new m(X,G!==X);if(Array.isArray(G)||Array.isArray(X)){const Ue=Array.isArray(G)&&Array.isArray(X)&&M.equals(G,X);return new m(X,!Ue)}let he=!1;for(const Ue in X)if(X.hasOwnProperty(Ue)){const Ve=T(G[Ue],X[Ue]);Ve.didChange&&(G[Ue]=Ve.newValue,he=!0)}return new m(G,he)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,he){return T(X,he)}validate(X){return this.defaultValue}}class c{constructor(X,he,Ue,Ve){this.id=X,this.name=he,this.defaultValue=Ue,this.schema=Ve}applyUpdate(X,he){return T(X,he)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,he,Ue){return Ue}}function h(G,X){return typeof G>"u"?X:G==="false"?!1:Boolean(G)}e.boolean=h;class u extends c{constructor(X,he,Ue,Ve=void 0){typeof Ve<"u"&&(Ve.type="boolean",Ve.default=Ue),super(X,he,Ue,Ve)}validate(X){return h(X,this.defaultValue)}}function v(G,X,he,Ue){if(typeof G>"u")return X;let Ve=parseInt(G,10);return isNaN(Ve)?X:(Ve=Math.max(he,Ve),Ve=Math.min(Ue,Ve),Ve|0)}e.clampedInt=v;class I extends c{constructor(X,he,Ue,Ve,Ze,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ue,Ke.minimum=Ve,Ke.maximum=Ze),super(X,he,Ue,Ke),this.minimum=Ve,this.maximum=Ze}static clampedInt(X,he,Ue,Ve){return v(X,he,Ue,Ve)}validate(X){return I.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class l extends c{constructor(X,he,Ue,Ve,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(X,he,Ue,Ze),this.validationFn=Ve}static clamp(X,he,Ue){return X<he?he:X>Ue?Ue:X}static float(X,he){if(typeof X=="number")return X;if(typeof X>"u")return he;const Ue=parseFloat(X);return isNaN(Ue)?he:Ue}validate(X){return this.validationFn(l.float(X,this.defaultValue))}}class w extends c{static string(X,he){return typeof X!="string"?he:X}constructor(X,he,Ue,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.default=Ue),super(X,he,Ue,Ve)}validate(X){return w.string(X,this.defaultValue)}}function t(G,X,he){return typeof G!="string"||he.indexOf(G)===-1?X:G}e.stringSet=t;class d extends c{constructor(X,he,Ue,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ve,Ze.default=Ue),super(X,he,Ue,Ze),this._allowedValues=Ve}validate(X){return t(X,this.defaultValue,this._allowedValues)}}class i extends b{constructor(X,he,Ue,Ve,Ze,Ke,je=void 0){typeof je<"u"&&(je.type="string",je.enum=Ze,je.default=Ve),super(X,he,Ue,je),this._allowedValues=Ze,this._convert=Ke}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function n(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,he,Ue){return Ue===0?X.accessibilitySupport:Ue}}class a extends b{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:r.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{insertSpace:h(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function g(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function P(G){switch(G){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=P;function N(G){switch(G){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class V extends f{constructor(){super(130)}compute(X,he,Ue){const Ve=["monaco-editor"];return he.get(34)&&Ve.push(he.get(34)),X.extraEditorClassName&&Ve.push(X.extraEditorClassName),he.get(67)==="default"?Ve.push("mouse-default"):he.get(67)==="copy"&&Ve.push("mouse-copy"),he.get(101)&&Ve.push("showUnused"),he.get(128)&&Ve.push("showDeprecated"),Ve.join(" ")}}class U extends u{constructor(){super(33,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(X,he,Ue){return Ue&&X.emptySelectionClipboard}}class D extends b{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:r.localize(16,null),included:y.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:r.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{cursorMoveOnType:h(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":t(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":t(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(he.loop,this.defaultValue.loop)}}}class x extends b{constructor(){super(46,"fontLigatures",x.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?x.OFF:X==="true"?x.ON:X:Boolean(X)?x.ON:x.OFF}}e.EditorFontLigatures=x,x.OFF='"liga" off, "calt" off',x.ON='"liga" on, "calt" on';class L extends f{constructor(){super(45)}compute(X,he,Ue){return X.fontInfo}}class R extends c{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(X){const he=l.float(X,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(he,6,100)}compute(X,he,Ue){return X.fontInfo.fontSize}}class K extends b{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(I.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class W extends b{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:r.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{multiple:t(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??t(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??t(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??t(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??t(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??t(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends b{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:r.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),delay:I.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:h(he.sticky,this.defaultValue.sticky),above:h(he.above,this.defaultValue.above)}}}var fe;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(fe=e.RenderMinimap||(e.RenderMinimap={}));class J extends f{constructor(){super(133)}compute(X,he,Ue){return J.computeLayout(he,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const he=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?he-1:0,Ve=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),Ze=Math.floor(X.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Ue,desiredRatio:Ve,minimapLineCount:Ze}}static _computeMinimapLayout(X,he){const Ue=X.outerWidth,Ve=X.outerHeight,Ze=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Ke=he.stableMinimapLayoutInput,je=Ke&&X.outerHeight===Ke.outerHeight&&X.lineHeight===Ke.lineHeight&&X.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ke.pixelRatio&&X.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&X.minimap.enabled===Ke.minimap.enabled&&X.minimap.side===Ke.minimap.side&&X.minimap.size===Ke.minimap.size&&X.minimap.showSlider===Ke.minimap.showSlider&&X.minimap.renderCharacters===Ke.minimap.renderCharacters&&X.minimap.maxColumn===Ke.minimap.maxColumn&&X.minimap.scale===Ke.minimap.scale&&X.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&X.isViewportWrapping===Ke.isViewportWrapping,tt=X.lineHeight,st=X.typicalHalfwidthCharacterWidth,dt=X.scrollBeyondLastLine,at=X.minimap.renderCharacters;let rt=Ze>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const _t=X.minimap.maxColumn,Rt=X.minimap.size,Ot=X.minimap.side,mt=X.verticalScrollbarWidth,Dt=X.viewLineCount,Nt=X.remainingWidth,Mt=X.isViewportWrapping,qe=at?2:3;let Ut=Math.floor(Ze*Ve);const Ft=Ut/Ze;let Tt=!1,gt=!1,yt=qe*rt,Se=rt/Ze,De=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:it,extraLinesBeyondLastLine:ct,desiredRatio:Ct,minimapLineCount:pt}=J.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:dt,height:Ve,lineHeight:tt,pixelRatio:Ze});if(Dt/pt>1)Tt=!0,gt=!0,rt=1,yt=1,Se=rt/Ze;else{let bt=!1,vt=rt+1;if(Rt==="fit"){const wt=Math.ceil((Dt+ct)*yt);Mt&&je&&Nt<=he.stableFitRemainingWidth?(bt=!0,vt=he.stableFitMaxMinimapScale):bt=wt>Ut}if(Rt==="fill"||bt){Tt=!0;const wt=rt;yt=Math.min(tt*Ze,Math.max(1,Math.floor(1/Ct))),Mt&&je&&Nt<=he.stableFitRemainingWidth&&(vt=he.stableFitMaxMinimapScale),rt=Math.min(vt,Math.max(1,Math.floor(yt/qe))),rt>wt&&(De=Math.min(2,rt/wt)),Se=rt/Ze/De,Ut=Math.ceil(Math.max(it,Dt+ct)*yt),Mt?(he.stableMinimapLayoutInput=X,he.stableFitRemainingWidth=Nt,he.stableFitMaxMinimapScale=rt):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const me=Math.floor(_t*Se),q=Math.min(me,Math.max(0,Math.floor((Nt-mt-2)*Se/(st+Se)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*q);const Le=Ae/Ze;Ae=Math.floor(Ae*De);const et=at?1:2,Be=Ot==="left"?0:Ue-q-mt;return{renderMinimap:et,minimapLeft:Be,minimapWidth:q,minimapHeightIsEditorHeight:Tt,minimapIsSampling:gt,minimapScale:rt,minimapLineHeight:yt,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Ut,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Ft}}static computeLayout(X,he){const Ue=he.outerWidth|0,Ve=he.outerHeight|0,Ze=he.lineHeight|0,Ke=he.lineNumbersDigitCount|0,je=he.typicalHalfwidthCharacterWidth,tt=he.maxDigitWidth,st=he.pixelRatio,dt=he.viewLineCount,at=X.get(125),rt=at==="inherit"?X.get(124):at,_t=rt==="inherit"?X.get(120):rt,Rt=X.get(123),Ot=X.get(2),mt=he.isDominatedByLongLines,Dt=X.get(51),Nt=X.get(61).renderType!==0,Mt=X.get(62),qe=X.get(95),Ut=X.get(66),Ft=X.get(93),Tt=Ft.verticalScrollbarSize,gt=Ft.verticalHasArrows,yt=Ft.arrowSize,Se=Ft.horizontalScrollbarSize,De=X.get(59),me=X.get(38),q=X.get(100)!=="never";let Ae;if(typeof De=="string"&&/^\d+(\.\d+)?ch$/.test(De)){const Wt=parseFloat(De.substr(0,De.length-2));Ae=I.clampedInt(Wt*je,0,0,1e3)}else Ae=I.clampedInt(De,0,0,1e3);me&&q&&(Ae+=16);let Le=0;if(Nt){const Wt=Math.max(Ke,Mt);Le=Math.round(Wt*tt)}let et=0;Dt&&(et=Ze);let Be=0,it=Be+et,ct=it+Le,Ct=ct+Ae;const pt=Ue-et-Le-Ae;let It=!1,bt=!1,vt=-1;Ot!==2&&(rt==="inherit"&&mt?(It=!0,bt=!0):_t==="on"||_t==="bounded"?bt=!0:_t==="wordWrapColumn"&&(vt=Rt));const wt=J._computeMinimapLayout({outerWidth:Ue,outerHeight:Ve,lineHeight:Ze,typicalHalfwidthCharacterWidth:je,pixelRatio:st,scrollBeyondLastLine:qe,minimap:Ut,verticalScrollbarWidth:Tt,viewLineCount:dt,remainingWidth:pt,isViewportWrapping:bt},he.memory||new O);wt.renderMinimap!==0&&wt.minimapLeft===0&&(Be+=wt.minimapWidth,it+=wt.minimapWidth,ct+=wt.minimapWidth,Ct+=wt.minimapWidth);const ti=pt-wt.minimapWidth,Et=Math.max(1,Math.floor((ti-Tt-2)/je)),$t=gt?yt:0;return bt&&(vt=Math.max(1,Et),_t==="bounded"&&(vt=Math.min(vt,Rt))),{width:Ue,height:Ve,glyphMarginLeft:Be,glyphMarginWidth:et,lineNumbersLeft:it,lineNumbersWidth:Le,decorationsLeft:ct,decorationsWidth:Ae,contentLeft:Ct,contentWidth:ti,minimap:wt,viewportColumn:Et,isWordWrapMinified:It,isViewportWrapping:bt,wrappingColumn:vt,verticalScrollbarWidth:Tt,horizontalScrollbarHeight:Se,overviewRuler:{top:$t,width:Tt,height:Ve-2*$t,right:0}}}}e.EditorLayoutInfoComputer=J;class Q extends b{constructor(){const X={enabled:!0};super(58,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:r.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}class ce extends b{constructor(){const X={enabled:!1,maxLineCount:5};super(105,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:r.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:r.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),maxLineCount:I.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class te extends b{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:r.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[r.localize(47,null),r.localize(48,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(49,null,y.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),r.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:r.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:r.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:r.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:t(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:I.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(he.fontFamily,this.defaultValue.fontFamily),padding:h(he.padding,this.defaultValue.padding)}}}class pe extends l{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>l.clamp(X,0,150),{markdownDescription:r.localize(54,null)})}compute(X,he,Ue){return X.fontInfo.lineHeight}}class be extends b{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:r.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:r.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(57,null),r.localize(58,null),r.localize(59,null)],default:X.size,description:r.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:r.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:r.localize(62,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:r.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:r.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),autohide:h(he.autohide,this.defaultValue.autohide),size:t(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(he.side,this.defaultValue.side,["right","left"]),showSlider:t(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(he.renderCharacters,this.defaultValue.renderCharacters),scale:I.clampedInt(he.scale,1,1,3),maxColumn:I.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(G){return G==="ctrlCmd"?y.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ee extends b{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(67,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{top:I.clampedInt(he.top,0,0,1e3),bottom:I.clampedInt(he.bottom,0,0,1e3)}}}class Pe extends b{constructor(){const X={enabled:!0,cycle:!1};super(77,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:r.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:r.localize(69,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),cycle:h(he.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(X,he,Ue){return X.pixelRatio}}class We extends b{constructor(){const X={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[r.localize(70,null),r.localize(71,null),r.localize(72,null)]}];super(80,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:X.strings,description:r.localize(73,null)},comments:{anyOf:he,default:X.comments,description:r.localize(74,null)},other:{anyOf:he,default:X.other,description:r.localize(75,null)}},default:X,markdownDescription:r.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const st=X?"on":"off";return{comments:st,strings:st,other:st}}if(!X||typeof X!="object")return this.defaultValue;const{other:he,comments:Ue,strings:Ve}=X,Ze=["on","inline","off"];let Ke,je,tt;return typeof he=="boolean"?Ke=he?"on":"off":Ke=t(he,this.defaultValue.other,Ze),typeof Ue=="boolean"?je=Ue?"on":"off":je=t(Ue,this.defaultValue.comments,Ze),typeof Ve=="boolean"?tt=Ve?"on":"off":tt=t(Ve,this.defaultValue.strings,Ze),{other:Ke,comments:je,strings:tt}}}var Xe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Xe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Te extends b{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(77,null),r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"on",description:r.localize(81,null)})}validate(X){let he=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(he=4,Ue=X):X==="interval"?he=3:X==="relative"?he=2:X==="on"?he=1:he=0),{renderType:he,renderFn:Ue}}}function _e(G){const X=G.get(88);return X==="editable"?G.get(82):X!=="on"}e.filterValidationDecorations=_e;class ye extends b{constructor(){const X=[],he={type:"number",description:r.localize(82,null)};super(92,"rulers",X,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:r.localize(83,null),format:"color-hex"}}}]},default:X,description:r.localize(84,null)})}validate(X){if(Array.isArray(X)){const he=[];for(const Ue of X)if(typeof Ue=="number")he.push({column:I.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ve=Ue;he.push({column:I.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return he.sort((Ue,Ve)=>Ue.column-Ve.column),he}return this.defaultValue}}function ae(G,X){if(typeof G!="string")return X;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends b{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(85,null),r.localize(86,null),r.localize(87,null)],default:"auto",description:r.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(89,null),r.localize(90,null),r.localize(91,null)],default:"auto",description:r.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:r.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:r.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:r.localize(95,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X,Ue=I.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=I.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:I.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(he.vertical,this.defaultValue.vertical),horizontal:ae(he.horizontal,this.defaultValue.horizontal),useShadows:h(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:I.clampedInt(he.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:I.clampedInt(he.verticalSliderSize,Ve,0,1e3),scrollByPage:h(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends b{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:r.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:r.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:r.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:r.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:r.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:r.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:r.localize(102,null)}})}applyUpdate(X,he){let Ue=!1;he.allowedCharacters&&X&&(_.equals(X.allowedCharacters,he.allowedCharacters)||(X={...X,allowedCharacters:he.allowedCharacters},Ue=!0)),he.allowedLocales&&X&&(_.equals(X.allowedLocales,he.allowedLocales)||(X={...X,allowedLocales:he.allowedLocales},Ue=!0));const Ve=super.applyUpdate(X,he);return Ue?new m(Ve.newValue,!0):Ve}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{nonBasicASCII:H(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,he){if(typeof X!="object"||!X)return he;const Ue={};for(const[Ve,Ze]of Object.entries(X))Ze===!0&&(Ue[Ve]=!0);return Ue}}class ee extends b{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:r.localize(103,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),mode:t(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class C extends b{constructor(){const X={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:r.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:r.localize(105,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{enabled:h(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends b{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(106,null),r.localize(107,null),r.localize(108,null)],default:X.bracketPairs,description:r.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(110,null),r.localize(111,null),r.localize(112,null)],default:X.bracketPairsHorizontal,description:r.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:r.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:r.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[r.localize(116,null),r.localize(117,null),r.localize(118,null)],default:X.highlightActiveIndentation,description:r.localize(119,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{bracketPairs:H(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(G,X,he){const Ue=he.indexOf(G);return Ue===-1?X:he[Ue]}class j extends b{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(120,null),r.localize(121,null)],default:X.insertMode,description:r.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:r.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:r.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:r.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:r.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:r.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:r.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:r.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:r.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(162,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const he=X;return{insertMode:t(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(he.showIcons,this.defaultValue.showIcons),showStatusBar:h(he.showStatusBar,this.defaultValue.showStatusBar),preview:h(he.preview,this.defaultValue.preview),previewMode:t(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(he.showMethods,this.defaultValue.showMethods),showFunctions:h(he.showFunctions,this.defaultValue.showFunctions),showConstructors:h(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(he.showFields,this.defaultValue.showFields),showVariables:h(he.showVariables,this.defaultValue.showVariables),showClasses:h(he.showClasses,this.defaultValue.showClasses),showStructs:h(he.showStructs,this.defaultValue.showStructs),showInterfaces:h(he.showInterfaces,this.defaultValue.showInterfaces),showModules:h(he.showModules,this.defaultValue.showModules),showProperties:h(he.showProperties,this.defaultValue.showProperties),showEvents:h(he.showEvents,this.defaultValue.showEvents),showOperators:h(he.showOperators,this.defaultValue.showOperators),showUnits:h(he.showUnits,this.defaultValue.showUnits),showValues:h(he.showValues,this.defaultValue.showValues),showConstants:h(he.showConstants,this.defaultValue.showConstants),showEnums:h(he.showEnums,this.defaultValue.showEnums),showEnumMembers:h(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(he.showKeywords,this.defaultValue.showKeywords),showWords:h(he.showWords,this.defaultValue.showWords),showColors:h(he.showColors,this.defaultValue.showColors),showFiles:h(he.showFiles,this.defaultValue.showFiles),showReferences:h(he.showReferences,this.defaultValue.showReferences),showFolders:h(he.showFolders,this.defaultValue.showFolders),showTypeParameters:h(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(he.showSnippets,this.defaultValue.showSnippets),showUsers:h(he.showUsers,this.defaultValue.showUsers),showIssues:h(he.showIssues,this.defaultValue.showIssues)}}}class oe extends b{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(163,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class le extends f{constructor(){super(132)}compute(X,he,Ue){return he.get(82)?!0:X.tabFocusMode}}var Z;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Z=e.WrappingIndent||(e.WrappingIndent={}));function ve(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(X,he,Ue){const Ve=he.get(133);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}class Ne extends b{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:r.localize(164,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:h(X.enabled,this.defaultValue.enabled)}}}const xe="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:y.isMacintosh?Ye:y.isLinux?Ge:xe,fontWeight:"normal",fontSize:y.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var nt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.dropIntoEditor=32]="dropIntoEditor",G[G.emptySelectionClipboard=33]="emptySelectionClipboard",G[G.extraEditorClassName=34]="extraEditorClassName",G[G.fastScrollSensitivity=35]="fastScrollSensitivity",G[G.find=36]="find",G[G.fixedOverflowWidgets=37]="fixedOverflowWidgets",G[G.folding=38]="folding",G[G.foldingStrategy=39]="foldingStrategy",G[G.foldingHighlight=40]="foldingHighlight",G[G.foldingImportsByDefault=41]="foldingImportsByDefault",G[G.foldingMaximumRegions=42]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=44]="fontFamily",G[G.fontInfo=45]="fontInfo",G[G.fontLigatures=46]="fontLigatures",G[G.fontSize=47]="fontSize",G[G.fontWeight=48]="fontWeight",G[G.formatOnPaste=49]="formatOnPaste",G[G.formatOnType=50]="formatOnType",G[G.glyphMargin=51]="glyphMargin",G[G.gotoLocation=52]="gotoLocation",G[G.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",G[G.hover=54]="hover",G[G.inDiffEditor=55]="inDiffEditor",G[G.inlineSuggest=56]="inlineSuggest",G[G.letterSpacing=57]="letterSpacing",G[G.lightbulb=58]="lightbulb",G[G.lineDecorationsWidth=59]="lineDecorationsWidth",G[G.lineHeight=60]="lineHeight",G[G.lineNumbers=61]="lineNumbers",G[G.lineNumbersMinChars=62]="lineNumbersMinChars",G[G.linkedEditing=63]="linkedEditing",G[G.links=64]="links",G[G.matchBrackets=65]="matchBrackets",G[G.minimap=66]="minimap",G[G.mouseStyle=67]="mouseStyle",G[G.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=69]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",G[G.multiCursorModifier=71]="multiCursorModifier",G[G.multiCursorPaste=72]="multiCursorPaste",G[G.occurrencesHighlight=73]="occurrencesHighlight",G[G.overviewRulerBorder=74]="overviewRulerBorder",G[G.overviewRulerLanes=75]="overviewRulerLanes",G[G.padding=76]="padding",G[G.parameterHints=77]="parameterHints",G[G.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",G[G.quickSuggestions=80]="quickSuggestions",G[G.quickSuggestionsDelay=81]="quickSuggestionsDelay",G[G.readOnly=82]="readOnly",G[G.renameOnType=83]="renameOnType",G[G.renderControlCharacters=84]="renderControlCharacters",G[G.renderFinalNewline=85]="renderFinalNewline",G[G.renderLineHighlight=86]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=88]="renderValidationDecorations",G[G.renderWhitespace=89]="renderWhitespace",G[G.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",G[G.roundedSelection=91]="roundedSelection",G[G.rulers=92]="rulers",G[G.scrollbar=93]="scrollbar",G[G.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=95]="scrollBeyondLastLine",G[G.scrollPredominantAxis=96]="scrollPredominantAxis",G[G.selectionClipboard=97]="selectionClipboard",G[G.selectionHighlight=98]="selectionHighlight",G[G.selectOnLineNumbers=99]="selectOnLineNumbers",G[G.showFoldingControls=100]="showFoldingControls",G[G.showUnused=101]="showUnused",G[G.snippetSuggestions=102]="snippetSuggestions",G[G.smartSelect=103]="smartSelect",G[G.smoothScrolling=104]="smoothScrolling",G[G.stickyScroll=105]="stickyScroll",G[G.stickyTabStops=106]="stickyTabStops",G[G.stopRenderingLineAfter=107]="stopRenderingLineAfter",G[G.suggest=108]="suggest",G[G.suggestFontSize=109]="suggestFontSize",G[G.suggestLineHeight=110]="suggestLineHeight",G[G.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",G[G.suggestSelection=112]="suggestSelection",G[G.tabCompletion=113]="tabCompletion",G[G.tabIndex=114]="tabIndex",G[G.unicodeHighlighting=115]="unicodeHighlighting",G[G.unusualLineTerminators=116]="unusualLineTerminators",G[G.useShadowDOM=117]="useShadowDOM",G[G.useTabStops=118]="useTabStops",G[G.wordSeparators=119]="wordSeparators",G[G.wordWrap=120]="wordWrap",G[G.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=123]="wordWrapColumn",G[G.wordWrapOverride1=124]="wordWrapOverride1",G[G.wordWrapOverride2=125]="wordWrapOverride2",G[G.wrappingIndent=126]="wrappingIndent",G[G.wrappingStrategy=127]="wrappingStrategy",G[G.showDeprecated=128]="showDeprecated",G[G.inlayHints=129]="inlayHints",G[G.editorClassName=130]="editorClassName",G[G.pixelRatio=131]="pixelRatio",G[G.tabFocusMode=132]="tabFocusMode",G[G.layoutInfo=133]="layoutInfo",G[G.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(165,null)})),acceptSuggestionOnEnter:ke(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(166,null),""],markdownDescription:r.localize(167,null)})),accessibilitySupport:ke(new s),accessibilityPageSize:ke(new I(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(168,null)})),ariaLabel:ke(new w(4,"ariaLabel",r.localize(169,null))),autoClosingBrackets:ke(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),autoClosingDelete:ke(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(173,null),""],description:r.localize(174,null)})),autoClosingOvertype:ke(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(175,null),""],description:r.localize(176,null)})),autoClosingQuotes:ke(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(177,null),r.localize(178,null),""],description:r.localize(179,null)})),autoIndent:ke(new i(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],n,{enumDescriptions:[r.localize(180,null),r.localize(181,null),r.localize(182,null),r.localize(183,null),r.localize(184,null)],description:r.localize(185,null)})),automaticLayout:ke(new u(10,"automaticLayout",!1)),autoSurround:ke(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(186,null),r.localize(187,null),r.localize(188,null),""],description:r.localize(189,null)})),bracketPairColorization:ke(new C),bracketPairGuides:ke(new B),stickyTabStops:ke(new u(106,"stickyTabStops",!1,{description:r.localize(190,null)})),codeLens:ke(new u(14,"codeLens",!0,{description:r.localize(191,null)})),codeLensFontFamily:ke(new w(15,"codeLensFontFamily","",{description:r.localize(192,null)})),codeLensFontSize:ke(new I(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(193,null)})),colorDecorators:ke(new u(17,"colorDecorators",!0,{description:r.localize(194,null)})),columnSelection:ke(new u(18,"columnSelection",!1,{description:r.localize(195,null)})),comments:ke(new a),contextmenu:ke(new u(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new u(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(196,null)})),cursorBlinking:ke(new i(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:r.localize(197,null)})),cursorSmoothCaretAnimation:ke(new u(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(198,null)})),cursorStyle:ke(new i(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:r.localize(199,null)})),cursorSurroundingLines:ke(new I(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(200,null)})),cursorSurroundingLinesStyle:ke(new d(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(201,null),r.localize(202,null)],description:r.localize(203,null)})),cursorWidth:ke(new I(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(204,null)})),disableLayerHinting:ke(new u(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new u(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new u(30,"domReadOnly",!1)),dragAndDrop:ke(new u(31,"dragAndDrop",!0,{description:r.localize(205,null)})),emptySelectionClipboard:ke(new U),dropIntoEditor:ke(new Ne),stickyScroll:ke(new ce),extraEditorClassName:ke(new w(34,"extraEditorClassName","")),fastScrollSensitivity:ke(new l(35,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:r.localize(206,null)})),find:ke(new D),fixedOverflowWidgets:ke(new u(37,"fixedOverflowWidgets",!1)),folding:ke(new u(38,"folding",!0,{description:r.localize(207,null)})),foldingStrategy:ke(new d(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(208,null),r.localize(209,null)],description:r.localize(210,null)})),foldingHighlight:ke(new u(40,"foldingHighlight",!0,{description:r.localize(211,null)})),foldingImportsByDefault:ke(new u(41,"foldingImportsByDefault",!1,{description:r.localize(212,null)})),foldingMaximumRegions:ke(new I(42,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(213,null)})),unfoldOnClickAfterEndOfLine:ke(new u(43,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(214,null)})),fontFamily:ke(new w(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(215,null)})),fontInfo:ke(new L),fontLigatures2:ke(new x),fontSize:ke(new R),fontWeight:ke(new K),formatOnPaste:ke(new u(49,"formatOnPaste",!1,{description:r.localize(216,null)})),formatOnType:ke(new u(50,"formatOnType",!1,{description:r.localize(217,null)})),glyphMargin:ke(new u(51,"glyphMargin",!0,{description:r.localize(218,null)})),gotoLocation:ke(new W),hideCursorInOverviewRuler:ke(new u(53,"hideCursorInOverviewRuler",!1,{description:r.localize(219,null)})),hover:ke(new $),inDiffEditor:ke(new u(55,"inDiffEditor",!1)),letterSpacing:ke(new l(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>l.clamp(G,-5,20),{description:r.localize(220,null)})),lightbulb:ke(new Q),lineDecorationsWidth:ke(new c(59,"lineDecorationsWidth",10)),lineHeight:ke(new pe),lineNumbers:ke(new Te),lineNumbersMinChars:ke(new I(62,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new u(63,"linkedEditing",!1,{description:r.localize(221,null)})),links:ke(new u(64,"links",!0,{description:r.localize(222,null)})),matchBrackets:ke(new d(65,"matchBrackets","always",["always","near","never"],{description:r.localize(223,null)})),minimap:ke(new be),mouseStyle:ke(new d(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new l(68,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:r.localize(224,null)})),mouseWheelZoom:ke(new u(69,"mouseWheelZoom",!1,{markdownDescription:r.localize(225,null)})),multiCursorMergeOverlapping:ke(new u(70,"multiCursorMergeOverlapping",!0,{description:r.localize(226,null)})),multiCursorModifier:ke(new i(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[r.localize(227,null),r.localize(228,null)],markdownDescription:r.localize(229,null)})),multiCursorPaste:ke(new d(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(230,null),r.localize(231,null)],markdownDescription:r.localize(232,null)})),occurrencesHighlight:ke(new u(73,"occurrencesHighlight",!0,{description:r.localize(233,null)})),overviewRulerBorder:ke(new u(74,"overviewRulerBorder",!0,{description:r.localize(234,null)})),overviewRulerLanes:ke(new I(75,"overviewRulerLanes",3,0,3)),padding:ke(new Ee),parameterHints:ke(new Pe),peekWidgetDefaultFocus:ke(new d(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(235,null),r.localize(236,null)],description:r.localize(237,null)})),definitionLinkOpensInPeek:ke(new u(79,"definitionLinkOpensInPeek",!1,{description:r.localize(238,null)})),quickSuggestions:ke(new We),quickSuggestionsDelay:ke(new I(81,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(239,null)})),readOnly:ke(new u(82,"readOnly",!1)),renameOnType:ke(new u(83,"renameOnType",!1,{description:r.localize(240,null),markdownDeprecationMessage:r.localize(241,null)})),renderControlCharacters:ke(new u(84,"renderControlCharacters",!0,{description:r.localize(242,null),restricted:!0})),renderFinalNewline:ke(new u(85,"renderFinalNewline",!0,{description:r.localize(243,null)})),renderLineHighlight:ke(new d(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(244,null)],description:r.localize(245,null)})),renderLineHighlightOnlyWhenFocus:ke(new u(87,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(246,null)})),renderValidationDecorations:ke(new d(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new d(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(247,null),r.localize(248,null),r.localize(249,null),""],description:r.localize(250,null)})),revealHorizontalRightPadding:ke(new I(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new u(91,"roundedSelection",!0,{description:r.localize(251,null)})),rulers:ke(new ye),scrollbar:ke(new ue),scrollBeyondLastColumn:ke(new I(94,"scrollBeyondLastColumn",4,0,1073741824,{description:r.localize(252,null)})),scrollBeyondLastLine:ke(new u(95,"scrollBeyondLastLine",!0,{description:r.localize(253,null)})),scrollPredominantAxis:ke(new u(96,"scrollPredominantAxis",!0,{description:r.localize(254,null)})),selectionClipboard:ke(new u(97,"selectionClipboard",!0,{description:r.localize(255,null),included:y.isLinux})),selectionHighlight:ke(new u(98,"selectionHighlight",!0,{description:r.localize(256,null)})),selectOnLineNumbers:ke(new u(99,"selectOnLineNumbers",!0)),showFoldingControls:ke(new d(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[r.localize(257,null),r.localize(258,null),r.localize(259,null)],description:r.localize(260,null)})),showUnused:ke(new u(101,"showUnused",!0,{description:r.localize(261,null)})),showDeprecated:ke(new u(128,"showDeprecated",!0,{description:r.localize(262,null)})),inlayHints:ke(new te),snippetSuggestions:ke(new d(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(263,null),r.localize(264,null),r.localize(265,null),r.localize(266,null)],description:r.localize(267,null)})),smartSelect:ke(new oe),smoothScrolling:ke(new u(104,"smoothScrolling",!1,{description:r.localize(268,null)})),stopRenderingLineAfter:ke(new I(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new j),inlineSuggest:ke(new ee),suggestFontSize:ke(new I(109,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new I(110,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new u(111,"suggestOnTriggerCharacters",!0,{description:r.localize(271,null)})),suggestSelection:ke(new d(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(272,null),r.localize(273,null),r.localize(274,null)],description:r.localize(275,null)})),tabCompletion:ke(new d(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(276,null),r.localize(277,null),r.localize(278,null)],description:r.localize(279,null)})),tabIndex:ke(new I(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new Y),unusualLineTerminators:ke(new d(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(280,null),r.localize(281,null),r.localize(282,null)],description:r.localize(283,null)})),useShadowDOM:ke(new u(117,"useShadowDOM",!0)),useTabStops:ke(new u(118,"useTabStops",!0,{description:r.localize(284,null)})),wordSeparators:ke(new w(119,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:r.localize(285,null)})),wordWrap:ke(new d(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(286,null),r.localize(287,null),r.localize(288,null),r.localize(289,null)],description:r.localize(290,null)})),wordWrapBreakAfterCharacters:ke(new w(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new w(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new I(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(291,null)})),wordWrapOverride1:ke(new d(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new d(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new i(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ve,{enumDescriptions:[r.localize(292,null),r.localize(293,null),r.localize(294,null),r.localize(295,null)],description:r.localize(296,null)})),wrappingStrategy:ke(new d(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(297,null),r.localize(298,null)],description:r.localize(299,null)})),editorClassName:ke(new V),pixelRatio:ke(new Fe),tabFocusMode:ke(new le),layoutInfo:ke(new J),wrappingInfo:ke(new ge)}}),define(Ce[123],Ie([17,18]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[124],Ie([17,18]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[125],Ie([17,18]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[126],Ie([17,18]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(Ce[127],Ie([17,18]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(Ce[128],Ie([17,18]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(Ce[129],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[130],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[131],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[132],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[133],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[134],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[135],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[136],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(Ce[137],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[138],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[139],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[140],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[141],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[142],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[143],Ie([17,18]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[144],Ie([1,0,22,29,125,239]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function E(u){return u=u.trim(),u==="*"||_.test(u)}e.isValidVersionStr=E;function k(u){if(!E(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=u.match(_);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=k;function O(u){if(!u)return null;const v=u.majorBase,I=u.majorMustEqual,l=u.minorBase;let w=u.minorMustEqual;const t=u.patchBase;let d=u.patchMustEqual;u.hasCaret&&(v===0||(w=!1),d=!1);let i=0;if(u.preRelease){const n=A.exec(u.preRelease);if(n){const[,s,a,o]=n;i=Date.UTC(Number(s),Number(a)-1,Number(o))}}return{majorBase:v,majorMustEqual:I,minorBase:l,minorMustEqual:w,patchBase:t,patchMustEqual:d,isMinimum:u.hasGreaterEquals,notBefore:i}}e.normalizeVersion=O;function b(u,v,I){let l;typeof u=="string"?l=O(k(u)):l=u;let w;v instanceof Date?w=v.getTime():typeof v=="string"&&(w=new Date(v).getTime());let t;if(typeof I=="string"?t=O(k(I)):t=I,!l||!t)return!1;const d=l.majorBase,i=l.minorBase,n=l.patchBase;let s=t.majorBase,a=t.minorBase,o=t.patchBase;const g=t.notBefore;let p=t.majorMustEqual,P=t.minorMustEqual,N=t.patchMustEqual;return t.isMinimum?d>s?!0:d<s?!1:i>a?!0:i<a||w&&w<g?!1:n>=o:(d===1&&s===0&&(!p||!P||!N)&&(s=1,a=0,o=0,p=!0,P=!1,N=!1),d<s?!1:d>s?!p:i<a?!1:i>a?!P:n<o?!1:n>o?!N:!(w&&w<g))}e.isValidVersion=b;function m(u,v,I,l,w){const t=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return t.push([y.default.Error,S.localize(0,null)]),t;if(typeof l.name!="string")return t.push([y.default.Error,S.localize(1,null,"name")]),t;if(typeof l.version!="string")return t.push([y.default.Error,S.localize(2,null,"version")]),t;if(!l.engines)return t.push([y.default.Error,S.localize(3,null,"engines")]),t;if(typeof l.engines.vscode!="string")return t.push([y.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof l.extensionDependencies<"u"&&!h(l.extensionDependencies))return t.push([y.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof l.activationEvents<"u"){if(!h(l.activationEvents))return t.push([y.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof l.main>"u"&&typeof l.browser>"u")return t.push([y.default.Error,S.localize(7,null,"activationEvents","main")]),t}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&t.push([y.default.Warning,S.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return t.push([y.default.Error,S.localize(9,null,"main")]),t;{const n=(0,r.joinPath)(I,l.main);(0,r.isEqualOrParent)(n,I)||t.push([y.default.Warning,S.localize(10,null,n.path,I.path)])}if(typeof l.activationEvents>"u")return t.push([y.default.Error,S.localize(11,null,"activationEvents","main")]),t}if(typeof l.browser<"u"){if(typeof l.browser!="string")return t.push([y.default.Error,S.localize(12,null,"browser")]),t;{const n=(0,r.joinPath)(I,l.browser);(0,r.isEqualOrParent)(n,I)||t.push([y.default.Warning,S.localize(13,null,n.path,I.path)])}if(typeof l.activationEvents>"u")return t.push([y.default.Error,S.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(l.version))return t.push([y.default.Error,S.localize(15,null)]),t;const d=[];if(!T(u,v,l,w,d))for(const n of d)t.push([y.default.Error,n]);return t}e.validateExtensionManifest=m;function T(u,v,I,l,w){return l||typeof I.main>"u"&&typeof I.browser>"u"?!0:c(u,v,I.engines.vscode,w)}e.isValidExtensionVersion=T;function f(u,v,I){return u==="*"||c(v,I,u)}e.isEngineValid=f;function c(u,v,I,l=[]){const w=O(k(I));if(!w)return l.push(S.localize(16,null,I)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return l.push(S.localize(17,null,I)),!1}else if(!w.majorMustEqual)return l.push(S.localize(18,null,I)),!1;return b(u,v,w)?!0:(l.push(S.localize(19,null,u,I)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let v=0,I=u.length;v<I;v++)if(typeof u[v]!="string")return!1;return!0}}),define(Ce[79],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(S,M=[],_=!1){this.ctor=S,this.staticArguments=M,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=r}),define(Ce[56],Ie([1,0,79]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const y=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S=e.InstantiationType||(e.InstantiationType={}));function M(A,E,k){E instanceof r.SyncDescriptor||(E=new r.SyncDescriptor(E,[],Boolean(k))),y.push([A,E])}e.registerSingleton=M;function _(){return y}e.getSingletonServiceDescriptors=_}),define(Ce[145],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(M,_){this.key=M,this.data=_,this.incoming=new Map,this.outgoing=new Map}}e.Node=r;class y{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const _ of this._nodes.values())_.outgoing.size===0&&M.push(_);return M}insertEdge(M,_){const A=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(_);A.outgoing.set(E.key,E),E.incoming.set(A.key,A)}removeNode(M){const _=this._hashFn(M);this._nodes.delete(_);for(const A of this._nodes.values())A.outgoing.delete(_),A.incoming.delete(_)}lookupOrInsertNode(M){const _=this._hashFn(M);let A=this._nodes.get(_);return A||(A=new r(_,M),this._nodes.set(_,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[_,A]of this._nodes)M.push(`${_}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,_]of this._nodes){const A=new Set([M]),E=this._findCycle(_,A);if(E)return E}}_findCycle(M,_){for(const[A,E]of M.outgoing){if(_.has(A))return[..._,A].join(" -> ");_.add(A);const k=this._findCycle(E,_);if(k)return k;_.delete(A)}}}e.Graph=y}),define(Ce[3],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function A(E){return E[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=A})(r=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function y(_,A,E){A[r.DI_TARGET]===A?A[r.DI_DEPENDENCIES].push({id:_,index:E}):(A[r.DI_DEPENDENCIES]=[{id:_,index:E}],A[r.DI_TARGET]=A)}function S(_){if(r.serviceIds.has(_))return r.serviceIds.get(_);const A=function(E,k,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");y(A,E,O)};return A.toString=()=>_,r.serviceIds.set(_,A),A}e.createDecorator=S;function M(_){return _}e.refineServiceDecorator=M}),define(Ce[57],Ie([1,0,10,2,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function M(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof y.URI)}e.isConfigurationOverrides=M;function _(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof y.URI)}e.isConfigurationUpdateOverrides=_;var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function k(u,v){const I=Object.create(null);for(const l in u)O(I,l,u[l],v);return I}e.toValuesTree=k;function O(u,v,I,l){const w=v.split("."),t=w.pop();let d=u;for(let i=0;i<w.length;i++){const n=w[i];let s=d[n];switch(typeof s){case"undefined":s=d[n]=Object.create(null);break;case"object":break;default:l(`Ignoring ${v} as ${w.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}d=s}if(typeof d=="object"&&d!==null)try{d[t]=I}catch{l(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(d)}`)}else l(`Ignoring ${v} as ${w.join(".")} is ${JSON.stringify(d)}`)}e.addToValueTree=O;function b(u,v){const I=v.split(".");m(u,I)}e.removeFromValueTree=b;function m(u,v){const I=v.shift();if(v.length===0){delete u[I];return}if(Object.keys(u).indexOf(I)!==-1){const l=u[I];typeof l=="object"&&!Array.isArray(l)&&(m(l,v),Object.keys(l).length===0&&delete u[I])}}function T(u,v,I){function l(d,i){let n=d;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const w=v.split("."),t=l(u,w);return typeof t>"u"?I:t}e.getConfigurationValue=T;function f(u,v,I){Object.keys(v).forEach(l=>{l!=="__proto__"&&(l in u?r.isObject(u[l])&&r.isObject(v[l])?f(u[l],v[l],I):I&&(u[l]=v[l]):u[l]=v[l])})}e.merge=f;function c(u,v,I){const l=u.inspect(v),w=u.inspect(I);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:l.defaultValue}e.getMigratedSettingValue=c;function h(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=h}),define(Ce[38],Ie([1,0,21,9,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",r.isMacintosh),M.set("isLinux",r.isLinux),M.set("isWindows",r.isWindows),M.set("isWeb",r.isWeb),M.set("isMacNative",r.isMacintosh&&!r.isWeb),M.set("isEdge",r.isEdge),M.set("isFirefox",r.isFirefox),M.set("isChrome",r.isChrome),M.set("isSafari",r.isSafari);const _=Object.prototype.hasOwnProperty;var A;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return b.INSTANCE}static true(){return m.INSTANCE}static has(D){return T.create(D)}static equals(D,x){return f.create(D,x)}static notEquals(D,x){return u.create(D,x)}static regex(D,x){return i.create(D,x)}static in(D,x){return c.create(D,x)}static notIn(D,x){return h.create(D,x)}static not(D){return v.create(D)}static and(...D){return a.create(D,null)}static or(...D){return o.create(D,null,!0)}static greater(D,x){return l.create(D,x)}static greaterEquals(D,x){return w.create(D,x)}static smaller(D,x){return t.create(D,x)}static smallerEquals(D,x){return d.create(D,x)}static deserialize(D,x=!1){if(!!D)return this._deserializeOrExpression(D,x)}static _deserializeOrExpression(D,x){const L=D.split("||");return o.create(L.map(R=>this._deserializeAndExpression(R,x)),null,!0)}static _deserializeAndExpression(D,x){const L=D.split("&&");return a.create(L.map(R=>this._deserializeOne(R,x)),null)}static _deserializeOne(D,x){if(D=D.trim(),D.indexOf("!=")>=0){const L=D.split("!=");return u.create(L[0].trim(),this._deserializeValue(L[1],x))}if(D.indexOf("==")>=0){const L=D.split("==");return f.create(L[0].trim(),this._deserializeValue(L[1],x))}if(D.indexOf("=~")>=0){const L=D.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],x))}if(D.indexOf(" not in ")>=0){const L=D.split(" not in ");return h.create(L[0].trim(),L[1].trim())}if(D.indexOf(" in ")>=0){const L=D.split(" in ");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const L=D.split(">=");return w.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const L=D.split(">");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const L=D.split("<=");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const L=D.split("<");return t.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(D)?v.create(D.substr(1).trim()):T.create(D)}static _deserializeValue(D,x){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;const L=/^'([^']*)'$/.exec(D);return L?L[1].trim():D}static _deserializeRegexValue(D,x){if((0,y.isFalsyOrWhitespace)(D)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const L=D.indexOf("/"),R=D.lastIndexOf("/");if(L===R||L<0){if(x)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}const K=D.slice(L+1,R),W=D[R+1]==="i"?"i":"";try{return new RegExp(K,W)}catch($){if(x)throw new Error(`bad regexp-value '${D}', parse error: ${$}`);return console.warn(`bad regexp-value '${D}', parse error: ${$}`),null}}}e.ContextKeyExpr=E;function k(U,D){const x=U?U.substituteConstants():void 0,L=D?D.substituteConstants():void 0;return!x&&!L?!0:!x||!L?!1:x.equals(L)}e.expressionsAreEqualWithConstantSubstitution=k;function O(U,D){return U.cmp(D)}class b{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class m{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class T{constructor(D,x){this.key=D,this.negated=x,this.type=2}static create(D,x=null){const L=M.get(D);return typeof L=="boolean"?L?m.INSTANCE:b.INSTANCE:new T(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?m.INSTANCE:b.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=T;class f{constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=4}static create(D,x,L=null){if(typeof x=="boolean")return x?T.create(D,L):v.create(D,L);const R=M.get(D);return typeof R=="boolean"?x===(R?"true":"false")?m.INSTANCE:b.INSTANCE:new f(D,x,L)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?m.INSTANCE:b.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class c{constructor(D,x){this.key=D,this.valueKey=x,this.type=10,this.negated=null}static create(D,x){return new c(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.valueKey),L=D.getValue(this.key);return Array.isArray(x)?x.includes(L):typeof L=="string"&&typeof x=="object"&&x!==null?_.call(x,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=c;class h{constructor(D,x){this.key=D,this.valueKey=x,this.type=11,this._negated=c.create(D,x)}static create(D,x){return new h(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:this._negated.cmp(D._negated)}equals(D){return D.type===this.type?this._negated.equals(D._negated):!1}substituteConstants(){return this}evaluate(D){return!this._negated.evaluate(D)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(D){return D.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=h;class u{constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=5}static create(D,x,L=null){if(typeof x=="boolean")return x?v.create(D,L):T.create(D,L);const R=M.get(D);return typeof R=="boolean"?x===(R?"true":"false")?b.INSTANCE:m.INSTANCE:new u(D,x,L)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=M.get(this.key);if(typeof D=="boolean"){const x=D?"true":"false";return this.value===x?b.INSTANCE:m.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=u;class v{constructor(D,x){this.key=D,this.negated=x,this.type=3}static create(D,x=null){const L=M.get(D);return typeof L=="boolean"?L?b.INSTANCE:m.INSTANCE:new v(D,x)}cmp(D){return D.type!==this.type?this.type-D.type:p(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=M.get(this.key);return typeof D=="boolean"?D?b.INSTANCE:m.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=T.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function I(U,D){if(typeof U=="string"){const x=parseFloat(U);isNaN(x)||(U=x)}return typeof U=="string"||typeof U=="number"?D(U):b.INSTANCE}class l{constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=12}static create(D,x,L=null){return I(x,R=>new l(D,R,L))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class w{constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=13}static create(D,x,L=null){return I(x,R=>new w(D,R,L))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=w;class t{constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=14}static create(D,x,L=null){return I(x,R=>new t(D,R,L))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class d{constructor(D,x,L){this.key=D,this.value=x,this.negated=L,this.type=15}static create(D,x,L=null){return I(x,R=>new d(D,R,L))}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=d;class i{constructor(D,x){this.key=D,this.regexp=x,this.type=7,this.negated=null}static create(D,x){return new i(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const x=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return x<L?-1:x>L?1:0}equals(D){if(D.type===this.type){const x=this.regexp?this.regexp.source:"",L=D.regexp?D.regexp.source:"";return this.key===D.key&&x===L}return!1}substituteConstants(){return this}evaluate(D){const x=D.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=n.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class n{constructor(D){this._actual=D,this.type=8}static create(D){return new n(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new n(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;function s(U){let D=null;for(let x=0,L=U.length;x<L;x++){const R=U[x].substituteConstants();if(U[x]!==R&&D===null){D=[];for(let K=0;K<x;K++)D[K]=U[K]}D!==null&&(D[x]=R)}return D===null?U:D}class a{constructor(D,x){this.expr=D,this.negated=x,this.type=6}static create(D,x){return a._normalizeArr(D,x)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const R=O(this.expr[x],D.expr[x]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:a.create(D,this.negated)}evaluate(D){for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].evaluate(D))return!1;return!0}static _normalizeArr(D,x){const L=[];let R=!1;for(const K of D)if(!!K){if(K.type===1){R=!0;continue}if(K.type===0)return b.INSTANCE;if(K.type===6){L.push(...K.expr);continue}L.push(K)}if(L.length===0&&R)return m.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(O);for(let K=1;K<L.length;K++)L[K-1].equals(L[K])&&(L.splice(K,1),K--);if(L.length===1)return L[0];for(;L.length>1;){const K=L[L.length-1];if(K.type!==9)break;L.pop();const W=L.pop(),$=L.length===0,fe=o.create(K.expr.map(J=>a.create([J,W],null)),null,$);fe&&(L.push(fe),L.sort(O))}return L.length===1?L[0]:new a(L,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new a(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());this.negated=o.create(D,this,!0)}return this.negated}}class o{constructor(D,x){this.expr=D,this.negated=x,this.type=9}static create(D,x,L){return o._normalizeArr(D,x,L)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let x=0,L=this.expr.length;x<L;x++){const R=O(this.expr[x],D.expr[x]);if(R!==0)return R}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let x=0,L=this.expr.length;x<L;x++)if(!this.expr[x].equals(D.expr[x]))return!1;return!0}return!1}substituteConstants(){const D=s(this.expr);return D===this.expr?this:o.create(D,this.negated,!1)}evaluate(D){for(let x=0,L=this.expr.length;x<L;x++)if(this.expr[x].evaluate(D))return!0;return!1}static _normalizeArr(D,x,L){let R=[],K=!1;if(D){for(let W=0,$=D.length;W<$;W++){const fe=D[W];if(!!fe){if(fe.type===0){K=!0;continue}if(fe.type===1)return m.INSTANCE;if(fe.type===9){R=R.concat(fe.expr);continue}R.push(fe)}}if(R.length===0&&K)return b.INSTANCE;R.sort(O)}if(R.length!==0){if(R.length===1)return R[0];for(let W=1;W<R.length;W++)R[W-1].equals(R[W])&&(R.splice(W,1),W--);if(R.length===1)return R[0];if(L){for(let W=0;W<R.length;W++)for(let $=W+1;$<R.length;$++)N(R[W],R[$])&&(R.splice($,1),$--);if(R.length===1)return R[0]}return new o(R,x)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const x of this.expr)D.push(...x.keys());return D}map(D){return new o(this.expr.map(x=>x.map(D)),null)}negate(){if(!this.negated){const D=[];for(const x of this.expr)D.push(x.negate());for(;D.length>1;){const x=D.shift(),L=D.shift(),R=[];for(const W of V(x))for(const $ of V(L))R.push(a.create([W,$],null));const K=D.length===0;D.unshift(o.create(R,null,K))}this.negated=D[0]}return this.negated}}class g extends T{constructor(D,x,L){super(D,null),this._defaultValue=x,typeof L=="object"?g._info.push({...L,key:D}):L!==!0&&g._info.push({key:D,description:L,type:x!=null?typeof x:void 0})}static all(){return g._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return f.create(this.key,D)}notEqualsTo(D){return u.create(this.key,D)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,S.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(U,D){return U<D?-1:U>D?1:0}function P(U,D,x,L){return U<x?-1:U>x?1:D<L?-1:D>L?1:0}function N(U,D){if(D.type===6&&U.type!==9&&U.type!==6){for(const R of D.expr)if(U.equals(R))return!0}const x=U.negate(),L=V(x).concat(V(D));L.sort(O);for(let R=0;R<L.length;R++){const W=L[R].negate();for(let $=R+1;$<L.length;$++){const fe=L[$];if(W.equals(fe))return!0}}return!1}e.implies=N;function V(U){return U.type===9?U.expr:[U]}}),define(Ce[146],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[80],Ie([1,0,124,3]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function S(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=S;function M(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function _(u,v){switch(u){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function A(u,v){return v==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function E(u,v,I){return A(v,I)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===I?!0:k(I).includes(u)}e.isTargetPlatformCompatible=E;function k(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function O(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=O;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var T;(function(u){u.Install="install",u.Uninstall="uninstall"})(T=e.StatisticType||(e.StatisticType={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var c;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(c=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(v,I){super(v),this.code=I,this.name=I}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Ce[39],Ie([1,0,24,19,9,10,2,126,3]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function k(W){return W.create===!0}e.isFileOpenForWriteOptions=k;var O;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var b;(function(W){W[W.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var m;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function T(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=T;function f(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=f;function c(W){return!!(W.capabilities&32768)}e.hasFileCloneCapability=c;function h(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function u(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=u;function v(W){return T(W)?!!(W.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var I;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(I=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor($,fe){super($),this.code=fe}}e.FileSystemProviderError=l;function w(W,$){const fe=new l(W.toString(),$);return d(fe,$),fe}e.createFileSystemProviderError=w;function t(W){return W||w((0,A.localize)(0,null),I.Unknown)}e.ensureFileSystemProviderError=t;function d(W,$){return W.name=$?`${$} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=d;function i(W){if(!W)return I.Unknown;if(W instanceof l)return W.code;const $=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!$)return I.Unknown;switch($[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileExceedsMemoryLimit:return I.FileExceedsMemoryLimit;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}e.toFileSystemProviderErrorCode=i;function n(W){if(W instanceof P)return W.fileOperationResult;switch(i(W)){case I.FileNotFound:return 1;case I.FileIsADirectory:return 0;case I.FileNotADirectory:return 10;case I.FileWriteLocked:return 5;case I.NoPermissions:return 6;case I.FileExists:return 4;case I.FileExceedsMemoryLimit:return 9;case I.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var s;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class a{constructor($,fe,J){this.resource=$,this.operation=fe,this.target=J}isOperation($){return this.operation===$}}e.FileOperationEvent=a;var o;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class g{constructor($,fe){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const J=new Map;for(const Q of $){const ce=J.get(Q.type);switch(ce?ce.push([Q.resource,Q]):J.set(Q.type,[[Q.resource,Q]]),Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}}for(const[Q,ce]of J)switch(Q){case 1:this.added=r.TernarySearchTree.forUris(()=>fe),this.added.fill(ce);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>fe),this.updated.fill(ce);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>fe),this.deleted.fill(ce);break}}contains($,...fe){return this.doContains($,{includeChildren:!1},...fe)}affects($,...fe){return this.doContains($,{includeChildren:!0},...fe)}doContains($,fe,...J){if(!$)return!1;const Q=J.length>0;return!!((!Q||J.includes(1))&&(this.added?.get($)||fe.includeChildren&&this.added?.findSuperstr($))||(!Q||J.includes(0))&&(this.updated?.get($)||fe.includeChildren&&this.updated?.findSuperstr($))||(!Q||J.includes(2))&&(this.deleted?.findSubstr($)||fe.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=g;function p(W,$,fe){return!W||!$||W===$||$.length>W.length?!1:($.charAt($.length-1)!==y.sep&&($+=y.sep),fe?(0,S.startsWithIgnoreCase)(W,$):W.indexOf($)===0)}e.isParent=p;class P extends Error{constructor($,fe,J){super($),this.fileOperationResult=fe,this.options=J}}e.FileOperationError=P;class N extends P{constructor($,fe,J){super($,2,J),this.stat=fe}}e.NotModifiedSinceFileOperationError=N;var V;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=D;async function x(W,$){if(!$.hasProvider(_.URI.from({scheme:W.scheme})))return new Promise(fe=>{const J=$.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===W.scheme&&Q.added&&(J.dispose(),fe())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize($){return(0,M.isNumber)($)||($=0),$<L.KB?(0,A.localize)(1,null,$.toFixed(0)):$<L.MB?(0,A.localize)(2,null,($/L.KB).toFixed(2)):$<L.GB?(0,A.localize)(3,null,($/L.MB).toFixed(2)):$<L.TB?(0,A.localize)(4,null,($/L.GB).toFixed(2)):(0,A.localize)(5,null,($/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var R;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function K(W){return{maxFileSize:W===0?300*L.MB:16*L.GB,maxHeapSize:W===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=K}),define(Ce[58],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(...S){this._entries=new Map;for(const[M,_]of S)this.set(M,_)}set(S,M){const _=this._entries.get(S);return this._entries.set(S,M),_}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=r}),define(Ce[147],Ie([1,0,14,11,79,145,3,58]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class O{constructor(f=new A.ServiceCollection,c=!1,h,u=E){this._services=f,this._strict=c,this._parent=h,this._enableTracing=u,this._activeInstantiations=new Set,this._services.set(_.IInstantiationService,this),this._globalGraph=u?h?._globalGraph??new M.Graph(v=>v):void 0}createChild(f){return new O(f,this._strict,this,this._enableTracing)}invokeFunction(f,...c){const h=m.traceInvocation(this._enableTracing,f);let u=!1;try{return f({get:I=>{if(u)throw(0,y.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(I,h);if(!l)throw new Error(`[invokeFunction] unknown service '${I}'`);return l}},...c)}finally{u=!0,h.stop()}}createInstance(f,...c){let h,u;return f instanceof S.SyncDescriptor?(h=m.traceCreation(this._enableTracing,f.ctor),u=this._createInstance(f.ctor,f.staticArguments.concat(c),h)):(h=m.traceCreation(this._enableTracing,f),u=this._createInstance(f,c,h)),h.stop(),u}_createInstance(f,c=[],h){const u=_._util.getServiceDependencies(f).sort((l,w)=>l.index-w.index),v=[];for(const l of u){const w=this._getOrCreateServiceInstance(l.id,h);w||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),v.push(w)}const I=u.length>0?u[0].index:c.length;if(c.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${c.length} static arguments`);const l=I-c.length;l>0?c=c.concat(new Array(l)):c=c.slice(0,I)}return new f(...c,...v)}_setServiceInstance(f,c){if(this._services.get(f)instanceof S.SyncDescriptor)this._services.set(f,c);else if(this._parent)this._parent._setServiceInstance(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const c=this._services.get(f);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):c}_getOrCreateServiceInstance(f,c){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(f));const h=this._getServiceInstanceOrDescriptor(f);return h instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,h,c.branch(f,!0)):(c.branch(f,!1),h)}_safeCreateAndCacheServiceInstance(f,c,h){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,c,h)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,c,h){const u=new M.Graph(l=>l.id.toString());let v=0;const I=[{id:f,desc:c,_trace:h}];for(;I.length;){const l=I.pop();if(u.lookupOrInsertNode(l),v++>1e3)throw new k(u);for(const w of _._util.getServiceDependencies(l.desc.ctor)){const t=this._getServiceInstanceOrDescriptor(w.id);if(t||this._throwIfStrict(`[createInstance] ${f} depends on ${w.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(l.id),String(w.id)),t instanceof S.SyncDescriptor){const d={id:w.id,desc:t,_trace:l._trace.branch(w.id,!0)};u.insertEdge(l,d),I.push(d)}}}for(;;){const l=u.roots();if(l.length===0){if(!u.isEmpty())throw new k(u);break}for(const{data:w}of l){if(this._getServiceInstanceOrDescriptor(w.id)instanceof S.SyncDescriptor){const d=this._createServiceInstanceWithOwner(w.id,w.desc.ctor,w.desc.staticArguments,w.desc.supportsDelayedInstantiation,w._trace);this._setServiceInstance(w.id,d)}u.removeNode(w)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,c,h=[],u,v){if(this._services.get(f)instanceof S.SyncDescriptor)return this._createServiceInstance(f,c,h,u,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,c,h,u,v);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(f,c,h=[],u,v){if(u){const I=new O(void 0,this._strict,this,this._enableTracing);I._globalGraphImplicitDependency=String(f);const l=new r.IdleValue(()=>I._createInstance(c,h,v));return new Proxy(Object.create(null),{get(w,t){if(t in w)return w[t];const d=l.value;let i=d[t];return typeof i!="function"||(i=i.bind(d),w[t]=i),i},set(w,t,d){return l.value[t]=d,!0}})}else return this._createInstance(c,h,v)}_throwIfStrict(f,c){if(c&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=O;var b;(function(T){T[T.Creation=0]="Creation",T[T.Invocation=1]="Invocation",T[T.Branch=2]="Branch"})(b||(b={}));class m{constructor(f,c){this.type=f,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(f,c){return f?new m(1,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(f,c){return f?new m(0,c.name):m._None}branch(f,c){const h=new m(2,f.toString());return this._dep.push([f,c,h]),h}stop(){const f=Date.now()-this._start;m._totals+=f;let c=!1;function h(v,I){const l=[],w=new Array(v+1).join("	");for(const[t,d,i]of I._dep)if(d&&i){c=!0,l.push(`${w}CREATES -> ${t}`);const n=h(v+1,i);n&&l.push(n)}else l.push(`${w}uses -> ${t}`);return l.join(`
`)}const u=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||c)&&m.all.add(u.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Ce[15],Ie([1,0,43,5,7,21,3]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,_.createDecorator)("logService"),e.ILoggerService=(0,_.createDecorator)("loggerService");function A(){return new Date().toISOString()}var E;(function(d){d[d.Trace=0]="Trace",d[d.Debug=1]="Debug",d[d.Info=2]="Info",d[d.Warning=3]="Warning",d[d.Error=4]="Error",d[d.Critical=5]="Critical",d[d.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function k(d,i,n){switch(i){case E.Trace:d.trace(n);break;case E.Debug:d.debug(n);break;case E.Info:d.info(n);break;case E.Warning:d.warn(n);break;case E.Error:d.error(n);break;case E.Critical:d.critical(n);break;default:throw new Error("Invalid log level")}}e.log=k;function O(d){let i="";for(let n=0;n<d.length;n++){let s=d[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}i+=(n>0?" ":"")+s}return i}e.format=O;class b extends S.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class m extends b{constructor(i){super(),this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,O([i,...n]))}debug(i,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,O([i,...n]))}info(i,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,O([i,...n]))}warn(i,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,O([i,...n]))}error(i,...n){if(this.checkLogLevel(E.Error))if(i instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=i.stack,this.log(E.Error,O(s))}else this.log(E.Error,O([i,...n]))}critical(i,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,O([i,...n]))}flush(){}}e.AbstractMessageLogger=m;class T extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i),this.useColors=!M.isWindows}trace(i,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}debug(i,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}info(i,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.log(`[main ${A()}]`,i,...n))}warn(i,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${A()}]\x1B[0m`,i,...n):console.warn(`[main ${A()}]`,i,...n))}error(i,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`\x1B[91m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}critical(i,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`\x1B[90m[main ${A()}]\x1B[0m`,i,...n):console.error(`[main ${A()}]`,i,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class f extends b{constructor(i=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(i)}trace(i,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}e.ConsoleLogger=f;class c extends b{constructor(i,n=e.DEFAULT_LOG_LEVEL){super(),this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,r.toErrorMessage)(i,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class h extends b{constructor(i){super(),this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const s of this.logServices)s.trace(i,...n)}debug(i,...n){for(const s of this.logServices)s.debug(i,...n)}info(i,...n){for(const s of this.logServices)s.info(i,...n)}warn(i,...n){for(const s of this.logServices)s.warn(i,...n)}error(i,...n){for(const s of this.logServices)s.error(i,...n)}critical(i,...n){for(const s of this.logServices)s.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=h;class u extends S.Disposable{constructor(i){super(),this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}e.LogService=u;class v extends S.Disposable{constructor(i,n){super(),this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let s=this.loggers.get(i.toString());return s||(s=this.doCreateLogger(i,n?.always?E.Trace:this.logLevel,n),this.loggers.set(i.toString(),s),n?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class I{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(i){}getLevel(){return E.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}e.NullLogService=I;function l(d){if(d.verbose)return E.Trace;if(typeof d.logLevel=="string"){const i=w(d.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function w(d){switch(d){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=w;function t(d){switch(d){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=t}),define(Ce[81],Ie([1,0,29,127,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var _;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(f,c){return c-f}E.compare=k;const O=Object.create(null);O[E.Error]=(0,y.localize)(0,null),O[E.Warning]=(0,y.localize)(1,null),O[E.Info]=(0,y.localize)(2,null);function b(f){return O[f]||""}E.toString=b;function m(f){switch(f){case r.default.Error:return E.Error;case r.default.Warning:return E.Warning;case r.default.Info:return E.Info;case r.default.Ignore:return E.Hint}}E.fromSeverity=m;function T(f){switch(f){case E.Error:return r.default.Error;case E.Warning:return r.default.Warning;case E.Info:return r.default.Info;case E.Hint:return r.default.Ignore}}E.toSeverity=T}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(E){const k="";function O(m){return b(m,!0)}E.makeKey=O;function b(m,T){const f=[k];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(k),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(k),m.severity!==void 0&&m.severity!==null?f.push(_.toString(m.severity)):f.push(k),m.message&&T?f.push(m.message.replace("\xA6","\\\xA6")):f.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(k),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(k),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(k),f.push(k),f.join("\xA6")}E.makeKeyOptionalMessage=b})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,S.createDecorator)("markerService")}),define(Ce[148],Ie([1,0,5,29,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=y.default,e.INotificationService=(0,S.createDecorator)("notificationService");var M;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new E,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class E{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=E}),define(Ce[82],Ie([1,0,7,9,2,3]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function _(O,b){return S.URI.isUri(O)?(0,y.equalsIgnoreCase)(O.scheme,b):(0,y.startsWithIgnoreCase)(O,b+":")}e.matchesScheme=_;function A(O,...b){return b.some(m=>_(O,m))}e.matchesSomeScheme=A;function E(O,b){return O.with({fragment:`${b.startLineNumber},${b.startColumn}${b.endLineNumber?`-${b.endLineNumber}${b.endColumn?`,${b.endColumn}`:""}`:""}`})}e.withSelection=E;function k(O){let b;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return m&&(b={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},O=O.with({fragment:""})),{selection:b,uri:O}}e.extractSelection=k}),define(Ce[149],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,r.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ne,e,r,y){var S=arguments.length,M=S<3?e:y===null?y=Object.getOwnPropertyDescriptor(e,r):y,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ne,e,r,y);else for(var A=ne.length-1;A>=0;A--)(_=ne[A])&&(M=(S<3?_(M):S>3?_(e,r,M):_(e,r))||M);return S>3&&M&&Object.defineProperty(e,r,M),M},$e=this&&this.__param||function(ne,e){return function(r,y){e(r,y,ne)}};define(Ce[150],Ie([1,0,14,20,7,3]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var _;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let E=class extends S.Disposable{constructor(b,m){super(),this.deferred=new r.DeferredPromise,m.withProgress(b,T=>(this.reporter=T,this.lastStep&&T.report(this.lastStep),this.deferred.p)),this._register((0,S.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};E=ze([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends S.Disposable{constructor(b){super(),this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(b){this.stop();const m=++this.currentOperationId,T=new y.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,S.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,S.toDisposable)(()=>T.cancel())),this.currentOperationDisposables.add((0,S.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:T.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,44,10]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(_,A){r.ok(y.isString(_)),r.ok(y.isObject(A)),r.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,A)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new S}),define(Ce[83],Ie([1,0,5,30]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[S(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new M;y.Registry.add(e.Extensions.JSONContribution,_)}),define(Ce[84],Ie([1,0,16,5,10,123,57,83,30]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=E.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new y.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new y.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const i=this.doRegisterConfigurations(t,d);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const d=this.doDeregisterConfigurations(t);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d})}updateConfigurations({add:t,remove:d}){const i=[];i.push(...this.doDeregisterConfigurations(d)),i.push(...this.doRegisterConfigurations(t,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(i)})}registerDefaultConfigurations(t){const d=[],i=[];for(const{overrides:n,source:s}of t)for(const a in n)if(d.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.configurationDefaultsOverrides.get(a),g=o?.valuesSources??new Map;if(s)for(const V of Object.keys(n[a]))g.set(V,s);const p={...o?.value||{},...n[a]};this.configurationDefaultsOverrides.set(a,{source:s,value:p,valuesSources:g});const P=(0,_.getLanguageTagSettingPlainKey)(a),N={type:"object",default:p,description:M.localize(1,null,P),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:S.isString(s)?void 0:s,defaultValueSource:s};i.push(...c(a)),this.configurationProperties[a]=N,this.defaultLanguageConfigurationOverridesNode.properties[a]=N}else{this.configurationDefaultsOverrides.set(a,{value:n[a],source:s});const o=this.configurationProperties[a];o&&(this.updatePropertyDefaultValue(a,o),this.updateSchema(a,o))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const d=[];for(const{overrides:i,source:n}of t)for(const s in i){const a=this.configurationDefaultsOverrides.get(s),o=S.isString(n)?n:n?.id,g=S.isString(a?.source)?a?.source:a?.source?.id;if(o===g)if(d.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const p=this.configurationProperties[s];p&&(this.updatePropertyDefaultValue(s,p),this.updateSchema(s,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:d,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const d of t)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,d){const i=[];return t.forEach(n=>{i.push(...this.validateAndRegisterProperties(n,d,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),i}doDeregisterConfigurations(t){const d=[],i=n=>{if(n.properties)for(const s in n.properties){d.push(s);const a=this.configurationProperties[s];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return d}validateAndRegisterProperties(t,d=!0,i,n,s=3){s=S.isUndefinedOrNull(t.scope)?s:t.scope;const a=[],o=t.properties;if(o)for(const p in o){const P=o[p];if(d&&I(p,P)){delete o[p];continue}if(P.source=i,P.defaultDefaultValue=o[p].default,this.updatePropertyDefaultValue(p,P),e.OVERRIDE_PROPERTY_REGEX.test(p)?P.scope=void 0:(P.scope=S.isUndefinedOrNull(P.scope)?s:P.scope,P.restricted=S.isUndefinedOrNull(P.restricted)?!!n?.includes(p):P.restricted),o[p].hasOwnProperty("included")&&!o[p].included){this.excludedConfigurationProperties[p]=o[p],delete o[p];continue}else this.configurationProperties[p]=o[p],o[p].policy?.name&&this.policyConfigurations.set(o[p].policy.name,p);!o[p].deprecationMessage&&o[p].markdownDeprecationMessage&&(o[p].deprecationMessage=o[p].markdownDeprecationMessage),a.push(p)}const g=t.allOf;if(g)for(const p of g)a.push(...this.validateAndRegisterProperties(p,d,i,n,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const d=i=>{const n=i.properties;if(n)for(const a in n)this.updateSchema(a,n[a]);i.allOf?.forEach(d)};d(t)}updateSchema(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.resourceLanguageSettingsSchema.properties[t]=d;break}}removeFromSchema(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const d=`[${t}]`,i={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,i),e.allSettings.properties[d]=i,e.applicationSettings.properties[d]=i,e.machineSettings.properties[d]=i,e.machineOverridableSettings.properties[d]=i,e.windowSettings.properties[d]=i,e.resourceSettings.properties[d]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,d){const i=this.configurationDefaultsOverrides.get(t);let n=i?.value,s=i?.source;S.isUndefined(n)&&(n=d.defaultDefaultValue,s=void 0),S.isUndefined(n)&&(n=u(d.type)),d.default=n,d.defaultValueSource=s}}const T="\\[([^\\]]+)\\]",f=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function c(w){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let d=f.exec(w);for(;d?.length;){const i=d[1].trim();i&&t.push(i),d=f.exec(w)}}return(0,r.distinct)(t)}e.overrideIdentifiersFromKey=c;function h(w){return w.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=h;function u(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=u;const v=new m;E.Registry.add(e.Extensions.Configuration,v);function I(w,t){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?M.localize(7,null,w):v.getConfigurationProperties()[w]!==void 0?M.localize(8,null,w):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,w,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=I;function l(){const w=[],t=v.getConfigurationProperties();for(const d of Object.keys(t))w.push([d,t[d].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=l}),define(Ce[151],Ie([1,0,16,5,105,7,24,26,10,2,57,84,30]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class T{constructor(t={},d=[],i=[]){this._contents=t,this._keys=d,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(t){return t?(0,O.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,d){const i=this.getContentsForOverrideIdentifer(d);return i?t?(0,O.getConfigurationValue)(i,t):i:void 0}getKeysForOverrideIdentifier(t){const d=[];for(const i of this.overrides)i.identifiers.includes(t)&&d.push(...i.keys);return r.distinct(d)}getAllOverrideIdentifiers(){const t=[];for(const d of this.overrides)t.push(...d.identifiers);return r.distinct(t)}override(t){let d=this.overrideConfigurations.get(t);return d||(d=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,d)),d}merge(...t){const d=A.deepClone(this.contents),i=A.deepClone(this.overrides),n=[...this.keys];for(const s of t)if(!s.isEmpty()){this.mergeContents(d,s.contents);for(const a of s.overrides){const[o]=i.filter(g=>r.equals(g.identifiers,a.identifiers));o?(this.mergeContents(o.contents,a.contents),o.keys.push(...a.keys),o.keys=r.distinct(o.keys)):i.push(A.deepClone(a))}for(const a of s.keys)n.indexOf(a)===-1&&n.push(a)}return new T(d,n,i)}freeze(){return this.frozen=!0,this}clone(){return new T(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(t){const d=this.getContentsForOverrideIdentifer(t);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const i={};for(const n of r.distinct([...Object.keys(this.contents),...Object.keys(d)])){let s=this.contents[n];const a=d[n];a&&(typeof s=="object"&&typeof a=="object"?(s=A.deepClone(s),this.mergeContents(s,a)):s=a),i[n]=s}return new T(i,this.keys,this.overrides)}mergeContents(t,d){for(const i of Object.keys(d)){if(i in t&&E.isObject(t[i])&&E.isObject(d[i])){this.mergeContents(t[i],d[i]);continue}t[i]=A.deepClone(d[i])}}checkAndFreeze(t){return this.frozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){let d=null,i=null;const n=s=>{s&&(i?this.mergeContents(i,s):i=A.deepClone(s))};for(const s of this.overrides)r.equals(s.identifiers,[t])?d=s.contents:s.identifiers.includes(t)&&n(s.contents);return n(d),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,d){this.addKey(t),(0,O.addToValueTree)(this.contents,t,d,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&(0,O.removeFromValueTree)(this.contents,t)}addKey(t){let d=this.keys.length;for(let i=0;i<d;i++)t.indexOf(this.keys[i])===0&&(d=i);this.keys.splice(d,1,t)}removeKey(t){const d=this.keys.indexOf(t);return d!==-1?(this.keys.splice(d,1),!0):!1}}e.ConfigurationModel=T;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new T}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,d){if(!E.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,d)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,d){this._raw=t;const{contents:i,keys:n,overrides:s,restricted:a}=this.doParseRaw(t,d);this._configurationModel=new T(i,n,s),this._restrictedConfigurations=a||[]}doParseContent(t){let d={},i=null,n=[];const s=[],a=[];function o(p){Array.isArray(n)?n.push(p):i!==null&&(n[i]=p)}const g={onObjectBegin:()=>{const p={};o(p),s.push(n),n=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{n=s.pop()},onArrayBegin:()=>{const p=[];o(p),s.push(n),n=p,i=null},onArrayEnd:()=>{n=s.pop()},onLiteralValue:o,onError:(p,P,N)=>{a.push({error:p,offset:P,length:N})}};if(t)try{S.visit(t,g),d=n[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return d}doParseRaw(t,d){const i=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,i,!0,d);t=n.raw;const s=(0,O.toValuesTree)(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),a=Object.keys(t),o=this.toOverrides(t,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:s,keys:a,overrides:o,restricted:n.restricted}}filter(t,d,i,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:t,restricted:[]};const s={},a=[];for(const o in t)if(b.OVERRIDE_PROPERTY_REGEX.test(o)&&i){const g=this.filter(t[o],d,!1,n);s[o]=g.raw,a.push(...g.restricted)}else{const g=d[o],p=g?typeof g.scope<"u"?g.scope:3:void 0;g?.restricted&&a.push(o),(p===void 0||n.scopes===void 0||n.scopes.includes(p))&&(n.skipRestricted&&g?.restricted||(s[o]=t[o]))}return{raw:s,restricted:a}}toOverrides(t,d){const i=[];for(const n of Object.keys(t))if(b.OVERRIDE_PROPERTY_REGEX.test(n)){const s={};for(const a in t[n])s[a]=t[n][a];i.push({identifiers:(0,b.overrideIdentifiersFromKey)(n),keys:Object.keys(s),contents:(0,O.toValuesTree)(s,d)})}return i}}e.ConfigurationModelParser=f;class c extends M.Disposable{constructor(t,d,i,n){super(),this.userSettingsResource=t,this.scopes=d,this.fileService=n,this._onDidChange=this._register(new y.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(y.Event.any(y.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),y.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&i.isEqual(s.resource,t)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new T}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class h{constructor(t,d,i,n,s=new T,a=new T,o=new _.ResourceMap,g=new T,p=new _.ResourceMap,P=!0){this._defaultConfiguration=t,this._policyConfiguration=d,this._applicationConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=o,this._memoryConfiguration=g,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new _.ResourceMap,this._userConfiguration=null}getValue(t,d,i){return this.getConsolidatedConfigurationModel(t,d,i).getValue(t)}updateValue(t,d,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new T,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,d===void 0?n.removeValue(t):n.setValue(t,d),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,d,i){const n=this.getConsolidatedConfigurationModel(t,d,i),s=this.getFolderConfigurationModelForResource(d.resource,i),a=d.resource?this._memoryConfigurationByResource.get(d.resource)||this._memoryConfiguration:this._memoryConfiguration,o=d.overrideIdentifier?this._defaultConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),g=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(t),p=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(t),P=d.overrideIdentifier?this.userConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),N=d.overrideIdentifier?this.localUserConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),V=d.overrideIdentifier?this.remoteUserConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),U=i?d.overrideIdentifier?this._workspaceConfiguration.freeze().override(d.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,D=s?d.overrideIdentifier?s.freeze().override(d.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,x=d.overrideIdentifier?a.override(d.overrideIdentifier).getValue(t):a.getValue(t),L=n.getValue(t),R=r.distinct(n.overrides.map(K=>K.identifiers).flat()).filter(K=>n.getOverrideValue(t,K)!==void 0);return{defaultValue:o,policyValue:g,applicationValue:p,userValue:P,userLocalValue:N,userRemoteValue:V,workspaceValue:U,workspaceFolderValue:D,memoryValue:x,value:L,default:o!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,policy:g!==void 0?{value:g}:void 0,application:p!==void 0?{value:p,override:d.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,userRemote:V!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:d.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:s?.freeze().getValue(t),override:d.overrideIdentifier?s?.freeze().getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:a.getValue(t),override:d.overrideIdentifier?a.getOverrideValue(t,d.overrideIdentifier):void 0}:void 0,overrideIdentifiers:R.length?R:void 0}}keys(t){const d=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:d?d.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(t){this._policyConfiguration=t}updateApplicationConfiguration(t){this._applicationConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,d){this._folderConfigurations.set(t,d),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,d){const i=[];if(!d){const{added:n,updated:s,removed:a}=I(this._defaultConfiguration,t);d=[...n,...s,...a]}for(const n of d)for(const s of(0,b.overrideIdentifiersFromKey)(n)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(s),o=t.getKeysForOverrideIdentifier(s),g=[...o.filter(p=>a.indexOf(p)===-1),...a.filter(p=>o.indexOf(p)===-1),...a.filter(p=>!A.equals(this._defaultConfiguration.override(s).getValue(p),t.override(s).getValue(p)))];i.push([s,g])}return this.updateDefaultConfiguration(t),{keys:d,overrides:i}}compareAndUpdatePolicyConfiguration(t){const{added:d,updated:i,removed:n}=I(this._policyConfiguration,t),s=[...d,...i,...n];return s.length&&this.updatePolicyConfiguration(t),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:d,updated:i,removed:n,overrides:s}=I(this.applicationConfiguration,t),a=[...d,...i,...n];return a.length&&this.updateApplicationConfiguration(t),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:d,updated:i,removed:n,overrides:s}=I(this.localUserConfiguration,t),a=[...d,...i,...n];return a.length&&this.updateLocalUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:d,updated:i,removed:n,overrides:s}=I(this.remoteUserConfiguration,t),a=[...d,...i,...n];return a.length&&this.updateRemoteUserConfiguration(t),{keys:a,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:d,updated:i,removed:n,overrides:s}=I(this.workspaceConfiguration,t),a=[...d,...i,...n];return a.length&&this.updateWorkspaceConfiguration(t),{keys:a,overrides:s}}compareAndUpdateFolderConfiguration(t,d){const i=this.folderConfigurations.get(t),{added:n,updated:s,removed:a,overrides:o}=I(i,d),g=[...n,...s,...a];return(g.length||!i)&&this.updateFolderConfiguration(t,d),{keys:g,overrides:o}}compareAndDeleteFolderConfiguration(t){const d=this.folderConfigurations.get(t);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:n,removed:s,overrides:a}=I(d,void 0);return{keys:[...i,...n,...s],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(t,d,i){let n=this.getConsolidatedConfigurationModelForResource(d,i);return d.overrideIdentifier&&(n=n.override(d.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(t)!==void 0&&(n=n.merge(this._policyConfiguration)),n}getConsolidatedConfigurationModelForResource({resource:t},d){let i=this.getWorkspaceConsolidatedConfiguration();if(d&&t){const n=d.getFolder(t);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const s=this._memoryConfigurationByResource.get(t);s&&(i=i.merge(s))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let d=this._foldersConsolidatedConfigurations.get(t);if(!d){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(d=i.merge(n),this._freeze&&(d=d.freeze()),this._foldersConsolidatedConfigurations.set(t,d)):d=i}return d}getFolderConfigurationModelForResource(t,d){if(d&&t){const i=d.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,d)=>{const{contents:i,overrides:n,keys:s}=this._folderConfigurations.get(d);return t.push([d,{contents:i,overrides:n,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(d=>t.add(d)),this.userConfiguration.freeze().keys.forEach(d=>t.add(d)),this._workspaceConfiguration.freeze().keys.forEach(d=>t.add(d)),this._folderConfigurations.forEach(d=>d.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}allOverrideIdentifiers(){const t=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>t.add(d)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>t.add(d)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(d=>t.add(d)),this._folderConfigurations.forEach(d=>d.freeze().getAllOverrideIdentifiers().forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const d=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>d.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>d.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>d.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(n=>d.add(n))),[...d.values()]}static parse(t){const d=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.policy),n=this.parseConfigurationModel(t.application),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((g,p)=>(g.set(k.URI.revive(p[0]),this.parseConfigurationModel(p[1])),g),new _.ResourceMap);return new h(d,i,n,s,new T,a,o,new T,new _.ResourceMap,!1)}static parseConfigurationModel(t){return new T(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=h;function u(...w){if(w.length===0)return{keys:[],overrides:[]};if(w.length===1)return w[0];const t=new Set,d=new Map;for(const n of w)n.keys.forEach(s=>t.add(s)),n.overrides.forEach(([s,a])=>{const o=(0,_.getOrSet)(d,s,new Set);a.forEach(g=>o.add(g))});const i=[];return d.forEach((n,s)=>i.push([s,[...n.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=u;class v{constructor(t,d,i,n){this.change=t,this.previous=d,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(o=>s.add(o)),t.overrides.forEach(([,o])=>o.forEach(g=>s.add(g))),this.affectedKeys=[...s.values()];const a=new T;this.affectedKeys.forEach(o=>a.setValue(o,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,d){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(d){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,d,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(t,d,this.currentWorkspace);return!A.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(t,d){let i=(0,O.toValuesTree)({[d]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(t=t[n],!t)return!1;i=i[n]}return!0}}e.ConfigurationChangeEvent=v;function I(w,t){const{added:d,removed:i,updated:n}=l(t,w),s=[],a=w?.getAllOverrideIdentifiers()||[],o=t?.getAllOverrideIdentifiers()||[];if(t){const g=o.filter(p=>!a.includes(p));for(const p of g)s.push([p,t.getKeysForOverrideIdentifier(p)])}if(w){const g=a.filter(p=>!o.includes(p));for(const p of g)s.push([p,w.getKeysForOverrideIdentifier(p)])}if(t&&w){for(const g of a)if(o.includes(g)){const p=l({contents:w.getOverrideValue(void 0,g)||{},keys:w.getKeysForOverrideIdentifier(g)},{contents:t.getOverrideValue(void 0,g)||{},keys:t.getKeysForOverrideIdentifier(g)});s.push([g,[...p.added,...p.removed,...p.updated]])}}return{added:d,removed:i,updated:n,overrides:s}}function l(w,t){const d=w?t?w.keys.filter(s=>t.keys.indexOf(s)===-1):[...w.keys]:[],i=t?w?t.keys.filter(s=>w.keys.indexOf(s)===-1):[...t.keys]:[],n=[];if(w&&t){for(const s of t.keys)if(w.keys.indexOf(s)!==-1){const a=(0,O.getConfigurationValue)(t.contents,s),o=(0,O.getConfigurationValue)(w.contents,s);A.equals(a,o)||n.push(s)}}return{added:d,removed:i,updated:n}}}),define(Ce[85],Ie([1,0,11,3]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,y.createDecorator)("remoteAuthorityResolverService");var S;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(S=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends r.ErrorNoTelemetry{constructor(A,E=S.Unknown,k){super(A),this._message=A,this._code=E,this._detail=k,this.isHandled=E===S.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===S.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===S.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}}e.RemoteAuthorityResolverError=M}),define(Ce[86],Ie([1,0,12]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function y(k){return k.scheme===r.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=y;function S(k){if(!k)return;const O=k.indexOf("+");return O<0?k:k.substr(0,O)}e.getRemoteName=S;function M(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=M;function _(k){const{host:O,port:b}=E(k);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:b}}e.parseAuthorityWithPort=_;function A(k,O){let{host:b,port:m}=E(k);return typeof m>"u"&&(m=O),{host:b,port:m}}e.parseAuthorityWithOptionalPort=A;function E(k){const O=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const b=k.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ce[27],Ie([1,0,9,3,86]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function _(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=_,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var E;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class k{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,h){if(typeof c>"u"||c===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof c=="string"||typeof h=="string"){const u=typeof c=="string"?c:c.value,v=typeof h=="string"?h:h.value;return r.equalsIgnoreCase(u,v)}return c._lower===h._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=k;function O(f){return b(f)}e.isApplicationScopedExtension=O;function b(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function T(f,c){if(c){const h=`onResolveRemoteAuthority:${(0,S.getRemoteName)(c)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=T,e.IBuiltinExtensionsScannerService=(0,y.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[152],Ie([1,0,9,80,27,21,2,11,59]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(d,i){return d.uuid&&i.uuid?d.uuid===i.uuid:d.id===i.id?!0:(0,r.compareIgnoreCase)(d.id,i.id)===0}e.areSameExtensions=k;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{constructor(i,n,s="undefined"){this.version=n,this.targetPlatform=s,this.id=i.id}static create(i){const n=i.manifest?i.manifest.version:i.version,s=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,n,s)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new b({id:n[1]},n[2],n[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?k(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function T(d){const i=m.exec(d);return i&&i[1]?[c(i[1]),i[2]]:[c(d),void 0]}e.getIdAndVersion=T;function f(d,i){return`${d}.${i}`}e.getExtensionId=f;function c(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function h(d,i){return c(f(d,i))}e.getGalleryExtensionId=h;function u(d,i){const n=[],s=a=>{for(const o of n)if(o.some(g=>k(i(g),i(a))))return o;return null};for(const a of d){const o=s(a);o?o.push(a):n.push([a])}return n}e.groupByExtension=u;function v(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function I(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new S.ExtensionIdentifier("pprice.better-merge");function l(d,i){const n=[],s=i.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const a=s.shift();if(a&&n.every(o=>!k(o.identifier,{id:a}))){const o=d.filter(g=>k(g.identifier,{id:a}));o.length===1&&(n.push(o[0]),s.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.getExtensionDependencies=l;async function w(d,i){if(!M.isLinux)return!1;let n;try{n=(await d.readFile(_.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await d.readFile(_.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(a))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=w;async function t(d,i){const n=await w(d,i),s=(0,y.getTargetPlatform)(n?"alpine":M.platform,E.arch);return i.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=t}),define(Ce[153],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,M,_=5){const A=M(E=>{const k=typeof E=="string"?E:E.data;let O=this._terminalBufferMap.get(S);if(O){O.data.push(k);return}const b=setTimeout(()=>this.flushBuffer(S),_);O={data:[k],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(S),A.dispose()}},this._terminalBufferMap.set(S,O)});return A}stopBuffering(S){this._terminalBufferMap.get(S)?.dispose()}flushBuffer(S){const M=this._terminalBufferMap.get(S);M&&(this._terminalBufferMap.delete(S),this._callback(S,M.data.join("")))}}e.TerminalDataBufferer=r}),define(Ce[154],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var r;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(r=e.ColorScheme||(e.ColorScheme={}));function y(M){return M===r.HIGH_CONTRAST_DARK||M===r.HIGH_CONTRAST_LIGHT}e.isHighContrast=y;function S(M){return M===r.DARK||M===r.HIGH_CONTRAST_DARK}e.isDark=S}),define(Ce[60],Ie([1,0,116,5,7,3,30,154]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var E;(function(h){function u(v){return v&&typeof v=="object"&&typeof v.id=="string"}h.isThemeColor=u})(E=e.ThemeColor||(e.ThemeColor={}));function k(h){return{id:h}}e.themeColorFromId=k;var O;(function(h){function u(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||E.isThemeColor(n.color))}h.isThemeIcon=u;const v=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function I(n){const s=v.exec(n);if(!s)return;const[,a]=s;return{id:a}}h.fromString=I;function l(n){return{id:n}}h.fromId=l;function w(n,s){let a=n.id;const o=a.lastIndexOf("~");return o!==-1&&(a=a.substring(0,o)),s&&(a=`${a}~${s}`),{id:a}}h.modify=w;function t(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}h.getModifier=t;function d(n,s){return n.id===s.id&&n.color?.id===s.color?.id}h.isEqual=d;function i(n,s){return{id:n.id,color:s?k(s):void 0}}h.asThemeIcon=i,h.asClassNameArray=r.CSSIcon.asClassNameArray,h.asClassName=r.CSSIcon.asClassName,h.asCSSSelector=r.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function b(h){switch(h){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(u){return this.themingParticipants.push(u),this.onThemingParticipantAddedEmitter.fire(u),(0,S.toDisposable)(()=>{const v=this.themingParticipants.indexOf(u);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const T=new m;_.Registry.add(e.Extensions.ThemingContribution,T);function f(h){return T.onColorThemeChange(h)}e.registerThemingParticipant=f;class c extends S.Disposable{constructor(u){super(),this.themeService=u,this.theme=u.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(u){this.theme=u,this.updateStyles()}updateStyles(){}getColor(u,v){let I=this.theme.getColor(u);return I&&v&&(I=v(I,this.theme)),I?I.toString():null}}e.Themable=c}),define(Ce[155],Ie([1,0,5,21,3,15]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,S.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,S.createDecorator)("sharedTunnelsService");var _;(function(c){c.Http="http",c.Https="https"})(_=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(c){return e.LOCALHOST_ADDRESSES.indexOf(c)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(c){return e.ALL_INTERFACES_ADDRESSES.indexOf(c)>=0}e.isAllInterfaces=b;function m(c,h){return h?h!==1&&c<1024:!y.isWindows&&c<1024}e.isPortPrivileged=m;class T{constructor(h,u,v){this.remoteAddress=h,this.localAddress=u,this._dispose=v,this._onDispose=new r.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=T;let f=class{constructor(h){this.logService=h,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],u=Array.from(this._tunnels.values());for(const v of u){const I=Array.from(v.values());for(const l of I){const w=await l.value;w&&h.push(w)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:u}of h.values())await u.then(v=>v?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,u,v,I,l=!1,w,t){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${v} on local port ${I}.`),!h)return;if(u||(u="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.retainOrCreateTunnel(h,u,v,I,l,w,t);return d?d.then(i=>{if(!i){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(u,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(i);return(i.tunnelRemoteHost!==u||i.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const u=this._tunnels.get(h.tunnelRemoteHost);if(u){const v=u.get(h.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,v))}}}}async tryDisposeTunnel(h,u,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${u}.`);const I=v.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(u),I}}async closeTunnel(h,u){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${u} `);const v=this._tunnels.get(h);if(v&&v.has(u)){const I=v.get(u);I.refcount=0,await this.tryDisposeTunnel(h,u,I)}}addTunnelToMap(h,u,v){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(u,{refcount:1,value:v})}async removeEmptyTunnelFromMap(h,u){const v=this._tunnels.get(h);v&&(await v.get(u)||v.delete(u),v.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,u){const v=[h];O(h)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):b(h)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const I=v.map(l=>this._tunnels.get(l));for(const l of I){const w=l?.get(u);if(w)return w}}canTunnel(h){return!!k(h)}createWithProvider(h,u,v,I,l,w,t){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${v} on local port ${I}.`);const d=v;this._factoryInProgress.add(d);const n={elevationRequired:l?m(I===void 0?v:I):!1},s={remoteAddress:{host:u,port:v},localAddressPort:I,privacy:w,public:w?w!==A.Private:void 0,protocol:t},a=h.forwardPort(s,n);return a?(this.addTunnelToMap(u,v,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(d)})):this._factoryInProgress.delete(d),a}};f=ze([$e(0,M.ILogService)],f),e.AbstractTunnelService=f}),define(Ce[156],Ie([1,0,12]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function y(E){return E.scheme!==r.Schemas.file&&E.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=y;function S(E){if(E.folders.length)return E.folders.every(k=>y(k.uri))?E.folders[0].uri:void 0;if(E.configuration&&y(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=S;function M(E){return S(E)?.scheme}e.getVirtualWorkspaceScheme=M;function _(E){return S(E)?.authority}e.getVirtualWorkspaceAuthority=_;function A(E){return S(E)!==void 0}e.isVirtualWorkspace=A}),define(Ce[45],Ie([1,0,128,19,24,22,2,3,12]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function k(d){const i=d;return typeof i?.id=="string"&&_.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(d,i){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,y.basename)(d)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const n=d;if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=O;function b(d){const i=d;return typeof i?.id=="string"&&_.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function m(d){const i=d;if(i?.uri)return{id:i.id,uri:_.URI.revive(i.uri)};const n=d;if(n?.configPath)return{id:n.id,configPath:_.URI.revive(n.configPath)};if(d?.id)return{id:d.id}}e.reviveIdentifier=m;var T;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(T=e.WorkbenchState||(e.WorkbenchState={}));function f(d){const i=d;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=f;function c(d){const i=d;return!!(i&&typeof i=="object"&&_.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=c;class h{constructor(i,n,s,a,o){this._id=i,this._transient=s,this._configuration=a,this._ignorePathCasing=o,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=n}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(i,n){this.raw=n,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function v(d){return new u({uri:d,index:0,name:(0,M.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,r.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(d,i){return M.extUriBiasedIgnorePathCase.isEqualOrParent(d,i.untitledWorkspacesHome)}e.isUntitledWorkspace=I;function l(d){let i;return _.URI.isUri(d)?i=d:i=d.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=l;function w(d,i){return!I(d,i)&&!l(d)}e.isSavedWorkspace=w;function t(d){return(typeof d=="string"?(0,y.extname)(d):(0,M.extname)(d))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Ce[61],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const M=this._idPool++;return this._data.set(M,S),this.logDebugInfo(),M}get(S,M){return this._data.has(S)?this._data.get(S)[M]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(Ce[35],Ie([1,0,12,22,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new y.ExtUri(A=>{const E=this._providerInfo.get(A.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(A,E){E===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,E)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,S.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[28],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(Ce[157],Ie([1,0,14]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class y{constructor(_,A,E){this._deferredPromises=new Map,this._id=_,this._shared=A,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of k.values())O.complete()}catch(O){for(const b of k.values())b.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,_])=>_!==void 0).map(([_])=>_)}get whenReady(){return this._init}get(_,A){let E=this._value[_];return typeof E>"u"&&(E=A),E}update(_,A){this._value[_]=A;const E=this._deferredPromises.get(_);if(E!==void 0)return E.p;const k=new r.DeferredPromise;return this._deferredPromises.set(_,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=y;class S extends y{constructor(_,A){super(_.identifier.value,!0,A),this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=S}),define(Ce[158],Ie([1,0,5,2]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class S{constructor(_){this._notebooksAndEditors=_,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new r.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(_,A,E,k){const b=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptModelChanged(A.value,E,k);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(_,A){this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_)).acceptDirty(A)}$acceptModelSaved(_){const A=this._notebooksAndEditors.getNotebookDocument(y.URI.revive(_));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=S}),define(Ce[13],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class y{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=y});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[159],Ie([1,0,27,5]),function(ne,e,r,y){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,E){S.set(this,void 0),this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(A.identifier),Je(this,S,E,"f"),Oe(this,S,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(A){return Oe(this,S,"f").get(this._id,A)}store(A,E){return Oe(this,S,"f").store(this._id,A,E)}delete(A){return Oe(this,S,"f").delete(this._id,A)}}e.ExtensionSecrets=M,S=new WeakMap}),define(Ce[87],Ie([1,0,3,5]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new y.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new y.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(_,A){this._level=_,this._productConfig=A||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(_){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=_,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(Ce[62],Ie([1,0,3,155,5,13]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var _;(function(E){function k(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:b.protocol}}E.fromApiTunnel=k;function O(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==y.TunnelPrivacyId.ConstantPrivate&&b.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}E.fromServiceTunnel=O})(_=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let A=class{constructor(k){this.onDidChangeTunnels=new S.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,O){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,O){return{dispose:()=>{}}}async $providePortAttributes(k,O,b,m,T){return[]}async $forwardPort(k,O){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([$e(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(Ce[46],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class y{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=y}),define(Ce[160],Ie([1,0,23]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class y{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function S(A,E){if(E.serializeBuffersForPostMessage){const k=new y,O=(T,f)=>{if(f instanceof ArrayBuffer){const c=k.add(f);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(f)){const c=M(f);if(c){const h=k.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:c,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},b=JSON.stringify(A,O),m=k.buffers.map(T=>{const f=new Uint8Array(T);return r.VSBuffer.wrap(f)});return{message:b,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=S;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(A,E){const k=E.map(m=>{const T=new ArrayBuffer(m.byteLength);return new Uint8Array(T).set(m.buffer),T}),O=E.length?(m,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const f=T,{index:c}=f,h=k[c];if(f.view)switch(f.view.type){case 1:return new Int8Array(h,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return T}:void 0;return{message:JSON.parse(A,O),arrayBuffers:k}}e.deserializeWebviewMessage=_}),define(Ce[88],Ie([1,0,136,10,2,7,3,30,39,16,12]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(J){J[J.PROGRAMMATIC=1]="PROGRAMMATIC",J[J.USER=2]="USER",J[J.EDIT=3]="EDIT",J[J.NAVIGATION=4]="NAVIGATION",J[J.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(J){J[J.IDENTICAL=1]="IDENTICAL",J[J.SIMILAR=2]="SIMILAR",J[J.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function T(J){const Q=J;return!!Q&&typeof Q.getSelection=="function"&&!!Q.onDidChangeSelection}e.isEditorPaneWithSelection=T;function f(J,Q,ce){for(const te of ce.visibleEditorPanes)if(te.group.id===Q&&J.matches(te.input))return te.getViewState()}e.findViewStateForEditor=f;function c(J){if(a(J))return!1;const Q=J;return S.URI.isUri(Q?.resource)}e.isResourceEditorInput=c;function h(J){if(a(J))return!1;const Q=J;return Q?.original!==void 0&&Q.modified!==void 0}e.isResourceDiffEditorInput=h;function u(J){if(a(J)||h(J))return!1;const Q=J;return Q?.primary!==void 0&&Q.secondary!==void 0}e.isResourceSideBySideEditorInput=u;function v(J){if(a(J))return!1;const Q=J;return Q?Q.resource===void 0||Q.resource.scheme===O.Schemas.untitled||Q.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;const I=/Untitled-\d+/;function l(J){return J.scheme===O.Schemas.untitled&&J.path.length>1&&!I.test(J.path)}e.isUntitledWithAssociatedResource=l;function w(J){if(a(J))return!1;const Q=J;return S.URI.isUri(Q?.base?.resource)&&S.URI.isUri(Q?.input1?.resource)&&S.URI.isUri(Q?.input2?.resource)&&S.URI.isUri(Q?.result?.resource)}e.isResourceMergeEditorInput=w;var t;(function(J){J[J.SHORT=0]="SHORT",J[J.MEDIUM=1]="MEDIUM",J[J.LONG=2]="LONG"})(t=e.Verbosity||(e.Verbosity={}));var d;(function(J){J[J.EXPLICIT=1]="EXPLICIT",J[J.AUTO=2]="AUTO",J[J.FOCUS_CHANGE=3]="FOCUS_CHANGE",J[J.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.mapIdToSaveSource=new Map}registerSource(Q,ce){let te=this.mapIdToSaveSource.get(Q);return te||(te={source:Q,label:ce},this.mapIdToSaveSource.set(Q,te)),te.source}getSourceLabel(Q){return this.mapIdToSaveSource.get(Q)?.label??Q}}e.SaveSourceRegistry=new i;var n;(function(J){J[J.None=0]="None",J[J.Readonly=2]="Readonly",J[J.Untitled=4]="Untitled",J[J.Singleton=8]="Singleton",J[J.RequiresTrust=16]="RequiresTrust",J[J.CanSplitInGroup=32]="CanSplitInGroup",J[J.ForceDescription=64]="ForceDescription",J[J.CanDropIntoEditor=128]="CanDropIntoEditor",J[J.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends M.Disposable{}e.AbstractEditorInput=s;function a(J){return J instanceof s}e.isEditorInput=a;function o(J){const Q=J;return S.URI.isUri(Q?.preferredResource)}function g(J){const Q=J;return a(Q?.primary)&&a(Q?.secondary)}e.isSideBySideEditorInput=g;function p(J){const Q=J;return a(Q?.modified)&&a(Q?.original)}e.isDiffEditorInput=p;function P(J){return a(J?.editor)}e.isEditorInputWithOptions=P;function N(J){const Q=J;return P(J)&&Q?.group!==void 0}e.isEditorInputWithOptionsAndGroup=N;function V(J){const Q=J;return typeof Q?.groupId=="number"&&a(Q.editor)}e.isEditorIdentifier=V;var U;(function(J){J[J.UNKNOWN=0]="UNKNOWN",J[J.REPLACE=1]="REPLACE",J[J.MOVE=2]="MOVE",J[J.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var D;(function(J){J[J.GROUP_ACTIVE=0]="GROUP_ACTIVE",J[J.GROUP_INDEX=1]="GROUP_INDEX",J[J.GROUP_LOCKED=2]="GROUP_LOCKED",J[J.EDITOR_OPEN=3]="EDITOR_OPEN",J[J.EDITOR_CLOSE=4]="EDITOR_CLOSE",J[J.EDITOR_MOVE=5]="EDITOR_MOVE",J[J.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",J[J.EDITOR_LABEL=7]="EDITOR_LABEL",J[J.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",J[J.EDITOR_PIN=9]="EDITOR_PIN",J[J.EDITOR_STICKY=10]="EDITOR_STICKY",J[J.EDITOR_DIRTY=11]="EDITOR_DIRTY",J[J.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(D=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(J){J[J.PRIMARY=1]="PRIMARY",J[J.SECONDARY=2]="SECONDARY",J[J.BOTH=3]="BOTH",J[J.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri(Q,ce){if(!Q)return;if(w(Q))return e.EditorResourceAccessor.getOriginalUri(Q.result,ce);if(ce?.supportSideBySide){const{primary:pe,secondary:be}=this.getSideEditors(Q);if(pe&&be){if(ce?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:ce.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===x.ANY)return this.getOriginalUri(pe,{filterByScheme:ce.filterByScheme})??this.getOriginalUri(be,{filterByScheme:ce.filterByScheme});Q=ce.supportSideBySide===x.PRIMARY?pe:be}}if(h(Q)||u(Q)||w(Q))return;const te=o(Q)?Q.preferredResource:Q.resource;return!te||!ce||!ce.filterByScheme?te:this.filterUri(te,ce.filterByScheme)}getSideEditors(Q){return g(Q)||u(Q)?{primary:Q.primary,secondary:Q.secondary}:p(Q)||h(Q)?{primary:Q.modified,secondary:Q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Q,ce){if(!Q)return;if(w(Q))return e.EditorResourceAccessor.getCanonicalUri(Q.result,ce);if(ce?.supportSideBySide){const{primary:pe,secondary:be}=this.getSideEditors(Q);if(pe&&be){if(ce?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:ce.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===x.ANY)return this.getCanonicalUri(pe,{filterByScheme:ce.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:ce.filterByScheme});Q=ce.supportSideBySide===x.PRIMARY?pe:be}}if(h(Q)||u(Q)||w(Q))return;const te=Q.resource;return!te||!ce||!ce.filterByScheme?te:this.filterUri(te,ce.filterByScheme)}filterUri(Q,ce){if(Array.isArray(ce)){if(ce.some(te=>Q.scheme===te))return Q}else if(ce===Q.scheme)return Q}}e.EditorResourceAccessor=new L;var R;(function(J){J[J.LEFT=0]="LEFT",J[J.RIGHT=1]="RIGHT"})(R=e.CloseDirection||(e.CloseDirection={}));class K{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Q){const ce=this.instantiationService=Q.get(_.IInstantiationService);for(const[te,pe]of this.editorSerializerConstructors)this.createEditorSerializer(te,pe,ce);this.editorSerializerConstructors.clear()}createEditorSerializer(Q,ce,te){const pe=te.createInstance(ce);this.editorSerializerInstances.set(Q,pe)}registerFileEditorFactory(Q){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Q}getFileEditorFactory(){return(0,y.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Q,ce){if(this.editorSerializerConstructors.has(Q)||this.editorSerializerInstances.has(Q))throw new Error(`A editor serializer with type ID '${Q}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Q,ce,this.instantiationService):this.editorSerializerConstructors.set(Q,ce),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(Q),this.editorSerializerInstances.delete(Q)})}getEditorSerializer(Q){return this.editorSerializerInstances.get(typeof Q=="string"?Q:Q.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new K);async function W(J,Q){if(!J||!J.length)return[];const ce=await Promise.all(J.map(async te=>{const pe=S.URI.revive(te.fileUri);if(!pe||!await Q.canHandleResource(pe))return;let re=te.exists,Ee=te.type;if(typeof re!="boolean"||typeof Ee!="number")try{Ee=(await Q.stat(pe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,re=!0}catch{re=!1}if(!re&&te.openOnlyIfExists||Ee===E.FileType.Directory)return;const Pe={...te.options,pinned:!0};let Fe;return re?Fe={resource:pe,options:Pe}:Fe={resource:pe,options:Pe,forceUntitled:!0},Fe}));return(0,k.coalesce)(ce)}e.pathsToEditors=W;var $;(function(J){J[J.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",J[J.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}));function fe(J){const Q=J;if(!Q)return!1;const ce=Q;if(ce.modified)return fe(ce.modified);const te=Q;return!!(te.contributionsState&&te.viewState&&Array.isArray(te.cursorState))}e.isTextEditorViewState=fe}),define(Ce[63],Ie([1,0,12,2]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function S(A,E){return A.scheme===r.Schemas.http||A.scheme===r.Schemas.https?A:(E&&E.authority&&E.isRemote&&A.scheme===r.Schemas.file&&(A=y.URI.from({scheme:r.Schemas.vscodeRemote,authority:E.authority,path:A.path})),y.URI.from({scheme:r.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=S;function M(A){return A.replace(/./g,E=>{const k=E.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?E:"-"+k.toString(16).padStart(4,"0")})}function _(A){return A.replace(/-([0-9a-f]{4})/g,(E,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=_}),define(Ce[161],Ie([1,0,5,7,63]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,E,k){this._proxy=A,this._editors=E,this._remoteInfo=k,this._handlePool=0,this._disposables=new y.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const O=E.getVisibleTextEditors();for(const b of this._insets.values())O.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,E,k,O,b){let m;for(const I of this._editors.getVisibleTextEditors(!0))if(I.value===A){m=I;break}if(!m)throw new Error("not a visible editor");const T=this,f=this._handlePool++,c=new r.Emitter,h=new r.Emitter,u=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(I){return(0,S.asWebviewUri)(I,T._remoteInfo)}get cspSource(){return S.webviewGenericCspSource}set options(I){this._options=I,T._proxy.$setOptions(f,I)}get options(){return this._options}set html(I){this._html=I,T._proxy.$setHtml(f,I)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(I){return T._proxy.$postMessage(f,I)}},v=new class{constructor(){this.editor=A,this.line=E,this.height=k,this.webview=u,this.onDidDispose=h.event}dispose(){T._insets.has(f)&&(T._insets.delete(f),T._proxy.$disposeEditorInset(f),h.fire(),h.dispose(),c.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,E+1,k,O||{},b.identifier,b.extensionLocation),this._insets.set(f,{editor:A,inset:v,onDidReceiveMessage:c}),v}$onDidDispose(A){const E=this._insets.get(A);E&&E.inset.dispose()}$onDidReceiveMessage(A,E){this._insets.get(A)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=M}),define(Ce[162],Ie([1,0,5,14,137]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,E,k,O){const b={command:A};if(E&&Object.keys(E).length>0&&(b.arguments=E),this.internalSend("request",b),typeof O=="number"){const m=setTimeout(()=>{clearTimeout(m);const T=this.pendingRequests.get(b.seq);if(T){this.pendingRequests.delete(b.seq);const f={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,S.localize)(0,null,O,A)};T(f)}},O)}return k&&this.pendingRequests.set(b.seq,k),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,E){return A.type!=="event"||E.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,y.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const E=A,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}}internalSend(A,E){E.type=A,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((E,k)=>A.set(k,E)),await(0,y.timeout)(500),A.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Ce[163],Ie([1,0,138,38,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new y.RawContextKey("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new y.RawContextKey("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new y.RawContextKey("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new y.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:r.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new y.RawContextKey("inDebugMode",!1,{type:"boolean",description:r.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new y.RawContextKey("inDebugRepl",!1,{type:"boolean",description:r.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new y.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new y.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:r.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new y.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:r.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new y.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new y.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:r.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new y.RawContextKey("variablesFocused",!0,{type:"boolean",description:r.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new y.RawContextKey("expressionSelected",!1,{type:"boolean",description:r.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new y.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:r.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new y.RawContextKey("callStackItemType",void 0,{type:"string",description:r.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new y.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new y.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:r.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new y.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new y.RawContextKey("watchItemType",void 0,{type:"string",description:r.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new y.RawContextKey("canViewMemory",void 0,{type:"boolean",description:r.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new y.RawContextKey("breakpointItemType",void 0,{type:"string",description:r.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new y.RawContextKey("breakpointAccessType",void 0,{type:"string",description:r.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new y.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new y.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new y.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:r.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new y.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new y.RawContextKey("stepBackSupported",!1,{type:"boolean",description:r.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new y.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:r.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new y.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new y.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new y.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new y.RawContextKey("breakpointsExist",!1,{type:"boolean",description:r.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new y.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:r.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new y.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:r.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new y.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new y.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new y.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new y.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new y.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new y.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new y.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new y.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new y.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new y.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:r.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new y.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new y.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:r.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new y.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:r.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new y.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new y.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new y.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new y.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(50,null)});const M=m=>r.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(52,null)};var _;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(_=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var E;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,S.createDecorator)(e.DEBUG_SERVICE_ID);var b;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(b=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[164],Ie([1,0,9,2,19,26,12]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function E(i,n,s){return i.replace(A,function(a,o){return n&&o.length>0&&o[0]!=="_"?a:s&&s.hasOwnProperty(o)?s[o]:a})}e.formatPII=E;function k(i){const n={};for(const s of Object.keys(i))s.startsWith("!")||(n[s]=i[s]);return n}e.filterExceptionsFromTelemetry=k;function O(i){return i.configuration.request==="attach"&&!b(i)&&(!i.parentSession||O(i.parentSession))}e.isSessionAttach=O;function b(i){let n=i.configuration.type;if(!!n)return n==="vslsShare"&&(n=i.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?i:i.parentSession?b(i.parentSession):void 0}e.getExtensionHostDebugSession=b;function m(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=m;function T(i,n,s){let a,o=0;const g=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let p=null;for(;p=g.exec(i);){const P=p.index+1,N=P+p[0].length;if(P<=n&&N>=s){a=p[0],o=P;break}}if(a){const P=/\w+/g;let N=null;for(;(N=P.exec(a))&&!(N.index+1+o+N[0].length>=s););N&&(a=a.substring(0,P.lastIndex))}return a?{start:o,end:o+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=T;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(i){return!!(i&&i.match(f))}e.isUri=c;function h(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(c(i.path))return y.URI.parse(i.path);if((0,S.isAbsolute)(i.path))return y.URI.file(i.path)}return i.path}function u(i){if(typeof i.path=="object"){const n=y.URI.revive(i.path);if(n)return n.scheme===_.Schemas.file?n.fsPath:n.toString()}return i.path}function v(i,n){const s=n?h:u,a=(0,M.deepClone)(i);return l(a,(o,g)=>{o&&g&&(g.path=s(g))}),a}e.convertToDAPaths=v;function I(i,n){const s=n?h:u,a=(0,M.deepClone)(i);return l(a,(o,g)=>{!o&&g&&(g.path=s(g))}),a}e.convertToVSCPaths=I;function l(i,n){switch(i.type){case"event":{const s=i;switch(s.event){case"output":n(!1,s.body.source);break;case"loadedSource":n(!1,s.body.source);break;case"breakpoint":n(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=i;switch(s.command){case"setBreakpoints":n(!0,s.arguments.source);break;case"breakpointLocations":n(!0,s.arguments.source);break;case"source":n(!0,s.arguments.source);break;case"gotoTargets":n(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(a=>n(!1,a));break;default:break}break}case"response":{const s=i;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(a=>n(!1,a.source));break;case"loadedSources":s.body.sources.forEach(a=>n(!1,a));break;case"scopes":s.body.scopes.forEach(a=>n(!1,a.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(a=>n(!1,a.source));break;case"setBreakpoints":s.body.breakpoints.forEach(a=>n(!1,a.source));break;case"disassemble":s.body?.instructions.forEach(o=>n(!1,o.location));break;default:break}break}}}function w(i){return i.filter(n=>!n.presentation?.hidden).sort((n,s)=>n.presentation?s.presentation?n.presentation.group?s.presentation.group?n.presentation.group!==s.presentation.group?n.presentation.group.localeCompare(s.presentation.group):t(n.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(n.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=w;function t(i,n){return typeof i!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:i-n}async function d(i,n){const s=i.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(s!=="none"&&(await n.saveAll(),s==="allEditorsInActiveGroup")){const a=n.activeEditorPane;a&&a.input.resource?.scheme===_.Schemas.untitled&&await n.save({editor:a.input,groupId:a.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=d}),define(Ce[64],Ie([1,0,23,34,165,74,12,19,21,38]),function(ne,e,r,y,S,M,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var O;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var b;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(b=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(o){o[o.Unconfirmed=1]="Unconfirmed",o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var T;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(T=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var c;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.ChangeCellLanguage=5]="ChangeCellLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.ChangeCellMime=13]="ChangeCellMime",o[o.Unknown=100]="Unknown"})(c=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var u;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(u=e.CellEditType||(e.CellEditType={}));var v;(function(o){o.scheme=_.Schemas.vscodeNotebookCell;const g=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${g.join("")}]+`),P=7;function N(R,K){const W=K.toString(P),fe=`${W.length<g.length?g[W.length-1]:"z"}${W}s${(0,r.encodeBase64)(r.VSBuffer.fromString(R.scheme),!0,!0)}`;return R.with({scheme:o.scheme,fragment:fe})}o.generate=N;function V(R){if(R.scheme!==o.scheme)return;const K=R.fragment.indexOf("s");if(K<0)return;const W=parseInt(R.fragment.substring(0,K).replace(p,""),P),$=(0,r.decodeBase64)(R.fragment.substring(K+1)).toString();if(!isNaN(W))return{handle:W,notebook:R.with({scheme:$,fragment:null})}}o.parse=V;function U(R,K){return R.with({scheme:_.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${R.scheme!==_.Schemas.file?R.scheme:""}`})}o.generateCellOutputUri=U;function D(R){if(R.scheme!==_.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(R.fragment);if(!K)return;const W=K[1]&&K[1]!==""?K[1]:void 0,$=K[2];return{outputId:W,notebook:R.with({scheme:$||_.Schemas.file,fragment:null})}}o.parseCellOutputUri=D;function x(R,K,W){return o.generate(R,K).with({scheme:W})}o.generateCellPropertyUri=x;function L(R,K){if(R.scheme===K)return o.parse(R.with({scheme:o.scheme}))}o.parseCellPropertyUri=L})(v=e.CellUri||(e.CellUri={}));const I=o=>E.isWindows?o.replace(/\//g,"\\"):o;class l{constructor(g=[],p=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=p,this.order=[...new Set(g)].map(P=>({pattern:P,matches:y.parse(I(P))}))}sort(g){const p=new Map(S.Iterable.map(g,N=>[N,I(N)]));let P=[];for(const{matches:N}of this.order)for(const[V,U]of p)if(N(U)){P.push(V),p.delete(V);break}return p.size&&(P=P.concat([...p.keys()].sort((N,V)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(V)))),P}prioritize(g,p){const P=this.findIndex(g);if(P===-1){this.order.unshift({pattern:g,matches:y.parse(I(g))});return}const N=new Set(p.map(U=>this.findIndex(U,P)));N.delete(-1);const V=Array.from(N).sort();this.order.splice(P+1,0,...V.map(U=>this.order[U]));for(let U=V.length-1;U>=0;U--)this.order.splice(V[U],1)}toArray(){return this.order.map(g=>g.pattern)}findIndex(g,p=this.order.length){const P=I(g);for(let N=0;N<p;N++)if(this.order[N].matches(P))return N;return-1}}e.MimeTypeDisplayOrder=l;function w(o,g,p,P=(N,V)=>N===V){const N=[];function V(x,L,R){if(L===0&&R.length===0)return;const K=N[N.length-1];K&&K.start+K.deleteCount===x?(K.deleteCount+=L,K.toInsert.push(...R)):N.push({start:x,deleteCount:L,toInsert:R})}let U=0,D=0;for(;;){if(U===o.length){V(U,0,g.slice(D));break}if(D===g.length){V(U,o.length-U,[]);break}const x=o[U],L=g[D];if(P(x,L)){U+=1,D+=1;continue}p(L)?(V(U,1,[]),U+=1):(V(U,0,[L]),D+=1)}return N}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(o){o.default="default",o.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(o){const g=o;return!!((typeof g.include=="string"||y.isRelativePattern(g.include))&&(typeof g.exclude=="string"||y.isRelativePattern(g.exclude)))}e.isDocumentExcludePattern=d;function i(o,g,p){if(Array.isArray(o.viewType)&&o.viewType.indexOf(g)>=0||o.viewType===g)return!0;if(o.filenamePattern){const P=d(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,N=d(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(y.match(P,(0,A.basename)(p.fsPath).toLowerCase()))return!(N&&y.match(N,(0,A.basename)(p.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var n;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(g){return`${s._prefix}${g}`}static parse(g){if(g.startsWith(s._prefix))return g.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/";function a(o){return["application/vnd.code.notebook.stdout","application/x.notebook.stdout","application/x.notebook.stream","application/vnd.code.notebook.stderr","application/x.notebook.stderr"].includes(o)}e.isTextStreamMime=a}),define(Ce[166],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var y;(function(S){S[S.Output=1]="Output",S[S.OutputItems=2]="OutputItems",S[S.ExecutionState=3]="ExecutionState"})(y=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(Ce[167],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function y(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=y;function S(_){return Array.from(_.entries()).map(A=>[A[0],r(A[1].map)])}e.serializeEnvironmentVariableCollections=S;function M(_){return new Map(_.map(A=>[A[0],{map:y(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[47],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(M){M.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var y;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(y=e.TestPosition||(e.TestPosition={}));class S{constructor(_,A=_.length){if(this.path=_,this.viewEnd=A,_.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(_,A,E=_.parent){if(_.id===A)return new S([A]);const k=[_.id];for(let O=E;O&&O.id!==A;O=O.parent)k.push(O.id);return k.push(A),new S(k.reverse())}static isRoot(_){return!_.includes("\0")}static root(_){const A=_.indexOf("\0");return A===-1?_:_.slice(0,A)}static fromString(_){return new S(_.split("\0"))}static join(_,A){return new S([..._.path,A])}static joinToString(_,A){return _.toString()+"\0"+A}static compare(_,A){return _===A?0:A.startsWith(_+"\0")?2:_.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new S(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let _=1;_<=this.viewEnd;_++)yield new S(this.path,_)}compare(_){if(typeof _=="string")return S.compare(this.toString(),_);for(let A=0;A<_.viewEnd&&A<this.viewEnd;A++)if(_.path[A]!==this.path[A])return 1;return _.viewEnd>this.viewEnd?2:_.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let _=1;_<this.viewEnd;_++)this.stringifed+="\0",this.stringifed+=this.path[_]}return this.stringifed}}e.TestId=S}),define(Ce[48],Ie([1,0,2,49]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var S;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(S=e.TestResultState||(e.TestResultState={}));var M;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(s){s.serialize=a=>({range:a.range.toJSON(),uri:a.uri.toJSON()}),s.deserialize=a=>({range:y.Range.lift(a.range),uri:r.URI.revive(a.uri)})})(_=e.IRichLocation||(e.IRichLocation={}));var A;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(A=e.TestMessageType||(e.TestMessageType={}));var E;(function(s){s.serialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:0,expected:a.expected,actual:a.actual,location:a.location&&_.deserialize(a.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var k;(function(s){s.serialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.serialize(a.location)}),s.deserialize=a=>({message:a.message,type:1,offset:a.offset,length:a.length,location:a.location&&_.deserialize(a.location)})})(k=e.ITestOutputMessage||(e.ITestOutputMessage={}));var O;(function(s){s.serialize=a=>a.type===0?E.serialize(a):k.serialize(a),s.deserialize=a=>a.type===0?E.deserialize(a):k.deserialize(a)})(O=e.ITestMessage||(e.ITestMessage={}));var b;(function(s){s.serializeWithoutMessages=a=>({state:a.state,duration:a.duration,messages:[]}),s.serialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(O.serialize)}),s.deserialize=a=>({state:a.state,duration:a.duration,messages:a.messages.map(O.deserialize)})})(b=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",T=(s,a)=>s+m+a;e.namespaceTestTag=T;const f=s=>{const a=s.indexOf(m);return{ctrlId:s.slice(0,a),tagId:s.slice(a+1)}};e.denamespaceTestTag=f;var c;(function(s){s.serialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?.toJSON(),range:a.range?.toJSON()||null,description:a.description,error:a.error,sortText:a.sortText}),s.deserialize=a=>({extId:a.extId,label:a.label,tags:a.tags,busy:a.busy,children:void 0,uri:a.uri?r.URI.revive(a.uri):void 0,range:a.range?y.Range.lift(a.range):null,description:a.description,error:a.error,sortText:a.sortText})})(c=e.ITestItem||(e.ITestItem={}));var h;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var u;(function(s){s.serialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:c.serialize(a.item)}),s.deserialize=a=>({controllerId:a.controllerId,expand:a.expand,parent:a.parent,item:c.deserialize(a.item)})})(u=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(s){s.serialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.uri!==void 0&&(o.uri=a.item.uri?.toJSON()),a.item.range!==void 0&&(o.range=a.item.range?.toJSON()),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o,docv:a.docv}},s.deserialize=a=>{let o;return a.item&&(o={},a.item.label!==void 0&&(o.label=a.item.label),a.item.tags!==void 0&&(o.tags=a.item.tags),a.item.busy!==void 0&&(o.busy=a.item.busy),a.item.range!==void 0&&(o.range=a.item.range?y.Range.lift(a.item.range):null),a.item.description!==void 0&&(o.description=a.item.description),a.item.error!==void 0&&(o.error=a.item.error),a.item.sortText!==void 0&&(o.sortText=a.item.sortText)),{extId:a.extId,expand:a.expand,item:o,docv:a.docv}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const I=(s,a)=>{a.expand!==void 0&&(s.expand=a.expand),a.item!==void 0&&(s.item=s.item?Object.assign(s.item,a.item):a.item)};e.applyTestItemUpdate=I;var l;(function(s){s.serializeWithoutMessages=a=>({...u.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(b.serializeWithoutMessages),retired:a.retired}),s.serialize=a=>({...u.serialize(a),ownComputedState:a.ownComputedState,computedState:a.computedState,tasks:a.tasks.map(b.serialize),retired:a.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var w;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(w=e.DetailType||(e.DetailType={}));var t;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(t=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(s){s.deserialize=a=>a.op===0?{op:a.op,item:u.deserialize(a.item)}:a.op===1?{op:a.op,item:v.deserialize(a.item)}:a,s.serialize=a=>a.op===0?{op:a.op,item:u.serialize(a.item)}:a.op===1?{op:a.op,item:v.serialize(a.item)}:a})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class i{add(a){}update(a){}remove(a,o){}complete(){}}e.IncrementalChangeCollector=i;class n{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(a){const o=this.createChangeCollector();for(const g of a)switch(g.op){case 0:{const p=u.deserialize(g.item);if(p.parent){if(this.items.has(p.parent)){const P=this.items.get(p.parent);P.children.add(p.item.extId);const N=this.createItem(p,P);this.items.set(p.item.extId,N),o.add(N)}}else{const P=this.createItem(p);this.roots.add(P),this.items.set(p.item.extId,P),o.add(P)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=v.deserialize(g.item),P=this.items.get(p.extId);if(!P)break;p.expand!==void 0&&(P.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(P,p),o.update(P);break}case 2:{const p=this.items.get(g.itemId);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const P=[[g.itemId]];for(;P.length;)for(const N of P.pop()){const V=this.items.get(N);V&&(P.push(V.children),this.items.delete(N),o.remove(V,V!==p),V.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(g.itemId);break;case 3:this.updatePendingRoots(g.amount);break;case 5:this._tags.set(g.tag.id,g.tag);break;case 6:this._tags.delete(g.id);break}o.complete()}retireTest(a){}updatePendingRoots(a){this.pendingRootCount+=a}createChangeCollector(){return new i}}e.AbstractIncrementalTestCollection=n}),define(Ce[65],Ie([1,0,14,5,7,44,48,47]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(u,v)=>u===v,O={range:(u,v)=>u===v?!0:!u||!v?!1:u.equalsRange(v),busy:k,label:k,description:k,error:k,tags:(u,v)=>!(u.length!==v.length||u.some(I=>!v.includes(I)))},b=(u,v)=>{let I;for(const[l,w]of Object.entries(O))w(u[l],v[l])||(I?I[l]=v[l]:I={[l]:v[l]});return I};class m extends S.Disposable{constructor(v){super(),this.options=v,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new y.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const I of this.tree.values())this.updateExpandability(I)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const I=this.diff[this.diff.length-1];if(I&&v.op===1){if(I.op===1&&I.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(I.item,v.item);return}if(I.op===0&&I.item.item.extId===v.item.extId){(0,_.applyTestItemUpdate)(I.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,I){const l=this.tree.get(v);if(!!l){if((l.expandLevels===void 0||I>l.expandLevels)&&(l.expandLevels=I),l.expand===1){const w=this.resolveChildren(l);return w.isOpen()?this.expandChildren(l,I-1):w.wait().then(()=>this.expandChildren(l,I-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,I-1)):this.expandChildren(l,I-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,I){switch(I.op){case 3:this.removeItem(A.TestId.joinToString(v.fullId,I.id));break;case 0:this.upsertItem(I.item,v);break;case 5:for(const l of I.ops)this.onTestItemEvent(v,l);break;case 1:this.diffTagRefs(I.new,I.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:I.update,docv:this.options.getDocumentVersion(v.actual.uri)}});break;default:(0,M.assertNever)(I)}}upsertItem(v,I){const l=A.TestId.fromExtHostTestItem(v,this.root.id,I?.actual),w=this.options.getApiFor(v);w.parent&&w.parent!==I?.actual&&this.options.getChildren(w.parent).delete(v.id);let t=this.tree.get(l.toString());if(!t){t={fullId:l,actual:v,parent:I?l.parentId:null,expandLevels:I?.expandLevels?I.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(t.fullId.toString(),t),this.setItemParent(v,I),this.pushDiff({op:0,item:{parent:t.parent&&t.parent.toString(),controllerId:this.options.controllerId,expand:t.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,t,I);return}if(t.actual===v){this.connectItem(v,t,I);return}const d=this.options.getChildren(t.actual),i=t.actual,n=b(this.options.toITestItem(i),this.options.toITestItem(v));this.options.getApiFor(i).listener=void 0,t.actual=v,t.expand=0,n&&(n.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,i.tags,l.toString()),delete n.tags),this.onTestItemEvent(t,{op:4,update:n})),this.connectItemAndChildren(v,t,I);for(const[s,a]of d)this.options.getChildren(v).get(a.id)||this.removeItem(A.TestId.joinToString(l,a.id))}diffTagRefs(v,I,l){const w=new Set(I.map(t=>t.id));for(const t of v)w.delete(t.id)||this.incrementTagRefs(t);this.pushDiff({op:1,item:{extId:l,item:{tags:v.map(t=>(0,_.namespaceTestTag)(this.options.controllerId,t.id))}}}),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const I=this.tags.get(v.id);I?I.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,_.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const I=this.tags.get(v);I&&!--I.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,_.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,I){this.options.getApiFor(v).parent=I&&I.actual!==this.root?I.actual:void 0}connectItem(v,I,l){this.setItemParent(v,l);const w=this.options.getApiFor(v);w.parent=l?.actual,w.listener=t=>this.onTestItemEvent(I,t),this.updateExpandability(I)}connectItemAndChildren(v,I,l){this.connectItem(v,I,l);for(const[w,t]of this.options.getChildren(v))this.upsertItem(t,I)}updateExpandability(v){let I;this._resolveHandler?v.resolveBarrier?I=v.resolveBarrier.isOpen()?3:2:I=v.actual.canResolveChildren?1:0:I=0,I!==v.expand&&(v.expand=I,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:I}}),I===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,I){if(I<0)return;const l=[];for(const[w,t]of this.options.getChildren(v.actual)){const d=this.expand(A.TestId.joinToString(v.fullId,t.id),I);(0,r.isThenable)(d)&&l.push(d)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const t=new r.Barrier;return t.open(),t}v.expand=2,this.pushExpandStateUpdate(v);const I=v.resolveBarrier=new r.Barrier,l=t=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,t)};let w;try{w=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(t){l(t)}return(0,r.isThenable)(w)?w.catch(l).then(()=>{I.open(),this.updateExpandability(v)}):(I.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const I=this.tree.get(v);if(!I)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const l=[I];for(;l.length;){const w=l.pop();if(!!w){this.options.getApiFor(w.actual).listener=void 0;for(const t of w.actual.tags)this.decrementTagRefs(t.id);this.tree.delete(w.fullId.toString());for(const[t,d]of this.options.getChildren(w.actual))l.push(this.tree.get(A.TestId.joinToString(w.fullId,d.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=m;class T extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=T;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class c extends Error{constructor(v,I,l){super(`TestItem with ID "${v}" is from controller "${I}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=c;const h=(u,v,I)=>{let l=new Map;return{get size(){return l.size},forEach(w,t){for(const d of l.values())w.call(t,d,this)},[Symbol.iterator](){return l.entries()},replace(w){const t=new Map,d=new Set(l.keys()),i={op:5,ops:[]};for(const n of w){if(!(n instanceof I))throw new f(n.id);const s=v(n).controllerId;if(s!==u.controllerId)throw new c(n.id,s,u.controllerId);if(t.has(n.id))throw new T(n.id);t.set(n.id,n),d.delete(n.id),i.ops.push({op:0,item:n})}for(const n of d.keys())i.ops.push({op:3,id:n});u.listener?.(i),l=t},add(w){if(!(w instanceof I))throw new f(w.id);l.set(w.id,w),u.listener?.({op:0,item:w})},delete(w){l.delete(w)&&u.listener?.({op:3,id:w})},get(w){return l.get(w)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=h}),define(Ce[89],Ie([1,0,65]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const y=new WeakMap,S=(_,A)=>{const E={controllerId:A};return y.set(_,E),E};e.createPrivateApiFor=S;const M=_=>{const A=y.get(_);if(!A)throw new r.InvalidTestItemError(_?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ce[168],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,r.createDecorator)("configurationResolverService");var y;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(y=e.VariableKind||(e.VariableKind={}));class S extends Error{constructor(_,A){super(A),this.variable=_}}e.VariableError=S}),define(Ce[169],Ie([1,0,19,59,10,26,21,77,141,168,9]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(T,f,c,h){this._contributedVariables=new Map,this._context=T,this._labelService=f,this._userHomePromise=c,h&&(this._envVariablesPromise=h.then(u=>this.prepareEnv(u)))}prepareEnv(T){if(_.isWindows){const f=Object.create(null);return Object.keys(T).forEach(c=>{f[c.toLowerCase()]=T[c]}),f}return T}resolveWithEnvironment(T,f,c){return this.recursiveResolve({env:this.prepareEnv(T),userHome:void 0},f?f.uri:void 0,c)}async resolveAsync(T,f){const c={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(c,T?T.uri:void 0,f)}async resolveAnyBase(T,f,c,h){const u=M.deepClone(f);_.isWindows&&u.windows?Object.keys(u.windows).forEach(I=>u[I]=u.windows[I]):_.isMacintosh&&u.osx?Object.keys(u.osx).forEach(I=>u[I]=u.osx[I]):_.isLinux&&u.linux&&Object.keys(u.linux).forEach(I=>u[I]=u.linux[I]),delete u.windows,delete u.osx,delete u.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,T?T.uri:void 0,u,c,h)}async resolveAnyAsync(T,f,c){return this.resolveAnyBase(T,f,c)}async resolveAnyMap(T,f,c){const h=new Map;return{newConfig:await this.resolveAnyBase(T,f,c,h),resolvedVariables:h}}resolveWithInteractionReplace(T,f,c,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,f,c,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,f){if(this._contributedVariables.has(T))throw new Error("Variable "+T+" is contributed twice.");this._contributedVariables.set(T,f)}async recursiveResolve(T,f,c,h,u){if(S.isString(c))return this.resolveString(T,f,c,h,u);if(Array.isArray(c))return Promise.all(c.map(v=>this.recursiveResolve(T,f,v,h,u)));if(S.isObject(c)){const v=Object.create(null),I=await Promise.all(Object.keys(c).map(async l=>[await this.resolveString(T,f,l,h,u),await this.recursiveResolve(T,f,c[l],h,u)]));for(const[l,w]of I)v[l]=w;return v}return c}resolveString(T,f,c,h,u){return(0,O.replaceAsync)(c,b.VARIABLE_REGEXP,async(v,I)=>{if(I.includes(b.VARIABLE_LHS))return v;let l=await this.evaluateSingleVariable(T,v,I,f,h);return u?.set(I,l),l!==v&&S.isString(l)&&l.match(b.VARIABLE_REGEXP)&&(l=await this.resolveString(T,f,l,h,u)),l})}fsPath(T){return this._labelService?this._labelService.getUriLabel(T,{noPrefix:!0}):T.fsPath}async evaluateSingleVariable(T,f,c,h,u){let v;const I=c.split(":");I.length>1&&(c=I[0],v=I[1]);const l=d=>{const i=this._context.getFilePath();if(i)return i;throw new k.VariableError(d,(0,E.localize)(0,null,f))},w=d=>{const i=l(d);if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new k.VariableError(d,(0,E.localize)(1,null,f,r.basename(i)))},t=d=>{if(v){const i=this._context.getFolderUri(v);if(i)return i;throw new k.VariableError(d,(0,E.localize)(2,null,f,v))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new k.VariableError(d,(0,E.localize)(3,null,f)):new k.VariableError(d,(0,E.localize)(4,null,f))};switch(c){case"env":if(v){if(T.env){const d=T.env[_.isWindows?v.toLowerCase():v];if(S.isString(d))return d}return""}throw new k.VariableError(k.VariableKind.Env,(0,E.localize)(5,null,f));case"config":if(v){const d=this._context.getConfigurationValue(h,v);if(S.isUndefinedOrNull(d))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(6,null,f,v));if(S.isObject(d))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(7,null,f,v));return d}throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(8,null,f));case"command":return this.resolveFromMap(k.VariableKind.Command,f,v,u,"command");case"input":return this.resolveFromMap(k.VariableKind.Input,f,v,u,"input");case"extensionInstallFolder":if(v){const d=await this._context.getExtension(v);if(!d)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,f,v));return this.fsPath(d.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,f));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(t(k.VariableKind.WorkspaceFolder)));case"cwd":return h||v?(0,A.normalizeDriveLetter)(this.fsPath(t(k.VariableKind.Cwd))):y.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(t(k.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(T.userHome)return T.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,E.localize)(11,null,f))}case"lineNumber":{const d=this._context.getLineNumber();if(d)return d;throw new k.VariableError(k.VariableKind.LineNumber,(0,E.localize)(12,null,f))}case"selectedText":{const d=this._context.getSelectedText();if(d)return d;throw new k.VariableError(k.VariableKind.SelectedText,(0,E.localize)(13,null,f))}case"file":return l(k.VariableKind.File);case"fileWorkspaceFolder":return w(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||v?r.relative(this.fsPath(t(k.VariableKind.RelativeFile)),l(k.VariableKind.RelativeFile)):l(k.VariableKind.RelativeFile);case"relativeFileDirname":{const d=r.dirname(l(k.VariableKind.RelativeFileDirname));if(h||v){const i=r.relative(this.fsPath(t(k.VariableKind.RelativeFileDirname)),d);return i.length===0?".":i}return d}case"fileDirname":return r.dirname(l(k.VariableKind.FileDirname));case"fileExtname":return r.extname(l(k.VariableKind.FileExtname));case"fileBasename":return r.basename(l(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=r.basename(l(k.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-r.extname(d).length)}case"fileDirnameBasename":return r.basename(r.dirname(l(k.VariableKind.FileDirnameBasename)));case"execPath":{const d=this._context.getExecPath();return d||f}case"execInstallFolder":{const d=this._context.getAppRoot();return d||f}case"pathSeparator":return r.sep;default:try{const d=v?`${c}:${v}`:c;return this.resolveFromMap(k.VariableKind.Unknown,f,d,u,void 0)}catch{return f}}}}resolveFromMap(T,f,c,h,u){if(c&&h){const v=u===void 0?h[c]:h[u+":"+c];if(typeof v=="string")return v;throw new k.VariableError(T,(0,E.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[90],Ie([1,0,3,88]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var S;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(S=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var _;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(_=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function k(f){const c=f;return(0,y.isEditorInput)(c?.editor)&&(0,y.isEditorInput)(c?.replacement)}e.isEditorReplacement=k;var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const c=f;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.isEditorGroup=m;function T(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(Ce[170],Ie([1,0,3,90]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function S(M){const _=M;return typeof M=="number"||(0,y.isEditorGroup)(_)}e.isPreferredGroup=S}),define(Ce[171],Ie([1,0,3,146]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(y.IEnvironmentService)}),define(Ce[172],Ie([1,0,27,5,19]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(b){this.removedDueToLooping=b}}e.DeltaExtensionsResult=M;class _{constructor(b){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=b,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const b of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(b.identifier))){console.error("Extension `"+b.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(b.identifier),b),this._extensionsArr.push(b),Array.isArray(b.activationEvents))for(let m of b.activationEvents)m==="onUri"&&(m=`onUri:${r.ExtensionIdentifier.toKey(b.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(b)}}set(b){this._extensionDescriptions=b,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(b,m){this._extensionDescriptions=k(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(b);const T=_._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=k(this._extensionDescriptions,T.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(T)}static _findLoopingExtensions(b){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(u){this._nodesSet.has(u)||(this._nodesSet.add(u),this._nodesArr.push(u))}addArc(u,v){this.addNode(u),this.addNode(v),this._arcs.has(u)?this._arcs.get(u).push(v):this._arcs.set(u,[v])}getArcs(u){return this._arcs.has(u)?this._arcs.get(u):[]}hasOnlyGoodArcs(u,v){const I=m.getArcs(u);for(let l=0;l<I.length;l++)if(!v.has(I[l]))return!1;return!0}getNodes(){return this._nodesArr}},T=new Map;for(const u of b){const v=r.ExtensionIdentifier.toKey(u.identifier);if(T.set(v,u),u.extensionDependencies)for(const I of u.extensionDependencies){const l=r.ExtensionIdentifier.toKey(I);m.addArc(v,l)}}const f=new Set;m.getNodes().filter(u=>m.getArcs(u).length===0).forEach(u=>f.add(u));const c=m.getNodes().filter(u=>!f.has(u));let h;do{h=!1;for(let u=0;u<c.length;u++){const v=c[u];m.hasOnlyGoodArcs(v,f)&&(c.splice(u,1),u--,f.add(v),h=!0)}}while(h);return c.map(u=>T.get(u))}containsActivationEvent(b){return this._activationMap.has(b)}containsExtension(b){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(b))}getExtensionDescriptionsForActivationEvent(b){const m=this._activationMap.get(b);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(b){const m=this._extensionsMap.get(r.ExtensionIdentifier.toKey(b));return m||void 0}getExtensionDescriptionByUUID(b){for(const m of this._extensionsArr)if(m.uuid===b)return m}getExtensionDescriptionByIdOrUUID(b,m){return this.getExtensionDescription(b)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=_;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function E(O,b){const m=O.isBuiltin?0:O.isUnderDevelopment?2:1,T=b.isBuiltin?0:b.isUnderDevelopment?2:1;if(m!==T)return m-T;const f=S.posix.basename(O.extensionLocation.path),c=S.posix.basename(b.extensionLocation.path);return f<c?-1:f>c?1:0}function k(O,b){const m=new Set;return b.forEach(T=>m.add(r.ExtensionIdentifier.toKey(T))),O.filter(T=>!m.has(r.ExtensionIdentifier.toKey(T.identifier)))}}),define(Ce[91],Ie([1,0,23]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var y;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(y=e.UIKind||(e.UIKind={}));var S;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(S=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function _(k){const O=r.VSBuffer.alloc(1);switch(k){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=_;function A(k,O){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var E;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[25],Ie([1,0,5,2,3,27,152]),function(ne,e,r,y,S,M,_){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:y.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,S.createDecorator)("extensionService");class E{constructor(a){this.affinity=a,this.kind=1}equals(a){return this.kind===a.kind&&this.affinity===a.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class k{constructor(){this.kind=2,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=k;class O{constructor(){this.kind=3,this.affinity=0}equals(a){return this.kind===a.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class b{constructor(a){this.dependency=a}}e.MissingExtensionDependency=b;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function T(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=T;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(a,o){const g=[],p=[],P=[],N=[],V=u(this._allExtensions),U=u(a),D=(K,W)=>K.extensionLocation.toString()===W.extensionLocation.toString()||K.isBuiltin===W.isBuiltin||K.isUserBuiltin===W.isUserBuiltin||K.isUnderDevelopment===W.isUnderDevelopment;for(const K of this._allExtensions){const W=U.get(M.ExtensionIdentifier.toKey(K.identifier));if(!W){g.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}if(!D(K,W)){g.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of a){const W=V.get(M.ExtensionIdentifier.toKey(K.identifier));if(!W){p.push(K);continue}if(!D(W,K)){g.push(W.identifier),V.delete(M.ExtensionIdentifier.toKey(W.identifier));continue}}const x=h(this._myExtensions),L=h(o);for(const K of this._myExtensions)L.has(M.ExtensionIdentifier.toKey(K))||P.push(K);for(const K of o)x.has(M.ExtensionIdentifier.toKey(K))||N.push(K);const R={toRemove:g,toAdd:p,myToRemove:P,myToAdd:N};return this.delta(R),R}delta(a){const{toRemove:o,toAdd:g,myToRemove:p,myToAdd:P}=a,N=h(o),V=h(p);for(let U=0;U<this._allExtensions.length;U++)N.has(M.ExtensionIdentifier.toKey(this._allExtensions[U].identifier))&&(this._allExtensions.splice(U,1),U--);for(let U=0;U<this._myExtensions.length;U++)V.has(M.ExtensionIdentifier.toKey(this._myExtensions[U]))&&(this._myExtensions.splice(U,1),U--);for(const U of g)this._allExtensions.push(U);for(const U of P)this._myExtensions.push(U)}containsExtension(a){for(const o of this._myExtensions)if(M.ExtensionIdentifier.equals(o,a))return!0;return!1}}e.ExtensionHostExtensions=f;class c{constructor(a){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,a)for(const o of a)this.add(o)}get size(){return this._map.size}add(a){return this._map.set(this._toKey(a),a),this}clear(){this._map.clear()}delete(a){return this._map.delete(this._toKey(a))}has(a){return this._map.has(this._toKey(a))}forEach(a,o){this._map.forEach(g=>a.call(o,g,g,this))}*entries(){for(const[a,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=c;function h(s){const a=new Set;for(const o of s)a.add(M.ExtensionIdentifier.toKey(o));return a}e.extensionIdentifiersArrayToSet=h;function u(s){const a=new Map;for(const o of s)a.set(M.ExtensionIdentifier.toKey(o.identifier),o);return a}function v(s,a){return s.enabledApiProposals?s.enabledApiProposals.includes(a):!1}e.isProposedApiEnabled=v;function I(s,a){if(!v(s,a))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=I;class l{constructor(a,o,g,p){this.codeLoadingTime=a,this.activateCallTime=o,this.activateResolvedTime=g,this.activationReason=p}}e.ActivationTimes=l;class w{constructor(a,o){this.description=a,this.value=o}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var t;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function d(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function i(s,a){return{identifier:new M.ExtensionIdentifier((0,_.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!a,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(a,o){return Promise.resolve(0)}getInspectPorts(a,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(a,o){return Promise.resolve()}}e.NullExtensionService=n}),define(Ce[173],Ie([1,0,11,27,25,15,14]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(h,u,v,I){this.startup=h,this.codeLoadingTime=u,this.activateCallTime=v,this.activateResolvedTime=I}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class E{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,u){return h===-1||u===-1?-1:u-h}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class k{constructor(h,u,v,I,l,w){this.activationFailed=h,this.activationFailedError=u,this.activationTimes=v,this.module=I,this.exports=l,this.subscriptions=w}}e.ActivatedExtension=k;class O extends k{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class b extends k{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class m extends k{constructor(h){super(!0,h,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let T=class{constructor(h,u,v,I,l){this._logService=l,this._registry=h,this._resolvedExtensionsSet=new Set,u.forEach(w=>this._resolvedExtensionsSet.add(y.ExtensionIdentifier.toKey(w))),this._externalExtensionsMap=new Map,v.forEach(w=>this._externalExtensionsMap.set(y.ExtensionIdentifier.toKey(w),w)),this._host=I,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[h,u]of this._operations)u.dispose()}isActivated(h){const u=this._operations.get(y.ExtensionIdentifier.toKey(h));return Boolean(u&&u.value)}getActivatedExtension(h){const u=this._operations.get(y.ExtensionIdentifier.toKey(h));if(!u||!u.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return u.value}async activateByEvent(h,u){if(this._alreadyActivatedEvents[h])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(h);await this._activateExtensions(v.map(I=>({id:I.identifier,reason:{startup:u,extensionId:I.identifier,activationEvent:h}}))),this._alreadyActivatedEvents[h]=!0}activateById(h,u){const v=this._registry.getExtensionDescription(h);if(!v)throw new Error(`Extension '${h}' is not known`);return this._activateExtensions([{id:v.identifier,reason:u}])}async _activateExtensions(h){const u=h.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(u.map(v=>v.wait()))}_handleActivationRequest(h){if(this._operations.has(y.ExtensionIdentifier.toKey(h.id)))return this._operations.get(y.ExtensionIdentifier.toKey(h.id));if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(h.id)))return this._createAndSaveOperation(h,null,[],null);const u=this._registry.getExtensionDescription(h.id);if(!u){const l=new Error(`Cannot activate unknown extension '${h.id.value}'`),w=this._createAndSaveOperation(h,null,[],new m(l));return this._host.onExtensionActivationError(h.id,l,new S.MissingExtensionDependency(h.id.value)),w}const v=[],I=typeof u.extensionDependencies>"u"?[]:u.extensionDependencies;for(const l of I){if(this._resolvedExtensionsSet.has(y.ExtensionIdentifier.toKey(l)))continue;const w=this._operations.get(y.ExtensionIdentifier.toKey(l));if(w){v.push(w);continue}if(this._externalExtensionsMap.has(y.ExtensionIdentifier.toKey(l))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(y.ExtensionIdentifier.toKey(l)),reason:h.reason}));continue}const t=this._registry.getExtensionDescription(l);if(t){if(!t.main&&!t.browser)continue;v.push(this._handleActivationRequest({id:t.identifier,reason:h.reason}));continue}const d=u.displayName||u.identifier.value,i=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${l}'`),n=this._createAndSaveOperation(h,u.displayName,[],new m(i));return this._host.onExtensionActivationError(u.identifier,i,new S.MissingExtensionDependency(l)),n}return this._createAndSaveOperation(h,u.displayName,v,null)}_createAndSaveOperation(h,u,v,I){const l=new f(h.id,u,h.reason,v,I,this._host,this._logService);return this._operations.set(y.ExtensionIdentifier.toKey(h.id),l),l}};T=ze([$e(4,M.ILogService)],T),e.ExtensionsActivator=T;let f=class{constructor(h,u,v,I,l,w,t){this._id=h,this._displayName=u,this._reason=v,this._deps=I,this._value=l,this._host=w,this._logService=t,this._barrier=new _.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let h=0;h<this._deps.length;h++){const u=this._deps[h];if(u.value&&!u.value.activationFailed){this._deps.splice(h,1),h--;continue}if(u.value&&u.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${u.friendlyName}' failed to activate`);v.detail=u.value.activationFailedError,this._value=new m(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(h=>h.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(h){const u=new Error;if(h&&h.name&&(u.name=h.name),h&&h.message?u.message=`Activating extension '${this._id.value}' failed: ${h.message}.`:u.message=`Activating extension '${this._id.value}' failed: ${h}.`,h&&h.stack&&(u.stack=h.stack),this._value=new m(u),this._isDisposed&&r.isCancellationError(h))return;this._host.onExtensionActivationError(this._id,u,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(h)}}};f=ze([$e(6,M.ILogService)],f)}),define(Ce[174],Ie([1,0,15,28,25]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends r.LogService{constructor(A,E){super(A.createLogger(E.logFile,{name:S.ExtensionHostLogFileName}))}};M=ze([$e(0,r.ILoggerService),$e(1,y.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[6],Ie([1,0,16,11,76,24,74,9,10,2,42,39,85,64,25]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f){"use strict";var c,h,u,v,I,l,w,t,d,i,n,s,a,o,g,p,P,N,V,U,D,x,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(z){function F(){return Reflect.construct(z,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(z,"name")),Object.setPrototypeOf(F,z),Object.setPrototypeOf(F.prototype,z.prototype),F}let K=l=class{constructor(F){c.set(this,void 0),Je(this,c,F,"f")}static from(...F){let ie=F;return new l(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}dispose(){typeof Oe(this,c,"f")=="function"&&(Oe(this,c,"f").call(this),Je(this,c,void 0,"f"))}};c=new WeakMap,K=l=ze([R],K),e.Disposable=K;let W=w=class{constructor(F,ie){if(F<0)throw(0,y.illegalArgument)("line must be non-negative");if(ie<0)throw(0,y.illegalArgument)("character must be non-negative");this._line=F,this._character=ie}static Min(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isBefore(ie)&&(ie=He)}return ie}static Max(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let we=1;we<F.length;we++){const He=F[we];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(F){if(!F)return!1;if(F instanceof w)return!0;const{line:ie,character:we}=F;return typeof ie=="number"&&typeof we=="number"}static of(F){if(F instanceof w)return F;if(this.isPosition(F))return new w(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,ie=0){if(F===null||ie===null)throw(0,y.illegalArgument)();let we;return typeof F>"u"?we=0:typeof F=="number"?we=F:(we=typeof F.lineDelta=="number"?F.lineDelta:0,ie=typeof F.characterDelta=="number"?F.characterDelta:0),we===0&&ie===0?this:new w(this.line+we,this.character+ie)}with(F,ie=this.character){if(F===null||ie===null)throw(0,y.illegalArgument)();let we;return typeof F>"u"?we=this.line:typeof F=="number"?we=F:(we=typeof F.line=="number"?F.line:this.line,ie=typeof F.character=="number"?F.character:this.character),we===this.line&&ie===this.character?this:new w(we,ie)}toJSON(){return{line:this.line,character:this.character}}};W=w=ze([R],W),e.Position=W;let $=t=class{constructor(F,ie,we,He){let Qe,lt;if(typeof F=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,ie),lt=new W(we,He)):W.isPosition(F)&&W.isPosition(ie)&&(Qe=W.of(F),lt=W.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");Qe.isBefore(lt)?(this._start=Qe,this._end=lt):(this._start=lt,this._end=Qe)}static isRange(F){return F instanceof t?!0:F?W.isPosition(F.start)&&W.isPosition(F.end):!1}static of(F){if(F instanceof t)return F;if(this.isRange(F))return new t(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(F){return t.isRange(F)?this.contains(F.start)&&this.contains(F.end):W.isPosition(F)?!(W.of(F).isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const ie=W.Max(F.start,this._start),we=W.Min(F.end,this._end);if(!ie.isAfter(we))return new t(ie,we)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ie=W.Min(F.start,this._start),we=W.Max(F.end,this.end);return new t(ie,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,ie=this.end){if(F===null||ie===null)throw(0,y.illegalArgument)();let we;return F?W.isPosition(F)?we=F:(we=F.start||this.start,ie=F.end||this.end):we=this.start,we.isEqual(this._start)&&ie.isEqual(this.end)?this:new t(we,ie)}toJSON(){return[this.start,this.end]}};$=t=ze([R],$),e.Range=$;let fe=d=class extends ${constructor(F,ie,we,He){let Qe,lt;if(typeof F=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"?(Qe=new W(F,ie),lt=new W(we,He)):W.isPosition(F)&&W.isPosition(ie)&&(Qe=W.of(F),lt=W.of(ie)),!Qe||!lt)throw new Error("Invalid arguments");super(Qe,lt),this._anchor=Qe,this._active=lt}static isSelection(F){return F instanceof d?!0:F?$.isRange(F)&&W.isPosition(F.anchor)&&W.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};fe=d=ze([R],fe),e.Selection=fe;class J{constructor(F,ie,we){if(typeof F!="string"||F.length===0)throw(0,y.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,y.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,y.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=J;class Q extends Error{constructor(F,ie=m.RemoteAuthorityResolverErrorCode.Unknown,we){super(F),this._message=F,this._code=ie,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}static NotAvailable(F,ie){return new Q(F,m.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(F){return new Q(F,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Q;var ce;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(ce=e.EndOfLine||(e.EndOfLine={}));var te;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(te=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let pe=i=class{constructor(F,ie){this._range=F,this._newText=ie}static isTextEdit(F){return F instanceof i?!0:F?$.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ie){return new i(F,ie)}static insert(F,ie){return i.replace(new $(F,F),ie)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const ie=new i(new $(new W(0,0),new W(0,0)),"");return ie.newEol=F,ie}get range(){return this._range}set range(F){if(F&&!$.isRange(F))throw(0,y.illegalArgument)("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw(0,y.illegalArgument)("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw(0,y.illegalArgument)("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};pe=i=ze([R],pe),e.TextEdit=pe;let be=n=class{constructor(F,ie){this.range=F,this.newCells=ie}static isNotebookCellEdit(F){return F instanceof n?!0:F?jt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,ie){return new n(F,ie)}static insertCells(F,ie){return new n(new jt(F,F),ie)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,ie){const we=new n(new jt(F,F),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(F){const ie=new n(new jt(0,0),[]);return ie.newNotebookMetadata=F,ie}};be=n=ze([R],be),e.NotebookEdit=be;class re{constructor(F,ie){this.range=F,this.snippet=ie}static isSnippetTextEdit(F){return F instanceof re?!0:F?$.isRange(F.range)&&Fe.isSnippetString(F.snippet):!1}static replace(F,ie){return new re(F,ie)}static insert(F,ie){return re.replace(new $(F,F),ie)}}e.SnippetTextEdit=re;var Ee;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,ie,we,He){this._edits.push({_type:1,from:F,to:ie,options:we,metadata:He})}createFile(F,ie,we){this._edits.push({_type:1,from:void 0,to:F,options:ie,metadata:we})}deleteFile(F,ie,we){this._edits.push({_type:1,from:F,to:void 0,options:ie,metadata:we})}replaceNotebookMetadata(F,ie,we){this._edits.push({_type:3,metadata:we,uri:F,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(F,ie,we,He){const Qe=ie.start,lt=ie.end;(Qe!==lt||we.length>0)&&this._edits.push({_type:5,uri:F,index:Qe,count:lt-Qe,cells:we,metadata:He})}replaceNotebookCellMetadata(F,ie,we,He){this._edits.push({_type:3,metadata:He,uri:F,edit:{editType:8,index:ie,metadata:we}})}replace(F,ie,we,He){this._edits.push({_type:2,uri:F,edit:new pe(ie,we),metadata:He})}insert(F,ie,we,He){this.replace(F,new $(ie,ie),we,He)}delete(F,ie,we){this.replace(F,ie,"",we)}has(F){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===F.toString())}set(F,ie){if(ie)for(const we of ie){if(!we)continue;let He,Qe;Array.isArray(we)?(He=we[0],Qe=we[1]):He=we,be.isNotebookCellEdit(He)?He.newCellMetadata?this.replaceNotebookCellMetadata(F,He.range.start,He.newCellMetadata,Qe):He.newNotebookMetadata?this.replaceNotebookMetadata(F,He.newNotebookMetadata,Qe):this.replaceNotebookCells(F,He.range,He.newCells,Qe):re.isSnippetTextEdit(He)?this._edits.push({_type:6,uri:F,range:He.range,edit:He.snippet,metadata:Qe}):this._edits.push({_type:2,uri:F,edit:He,metadata:Qe})}else{for(let we=0;we<this._edits.length;we++){const He=this._edits[we];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===F.toString()&&(this._edits[we]=void 0);break}}(0,r.coalesceInPlace)(this._edits)}}get(F){const ie=[];for(const we of this._edits)we._type===2&&we.uri.toString()===F.toString()&&ie.push(we.edit);return ie}entries(){const F=new M.ResourceMap;for(const ie of this._edits)if(ie._type===2){let we=F.get(ie.uri);we||(we=[ie.uri,[]],F.set(ie.uri,we)),we[1].push(ie.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=ze([R],Pe),e.WorkspaceEdit=Pe;let Fe=s=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof s?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=s._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ie=this._tabstop++){if(typeof F=="function"){const we=new s;we._tabstop=this._tabstop,F(we),this._tabstop=we._tabstop,F=we.value}else F=s._escape(F);return this.value+="${",this.value+=ie,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ie=this._tabstop++){const we=F.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(F,ie){if(typeof ie=="function"){const we=new s;we._tabstop=this._tabstop,ie(we),this._tabstop=we._tabstop,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Fe=s=ze([R],Fe),e.SnippetString=Fe;var We;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(We=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Te=a=class{constructor(F,ie){if(this.uri=F,ie)if($.isRange(ie))this.range=$.of(ie);else if(W.isPosition(ie))this.range=new $(ie,ie);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof a?!0:F?$.isRange(F.range)&&k.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Te=a=ze([R],Te),e.Location=Te;let _e=class{constructor(F,ie){this.location=F,this.message=ie}static is(F){return F?typeof F.message=="string"&&F.location&&$.isRange(F.location.range)&&k.URI.isUri(F.location.uri):!1}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.location.range.isEqual(ie.location.range)&&F.location.uri.toString()===ie.location.uri.toString()}};_e=ze([R],_e),e.DiagnosticRelatedInformation=_e;let ye=class{constructor(F,ie,we=Xe.Error){if(!$.isRange(F))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=F,this.message=ie,this.severity=we}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.severity===ie.severity&&F.code===ie.code&&F.severity===ie.severity&&F.source===ie.source&&F.range.isEqual(ie.range)&&(0,r.equals)(F.tags,ie.tags)&&(0,r.equals)(F.relatedInformation,ie.relatedInformation,_e.isEqual)}};ye=ze([R],ye),e.Diagnostic=ye;let ae=class{constructor(F,ie){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=ie}};ae=ze([R],ae),e.Hover=ae;var ue;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(ue=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Y=class{constructor(F,ie=ue.Text){this.range=F,this.kind=ie}toJSON(){return{range:this.range,kind:ue[this.kind]}}};Y=ze([R],Y),e.DocumentHighlight=Y;var ee;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(ee=e.SymbolKind||(e.SymbolKind={}));var C;(function(z){z[z.Deprecated=1]="Deprecated"})(C=e.SymbolTag||(e.SymbolTag={}));let B=o=class{constructor(F,ie,we,He,Qe){this.name=F,this.kind=ie,this.containerName=Qe,typeof we=="string"&&(this.containerName=we),He instanceof Te?this.location=He:we instanceof $&&(this.location=new Te(He,we)),o.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};B=o=ze([R],B),e.SymbolInformation=B;let H=g=class{constructor(F,ie,we,He,Qe){this.name=F,this.detail=ie,this.kind=we,this.range=He,this.selectionRange=Qe,this.children=[],g.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(g.validate)}};H=g=ze([R],H),e.DocumentSymbol=H;var j;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(j=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(F,ie){this.title=F,this.kind=ie}};oe=ze([R],oe),e.CodeAction=oe;let le=p=class{constructor(F){this.value=F}append(F){return new p(this.value?this.value+p.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+p.sep)}};le.sep=".",le=p=ze([R],le),e.CodeActionKind=le,le.Empty=new le(""),le.QuickFix=le.Empty.append("quickfix"),le.Refactor=le.Empty.append("refactor"),le.RefactorExtract=le.Refactor.append("extract"),le.RefactorInline=le.Refactor.append("inline"),le.RefactorMove=le.Refactor.append("move"),le.RefactorRewrite=le.Refactor.append("rewrite"),le.Source=le.Empty.append("source"),le.SourceOrganizeImports=le.Source.append("organizeImports"),le.SourceFixAll=le.Source.append("fixAll");let Z=class{constructor(F,ie){if(this.range=F,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Z=ze([R],Z),e.SelectionRange=Z;class ve{constructor(F,ie,we,He,Qe,lt){this.kind=F,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.CallHierarchyItem=ve;class ge{constructor(F,ie){this.fromRanges=ie,this.from=F}}e.CallHierarchyIncomingCall=ge;class Ne{constructor(F,ie){this.fromRanges=ie,this.to=F}}e.CallHierarchyOutgoingCall=Ne;var xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ye=class{constructor(F,ie){this.range=F,this.command=ie}get isResolved(){return!!this.command}};Ye=ze([R],Ye),e.CodeLens=Ye;let Ge=P=class{constructor(F,ie=!1){h.set(this,void 0),Je(this,h,new S.MarkdownString(F,{supportThemeIcons:ie}),"f")}static isMarkdownString(F){return F instanceof P?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return Oe(this,h,"f").value}set value(F){Oe(this,h,"f").value=F}get isTrusted(){return Oe(this,h,"f").isTrusted}set isTrusted(F){Oe(this,h,"f").isTrusted=F}get supportThemeIcons(){return Oe(this,h,"f").supportThemeIcons}set supportThemeIcons(F){Oe(this,h,"f").supportThemeIcons=F}get supportHtml(){return Oe(this,h,"f").supportHtml}set supportHtml(F){Oe(this,h,"f").supportHtml=F}get baseUri(){return Oe(this,h,"f").baseUri}set baseUri(F){Oe(this,h,"f").baseUri=F}appendText(F){return Oe(this,h,"f").appendText(F),this}appendMarkdown(F){return Oe(this,h,"f").appendMarkdown(F),this}appendCodeblock(F,ie){return Oe(this,h,"f").appendCodeblock(ie??"",F),this}};h=new WeakMap,Ge=P=ze([R],Ge),e.MarkdownString=Ge;let ke=class{constructor(F,ie){this.label=F,this.documentation=ie}};ke=ze([R],ke),e.ParameterInformation=ke;let nt=class{constructor(F,ie){this.label=F,this.documentation=ie,this.parameters=[]}};nt=ze([R],nt),e.SignatureInformation=nt;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=ze([R],G),e.SignatureHelp=G;var X;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(F){this.value=F}};Ue=ze([R],Ue),e.InlayHintLabelPart=Ue;let Ve=class{constructor(F,ie,we){this.position=F,this.label=ie,this.kind=we}};Ve=ze([R],Ve),e.InlayHint=Ve;var Ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var je;(function(z){z[z.Deprecated=1]="Deprecated"})(je=e.CompletionItemTag||(e.CompletionItemTag={}));let tt=class{constructor(F,ie){this.label=F,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};tt=ze([R],tt),e.CompletionItem=tt;let st=class{constructor(F=[],ie=!1){this.items=F,this.isIncomplete=ie}};st=ze([R],st),e.CompletionList=st;let dt=class{constructor(F,ie,we){this.insertText=F,this.range=ie,this.command=we}};dt=ze([R],dt),e.InlineSuggestion=dt;let at=class{constructor(F){this.commands=void 0,this.items=F}};at=ze([R],at),e.InlineSuggestionList=at;let rt=class{constructor(F,ie,we){this.insertText=F,this.range=ie,this.command=we}};rt=ze([R],rt),e.InlineSuggestionNew=rt;let _t=class{constructor(F,ie){this.items=F,this.commands=ie}};_t=ze([R],_t),e.InlineSuggestionsNew=_t;var Rt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Rt=e.ViewColumn||(e.ViewColumn={}));var Ot;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ot=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Dt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Dt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Mt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var qe;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(qe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function F(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=F}(Mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(F,ie){if(ie&&!k.URI.isUri(ie))throw(0,y.illegalArgument)("target");if(!$.isRange(F)||F.isEmpty)throw(0,y.illegalArgument)("range");this.range=F,this.target=ie}};Ft=ze([R],Ft),e.DocumentLink=Ft;let Tt=class{constructor(F,ie,we,He){this.red=F,this.green=ie,this.blue=we,this.alpha=He}};Tt=ze([R],Tt),e.Color=Tt;let gt=class{constructor(F,ie){if(ie&&!(ie instanceof Tt))throw(0,y.illegalArgument)("color");if(!$.isRange(F)||F.isEmpty)throw(0,y.illegalArgument)("range");this.range=F,this.color=ie}};gt=ze([R],gt),e.ColorInformation=gt;let yt=class{constructor(F){if(!F||typeof F!="string")throw(0,y.illegalArgument)("label");this.label=F}};yt=ze([R],yt),e.ColorPresentation=yt;var Se;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Se=e.ColorFormat||(e.ColorFormat={}));var De;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(De=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var me;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(me=e.TerminalExitReason||(e.TerminalExitReason={}));class q{constructor(F,ie,we){if(this.startIndex=F,this.length=ie,this.tooltip=we,typeof F!="number"||F<0)throw(0,y.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,y.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,y.illegalArgument)("tooltip")}}e.TerminalLink=q;var Ae;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(Ae=e.TerminalLocation||(e.TerminalLocation={}));class Le{constructor(F){if(this.options=F,typeof F!="object")throw(0,y.illegalArgument)("options")}}e.TerminalProfile=Le;var et;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(et=e.TaskRevealKind||(e.TaskRevealKind={}));var Be;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Be=e.TaskPanelKind||(e.TaskPanelKind={}));let it=N=class{constructor(F,ie){if(this.label=ie,typeof F!="string"||typeof ie!="string")throw(0,y.illegalArgument)("name");this._id=F}static from(F){switch(F){case"clean":return N.Clean;case"build":return N.Build;case"rebuild":return N.Rebuild;case"test":return N.Test;default:return}}get id(){return this._id}};it.Clean=new N("clean","Clean"),it.Build=new N("build","Build"),it.Rebuild=new N("rebuild","Rebuild"),it.Test=new N("test","Test"),it=N=ze([R],it),e.TaskGroup=it;function ct(z){let F="";for(let ie=0;ie<z.length;ie++)F+=z[ie].replace(/,/g,",,")+",";return F}let Ct=class{constructor(F,ie,we){if(typeof F!="string")throw(0,y.illegalArgument)("process");this._args=[],this._process=F,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=we):this._options=ie)}get process(){return this._process}set process(F){if(typeof F!="string")throw(0,y.illegalArgument)("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(const ie of this._args)F.push(ie);return ct(F)}};Ct=ze([R],Ct),e.ProcessExecution=Ct;let pt=class{constructor(F,ie,we){if(this._args=[],Array.isArray(ie)){if(!F)throw(0,y.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,y.illegalArgument)("command");this._command=F,this._args=ie,this._options=we}else{if(typeof F!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=F,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw(0,y.illegalArgument)("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,y.illegalArgument)("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const ie of this._args)F.push(typeof ie=="string"?ie:ie.value);return ct(F)}};pt=ze([R],pt),e.ShellExecution=pt;var It;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(It=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class vt{constructor(F){this._callback=F}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=vt;let wt=V=class{constructor(F,ie,we,He,Qe,lt){this.__deprecated=!1,this._definition=this.definition=F;let ht;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=we,this.execution=He,ht=Qe,this.__deprecated=!0):ie===bt.Global||ie===bt.Workspace?(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=lt):(this.target=ie,this._name=this.name=we,this._source=this.source=He,this.execution=Qe,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ct?this._definition={type:V.ProcessType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:V.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:V.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:V.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(F){if(F==null)throw(0,y.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw(0,y.illegalArgument)("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const ie=this._definition.type;(V.EmptyType===ie||V.ProcessType===ie||V.ShellType===ie||V.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw(0,y.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=V=ze([R],wt),e.Task=wt;var ti;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(ti=e.ProgressLocation||(e.ProgressLocation={}));let Et=U=class{constructor(F,ie=$t.None){this.collapsibleState=ie,k.URI.isUri(F)?this.resourceUri=F:this.label=F}static isTreeItem(F,ie){if(F instanceof U)return!0;const we=F;if(we.label!==void 0&&!(0,E.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,E.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,E.isString)(we.iconPath)&&!k.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,E.isString)(we.iconPath.id))){const He=we.iconPath;if(!He||!(0,E.isString)(He.light)&&!k.URI.isUri(He.light)&&!(0,E.isString)(He.dark)&&!k.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,E.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!k.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,E.isString)(we.tooltip)&&!(we.tooltip instanceof Ge))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<$t.None&&we.collapsibleState>$t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,E.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(ie,"treeItemCheckbox");const He=(0,E.isNumber)(we.checkboxState)?we.checkboxState:(0,E.isObject)(we.checkboxState)&&(0,E.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,Qe=!(0,E.isNumber)(we.checkboxState)&&(0,E.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(He===void 0||He!==Wt.Checked&&He!==Wt.Unchecked||Qe!==void 0&&!(0,E.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}};Et=U=ze([R],Et),e.TreeItem=Et;var $t;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Wt;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(Wt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let ii=class{constructor(F,ie){this.value=F,this.id=ie??(0,O.generateUuid)()}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};ii=ze([R],ii),e.DataTransferItem=ii;let gi=class{constructor(F){u.set(this,new Map);for(const[ie,we]of F??[]){const He=Oe(this,u,"f").get(ie);He?He.push(we):Oe(this,u,"f").set(ie,[we])}}get(F){return Oe(this,u,"f").get(F)?.[0]}set(F,ie){Oe(this,u,"f").set(F,[ie])}forEach(F,ie){for(const[we,He]of Oe(this,u,"f"))for(const Qe of He)F.call(ie,Qe,we,this)}*[(u=new WeakMap,Symbol.iterator)](){for(const[F,ie]of Oe(this,u,"f"))for(const we of ie)yield[F,we]}};gi=ze([R],gi),e.DataTransfer=gi;let kt=class{constructor(F){this.insertText=F}};kt=ze([R],kt),e.DocumentDropEdit=kt;let ni=class{constructor(F){this.insertText=F}};ni=ze([R],ni),e.DocumentPasteEdit=ni;let Ht=class{constructor(F,ie){this.id=F,this.color=ie}};Ht=ze([R],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let Yt=class{constructor(F){this.id=F}};Yt=ze([R],Yt),e.ThemeColor=Yt;var ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ri=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{constructor(F,ie){if(typeof F!="string"&&(!F||!k.URI.isUri(F)&&!k.URI.isUri(F.uri)))throw(0,y.illegalArgument)("base");if(typeof ie!="string")throw(0,y.illegalArgument)("pattern");typeof F=="string"?this.baseUri=k.URI.file(F):k.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=ie}get base(){return this._base}set base(F){this._base=F,this._baseUri=k.URI.file(F)}get baseUri(){return this._baseUri}set baseUri(F){this._baseUri=F,this._base=F.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=ze([R],ut),e.RelativePattern=ut;let Jt=class{constructor(F,ie,we,He){this.enabled=typeof F=="boolean"?F:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};Jt=ze([R],Jt),e.Breakpoint=Jt;let xt=class extends Jt{constructor(F,ie,we,He,Qe){if(super(ie,we,He,Qe),F===null)throw(0,y.illegalArgument)("location");this.location=F}};xt=ze([R],xt),e.SourceBreakpoint=xt;let Kt=class extends Jt{constructor(F,ie,we,He,Qe){super(ie,we,He,Qe),this.functionName=F}};Kt=ze([R],Kt),e.FunctionBreakpoint=Kt;let si=class extends Jt{constructor(F,ie,we,He,Qe,lt,ht){if(super(He,Qe,lt,ht),!ie)throw(0,y.illegalArgument)("dataId");this.label=F,this.dataId=ie,this.canPersist=we}};si=ze([R],si),e.DataBreakpoint=si;let pi=class{constructor(F,ie,we){this.command=F,this.args=ie||[],this.options=we}};pi=ze([R],pi),e.DebugAdapterExecutable=pi;let oi=class{constructor(F,ie){this.port=F,this.host=ie}};oi=ze([R],oi),e.DebugAdapterServer=oi;let vi=class{constructor(F){this.path=F}};vi=ze([R],vi),e.DebugAdapterNamedPipeServer=vi;let ai=class{constructor(F){this.implementation=F}};ai=ze([R],ai),e.DebugAdapterInlineImplementation=ai;let Zt=class{constructor(F,ie){this.range=F,this.expression=ie}};Zt=ze([R],Zt),e.EvaluatableExpression=Zt;var Ri;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ri=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Ei;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ei=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let ei=class{constructor(F,ie){this.range=F,this.text=ie}};ei=ze([R],ei),e.InlineValueText=ei;let bi=class{constructor(F,ie,we=!0){this.range=F,this.variableName=ie,this.caseSensitiveLookup=we}};bi=ze([R],bi),e.InlineValueVariableLookup=bi;let wi=class{constructor(F,ie){this.range=F,this.expression=ie}};wi=ze([R],wi),e.InlineValueEvaluatableExpression=wi;let Gt=class{constructor(F,ie){this.frameId=F,this.stoppedLocation=ie}};Gt=ze([R],Gt),e.InlineValueContext=Gt;var Oi;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(Oi=e.FileChangeType||(e.FileChangeType={}));let Si=D=class extends Error{constructor(F,ie=b.FileSystemProviderErrorCode.Unknown,we){super(k.URI.isUri(F)?F.toString(!0):F),this.code=we?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(F){return new D(F,b.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(F){return new D(F,b.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(F){return new D(F,b.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(F){return new D(F,b.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(F){return new D(F,b.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(F){return new D(F,b.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}};Si=D=ze([R],Si),e.FileSystemError=Si;let _i=class{constructor(F,ie,we){this.start=F,this.end=ie,this.kind=we}};_i=ze([R],_i),e.FoldingRange=_i;var Fi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(Fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var yi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(yi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ii;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Ii=e.CommentMode||(e.CommentMode={}));var Ti;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Ti=e.CommentThreadState||(e.CommentThreadState={}));class Me{constructor(F,ie=[]){this.tokenTypes=F,this.tokenModifiers=ie}}e.SemanticTokensLegend=Me;function Vt(z){return typeof z>"u"||(0,E.isStringArray)(z)}class ci{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let ie=0,we=F.tokenTypes.length;ie<we;ie++)this._tokenTypeStrToInt.set(F.tokenTypes[ie],ie);for(let ie=0,we=F.tokenModifiers.length;ie<we;ie++)this._tokenModifierStrToInt.set(F.tokenModifiers[ie],ie)}}push(F,ie,we,He,Qe){if(typeof F=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof He=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(F,ie,we,He,Qe);if($.isRange(F)&&typeof ie=="string"&&Vt(we))return this._push(F,ie,we);throw(0,y.illegalArgument)()}_push(F,ie,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=F.start.line,Qe=F.start.character,lt=F.end.character-F.start.character,ht=this._tokenTypeStrToInt.get(ie);let At=0;if(we)for(const Bt of we){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const zt=this._tokenModifierStrToInt.get(Bt);At|=1<<zt>>>0}this._pushEncoded(He,Qe,lt,ht,At)}_pushEncoded(F,ie,we,He,Qe){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Bt=0,zt=0;for(let qt=0;qt<At;qt++){let Xt=this._data[5*qt],Di=this._data[5*qt+1];Xt===0?(Xt=Bt,Di+=zt):Xt+=Bt,this._data[5*qt]=Xt,this._data[5*qt+1]=Di,Bt=Xt,zt=Di}}let lt=F,ht=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=we,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Qe,this._prevLine=F,this._prevChar=ie}static _sortAndDeltaEncode(F){const ie=[],we=F.length/5|0;for(let ht=0;ht<we;ht++)ie[ht]=ht;ie.sort((ht,At)=>{const Bt=F[5*ht],zt=F[5*At];if(Bt===zt){const qt=F[5*ht+1],Xt=F[5*At+1];return qt-Xt}return Bt-zt});const He=new Uint32Array(F.length);let Qe=0,lt=0;for(let ht=0;ht<we;ht++){const At=5*ie[ht],Bt=F[At+0],zt=F[At+1],qt=F[At+2],Xt=F[At+3],Di=F[At+4],Qi=Bt-Qe,yn=Qi===0?zt-lt:zt,Ci=5*ht;He[Ci+0]=Qi,He[Ci+1]=yn,He[Ci+2]=qt,He[Ci+3]=Xt,He[Ci+4]=Di,Qe=Bt,lt=zt}return He}build(F){return this._dataIsSortedAndDeltaEncoded?new ft(new Uint32Array(this._data),F):new ft(ci._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=ci;class ft{constructor(F,ie){this.resultId=ie,this.data=F}}e.SemanticTokens=ft;class Ni{constructor(F,ie,we){this.start=F,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Ni;class Mi{constructor(F,ie){this.resultId=ie,this.edits=F}}e.SemanticTokensEdits=Mi;var ki;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(ki=e.DebugConsoleMode||(e.DebugConsoleMode={}));let li=class{constructor(){}};li.Back={iconPath:new Ht("arrow-left")},li=ze([R],li),e.QuickInputButtons=li;var ui;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(ui=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Li;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(Li=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ui;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Ui=e.ExtensionKind||(e.ExtensionKind={}));class Bi{constructor(F,ie,we){this.badge=F,this.tooltip=ie,this.color=we}static validate(F){if(F.badge){let ie=(0,A.nextCharLength)(F.badge,0);if(ie<F.badge.length&&(ie+=(0,A.nextCharLength)(F.badge,ie)),F.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Bi;let di=class{constructor(F){this.kind=F}};di=ze([R],di),e.ColorTheme=di;var xi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{constructor(F,ie){if(F<0)throw(0,y.illegalArgument)("start must be positive");if(ie<0)throw(0,y.illegalArgument)("end must be positive");F<=ie?(this._start=F,this._end=ie):(this._start=ie,this._end=F)}static isNotebookRange(F){return F instanceof jt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(F){let ie=this._start,we=this._end;return F.start!==void 0&&(ie=F.start),F.end!==void 0&&(we=F.end),ie===this._start&&we===this._end?this:new jt(ie,we)}}e.NotebookRange=jt;class hi{constructor(F,ie,we,He,Qe,lt,ht){this.kind=F,this.value=ie,this.languageId=we,this.mime=He,this.outputs=Qe??[],this.metadata=lt,this.executionSummary=ht,hi.validate(this)}static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ie=>hi.isNotebookCellData(ie))}static isNotebookCellData(F){return!0}}e.NotebookCellData=hi;class zi{constructor(F){this.cells=F}}e.NotebookData=zi;class Lt{constructor(F,ie){this.data=F,this.mime=ie;const we=(0,_.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}static isNotebookCellOutputItem(F){return F instanceof Lt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ie={name:F.name,message:F.message,stack:F.stack};return Lt.json(ie,"application/vnd.code.notebook.error")}static stdout(F){return Lt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return Lt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ie="application/octet-stream"){return new Lt(F,ie)}static text(F,ie=_.Mimes.text){const we=Oe(Lt,v,"f",I).encode(String(F));return new Lt(we,ie)}static json(F,ie="text/x-json"){const we=JSON.stringify(F,void 0,"	");return Lt.text(we,ie)}}e.NotebookCellOutputItem=Lt,v=Lt,I={value:new TextEncoder};class se{constructor(F,ie,we){this.items=se.ensureUniqueMimeTypes(F,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,O.generateUuid)(),this.metadata=ie??we)}static isNotebookCellOutput(F){return F instanceof se?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,ie=!1){const we=new Set,He=new Set;for(let Qe=0;Qe<F.length;Qe++){const lt=F[Qe],ht=(0,_.normalizeMimeType)(lt.mime);if(!we.has(ht)||(0,T.isTextStreamMime)(ht)){we.add(ht);continue}He.add(Qe),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return He.size===0?F:F.filter((Qe,lt)=>!He.has(lt))}}e.NotebookCellOutput=se;var de;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(de=e.NotebookCellKind||(e.NotebookCellKind={}));var Re;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Re=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ot;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ot=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var St;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(St=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Pt{constructor(F,ie){this.text=F,this.alignment=ie}}e.NotebookCellStatusBarItem=Pt;var en;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(en=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class tn{constructor(F,ie=[]){this.uri=F,this.provides=(0,r.asArray)(ie)}}e.NotebookRendererScript=tn;let $i=class{constructor(F,ie){this.label=F,this.timestamp=ie}};$i=ze([R],$i),e.TimelineItem=$i;var nn;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(nn=e.ExtensionMode||(e.ExtensionMode={}));var rn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var sn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(sn=e.StandardTokenType||(e.StandardTokenType={}));class on{constructor(F,ie){this.ranges=F,this.wordPattern=ie}}e.LinkedEditingRanges=on;class an{constructor(F,ie){this._port=F,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=an;var cn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(cn=e.TestResultState||(e.TestResultState={}));var ln;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(ln=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Wi=class{constructor(F=void 0,ie=void 0,we=void 0){this.include=F,this.exclude=ie,this.profile=we}};Wi=ze([R],Wi),e.TestRunRequest=Wi;let Hi=x=class{constructor(F){this.message=F}static diff(F,ie,we){const He=new x(F);return He.expectedOutput=ie,He.actualOutput=we,He}};Hi=x=ze([R],Hi),e.TestMessage=Hi;let Vi=class{constructor(F){this.id=F}};Vi=ze([R],Vi),e.TestTag=Vi;let fi=class{constructor(F,ie){this.covered=F,this.total=ie}};fi=ze([R],fi),e.CoveredCount=fi;let ji=L=class{constructor(F,ie,we,He){this.uri=F,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=He}static fromDetails(F,ie){const we=new fi(0,0),He=new fi(0,0),Qe=new fi(0,0);for(const ht of ie)if("branches"in ht){we.total+=1,we.covered+=ht.executionCount>0?1:0;for(const At of ht.branches)He.total+=1,He.covered+=At.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=ht.executionCount>0?1:0;const lt=new L(F,we,He.total>0?He:void 0,Qe.total>0?Qe:void 0);return lt.detailedCoverage=ie,lt}};ji=L=ze([R],ji),e.FileCoverage=ji;let qi=class{constructor(F,ie,we=[]){this.executionCount=F,this.location=ie,this.branches=we}};qi=ze([R],qi),e.StatementCoverage=qi;let Ki=class{constructor(F,ie){this.executionCount=F,this.location=ie}};Ki=ze([R],Ki),e.BranchCoverage=Ki;let Gi=class{constructor(F,ie){this.executionCount=F,this.location=ie}};Gi=ze([R],Gi),e.FunctionCoverage=Gi;var un;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(un=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var dn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(dn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var hn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(hn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class fn{constructor(F,ie,we,He,Qe,lt){this.kind=F,this.name=ie,this.detail=we,this.uri=He,this.range=Qe,this.selectionRange=lt}}e.TypeHierarchyItem=fn;class mn{constructor(F){this.uri=F}}e.TextTabInput=mn;class gn{constructor(F,ie){this.original=F,this.modified=ie}}e.TextDiffTabInput=gn;class pn{constructor(F,ie,we,He){this.base=F,this.input1=ie,this.input2=we,this.result=He}}e.TextMergeTabInput=pn;class vn{constructor(F,ie){this.uri=F,this.viewType=ie}}e.CustomEditorTabInput=vn;class En{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=En;class bn{constructor(F,ie){this.uri=F,this.notebookType=ie}}e.NotebookEditorTabInput=bn;class wn{constructor(F,ie,we){this.original=F,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=wn;class Sn{constructor(){}}e.TerminalEditorTabInput=Sn;class _n{constructor(F,ie){this.uri=F,this.inputBoxUri=ie}}e.InteractiveWindowInput=_n}),define(Ce[92],Ie([1,0,44,12,9,240,122,6,16]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function O(f,c){c?k.set(f,c):k.delete(f)}e.setWordDefinitionFor=O;function b(f){return k.get(f)}e.getWordDefinitionFor=b;class m extends M.MirrorTextModel{constructor(c,h,u,v,I,l,w,t){super(h,u,v,I),this._proxy=c,this._languageId=l,this._isDirty=w,this.notebook=t,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,E.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===y.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},save(){return c._save()},getText(h){return h?c._getTextInRange(h):c.getText()},get eol(){return c._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(h){return c._lineAt(h)},offsetAt(h){return c._offsetAt(h)},positionAt(h){return c._positionAt(h)},validateRange(h){return c._validateRange(h)},validatePosition(h){return c._validatePosition(h)},getWordRangeAtPosition(h,u){return c._getWordRangeAtPosition(h,u)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,r.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,r.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const h=this._validateRange(c);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const u=this._eol,v=h.start.line,I=h.end.line,l=[];l.push(this._lines[v].substring(h.start.character));for(let w=v+1;w<I;w++)l.push(this._lines[w]);return l.push(this._lines[I].substring(0,h.end.character)),l.join(u)}_lineAt(c){let h;if(c instanceof A.Position?h=c.line:typeof c=="number"&&(h=c),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new T(h,this._lines[h],h===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(c),u=this._lines[h.index].length;return new A.Position(h.index,Math.min(h.remainder,u))}_validateRange(c){if(!(c instanceof A.Range))throw new Error("Invalid argument");const h=this._validatePosition(c.start),u=this._validatePosition(c.end);return h===c.start&&u===c.end?c:new A.Range(h.line,h.character,u.line,u.character)}_validatePosition(c){if(!(c instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:h,character:u}=c,v=!1;if(h<0)h=0,u=0,v=!0;else if(h>=this._lines.length)h=this._lines.length-1,u=this._lines[h].length,v=!0;else{const I=this._lines[h].length;u<0?(u=0,v=!0):u>I&&(u=I,v=!0)}return v?new A.Position(h,u):c}_getWordRangeAtPosition(c,h){const u=this._validatePosition(c);if(!h)h=b(this._languageId);else if((0,S.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const v=(0,_.getWordAtText)(u.character+1,(0,_.ensureValidWordDefinition)(h),this._lines[u.line],0);if(v)return new A.Range(u.line,v.startColumn-1,u.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class T{constructor(c,h,u){this._line=c,this._text=h,this._isLastLine=u}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=T}),define(Ce[175],Ie([1,0,6,13,5]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let E;switch(A){case"light":E=r.ColorThemeKind.Light;break;case"hcDark":E=r.ColorThemeKind.HighContrast;break;case"hcLight":E=r.ColorThemeKind.HighContrastLight;break;default:E=r.ColorThemeKind.Dark}this._actual=new r.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=ze([$e(0,y.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[8],Ie([1,0,16,23,76,24,106,75,26,10,2,49,66,81,89,88,64,47,48,170,6,176]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var t;(function(Se){function De(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:et,positionColumn:Be}=q,it=new l.Position(Ae-1,Le-1),ct=new l.Position(et-1,Be-1);return new l.Selection(it,ct)}Se.to=De;function me(q){const{anchor:Ae,active:Le}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=me})(t=e.Selection||(e.Selection={}));var d;(function(Se){function De(q){if(!q)return;const{start:Ae,end:Le}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=De;function me(q){if(!q)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:et,endColumn:Be}=q;return new l.Range(Ae-1,Le-1,et-1,Be-1)}Se.to=me})(d=e.Range||(e.Range={}));var i;(function(Se){function De(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}Se.to=De})(i=e.TokenType||(e.TokenType={}));var n;(function(Se){function De(q){return new l.Position(q.lineNumber-1,q.column-1)}Se.to=De;function me(q){return{lineNumber:q.line+1,column:q.character+1}}Se.from=me})(n=e.Position||(e.Position={}));var s;(function(Se){function De(Ae,Le){return(0,r.coalesce)((0,r.asArray)(Ae).map(et=>me(et,Le)))}Se.from=De;function me(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Le),pattern:he.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var a;(function(Se){function De(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}Se.from=De;function me(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}Se.to=me})(a=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(Se){function De(q){let Ae;return q.code&&((0,k.isString)(q.code)||(0,k.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...d.from(q.range),message:q.message,source:q.source,code:Ae,severity:p.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(g.from),tags:Array.isArray(q.tags)?(0,r.coalesce)(q.tags.map(a.from)):void 0}}Se.from=De;function me(q){const Ae=new l.Diagnostic(d.to(q),q.message,p.to(q.severity));return Ae.source=q.source,Ae.code=(0,k.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(g.to),Ae.tags=q.tags&&(0,r.coalesce)(q.tags.map(a.to)),Ae}Se.to=me})(o=e.Diagnostic||(e.Diagnostic={}));var g;(function(Se){function De(q){return{...d.from(q.location.range),message:q.message,resource:q.location.uri}}Se.from=De;function me(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,d.to(q)),q.message)}Se.to=me})(g=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var p;(function(Se){function De(q){switch(q){case l.DiagnosticSeverity.Error:return T.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return T.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return T.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return T.MarkerSeverity.Hint}return T.MarkerSeverity.Error}Se.from=De;function me(q){switch(q){case T.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case T.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case T.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case T.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}Se.to=me})(p=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var P;(function(Se){function De(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?I.SIDE_GROUP:I.ACTIVE_GROUP}Se.from=De;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=me})(P=e.ViewColumn||(e.ViewColumn={}));function N(Se){return typeof Se.range<"u"}function V(Se){return Se.length===0?!0:!!N(Se[0])}e.isDecorationOptionsArr=V;var U;(function(Se){function De(Be){return Be.map(Se.from)}Se.fromMany=De;function me(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function q(Be){let it;if(me(Be)){const{language:It,value:bt}=Be;it={value:"```"+It+`
`+bt+"\n```\n"}}else l.MarkdownString.isMarkdownString(Be)?it={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?it={value:Be}:it={value:""};const ct=Object.create(null);it.uris=ct;const Ct=It=>{try{let bt=O.URI.parse(It,!0);bt=bt.with({query:Ae(bt.query,ct)}),ct[It]=bt}catch{}return""},pt=new _.marked.Renderer;return pt.link=Ct,pt.image=It=>typeof It=="string"?Ct(S.parseHrefAndDimensions(It).href):"",(0,_.marked)(it.value,{renderer:pt}),it}Se.from=q;function Ae(Be,it){if(!Be)return Be;let ct;try{ct=(0,A.parse)(Be)}catch{}if(!ct)return Be;let Ct=!1;return ct=(0,E.cloneAndChange)(ct,pt=>{if(O.URI.isUri(pt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[It]=pt,Ct=!0,It}else return}),Ct?JSON.stringify(ct):Be}function Le(Be){const it=new l.MarkdownString(Be.value,Be.supportThemeIcons);return it.isTrusted=Be.isTrusted,it.supportHtml=Be.supportHtml,it.baseUri=Be.baseUri?O.URI.from(Be.baseUri):void 0,it}Se.to=Le;function et(Be){if(!!Be)return typeof Be=="string"?Be:Se.from(Be)}Se.fromStrict=et})(U=e.MarkdownString||(e.MarkdownString={}));function D(Se){return V(Se)?Se.map(De=>({range:d.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?U.fromMany(De.hoverMessage):De.hoverMessage?U.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Se.map(De=>({range:d.from(De)}))}e.fromRangeOrRangeWithMessage=D;function x(Se){return typeof Se>"u"?Se:typeof Se=="string"?O.URI.file(Se):Se}e.pathOrURIToURI=x;var L;(function(Se){function De(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?x(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Se.from=De})(L=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(Se){function De(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?x(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}Se.from=De})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(Se){function De(me){if(typeof me>"u")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=De})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(Se){function De(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?K.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?R.from(me.light):void 0,dark:me.dark?R.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?x(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?L.from(me.before):void 0,after:me.after?L.from(me.after):void 0}}Se.from=De})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Se){function De(q){return{text:q.newText,eol:q.newEol&&Ge.from(q.newEol),range:d.from(q.range)}}Se.from=De;function me(q){const Ae=new l.TextEdit(d.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:Ge.to(q.eol),Ae}Se.to=me})($=e.TextEdit||(e.TextEdit={}));var fe;(function(Se){function De(q,Ae){const Le={edits:[]};if(q instanceof l.WorkspaceEdit){const et=new M.ResourceSet;for(const Be of q._allEntries())Be._type===1&&O.URI.isUri(Be.to)&&Be.from===void 0&&et.add(Be.to);for(const Be of q._allEntries())Be._type===1?Le.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,y.encodeBase64)(y.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Le.edits.push({resource:Be.uri,textEdit:$.from(Be.edit),versionId:et.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Le.edits.push({resource:Be.uri,textEdit:{range:d.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:et.has(Be.uri)?void 0:Ae?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Le.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Le.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(st.from)}})}return Le}Se.from=De;function me(q){const Ae=new l.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Ae.replace(O.URI.revive(Le.resource),d.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(O.URI.revive(Le.oldResource),O.URI.revive(Le.newResource),Le.options);return Ae}Se.to=me})(fe=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Se){const De=Object.create(null);De[l.SymbolKind.File]=0,De[l.SymbolKind.Module]=1,De[l.SymbolKind.Namespace]=2,De[l.SymbolKind.Package]=3,De[l.SymbolKind.Class]=4,De[l.SymbolKind.Method]=5,De[l.SymbolKind.Property]=6,De[l.SymbolKind.Field]=7,De[l.SymbolKind.Constructor]=8,De[l.SymbolKind.Enum]=9,De[l.SymbolKind.Interface]=10,De[l.SymbolKind.Function]=11,De[l.SymbolKind.Variable]=12,De[l.SymbolKind.Constant]=13,De[l.SymbolKind.String]=14,De[l.SymbolKind.Number]=15,De[l.SymbolKind.Boolean]=16,De[l.SymbolKind.Array]=17,De[l.SymbolKind.Object]=18,De[l.SymbolKind.Key]=19,De[l.SymbolKind.Null]=20,De[l.SymbolKind.EnumMember]=21,De[l.SymbolKind.Struct]=22,De[l.SymbolKind.Event]=23,De[l.SymbolKind.Operator]=24,De[l.SymbolKind.TypeParameter]=25;function me(Ae){return typeof De[Ae]=="number"?De[Ae]:6}Se.from=me;function q(Ae){for(const Le in De)if(De[Le]===Ae)return Number(Le);return l.SymbolKind.Property}Se.to=q})(J=e.SymbolKind||(e.SymbolKind={}));var Q;(function(Se){function De(q){switch(q){case l.SymbolTag.Deprecated:return 1}}Se.from=De;function me(q){switch(q){case 1:return l.SymbolTag.Deprecated}}Se.to=me})(Q=e.SymbolTag||(e.SymbolTag={}));var ce;(function(Se){function De(q){return{name:q.name,kind:J.from(q.kind),tags:q.tags&&q.tags.map(Q.from),containerName:q.containerName,location:Ee.from(q.location)}}Se.from=De;function me(q){const Ae=new l.SymbolInformation(q.name,J.to(q.kind),q.containerName,Ee.to(q.location));return Ae.tags=q.tags&&q.tags.map(Q.to),Ae}Se.to=me})(ce=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(Se){function De(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:d.from(q.range),selectionRange:d.from(q.selectionRange),kind:J.from(q.kind),tags:q.tags?.map(Q.from)??[]};return q.children&&(Ae.children=q.children.map(De)),Ae}Se.from=De;function me(q){const Ae=new l.DocumentSymbol(q.name,q.detail,J.to(q.kind),d.to(q.range),d.to(q.selectionRange));return(0,r.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(Q.to)),q.children&&(Ae.children=q.children.map(me)),Ae}Se.to=me})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var pe;(function(Se){function De(q){const Ae=new l.CallHierarchyItem(J.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),d.to(q.range),d.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=De;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:q.name,detail:q.detail,kind:J.from(q.kind),uri:q.uri,range:d.from(q.range),selectionRange:d.from(q.selectionRange),tags:q.tags?.map(Q.from)}}Se.from=me})(pe=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(Se){function De(me){return new l.CallHierarchyIncomingCall(pe.to(me.from),me.fromRanges.map(q=>d.to(q)))}Se.to=De})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var re;(function(Se){function De(me){return new l.CallHierarchyOutgoingCall(pe.to(me.to),me.fromRanges.map(q=>d.to(q)))}Se.to=De})(re=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Se){function De(q){return{range:q.range&&d.from(q.range),uri:q.uri}}Se.from=De;function me(q){return new l.Location(O.URI.revive(q.uri),d.to(q.range))}Se.to=me})(Ee=e.location||(e.location={}));var Pe;(function(Se){function De(q){const Ae=q,Le=q;return{originSelectionRange:Ae.originSelectionRange?d.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:d.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?d.from(Ae.targetSelectionRange):void 0}}Se.from=De;function me(q){return{targetUri:O.URI.revive(q.uri),targetRange:d.to(q.range),targetSelectionRange:q.targetSelectionRange?d.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?d.to(q.originSelectionRange):void 0}}Se.to=me})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(Se){function De(q){return{range:d.from(q.range),contents:U.fromMany(q.contents)}}Se.from=De;function me(q){return new l.Hover(q.contents.map(U.to),d.to(q.range))}Se.to=me})(Fe=e.Hover||(e.Hover={}));var We;(function(Se){function De(q){return{range:d.from(q.range),expression:q.expression}}Se.from=De;function me(q){return new l.EvaluatableExpression(d.to(q.range),q.expression)}Se.to=me})(We=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(Se){function De(q){if(q instanceof l.InlineValueText)return{type:"text",range:d.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:d.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=De;function me(q){switch(q.type){case"text":return{range:d.to(q.range),text:q.text};case"variable":return{range:d.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:d.to(q.range),expression:q.expression}}}Se.to=me})(Xe=e.InlineValue||(e.InlineValue={}));var Te;(function(Se){function De(q){return{frameId:q.frameId,stoppedLocation:d.from(q.stoppedLocation)}}Se.from=De;function me(q){return new l.InlineValueContext(q.frameId,d.to(q.stoppedLocation))}Se.to=me})(Te=e.InlineValueContext||(e.InlineValueContext={}));var _e;(function(Se){function De(q){return{range:d.from(q.range),kind:q.kind}}Se.from=De;function me(q){return new l.DocumentHighlight(d.to(q.range),q.kind)}Se.to=me})(_e=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(Se){function De(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}Se.to=De})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(Se){function De(me){return{triggerKind:ye.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Se.to=De})(ae=e.CompletionContext||(e.CompletionContext={}));var ue;(function(Se){function De(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}Se.from=De;function me(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}Se.to=me})(ue=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(Se){const De=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Le){return De.get(Le)??9}Se.from=me;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Le){return q.get(Le)??l.CompletionItemKind.Property}Se.to=Ae})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(Se){function De(me,q){const Ae=new l.CompletionItem(me.label);return Ae.insertText=me.insertText,Ae.kind=Y.to(me.kind),Ae.tags=me.tags?.map(ue.to),Ae.detail=me.detail,Ae.documentation=S.isMarkdownString(me.documentation)?U.to(me.documentation):me.documentation,Ae.sortText=me.sortText,Ae.filterText=me.filterText,Ae.preselect=me.preselect,Ae.commitCharacters=me.commitCharacters,b.Range.isIRange(me.range)?Ae.range=d.to(me.range):typeof me.range=="object"&&(Ae.range={inserting:d.to(me.range.insert),replacing:d.to(me.range.replace)}),Ae.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Ae.insertText=new l.SnippetString(me.insertText):(Ae.insertText=me.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ae.additionalTextEdits=me.additionalTextEdits.map(Le=>$.to(Le))),Ae.command=q&&me.command?q.fromInternal(me.command):void 0,Ae}Se.to=De})(ee=e.CompletionItem||(e.CompletionItem={}));var C;(function(Se){function De(q){return{label:q.label,documentation:U.fromStrict(q.documentation)}}Se.from=De;function me(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation}}Se.to=me})(C=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(Se){function De(q){return{label:q.label,documentation:U.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(C.from):[],activeParameter:q.activeParameter}}Se.from=De;function me(q){return{label:q.label,documentation:S.isMarkdownString(q.documentation)?U.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(C.to):[],activeParameter:q.activeParameter}}Se.to=me})(B=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(Se){function De(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.from):[]}}Se.from=De;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.to):[]}}Se.to=me})(H=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(Se){function De(me,q){const Ae=new l.InlayHint(n.to(q.position),typeof q.label=="string"?q.label:q.label.map(oe.to.bind(void 0,me)),q.kind&&le.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map($.to),Ae.tooltip=S.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}Se.to=De})(j=e.InlayHint||(e.InlayHint={}));var oe;(function(Se){function De(me,q){const Ae=new l.InlayHintLabelPart(q.label);return Ae.tooltip=S.isMarkdownString(q.tooltip)?U.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Ae.command=me.fromInternal(q.command)),q.location&&(Ae.location=Ee.to(q.location)),Ae}Se.to=De})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var le;(function(Se){function De(q){return q}Se.from=De;function me(q){return q}Se.to=me})(le=e.InlayHintKind||(e.InlayHintKind={}));var Z;(function(Se){function De(q){return{range:d.from(q.range),url:q.target,tooltip:q.tooltip}}Se.from=De;function me(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?O.URI.parse(q.url,!0):O.URI.revive(q.url)}catch{}return new l.DocumentLink(d.to(q.range),Ae)}Se.to=me})(Z=e.DocumentLink||(e.DocumentLink={}));var ve;(function(Se){function De(q){const Ae=new l.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=$.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Le=>$.to(Le))),Ae}Se.to=De;function me(q){return{label:q.label,textEdit:q.textEdit?$.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>$.from(Ae)):void 0}}Se.from=me})(ve=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(Se){function De(q){return new l.Color(q[0],q[1],q[2],q[3])}Se.to=De;function me(q){return[q.red,q.green,q.blue,q.alpha]}Se.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(Se){function De(q){return{range:d.from(q.range)}}Se.from=De;function me(q){return new l.SelectionRange(d.to(q.range))}Se.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var xe;(function(Se){function De(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}Se.to=De})(xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(Se){function De(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=De;function me(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}Se.to=me})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(Se){function De(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}Se.from=De;function me(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}Se.to=me})(Ge=e.EndOfLine||(e.EndOfLine={}));var ke;(function(Se){function De(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=De})(ke=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(Se){function De(me){const q={start:me.start+1,end:me.end+1};return me.kind&&(q.kind=G.from(me.kind)),q}Se.from=De})(nt=e.FoldingRange||(e.FoldingRange={}));var G;(function(Se){function De(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}Se.from=De})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(Se){function De(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?d.from(me.selection):void 0,override:typeof me.override=="boolean"?c.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=De})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Se){function De(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||q(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=De;function me(Le){const et=Le;return et?O.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function q(Le){const et=Le;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new l.RelativePattern(O.URI.revive(Le.baseUri),Le.pattern)}Se.to=Ae})(he=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(Se){function De(me){if(me){if(Array.isArray(me))return me.map(De);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:he.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}Se.from=De})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var Ve;(function(Se){function De(q){return{start:q.start,end:q.end}}Se.from=De;function me(q){return new l.NotebookRange(q.start,q.end)}Se.to=me})(Ve=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(Se){function De(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}Se.to=De;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}Se.from=me})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ke;(function(Se){function De(me){if(me===h.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(me===h.NotebookCellExecutionState.Pending)return;if(me===h.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Se.to=De})(Ke=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var je;(function(Se){function De(q){switch(q){case l.NotebookCellKind.Markup:return h.CellKind.Markup;case l.NotebookCellKind.Code:default:return h.CellKind.Code}}Se.from=De;function me(q){switch(q){case h.CellKind.Markup:return l.NotebookCellKind.Markup;case h.CellKind.Code:default:return l.NotebookCellKind.Code}}Se.to=me})(je=e.NotebookCellKind||(e.NotebookCellKind={}));var tt;(function(Se){function De(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)l.NotebookCellData.validate(Le),Ae.cells.push(st.from(Le));return Ae}Se.from=De;function me(q){const Ae=new l.NotebookData(q.cells.map(st.to));return(0,k.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}Se.to=me})(tt=e.NotebookData||(e.NotebookData={}));var st;(function(Se){function De(q){return{cellKind:je.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Ze.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(at.from):[]}}Se.from=De;function me(q){return new l.NotebookCellData(je.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(at.to):void 0,q.metadata,q.internalMetadata?Ze.to(q.internalMetadata):void 0)}Se.to=me})(st=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(Se){function De(q){return{mime:q.mime,valueBytes:y.VSBuffer.wrap(q.data)}}Se.from=De;function me(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}Se.to=me})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(Se){function De(q){return{outputId:q.id,items:q.items.map(dt.from),metadata:q.metadata}}Se.from=De;function me(q){const Ae=q.items.map(dt.to);return new l.NotebookCellOutput(Ae,q.outputId,q.metadata)}Se.to=me})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(Se){function De(Ae){return q(Ae)?{include:(0,k.withNullAsUndefined)(he.from(Ae.include)),exclude:(0,k.withNullAsUndefined)(he.from(Ae.exclude))}:(0,k.withNullAsUndefined)(he.from(Ae))}Se.from=De;function me(Ae){return q(Ae)?{include:he.to(Ae.include),exclude:he.to(Ae.exclude)}:he.to(Ae)}Se.to=me;function q(Ae){const Le=Ae;return Le?!(0,k.isUndefinedOrNull)(Le.include)&&!(0,k.isUndefinedOrNull)(Le.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(Se){function De(me,q,Ae){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ae),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Se.from=De})(_t=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(Se){function De(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}Se.from=De})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ot;(function(Se){function De(q){return{uri:q.uri,provides:q.provides}}Se.from=De;function me(q){return new l.NotebookRendererScript(O.URI.revive(q.uri),q.provides)}Se.to=me})(Ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(Se){function De(q){return{message:U.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:d.from(q.location.range),uri:q.location.uri}}}Se.from=De;function me(q){const Ae=new l.TestMessage(typeof q.message=="string"?q.message:U.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?Ee.to(q.location):void 0,Ae}Se.to=me})(mt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Se){Se.namespace=v.namespaceTestTag,Se.denamespace=v.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(Se){function De(q){const Ae=(0,f.getPrivateApiFor)(q).controllerId;return{extId:u.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:O.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Le=>Dt.namespace(Ae,Le.id)),range:b.Range.lift(d.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&U.fromStrict(q.error)||null}}Se.from=De;function me(q){return{parent:void 0,error:void 0,id:u.TestId.fromString(q.extId).localId,label:q.label,uri:O.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Le}=Dt.denamespace(Ae);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}Se.toPlain=me})(Nt=e.TestItem||(e.TestItem={})),function(Se){function De(q){return{id:q.id}}Se.from=De;function me(q){return new l.TestTag(q.id)}Se.to=me}(Dt=e.TestTag||(e.TestTag={}));var Mt;(function(Se){const De=(q,Ae)=>{const Le=[];for(const[Be,it]of Ae)u.TestId.compare(it.item.extId,Be)===2&&(Ae.delete(Be),Le.push(it));const et={...Nt.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(it=>it.type===0).map(mt.to)})),children:Le.map(Be=>De(Be,Ae))};for(const Be of et.children)Be.parent=et;return et};function me(q){const Ae=[],Le=new Map;for(const et of q.items)Le.set(et.item.extId,et),q.request.targets.some(Be=>Be.controllerId===et.controllerId&&Be.testIds.includes(et.item.extId))&&Ae.push(et);return{completedAt:q.completedAt,results:Ae.map(et=>De(et,Le))}}Se.to=me})(Mt=e.TestResults||(e.TestResults={}));var qe;(function(Se){function De(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?n.from(Le):d.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(et=>({count:et.executionCount,location:et.location&&me(et.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}Se.fromDetailed=q;function Ae(Le){return{uri:Le.uri,statement:De(Le.statementCoverage),branch:Le.branchCoverage&&De(Le.branchCoverage),function:Le.functionCoverage&&De(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}Se.fromFile=Ae})(qe=e.TestCoverage||(e.TestCoverage={}));var Ut;(function(Se){function De(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}Se.to=De})(Ut=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ft;(function(Se){function De(q){const Ae=new l.TypeHierarchyItem(J.to(q.kind),q.name,q.detail||"",O.URI.revive(q.uri),d.to(q.range),d.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}Se.to=De;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:J.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:d.from(q.range),selectionRange:d.from(q.selectionRange),tags:q.tags?.map(Q.from)}}Se.from=me})(Ft=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Tt;(function(Se){function De(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}Se.from=De})(Tt=e.ViewBadge||(e.ViewBadge={}));var gt;(function(Se){function De(me,q){const Ae=me.fileData;return Ae?new class extends l.DataTransferItem{asFile(){return{name:Ae.name,uri:O.URI.revive(Ae.uri),data:(0,w.once)(()=>q())}}}("",me.id):new l.DataTransferItem(me.asString)}Se.toDataTransferItem=De})(gt=e.DataTransferItem||(e.DataTransferItem={}));var yt;(function(Se){function De(q,Ae){const Le=q.items.map(([et,Be])=>[et,gt.toDataTransferItem(Be,()=>Ae(Be.id))]);return new l.DataTransfer(Le)}Se.toDataTransfer=De;async function me(q){const Ae={items:[]},Le=[];return q.forEach((et,Be)=>{Le.push((async()=>{const it=await et.asString(),ct=et.asFile();Ae.items.push([Be,{id:et.id,asString:it,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}])})())}),await Promise.all(Le),Ae}Se.toDataTransferDTO=me})(yt=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[177],Ie([1,0,2,11,6,8,241]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(k,O,b,m={timeout:1500,errors:3}){this._logService=k,this._documents=O,this._mainThreadBulkEdits=b,this._thresholds=m,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(O,b,m)=>{const f={dispose:this._callbacks.push([O,b,k])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(k,O){const b=r.URI.revive(k);let m=!1;const T=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const c of[...this._callbacks]){if(m)break;const h=this._documents.getDocument(b),u=await this._deliverEventAsyncAndBlameBadListeners(c,{document:h,reason:M.TextDocumentSaveReason.to(O)});f.push(u)}}finally{clearTimeout(T)}return f}_deliverEventAsyncAndBlameBadListeners([k,O,b],m){const T=this._badListeners.get(k);return typeof T=="number"&&T>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,k,O,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const c=this._badListeners.get(k);this._badListeners.set(k,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,O,b,m){const T=[],f=Date.now(),{document:c,reason:h}=m,{version:u}=c,v=Object.freeze({document:c,reason:h,waitUntil(I){if(Object.isFrozen(T))throw(0,y.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(I))}});try{O.apply(b,[v])}catch(I){return Promise.reject(I)}return Object.freeze(T),new Promise((I,l)=>{const w=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(T).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(w),I(t)}).catch(t=>{clearTimeout(w),l(t)})}).then(I=>{const l={edits:[]};for(const w of I)if(Array.isArray(w)&&w.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:d,range:i}of w)l.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:i&&M.Range.from(i),text:t,eol:d&&M.EndOfLine.from(d)}});if(l.edits.length!==0)return u===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[178],Ie([1,0,12,2,8,6,64]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(b,m,T,f){this.start=b,this.deletedCount=m,this.deletedItems=T,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class E{constructor(b,m,T){this.notebook=b,this._extHostDocument=m,this._cellData=T,this.handle=T.handle,this.uri=y.URI.revive(T.uri),this.cellKind=T.cellKind,this._outputs=T.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=T.internalMetadata??{},this._metadata=Object.freeze(T.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}static asModelAddData(b,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:b}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return b._mime},set mime(f){b._mime=f},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(T)}return this._apiCell}setOutputs(b){this._outputs=b.map(S.NotebookCellOutput.to)}setOutputItems(b,m,T){const f=T.map(S.NotebookCellOutputItem.to),c=this._outputs.find(h=>h.id===b);c&&(m||(c.items.length=0),c.items.push(...f))}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=E;class k{constructor(b,m,T,f,c){this._proxy=b,this._textDocumentsAndEditors=m,this._textDocuments=T,this.uri=f,this.handle=k._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=c.viewType,this._metadata=Object.freeze(c.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,c.cells]],!0,void 0),this._versionId=c.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,m={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===r.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(T){return T=b._validateIndex(T),b._cells[T].apiCell},getCells(T){return(T?b._getCells(T):b._cells).map(c=>c.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(m)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,m,T){this._versionId=b.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:T});const f={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},c=[];for(const u of b.rawEvents)u.kind===_.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(u.changes,!1,f.contentChanges):u.kind===_.NotebookCellsChangeType.Move?this._moveCell(u.index,u.newIdx,f.contentChanges):u.kind===_.NotebookCellsChangeType.Output?(this._setCellOutputs(u.index,u.outputs),c.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===_.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(u.index,u.outputId,u.append,u.outputItems),c.push({cell:this._cells[u.index].apiCell,outputs:this._cells[u.index].apiCell.outputs})):u.kind===_.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(u.index,u.language),c.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document})):u.kind===_.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this._cells[u.index].apiCell,document:this._cells[u.index].apiCell.document}):u.kind===_.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(u.index,u.mime):u.kind===_.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(u.index,u.metadata),c.push({cell:this._cells[u.index].apiCell,metadata:this._cells[u.index].apiCell.metadata})):u.kind===_.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(u.index,u.internalMetadata),c.push({cell:this._cells[u.index].apiCell,executionSummary:this._cells[u.index].apiCell.executionSummary}));const h=new Map;for(let u=0;u<c.length;u++){const v=c[u],I=h.get(v.cell);if(I===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});h.set(v.cell,l-1)}else f.cellChanges[I]={...f.cellChanges[I],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let m=b.start|0,T=b.end|0;return m<0&&(m=0),T>this._cells.length&&(T=this._cells.length),b.with({start:m,end:T})}_getCells(b){b=this._validateRange(b);const m=[];for(let T=b.start;T<b.end;T++)m.push(this._cells[T]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,m,T){if(this._disposed)return;const f=[],c=[],h=[];if(b.reverse().forEach(u=>{const I=u[2].map(t=>{const d=new E(this,this._textDocumentsAndEditors,t);return m||c.push(E.asModelAddData(this.apiNotebook,t)),d}),l=new A(u[0],u[1],[],I),w=this._cells.splice(u[0],u[1],...I);for(const t of w)h.push(t.uri),l.deletedItems.push(t.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:h}),T)for(const u of f)T.push(u.asApiEvent())}_moveCell(b,m,T){const f=this._cells.splice(b,1);this._cells.splice(m,0,...f);const c=[new A(b,1,f.map(h=>h.apiCell),[]),new A(m,0,[],f)];for(const h of c)T.push(h.asApiEvent())}_setCellOutputs(b,m){this._cells[b].setOutputs(m)}_setCellOutputItems(b,m,T,f){this._cells[b].setOutputItems(m,T,f)}_changeCellLanguage(b,m){const T=this._cells[b];T.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(T.uri,m)}_changeCellMime(b,m){const T=this._cells[b];T.apiCell.mime=m}_changeCellMetadata(b,m){this._cells[b].setMetadata(m)}_changeCellInternalMetadata(b,m){this._cells[b].setInternalMetadata(m)}getCellFromApiCell(b){return this._cells.find(m=>m.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(m=>m.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=k,k._handlePool=0}),define(Ce[93],Ie([1,0,11,8,6]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,E,k,O,b,m){this.id=A,this._proxy=E,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=O,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(E){this.selections=[E]},get selections(){return A._selections},set selections(E){if(!Array.isArray(E)||!E.every(S.NotebookRange.isNotebookRange))throw(0,r.illegalArgument)("selections");A._selections=E,A._trySetSelections(E)},get visibleRanges(){return A._visibleRanges},revealRange(E,k){A._proxy.$tryRevealRange(A.id,y.NotebookRange.from(E),k??S.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(y.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ce[179],Ie([1,0,5,15,8]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,E){this._logService=A,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,E);const k=this._notebooksAndEditors.getEditorById(A);E.visibleRanges&&k._acceptVisibleRanges(E.visibleRanges.ranges.map(S.NotebookRange.to)),E.selections&&k._acceptSelections(E.selections.selections.map(S.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const E in A)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(S.ViewColumn.to(A[E]))}};M=ze([$e(0,y.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[180],Ie([1,0,8,150,131,20,55,11]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,T,f){const c=this._handles++,{title:h,location:u,cancellable:v}=T,I={label:(0,S.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(c,{location:r.ProgressLocation.from(u),title:h,source:I,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(c,f,!!v)}_withProgress(m,T,f){let c;f&&(c=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,c));const h=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),c?.dispose()};let u;try{u=T(new O(this._proxy,m),f&&c?c.token:M.CancellationToken.None)}catch(v){throw h(m),v}return u.then(v=>h(m),v=>h(m)),u}$acceptProgressCanceled(m){const T=this._mapHandleToCancellationSource.get(m);T&&(T.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=E;function k(b,m){return b.message=m.message,typeof m.increment=="number"&&(typeof b.increment=="number"?b.increment+=m.increment:b.increment=m.increment),b}class O extends y.Progress{constructor(m,T){super(f=>this.throttledReport(f)),this._proxy=m,this._handle=T}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,_.throttle)(100,(b,m)=>k(b,m),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ce[94],Ie([1,0,49,89,47,65,48,8,2]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(I,l,w,t)=>{let d=l;return{enumerable:!0,configurable:!1,get(){return d},set(i){if(!w(d,i)){const n=d;d=i,I.listener?.(t(i,n))}}}},O=(I,l)=>I===l,b={range:(I,l)=>I===l?!0:!I||!l?!1:I.isEqual(l),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(I,l)=>!(I.length!==l.length||I.some(w=>!l.find(t=>w.id===t.id)))},m=I=>l=>({op:4,update:I(l)}),T=(I,l)=>({range:k(I,void 0,b.range,m(w=>({range:r.Range.lift(A.Range.from(w))}))),label:k(I,l,b.label,m(w=>({label:w}))),description:k(I,void 0,b.description,m(w=>({description:w}))),sortText:k(I,void 0,b.sortText,m(w=>({sortText:w}))),canResolveChildren:k(I,!1,b.canResolveChildren,w=>({op:2,state:w})),busy:k(I,!1,b.busy,m(w=>({busy:w}))),error:k(I,void 0,b.error,m(w=>({error:A.MarkdownString.fromStrict(w)||null}))),tags:k(I,[],b.tags,(w,t)=>({op:1,new:w.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),f=I=>{const l=S.TestId.fromString(I.extId),w=new h(l.controllerId,l.localId,I.label,E.URI.revive(I.uri)||void 0);return w.range=A.Range.to(I.range||void 0),w.description=I.description||void 0,w.sortText=I.sortText||void 0,w.tags=I.tags.map(t=>A.TestTag.to({id:(0,_.denamespaceTestTag)(t).tagId})),w},c=I=>{let l;for(const w of I.tests){const t=f(w.item);(0,y.getPrivateApiFor)(t).parent=l,l=t}return l};e.toItemFromContext=c;class h{constructor(l,w,t,d){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const i=(0,y.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof u?void 0:i.parent}},children:{value:(0,M.createTestItemChildren)(i,y.getPrivateApiFor,h),enumerable:!0,writable:!1},...T(i,t)})}}e.TestItemImpl=h;class u extends h{constructor(l,w){super(l,l,w,void 0)}}e.TestItemRootImpl=u;class v extends M.TestItemCollection{constructor(l,w,t){super({controllerId:l,getDocumentVersion:d=>t.getDocument(d)?.version,getApiFor:y.getPrivateApiFor,getChildren:d=>d.children,root:new u(l,w),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(Ce[95],Ie([1,0,44,11,73,8,6]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,T,f){const c=A._Keys.nextId();m.$registerTextEditorDecorationType(T.identifier,c,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:c,dispose(){m.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=A,A._Keys=new S.IdGenerator("TextEditorDecorationType");class E{constructor(m,T){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=T.undoStopBefore,this._undoStopAfter=T.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,T){this._throwIfFinalized();let f=null;if(m instanceof _.Position)f=new _.Range(m,m);else if(m instanceof _.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,T,!1)}insert(m,T){this._throwIfFinalized(),this._pushEdit(new _.Range(m,m),T,!0)}delete(m){this._throwIfFinalized();let T=null;if(m instanceof _.Range)T=m;else throw new Error("Unrecognized location");this._pushEdit(T,null,!0)}_pushEdit(m,T,f){const c=this._document.validateRange(m);this._collectedEdits.push({range:c,text:T,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==_.EndOfLine.LF&&m!==_.EndOfLine.CRLF)throw(0,y.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=E;class k{constructor(m,T,f,c){this._proxy=m,this._id=T,this._accept(f),this._logService=c;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(u){h._setTabSize(u)},get insertSpaces(){return h._insertSpaces},set insertSpaces(u){h._setInsertSpaces(u)},get cursorStyle(){return h._cursorStyle},set cursorStyle(u){h._setCursorStyle(u)},get lineNumbers(){return h._lineNumbers},set lineNumbers(u){h._setLineNumbers(u)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const T=Math.floor(m);return T>0?T:null}if(typeof m=="string"){const T=parseInt(m,10);return isNaN(T)?null:T>0?T:null}return null}_setTabSize(m){const T=this._validateTabSize(m);if(T!==null){if(typeof T=="number"){if(this._tabSize===T)return;this._tabSize=T}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:T}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const T=this._validateInsertSpaces(m);if(typeof T=="boolean"){if(this._insertSpaces===T)return;this._insertSpaces=T}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:T}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const T={};let f=!1;if(typeof m.tabSize<"u"){const c=this._validateTabSize(m.tabSize);c==="auto"?(f=!0,T.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,f=!0,T.tabSize=c)}if(typeof m.insertSpaces<"u"){const c=this._validateInsertSpaces(m.insertSpaces);c==="auto"?(f=!0,T.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,f=!0,T.insertSpaces=c)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,T.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,T.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,T))}_warnOnError(m,T){T.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=k;class O{constructor(m,T,f,c,h,u,v,I){this.id=m,this._proxy=T,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new k(this._proxy,this.id,u,f),this._visibleRanges=v,this._viewColumn=I;const l=this;this.value=Object.freeze({get document(){return c.getValue()},set document(w){throw(0,y.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(w){if(!(w instanceof _.Selection))throw(0,y.illegalArgument)("selection");l._selections=[w],l._trySetSelection()},get selections(){return l._selections},set selections(w){if(!Array.isArray(w)||w.some(t=>!(t instanceof _.Selection)))throw(0,y.illegalArgument)("selections");l._selections=w,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(w){throw(0,y.readonly)("visibleRanges")},get options(){return l._options.value},set options(w){l._disposed||l._options.assign(w)},get viewColumn(){return l._viewColumn},set viewColumn(w){throw(0,y.readonly)("viewColumn")},edit(w,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new E(c.getValue(),t);return w(d),l._applyEdit(d)},insertSnippet(w,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!t||Array.isArray(t)&&t.length===0)i=l._selections.map(n=>M.Range.from(n));else if(t instanceof _.Position){const{lineNumber:n,column:s}=M.Position.from(t);i=[{startLineNumber:n,startColumn:s,endLineNumber:n,endColumn:s}]}else if(t instanceof _.Range)i=[M.Range.from(t)];else{i=[];for(const n of t)if(n instanceof _.Range)i.push(M.Range.from(n));else{const{lineNumber:s,column:a}=M.Position.from(n);i.push({startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a})}}return T.$tryInsertSnippet(m,c.getValue().version,w.value,i,d)},setDecorations(w,t){const d=t.length===0;d&&!l._hasDecorationsForKey.has(w.key)||(d?l._hasDecorationsForKey.delete(w.key):l._hasDecorationsForKey.add(w.key),l._runOnProxy(()=>{if(M.isDecorationOptionsArr(t))return T.$trySetDecorations(m,w.key,M.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let n=0,s=t.length;n<s;n++){const a=t[n];i[4*n]=a.start.line+1,i[4*n+1]=a.start.character+1,i[4*n+2]=a.end.line+1,i[4*n+3]=a.end.character+1}return T.$trySetDecorationsFast(m,w.key,i)}}))},revealRange(w,t){l._runOnProxy(()=>T.$tryRevealRange(m,M.Range.from(w),t||_.TextEditorRevealType.Default))},show(w){T.$tryShowEditor(m,M.ViewColumn.from(w))},hide(){T.$tryHideEditor(m)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,r.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,r.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,r.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,r.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const T=m.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const f=T.edits.map(h=>h.range);f.sort((h,u)=>h.end.line===u.end.line?h.end.character===u.end.character?h.start.line===u.start.line?h.start.character-u.start.character:h.start.line-u.start.line:h.end.character-u.end.character:h.end.line-u.end.line);for(let h=0,u=f.length-1;h<u;h++){const v=f[h].end;if(f[h+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=T.edits.map(h=>({range:M.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,T.documentVersionId,c,{setEndOfLine:typeof T.setEndOfLine=="number"?M.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this._logService.warn(T),null))}}e.ExtHostTextEditor=O}),define(Ce[181],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceEditIsRefactoring:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceEditIsRefactoring.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[182],Ie([1,0,142,11,29,80,83,30,27,181,149]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=A.Registry.as(_.Extensions.JSONContribution);class m{constructor(l,w,t){this._messageHandler=l,this._extension=w,this._extensionPointId=t}_msg(l,w){this._messageHandler({type:l,message:w,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(S.default.Error,l)}warn(l){this._msg(S.default.Warning,l)}info(l){this._msg(S.default.Info,l)}}e.ExtensionMessageCollector=m;class T{constructor(l,w){this.added=l,this.removed=w}static _toSet(l){const w=new Set;for(let t=0,d=l.length;t<d;t++)w.add(E.ExtensionIdentifier.toKey(l[t].description.identifier));return w}static compute(l,w){if(!l||!l.length)return new T(w,[]);if(!w||!w.length)return new T([],l);const t=this._toSet(l),d=this._toSet(w),i=w.filter(s=>!t.has(E.ExtensionIdentifier.toKey(s.description.identifier))),n=l.filter(s=>!d.has(E.ExtensionIdentifier.toKey(s.description.identifier)));return new T(i,n)}}e.ExtensionPointUserDelta=T;class f{constructor(l,w){this.name=l,this.defaultExtensionKind=w,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=T.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,y.onUnexpectedError)(l)}}}e.ExtensionPoint=f;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},activationEvents:{description:r.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:r.localize(31,null)},{label:"onUri",body:"onUri",description:r.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(36,null)},{label:"onRenderer",description:r.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(39,null)},{label:"*",description:r.localize(40,null),body:"*"}]}},badges:{type:"array",description:r.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(42,null)},href:{type:"string",description:r.localize(43,null)},description:{type:"string",description:r.localize(44,null)}}}},markdown:{type:"string",description:r.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:r.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:r.localize(49,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(50,null)},{body:["workspace"],description:r.localize(51,null)},{body:["ui","workspace"],description:r.localize(52,null)},{body:["workspace","ui"],description:r.localize(53,null)},{body:[],description:r.localize(54,null)}]},capabilities:{description:r.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(58,null),r.localize(59,null),r.localize(60,null)]},description:{type:"string",markdownDescription:r.localize(61,null)}}},untrustedWorkspaces:{description:r.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(64,null),r.localize(65,null),r.localize(66,null)]},restrictedConfigurations:{description:r.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(68,null)}}}}},sponsor:{description:r.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(71,null),type:"string"},"vscode:uninstall":{description:r.localize(72,null),type:"string"}}},icon:{type:"string",description:r.localize(73,null)}}};class u{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const w=new f(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,w),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,b.registerSchema(h,e.schema),w}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=u;const v={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(v.ExtensionsRegistry,new u),e.ExtensionsRegistry=A.Registry.as(v.ExtensionsRegistry),b.registerSchema(h,e.schema),b.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:r.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[183],Ie([1,0,139,10,26,182,38,5]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var k;(function(m){function T(f,c,h){if(!f)return;const u=y.isString(f.type)?f.type:void 0;if(!u||u.length===0){h.error(r.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const I of f.required)y.isString(I)&&v.push(I);return{extensionId:c.value,taskType:u,required:v,properties:f.properties?S.deepClone(f.properties):{},when:f.when?_.ContextKeyExpr.deserialize(f.when):void 0}}m.from=T})(k||(k={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:r.localize(4,null),type:"array",items:E}});class b{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((T,f)=>{O.setHandler((c,h)=>{this._schema=void 0;try{for(const u of h.removed){const v=u.value;for(const I of v)this.taskTypes&&I.type&&this.taskTypes[I.type]&&delete this.taskTypes[I.type]}for(const u of h.added){const v=u.value;for(const I of v){const l=k.from(I,u.description.identifier,u.collector);l&&(this.taskTypes[l.taskType]=l)}}(h.removed.length>0||h.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}T(void 0)})})}onReady(){return this.readyPromise}get(T){return this.taskTypes[T]}all(){return Object.keys(this.taskTypes).map(T=>this.taskTypes[T])}getJsonSchema(){if(this._schema===void 0){const T=[];for(const f of this.all()){const c={type:"object",additionalProperties:!1};f.required.length>0&&(c.required=f.required.slice(0)),f.properties!==void 0?c.properties=S.deepClone(f.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[f.taskType]},T.push(c)}this._schema={oneOf:T}}return this._schema}}e.TaskDefinitionRegistryImpl=b,e.TaskDefinitionRegistry=new b}),define(Ce[184],Ie([1,0,140,10,22,26,38,183]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new _.RawContextKey("taskRunning",!1,r.localize(0,null)),e.TASKS_CATEGORY={value:r.localize(1,null),original:"Tasks"};var E;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function K(W){if(!W)return R.Strong;switch(W.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=K}(O=e.RevealKind||(e.RevealKind={}));var b;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(b=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function K(W){switch(W.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=K}(b=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(R){function K(W){switch(W.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=K}(m=e.PanelKind||(e.PanelKind={}));var T;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:b.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(T=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(R){function K($){switch($.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=K;function W($){switch($){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=W}(f=e.RuntimeType||(e.RuntimeType={}));var c;(function(R){function K(W){return y.isString(W)?W:W.value}R.value=K})(c=e.CommandString||(e.CommandString={}));var h;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function K($){return $===R.Clean._id||$===R.Build._id||$===R.Rebuild._id||$===R.Test._id}R.is=K;function W($){if($!==void 0)return y.isString($)?K($)?{_id:$,isDefault:!1}:void 0:$}R.from=W})(h=e.TaskGroup||(e.TaskGroup={}));var u;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(u=e.TaskScope||(e.TaskScope={}));var v;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function K(W){switch(W){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=K})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var I;(function(R){R.parallel="parallel",R.sequence="sequence"})(I=e.DependsOrder||(e.DependsOrder={}));var l;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(l=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class t{constructor(K,W,$,fe,J,Q){this._label="",this._id=K,W&&(this._label=W),$&&(this.type=$),this.runOptions=fe,this.configurationProperties=J,this._source=Q}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,W=!1){if(K===void 0)return!1;if(y.isString(K))return K===this._label||K===this.configurationProperties.identifier||W&&K===this._id;const $=this.getDefinition(!0);return $!==void 0&&$._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=t;class d extends t{constructor(K,W,$,fe,J,Q,ce,te){super(K,$,void 0,ce,te,W),this.command={},this._source=W,this.hasDefinedMatchers=Q,J&&(this.command=J)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case f.Shell:W="shell";break;case f.Process:W="process";break;case f.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(K){return K instanceof d}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new d(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=d;class i extends t{constructor(K,W,$,fe,J,Q,ce){super(K,$,fe,Q,ce,W),this._source=W,this.configures=J}static is(K){return K instanceof i}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?S.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let W=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(W+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:W};return JSON.stringify($)}}e.ConfiguringTask=i;class n extends t{constructor(K,W,$,fe,J,Q,ce,te,pe){super(K,$,fe,te,pe,W),this.defines=J,this.hasDefinedMatchers=ce,this.command=Q,this.icon=pe.icon,this.hide=pe.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof n}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new n(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=n;class s extends t{constructor(K,W,$,fe,J,Q){super(K,$,fe,J,Q,W),this._source=W}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new s(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=s;var a;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(a=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(a=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class g{constructor(K){this._order=new Map;for(let W=0;W<K.length;W++)this._order.set(K[W].uri.toString(),W)}compare(K,W){const $=K.getWorkspaceFolder(),fe=W.getWorkspaceFolder();if($&&fe){let J=this._order.get($.uri.toString());J=J===void 0?0:J+1;let Q=this._order.get(fe.uri.toString());return Q=Q===void 0?0:Q+1,J===Q?K._label.localeCompare(W._label):J-Q}else return!$&&fe?-1:$&&!fe?1:0}}e.TaskSorter=g;var p;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(p=e.TaskEventKind||(e.TaskEventKind={}));var P;(function(R){R.SingleRun="singleRun",R.Background="background"})(P=e.TaskRunType||(e.TaskRunType={}));var N;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(N=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(R){function K(W,$,fe,J,Q){if($){const ce={kind:W,taskId:$._id,taskName:$.configurationProperties.name,runType:$.configurationProperties.isBackground?"background":"singleRun",group:$.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:$};return W==="start"?(ce.terminalId=fe,ce.resolvedVariables=J):W==="processStarted"?ce.processId=fe:W==="processEnded"&&(ce.exitCode=fe),Object.freeze(ce)}else return Object.freeze({kind:"changed"})}R.create=K})(V=e.TaskEvent||(e.TaskEvent={}));var U;(function(R){function K($){const fe=Object.keys($).sort();let J="";for(const Q of fe){let ce=$[Q];ce instanceof Object?ce=K(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),J+=Q+","+ce+","}return J}function W($){const J={_key:K($),type:$.taskType};return Object.assign(J,$),J}R.create=W})(U=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var D;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(D=e.TaskSettingId||(e.TaskSettingId={}));var x;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(x=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var L;(function(R){function K(W,$){const fe=A.TaskDefinitionRegistry.get(W.type);if(fe===void 0){const te=M.deepClone(W);return delete te._key,U.create(te)}const J=Object.create(null);J.type=fe.taskType;const Q=new Set;fe.required.forEach(te=>Q.add(te));const ce=fe.properties;for(const te of Object.keys(ce)){const pe=W[te];if(pe!=null)J[te]=pe;else if(Q.has(te)){const be=ce[te];if(be.default!==void 0)J[te]=M.deepClone(be.default);else switch(be.type){case"boolean":J[te]=!1;break;case"number":case"integer":J[te]=0;break;case"string":J[te]="";break;default:$.error(r.localize(2,null,JSON.stringify(W,void 0,0),te));return}}}return U.create(J)}R.createTaskIdentifier=K})(L=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[185],Ie([1,0,11]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class y{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((_,A)=>{this._actualOk=_,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(_){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=_,this._actual&&this._actualOk(_))}resolveErr(_){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=_,this._actual?this._actualErr(_):(0,r.onUnexpectedError)(_))}then(_,A){return this._ensureActual().then(_,A)}catch(_){return this._ensureActual().then(void 0,_)}finally(_){return this._ensureActual().finally(_)}}e.LazyPromise=y;class S extends y{constructor(){super(),this._hasErr=!0,this._err=new r.CancellationError}}e.CanceledLazyPromise=S}),define(Ce[40],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const y=[];function S(A){const E=new r(A);return y[E.nid]=E,E}e.createProxyIdentifier=S;function M(A){return y[A].sid}e.getStringIdentifierForProxy=M;class _{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=_}),define(Ce[4],Ie([1,0,40]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var y;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput"})(S=e.TabInputKind||(e.TabInputKind={}));var M;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var _;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(h){return h._id=b._n++,h}}e.IdObject=b,b._n=0;var m;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(m=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var T;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(T=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,r.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,r.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,r.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,r.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,r.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,r.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,r.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,r.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,r.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,r.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,r.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,r.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,r.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,r.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,r.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,r.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,r.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,r.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,r.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,r.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,r.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,r.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,r.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,r.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,r.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,r.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,r.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,r.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,r.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,r.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,r.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,r.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,r.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,r.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,r.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,r.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,r.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,r.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,r.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,r.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,r.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,r.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,r.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,r.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,r.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,r.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,r.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,r.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,r.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,r.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,r.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,r.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,r.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,r.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,r.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,r.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,r.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,r.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,r.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,r.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,r.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,r.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ce[67],Ie([1,0,3,15,4,13]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(S.MainContext.MainThreadTelemetry)}report(E,k,O){const b=this.getUsageKey(E,k);this._reportedUsages.has(b)||(this._reportedUsages.add(b),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};_=ze([$e(0,M.IExtHostRpcService),$e(1,y.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(A,E,k){}})}),define(Ce[186],Ie([1,0,5,4,6,27]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(y.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,k,O,b={}){const m=M.ExtensionIdentifier.toKey(E.identifier),T=this._inFlightRequests.get(m)||[],f=[...O].sort().join(" ");let c=T.find(h=>h.providerId===k&&h.scopes===f);if(c)return c.result;{const h=this._getSession(E,m,k,O,b);c={providerId:k,scopes:f,result:h},T.push(c),this._inFlightRequests.set(m,T);try{await h}finally{const u=T.findIndex(v=>v.providerId===k&&v.scopes===f);u>-1&&(T.splice(u),this._inFlightRequests.set(m,T))}return h}}async _getSession(E,k,O,b,m={}){await this._proxy.$ensureProvider(O);const T=E.displayName||E.name;return this._proxy.$getSession(O,b,k,T,m)}async removeSession(E,k){const O=this._authenticationProviders.get(E);return O?O.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,O,b){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:O,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(T=>T.id===E)||this._providers.push({id:E,label:k});const m=O.onDidChangeSessions(T=>{this._proxy.$sendDidChangeSessions(E,{added:T.added??[],changed:T.changed??[],removed:T.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,k,b?.supportsMultipleAccounts??!1),new S.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const T=this._providers.findIndex(f=>f.id===E);T>-1&&this._providers.splice(T),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const O=this._authenticationProviders.get(E);if(O)return Promise.resolve(O.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(Ce[187],Ie([1,0,4,13,8,25]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let _=class{constructor(E,k){this._proxy=E.getProxy(r.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:O=>k.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,k,O){const b=(0,M.isProposedApiEnabled)(k,"workspaceEditIsRefactoring");O&&!b&&(console.warn(`Extension '${k.identifier.value}' uses a proposed API 'workspaceEditIsRefactoring' which is NOT enabled for it`),O=void 0);const m=S.WorkspaceEdit.from(E,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(m,void 0,O)}};_=ze([$e(0,y.IExtHostRpcService)],_),e.ExtHostBulkEdits=_}),define(Ce[188],Ie([1,0,4]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class y{constructor(M){const _=M.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(A){return _.$writeText(A)}})}}e.ExtHostClipboard=y});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[36],Ie([1,0,10,6,8,26,4,16,15,75,49,242,2,7,3,13,94,23,40,43]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I){"use strict";var l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let t=class{constructor(o,g){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,w.set(this,void 0),Je(this,l,o.getProxy(_.MainContext.MainThreadCommands),"f"),this._logService=g,Je(this,w,o.getProxy(_.MainContext.MainThreadTelemetry),"f"),this.converter=new d(this,p=>{const P=this._apiCommands.get(p);return P?.result===n.Void?P:void 0},g),this._argumentProcessors=[{processArgument(p){return(0,k.revive)(p)}},{processArgument(p){return(0,M.cloneAndChange)(p,function(P){if(O.Range.isIRange(P))return S.Range.to(P);if(b.Position.isIPosition(P))return S.Position.to(P);if(O.Range.isIRange(P.range)&&m.URI.isUri(P.uri))return S.location.to(P);if(P instanceof u.VSBuffer)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const g=this.registerCommand(!1,o.id,async(...p)=>{const P=o.args.map((V,U)=>{if(!V.validate(p[U]))throw new Error(`Invalid argument '${V.name}' when running '${o.id}', received: ${p[U]}`);return V.convert(p[U])}),N=await this.executeCommand(o.internalId,...P);return o.result.convert(N,p,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new y.Disposable(()=>{g.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,g,p,P,N,V){if(this._logService.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this._commands.has(g))throw new Error(`command '${g}' already exists`);return this._commands.set(g,{callback:p,thisArg:P,description:N,extension:V}),o&&Oe(this,l,"f").$registerCommand(g),new y.Disposable(()=>{this._commands.delete(g)&&o&&Oe(this,l,"f").$unregisterCommand(g)})}executeCommand(o,...g){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,g,!0)}async _doExecuteCommand(o,g,p){if(this._commands.has(o))return Oe(this,l,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,g,!1);{let P=!1;const N=(0,M.cloneAndChange)(g,function(V){if(V instanceof y.Position)return S.Position.from(V);if(V instanceof y.Range)return S.Range.from(V);if(V instanceof y.Location)return S.location.from(V);if(y.NotebookRange.isNotebookRange(V))return S.NotebookRange.from(V);if(V instanceof ArrayBuffer)return P=!0,u.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return P=!0,u.VSBuffer.wrap(V);if(V instanceof u.VSBuffer)return P=!0,V;if(!Array.isArray(V))return V});try{const V=await Oe(this,l,"f").$executeCommand(o,P?new v.SerializableObjectWithBuffers(N):N,p);return(0,k.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(o,g,!1);throw V}}}async _executeContributedCommand(o,g,p){const P=this._commands.get(o);if(!P)throw new Error("Unknown command");this._reportTelemetry(P,o);const{callback:N,thisArg:V,description:U}=P;if(U)for(let D=0;D<U.args.length;D++)try{(0,r.validateConstraint)(g[D],U.args[D].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${U.args[D].name}' - ${U.args[D].description}`)}try{return await N.apply(V,g)}catch(D){if(o===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...g);x&&(o=x.command)}throw this._logService.error(D,o,P.extension?.identifier),p?new class extends Error{constructor(){super((0,I.toErrorMessage)(D)),this.id=o,this.source=P.extension?.displayName??P.extension?.name}}:D}}_reportTelemetry(o,g){!o.extension||o.extension.isBuiltin||Oe(this,w,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:g})}$executeContributedCommand(o,...g){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(g=g.map(p=>this._argumentProcessors.reduce((P,N)=>N.processArgument(P),p)),this._executeContributedCommand(o,g,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Oe(this,l,"f").$getCommands().then(g=>(o&&(g=g.filter(p=>p[0]!=="_")),g))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[g,p]of this._commands){const{description:P}=p;P&&(o[g]=P)}return Promise.resolve(o)}};l=new WeakMap,w=new WeakMap,t=ze([$e(0,c.IExtHostRpcService),$e(1,E.ILogService)],t),e.ExtHostCommands=t,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class d{constructor(o,g,p){this._commands=o,this._lookupApiCommand=g,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,g){if(!o)return;const p={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return p;const P=this._lookupApiCommand(o.command);if(P)p.id=P.internalId,p.arguments=P.args.map((N,V)=>N.convert(o.arguments&&o.arguments[V]));else if((0,A.isNonEmptyArray)(o.arguments)){const N=++this._cachIdPool;this._cache.set(N,o),g.add((0,T.toDisposable)(()=>{this._cache.delete(N),this._logService.trace("CommandsConverter#DISPOSE",N)})),p.$ident=N,p.id=this.delegatingCommandId,p.arguments=[N],this._logService.trace("CommandsConverter#CREATE",o.command,N)}return p}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const g=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],g?g.command:"MISSING"),g?this._commands.executeCommand(g.command,...g.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=d;class i{constructor(o,g,p,P){this.name=o,this.description=g,this.validate=p,this.convert=P}optional(){return new i(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,g){return new i(o??this.name,g??this.description,this.validate,this.convert)}}e.ApiCommandArgument=i,i.Uri=new i("uri","Uri of a text document",a=>m.URI.isUri(a),a=>a),i.Position=new i("position","A position in a text document",a=>y.Position.isPosition(a),S.Position.from),i.Range=new i("range","A range in a text document",a=>y.Range.isRange(a),S.Range.from),i.Selection=new i("selection","A selection in a text document",a=>y.Selection.isSelection(a),S.Selection.from),i.Number=new i("number","",a=>typeof a=="number",a=>a),i.String=new i("string","",a=>typeof a=="string",a=>a),i.CallHierarchyItem=new i("item","A call hierarchy item",a=>a instanceof y.CallHierarchyItem,S.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",a=>a instanceof y.TypeHierarchyItem,S.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",a=>a instanceof h.TestItemImpl,S.TestItem.from);class n{constructor(o,g){this.description=o,this.convert=g}}e.ApiCommandResult=n,n.Void=new n("no result",a=>a);class s{constructor(o,g,p,P,N){this.id=o,this.internalId=g,this.description=p,this.args=P,this.result=N}}e.ApiCommand=s}),define(Ce[189],Ie([1,0,2,8,6,66,36,16,78,82,12]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",T(y.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,h)=>{if((0,A.isFalsyOrEmpty)(c))return;class u extends S.SymbolInformation{static to(I){const l=new u(I.name,y.SymbolKind.to(I.kind),I.containerName||"",new S.Location(h[0],y.Range.to(I.range)));return l.detail=I.detail,l.range=l.location.range,l.selectionRange=y.Range.to(I.selectionRange),l.children=I.children?I.children.map(u.to):[],l}}return c.map(u.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(y.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new _.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",T(y.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",T(y.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",T(y.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(h=>S.Position.isPosition(h)),c=>c.map(y.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(h=>{let u;for(const v of h.reverse())u=new S.SelectionRange(y.Range.to(v),u);return u}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(y.WorkspaceSymbol.to))),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(y.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:y.Range.to(c.range),placeholder:c.text}})),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return y.WorkspaceEdit.to(c)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(y.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new S.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,E.decodeSemanticTokensDto)(c);if(h.type==="full")return new S.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range.optional()],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new S.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const h=(0,E.decodeSemanticTokensDto)(c);if(h.type==="full")return new S.SemanticTokens(h.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,h,u)=>{if(!c)return new S.CompletionList([]);const v=c.suggestions.map(I=>y.CompletionItem.to(I,u));return new S.CompletionList(v,c.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return y.SignatureHelp.to(c)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,h,u)=>T(v=>new S.CodeLens(y.Range.to(v.range),v.command&&u.fromInternal(v.command)))(c))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>S.Range.isRange(c),c=>S.Selection.isSelection(c)?y.Selection.from(c):y.Range.from(c)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,h,u)=>T(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return u.fromInternal(v.command)}else{const I=new S.CodeAction(v.title,v.kind?new S.CodeActionKind(v.kind):void 0);return v.edit&&(I.edit=y.WorkspaceEdit.to(v.edit)),v.command&&(I.command=u.fromInternal(v.command)),I.isPreferred=v.isPreferred,I}})(c))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(h=>new S.ColorInformation(y.Range.to(h.range),y.Color.to(h.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",c=>c instanceof S.Color,y.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:y.Range.from(c.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(y.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",(c,h,u)=>c.map(y.InlayHint.to.bind(void 0,u)))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",T(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(h=>y.NotebookExclusiveDocumentPattern.to(h))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(y.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new _.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",c=>r.URI.isUri(c)||typeof c=="string"&&(0,k.matchesSomeScheme)(c,O.Schemas.http,O.Schemas.https),c=>c),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[y.ViewColumn.from(c),void 0]:[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[y.ViewColumn.from(c.viewColumn),y.TextEditorOpenOptions.from(c)]).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[_.ApiCommandArgument.TypeHierarchyItem],new _.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(y.TypeHierarchyItem.to))),new _.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[_.ApiCommandArgument.TestItem],_.ApiCommandResult.Void),new _.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[_.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],_.ApiCommandResult.Void)];class m{static register(h){b.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=m;function T(c){return h=>{if(Array.isArray(h))return h.map(c)}}function f(c){if(!Array.isArray(c))return;const h=[];for(const u of c)M.isLocationLink(u)?h.push(y.DefinitionLink.to(u)):h.push(y.location.to(u));return h}}),define(Ce[190],Ie([1,0,14,55,5,7,2,66,27,8,6,25,4]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function T(f,c,h){const u=f.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,c.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const o=this._commentControllers.get(a.handle);return o?o.value:a}else if(a&&a.$mid===7){const o=this._commentControllers.get(a.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.commentThreadHandle);return g?g.value:a}else if(a&&a.$mid===8){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.thread.commentThreadHandle);return g?{thread:g.value,text:a.text}:a}else if(a&&a.$mid===9){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.thread.commentThreadHandle);if(!g)return a;const p=a.commentUniqueId,P=g.getCommentByUniqueId(p);return P||a}else if(a&&a.$mid===10){const o=this._commentControllers.get(a.thread.commentControlHandle);if(!o)return a;const g=o.getCommentThread(a.thread.commentThreadHandle);if(!g)return a;const p=a.text,P=a.commentUniqueId,N=g.getCommentByUniqueId(P);return N?(typeof N.body=="string"?N.body=p:N.body.value=p,N):a}return a}})}createCommentController(a,o,g){const p=v.handlePool++,P=new l(a,p,o,g);this._commentControllers.set(P.handle,P);const N=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(a.identifier))||[];return N.push(P),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(a.identifier),N),P.value}$createCommentThreadTemplate(a,o,g){const p=this._commentControllers.get(a);!p||p.$createCommentThreadTemplate(o,g)}async $updateCommentThreadTemplate(a,o,g){const p=this._commentControllers.get(a);!p||p.$updateCommentThreadTemplate(o,g)}$deleteCommentThread(a,o){this._commentControllers.get(a)?.$deleteCommentThread(o)}$provideCommentingRanges(a,o,g){const p=this._commentControllers.get(a);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const P=h.getDocument(_.URI.revive(o));return(0,r.asPromise)(()=>p.commentingRangeProvider.provideCommentingRanges(P,g)).then(N=>N?N.map(V=>k.Range.from(V)):void 0)}$toggleReaction(a,o,g,p,P){const N=this._commentControllers.get(a);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const V=N.getCommentThread(o);if(V){const U=V.getCommentByUniqueId(p.uniqueIdInThread);if(N!==void 0&&U&&N.reactionHandler)return N.reactionHandler(U,d(P))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class I{constructor(a,o,g,p,P,N,V,U){this._commentControllerHandle=o,this._id=g,this._uri=p,this._range=P,this._comments=N,this.extensionDescription=V,this._isTemplate=U,this.handle=I._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${a}.${this.handle}`),u.$createCommentThread(o,this.handle,this._id,this._uri,k.Range.from(this._range),V.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this._localDisposables.push({dispose:()=>{u.$deleteCommentThread(o,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(x){D.range=x},get comments(){return D.comments},set comments(x){D.comments=x},get collapsibleState(){return D.collapsibleState},set collapsibleState(x){D.collapsibleState=x},get canReply(){return D.canReply},set canReply(x){D.canReply=x},get contextValue(){return D.contextValue},set contextValue(x){D.contextValue=x},get label(){return D.label},set label(x){D.label=x},get state(){return D.state},set state(x){D.state=x},dispose:()=>{D.dispose()}}}set threadId(a){this._id=a}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(a){a.isEqual(this._range)||(this._range=a,this.modifications.range=a,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(a){this._canReply!==a&&(this._canReply=a,this.modifications.canReply=a,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(a){this._label=a,this.modifications.label=a,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(a){this._contextValue=a,this.modifications.contextValue=a,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(a){this._comments=a,this.modifications.comments=a,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(a){this._collapseState=a,this.modifications.collapsibleState=a,this._onDidUpdateCommentThread.fire()}get state(){return(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(a){(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=a,this.modifications.state=a,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const a=g=>Object.prototype.hasOwnProperty.call(this.modifications,g),o={};a("range")&&(o.range=k.Range.from(this._range)),a("label")&&(o.label=this.label),a("contextValue")&&(o.contextValue=this.contextValue??null),a("comments")&&(o.comments=this._comments.map(g=>w(this,g,this._commentsMap))),a("collapsibleState")&&(o.collapseState=i(this._collapseState)),a("canReply")&&(o.canReply=this.canReply),a("state")&&(o.state=n(this._state)),a("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},u.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(a){for(const o of this._commentsMap){const g=o[0],p=o[1];if(a===p)return g}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(a=>a.dispose())}}I._handlePool=0,ze([(0,y.debounce)(100)],I.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(a,o,g,p){this._extension=a,this._handle=o,this._id=g,this._label=p,this._threads=new Map,u.$registerCommentController(this.handle,g,p);const P=this;this.value=Object.freeze({id:P.id,label:P.label,get options(){return P.options},set options(N){P.options=N},get commentingRangeProvider(){return P.commentingRangeProvider},set commentingRangeProvider(N){P.commentingRangeProvider=N},get reactionHandler(){return P.reactionHandler},set reactionHandler(N){P.reactionHandler=N},createCommentThread(N,V,U){return P.createCommentThread(N,V,U).value},dispose:()=>{P.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(a){this._commentingRangeProvider=a,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(a){this._reactionHandler=a,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this._options}set options(a){this._options=a,u.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(a,o,g,p){if(typeof a=="string"){const P=new I(this.id,this.handle,a,o,g,p,this._extension,!1);return this._threads.set(P.handle,P),P}else{const P=new I(this.id,this.handle,void 0,a,o,g,this._extension,!1);return this._threads.set(P.handle,P),P}}$createCommentThreadTemplate(a,o){const g=new I(this.id,this.handle,void 0,_.URI.revive(a),k.Range.to(o),[],this._extension,!0);return g.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(g.handle,g),g}$updateCommentThreadTemplate(a,o){const g=this._threads.get(a);g&&(g.range=k.Range.to(o))}$deleteCommentThread(a){this._threads.get(a)?.dispose(),this._threads.delete(a)}getCommentThread(a){return this._threads.get(a)}dispose(){this._threads.forEach(a=>{a.dispose()}),this._localDisposables.forEach(a=>a.dispose())}}function w(s,a,o){let g=o.get(a);g||(g=++s.commentHandle,o.set(a,g));const p=a.author&&a.author.iconPath?a.author.iconPath.toString():void 0;return{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:g,body:typeof a.body=="string"?a.body:k.MarkdownString.from(a.body),userName:a.author.name,userIconPath:p,label:a.label,commentReactions:a.reactions?a.reactions.map(P=>t(P)):void 0,timestamp:a.timestamp?.toJSON()}}function t(s){return{label:s.label,iconPath:s.iconPath?k.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function d(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?_.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function i(s){if(s!==void 0)switch(s){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function n(s){if(s!==void 0)switch(s){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new v}e.createExtHostComments=T}),define(Ce[191],Ie([1,0,26,4,28,13]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let _=class{constructor(O,b){this._mainThreadConsole=O.getProxy(y.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,b){const m=this,T=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){m._handleConsoleCall(O,b,T,arguments)}})}_handleConsoleCall(O,b,m,T){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:E(T,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,m,T)}};_=ze([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],_),e.AbstractExtHostConsoleForwarder=_;const A=1e5;function E(k,O){const b=[];if(k.length)for(let m=0;m<k.length;m++){let T=k[m];if(typeof T>"u")T="undefined";else if(T instanceof Error){const f=T;f.stack?T=f.stack:T=f.toString()}b.push(T)}if(O){const m=new Error().stack;m&&b.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,r.safeStringify)(b);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[96],Ie([1,0,2,4,6,3,13,15,16,9,19]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class Pi{constructor(T,f){this._logService=f,this._provider=new Map,this._proxy=T.getProxy(y.MainContext.MainThreadDecorations)}registerFileDecorationProvider(T,f){const c=Pi._handlePool++;this._provider.set(c,{provider:T,extensionId:f}),this._proxy.$registerDecorationProvider(c,f.value);const h=T.onDidChangeFileDecorations&&T.onDidChangeFileDecorations(u=>{if(!u){this._proxy.$onDidChange(c,null);return}const v=(0,E.asArray)(u);if(v.length<=Pi._maxEventSize){this._proxy.$onDidChange(c,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,v.length);const I=v.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),l=(0,E.groupBy)(I,(t,d)=>t.rank-d.rank||(0,k.compare)(t.uri.path,d.uri.path)),w=[];e:for(const t of l){let d;for(const i of t){const n=(0,O.dirname)(i.uri.path);if(d!==n&&(d=n,w.push(i.uri)>=Pi._maxEventSize))break e}}this._proxy.$onDidChange(c,w)});return new S.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(T,f,c){if(!this._provider.has(T))return Object.create(null);const h=Object.create(null),{provider:u,extensionId:v}=this._provider.get(T);return await Promise.all(f.map(async I=>{try{const{uri:l,id:w}=I,t=await Promise.resolve(u.provideFileDecoration(r.URI.revive(l),c));if(!t)return;try{S.FileDecoration.validate(t),h[w]=[t.propagate,t.tooltip,t.badge,t.color]}catch(d){this._logService.warn(`INVALID decoration from extension '${v.value}': ${d}`)}}catch(l){this._logService.error(l)}})),h}};b._handlePool=0,b._maxEventSize=250,b=ze([$e(0,_.IExtHostRpcService),$e(1,A.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[192],Ie([1,0,129,81,2,4,6,8,5,15,24,35]),function(ne,e,r,y,S,M,_,A,E,k,O,b){"use strict";var m,T,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(v,I,l,w,t,d){this._name=v,this._owner=I,this._maxDiagnosticsPerFile=l,m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Je(this,f,new O.ResourceMap(i=>w.getComparisonKey(i)),"f"),Je(this,m,t,"f"),Je(this,T,d,"f")}dispose(){this._isDisposed||(Oe(this,T,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,I){if(!v){this.clear();return}this._checkDisposed();let l=[];if(S.URI.isUri(v)){if(!I){this.delete(v);return}Oe(this,f,"f").set(v,I.slice()),l=[v]}else if(Array.isArray(v)){l=[];let t;v=[...v].sort(c._compareIndexedTuplesByUri);for(const d of v){const[i,n]=d;if((!t||i.toString()!==t.toString())&&(t&&Oe(this,f,"f").get(t).length===0&&Oe(this,f,"f").delete(t),t=i,l.push(i),Oe(this,f,"f").set(i,[])),n)Oe(this,f,"f").get(i)?.push(...n);else{const s=Oe(this,f,"f").get(i);s&&(s.length=0)}}}if(Oe(this,T,"f").fire(l),!Oe(this,m,"f"))return;const w=[];for(const t of l){let d=[];const i=Oe(this,f,"f").get(t);if(i)if(i.length>this._maxDiagnosticsPerFile){d=[];const n=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const a of i)if(a.severity===n[s]&&d.push(A.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;d.push({severity:y.MarkerSeverity.Info,message:(0,r.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=i.map(n=>A.Diagnostic.from(n));w.push([t,d])}Oe(this,m,"f").$changeMany(this._owner,w)}delete(v){this._checkDisposed(),Oe(this,T,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,m,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Oe(this,T,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(v,I){this._checkDisposed();for(const[l,w]of this)v.call(I,l,w,this)}*[(m=new WeakMap,T=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const I=Oe(this,f,"f").get(v);return Array.isArray(I)?Object.freeze(I.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,I){return v[0].toString()<I[0].toString()?-1:v[0].toString()>I[0].toString()?1:0}}e.DiagnosticCollection=c;let h=class mi{constructor(v,I,l){this._logService=I,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:w=>w.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,mi._mapper),this._proxy=v.getProxy(M.MainContext.MainThreadDiagnostics)}static _mapper(v){const I=new O.ResourceMap;for(const l of v)I.set(l,l);return{uris:Object.freeze(Array.from(I.values()))}}createDiagnosticCollection(v,I){const{_collections:l,_proxy:w,_onDidChangeDiagnostics:t,_logService:d,_fileSystemInfoService:i}=this,n=new class{$changeMany(o,g){w.$changeMany(o,g),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,o,g.length===0?"CLEARING":g)}$clear(o){w.$clear(o),d.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,o)}dispose(){w.dispose()}};let s;if(!I)I="_generated_diagnostic_collection_name_#"+mi._idPool++,s=I;else if(!l.has(I))s=I;else{this._logService.warn(`DiagnosticCollection with name '${I}' does already exist.`);do s=I+mi._idPool++;while(l.has(s))}return new class extends c{constructor(){super(I,s,mi._maxDiagnosticsPerFile,i.extUri,n,t),l.set(s,this)}dispose(){super.dispose(),l.delete(s)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const I=new Map,l=[];for(const w of this._collections.values())w.forEach((t,d)=>{let i=I.get(t.toString());typeof i>"u"&&(i=l.length,I.set(t.toString(),i),l.push([t,[]])),l[i][1]=l[i][1].concat(...d)});return l}}_getDiagnostics(v){let I=[];for(const l of this._collections.values())l.has(v)&&(I=I.concat(l.get(v)));return I}$acceptMarkersChange(v){if(!this._mirrorCollection){const I="_generated_mirror",l=new c(I,I,mi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(I,l),this._mirrorCollection=l}for(const[I,l]of v)this._mirrorCollection.set(S.URI.revive(I),l.map(A.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=ze([$e(1,k.ILogService),$e(2,b.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(Ce[193],Ie([1,0,2,4]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(_){this._proxy=_.getProxy(y.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(A=>A?A.map(E=>r.URI.revive(E)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(A=>A?r.URI.revive(A):void 0)}}e.ExtHostDialogs=S}),define(Ce[194],Ie([1,0,11,2,6,4,12,20,9]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(b,m,T){this._documentsAndEditors=m,this._logService=T,this._documentContentProviders=new Map,this._proxy=b.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,m){if(Object.keys(_.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const T=k._handlePool++;this._documentContentProviders.set(T,m),this._proxy.$registerTextContentProvider(T,b);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(c=>{if(c.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(T,c).then(h=>{if(!h&&typeof h!="string")return;const u=this._documentsAndEditors.getDocument(c);if(!u)return;const v=(0,E.splitLines)(h);if(!u.equalLines(v))return this._proxy.$onVirtualDocumentChange(c,h)},r.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(T)&&this._proxy.$unregisterTextContentProvider(T),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(b,m){const T=this._documentContentProviders.get(b);return T?Promise.resolve(T.provideTextDocumentContent(y.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(Ce[195],Ie([1,0,5,7,2,4,92,8,10,26,6]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(T,f){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new y.DisposableStore,this._documentLoader=new Map,this._proxy=T.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const h of c)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const h of c)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(T){if(!T)return;const f=this._documentsAndEditors.getDocument(T);if(f)return f}getDocument(T){const f=this.getDocumentData(T);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return f.document}ensureDocumentData(T){const f=this._documentsAndEditors.getDocument(T);if(f)return Promise.resolve(f);let c=this._documentLoader.get(T.toString());return c||(c=this._proxy.$tryOpenDocument(T).then(h=>{this._documentLoader.delete(T.toString());const u=S.URI.revive(h);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(u))},h=>(this._documentLoader.delete(T.toString()),Promise.reject(h))),this._documentLoader.set(T.toString(),c)),c}createDocumentData(T){return this._proxy.$tryCreateDocument(T).then(f=>S.URI.revive(f))}$acceptModelLanguageChanged(T,f){const c=S.URI.revive(T),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(f),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(T){const f=S.URI.revive(T),c=this._documentsAndEditors.getDocument(f);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(T,f){const c=S.URI.revive(T),h=this._documentsAndEditors.getDocument(c);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,f,c){const h=S.URI.revive(T),u=this._documentsAndEditors.getDocument(h);if(!u)throw new Error("unknown document");u._acceptIsDirty(c),u.onEvents(f);let v;f.isUndoing?v=O.TextDocumentChangeReason.Undo:f.isRedoing&&(v=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:u.document,contentChanges:f.changes.map(I=>({range:A.Range.to(I.range),rangeOffset:I.rangeOffset,rangeLength:I.rangeLength,text:I.text})),reason:v}))}setWordDefinitionFor(T,f){(0,_.setWordDefinitionFor)(T,f)}}e.ExtHostDocuments=b}),define(Ce[50],Ie([1,0,44,5,7,2,3,4,92,13,95,8,15,24,12,165,196]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class u{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let v=class{constructor(l,w){this._extHostRpc=l,this._logService=w,this._activeEditorId=null,this._editors=new Map,this._documents=new T.ResourceMap,this._onDidAddDocuments=new y.Emitter,this._onDidRemoveDocuments=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const w=[],t=[],d=[];if(l.removedDocuments)for(const i of l.removedDocuments){const n=M.URI.revive(i),s=this._documents.get(n);s?.unref()&&(this._documents.delete(n),w.push(s.value))}if(l.addedDocuments)for(const i of l.addedDocuments){const n=M.URI.revive(i.uri);let s=this._documents.get(n);if(s&&n.scheme!==f.Schemas.vscodeNotebookCell&&n.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);s||(s=new u(new E.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),n,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(n,s),t.push(s.value)),s.ref()}if(l.removedEditors)for(const i of l.removedEditors){const n=this._editors.get(i);this._editors.delete(i),n&&d.push(n)}if(l.addedEditors)for(const i of l.addedEditors){const n=M.URI.revive(i.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const s=this._documents.get(n).value,a=new O.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>s.document),i.selections.map(b.Selection.to),i.options,i.visibleRanges.map(o=>b.Range.to(o)),typeof i.editorPosition=="number"?b.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,a)}l.newActiveEditor!==void 0&&(r.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,S.dispose)(w),(0,S.dispose)(d),l.removedDocuments&&this._onDidRemoveDocuments.fire(w),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const w=this._editors.get(this._activeEditorId);return l?w:w?.value}allEditors(){return[...this._editors.values()]}};v=ze([$e(0,k.IExtHostRpcService),$e(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[51],Ie([1,0,8,4,2,5,3,6,13,10,72]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,_.createDecorator)("IExtHostEditorTabs");class b{constructor(h,u,v){this._activeTabIdGetter=v,this._parentGroup=u,this.acceptDtoUpdate(h)}get apiObject(){if(!this._apiObject){const h=this,u={get isActive(){return h._dto.id===h._activeTabIdGetter()},get label(){return h._dto.label},get input(){return h._input},get isDirty(){return h._dto.isDirty},get isPinned(){return h._dto.isPinned},get isPreview(){return h._dto.isPreview},get group(){return h._parentGroup.apiObject}};this._apiObject=Object.freeze(u)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(h){this._dto=h,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(S.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(S.URI.revive(this._dto.input.base),S.URI.revive(this._dto.input.input1),S.URI.revive(this._dto.input.input2),S.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(S.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(S.URI.revive(this._dto.input.original),S.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(S.URI.revive(this._dto.input.uri),S.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(h,u){this._tabs=[],this._activeTabId="",this._dto=h,this._activeGroupIdGetter=u;for(const v of h.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new b(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const h=this,u={get isActive(){return h._dto.groupId===h._activeGroupIdGetter()},get viewColumn(){return r.ViewColumn.to(h._dto.viewColumn)},get activeTab(){return h._tabs.find(v=>v.tabId===h._activeTabId)?.apiObject},get tabs(){return Object.freeze(h._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(u)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(h){this._dto=h}acceptTabOperation(h){if(h.kind===0){const v=new b(h.tabDto,this,()=>this.activeTabId());return this._tabs.splice(h.index,0,v),h.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(h.kind===1){const v=this._tabs.splice(h.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(h.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this._tabs.splice(h.index,0,v),v}const u=this._tabs.find(v=>v.tabId===h.tabDto.id);if(!u)throw new Error("INVALID tab");return h.tabDto.isActive?this._activeTabId=h.tabDto.id:this._activeTabId===h.tabDto.id&&!h.tabDto.isActive&&(this._activeTabId=""),u.acceptDtoUpdate(h.tabDto),u}activeTabId(){return this._activeTabId}}let T=class{constructor(h){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=h.getProxy(y.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const h=this,u={onDidChangeTabGroups:h._onDidChangeTabGroups.event,onDidChangeTabs:h._onDidChangeTabs.event,get all(){return Object.freeze(h._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=h._activeGroupId;return(0,k.assertIsDefined)(h._extHostTabGroups.find(l=>l.groupId===v)?.apiObject)},close:async(v,I)=>{const l=Array.isArray(v)?v:[v];return l.length?f(l[0])?this._closeGroups(l,I):this._closeTabs(l,I):!0}};this._apiObject=Object.freeze(u)}return this._apiObject}$acceptEditorTabModel(h){const u=new Set(this._extHostTabGroups.map(i=>i.groupId)),v=new Set(h.map(i=>i.groupId)),I=(0,O.diffSets)(u,v),l=this._extHostTabGroups.filter(i=>I.removed.includes(i.groupId)).map(i=>i.apiObject),w=[],t=[];this._extHostTabGroups=h.map(i=>{const n=new m(i,()=>this._activeGroupId);return I.added.includes(n.groupId)?w.push(n.apiObject):t.push(n.apiObject),n});const d=(0,k.assertIsDefined)(h.find(i=>i.isActive===!0)?.groupId);d!==void 0&&this._activeGroupId!==d&&(this._activeGroupId=d),this._onDidChangeTabGroups.fire(Object.freeze({opened:w,closed:l,changed:t}))}$acceptTabGroupUpdate(h){const u=this._extHostTabGroups.find(v=>v.groupId===h.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(h),h.isActive&&(this._activeGroupId=h.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const u=this._extHostTabGroups.find(I=>I.groupId===h.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const v=u.acceptTabOperation(h);switch(h.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(h){for(const u of this._extHostTabGroups)for(const v of u.tabs)if(v.apiObject===h)return v}_findExtHostTabGroupFromApi(h){return this._extHostTabGroups.find(u=>u.apiObject===h)}async _closeTabs(h,u){const v=[];for(const I of h){const l=this._findExtHostTabFromApi(I);if(!l)throw new Error("Tab close: Invalid tab not found!");v.push(l.tabId)}return this._proxy.$closeTab(v,u)}async _closeGroups(h,u){const v=[];for(const I of h){const l=this._findExtHostTabGroupFromApi(I);if(!l)throw new Error("Group close: Invalid group not found!");v.push(l.groupId)}return this._proxy.$closeGroup(v,u)}};T=ze([$e(0,E.IExtHostRpcService)],T),e.ExtHostEditorTabs=T;function f(c){return c.tabs!==void 0}}),define(Ce[197],Ie([1,0,2,4,7,6,8,243,9,23,25]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const c=this._schemes.indexOf(f);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),c=[];let h,u,v=14,I=14;for(const l of f){let w=h?(0,E.commonPrefixLength)(h,l):0;for(w===0?u=1:u=I;w<l.length;w++)w+1===l.length?(v=I,I=9):I+=1,c.push([u,l.toUpperCase().charCodeAt(w),I]),c.push([u,l.toLowerCase().charCodeAt(w),I]),u=I;h=l,I=v}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new A.StateMachine(c)}}provideDocumentLinks(f){this._initStateMachine();const c=[],h=A.LinkComputer.computeLinks({getLineContent(u){return f.lineAt(u-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const u of h){const v=_.DocumentLink.to(u);v.target&&c.push(v)}return c}}class m{constructor(f,c){this._extHostLanguageFeatures=c,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(y.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,c,h,u={}){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(v,h);let I=2;u.isCaseSensitive&&(I+=1024),u.isReadonly&&(I+=2048),typeof h.copy=="function"&&(I+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,O.checkProposedApiEnabled)(f,"fsChunks"),I+=4),this._proxy.$registerFileSystemProvider(v,c,I).catch(w=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${c}`),console.error(w)});const l=h.onDidChangeFile(w=>{const t=[];for(const d of w){const{uri:i,type:n}=d;if(i.scheme!==c)continue;let s;switch(n){case M.FileChangeType.Changed:s=0;break;case M.FileChangeType.Created:s=1;break;case M.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:i,type:s})}this._proxy.$onFileSystemChange(v,t)});return(0,S.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(f){const{type:c,ctime:h,mtime:u,size:v,permissions:I}=f;return{type:c,ctime:h,mtime:u,size:v,permissions:I}}$stat(f,c){return Promise.resolve(this._getFsProvider(f).stat(r.URI.revive(c))).then(h=>m._asIStat(h))}$readdir(f,c){return Promise.resolve(this._getFsProvider(f).readDirectory(r.URI.revive(c)))}$readFile(f,c){return Promise.resolve(this._getFsProvider(f).readFile(r.URI.revive(c))).then(h=>k.VSBuffer.wrap(h))}$writeFile(f,c,h,u){return Promise.resolve(this._getFsProvider(f).writeFile(r.URI.revive(c),h.buffer,u))}$delete(f,c,h){return Promise.resolve(this._getFsProvider(f).delete(r.URI.revive(c),h))}$rename(f,c,h,u){return Promise.resolve(this._getFsProvider(f).rename(r.URI.revive(c),r.URI.revive(h),u))}$copy(f,c,h,u){const v=this._getFsProvider(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(r.URI.revive(c),r.URI.revive(h),u))}$mkdir(f,c){return Promise.resolve(this._getFsProvider(f).createDirectory(r.URI.revive(c)))}$watch(f,c,h,u){const v=this._getFsProvider(f).watch(r.URI.revive(h),u);this._watches.set(c,v)}$unwatch(f,c){const h=this._watches.get(c);h&&(h.dispose(),this._watches.delete(c))}$open(f,c,h){const u=this._getFsProvider(f);if(!u.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(u.open(r.URI.revive(c),h))}$close(f,c){const h=this._getFsProvider(f);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(c))}$read(f,c,h,u){const v=this._getFsProvider(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const I=k.VSBuffer.alloc(u);return Promise.resolve(v.read(c,h,I.buffer,0,u)).then(l=>I.slice(0,l))}$write(f,c,h,u){const v=this._getFsProvider(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(c,h,u.buffer,0,u.byteLength))}_getFsProvider(f){const c=this._fsProvider.get(f);if(!c){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return c}}e.ExtHostFileSystem=m}),define(Ce[52],Ie([1,0,4,39,6,23,3,13,35,7]),function(ne,e,r,y,S,M,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Qt{constructor(m,T){this._fileSystemProvider=new Map,this._proxy=m.getProxy(r.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(c){try{const h=f._fileSystemProvider.get(c.scheme);if(!h)return await f._proxy.$stat(c);await f._proxy.$ensureActivation(c.scheme);const u=await h.stat(c);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions}}catch(h){Qt._handleError(h)}},async readDirectory(c){try{const h=f._fileSystemProvider.get(c.scheme);return h?(await f._proxy.$ensureActivation(c.scheme),(await h.readDirectory(c)).slice()):await f._proxy.$readdir(c)}catch(h){return Qt._handleError(h)}},async createDirectory(c){try{return await f._proxy.$mkdir(c)}catch(h){return Qt._handleError(h)}},async readFile(c){try{const h=f._fileSystemProvider.get(c.scheme);return h?(await f._proxy.$ensureActivation(c.scheme),(await h.readFile(c)).slice()):(await f._proxy.$readFile(c)).buffer}catch(h){return Qt._handleError(h)}},async writeFile(c,h){try{return await f._proxy.$writeFile(c,M.VSBuffer.wrap(h))}catch(u){return Qt._handleError(u)}},async delete(c,h){try{const u=f._fileSystemProvider.get(c.scheme);return u?(await f._proxy.$ensureActivation(c.scheme),await u.delete(c,{recursive:!1,...h})):await f._proxy.$delete(c,{recursive:!1,useTrash:!1,...h})}catch(u){return Qt._handleError(u)}},async rename(c,h,u){try{return await f._proxy.$rename(c,h,{overwrite:!1,...u})}catch(v){return Qt._handleError(v)}},async copy(c,h,u){try{return await f._proxy.$copy(c,h,{overwrite:!1,...u})}catch(v){return Qt._handleError(v)}},isWritableFileSystem(c){const h=T.getCapabilities(c);if(typeof h=="number")return!(h&2048)}})}static _handleError(m){if(m instanceof S.FileSystemError)throw m;if(!(m instanceof Error))throw new S.FileSystemError(String(m));if(m.name==="ENOPRO")throw S.FileSystemError.Unavailable(m.message);switch(m.name){case y.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(m.message);case y.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(m.message);case y.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(m.message);case y.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(m.message);case y.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(m.message);case y.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(m.message);default:throw new S.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,T){return this._fileSystemProvider.set(m,T),(0,k.toDisposable)(()=>this._fileSystemProvider.delete(m))}};O=ze([$e(0,A.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[198],Ie([1,0,5,34,2,4,8,6]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(b,m,T,f,c,h,u,v){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const I=this.ensureWatching(b,T,c);this._config=0,h&&(this._config+=1),u&&(this._config+=2),v&&(this._config+=4);const l=(0,y.parse)(c),w=typeof c=="string",t=f(d=>{if(!h)for(const i of d.created){const n=S.URI.revive(i);l(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!u)for(const i of d.changed){const n=S.URI.revive(i);l(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!v)for(const i of d.deleted){const n=S.URI.revive(i);l(n.fsPath)&&(!w||m.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=A.Disposable.from(I,this._onDidCreate,this._onDidChange,this._onDidDelete,t)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(b,m,T){const f=A.Disposable.from();if(typeof T=="string")return f;const c=b.getProxy(M.MainContext.MainThreadFileSystem);let h=!1;(T.pattern.includes(y.GLOBSTAR)||T.pattern.includes(y.GLOB_SPLIT))&&(h=!0);const u=Math.random();return c.$watch(m.identifier.value,u,T.baseUri,{recursive:h,excludes:[]}),A.Disposable.from({dispose:()=>c.$unwatch(u)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(b,m,T){this._mainContext=b,this._logService=m,this._extHostDocumentsAndEditors=T,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,m,T,f,c,h){return new E(this._mainContext,b,m,this._onFileSystemEvent.event,_.GlobPattern.from(T),f,c,h)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,m){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:m.map(T=>({oldUri:S.URI.revive(T.source),newUri:S.URI.revive(T.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:m.map(T=>S.URI.revive(T.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:m.map(T=>S.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,m){return(T,f,c)=>{const h=function(v){T.call(f,v)};return h.extension=b,m.event(h,void 0,c)}}async $onWillRunFileOperation(b,m,T,f){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:m.map(c=>({oldUri:S.URI.revive(c.source),newUri:S.URI.revive(c.target)}))},T,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:m.map(c=>S.URI.revive(c.target))},T,f);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:m.map(c=>S.URI.revive(c.target))},T,f)}}async _fireWillEvent(b,m,T,f){const c=new Set,h=[];if(await b.fireAsync(m,f,async(v,I)=>{const l=Date.now(),w=await Promise.resolve(v);w instanceof A.WorkspaceEdit&&(h.push([I.extension,w]),c.add(I.extension.displayName??I.extension.identifier.value)),Date.now()-l>T&&this._logService.warn("SLOW file-participant",I.extension.identifier)}),f.isCancellationRequested||h.length===0)return;const u={edits:[]};for(const[,v]of h){const{edits:I}=_.WorkspaceEdit.from(v,{getTextDocumentVersion:l=>this._extHostDocumentsAndEditors.getDocument(l)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(I)}return{edit:u,extensionNames:Array.from(c)}}}e.ExtHostFileSystemEventService=k}),define(Ce[199],Ie([1,0,2,36]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class S{constructor(_,A,E,k,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=E,this._commands=k;const b=new y.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new y.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new y.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new y.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new y.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new y.ApiCommandResult("Notebook and input URI",m=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const T=this._extHostNotebooks.getEditorById(m.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri),notebookEditor:T.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:r.URI.revive(m.notebookUri),inputUri:r.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(_,A,E,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:E,uri:_,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(_,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[_]})}}e.ExtHostInteractive=S}),define(Ce[200],Ie([1,0,7,4]),function(ne,e,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(_){this._handlePool=0,this._proxy=_.getProxy(y.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,_),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=S}),define(Ce[201],Ie([1,0,2,26,8,6,66,4,9,49,16,10,244,20,7,78,73,61,202,11,14,25]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class t{constructor(C,B){this._documents=C,this._provider=B}async provideDocumentSymbols(C,B){const H=this._documents.getDocument(C),j=await this._provider.provideDocumentSymbols(H,B);if(!(0,O.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(S.DocumentSymbol.from):t._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(C){C=C.slice(0).sort((j,oe)=>{let le=j.location.range.start.compareTo(oe.location.range.start);return le===0&&(le=oe.location.range.end.compareTo(j.location.range.end)),le});const B=[],H=[];for(const j of C){const oe={name:j.name||"!!MISSING: name!!",kind:S.SymbolKind.from(j.kind),tags:j.tags?.map(S.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:S.Range.from(j.location.range),selectionRange:S.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(oe),B.push(oe);break}const le=H[H.length-1];if(k.Range.containsRange(le.range,oe.range)&&!k.Range.equalsRange(le.range,oe.range)){le.children?.push(oe),H.push(oe);break}H.pop()}}return B}}class d{constructor(C,B,H){this._documents=C,this._commands=B,this._provider=H,this._cache=new u.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(C,B){const H=this._documents.getDocument(C),j=await this._provider.provideCodeLenses(H,B);if(!j||B.isCancellationRequested)return;const oe=this._cache.add(j),le=new f.DisposableStore;this._disposables.set(oe,le);const Z={cacheId:oe,lenses:[]};for(let ve=0;ve<j.length;ve++)Z.lenses.push({cacheId:[oe,ve],range:S.Range.from(j[ve].range),command:this._commands.toInternal(j[ve].command,le)});return Z}async resolveCodeLens(C,B){const H=C.cacheId&&this._cache.get(...C.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,B),j||(j=H),B.isCancellationRequested)return;const oe=C.cacheId&&this._disposables.get(C.cacheId[0]);if(!!oe)return C.command=this._commands.toInternal(j.command??d._badCmd,oe),C}releaseCodeLenses(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function i(ee){return Array.isArray(ee)?ee.map(S.DefinitionLink.from):ee?[S.DefinitionLink.from(ee)]:[]}class n{constructor(C,B){this._documents=C,this._provider=B}async provideDefinition(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideDefinition(j,oe,H);return i(le)}}class s{constructor(C,B){this._documents=C,this._provider=B}async provideDeclaration(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideDeclaration(j,oe,H);return i(le)}}class a{constructor(C,B){this._documents=C,this._provider=B}async provideImplementation(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideImplementation(j,oe,H);return i(le)}}class o{constructor(C,B){this._documents=C,this._provider=B}async provideTypeDefinition(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideTypeDefinition(j,oe,H);return i(le)}}class g{constructor(C,B){this._documents=C,this._provider=B}async provideHover(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideHover(j,oe,H);if(!(!le||(0,O.isFalsyOrEmpty)(le.contents)))return le.range||(le.range=j.getWordRangeAtPosition(oe)),le.range||(le.range=new M.Range(oe,oe)),S.Hover.from(le)}}class p{constructor(C,B){this._documents=C,this._provider=B}async provideEvaluatableExpression(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideEvaluatableExpression(j,oe,H);if(le)return S.EvaluatableExpression.from(le)}}class P{constructor(C,B){this._documents=C,this._provider=B}async provideInlineValues(C,B,H,j){const oe=this._documents.getDocument(C),le=await this._provider.provideInlineValues(oe,S.Range.to(B),S.InlineValueContext.to(H),j);if(Array.isArray(le))return le.map(Z=>S.InlineValue.from(Z))}}class N{constructor(C,B){this._documents=C,this._provider=B}async provideDocumentHighlights(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideDocumentHighlights(j,oe,H);if(Array.isArray(le))return le.map(S.DocumentHighlight.from)}}class V{constructor(C,B){this._documents=C,this._provider=B}async provideLinkedEditingRanges(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.provideLinkedEditingRanges(j,oe,H);if(le&&Array.isArray(le.ranges))return{ranges:(0,O.coalesce)(le.ranges.map(S.Range.from)),wordPattern:le.wordPattern}}}class U{constructor(C,B){this._documents=C,this._provider=B}async provideReferences(C,B,H,j){const oe=this._documents.getDocument(C),le=S.Position.to(B),Z=await this._provider.provideReferences(oe,le,H,j);if(Array.isArray(Z))return Z.map(S.location.from)}}class D{constructor(C,B,H,j,oe,le,Z){this._documents=C,this._commands=B,this._diagnostics=H,this._provider=j,this._logService=oe,this._extension=le,this._apiDeprecation=Z,this._cache=new u.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(C,B,H,j){const oe=this._documents.getDocument(C),le=m.Selection.isISelection(B)?S.Selection.to(B):S.Range.to(B),Z=[];for(const Ge of this._diagnostics.getDiagnostics(C))if(le.intersection(Ge.range)&&Z.push(Ge)>D._maxCodeActionsPerFile)break;const ve={diagnostics:Z,only:H.only?new M.CodeActionKind(H.only):void 0,triggerKind:S.CodeActionTriggerKind.to(H.trigger)},ge=await this._provider.provideCodeActions(oe,le,ve,j);if(!(0,O.isNonEmptyArray)(ge)||j.isCancellationRequested)return;const Ne=this._cache.add(ge),xe=new f.DisposableStore;this._disposables.set(Ne,xe);const Ye=[];for(let Ge=0;Ge<ge.length;Ge++){const ke=ge[Ge];!ke||(D._isCommand(ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ye.push({_isSynthetic:!0,title:ke.title,command:this._commands.toInternal(ke,xe)})):(ve.only&&(ke.kind?ve.only.contains(ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ye.push({cacheId:[Ne,Ge],title:ke.title,command:ke.command&&this._commands.toInternal(ke.command,xe),diagnostics:ke.diagnostics&&ke.diagnostics.map(S.Diagnostic.from),edit:ke.edit&&S.WorkspaceEdit.from(ke.edit,void 0),kind:ke.kind&&ke.kind.value,isPreferred:ke.isPreferred,disabled:ke.disabled?.reason})))}return{cacheId:Ne,actions:Ye}}async resolveCodeAction(C,B){const[H,j]=C,oe=this._cache.get(H,j);if(!oe||D._isCommand(oe)||!this._provider.resolveCodeAction)return;const le=await this._provider.resolveCodeAction(oe,B)??oe;return le?.edit?S.WorkspaceEdit.from(le.edit,void 0):void 0}releaseCodeActions(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}static _isCommand(C){return typeof C.command=="string"&&typeof C.title=="string"}}D._maxCodeActionsPerFile=1e3;class x{constructor(C,B,H,j){this._proxy=C,this._documents=B,this._provider=H,this._handle=j}async prepareDocumentPaste(C,B,H,j){if(!this._provider.prepareDocumentPaste)return;const oe=this._documents.getDocument(C),le=B.map(ve=>S.Range.to(ve)),Z=S.DataTransfer.toDataTransfer(H,()=>{throw new I.NotImplementedError});return await this._provider.prepareDocumentPaste(oe,le,Z,j),S.DataTransfer.toDataTransferDTO(Z)}async providePasteEdits(C,B,H,j,oe){const le=this._documents.getDocument(B),Z=H.map(Ne=>S.Range.to(Ne)),ve=S.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,C,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(le,Z,ve,oe);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?S.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}}class L{constructor(C,B){this._documents=C,this._provider=B}async provideDocumentFormattingEdits(C,B,H){const j=this._documents.getDocument(C),oe=await this._provider.provideDocumentFormattingEdits(j,B,H);if(Array.isArray(oe))return oe.map(S.TextEdit.from)}}class R{constructor(C,B){this._documents=C,this._provider=B}async provideDocumentRangeFormattingEdits(C,B,H,j){const oe=this._documents.getDocument(C),le=S.Range.to(B),Z=await this._provider.provideDocumentRangeFormattingEdits(oe,le,H,j);if(Array.isArray(Z))return Z.map(S.TextEdit.from)}}class K{constructor(C,B){this._documents=C,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,B,H,j,oe){const le=this._documents.getDocument(C),Z=S.Position.to(B),ve=await this._provider.provideOnTypeFormattingEdits(le,Z,H,j,oe);if(Array.isArray(ve))return ve.map(S.TextEdit.from)}}class W{constructor(C,B){this._provider=C,this._logService=B,this._cache=new u.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,B){const H=await this._provider.provideWorkspaceSymbols(C,B);if(!(0,O.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),oe={cacheId:j,symbols:[]};for(let le=0;le<H.length;le++){const Z=H[le];if(!Z||!Z.name){this._logService.warn("INVALID SymbolInformation",Z);continue}oe.symbols.push({...S.WorkspaceSymbol.from(Z),cacheId:[j,le]})}return oe}async resolveWorkspaceSymbol(C,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const H=this._cache.get(...C.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,B);return j&&(0,y.mixin)(C,S.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(C){this._cache.delete(C)}}class ${constructor(C,B,H){this._documents=C,this._provider=B,this._logService=H}static supportsResolving(C){return typeof C.prepareRename=="function"}async provideRenameEdits(C,B,H,j){const oe=this._documents.getDocument(C),le=S.Position.to(B);try{const Z=await this._provider.provideRenameEdits(oe,le,H,j);return Z?S.WorkspaceEdit.from(Z):void 0}catch(Z){const ve=$._asMessage(Z);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(Z)}}async resolveRenameLocation(C,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(C),oe=S.Position.to(B);try{const le=await this._provider.prepareRename(j,oe,H);let Z,ve;if(M.Range.isRange(le)?(Z=le,ve=j.getText(le)):(0,b.isObject)(le)&&(Z=le.range,ve=le.placeholder),!Z||!ve)return;if(Z.start.line>oe.line||Z.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(Z),text:ve}}catch(le){const Z=$._asMessage(le);return Z?{rejectReason:Z,range:void 0,text:void 0}:Promise.reject(le)}}static _asMessage(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class fe{constructor(C,B){this.resultId=C,this.tokens=B}}class J{constructor(C,B){this._documents=C,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(C,B,H){const j=this._documents.getDocument(C),oe=B!==0?this._previousResults.get(B):null;let le=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,oe.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return oe&&this._previousResults.delete(B),le?(le=J._fixProvidedSemanticTokens(le),this._send(J._convertToEdits(oe,le),le)):null}async releaseDocumentSemanticColoring(C){this._previousResults.delete(C)}static _fixProvidedSemanticTokens(C){return J._isSemanticTokens(C)?J._isCorrectSemanticTokens(C)?C:new M.SemanticTokens(new Uint32Array(C.data),C.resultId):J._isSemanticTokensEdits(C)?J._isCorrectSemanticTokensEdits(C)?C:new M.SemanticTokensEdits(C.edits.map(B=>new M.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),C.resultId):C}static _isSemanticTokens(C){return C&&!!C.data}static _isCorrectSemanticTokens(C){return C.data instanceof Uint32Array}static _isSemanticTokensEdits(C){return C&&Array.isArray(C.edits)}static _isCorrectSemanticTokensEdits(C){for(const B of C.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(C,B){if(!J._isSemanticTokens(B)||!C||!C.tokens)return B;const H=C.tokens,j=H.length,oe=B.data,le=oe.length;let Z=0;const ve=Math.min(j,le);for(;Z<ve&&H[Z]===oe[Z];)Z++;if(Z===j&&Z===le)return new M.SemanticTokensEdits([],B.resultId);let ge=0;const Ne=ve-Z;for(;ge<Ne&&H[j-ge-1]===oe[le-ge-1];)ge++;return new M.SemanticTokensEdits([{start:Z,deleteCount:j-Z-ge,data:oe.subarray(Z,le-ge)}],B.resultId)}_send(C,B){if(J._isSemanticTokens(C)){const H=this._nextResultId++;return this._previousResults.set(H,new fe(C.resultId,C.data)),(0,c.encodeSemanticTokensDto)({id:H,type:"full",data:C.data})}if(J._isSemanticTokensEdits(C)){const H=this._nextResultId++;return J._isSemanticTokens(B)?this._previousResults.set(H,new fe(B.resultId,B.data)):this._previousResults.set(H,new fe(C.resultId)),(0,c.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(C.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=J;class Q{constructor(C,B){this._documents=C,this._provider=B}async provideDocumentRangeSemanticTokens(C,B,H){const j=this._documents.getDocument(C),oe=await this._provider.provideDocumentRangeSemanticTokens(j,S.Range.to(B),H);return oe?this._send(oe):null}_send(C){return(0,c.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}e.DocumentRangeSemanticTokensAdapter=Q;class ce{constructor(C,B,H,j,oe){this._documents=C,this._commands=B,this._provider=H,this._apiDeprecation=j,this._extension=oe,this._cache=new u.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}async provideCompletionItems(C,B,H,j){const oe=this._documents.getDocument(C),le=S.Position.to(B),Z=oe.getWordRangeAtPosition(le)||new M.Range(le,le),ve=Z.with({end:le}),ge=new v.StopWatch(!0),Ne=await this._provider.provideCompletionItems(oe,le,j,S.CompletionContext.to(H));if(!Ne||j.isCancellationRequested)return;const xe=Array.isArray(Ne)?new M.CompletionList(Ne):Ne,Ye=ce.supportsResolving(this._provider)?this._cache.add(xe.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(Ye,Ge);const ke=[],nt={x:Ye,b:ke,a:{replace:S.Range.from(Z),insert:S.Range.from(ve)},c:xe.isIncomplete||void 0,d:ge.elapsed()};for(let G=0;G<xe.items.length;G++){const X=xe.items[G],he=this._convertCompletionItem(X,[Ye,G],ve,Z);ke.push(he)}return nt}async resolveCompletionItem(C,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...C);if(!H)return;const j=await this._provider.resolveCompletionItem(H,B);if(!!j)return this._convertCompletionItem(j,C)}releaseCompletionItems(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_convertCompletionItem(C,B,H,j){const oe=this._disposables.get(B[0]);if(!oe)throw Error("DisposableStore is missing...");const le={x:B,a:C.label,b:C.kind!==void 0?S.CompletionItemKind.from(C.kind):void 0,n:C.tags&&C.tags.map(S.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:S.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters,l:C.additionalTextEdits&&C.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal(C.command,oe)};C.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=C.textEdit.newText):typeof C.insertText=="string"?le.h=C.insertText:C.insertText instanceof M.SnippetString&&(le.h=C.insertText.value,le.i|=4);let Z;return C.textEdit?Z=C.textEdit.range:C.range&&(Z=C.range),M.Range.isRange(Z)?le.j=S.Range.from(Z):Z&&(!H?.isEqual(Z.inserting)||!j?.isEqual(Z.replacing))&&(le.j={insert:S.Range.from(Z.inserting),replace:S.Range.from(Z.replacing)}),le}}class te{async provideInlineCompletions(C,B,H,j){}disposeCompletions(C){}handleDidShowCompletionItem(C,B){}}class pe extends te{constructor(C,B,H,j){super(),this._extension=C,this._documents=B,this._provider=H,this._commands=j,this._references=new re,this._isAdditionsProposedApiEnabled=(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[_.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(C,B,H,j){const oe=this._documents.getDocument(C),le=S.Position.to(B),Z=await this._provider.provideInlineCompletionItems(oe,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const ve=Array.isArray(Z)?Z:Z.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(Z)?[]:Z.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let ke;Ye.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:ke,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,B){const H=this._references.get(C)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class be extends te{constructor(C,B,H,j){super(),this.extension=C,this._documents=B,this._provider=H,this._commands=j,this._references=new re,this.isAdditionProposedApiEnabled=(0,w.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[_.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[_.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(C,B,H,j){const oe=this._documents.getDocument(C),le=S.Position.to(B),Z=await this._provider.provideInlineCompletionItems(oe,le,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:S.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const ve=Array.isArray(Z)?Z:Z.items,ge=Array.isArray(Z)?[]:Z.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:ve}),items:ve.map((Ye,Ge)=>{let ke;Ye.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?S.Range.from(Ye.range):void 0,command:ke,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(C){this._references.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,B){const H=this._references.get(C)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class re{constructor(){this._references=new Map,this._idPool=1}createReferenceId(C){const B=this._idPool++;return this._references.set(B,C),B}disposeReferenceId(C){const B=this._references.get(C);return this._references.delete(C),B}get(C){return this._references.get(C)}}class Ee{constructor(C,B){this._documents=C,this._provider=B,this._cache=new u.Cache("SignatureHelp")}async provideSignatureHelp(C,B,H,j){const oe=this._documents.getDocument(C),le=S.Position.to(B),Z=this.reviveContext(H),ve=await this._provider.provideSignatureHelp(oe,le,j,Z);if(ve){const ge=this._cache.add([ve]);return{...S.SignatureHelp.from(ve),id:ge}}}reviveContext(C){let B;if(C.activeSignatureHelp){const H=S.SignatureHelp.to(C.activeSignatureHelp),j=this._cache.get(C.activeSignatureHelp.id,0);j?(B=j,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...C,activeSignatureHelp:B}}releaseSignatureHelp(C){this._cache.delete(C)}}class Pe{constructor(C,B,H,j,oe){this._documents=C,this._commands=B,this._provider=H,this._logService=j,this._extension=oe,this._cache=new u.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(C,B,H){const j=this._documents.getDocument(C),oe=S.Range.to(B),le=await this._provider.provideInlayHints(j,oe,H);if(!Array.isArray(le)||le.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const Z=this._cache.add(le);this._disposables.set(Z,new f.DisposableStore);const ve={hints:[],cacheId:Z};for(let ge=0;ge<le.length;ge++)this._isValidInlayHint(le[ge],oe)&&ve.hints.push(this._convertInlayHint(le[ge],[Z,ge]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),ve}async resolveInlayHint(C,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...C);if(!H)return;const j=await this._provider.resolveInlayHint(H,B);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,C)}releaseHints(C){this._disposables.get(C)?.dispose(),this._disposables.delete(C),this._cache.delete(C)}_isValidInlayHint(C,B){return C.label.length===0||Array.isArray(C.label)&&C.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(B&&!B.contains(C.position))}_convertInlayHint(C,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:B,tooltip:S.MarkdownString.fromStrict(C.tooltip),position:S.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(S.TextEdit.from),kind:C.kind&&S.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?j.label=C.label:j.label=C.label.map(oe=>{const le={label:oe.value};return le.tooltip=S.MarkdownString.fromStrict(oe.tooltip),M.Location.isLocation(oe.location)&&(le.location=S.location.from(oe.location)),oe.command&&(le.command=this._commands.toInternal(oe.command,H)),le}),j}}class Fe{constructor(C,B){this._documents=C,this._provider=B,this._cache=new u.Cache("DocumentLink")}async provideLinks(C,B){const H=this._documents.getDocument(C),j=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(j)||j.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(S.DocumentLink.from)};{const oe=this._cache.add(j),le={links:[],cacheId:oe};for(let Z=0;Z<j.length;Z++){if(!Fe._validateLink(j[Z]))continue;const ve=S.DocumentLink.from(j[Z]);ve.cacheId=[oe,Z],le.links.push(ve)}return le}}}static _validateLink(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...C);if(!H)return;const j=await this._provider.resolveDocumentLink(H,B);if(!(!j||!Fe._validateLink(j)))return S.DocumentLink.from(j)}releaseLinks(C){this._cache.delete(C)}}class We{constructor(C,B){this._documents=C,this._provider=B}async provideColors(C,B){const H=this._documents.getDocument(C),j=await this._provider.provideDocumentColors(H,B);return Array.isArray(j)?j.map(le=>({color:S.Color.from(le.color),range:S.Range.from(le.range)})):[]}async provideColorPresentations(C,B,H){const j=this._documents.getDocument(C),oe=S.Range.to(B.range),le=S.Color.to(B.color),Z=await this._provider.provideColorPresentations(le,{document:j,range:oe},H);if(!!Array.isArray(Z))return Z.map(S.ColorPresentation.from)}}class Xe{constructor(C,B){this._documents=C,this._provider=B}async provideFoldingRanges(C,B,H){const j=this._documents.getDocument(C),oe=await this._provider.provideFoldingRanges(j,B,H);if(!!Array.isArray(oe))return oe.map(S.FoldingRange.from)}}class Te{constructor(C,B,H){this._documents=C,this._provider=B,this._logService=H}async provideSelectionRanges(C,B,H){const j=this._documents.getDocument(C),oe=B.map(S.Position.to),le=await this._provider.provideSelectionRanges(j,oe,H);if(!(0,O.isNonEmptyArray)(le))return[];if(le.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Z=[];for(let ve=0;ve<oe.length;ve++){const ge=[];Z.push(ge);let Ne=oe[ve],xe=le[ve];for(;;){if(!xe.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(S.SelectionRange.from(xe)),!xe.parent)break;Ne=xe.range,xe=xe.parent}}return Z}}class _e{constructor(C,B){this._documents=C,this._provider=B,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.prepareCallHierarchy(j,oe,H);if(!le)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Z,ve)):[this._cacheAndConvertItem(Z,le)]}async provideCallsTo(C,B,H){const j=this._itemFromCache(C,B);if(!j)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(!!oe)return oe.map(le=>({from:this._cacheAndConvertItem(C,le.from),fromRanges:le.fromRanges.map(Z=>S.Range.from(Z))}))}async provideCallsFrom(C,B,H){const j=this._itemFromCache(C,B);if(!j)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(!!oe)return oe.map(le=>({to:this._cacheAndConvertItem(C,le.to),fromRanges:le.fromRanges.map(Z=>S.Range.from(Z))}))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,B){const H=this._cache.get(C),j=S.CallHierarchyItem.from(B,C,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(C,B){return this._cache.get(C)?.get(B)}}class ye{constructor(C,B){this._documents=C,this._provider=B,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(C,B,H){const j=this._documents.getDocument(C),oe=S.Position.to(B),le=await this._provider.prepareTypeHierarchy(j,oe,H);if(!le)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(le)?le.map(ve=>this._cacheAndConvertItem(Z,ve)):[this._cacheAndConvertItem(Z,le)]}async provideSupertypes(C,B,H){const j=this._itemFromCache(C,B);if(!j)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(j,H);if(!!oe)return oe.map(le=>this._cacheAndConvertItem(C,le))}async provideSubtypes(C,B,H){const j=this._itemFromCache(C,B);if(!j)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(j,H);if(!!oe)return oe.map(le=>this._cacheAndConvertItem(C,le))}releaseSession(C){this._cache.delete(C)}_cacheAndConvertItem(C,B){const H=this._cache.get(C),j=S.TypeHierarchyItem.from(B,C,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(C,B){return this._cache.get(C)?.get(B)}}class ae{constructor(C,B,H,j){this._proxy=C,this._documents=B,this._provider=H,this._handle=j}async provideDocumentOnDropEdits(C,B,H,j,oe){const le=this._documents.getDocument(B),Z=S.Position.to(H),ve=S.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,C,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(le,Z,ve,oe);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?S.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}}class ue{constructor(C,B){this.adapter=C,this.extension=B}}class Y{constructor(C,B,H,j,oe,le,Z){this._adapter=new Map,this._uriTransformer=B,this._proxy=C.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=j,this._diagnostics=oe,this._logService=le,this._apiDeprecation=Z}_transformDocumentSelector(C){return S.DocumentSelector.from(C,this._uriTransformer)}_createDisposable(C){return new M.Disposable(()=>{this._adapter.delete(C),this._proxy.$unregister(C)})}_nextHandle(){return Y._handlePool++}async _withAdapter(C,B,H,j,oe,le=!1){const Z=this._adapter.get(C);if(!Z||!(Z.adapter instanceof B))return j;const ve=Date.now();le||this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ge=H(Z.adapter,Z.extension);return Promise.resolve(ge).catch(Ne=>{(0,I.isCancellationError)(Ne)||(this._logService.error(`[${Z.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{le||this._logService.trace(`[${Z.extension.identifier.value}] provider DONE after ${Date.now()-ve}ms`)}),T.CancellationToken.isCancellationToken(oe)?(0,l.raceCancellationError)(ge,oe):ge}_addNewAdapter(C,B){const H=this._nextHandle();return this._adapter.set(H,new ue(C,B)),H}static _extLabel(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,B,H,j){const oe=this._addNewAdapter(new t(this._documents,H),C),le=j&&j.label||Y._extLabel(C);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(B),le),this._createDisposable(oe)}$provideDocumentSymbols(C,B,H){return this._withAdapter(C,t,j=>j.provideDocumentSymbols(r.URI.revive(B),H),void 0,H)}registerCodeLensProvider(C,B,H){const j=this._nextHandle(),oe=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new d(this._documents,this._commands.converter,H),C)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(B),oe);let le=this._createDisposable(j);if(oe!==void 0){const Z=H.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(oe));le=M.Disposable.from(le,Z)}return le}$provideCodeLenses(C,B,H){return this._withAdapter(C,d,j=>j.provideCodeLenses(r.URI.revive(B),H),void 0,H)}$resolveCodeLens(C,B,H){return this._withAdapter(C,d,j=>j.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(C,B){this._withAdapter(C,d,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(C,B,H){const j=this._addNewAdapter(new n(this._documents,H),C);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDefinition(C,B,H,j){return this._withAdapter(C,n,oe=>oe.provideDefinition(r.URI.revive(B),H,j),[],j)}registerDeclarationProvider(C,B,H){const j=this._addNewAdapter(new s(this._documents,H),C);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDeclaration(C,B,H,j){return this._withAdapter(C,s,oe=>oe.provideDeclaration(r.URI.revive(B),H,j),[],j)}registerImplementationProvider(C,B,H){const j=this._addNewAdapter(new a(this._documents,H),C);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideImplementation(C,B,H,j){return this._withAdapter(C,a,oe=>oe.provideImplementation(r.URI.revive(B),H,j),[],j)}registerTypeDefinitionProvider(C,B,H){const j=this._addNewAdapter(new o(this._documents,H),C);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideTypeDefinition(C,B,H,j){return this._withAdapter(C,o,oe=>oe.provideTypeDefinition(r.URI.revive(B),H,j),[],j)}registerHoverProvider(C,B,H,j){const oe=this._addNewAdapter(new g(this._documents,H),C);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideHover(C,B,H,j){return this._withAdapter(C,g,oe=>oe.provideHover(r.URI.revive(B),H,j),void 0,j)}registerEvaluatableExpressionProvider(C,B,H,j){const oe=this._addNewAdapter(new p(this._documents,H),C);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideEvaluatableExpression(C,B,H,j){return this._withAdapter(C,p,oe=>oe.provideEvaluatableExpression(r.URI.revive(B),H,j),void 0,j)}registerInlineValuesProvider(C,B,H,j){const oe=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,le=this._addNewAdapter(new P(this._documents,H),C);this._proxy.$registerInlineValuesProvider(le,this._transformDocumentSelector(B),oe);let Z=this._createDisposable(le);if(oe!==void 0){const ve=H.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(oe));Z=M.Disposable.from(Z,ve)}return Z}$provideInlineValues(C,B,H,j,oe){return this._withAdapter(C,P,le=>le.provideInlineValues(r.URI.revive(B),H,j,oe),void 0,oe)}registerDocumentHighlightProvider(C,B,H){const j=this._addNewAdapter(new N(this._documents,H),C);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentHighlights(C,B,H,j){return this._withAdapter(C,N,oe=>oe.provideDocumentHighlights(r.URI.revive(B),H,j),void 0,j)}registerLinkedEditingRangeProvider(C,B,H){const j=this._addNewAdapter(new V(this._documents,H),C);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideLinkedEditingRanges(C,B,H,j){return this._withAdapter(C,V,async oe=>{const le=await oe.provideLinkedEditingRanges(r.URI.revive(B),H,j);if(le)return{ranges:le.ranges,wordPattern:le.wordPattern?Y._serializeRegExp(le.wordPattern):void 0}},void 0,j)}registerReferenceProvider(C,B,H){const j=this._addNewAdapter(new U(this._documents,H),C);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideReferences(C,B,H,j,oe){return this._withAdapter(C,U,le=>le.provideReferences(r.URI.revive(B),H,j,oe),void 0,oe)}registerCodeActionProvider(C,B,H,j){const oe=new f.DisposableStore,le=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,H,this._logService,C,this._apiDeprecation),C);return this._proxy.$registerQuickFixSupport(le,this._transformDocumentSelector(B),{providedKinds:j?.providedCodeActionKinds?.map(Z=>Z.value),documentation:j?.documentation?.map(Z=>({kind:Z.kind.value,command:this._commands.converter.toInternal(Z.command,oe)}))},Y._extLabel(C),Boolean(H.resolveCodeAction)),oe.add(this._createDisposable(le)),oe}$provideCodeActions(C,B,H,j,oe){return this._withAdapter(C,D,le=>le.provideCodeActions(r.URI.revive(B),H,j,oe),void 0,oe)}$resolveCodeAction(C,B,H){return this._withAdapter(C,D,j=>j.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(C,B){this._withAdapter(C,D,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(C,B,H){const j=this._addNewAdapter(new L(this._documents,H),C);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(B),C.identifier,C.displayName||C.name),this._createDisposable(j)}$provideDocumentFormattingEdits(C,B,H,j){return this._withAdapter(C,L,oe=>oe.provideDocumentFormattingEdits(r.URI.revive(B),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(C,B,H){const j=this._addNewAdapter(new R(this._documents,H),C);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(B),C.identifier,C.displayName||C.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(C,B,H,j,oe){return this._withAdapter(C,R,le=>le.provideDocumentRangeFormattingEdits(r.URI.revive(B),H,j,oe),void 0,oe)}registerOnTypeFormattingEditProvider(C,B,H,j){const oe=this._addNewAdapter(new K(this._documents,H),C);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(B),j,C.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(C,B,H,j,oe,le){return this._withAdapter(C,K,Z=>Z.provideOnTypeFormattingEdits(r.URI.revive(B),H,j,oe,le),void 0,le)}registerWorkspaceSymbolProvider(C,B){const H=this._addNewAdapter(new W(B,this._logService),C);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(C,B,H){return this._withAdapter(C,W,j=>j.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(C,B,H){return this._withAdapter(C,W,j=>j.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(C,B){this._withAdapter(C,W,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(C,B,H){const j=this._addNewAdapter(new $(this._documents,H,this._logService),C);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(B),$.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(C,B,H,j,oe){return this._withAdapter(C,$,le=>le.provideRenameEdits(r.URI.revive(B),H,j,oe),void 0,oe)}$resolveRenameLocation(C,B,H,j){return this._withAdapter(C,$,oe=>oe.resolveRenameLocation(r.URI.revive(B),H,j),void 0,j)}registerDocumentSemanticTokensProvider(C,B,H,j){const oe=this._addNewAdapter(new J(this._documents,H),C),le=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(B),j,le);let Z=this._createDisposable(oe);if(le){const ve=H.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(le));Z=M.Disposable.from(Z,ve)}return Z}$provideDocumentSemanticTokens(C,B,H,j){return this._withAdapter(C,J,oe=>oe.provideDocumentSemanticTokens(r.URI.revive(B),H,j),null,j)}$releaseDocumentSemanticTokens(C,B){this._withAdapter(C,J,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,B,H,j){const oe=this._addNewAdapter(new Q(this._documents,H),C);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(B),j),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(C,B,H,j){return this._withAdapter(C,Q,oe=>oe.provideDocumentRangeSemanticTokens(r.URI.revive(B),H,j),null,j)}registerCompletionItemProvider(C,B,H,j){const oe=this._addNewAdapter(new ce(this._documents,this._commands.converter,H,this._apiDeprecation,C),C);return this._proxy.$registerCompletionsProvider(oe,this._transformDocumentSelector(B),j,ce.supportsResolving(H),`${C.identifier.value}(${j.join("")})`),this._createDisposable(oe)}$provideCompletionItems(C,B,H,j,oe){return this._withAdapter(C,ce,le=>le.provideCompletionItems(r.URI.revive(B),H,j,oe),void 0,oe)}$resolveCompletionItem(C,B,H){return this._withAdapter(C,ce,j=>j.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(C,B){this._withAdapter(C,ce,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(C,B,H){const j=new pe(C,this._documents,H,this._commands.converter),oe=this._addNewAdapter(j,C);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(B),j.supportsHandleDidShowCompletionItem),this._createDisposable(oe)}registerInlineCompletionsProviderNew(C,B,H){const j=this._addNewAdapter(new be(C,this._documents,H,this._commands.converter),C);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(B),!0),this._createDisposable(j)}$provideInlineCompletions(C,B,H,j,oe){return this._withAdapter(C,te,le=>le.provideInlineCompletions(r.URI.revive(B),H,j,oe),void 0,oe)}$handleInlineCompletionDidShow(C,B,H){this._withAdapter(C,te,async j=>{j.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(C,B){this._withAdapter(C,te,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(C,B,H,j){const oe=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,le=this._addNewAdapter(new Ee(this._documents,H),C);return this._proxy.$registerSignatureHelpProvider(le,this._transformDocumentSelector(B),oe),this._createDisposable(le)}$provideSignatureHelp(C,B,H,j,oe){return this._withAdapter(C,Ee,le=>le.provideSignatureHelp(r.URI.revive(B),H,j,oe),void 0,oe)}$releaseSignatureHelp(C,B){this._withAdapter(C,Ee,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(C,B,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new Pe(this._documents,this._commands.converter,H,this._logService,C),C);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",j,Y._extLabel(C));let le=this._createDisposable(oe);if(j!==void 0){const Z=H.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(j));le=M.Disposable.from(le,Z)}return le}$provideInlayHints(C,B,H,j){return this._withAdapter(C,Pe,oe=>oe.provideInlayHints(r.URI.revive(B),H,j),void 0,j)}$resolveInlayHint(C,B,H){return this._withAdapter(C,Pe,j=>j.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(C,B){this._withAdapter(C,Pe,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(C,B,H){const j=this._addNewAdapter(new Fe(this._documents,H),C);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(C,B,H){return this._withAdapter(C,Fe,j=>j.provideLinks(r.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(C,B,H){return this._withAdapter(C,Fe,j=>j.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(C,B){this._withAdapter(C,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(C,B,H){const j=this._addNewAdapter(new We(this._documents,H),C);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentColors(C,B,H){return this._withAdapter(C,We,j=>j.provideColors(r.URI.revive(B),H),[],H)}$provideColorPresentations(C,B,H,j){return this._withAdapter(C,We,oe=>oe.provideColorPresentations(r.URI.revive(B),H,j),void 0,j)}registerFoldingRangeProvider(C,B,H){const j=this._nextHandle(),oe=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ue(new Xe(this._documents,H),C)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(B),oe);let le=this._createDisposable(j);if(oe!==void 0){const Z=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));le=M.Disposable.from(le,Z)}return le}$provideFoldingRanges(C,B,H,j){return this._withAdapter(C,Xe,oe=>oe.provideFoldingRanges(r.URI.revive(B),H,j),void 0,j)}registerSelectionRangeProvider(C,B,H){const j=this._addNewAdapter(new Te(this._documents,H,this._logService),C);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideSelectionRanges(C,B,H,j){return this._withAdapter(C,Te,oe=>oe.provideSelectionRanges(r.URI.revive(B),H,j),[],j)}registerCallHierarchyProvider(C,B,H){const j=this._addNewAdapter(new _e(this._documents,H),C);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareCallHierarchy(C,B,H,j){return this._withAdapter(C,_e,oe=>Promise.resolve(oe.prepareSession(r.URI.revive(B),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(C,B,H,j){return this._withAdapter(C,_e,oe=>oe.provideCallsTo(B,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(C,B,H,j){return this._withAdapter(C,_e,oe=>oe.provideCallsFrom(B,H,j),void 0,j)}$releaseCallHierarchy(C,B){this._withAdapter(C,_e,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(C,B,H){const j=this._addNewAdapter(new ye(this._documents,H),C);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareTypeHierarchy(C,B,H,j){return this._withAdapter(C,ye,oe=>Promise.resolve(oe.prepareSession(r.URI.revive(B),H,j)),void 0,j)}$provideTypeHierarchySupertypes(C,B,H,j){return this._withAdapter(C,ye,oe=>oe.provideSupertypes(B,H,j),void 0,j)}$provideTypeHierarchySubtypes(C,B,H,j){return this._withAdapter(C,ye,oe=>oe.provideSubtypes(B,H,j),void 0,j)}$releaseTypeHierarchy(C,B){this._withAdapter(C,ye,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(C,B,H){const j=this._nextHandle();return this._adapter.set(j,new ue(new ae(this._proxy,this._documents,H,j),C)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentOnDropEdits(C,B,H,j,oe,le){return this._withAdapter(C,ae,Z=>Promise.resolve(Z.provideDocumentOnDropEdits(B,r.URI.revive(H),j,oe,le)),void 0,void 0)}registerDocumentPasteEditProvider(C,B,H,j){const oe=this._nextHandle();return this._adapter.set(oe,new ue(new x(this._proxy,this._documents,H,oe),C)),this._proxy.$registerPasteEditProvider(oe,this._transformDocumentSelector(B),!!H.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(oe)}$prepareDocumentPaste(C,B,H,j,oe){return this._withAdapter(C,x,le=>le.prepareDocumentPaste(r.URI.revive(B),H,j,oe),void 0,oe)}$providePasteEdits(C,B,H,j,oe,le){return this._withAdapter(C,x,Z=>Z.providePasteEdits(B,r.URI.revive(H),j,oe,le),void 0,le)}static _serializeRegExp(C){return{pattern:C.source,flags:(0,E.regExpFlags)(C)}}static _serializeIndentationRule(C){return{decreaseIndentPattern:Y._serializeRegExp(C.decreaseIndentPattern),increaseIndentPattern:Y._serializeRegExp(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?Y._serializeRegExp(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?Y._serializeRegExp(C.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(C){return{beforeText:Y._serializeRegExp(C.beforeText),afterText:C.afterText?Y._serializeRegExp(C.afterText):void 0,previousLineText:C.previousLineText?Y._serializeRegExp(C.previousLineText):void 0,action:C.action}}static _serializeOnEnterRules(C){return C.map(Y._serializeOnEnterRule)}setLanguageConfiguration(C,B,H){const{wordPattern:j}=H;if(j&&(0,E.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(B,j):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const oe=this._nextHandle(),le={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Y._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?Y._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Y._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,B,le),this._createDisposable(oe)}$setWordDefinitions(C){for(const B of C)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=Y,Y._handlePool=0}),define(Ce[203],Ie([1,0,4,8,6,29,14,7]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(O,b,m,T){this._documents=b,this._commands=m,this._uriTransformer=T,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,b){await this._proxy.$changeLanguage(O,b);const m=this._documents.getDocumentData(O);if(!m)throw new Error(`document '${O.toString()}' NOT found`);return m.document}async tokenAtPosition(O,b){const m=O.version,T=y.Position.from(b),f=await this._proxy.$tokensAtPosition(O.uri,T),c={type:S.StandardTokenType.Other,range:O.getWordRangeAtPosition(b)??new S.Range(b.line,b.character,b.line,b.character)};if(!f)return c;const h={range:y.Range.to(f.range),type:y.TokenType.to(f.type)};return!h.range.contains(b)||m!==O.version?c:h}createLanguageStatusItem(O,b,m){const T=this._handlePool++,f=this._proxy,c=this._ids,h=`${O.identifier.value}/${b}`;if(c.has(h))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);c.add(h);const u={selector:m,id:b,name:O.displayName??O.name,severity:S.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const I=new A.DisposableStore,l=()=>{v?.dispose(),v=(0,_.disposableTimeout)(()=>{I.clear(),this._proxy.$setLanguageStatus(T,{id:h,name:u.name??O.displayName??O.name,source:O.displayName??O.name,selector:y.DocumentSelector.from(u.selector,this._uriTransformer),label:u.text,detail:u.detail??"",severity:u.severity===S.LanguageStatusSeverity.Error?M.default.Error:u.severity===S.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:u.command&&this._commands.toInternal(u.command,I),accessibilityInfo:u.accessibilityInformation,busy:u.busy})},0)},w={dispose(){I.dispose(),v?.dispose(),f.$removeLanguageStatus(T),c.delete(h)},get id(){return u.id},get name(){return u.name},set name(t){u.name=t,l()},get selector(){return u.selector},set selector(t){u.selector=t,l()},get text(){return u.text},set text(t){u.text=t,l()},get detail(){return u.detail},set detail(t){u.detail=t,l()},get severity(){return u.severity},set severity(t){u.severity=t,l()},get accessibilityInformation(){return u.accessibilityInformation},set accessibilityInformation(t){u.accessibilityInformation=t,l()},get command(){return u.command},set command(t){u.command=t,l()},get busy(){return u.busy},set busy(t){u.busy=t,l()}};return l(),w}}e.ExtHostLanguages=E}),define(Ce[204],Ie([1,0,15,4,28,13,5]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends r.AbstractLoggerService{constructor(O,b){const m=new _.Emitter;super(b.logLevel,m.event),this._proxy=O.getProxy(y.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(O){this._onDidChangeLogLevel.fire(O)}doCreateLogger(O,b,m){return new E(this._proxy,O,b,m)}};A=ze([$e(0,M.IExtHostRpcService),$e(1,S.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class E extends r.AbstractMessageLogger{constructor(O,b,m,T){super(T?.always),this.proxy=O,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(b,T).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(O,b){const m=[[O,b]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(O){this.proxy.$log(this.file,O)}}}),define(Ce[205],Ie([1,0,4,15,25]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let _=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(r.MainContext.MainThreadMessageService)}showMessage(E,k,O,b,m){const T={source:{identifier:E.identifier,label:E.displayName||E.name}};let f;typeof b=="string"||M(b)?f=[b,...m]:(T.modal=b?.modal,T.useCustom=b?.useCustom,T.detail=b?.detail,f=m),T.useCustom&&(0,S.checkProposedApiEnabled)(E,"resolvers");const c=[];for(let h=0;h<f.length;h++){const u=f[h];if(typeof u=="string")c.push({title:u,handle:h,isCloseAffordance:!1});else if(typeof u=="object"){const{title:v,isCloseAffordance:I}=u;c.push({title:v,isCloseAffordance:!!I,handle:h})}else this._logService.warn("Invalid message item:",u)}return this._proxy.$showMessage(k,O,T,c).then(h=>{if(typeof h=="number")return f[h]})}};_=ze([$e(1,y.ILogService)],_),e.ExtHostMessageService=_}),define(Ce[206],Ie([1,0,23,5,7,24,9,10,2,61,4,36,8,6,40,178,93]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class u{constructor(I,l,w,t){this._textDocumentsAndEditors=w,this._textDocuments=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new y.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new y.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new y.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new y.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new k.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=I.getProxy(O.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=I.getProxy(O.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=I.getProxy(O.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===12){const i=d.notebookEditor?.notebookUri,n=d.cell.handle,a=this._documents.get(i)?.getCell(n);if(a)return a.apiCell}return d}}),u._registerApiCommands(l)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(I=>I.apiEditor)}getEditorById(I){const l=this._editors.get(I);if(!l)throw new Error(`unknown text editor: ${I}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(I){for(const[l,w]of this._editors)if(w.apiEditor===I)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(I,l){const w=this._documents.get(I);if(!w&&!l)throw new Error(`NO notebook document for '${I}'`);return w}_getProviderData(I){const l=this._notebookContentProviders.get(I);if(!l)throw new Error(`NO provider for '${I}'`);return l}registerNotebookContentProvider(I,l,w,t,d){if((0,_.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);return this._notebookContentProviders.set(l,{extension:I,provider:w}),this._notebookProxy.$registerNotebookProvider({id:I.identifier,location:I.extensionLocation},l,m.NotebookDocumentContentOptions.from(t),u._convertNotebookRegistrationData(I,d)),new T.Disposable(()=>{this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(I,l){if(!l)return;const w=l.filenamePattern.map(t=>m.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(l.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:I.identifier,providerDisplayName:I.displayName||I.name,displayName:l.displayName,filenamePattern:w,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(I,l,w){const t=u._notebookStatusBarItemProviderHandlePool++,d=typeof w.onDidChangeCellStatusBarItems=="function"?u._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(t,w),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(t,d,l);let i;return d!==void 0&&(i=w.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(d))),new T.Disposable(()=>{this._notebookStatusBarItemProviders.delete(t),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(t,d),i?.dispose()})}async createNotebookDocument(I){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:I.viewType,content:I.content&&m.NotebookData.from(I.content)});return E.URI.revive(l)}async openNotebookDocument(I){const l=this._documents.get(I);if(l)return l.apiNotebook;const w=await this._notebookDocumentsProxy.$tryOpenNotebook(I),t=this._documents.get(E.URI.revive(w));return(0,A.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(I,l){E.URI.isUri(I)&&(I=await this.openNotebookDocument(I));let w;typeof l=="object"?w={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(m.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:w={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(I.uri,I.notebookType,w),d=t&&this._editors.get(t)?.apiEditor;if(d)return d;throw t?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(I,l,w,t){const d=this._notebookStatusBarItemProviders.get(I),i=E.URI.revive(l),n=this._documents.get(i);if(!n||!d)return;const s=n.getCellFromIndex(w);if(!s)return;const a=await d.provideCellStatusBarItems(s.apiCell,t);if(!a)return;const o=new S.DisposableStore,g=this._statusBarCache.add([o]),P=(Array.isArray(a)?a:[a]).map(N=>m.NotebookStatusBarItem.from(N,this._commandsConverter,o));return{cacheId:g,items:P}}$releaseNotebookCellStatusBarItems(I){this._statusBarCache.delete(I)}registerNotebookSerializer(I,l,w,t,d){if((0,_.isFalsyOrWhitespace)(l))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,w),this._notebookProxy.$registerNotebookSerializer(i,{id:I.identifier,location:I.extensionLocation},l,m.NotebookDocumentContentOptions.from(t),u._convertNotebookRegistrationData(I,d)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(I,l,w){const t=this._notebookSerializer.get(I);if(!t)throw new Error("NO serializer found");const d=await t.deserializeNotebook(l.buffer,w);return new f.SerializableObjectWithBuffers(m.NotebookData.from(d))}async $notebookToData(I,l,w){const t=this._notebookSerializer.get(I);if(!t)throw new Error("NO serializer found");const d=await t.serializeNotebook(m.NotebookData.to(l.value),w);return r.VSBuffer.wrap(d)}async $openNotebook(I,l,w,t,d){const{provider:i}=this._getProviderData(I),n=await i.openNotebook(E.URI.revive(l),{backupId:w,untitledDocumentData:t?.buffer},d);return new f.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(m.NotebookCellData.from)})}_createExtHostEditor(I,l,w){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const t=new h.ExtHostNotebookEditor(l,this._notebookEditorsProxy,I,w.visibleRanges.map(m.NotebookRange.to),w.selections.map(m.NotebookRange.to),typeof w.viewColumn=="number"?m.ViewColumn.to(w.viewColumn):void 0);this._editors.set(l,t)}$acceptDocumentAndEditorsDelta(I){if(I.value.removedDocuments)for(const w of I.value.removedDocuments){const t=E.URI.revive(w),d=this._documents.get(t);d&&(d.dispose(),this._documents.delete(t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(d.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===t.toString()&&this._editors.delete(i.id)}if(I.value.addedDocuments){const w=[];for(const t of I.value.addedDocuments){const d=E.URI.revive(t.uri);if(this._documents.has(d))throw new Error(`adding EXISTING notebook ${d} `);const i=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,d,t);w.push(...t.cells.map(n=>c.ExtHostCell.asModelAddData(i.apiNotebook,n))),this._documents.get(d)?.dispose(),this._documents.set(d,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(I.value.addedEditors)for(const w of I.value.addedEditors){if(this._editors.has(w.id))return;const t=E.URI.revive(w.documentUri),d=this._documents.get(t);d&&this._createExtHostEditor(d,w.id,w)}const l=[];if(I.value.removedEditors)for(const w of I.value.removedEditors){const t=this._editors.get(w);t&&(this._editors.delete(w),this._activeNotebookEditor?.id===t.id&&(this._activeNotebookEditor=void 0),l.push(t))}if(I.value.visibleEditors){this._visibleNotebookEditors=I.value.visibleEditors.map(t=>this._editors.get(t)).filter(t=>!!t);const w=new Set;this._visibleNotebookEditors.forEach(t=>w.add(t.id));for(const t of this._editors.values()){const d=w.has(t.id);t._acceptVisibility(d)}this._visibleNotebookEditors=[...this._editors.values()].map(t=>t).filter(t=>t.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}I.value.newActiveEditor===null?this._activeNotebookEditor=void 0:I.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(I.value.newActiveEditor)),I.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(I){const l=b.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new b.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>r.VSBuffer.wrap(d))],new b.ApiCommandResult("Notebook Data",d=>m.NotebookData.to(d.value))),t=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new f.SerializableObjectWithBuffers(m.NotebookData.from(d)))],new b.ApiCommandResult("Bytes",d=>d.buffer));I.registerApiCommand(w),I.registerApiCommand(t)}}e.ExtHostNotebookController=u,u._notebookStatusBarItemProviderHandlePool=0}),define(Ce[207],Ie([1,0,16,14,20,5,7,24,2,27,15,4,36,8,6,63,166,25,40]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let I=class{constructor(n,s,a,o,g){this._initData=s,this._extHostNotebook=a,this._commands=o,this._logService=g,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=n.getProxy(b.MainContext.MainThreadNotebookKernels);const p=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const N=this._extHostNotebook.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:N}}else if(P&&"notebookEditor"in P){const N=this._extHostNotebook.getIdByEditor(P.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.document.uri.toString()}`);return{notebookEditorId:N}}return P})],m.ApiCommandResult.Void);this._commands.registerApiCommand(p)}createNotebookController(n,s,a,o,g,p){for(const ce of this._kernelData.values())if(ce.controller.id===s&&k.ExtensionIdentifier.equals(n.identifier,ce.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const P=this._handlePool++,N=this;this._logService.trace(`NotebookController[${P}], CREATED by ${n.identifier.value}, ${s}`);const V=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${n.identifier}'`);let U=!1;const D=new _.DisposableStore,x=new M.Emitter,L=new M.Emitter,R={id:d(n.identifier,s),notebookType:a,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:o||n.identifier.value,preloads:p?p.map(T.NotebookRendererScript.from):[]};let K=g??V,W;this._proxy.$addKernel(P,R).catch(ce=>{console.log(ce),U=!0});let $=0;const fe=()=>{if(U)return;const ce=++$;Promise.resolve().then(()=>{ce===$&&this._proxy.$updateKernel(P,R)})},J=new A.ResourceMap,Q={get id(){return s},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return R.label},set label(ce){R.label=ce??n.displayName??n.name,fe()},get detail(){return R.detail??""},set detail(ce){R.detail=ce,fe()},get description(){return R.description??""},set description(ce){R.description=ce,fe()},get kind(){return(0,u.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind??""},set kind(ce){(0,u.checkProposedApiEnabled)(n,"notebookControllerKind"),R.kind=ce,fe()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(ce){R.supportedLanguages=ce,fe()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){R.supportsExecutionOrder=ce,fe()},get rendererScripts(){return R.preloads?R.preloads.map(T.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ce){K=ce??V},get interruptHandler(){return W},set interruptHandler(ce){W=ce,R.supportsInterrupt=Boolean(ce),fe()},createNotebookCellExecution(ce){if(U)throw new Error("notebook controller is DISPOSED");if(!J.has(ce.notebook.uri))throw N._logService.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(J.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return N._createNotebookCellExecution(ce,d(n.identifier,this.id))},dispose:()=>{U||(this._logService.trace(`NotebookController[${P}], DISPOSED`),U=!0,this._kernelData.delete(P),D.dispose(),x.dispose(),L.dispose(),this._proxy.$removeKernel(P))},updateNotebookAffinity(ce,te){N._proxy.$updateNotebookPriority(P,ce.uri,te)},onDidReceiveMessage:L.event,postMessage(ce,te){return(0,u.checkProposedApiEnabled)(n,"notebookMessaging"),N._proxy.$postMessage(P,te&&N._extHostNotebook.getIdByEditor(te),ce)},asWebviewUri(ce){return(0,u.checkProposedApiEnabled)(n,"notebookMessaging"),(0,c.asWebviewUri)(ce,N._initData.remote)}};return this._kernelData.set(P,{extensionId:n.identifier,controller:Q,onDidReceiveMessage:L,onDidChangeSelection:x,associatedNotebooks:J}),Q}getIdByController(n){for(const[s,a]of this._kernelData)if(a.controller===n)return d(a.extensionId,n.id);return null}$acceptNotebookAssociation(n,s,a){const o=this._kernelData.get(n);if(o){const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));a?o.associatedNotebooks.set(g.uri,!0):o.associatedNotebooks.delete(g.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,g.uri.toString(),a),o.onDidChangeSelection.fire({selected:a,notebook:g.apiNotebook})}}async $executeCells(n,s,a){const o=this._kernelData.get(n);if(!o)return;const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(s)),p=[];for(const P of a){const N=g.getCell(P);N&&p.push(N.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,g.uri.toString(),p.length),await o.controller.executeHandler.call(o.controller,p,g.apiNotebook,o.controller)}catch(P){this._logService.error(`NotebookController[${n}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(n,s,a){const o=this._kernelData.get(n);if(!o)return;const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(s));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,g.apiNotebook);else for(const p of a){const P=g.getCell(p);P&&this._activeExecutions.get(P.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,s,a){const o=this._kernelData.get(n);if(!o)return;const g=this._extHostNotebook.getEditorById(s);o.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:a}))}$cellExecutionChanged(n,s,a){const g=this._extHostNotebook.getNotebookDocument(E.URI.revive(n)).getCell(s);if(g){const p=a?T.NotebookCellExecutionState.to(a):f.NotebookCellExecutionState.Idle;p!==void 0&&this._onDidChangeCellExecutionState.fire({cell:g.apiCell,state:p})}}_createNotebookCellExecution(n,s){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const g=new w(s,o,this._proxy);this._activeExecutions.set(o.uri,g);const p=g.onDidChangeState(()=>{g.state===l.Resolved&&(g.dispose(),p.dispose(),this._activeExecutions.delete(o.uri))});return g.asApiObject()}};I=ze([$e(4,O.ILogService)],I),e.ExtHostNotebookKernels=I;var l;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(l||(l={}));class w extends _.Disposable{constructor(n,s,a){super(),this._cell=s,this._proxy=a,this._handle=w.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new S.CancellationTokenSource),this._collector=new t(10,o=>this.update(o)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,n,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const s=Array.isArray(n)?n:[n];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let s=this._cell;if(n&&(s=this._cell.notebook.getCellFromApiCell(n)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(n){return n.map(s=>{const a=f.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return a===s.items?T.NotebookCellOutput.from(s):T.NotebookCellOutput.from({items:a,id:s.id,metadata:s.metadata})})}async updateOutputs(n,s,a){const o=this.cellIndexToHandle(s),g=this.validateAndConvertOutputs((0,r.asArray)(n));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,cellHandle:o,append:a,outputs:g})}async updateOutputItems(n,s,a){return n=f.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(n),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:n.map(T.NotebookCellOutputItem.from),outputId:s.id,append:a})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(a){n._executionOrder=a,n.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:n._executionOrder}])},start(a){if(n._state===l.Resolved||n._state===l.Started)throw new Error("Cannot call start again");n._state=l.Started,n._onDidChangeState.fire(),n.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:a})},end(a,o){if(n._state===l.Resolved)throw new Error("Cannot call resolve twice");n._state=l.Resolved,n._onDidChangeState.fire(),n._collector.flush(),n._proxy.$completeExecution(n._handle,new v.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:a}))},clearOutput(a){return n.verifyStateForOutput(),n.updateOutputs([],a,!1)},appendOutput(a,o){return n.verifyStateForOutput(),n.updateOutputs(a,o,!0)},replaceOutput(a,o){return n.verifyStateForOutput(),n.updateOutputs(a,o,!1)},appendOutputItems(a,o){return n.verifyStateForOutput(),n.updateOutputItems(a,o,!0)},replaceOutputItems(a,o){return n.verifyStateForOutput(),n.updateOutputItems(a,o,!1)}})}}w.HANDLE=0;class t{constructor(n,s){this.delay=n,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new y.DeferredPromise,this.startedTimer=Date.now(),(0,y.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>n.complete())}}function d(i,n){return`${i.value}/${n}`}e.createKernelId=d}),define(Ce[208],Ie([1,0,5,4,93]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(y.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,E,k){const O=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(E)?.fire({editor:O.apiEditor,message:k})}createRendererMessaging(A,E){if(!A.contributes?.notebookRenderer?.some(O=>O.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(O,b,m)=>this.getOrCreateEmitterFor(E).event(O,b,m),postMessage:(O,b)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,b]=[b,O]);const m=b&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(m?.id,E,O)}}}getOrCreateEmitterFor(A){let E=this._rendererMessageEmitters.get(A);return E||(E=new r.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,E),E)}}e.ExtHostNotebookRenderers=M}),define(Ce[209],Ie([1,0,20,5,7,4,2,6,11,16,29,60]),function(ne,e,r,y,S,M,_,A,E,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(T,f,c){const h=T.getProxy(M.MainContext.MainThreadQuickOpen);class u{constructor(s,a){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=a}showQuickPick(s,a,o=r.CancellationToken.None){this._onDidSelectItem=void 0;const g=Promise.resolve(s),p=++this._instances,P=h.$show(p,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},o),N={},V=P.then(()=>N);return Promise.race([V,g]).then(U=>{if(U!==N)return g.then(D=>{const x=[];for(let L=0;L<D.length;L++){const R=D[L];typeof R=="string"?x.push({label:R,handle:L}):R.kind===A.QuickPickItemKind.Separator?x.push({type:"separator",label:R.label}):x.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:L})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=L=>{a.onDidSelectItem(D[L])}),h.$setItems(p,x),P.then(L=>{if(typeof L=="number")return D[L];if(Array.isArray(L))return L.map(R=>D[R])})})}).then(void 0,U=>{if(!(0,E.isCancellationError)(U))return h.$setError(p,U),Promise.reject(U)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,a=r.CancellationToken.None){return this._validateInput=s?.validateInput,h.$input(s,typeof this._validateInput=="function",a).then(void 0,o=>{if(!(0,E.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(s){if(!this._validateInput)return;const a=await this._validateInput(s);if(!a||typeof a=="string")return a;let o;switch(a.severity){case A.InputBoxValidationSeverity.Info:o=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:o=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:o=O.default.Error;break;default:o=a.message?O.default.Error:O.default.Ignore;break}return{content:a.message,severity:o}}async showWorkspaceFolderPick(s,a=r.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!o)return;const g=await this._workspace.getWorkspaceFolders2();if(!!g)return g.find(p=>p.uri.toString()===o.uri.toString())}createQuickPick(s){const a=new d(s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(s){const a=new i(s,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(s,a){this._sessions.get(s)?._fireDidChangeValue(a)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,a){const o=this._sessions.get(s);o instanceof d&&o._fireDidChangeActive(a)}$onDidChangeSelection(s,a){const o=this._sessions.get(s);o instanceof d&&o._fireDidChangeSelection(a)}$onDidTriggerButton(s,a){this._sessions.get(s)?._fireDidTriggerButton(a)}$onDidTriggerItemButton(s,a,o){const g=this._sessions.get(s);g instanceof d&&g._fireDidTriggerItemButton(a,o)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class v{constructor(s,a){this._extensionId=s,this._onDidDispose=a,this._id=d._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((a,o)=>{const g=a===A.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(g,a)}),this.update({buttons:s.map((a,o)=>({...t(a),tooltip:a.tooltip,handle:a===A.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const a=this._handlesToButtons.get(s);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),h.$dispose(this._id))}update(s){if(!this._disposed){for(const a of Object.keys(s)){const o=s[a];this._pendingUpdate[a]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){h.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function I(n){if(n instanceof A.ThemeIcon)return{id:n.id};const s=w(n),a=l(n);return{dark:typeof s=="string"?_.URI.file(s):s,light:typeof a=="string"?_.URI.file(a):a}}function l(n){return typeof n=="object"&&"light"in n?n.light:n}function w(n){return typeof n=="object"&&"dark"in n?n.dark:n}function t(n){const s=I(n.iconPath);let a,o;return"id"in s?o=b.ThemeIcon.asClassName(s):a=s,{iconPath:a,iconClass:o}}class d extends v{constructor(s,a){super(s.identifier,a),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((o,g)=>{this._handlesToItems.set(g,o),this._itemsToHandles.set(o,g)});const a=[];for(let o=0;o<s.length;o++){const g=s[o];g.kind===A.QuickPickItemKind.Separator?a.push({type:"separator",label:g.label}):a.push({handle:o,label:g.label,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,buttons:g.buttons?.map((p,P)=>({...t(p),tooltip:p.tooltip,handle:P}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(s){const a=(0,k.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(s){const a=(0,k.coalesce)(s.map(o=>this._handlesToItems.get(o)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(s,a){const o=this._handlesToItems.get(s);if(!o||!o.buttons||!o.buttons.length)return;const g=o.buttons[a];g&&this._onDidTriggerItemButtonEmitter.fire({button:g,item:o})}}class i extends v{constructor(s,a){super(s.identifier,a),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:O.default.Error}):this.update({validationMessage:s.message,severity:s.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new u(f,c)}e.createExtHostQuickOpen=m});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[210],Ie([1,0,2,5,55,7,14,4,16,117,15,27,60,8,25]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f){"use strict";var c,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function u(g){if(g)return typeof g.iconPath=="string"?r.URI.file(g.iconPath):r.URI.isUri(g.iconPath)||m.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function v(g,p){if(!g.iconPath&&!p.iconPath)return 0;if(g.iconPath){if(!p.iconPath)return 1}else return-1;const P=typeof g.iconPath=="string"?g.iconPath:r.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,N=typeof p.iconPath=="string"?p.iconPath:r.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id;return(0,k.comparePaths)(P,N)}function I(g,p){let P=0;if(g.strikeThrough!==p.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==p.faded)return g.faded?1:-1;if(g.tooltip!==p.tooltip)return(g.tooltip||"").localeCompare(p.tooltip||"");if(P=v(g,p),P!==0)return P;if(g.light&&p.light)P=v(g.light,p.light);else{if(g.light)return 1;if(p.light)return-1}if(P!==0)return P;if(g.dark&&p.dark)P=v(g.dark,p.dark);else{if(g.dark)return 1;if(p.dark)return-1}return P}function l(g,p){if(g.command!==p.command)return g.command<p.command?-1:1;if(g.title!==p.title)return g.title<p.title?-1:1;if(g.tooltip!==p.tooltip){if(g.tooltip!==void 0&&p.tooltip!==void 0)return g.tooltip<p.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(p.tooltip!==void 0)return-1}if(g.arguments===p.arguments)return 0;if(g.arguments)if(p.arguments){if(g.arguments.length!==p.arguments.length)return g.arguments.length-p.arguments.length}else return 1;else return-1;for(let P=0;P<g.arguments.length;P++){const N=g.arguments[P],V=p.arguments[P];if(N!==V)return N<V?-1:1}return 0}function w(g,p){let P=(0,k.comparePaths)(g.resourceUri.fsPath,p.resourceUri.fsPath,!0);if(P!==0)return P;if(g.command&&p.command)P=l(g.command,p.command);else{if(g.command)return 1;if(p.command)return-1}if(P!==0)return P;if(g.decorations&&p.decorations)P=I(g.decorations,p.decorations);else{if(g.decorations)return 1;if(p.decorations)return-1}return P}function t(g,p){for(let P=0;P<g.length;P++)if(g[P]!==p[P])return!1;return!0}function d(g,p){return g.command===p.command&&g.title===p.title&&g.tooltip===p.tooltip&&(g.arguments&&p.arguments?t(g.arguments,p.arguments):g.arguments===p.arguments)}function i(g,p){return(0,E.equals)(g,p,d)}class n{constructor(p,P,N){this._extension=p,this._sourceControlHandle=N,c.set(this,void 0),this._value="",this._onDidChange=new y.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,c,P,"f")}get value(){return this._value}set value(p){p=p??"",Oe(this,c,"f").$setInputBoxValue(this._sourceControlHandle,p),this.updateValue(p)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(p){Oe(this,c,"f").$setInputBoxPlaceholder(this._sourceControlHandle,p),this._placeholder=p}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(p){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),p&&typeof p!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=p,Oe(this,c,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!p)}get enabled(){return this._enabled}set enabled(p){p=!!p,this._enabled!==p&&(this._enabled=p,Oe(this,c,"f").$setInputBoxEnablement(this._sourceControlHandle,p))}get visible(){return this._visible}set visible(p){p=!!p,this._visible!==p&&(this._visible=p,Oe(this,c,"f").$setInputBoxVisibility(this._sourceControlHandle,p))}showValidationMessage(p,P){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,c,"f").$showValidationMessage(this._sourceControlHandle,p,P)}$onInputBoxValueChange(p){this.updateValue(p)}updateValue(p){this._value=p,this._onDidChange.fire(p)}}e.ExtHostSCMInputBox=n,c=new WeakMap;class s{constructor(p,P,N,V,U){this._proxy=p,this._commands=P,this._sourceControlHandle=N,this._id=V,this._label=U,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new y.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new y.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(p){this._label=p,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,p)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(p){this._hideWhenEmpty=p,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(p){this._resourceStates=[...p],this._onDidUpdateResourceStates.fire()}getResourceState(p){return this._resourceStatesMap.get(p)}$executeResourceCommand(p,P){const N=this._resourceStatesCommandsMap.get(p);return N?(0,_.asPromise)(()=>this._commands.executeCommand(N.command,...N.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const p=[...this._resourceStates].sort(w),N=(0,E.sortedDiff)(this._resourceSnapshot,p,w).map(D=>{const x=D.toInsert.map(L=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,L);const K=L.resourceUri;let W;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const Ee=new M.DisposableStore;W=this._commands.converter.toInternal(L.command,Ee),this._resourceStatesDisposablesMap.set(R,Ee)}else this._resourceStatesCommandsMap.set(R,L.command);const $=u(L.decorations),fe=L.decorations&&u(L.decorations.light)||$,J=L.decorations&&u(L.decorations.dark)||$,Q=[fe,J],ce=L.decorations&&L.decorations.tooltip||"",te=L.decorations&&!!L.decorations.strikeThrough,pe=L.decorations&&!!L.decorations.faded,be=L.contextValue||"";return{rawResource:[R,K,Q,ce,te,pe,be,W],handle:R}});return{start:D.start,deleteCount:D.deleteCount,toInsert:x}}),V=N.map(({start:D,deleteCount:x,toInsert:L})=>[D,x,L.map(R=>R.rawResource)]),U=N.reverse();for(const{start:D,deleteCount:x,toInsert:L}of U){const R=L.map(W=>W.handle),K=this._handlesSnapshot.splice(D,x,...R);for(const W of K)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=p,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class a{constructor(p,P,N,V,U,D){this._extension=p,this._commands=N,this._id=V,this._label=U,this._rootUri=D,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new y.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=a._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,h,P,"f"),this._inputBox=new n(p,Oe(this,h,"f"),this.handle),Oe(this,h,"f").$registerSourceControl(this.handle,V,U,D)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(p){this._count!==p&&(this._count=p,Oe(this,h,"f").$updateSourceControl(this.handle,{count:p}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(p){this._quickDiffProvider=p,Oe(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!p})}get commitTemplate(){return this._commitTemplate}set commitTemplate(p){p!==this._commitTemplate&&(this._commitTemplate=p,Oe(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:p}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(p){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=p;const P=this._commands.converter.toInternal(p,this._acceptInputDisposables.value);Oe(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:P})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(p){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=p;const P=p!==void 0?{command:this._commands.converter.toInternal(p.command,this._actionButtonDisposables.value),secondaryCommands:p.secondaryCommands?.map(N=>N.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:p.description,enabled:p.enabled}:void 0;Oe(this,h,"f").$updateSourceControl(this.handle,{actionButton:P??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(p){if(this._statusBarCommands&&p&&i(this._statusBarCommands,p))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=p;const P=(p||[]).map(N=>this._commands.converter.toInternal(N,this._statusBarDisposables.value));Oe(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:P})}get selected(){return this._selected}createResourceGroup(p,P){const N=new s(Oe(this,h,"f"),this._commands,this.handle,p,P),V=y.Event.once(N.onDidDispose)(()=>this.createdResourceGroups.delete(N));return this.createdResourceGroups.set(N,V),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const p=[],P=[];for(const[N,V]of this.createdResourceGroups){V.dispose();const U=N.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(N),this.eventuallyUpdateResourceStates()});y.Event.once(N.onDidDispose)(()=>{this.updatedResourceGroups.delete(N),U.dispose(),this._groups.delete(N.handle),Oe(this,h,"f").$unregisterGroup(this.handle,N.handle)}),p.push([N.handle,N.id,N.label,N.features]);const D=N._takeResourceStateSnapshot();D.length>0&&P.push([N.handle,D]),this._groups.set(N.handle,N)}Oe(this,h,"f").$registerGroups(this.handle,p,P),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const p=[];this.updatedResourceGroups.forEach(P=>{const N=P._takeResourceStateSnapshot();N.length!==0&&p.push([P.handle,N])}),p.length>0&&Oe(this,h,"f").$spliceResourceStates(this.handle,p),this.updatedResourceGroups.clear()}getResourceGroup(p){return this._groups.get(p)}setSelectionState(p){this._selected=p,this._onDidChangeSelection.fire(p)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(p=>p.dispose()),Oe(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,a._handlePool=0,ze([(0,S.debounce)(100)],a.prototype,"eventuallyAddResourceGroups",null),ze([(0,S.debounce)(100)],a.prototype,"eventuallyUpdateResourceStates",null);let o=class Yi{constructor(p,P,N){this._commands=P,this.logService=N,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new y.Emitter,this._proxy=p.getProxy(A.MainContext.MainThreadSCM),this._telemetry=p.getProxy(A.MainContext.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const U=this._sourceControls.get(V.sourceControlHandle);if(!U)return V;const D=U.getResourceGroup(V.groupHandle);return D?D.getResourceState(V.handle):V}else if(V&&V.$mid===4){const U=this._sourceControls.get(V.sourceControlHandle);return U?U.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const U=this._sourceControls.get(V.handle);return U||V}return V}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(p,P,N,V){this.logService.trace("ExtHostSCM#createSourceControl",p.identifier.value,P,N,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:p.identifier.value});const U=Yi._handlePool++,D=new a(p,this._proxy,this._commands,P,N,V);this._sourceControls.set(U,D);const x=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier))||[];return x.push(D),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(p.identifier),x),D}getLastInputBox(p){this.logService.trace("ExtHostSCM#getLastInputBox",p.identifier.value);const P=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(p.identifier)),N=P&&P[P.length-1];return N&&N.inputBox}$provideOriginalResource(p,P,N){const V=r.URI.revive(P);this.logService.trace("ExtHostSCM#$provideOriginalResource",p,V.toString());const U=this._sourceControls.get(p);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>U.quickDiffProvider.provideOriginalResource(V,N)).then(D=>D||null)}$onInputBoxValueChange(p,P){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",p);const N=this._sourceControls.get(p);return N&&N.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(p,P,N,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",p,P,N);const U=this._sourceControls.get(p);if(!U)return Promise.resolve(void 0);const D=U.getResourceGroup(P);return D?D.$executeResourceCommand(N,V):Promise.resolve(void 0)}$validateInput(p,P,N){this.logService.trace("ExtHostSCM#$validateInput",p);const V=this._sourceControls.get(p);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>V.inputBox.validateInput(P,N)).then(U=>{if(!U)return Promise.resolve(void 0);const D=T.MarkdownString.fromStrict(U.message);return D?Promise.resolve([D,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(p){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",p),p!==void 0&&this._sourceControls.get(p)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=p,Promise.resolve(void 0)}};o._handlePool=0,o=ze([$e(2,O.ILogService)],o),e.ExtHostSCM=o}),define(Ce[68],Ie([1,0,4,5,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new y.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,E){return this._proxy.$getPassword(A,E)}store(A,E,k){return this._proxy.$setPassword(A,E,k)}delete(A,E){return this._proxy.$deletePassword(A,E)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,S.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[211],Ie([1,0,6,4,132,7,8,10]),function(ne,e,r,y,S,M,_,A){"use strict";var E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(f,c,h,u,v=r.StatusBarAlignment.Left,I){E.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Je(this,E,f,"f"),Je(this,k,c,"f"),this._entryId=O.ID_GEN++,this._extension=h,this._id=u,this._alignment=v,this._priority=this.validatePriority(I)}validatePriority(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!O.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,k,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,k,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let c;this._name?c=this._name:c=(0,S.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const u=_.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,f,c,this._text,u,this._command?.internal,h,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,E=new WeakMap,k=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,S.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const c={message:f};return this._messages.unshift(c),this._update(),new r.Disposable(()=>{const h=this._messages.indexOf(c);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,c){this._proxy=f.getProxy(y.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new b(this)}createStatusBarEntry(f,c,h,u){return new O(this._proxy,this._commands,f,c,h,u)}setStatusBarMessage(f,c){const h=this._statusMessage.setMessage(f);let u;return typeof c=="number"?u=setTimeout(()=>h.dispose(),c):typeof c<"u"&&c.then(()=>h.dispose(),()=>h.dispose()),new r.Disposable(()=>{h.dispose(),clearTimeout(u)})}}e.ExtHostStatusBar=m}),define(Ce[69],Ie([1,0,4,5,3]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new y.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,E){this._proxy.$registerExtensionStorageKeysToSync(A,E)}initializeExtensionStorage(A,E,k){return this._proxy.$initializeExtensionStorage(A,E).then(O=>O||k)}setValue(A,E,k){return this._proxy.$setValue(A,E,k)}$acceptValue(A,E,k){this._onDidChangeStorage.fire({shared:A,key:E,value:k})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,S.createDecorator)("IExtHostStorage")}),define(Ce[70],Ie([1,0,3,28,15,52,2]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let A=class{constructor(k,O,b){this._logService=O,this._extHostFileSystem=b,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(k){return _.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,O=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:_.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(k){if(this._value)return _.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return _.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=ze([$e(0,y.IExtHostInitDataService),$e(1,S.ILogService),$e(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ce[97],Ie([1,0,3,4,13]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,r.createDecorator)("IExtHostTelemetryLogService");let M=class{constructor(A){this._telemetryShape=A.getProxy(y.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(A,E,k){this._telemetryShape.$logTelemetryToOutputChannel(`${A.identifier.value}/${E}`,k)}};M=ze([$e(0,S.IExtHostRpcService)],M),e.ExtHostTelemetryLogService=M}),define(Ce[53],Ie([1,0,5,4,3,2,13,7,6,133,11,167,20,42,153,60,10,14,8]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,S.createDecorator)("IExtHostTerminalService");class I{constructor(o,g,p,P){this._proxy=o,this._id=g,this._creationOptions=p,this._name=P,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(V=>this._pidPromiseComplete=V);const N=this;this.value={get name(){return N._name||""},get processId(){return N._pidPromise},get creationOptions(){return N._creationOptions},get exitStatus(){return N._exitStatus},get state(){return N._state},sendText(V,U=!0){N._checkDisposed(),N._proxy.$sendText(N._id,V,U)},show(V){N._checkDisposed(),N._proxy.$show(N._id,V)},hide(){N._checkDisposed(),N._proxy.$hide(N._id)},dispose(){N._disposed||(N._disposed=!0,N._proxy.$dispose(N._id))},get dimensions(){if(!(N._cols===void 0||N._rows===void 0))return{columns:N._cols,rows:N._rows}}}}async create(o,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,h.withNullAsUndefined)(o.shellPath),shellArgs:(0,h.withNullAsUndefined)(o.shellArgs),cwd:(0,h.withNullAsUndefined)(o.cwd),env:(0,h.withNullAsUndefined)(o.env),icon:(0,h.withNullAsUndefined)(n(o.iconPath)),color:c.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,h.withNullAsUndefined)(o.message),strictEnv:(0,h.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(g?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(g?.useShellEnvironment),location:g?.location||this._serializeParentTerminal(o.location,g?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,g,p,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:c.ThemeColor.isThemeColor(P)?P.id:void 0,location:this._serializeParentTerminal(o,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,g){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in o?{viewColumn:v.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,g){this._exitStatus=Object.freeze({code:o,reason:g})}setDimensions(o,g){return o===this._cols&&g===this._rows||o===0||g===0?!1:(this._cols=o,this._rows=g,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(g=>{g!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=I;class l{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${g}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,g){this._pty.setDimensions?.({columns:o,rows:g})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(g=>this._onProcessData.fire(g)),this._pty.onDidClose?.((g=void 0)=>{this._onProcessExit.fire(g===void 0?void 0:g)}),this._pty.onDidOverrideDimensions?.(g=>{g&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this._pty.onDidChangeName?.(g=>{this._onDidChangeProperty.fire({type:"title",value:g})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=l;let w=1,t=class extends A.Disposable{constructor(o,g){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=g.getProxy(y.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[p,P]of this._terminalProcesses)P.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,g){const p=new I(this._proxy,(0,T.generateUuid)(),o,o.name),P=new l(o.pty);return p.createExtensionTerminal(o.location,this._serializeParentTerminal(o,g).resolvedExtHostIdentifier,n(o.iconPath),s(o.color)).then(N=>{const V=this._setupExtHostProcessListeners(N,P);this._terminalProcessDisposables[N]=V}),this._terminals.push(p),p.value}_serializeParentTerminal(o,g){if(g=g||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const p=o.location.parentTerminal;if(p){const P=this._terminals.find(N=>N.value===p);P&&(g.resolvedExtHostIdentifier=P._id)}}else o.location&&typeof o.location!="object"?g.location=o.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(o,g){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const P=new l(g),N=this._setupExtHostProcessListeners(o,P);this._terminalProcessDisposables[o]=N}async $acceptActiveTerminalChanged(o){const g=this._activeTerminal;if(o===null){this._activeTerminal=void 0,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(o);p&&(this._activeTerminal=p,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,g){const p=this._getTerminalById(o);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:g})}async $acceptTerminalDimensions(o,g,p){const P=this._getTerminalById(o);P&&P.setDimensions(g,p)&&this._onDidChangeTerminalDimensions.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptTerminalMaximumDimensions(o,g,p){this._terminalProcesses.get(o)?.resize(g,p)}async $acceptTerminalTitleChange(o,g){const p=this._getTerminalById(o);p&&(p.name=g)}async $acceptTerminalClosed(o,g,p){const P=this._getTerminalObjectIndexById(this._terminals,o);if(P!==null){const N=this._terminals.splice(P,1)[0];N.setExitStatus(g,p),this._onDidCloseTerminal.fire(N.value)}}$acceptTerminalOpened(o,g,p,P){if(g){const U=this._getTerminalObjectIndexById(this._terminals,g);if(U!==null){this._terminals[U]._id=o,this._onDidOpenTerminal.fire(this.terminals[U]),this._terminals[U].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:M.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},V=new I(this._proxy,o,N,p);this._terminals.push(V),this._onDidOpenTerminal.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(o,g){this._getTerminalById(o)?._setProcessId(g)}async $startExtensionTerminal(o,g){const p=this._getTerminalById(o);if(!p)return{message:(0,k.localize)(0,null,o)};p.isOpen||await new Promise(N=>{const V=this.onDidOpenTerminal(async U=>{U===p.value&&(V.dispose(),N())})});const P=this._terminalProcesses.get(o);P?P.startSendingEvents(g):this._extensionTerminalAwaitingStart[o]={initialDimensions:g}}_setupExtHostProcessListeners(o,g){const p=new A.DisposableStore;p.add(g.onProcessReady(N=>this._proxy.$sendProcessReady(o,N.pid,N.cwd))),p.add(g.onDidChangeProperty(N=>this._proxy.$sendProcessProperty(o,N))),this._bufferer.startBuffering(o,g.onProcessData),p.add(g.onProcessExit(N=>this._onProcessExit(o,N))),this._terminalProcesses.set(o,g);const P=this._extensionTerminalAwaitingStart[o];return P&&g instanceof l&&(g.startSendingEvents(P.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),p}$acceptProcessAckDataEvent(o,g){this._terminalProcesses.get(o)?.acknowledgeDataEvent(g)}$acceptProcessInput(o,g){this._terminalProcesses.get(o)?.input(g)}$acceptTerminalInteraction(o){const g=this._getTerminalById(o);g?.setInteractedWith()&&this._onDidChangeTerminalState.fire(g.value)}$acceptProcessResize(o,g,p){try{this._terminalProcesses.get(o)?.resize(g,p)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(o,g){this._terminalProcesses.get(o)?.shutdown(g)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(g=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(g=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:g}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,g,p){if(this._profileProviders.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this._profileProviders.set(g,p),this._proxy.$registerProfileProvider(g,o.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(g),this._proxy.$unregisterProfileProvider(g)})}async $createContributedProfileTerminal(o,g){const p=new m.CancellationTokenSource().token;let P=await this._profileProviders.get(o)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,g);return}this.createTerminalFromOptions(P.options,g)}}async $provideLinks(o,g){const p=this._getTerminalById(o);if(!p)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const N=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,N);const V=[],U={terminal:p.value,line:g},D=[];for(const R of this._linkProviders)D.push(u.Promises.withAsyncBody(async K=>{N.token.onCancellationRequested(()=>K({provider:R,links:[]}));const W=await R.provideTerminalLinks(U,N.token)||[];N.token.isCancellationRequested||K({provider:R,links:W})}));const x=await Promise.all(D);if(N.token.isCancellationRequested)return[];const L=new Map;for(const R of x)R&&R.links.length>0&&V.push(...R.links.map(K=>{const W={id:w++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return L.set(W.id,{provider:R.provider,link:K}),W}));return this._terminalLinkCache.set(o,L),V}$activateLink(o,g){const p=this._terminalLinkCache.get(o)?.get(g);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(o,g){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const p=this._terminalProcessDisposables[o];p&&(p.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,g)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,g){const p=this._getTerminalObjectIndexById(o,g);return p!==null?o[p]:null}_getTerminalObjectIndexById(o,g){let p=null;return o.some((P,N)=>P._id===g?(p=N,!0):!1),p}getEnvironmentVariableCollection(o){let g=this._environmentVariableCollections.get(o.identifier.value);return g||(g=new d,this._setEnvironmentVariableCollection(o.identifier.value,g)),g}_syncEnvironmentVariableCollection(o,g){const p=(0,b.serializeEnvironmentVariableCollection)(g.map);this._proxy.$setEnvironmentVariableCollection(o,g.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(o){o.forEach(g=>{const p=g[0],P=new d(g[1]);this._setEnvironmentVariableCollection(p,P)})}$acceptDefaultProfile(o,g){this._defaultProfile=o,this._defaultAutomationProfile=g}_setEnvironmentVariableCollection(o,g){this._environmentVariableCollections.set(o,g),g.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,g)})}};t=ze([$e(1,_.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class d{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,g){this._setIfDiffers(o,{value:g,type:E.EnvironmentVariableMutatorType.Replace})}append(o,g){this._setIfDiffers(o,{value:g,type:E.EnvironmentVariableMutatorType.Append})}prepend(o,g){this._setIfDiffers(o,{value:g,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,g){const p=this.map.get(o);(!p||p.value!==g.value||p.type!==g.type)&&(this.map.set(o,g),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,g){this.map.forEach((p,P)=>o.call(g,P,p,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let i=class extends t{constructor(o){super(!1,o)}createTerminal(o,g,p){throw new O.NotSupportedError}createTerminalFromOptions(o,g){throw new O.NotSupportedError}};i=ze([$e(0,_.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function n(a){if(!(!a||typeof a=="string"))return"id"in a?{id:a.id,color:a.color}:a}function s(a){return c.ThemeColor.isThemeColor(a)?a:void 0}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[212],Ie([1,0,16,23,20,5,176,213,7,26,10,42,4,13,94,8,6,47,65,48]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I){"use strict";var l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let t=class{constructor(U,D,x){this.editors=x,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=U.getProxy(m.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new i(this.proxy),D.registerArgumentProcessor({processArgument:L=>L?.$mid===13?(0,f.toItemFromContext)(L):L})}createTestController(U,D,x){if(this.controllers.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const L=new E.DisposableStore,R=L.add(new f.ExtHostTestItemCollection(U,D,this.editors));R.root.label=D;const K=new Map,W=this.proxy,$={items:R.root.children,get label(){return D},set label(J){D=J,R.root.label=J,W.$updateController(U,{label:D})},get refreshHandler(){return x},set refreshHandler(J){x=J,W.$updateController(U,{canRefresh:!!J})},get id(){return U},createRunProfile:(J,Q,ce,te,pe)=>{let be=(0,A.hash)(J);for(;K.has(be);)be++;return new P(this.proxy,K,U,be,J,Q,ce,te,pe)},createTestItem(J,Q,ce){return new f.TestItemImpl(U,J,Q,ce)},createTestRun:(J,Q,ce=!0)=>this.runTracker.createTestRun(U,R,J,Q,ce),set resolveHandler(J){R.resolveHandler=J},get resolveHandler(){return R.resolveHandler},dispose:()=>{L.dispose()}};W.$registerTestController(U,D,!!x),L.add((0,E.toDisposable)(()=>W.$unregisterTestController(U)));const fe={controller:$,collection:R,profiles:K};return this.controllers.set(U,fe),L.add((0,E.toDisposable)(()=>this.controllers.delete(U))),L.add(R.onDidGenerateDiff(J=>W.$publishDiff(U,J.map(I.TestsDiffOp.serialize)))),$}createTestObserver(){return this.observer.checkout()}async runTests(U,D=S.CancellationToken.None){const x=n(U);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const L=this.controllers.get(x.controllerId);if(!L)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(R=>u.TestId.fromExtHostTestItem(R,L.collection.root.id).toString())??[L.collection.root.id],profileGroup:N[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:U.exclude?.map(R=>R.id)},D)}$provideFileCoverage(U,D,x){return(0,r.mapFind)(this.runTracker.trackers,R=>R.id===U?R.getCoverage(D):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(U,D,x,L){return(0,r.mapFind)(this.runTracker.trackers,K=>K.id===U?K.getCoverage(D):void 0)?.resolveFileCoverage(x,L)??Promise.resolve([])}$configureRunProfile(U,D){this.controllers.get(U)?.profiles.get(D)?.configureHandler?.()}async $refreshTests(U,D){await this.controllers.get(U)?.controller.refreshHandler?.(D)}$publishTestResults(U){this.results=Object.freeze(U.map(D=>(0,k.deepFreeze)(c.TestResults.to(D))).concat(this.results).sort((D,x)=>x.completedAt-D.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(U,D){const x=this.controllers.get(u.TestId.fromString(U).controllerId)?.collection;x&&(await x.expand(U,D<0?1/0:D),x.flushDiff())}$acceptDiff(U){this.observer.applyDiff(U.map(I.TestsDiffOp.deserialize))}async $runControllerTests(U,D){return Promise.all(U.map(x=>this.runControllerTestRequest(x,D)))}async runControllerTestRequest(U,D){const x=this.controllers.get(U.controllerId);if(!x)return{};const{collection:L,profiles:R}=x,K=R.get(U.profileId);if(!K)return{};const W=U.testIds.map(Q=>L.tree.get(Q)).filter(O.isDefined),$=U.excludeExtIds.map(Q=>x.collection.tree.get(Q)).filter(O.isDefined).filter(Q=>W.some(ce=>ce.fullId.compare(Q.fullId)===2));if(!W.length)return{};const fe=new h.TestRunRequest(W.some(Q=>Q.actual instanceof f.TestItemRootImpl)?void 0:W.map(Q=>Q.actual),$.map(Q=>Q.actual),K),J=this.runTracker.prepareForMainThreadTestRun(fe,s.fromInternal(U,x.collection),D);try{return await K.runHandler(fe,D),{}}catch(Q){return{error:String(Q)}}finally{J.isRunning&&!D.isCancellationRequested&&await M.Event.toPromise(J.onEnd),J.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(U)}};t=ze([$e(0,T.IExtHostRpcService)],t),e.ExtHostTesting=t;class d extends E.Disposable{constructor(U,D,x){super(),this.dto=U,this.proxy=D,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:L}of this.tasks.values())L.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(U){return this.tasks.get(U)?.coverage}createRun(U){const D=this.dto.id,x=this.dto.controllerId,L=(0,b.generateUuid)(),R=new a(this.proxy,D,L),K=J=>(Q,...ce)=>{if($){console.warn(`Setting the state of test "${Q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Q)||(this.ensureTestIsKnown(Q),J(Q,...ce))},W=(J,Q)=>{const ce=Q instanceof Array?Q.map(c.TestMessage.from):[c.TestMessage.from(Q)];if(J.uri&&J.range){const te={range:c.Range.from(J.range),uri:J.uri};for(const pe of ce)pe.location=pe.location||te}this.proxy.$appendTestMessagesInRun(D,L,u.TestId.fromExtHostTestItem(J,x).toString(),ce)};let $=!1;const fe={isPersisted:this.dto.isPersisted,token:this.cts.token,name:U,get coverageProvider(){return R.coverageProvider},set coverageProvider(J){R.coverageProvider=J},enqueued:K(J=>{this.proxy.$updateTestStateInRun(D,L,u.TestId.fromExtHostTestItem(J,x).toString(),1)}),skipped:K(J=>{this.proxy.$updateTestStateInRun(D,L,u.TestId.fromExtHostTestItem(J,x).toString(),5)}),started:K(J=>{this.proxy.$updateTestStateInRun(D,L,u.TestId.fromExtHostTestItem(J,x).toString(),2)}),errored:K((J,Q,ce)=>{W(J,Q),this.proxy.$updateTestStateInRun(D,L,u.TestId.fromExtHostTestItem(J,x).toString(),6,ce)}),failed:K((J,Q,ce)=>{W(J,Q),this.proxy.$updateTestStateInRun(D,L,u.TestId.fromExtHostTestItem(J,x).toString(),4,ce)}),passed:K((J,Q)=>{this.proxy.$updateTestStateInRun(D,L,u.TestId.fromExtHostTestItem(J,this.dto.controllerId).toString(),3,Q)}),appendOutput:(J,Q,ce)=>{$||(ce&&(this.dto.isIncluded(ce)?this.ensureTestIsKnown(ce):ce=void 0),this.proxy.$appendOutputToRun(D,L,y.VSBuffer.fromString(J),Q&&c.location.from(Q),ce&&u.TestId.fromExtHostTestItem(ce,x).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(D,L),this.tasks.delete(L),this.isRunning||this.dispose())}};return this.tasks.set(L,{run:fe,coverage:R}),this.proxy.$startedTestRunTask(D,{id:L,name:U,running:!0}),fe}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(U){if(!(U instanceof f.TestItemImpl))throw new v.InvalidTestItemError(U.id);if(this.sharedTestIds.has(u.TestId.fromExtHostTestItem(U,this.dto.controllerId).toString()))return;const D=[],x=this.dto.colllection.root;for(;;){const L=c.TestItem.from(U);if(D.unshift(L),this.sharedTestIds.has(L.extId)||(this.sharedTestIds.add(L.extId),U===x))break;U=U.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,D)}}class i{constructor(U){this.proxy=U,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(U,D,x){return this.getTracker(U,D,x)}cancelRunById(U){for(const D of this.tracked.values())if(D.id===U){D.dispose();return}}cancelAllRuns(){for(const U of this.tracked.values())U.dispose()}createTestRun(U,D,x,L,R){const K=this.tracked.get(x);if(K)return K.createRun(L);const W=s.fromPublic(U,D,x,R),$=n(x);this.proxy.$startedExtensionTestRun({controllerId:U,profile:$&&{group:N[$.kind],id:$.profileId},exclude:x.exclude?.map(J=>u.TestId.fromExtHostTestItem(J,D.root.id).toString())??[],id:W.id,include:x.include?.map(J=>u.TestId.fromExtHostTestItem(J,D.root.id).toString())??[D.root.id],persist:R});const fe=this.getTracker(x,W);return fe.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),fe.createRun(L)}getTracker(U,D,x){const L=new d(D,this.proxy,x);return this.tracked.set(U,L),L.onEnd(()=>this.tracked.delete(U)),L}}e.TestRunCoordinator=i;const n=V=>{if(!!V.profile){if(!(V.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class s{constructor(U,D,x,L,R,K){this.controllerId=U,this.id=D,this.isPersisted=R,this.colllection=K,this.includePrefix=x.map(W=>W+"\0"),this.excludePrefix=L.map(W=>W+"\0")}static fromPublic(U,D,x,L){return new s(U,(0,b.generateUuid)(),x.include?.map(R=>u.TestId.fromExtHostTestItem(R,U).toString())??[U],x.exclude?.map(R=>u.TestId.fromExtHostTestItem(R,U).toString())??[],L,D)}static fromInternal(U,D){return new s(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,D)}isIncluded(U){const D=u.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(D===x||D.startsWith(x))return!1;for(const x of this.includePrefix)if(D===x||D.startsWith(x))return!0;return!1}}e.TestRunDto=s;class a{constructor(U,D,x){this.proxy=U,this.runId=D,this.taskId=x}set coverageProvider(U){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this._coverageProvider=U,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(U){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(U))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(D){throw this.fileCoverage=void 0,D}}async resolveFileCoverage(U,D){const x=await this.fileCoverage;let L=x?.[U];return!this._coverageProvider||!x||!L?[]:(L.detailedCoverage||(L=x[U]=await this._coverageProvider.resolveFileCoverage?.(L,D)??L),L.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class o extends I.IncrementalChangeCollector{constructor(U){super(),this.emitter=U,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(U){this.added.add(U)}update(U){Object.assign(U.revived,c.TestItem.toPlain(U.item)),this.added.has(U)||this.updated.add(U)}remove(U){if(this.added.has(U)){this.added.delete(U);return}if(this.updated.delete(U),U.parent&&this.alreadyRemoved.has(U.parent)){this.alreadyRemoved.add(U.item.extId);return}this.removed.add(U)}getChangeEvent(){const{added:U,updated:D,removed:x}=this;return{get added(){return[...U].map(L=>L.revived)},get updated(){return[...D].map(L=>L.revived)},get removed(){return[...x].map(L=>L.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends I.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(U){return this.items.get(U)}getMirroredTestDataByReference(U){return this.items.get(U.id)}createItem(U,D){return{...U,revived:c.TestItem.toPlain(U.item),depth:D?D.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=g;class p{constructor(U){this.proxy=U}checkout(){this.current||(this.current=this.createObserverData());const U=this.current;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(D=>D.revived)},dispose:(0,_.once)(()=>{--U.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(U){return this.current?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.current?.tests.apply(U)}createObserverData(){const U=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:U}}}class P{constructor(U,D,x,L,R,K,W,$=!1,fe=void 0){this.controllerId=x,this.profileId=L,this._label=R,this.kind=K,this.runHandler=W,this._isDefault=$,this._tag=fe,l.set(this,void 0),w.set(this,void 0),Je(this,l,U,"f"),Je(this,w,D,"f"),D.set(L,this);const J=N[K];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,l,"f").$publishTestRunProfile({profileId:L,controllerId:x,tag:fe?c.TestTag.namespace(this.controllerId,fe.id):null,label:R,group:J,isDefault:$,hasConfigurationHandler:!1})}get label(){return this._label}set label(U){U!==this._label&&(this._label=U,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this._isDefault}set isDefault(U){U!==this._isDefault&&(this._isDefault=U,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?c.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(U){U!==this._configureHandler&&(this._configureHandler=U,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}dispose(){Oe(this,w,"f")?.delete(this.profileId)&&(Je(this,w,void 0,"f"),Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=P,l=new WeakMap,w=new WeakMap;const N={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(Ce[214],Ie([1,0,16,5,4,95,8,6]),function(ne,e,r,y,S,M,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(O,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new y.Emitter,this._onDidChangeTextEditorOptions=new y.Emitter,this._onDidChangeTextEditorVisibleRanges=new y.Emitter,this._onDidChangeTextEditorViewColumn=new y.Emitter,this._onDidChangeActiveTextEditor=new y.Emitter,this._onDidChangeVisibleTextEditors=new y.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const b=this._extHostDocumentsAndEditors.allEditors();return O?b:b.map(m=>m.value)}async showTextDocument(O,b,m){let T;typeof b=="number"?T={position:_.ViewColumn.from(b),preserveFocus:m}:typeof b=="object"?T={position:_.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?_.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:T={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(O.uri,T),c=f&&this._extHostDocumentsAndEditors.getEditor(f);if(c)return c.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,b){return new M.TextEditorDecorationType(this._proxy,O,b).value}$acceptEditorPropertiesChanged(O,b){const m=this._extHostDocumentsAndEditors.getEditor(O);if(!m)throw new Error("unknown text editor");if(b.options&&m._acceptOptions(b.options),b.selections){const T=b.selections.selections.map(_.Selection.to);m._acceptSelections(T)}if(b.visibleRanges){const T=r.coalesce(b.visibleRanges.map(_.Range.to));m._acceptVisibleRanges(T)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...b.options,lineNumbers:_.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const T=A.TextEditorSelectionChangeKind.fromValue(b.selections.source),f=b.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:T})}if(b.visibleRanges){const T=r.coalesce(b.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:T})}}$acceptEditorPositionData(O){for(const b in O){const m=this._extHostDocumentsAndEditors.getEditor(b);if(!m)throw new Error("Unknown text editor");const T=_.ViewColumn.to(O[b]);m.value.viewColumn!==T&&(m._acceptViewColumn(T),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:T}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=E}),define(Ce[215],Ie([1,0,2,3,4,7,6,8,10]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,y.createDecorator)("IExtHostTimeline");class k{constructor(m,T){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(S.MainContext.MainThreadTimeline),T.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const c=f.uri===void 0?void 0:r.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(O(c))?.get(f.handle)}return f}})}async $getTimeline(m,T,f,c){return this._providers.get(m)?.provideTimeline(r.URI.revive(T),f,c)}registerTimelineProvider(m,T,f,c){const h=new M.DisposableStore,u=this.convertTimelineItem(T.id,c,h).bind(this);let v;T.onDidChange&&(v=T.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:T.id}),this));const I=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...T,scheme:m,onDidChange:void 0,async provideTimeline(l,w,t){w?.resetCache&&(h.clear(),I.get(T.id)?.clear());const d=await T.provideTimeline(l,w,t);if(d==null)return;const i=u(l,w);return{...d,source:T.id,items:d.items.map(i)}},dispose(){for(const l of I.values())l.get(T.id)?.clear();v?.dispose(),h.dispose()}})}convertTimelineItem(m,T,f){return(c,h)=>{let u;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(m);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(m,v));const I=O(c);u=v.get(I),u===void 0&&(u=new Map,v.set(I,u))}return v=>{const{iconPath:I,...l}=v,w=`${m}|${v.id??v.timestamp}`;u?.set(w,v);let t,d,i;v.iconPath&&(I instanceof _.ThemeIcon?i={id:I.id,color:I.color}:r.URI.isUri(I)?(t=I,d=I):{light:t,dark:d}=I);let n;return _.MarkdownString.isMarkdownString(l.tooltip)?n=A.MarkdownString.from(l.tooltip):(0,E.isString)(l.tooltip)?n=l.tooltip:_.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=A.MarkdownString.from(l.detail)):(0,E.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),n=l.detail),{...l,id:l.id??void 0,handle:w,source:m,command:v.command?T.toInternal(v.command,f):void 0,icon:t,iconDark:d,themeIcon:i,tooltip:n,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=k;function O(b){return b?.toString()}}),define(Ce[216],Ie([1,0,7,12,2,4]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(E){this._openers=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,O,b){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=b.schemes.find(T=>!_.supportedSchemes.has(T));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,O),this._proxy.$registerUriOpener(k,b.schemes,E,b.label),(0,r.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,O){const b=this._openers.get(E);if(!b)throw new Error(`Unknown opener with id: ${E}`);const m=S.URI.revive(k);return b.canOpenExternalUri(m,O)}async $openUri(E,k,O){const b=this._openers.get(E);if(!b)throw new Error(`Unknown opener id: '${E}'`);return b.openExternalUri(S.URI.revive(k.resolvedUri),{sourceUri:S.URI.revive(k.sourceUri)},O)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([y.Schemas.http,y.Schemas.https])}),define(Ce[217],Ie([1,0,4,2,7,11,27]),function(ne,e,r,y,S,M,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(k,O){if(this.handles.has(_.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const b=A.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(k)),this.handlers.set(b,O),this._proxy.$registerUriHandler(b,k),(0,S.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(k)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(k,O){const b=this.handlers.get(k);if(!b)return Promise.resolve(void 0);try{b.handleUri(y.URI.revive(O))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(k){return y.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=A,A.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[54],Ie([1,0,5,12,2,144,160,63,4]),function(ne,e,r,y,S,M,_,A,E){"use strict";var k,O,b,m,T,f,c,h,u,v,I,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class w{constructor(g,p,P,N,V,U,D){k.set(this,void 0),O.set(this,void 0),b.set(this,void 0),m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),c.set(this,""),h.set(this,void 0),u.set(this,!1),v.set(this,!1),I.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new r.Emitter),this._onDidDispose=Oe(this,l,"f").event,Je(this,k,g,"f"),Je(this,O,p,"f"),Je(this,h,P,"f"),Je(this,m,N,"f"),Je(this,T,V,"f"),Je(this,f,U,"f"),Je(this,I,t(U),"f"),Je(this,b,D,"f")}dispose(){Je(this,u,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return Je(this,v,!0,"f"),(0,A.asWebviewUri)(g,Oe(this,m,"f"))}get cspSource(){const g=Oe(this,f,"f").extensionLocation;if(g.scheme===y.Schemas.https||g.scheme===y.Schemas.http){let p=g.toString();return p.endsWith("/")||(p+="/"),p+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,c,"f")}set html(g){this.assertNotDisposed(),Oe(this,c,"f")!==g&&(Je(this,c,g,"f"),!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(Je(this,v,!0,"f"),Oe(this,b,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,O,"f").$setHtml(Oe(this,k,"f"),g))}get options(){return this.assertNotDisposed(),Oe(this,h,"f")}set options(g){this.assertNotDisposed(),Oe(this,O,"f").$setOptions(Oe(this,k,"f"),n(Oe(this,f,"f"),Oe(this,T,"f"),g)),Je(this,h,g,"f")}async postMessage(g){if(Oe(this,u,"f"))return!1;const p=(0,_.serializeWebviewMessage)(g,{serializeBuffersForPostMessage:Oe(this,I,"f")});return Oe(this,O,"f").$postMessage(Oe(this,k,"f"),p.message,...p.buffers)}assertNotDisposed(){if(Oe(this,u,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=w,k=new WeakMap,O=new WeakMap,b=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,v=new WeakMap,I=new WeakMap,l=new WeakMap;function t(o){try{const g=(0,M.normalizeVersion)((0,M.parseVersion)(o.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=t;class d{constructor(g,p,P,N,V){this.remoteInfo=p,this.workspace=P,this._logService=N,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=g.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(g,p,P){const N=this.getWebview(g);if(N){const{message:V}=(0,_.deserializeWebviewMessage)(p,P.value);N._onMessageEmitter.fire(V)}}$onMissingCsp(g,p){this._logService.warn(`${p} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,p,P){const N=new w(g,this._webviewProxy,s(p),this.remoteInfo,this.workspace,P,this._deprecationService);return this._webviews.set(g,N),N._onDidDispose(()=>{this._webviews.delete(g)}),N}deleteWebview(g){this._webviews.delete(g)}getWebview(g){return this._webviews.get(g)}}e.ExtHostWebviews=d;function i(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=i;function n(o,g,p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,enableForms:p.enableForms,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots||a(o,g)}}e.serializeWebviewOptions=n;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(g=>S.URI.from(g))}}e.reviveOptions=s;function a(o,g){return[...(g?.getWorkspaceFolders()||[]).map(p=>p.uri),o.extensionLocation]}}),define(Ce[218],Ie([1,0,20,213,7,12,22,2,8,54,61,4,6]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(t,d){this.document=t,this._storagePath=d,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,d){await this.getEdit(t).undo(),d||this.disposeBackup()}async redo(t,d){await this.getEdit(t).redo(),d||this.disposeBackup()}disposeEdits(t){for(const d of t)this._edits.delete(d)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,t)}updateBackup(t){this._backup?.delete(),this._backup=t}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(t){const d=this._edits.get(t,0);if(!d)throw new Error("No edit found");return d}}class f{constructor(){this._documents=new Map}get(t,d){return this._documents.get(this.key(t,d))}add(t,d,i){const n=this.key(t,d.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${d.uri}`);const s=new T(d,i);return this._documents.set(n,s),s}delete(t,d){const i=this.key(t,d.uri);this._documents.delete(i)}key(t,d){return`${t}@@@${d}`}}var c;(function(w){w[w.Text=0]="Text",w[w.Custom=1]="Custom"})(c||(c={}));class h{constructor(){this._providers=new Map}addTextProvider(t,d,i){return this.add(0,t,d,i)}addCustomProvider(t,d,i){return this.add(1,t,d,i)}get(t){return this._providers.get(t)}add(t,d,i,n){if(this._providers.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this._providers.set(d,{type:t,extension:i,provider:n}),new m.Disposable(()=>this._providers.delete(d))}}class u{constructor(t,d,i,n,s){this._extHostDocuments=d,this._extensionStoragePaths=i,this._extHostWebview=n,this._extHostWebviewPanels=s,this._editorProviders=new h,this._documents=new f,this._proxy=t.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,d,i,n){const s=new S.DisposableStore;return v(i)?(s.add(this._editorProviders.addTextProvider(d,t,i)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),d,n.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(d,t,i)),this.supportEditing(i)&&s.add(i.onDidChangeCustomDocument(a=>{const o=this.getCustomDocumentEntry(d,a.document.uri);if(I(a)){const g=o.addEdit(a);this._proxy.$onDidEdit(a.document.uri,d,g,a.label)}else this._proxy.$onContentChange(a.document.uri,d)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),d,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),m.Disposable.from(s,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(d)}))}async $createCustomDocument(t,d,i,n,s){const a=this._editorProviders.get(d);if(!a)throw new Error(`No provider found for '${d}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${d}'`);const o=A.URI.revive(t),g=await a.provider.openCustomDocument(o,{backupId:i,untitledDocumentData:n?.buffer},s);let p;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(p=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(d,g,p),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(t,d){const i=this._editorProviders.get(d);if(!i)throw new Error(`No provider found for '${d}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${d}'`);const n=A.URI.revive(t),{document:s}=this.getCustomDocumentEntry(d,n);this._documents.delete(d,s),s.dispose()}async $resolveWebviewEditor(t,d,i,n,s,a){const o=this._editorProviders.get(i);if(!o)throw new Error(`No provider found for '${i}'`);const g=E.ViewColumn.to(s),p=this._extHostWebview.createNewWebview(d,n.webviewOptions,o.extension),P=this._extHostWebviewPanels.createNewWebviewPanel(d,i,n.title,g,n.panelOptions,p,!0),N=A.URI.revive(t);switch(o.type){case 1:{const{document:V}=this.getCustomDocumentEntry(i,N);return o.provider.resolveCustomEditor(V,P,a)}case 0:{const V=this._extHostDocuments.getDocument(N);return o.provider.resolveCustomTextEditor(V,P,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,d,i){this.getCustomDocumentEntry(d,t).disposeEdits(i)}async $onMoveCustomEditor(t,d,i){const n=this._editorProviders.get(i);if(!n)throw new Error(`No provider found for '${i}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const a=A.URI.revive(d),o=this._extHostDocuments.getDocument(a);await n.provider.moveCustomTextEditor(o,s,r.CancellationToken.None)}async $undo(t,d,i,n){return this.getCustomDocumentEntry(d,t).undo(i,n)}async $redo(t,d,i,n){return this.getCustomDocumentEntry(d,t).redo(i,n)}async $revert(t,d,i){const n=this.getCustomDocumentEntry(d,t);await this.getCustomEditorProvider(d).revertCustomDocument(n.document,i),n.disposeBackup()}async $onSave(t,d,i){const n=this.getCustomDocumentEntry(d,t);await this.getCustomEditorProvider(d).saveCustomDocument(n.document,i),n.disposeBackup()}async $onSaveAs(t,d,i,n){const s=this.getCustomDocumentEntry(d,t);return this.getCustomEditorProvider(d).saveCustomDocumentAs(s.document,A.URI.revive(i),n)}async $backup(t,d,i){const n=this.getCustomDocumentEntry(d,t),a=await this.getCustomEditorProvider(d).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},i);return n.updateBackup(a),a.id}getCustomDocumentEntry(t,d){const i=this._documents.get(t,A.URI.revive(d));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(t){const i=this._editorProviders.get(t)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=u;function v(w){return typeof w.resolveCustomTextEditor=="function"}function I(w){return typeof w.undo=="function"&&typeof w.redo=="function"}function l(w){const t=w.scheme===M.Schemas.file||w.scheme===M.Schemas.untitled?w.fsPath:w.toString();return(0,y.hash)(t)+""}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[219],Ie([1,0,5,7,2,42,8,54,4,6]),function(ne,e,r,y,S,M,_,A,E,k){"use strict";var O,b,m,T,f,c,h,u,v,I,l,w,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends y.Disposable{constructor(a,o,g,p){super(),O.set(this,void 0),b.set(this,void 0),m.set(this,void 0),T.set(this,void 0),f.set(this,void 0),c.set(this,void 0),h.set(this,void 0),u.set(this,void 0),v.set(this,!0),I.set(this,void 0),l.set(this,!1),w.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,w,"f").event,t.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Oe(this,t,"f").event,Je(this,O,a,"f"),Je(this,b,o,"f"),Je(this,T,g,"f"),Je(this,m,p.viewType,"f"),Je(this,f,p.panelOptions,"f"),Je(this,u,p.viewColumn,"f"),Je(this,c,p.title,"f"),Je(this,I,p.active,"f")}dispose(){Oe(this,l,"f")||(Je(this,l,!0,"f"),Oe(this,w,"f").fire(),Oe(this,b,"f").$disposeWebview(Oe(this,O,"f")),Oe(this,T,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,T,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,c,"f")}set title(a){this.assertNotDisposed(),Oe(this,c,"f")!==a&&(Je(this,c,a,"f"),Oe(this,b,"f").$setTitle(Oe(this,O,"f"),a))}get iconPath(){return this.assertNotDisposed(),Oe(this,h,"f")}set iconPath(a){this.assertNotDisposed(),Oe(this,h,"f")!==a&&(Je(this,h,a,"f"),Oe(this,b,"f").$setIconPath(Oe(this,O,"f"),S.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,u,"f")=="number"&&Oe(this,u,"f")<0))return Oe(this,u,"f")}get active(){return this.assertNotDisposed(),Oe(this,I,"f")}get visible(){return this.assertNotDisposed(),Oe(this,v,"f")}_updateViewState(a){Oe(this,l,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Je(this,I,a.active,"f"),Je(this,v,a.visible,"f"),Je(this,u,a.viewColumn,"f"),Oe(this,t,"f").fire({webviewPanel:this}))}reveal(a,o){this.assertNotDisposed(),Oe(this,b,"f").$reveal(Oe(this,O,"f"),{viewColumn:typeof a>"u"?void 0:_.ViewColumn.from(a),preserveFocus:!!o})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,b=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,v=new WeakMap,I=new WeakMap,l=new WeakMap,w=new WeakMap,t=new WeakMap;class i{constructor(a,o,g){this.webviews=o,this.workspace=g,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,M.generateUuid)()}createWebviewPanel(a,o,g,p,P={}){const N=typeof p=="object"?p.viewColumn:p,V={viewColumn:_.ViewColumn.from(N),preserveFocus:typeof p=="object"&&!!p.preserveFocus},U=(0,A.shouldSerializeBuffersForPostMessage)(a),D=i.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(a),D,o,{title:g,panelOptions:n(P),webviewOptions:(0,A.serializeWebviewOptions)(a,this.workspace,P),serializeBuffersForPostMessage:U},V);const x=this.webviews.createNewWebview(D,P,a);return this.createNewWebviewPanel(D,o,g,N,P,x,!0)}$onDidChangeWebviewPanelViewStates(a){const o=Object.keys(a);o.sort((g,p)=>{const P=a[g],N=a[p];return P.active?1:N.active?-1:+P.visible-+N.visible});for(const g of o){const p=this.getWebviewPanel(g);if(!p)continue;const P=a[g];p._updateViewState({active:P.active,visible:P.visible,viewColumn:_.ViewColumn.to(P.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,o,g){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:g,extension:a}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(a)}),new k.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(a,o,g,p){const P=this._serializers.get(o);if(!P)throw new Error(`No serializer found for '${o}'`);const{serializer:N,extension:V}=P,U=this.webviews.createNewWebview(a,g.webviewOptions,V),D=this.createNewWebviewPanel(a,o,g.title,p,g.panelOptions,U,g.active);await N.deserializeWebviewPanel(D,g.state)}createNewWebviewPanel(a,o,g,p,P,N,V){const U=new d(a,this._proxy,N,{viewType:o,title:g,viewColumn:p,panelOptions:P,active:V});return this._webviewPanels.set(a,U),U}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=i;function n(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[220],Ie([1,0,5,7,54,8,4,6]),function(ne,e,r,y,S,M,_,A){"use strict";var E,k,O,b,m,T,f,c,h,u,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class I extends y.Disposable{constructor(t,d,i,n,s,a,o){super(),E.set(this,void 0),k.set(this,void 0),O.set(this,void 0),b.set(this,void 0),m.set(this,!1),T.set(this,void 0),f.set(this,void 0),c.set(this,void 0),h.set(this,void 0),u.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Oe(this,u,"f").event,v.set(this,this._register(new r.Emitter)),this.onDidDispose=Oe(this,v,"f").event,Je(this,O,i,"f"),Je(this,f,n,"f"),Je(this,E,t,"f"),Je(this,k,d,"f"),Je(this,b,s,"f"),Je(this,T,o,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,v,"f").fire(),Oe(this,b,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(t){this.assertNotDisposed(),Oe(this,f,"f")!==t&&(Je(this,f,t,"f"),Oe(this,k,"f").$setWebviewViewTitle(Oe(this,E,"f"),t))}get description(){return this.assertNotDisposed(),Oe(this,c,"f")}set description(t){this.assertNotDisposed(),Oe(this,c,"f")!==t&&(Je(this,c,t,"f"),Oe(this,k,"f").$setWebviewViewDescription(Oe(this,E,"f"),t))}get visible(){return Oe(this,T,"f")}get webview(){return Oe(this,b,"f")}get viewType(){return Oe(this,O,"f")}_setVisible(t){t===Oe(this,T,"f")||Oe(this,m,"f")||(Je(this,T,t,"f"),Oe(this,u,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,h,"f")}set badge(t){this.assertNotDisposed(),!(t?.value===Oe(this,h,"f")?.value&&t?.tooltip===Oe(this,h,"f")?.tooltip)&&(Je(this,h,M.ViewBadge.from(t),"f"),Oe(this,k,"f").$setWebviewViewBadge(Oe(this,E,"f"),t))}show(t){this.assertNotDisposed(),Oe(this,k,"f").$show(Oe(this,E,"f"),!!t)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,k=new WeakMap,O=new WeakMap,b=new WeakMap,m=new WeakMap,T=new WeakMap,f=new WeakMap,c=new WeakMap,h=new WeakMap,u=new WeakMap,v=new WeakMap;class l{constructor(t,d){this._extHostWebview=d,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,i,n){if(this._viewProviders.has(d))throw new Error(`View provider for '${d}' already registered`);return this._viewProviders.set(d,{provider:i,extension:t}),this._proxy.$registerWebviewViewProvider((0,S.toExtensionData)(t),d,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(t)}),new A.Disposable(()=>{this._viewProviders.delete(d),this._proxy.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,i,n,s){const a=this._viewProviders.get(d);if(!a)throw new Error(`No view provider found for '${d}'`);const{provider:o,extension:g}=a,p=this._extHostWebview.createNewWebview(t,{},g),P=new I(t,this._proxy,d,i,p,g,!0);this._webviewViews.set(t,P),await o.resolveWebviewView(P,{state:n},s)}async $onDidChangeWebviewViewVisibility(t,d){this.getWebviewView(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.getWebviewView(t);this._webviewViews.delete(t),d.dispose(),this._extHostWebview.deleteWebview(t)}getWebviewView(t){const d=this._webviewViews.get(t);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=l}),define(Ce[98],Ie([1,0,5,4,2,12,9,3,13]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Ji{constructor(b){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ji.InitialState,this._proxy=b.getProxy(y.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,m){let T;if(typeof b=="string"){T=b;try{b=S.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,_.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,T,m)}async asExternalUri(b,m){if((0,_.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this._proxy.$asExternalUri(b,m);return S.URI.from(T)}};k.InitialState={focused:!0},k=ze([$e(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[221],Ie([1,0,191,28,13]),function(ne,e,r,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends r.AbstractExtHostConsoleForwarder{constructor(A,E){super(A,E)}_nativeConsoleLogMessage(A,E,k){E.apply(console,k)}};M=ze([$e(0,S.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[222],Ie([1,0,14,23,20,11,5,7,118,185,40]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(P,N){try{return JSON.stringify(P,N)}catch{return"null"}}const T="$$ref$$",f={[T]:-1};class c{constructor(N,V){this.jsonString=N,this.referencedBuffers=V}}function h(P,N=null,V=!1){const U=[];return{jsonString:(V?m:JSON.stringify)(P,(x,L)=>{if(typeof L>"u")return f;if(typeof L=="object"){if(L instanceof y.VSBuffer){const R=U.push(L)-1;return{[T]:R}}if(N)return N(x,L)}return L}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=h;function u(P,N,V){return JSON.parse(P,(U,D)=>{if(D){const x=D[T];if(typeof x=="number")return N[x];if(V&&D.$mid===1)return V.transformIncoming(D)}return D})}e.parseJsonAndRestoreBufferRefs=u;function v(P,N){return JSON.stringify(P,N)}function I(P){return P?(N,V)=>V&&V.$mid===1?P.transformOutgoing(V):V:null}var l;(function(P){P[P.LocalSide=0]="LocalSide",P[P.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(P){P[P.Responsive=0]="Responsive",P[P.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},d=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class n extends A.Disposable{constructor(N,V=null,U=null){super(),this[b]=!0,this._onDidChangeResponsiveState=this._register(new _.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=N,this._logger=V,this._uriTransformer=U,this._uriReplacer=I(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let D=0,x=O.ProxyIdentifier.count;D<x;D++)this._locals[D]=null,this._proxies[D]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(D=>this._receiveOneMessage(D))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(N=>{this._pendingRPCReplies[N].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(N){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(N){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(N){this._responsiveState!==N&&(this._responsiveState=N,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(N){return this._uriTransformer?(0,E.transformIncomingURIs)(N,this._uriTransformer):N}getProxy(N){const{nid:V,sid:U}=N;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,U)),this._proxies[V]}_createProxy(N,V){const U={get:(D,x)=>(typeof x=="string"&&!D[x]&&x.charCodeAt(0)===36&&(D[x]=(...L)=>this._remoteCall(N,x,L)),x===i?V:D[x])};return new Proxy(Object.create(null),U)}set(N,V){return this._locals[N.nid]=V,V}assertRegistered(N){for(let V=0,U=N.length;V<U;V++){const D=N[V];if(!this._locals[D.nid])throw new Error(`Missing proxy instance ${D.sid}`)}}_receiveOneMessage(N){if(this._isDisposed)return;const V=N.byteLength,U=s.read(N,0),D=U.readUInt8(),x=U.readUInt32();switch(D){case 1:case 2:{let{rpcId:L,method:R,args:K}=o.deserializeRequestJSONArgs(U);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,L,R,K,D===2);break}case 3:case 4:{let{rpcId:L,method:R,args:K}=o.deserializeRequestMixedArgs(U);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,x,L,R,K,D===4);break}case 5:{this._logger?.logIncoming(V,x,0,"ack"),this._onDidReceiveAcknowledge(x);break}case 6:{this._receiveCancel(V,x);break}case 7:{this._receiveReply(V,x,void 0);break}case 9:{let L=o.deserializeReplyOKJSON(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(V,x,L);break}case 10:{const L=o.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(V,x,L);break}case 8:{const L=o.deserializeReplyOKVSBuffer(U);this._receiveReply(V,x,L);break}case 11:{let L=o.deserializeReplyErrError(U);this._uriTransformer&&(L=(0,E.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(V,x,L);break}case 12:{this._receiveReplyErr(V,x,void 0);break}default:console.error("received unexpected message"),console.error(N)}}_receiveRequest(N,V,U,D,x,L){this._logger?.logIncoming(N,V,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(U)}.${D}(`,x);const R=String(V);let K,W;if(L){const fe=new S.CancellationTokenSource;x.push(fe.token),K=this._invokeHandler(U,D,x),W=()=>fe.cancel()}else K=this._invokeHandler(U,D,x),W=t;this._cancelInvokedHandlers[R]=W;const $=o.serializeAcknowledged(V);this._logger?.logOutgoing($.byteLength,V,1,"ack"),this._protocol.send($),K.then(fe=>{delete this._cancelInvokedHandlers[R];const J=o.serializeReplyOK(V,fe,this._uriReplacer);this._logger?.logOutgoing(J.byteLength,V,1,"reply:",fe),this._protocol.send(J)},fe=>{delete this._cancelInvokedHandlers[R];const J=o.serializeReplyErr(V,fe);this._logger?.logOutgoing(J.byteLength,V,1,"replyErr:",fe),this._protocol.send(J)})}_receiveCancel(N,V){this._logger?.logIncoming(N,V,1,"receiveCancel");const U=String(V);this._cancelInvokedHandlers[U]?.()}_receiveReply(N,V,U){this._logger?.logIncoming(N,V,0,"receiveReply:",U);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D],x.resolveOk(U)}_receiveReplyErr(N,V,U){this._logger?.logIncoming(N,V,0,"receiveReplyErr:",U);const D=String(V);if(!this._pendingRPCReplies.hasOwnProperty(D))return;const x=this._pendingRPCReplies[D];delete this._pendingRPCReplies[D];let L;U&&(U.$isError?(L=new Error,L.name=U.name,L.message=U.message,L.stack=U.stack):L=U),x.resolveErr(L)}_invokeHandler(N,V,U){try{return Promise.resolve(this._doInvokeHandler(N,V,U))}catch(D){return Promise.reject(D)}}_doInvokeHandler(N,V,U){const D=this._locals[N];if(!D)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(N));const x=D[V];if(typeof x!="function")throw new Error("Unknown method "+V+" on actor "+(0,O.getStringIdentifierForProxy)(N));return x.apply(D,U)}_remoteCall(N,V,U){if(this._isDisposed)return new k.CanceledLazyPromise;let D=null;if(U.length>0&&S.CancellationToken.isCancellationToken(U[U.length-1])&&(D=U.pop()),D&&D.isCancellationRequested)return Promise.reject(M.canceled());const x=o.serializeRequestArguments(U,this._uriReplacer),L=++this._lastMessageId,R=String(L),K=new k.LazyPromise;D&&D.onCancellationRequested(()=>{const $=o.serializeCancel(L);this._logger?.logOutgoing($.byteLength,L,0,"cancel"),this._protocol.send(o.serializeCancel(L))}),this._pendingRPCReplies[R]=K,this._onWillSendRequest(L);const W=o.serializeRequest(L,N,V,x,!!D);return this._logger?.logOutgoing(W.byteLength,L,0,`request: ${(0,O.getStringIdentifierForProxy)(N)}.${V}(`,U),this._protocol.send(W),K}}e.RPCProtocol=n,b=d,n.UNRESPONSIVE_TIME=3*1e3;class s{constructor(N,V){this._buff=N,this._offset=V}static alloc(N,V,U){const D=new s(y.VSBuffer.alloc(U+1+4),0);return D.writeUInt8(N),D.writeUInt32(V),D}static read(N,V){return new s(N,V)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(N){this._buff.writeUInt8(N,this._offset),this._offset+=1}readUInt8(){const N=this._buff.readUInt8(this._offset);return this._offset+=1,N}writeUInt32(N){this._buff.writeUInt32BE(N,this._offset),this._offset+=4}readUInt32(){const N=this._buff.readUInt32BE(this._offset);return this._offset+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this._buff.writeUInt8(N.byteLength,this._offset),this._offset+=1,this._buff.set(N,this._offset),this._offset+=N.byteLength}readShortString(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,U}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readLongString(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+N).toString();return this._offset+=N,U}writeBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this._buff.writeUInt32BE(N.byteLength,this._offset),this._offset+=4,this._buff.set(N,this._offset),this._offset+=N.byteLength}readVSBuffer(){const N=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+N);return this._offset+=N,V}static sizeMixedArray(N){let V=0;V+=1;for(let U=0,D=N.length;U<D;U++){const x=N[U];switch(V+=1,x.type){case 1:V+=this.sizeLongString(x.value);break;case 2:V+=this.sizeVSBuffer(x.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(x.value);for(let L=0;L<x.buffers.length;++L)V+=this.sizeVSBuffer(x.buffers[L]);break;case 4:break}}return V}writeMixedArray(N){this._buff.writeUInt8(N.length,this._offset),this._offset+=1;for(let V=0,U=N.length;V<U;V++){const D=N[V];switch(D.type){case 1:this.writeUInt8(1),this.writeLongString(D.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(D.value);break;case 3:this.writeUInt8(3),this.writeUInt32(D.buffers.length),this.writeLongString(D.value);for(let x=0;x<D.buffers.length;++x)this.writeBuffer(D.buffers[x]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(N);for(let U=0;U<N;U++)switch(this.readUInt8()){case 1:V[U]=this.readLongString();break;case 2:V[U]=this.readVSBuffer();break;case 3:{const x=this.readUInt32(),L=this.readLongString(),R=[];for(let K=0;K<x;++K)R.push(this.readVSBuffer());V[U]=new O.SerializableObjectWithBuffers(u(L,R,null));break}case 4:V[U]=void 0;break}return V}}s.sizeUInt32=4;var a;(function(P){P[P.Simple=0]="Simple",P[P.Mixed=1]="Mixed"})(a||(a={}));class o{static _useMixedArgSerialization(N){for(let V=0,U=N.length;V<U;V++)if(N[V]instanceof y.VSBuffer||N[V]instanceof O.SerializableObjectWithBuffers||typeof N[V]>"u")return!0;return!1}static serializeRequestArguments(N,V){if(this._useMixedArgSerialization(N)){const U=[];for(let D=0,x=N.length;D<x;D++){const L=N[D];if(L instanceof y.VSBuffer)U[D]={type:2,value:L};else if(typeof L>"u")U[D]={type:4};else if(L instanceof O.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:K}=h(L.value,V);U[D]={type:3,value:y.VSBuffer.fromString(R),buffers:K}}else U[D]={type:1,value:y.VSBuffer.fromString(v(L,V))}}return{type:1,args:U}}return{type:0,args:v(N,V)}}static serializeRequest(N,V,U,D,x){switch(D.type){case 0:return this._requestJSONArgs(N,V,U,D.args,x);case 1:return this._requestMixedArgs(N,V,U,D.args,x)}}static _requestJSONArgs(N,V,U,D,x){const L=y.VSBuffer.fromString(U),R=y.VSBuffer.fromString(D);let K=0;K+=s.sizeUInt8(),K+=s.sizeShortString(L),K+=s.sizeLongString(R);const W=s.alloc(x?2:1,N,K);return W.writeUInt8(V),W.writeShortString(L),W.writeLongString(R),W.buffer}static deserializeRequestJSONArgs(N){const V=N.readUInt8(),U=N.readShortString(),D=N.readLongString();return{rpcId:V,method:U,args:JSON.parse(D)}}static _requestMixedArgs(N,V,U,D,x){const L=y.VSBuffer.fromString(U);let R=0;R+=s.sizeUInt8(),R+=s.sizeShortString(L),R+=s.sizeMixedArray(D);const K=s.alloc(x?4:3,N,R);return K.writeUInt8(V),K.writeShortString(L),K.writeMixedArray(D),K.buffer}static deserializeRequestMixedArgs(N){const V=N.readUInt8(),U=N.readShortString(),D=N.readMixedArray(),x=new Array(D.length);for(let L=0,R=D.length;L<R;L++){const K=D[L];typeof K=="string"?x[L]=JSON.parse(K):x[L]=K}return{rpcId:V,method:U,args:x}}static serializeAcknowledged(N){return s.alloc(5,N,0).buffer}static serializeCancel(N){return s.alloc(6,N,0).buffer}static serializeReplyOK(N,V,U){if(typeof V>"u")return this._serializeReplyOKEmpty(N);if(V instanceof y.VSBuffer)return this._serializeReplyOKVSBuffer(N,V);if(V instanceof O.SerializableObjectWithBuffers){const{jsonString:D,referencedBuffers:x}=h(V.value,U,!0);return this._serializeReplyOKJSONWithBuffers(N,D,x)}else return this._serializeReplyOKJSON(N,m(V,U))}static _serializeReplyOKEmpty(N){return s.alloc(7,N,0).buffer}static _serializeReplyOKVSBuffer(N,V){let U=0;U+=s.sizeVSBuffer(V);const D=s.alloc(8,N,U);return D.writeVSBuffer(V),D.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static _serializeReplyOKJSON(N,V){const U=y.VSBuffer.fromString(V);let D=0;D+=s.sizeLongString(U);const x=s.alloc(9,N,D);return x.writeLongString(U),x.buffer}static _serializeReplyOKJSONWithBuffers(N,V,U){const D=y.VSBuffer.fromString(V);let x=0;x+=s.sizeUInt32,x+=s.sizeLongString(D);for(const R of U)x+=s.sizeVSBuffer(R);const L=s.alloc(10,N,x);L.writeUInt32(U.length),L.writeLongString(D);for(const R of U)L.writeBuffer(R);return L.buffer}static deserializeReplyOKJSON(N){const V=N.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(N,V){const U=N.readUInt32(),D=N.readLongString(),x=[];for(let L=0;L<U;++L)x.push(N.readVSBuffer());return new O.SerializableObjectWithBuffers(u(D,x,V))}static serializeReplyErr(N,V){const U=V?m(M.transformErrorForSerialization(V),null):void 0;if(typeof U!="string")return this._serializeReplyErrEmpty(N);const D=y.VSBuffer.fromString(U);let x=0;x+=s.sizeLongString(D);const L=s.alloc(11,N,x);return L.writeLongString(D),L.buffer}static deserializeReplyErrError(N){const V=N.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(N){return s.alloc(12,N,0).buffer}}var g;(function(P){P[P.RequestJSONArgs=1]="RequestJSONArgs",P[P.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",P[P.RequestMixedArgs=3]="RequestMixedArgs",P[P.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",P[P.Acknowledged=5]="Acknowledged",P[P.Cancel=6]="Cancel",P[P.ReplyOKEmpty=7]="ReplyOKEmpty",P[P.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",P[P.ReplyOKJSON=9]="ReplyOKJSON",P[P.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",P[P.ReplyErrError=11]="ReplyErrError",P[P.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var p;(function(P){P[P.String=1]="String",P[P.VSBuffer=2]="VSBuffer",P[P.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",P[P.Undefined=4]="Undefined"})(p||(p={}))}),define(Ce[223],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(M){const _=A=>{self.removeEventListener("message",_);const E=A.data;Object.defineProperties(self,{postMessage:{value(k,O){E.postMessage(k,O)}},onmessage:{get(){return E.onmessage},set(k){E.onmessage=k}}}),E.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",_)}.toString();class y extends EventTarget{constructor(M,_,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${r})('${_}'))`,k=new Blob([E],{type:"application/javascript"}),O=URL.createObjectURL(k),b=new MessageChannel,m=O,T={type:"_newWorker",id:m,port:b.port2,url:O,options:A};M(T,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(O),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(f){b.port1.onmessage=f}},onmessageerror:{get(){return b.port1.onmessageerror},set(f){b.port1.onmessageerror=f}}}),b.port1.addEventListener("messageerror",f=>{const c=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(c)}),b.port1.addEventListener("message",f=>{const c=new MessageEvent("message",{data:f.data});this.dispatchEvent(c)}),b.port1.start()}}e.NestedWorker=y}),define(Ce[224],Ie([1,0,5,30,38,3,39,11,14]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new S.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new S.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new S.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var k;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(k=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new r.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new r.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(c=>f.push(c)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}y.Registry.add(e.Extensions.OutputChannels,new O);function b(T,f,c,h,u){return(0,E.createCancelablePromise)(async v=>{await(0,_.whenProviderRegistered)(c,h);const I=y.Registry.as(e.Extensions.OutputChannels);try{await m(c,1,h,u,v),I.registerChannel({id:T,label:f,file:c,log:!0})}catch(l){(0,A.isCancellationError)(l)||u.error("Error while registering log channel",c.toString(),(0,A.getErrorMessage)(l))}})}e.registerLogChannel=b;async function m(T,f,c,h,u){if(!await c.exists(T)){if(u.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");h.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",T.toString()),await(0,E.timeout)(1e3,u),await m(T,f+1,c,h,u)}}}),define(Ce[99],Ie([1,0,4,7,3,13,15,224,52,28,35,112,23,10]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends y.Disposable{constructor(u,v,I,l){super(),this.id=u,this.name=v,this.logger=I,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(u){this.append(u+`
`)}append(u){this.write(u),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const u=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,u)}replace(u){const v=this.offset;this.write(u),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(u,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof u=="boolean"?u:v))}hide(){this.proxy.$close(this.id)}write(u){this.offset+=m.VSBuffer.fromString(u).byteLength,this.logger.info(u)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let c=class{constructor(u,v,I,l,w){this.extHostFileSystem=I,this.extHostFileSystemInfo=l,this.loggerService=w,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=u.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.visibleChannelId=u;for(const[v,I]of this.channels)I.visible=v===this.visibleChannelId}createOutputChannel(u,v,I){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");if((0,T.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(u,v,I);return l.then(w=>{this.channels.set(w.id,w),w.visible=w.id===this.visibleChannelId}),this.createExtHostOutputChannel(u,l)}async doCreateOutputChannel(u,v,I){const l=await this.createOutputDirectory(),w=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),t=this.loggerService.createLogger(w,{always:!0,donotRotate:!0,donotUseFormatters:!0}),d=await this.proxy.$register(u,!1,w,v,I.identifier.value);return new f(d,u,t,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(u,v){let I=!1;const l=()=>{if(I)throw new Error("Channel has been closed")};return{get name(){return u},append(w){l(),v.then(t=>t.append(w))},appendLine(w){l(),v.then(t=>t.appendLine(w))},clear(){l(),v.then(w=>w.clear())},replace(w){l(),v.then(t=>t.replace(w))},show(w,t){l(),v.then(d=>d.show(w,t))},hide(){l(),v.then(w=>w.hide())},dispose(){I=!0,v.then(w=>w.dispose())}}}};c=ze([$e(0,M.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,E.IExtHostConsumerFileSystem),$e(3,O.IExtHostFileSystemInfo),$e(4,_.ILoggerService)],c),e.ExtHostOutputService=c,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(Ce[225],Ie([1,0,3]),function(ne,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(Ce[226],Ie([1,0,37,12,19,21,22,2,3,156,45,171,225]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let T=class Zi{constructor(c,h,u,v){this.localUserHome=c,this.remoteAgentService=h,this.environmentService=u,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const I=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=I?.userHome??c})()}hasValidBasename(c,h,u){return typeof h=="string"||typeof h>"u"?this.resolveOS.then(v=>this.doHasValidBasename(c,v,h)):this.doHasValidBasename(c,h,u)}doHasValidBasename(c,h,u){return c.scheme===y.Schemas.file||c.scheme===y.Schemas.vscodeRemote?(0,r.isValidBasename)(u??(0,_.basename)(c),h===1):!0}get defaultUriScheme(){return Zi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(c,h){if(c.remoteAuthority)return y.Schemas.vscodeRemote;const u=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(u)return u;const v=h.getWorkspace().folders[0];if(v)return v.uri.scheme;const I=h.getWorkspace().configuration;return I?I.scheme:y.Schemas.file}userHome(c){return c?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(c=>c===1?S.win32:S.posix)}async fileURI(c){let h="";if(await this.resolveOS===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const v=c.indexOf("/",2);v===-1?(h=c.substring(2),c="/"):(h=c.substring(2,v),c=c.substring(v)||"/")}return A.URI.from({scheme:y.Schemas.file,authority:h,path:c,query:"",fragment:""})}};T=ze([$e(1,m.IRemoteAgentService),$e(2,b.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],T),e.AbstractPathService=T}),define(Ce[100],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(_,A){this.line=_,this.character=A}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,A){return new r(0,0)}with(_){return new r(0,0)}}e.Position=r;class y{constructor(_,A,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(_,A),this.end=new r(E,k)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new y(0,0,0,0)}with(_){return new y(0,0,0,0)}}e.Range=y;var S;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[41],Ie([1,0,16,34,26,37,9,3,19,11,100,14]),function(ne,e,r,y,S,M,_,A,E,k,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",T=" characters skipped \u27EB",f=(m.length+T.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var c;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function u(Q){return!!Q.preview}e.resultIsMatch=u;function v(Q){return!!Q.resource}e.isFileMatch=v;function I(Q){return!!Q.message}e.isProgressMessage=I;var l;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(ce){this.resource=ce,this.results=[]}}e.FileMatch=w;class t{constructor(ce,te,pe){this.ranges=te;const be=Array.isArray(te)?te:[te];if(pe&&pe.matchLines===1&&d(be)){ce=(0,_.getNLines)(ce,pe.matchLines);let re="",Ee=0,Pe=0;const Fe=Math.floor(pe.charsPerLine/5),We=[];for(const Xe of be){const Te=Math.max(Xe.startColumn-Fe,0),_e=Xe.startColumn+pe.charsPerLine;if(Te>Pe+Fe+f){const ye=m+(Te-Pe)+T;re+=ye+ce.slice(Te,_e),Ee+=Te-(Pe+ye.length)}else re+=ce.slice(Pe,_e);We.push(new n(0,Xe.startColumn-Ee,Xe.endColumn-Ee)),Pe=_e}this.preview={text:re,matches:Array.isArray(this.ranges)?We:We[0]}}else{const re=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ce,matches:(0,r.mapArrayOrNot)(te,Ee=>new i(Ee.startLineNumber-re,Ee.startColumn,Ee.endLineNumber-re,Ee.endColumn))}}}}e.TextSearchMatch=t;function d(Q){const ce=Q[0].startLineNumber;for(const te of Q)if(te.startLineNumber!==ce||te.endLineNumber!==ce)return!1;return!0}class i{constructor(ce,te,pe,be){this.startLineNumber=ce,this.startColumn=te,this.endLineNumber=pe,this.endColumn=be}}e.SearchRange=i;class n extends i{constructor(ce,te,pe){super(ce,te,ce,pe)}}e.OneLineRange=n;var s;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function a(Q,ce=!0){const te=Q&&Q.files&&Q.files.exclude,pe=ce&&Q&&Q.search&&Q.search.exclude;if(!te&&!pe)return;if(!te||!pe)return te||pe;let be=Object.create(null);return be=S.mixin(be,S.deepClone(te)),be=S.mixin(be,S.deepClone(pe),!0),be}e.getExcludes=a;function o(Q,ce){return Q.excludePattern&&y.match(Q.excludePattern,ce)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&y.match(Q.includePattern,ce)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(te=>{const pe=te.folder.fsPath;if(M.isEqualOrParent(ce,pe)){const be=E.relative(pe,ce);return!te.includePattern||!!y.match(te.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var g;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(g=e.SearchErrorCode||(e.SearchErrorCode={}));class p extends Error{constructor(ce,te){super(ce),this.code=te}}e.SearchError=p;function P(Q){const ce=Q.message;if((0,k.isCancellationError)(Q))return new p(ce,g.canceled);try{const te=JSON.parse(ce);return new p(te.message,te.code)}catch{return new p(ce,g.other)}}e.deserializeSearchError=P;function N(Q){const ce={message:Q.message,code:Q.code};return new Error(JSON.stringify(ce))}e.serializeSearchError=N;function V(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=V;function U(Q){return Q.type==="success"}e.isSerializedSearchSuccess=U;function D(Q){return!!Q.path}e.isSerializedFileMatch=D;function x(Q,ce){const te=Q.searchPath?Q.searchPath:Q.relativePath;return(0,_.fuzzyContains)(te,ce)}e.isFilePatternMatch=x;class L{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function R(Q,ce){const te={...Q||{},...ce||{}};return Object.keys(te).filter(pe=>{const be=te[pe];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=R;class K{constructor(ce,te){this._parsedIncludeExpression=null,this._excludeExpression={...ce.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=y.parse(this._excludeExpression);let pe=ce.includePattern;te.includePattern&&(pe?pe={...pe,...te.includePattern}:pe=te.includePattern),pe&&(this._parsedIncludeExpression=y.parse(pe))}matchesExcludesSync(ce,te,pe){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,te,pe))}includedInQuerySync(ce,te,pe){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ce,te,pe)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ce,te,pe))}includedInQuery(ce,te,pe){const be=this._parsedExcludeExpression(ce,te,pe),re=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ce,te,pe):!0;return(0,b.isThenable)(be)?be.then(Ee=>Ee?!1:re()):re()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=K;function W(Q){for(const ce in Q)if(typeof Q[ce]!="boolean")return!0;return!1}function $(Q){if(!Q)return;let ce;return te=>(ce||(ce=(Q()||Promise.resolve([])).then(pe=>pe?J(pe):{})),ce.then(pe=>!!pe[te]))}e.hasSiblingPromiseFn=$;function fe(Q){if(!Q)return;let ce;return te=>{if(!ce){const pe=Q();ce=pe?J(pe):{}}return!!ce[te]}}e.hasSiblingFn=fe;function J(Q){const ce={};for(const te of Q)ce[te]=!0;return ce}}),define(Ce[31],Ie([1,0,16,14,20,5,7,24,12,107,22,9,10,2,135,3,15,148,45,35,28,13,8,6,46,41,4]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l,w,t,d,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(D,x,L){return new O.ExtUri(R=>P(R,L)).isEqual(D,x)}function o(D,x,L){return a(D.uri,x.uri,L)?0:(0,b.compare)(D.uri.toString(),x.uri.toString())}function g(D,x,L){return D.index!==x.index?D.index<x.index?-1:1:a(D.uri,x.uri,L)?(0,b.compare)(D.name,x.name):(0,b.compare)(D.uri.toString(),x.uri.toString())}function p(D,x,L,R){const K=D.slice(0).sort(($,fe)=>L($,fe,R)),W=x.slice(0).sort(($,fe)=>L($,fe,R));return(0,r.delta)(K,W,($,fe)=>L($,fe,R))}function P(D,x){const L=x.getCapabilities(D.scheme);return!(L&&L&1024)}class N extends v.Workspace{constructor(x,L,R,K,W,$,fe){super(x,R.map(J=>new v.WorkspaceFolder(J)),K,W,fe),this._name=L,this._isUntitled=$,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(fe),R.forEach(J=>{this._workspaceFolders.push(J),this._structure.set(J.uri,J)})}static toExtHostWorkspace(x,L,R,K){if(!x)return{workspace:null,added:[],removed:[]};const{id:W,name:$,folders:fe,configuration:J,transient:Q,isUntitled:ce}=x,te=[],pe=L;L?fe.forEach((Pe,Fe)=>{const We=T.URI.revive(Pe.uri),Xe=N._findFolder(R||L,We,K);Xe?(Xe.name=Pe.name,Xe.index=Pe.index,te.push(Xe)):te.push({uri:We,name:Pe.name,index:Fe})}):te.push(...fe.map(({uri:Pe,name:Fe,index:We})=>({uri:T.URI.revive(Pe),name:Fe,index:We}))),te.sort((Pe,Fe)=>Pe.index<Fe.index?-1:1);const be=new N(W,$,te,!!Q,J?T.URI.revive(J):null,!!ce,Pe=>P(Pe,K)),{added:re,removed:Ee}=p(pe?pe.workspaceFolders:[],be.workspaceFolders,o,K);return{workspace:be,added:re,removed:Ee}}static _findFolder(x,L,R){for(let K=0;K<x.folders.length;K++){const W=x.workspaceFolders[K];if(a(W.uri,L,R))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,L){return L&&this._structure.get(x)&&(x=(0,O.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let V=class{constructor(x,L,R,K,W){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=R,this._uriTransformerService=W,this._requestIdProvider=new k.Counter,this._barrier=new y.Barrier,this._proxy=x.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(s.MainContext.MainThreadMessageService);const $=L.workspace;this._confirmedWorkspace=$?new N($.id,$.name,[],!!$.transient,$.configuration?T.URI.revive($.configuration):null,!!$.isUntitled,fe=>P(fe,R)):void 0}$initializeWorkspace(x,L){this._trusted=L,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?T.URI.from({scheme:E.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,L,R,...K){const W=[];if(Array.isArray(K)&&K.forEach(ce=>{T.URI.isUri(ce.uri)&&!W.some(te=>a(te.uri,ce.uri,this._extHostFileSystemInfo))&&W.push({uri:ce.uri,name:ce.name||(0,O.basenameOrAuthority)(ce.uri)})}),this._unconfirmedWorkspace||[L,R].some(ce=>typeof ce!="number"||ce<0)||R===0&&W.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(L+R>$.length)return!1;const fe=$.slice(0);fe.splice(L,R,...W.map(ce=>({uri:ce.uri,name:ce.name||(0,O.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<fe.length;ce++){const te=fe[ce];if(fe.some((pe,be)=>be!==ce&&a(te.uri,pe.uri,this._extHostFileSystemInfo)))return!1}fe.forEach((ce,te)=>ce.index=te);const{added:J,removed:Q}=p($,fe,g,this._extHostFileSystemInfo);if(J.length===0&&Q.length===0)return!1;if(this._proxy){const ce=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(ce,L,R,W).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const pe={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(u.Severity.Error,(0,f.localize)(0,null,ce,te.toString()),pe,[])})}return this.trySetWorkspaceFolders(fe),!0}getWorkspaceFolder(x,L){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,L)}async getWorkspaceFolder2(x,L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,L)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,L){let R,K="";if(typeof x=="string"?(R=T.URI.file(x),K=x):typeof x<"u"&&(R=x,K=x.fsPath),!R)return K;const W=this.getWorkspaceFolder(R,!0);if(!W)return K;typeof L>"u"&&this._actualWorkspace&&(L=this._actualWorkspace.folders.length>1);let $=(0,O.relativePath)(W.uri,R);return L&&W.name&&($=`${W.name}/${$}`),$}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=N.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:L,added:R,removed:K}=N.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=L||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:K}))}findFiles(x,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let $;if(L===null?$=!1:L&&(typeof L=="string"?$=L:$=L.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:fe,folder:J}=U(t.GlobPattern.from(x));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(fe),(0,m.withUndefinedAsNull)(J),(0,m.withUndefinedAsNull)($),(0,m.withUndefinedAsNull)(R),W).then(Q=>Array.isArray(Q)?Q.map(ce=>T.URI.revive(ce)):[])}async findTextInFiles(x,L,R,K,W=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),fe=typeof L.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:L.previewOptions,{includePattern:J,folder:Q}=U(t.GlobPattern.from(L.include)),ce=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,te={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!0,fileEncoding:L.encoding,maxResults:L.maxResults,previewOptions:fe,afterContext:L.afterContext,beforeContext:L.beforeContext,includePattern:J,excludePattern:ce},pe=!1;if(this._activeSearchCallbacks[$]=be=>{if(pe)return;const re=T.URI.revive(be.resource);be.results.forEach(Ee=>{(0,n.resultIsMatch)(Ee)?R({uri:re,preview:{text:Ee.preview.text,matches:(0,r.mapArrayOrNot)(Ee.preview.matches,Pe=>new d.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,r.mapArrayOrNot)(Ee.ranges,Pe=>new d.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):R({uri:re,text:Ee.text,lineNumber:Ee.lineNumber})})},W.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(x,(0,m.withUndefinedAsNull)(Q),te,$,W);return delete this._activeSearchCallbacks[$],be||{}}catch(be){throw delete this._activeSearchCallbacks[$],be}}$handleTextSearchResult(x,L){this._activeSearchCallbacks[L]?.(x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(x,L){if(this._editSessionIdentityProviders.has(x))throw new Error(`A provider has already been registered for scheme ${x}`);this._editSessionIdentityProviders.set(x,L);const R=this._uriTransformerService.transformOutgoingScheme(x),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,R),(0,_.toDisposable)(()=>{this._editSessionIdentityProviders.delete(x),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(x,L){this._logService.info("Getting edit session identifier for workspaceFolder",x);const R=await this.resolveWorkspaceFolder(T.URI.revive(x));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const K=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!K),!K)return;const W=await K.provideEditSessionIdentity(R,L);if(this._logService.info("Provider returned edit session identifier: ",W),!!W)return W}};V=ze([$e(0,w.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,I.IExtHostFileSystemInfo),$e(3,h.ILogService),$e(4,i.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,c.createDecorator)("IExtHostWorkspace");function U(D){let x,L;return D&&(typeof D=="string"?x=D:(x=D.pattern,L=T.URI.revive(D.baseUri))),{includePattern:x,folder:L}}}),define(Ce[32],Ie([1,0,26,5,31,4,6,151,84,10,14,3,13,15,2]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(d,i){if(i){const n=i.split(".");let s=d;for(let a=0;s&&a<n.length;a++)s=s[n[a]];return s}}function h(d){return d instanceof f.URI}function u(d){return d&&d.uri instanceof f.URI&&d.languageId&&typeof d.languageId=="string"}function v(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function I(d){return d&&d.uri instanceof f.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function l(d){if(h(d))return{resource:d};if(u(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(v(d))return{overrideIdentifier:d.languageId};if(I(d))return{resource:d.uri};if(d===null)return{resource:null}}let w=class{constructor(i,n,s){this._proxy=i.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=s,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new t(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,n){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(i,n))}};w=ze([$e(0,m.IExtHostRpcService),$e(1,S.IExtHostWorkspace),$e(2,T.ILogService)],w),e.ExtHostConfiguration=w;class t{constructor(i,n,s,a){this._onDidChangeConfiguration=new y.Emitter,this._proxy=i,this._logService=a,this._extHostWorkspace=n,this._configuration=A.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,n){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,s))}getConfiguration(i,n,s){const a=l(n)||{},o=this._toReadonlyValue(i?c(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,a,s?.identifier);function g(P){if(P==null)return null;if(typeof P=="boolean")return P?2:5;switch(P){case _.ConfigurationTarget.Global:return 2;case _.ConfigurationTarget.Workspace:return 5;case _.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(P){return typeof c(o,P)<"u"},get:(P,N)=>{this._validateConfigurationAccess(i?`${i}.${P}`:P,a,s?.identifier);let V=c(o,P);if(typeof V>"u")V=N;else{let U;const D=(x,L)=>{let R;const K=()=>{U=U||(0,r.deepClone)(o),R=R||c(U,L)};return(0,k.isObject)(x)?new Proxy(x,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return K(),()=>R;if(U)return R=R||c(U,L),R[$];const fe=W[$];return typeof $=="string"?D(fe,`${L}.${$}`):fe},set:(W,$,fe)=>(K(),R&&(R[$]=fe),!0),deleteProperty:(W,$)=>(K(),R&&delete R[$],!0),defineProperty:(W,$,fe)=>(K(),R&&Object.defineProperty(R,$,fe),!0)}):x};V=D(V,P)}return V},update:(P,N,V,U)=>{P=i?`${i}.${P}`:P;const D=g(V);return N!==void 0?this._proxy.$updateConfigurationOption(D,P,N,a,U):this._proxy.$removeConfigurationOption(D,P,a,U)},inspect:P=>{P=i?`${i}.${P}`:P;const N=(0,r.deepClone)(this._configuration.inspect(P,a,this._extHostWorkspace.workspace));if(N)return{key:P,defaultValue:N.policy?.value??N.default?.value,globalValue:N.user?.value??N.application?.value,workspaceValue:N.workspace?.value,workspaceFolderValue:N.workspaceFolder?.value,defaultLanguageValue:N.default?.override,globalLanguageValue:N.user?.override??N.application?.override,workspaceLanguageValue:N.workspace?.override,workspaceFolderLanguageValue:N.workspaceFolder?.override,languageIds:N.overrideIdentifiers}}};return typeof o=="object"&&(0,r.mixin)(p,o,!1),Object.freeze(p)}_toReadonlyValue(i){const n=s=>(0,k.isObject)(s)?new Proxy(s,{get:(a,o)=>n(a[o]),set:(a,o,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(a,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(a,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return n(i)}_validateConfigurationAccess(i,n,s){const a=E.OVERRIDE_PROPERTY_REGEX.test(i)?4:this._configurationScopes.get(i),o=s?`[${s.value}] `:"";if(a===4){typeof n?.resource>"u"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){n?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,n){const s=new A.ConfigurationChangeEvent(i,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,o)=>s.affectsConfiguration(a,l(o))})}_toMap(i){return i.reduce((n,s)=>(n.set(s[0],s[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[101],Ie([1,0,2,14,5,4,6,31,50,32,20,53,13,28,3,12,21,15,67,184,11]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var d;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(d=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(L){function R($){if($){const fe=$;return fe&&!!fe.process}else return!1}L.is=R;function K($){if($==null)return;const fe={process:$.process,args:$.args};return $.options&&(fe.options=i.from($.options)),fe}L.from=K;function W($){if($!=null)return new _.ProcessExecution($.process,$.args,$.options)}L.to=W})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(L){function R(W){if(W!=null)return W}L.from=R;function K(W){if(W!=null)return W}L.to=K})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(L){function R($){if($){const fe=$;return fe&&(!!fe.commandLine||!!fe.command)}else return!1}L.is=R;function K($){if($==null)return;const fe={};return $.commandLine!==void 0?fe.commandLine=$.commandLine:(fe.command=$.command,fe.args=$.args),$.options&&(fe.options=s.from($.options)),fe}L.from=K;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new _.ShellExecution($.commandLine,$.options):new _.ShellExecution($.command,$.args?$.args:[],$.options)}L.to=W})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(L){function R($){if($){const fe=$;return fe&&fe.customExecution==="customExecution"}else return!1}L.is=R;function K($){return{customExecution:"customExecution"}}L.from=K;function W($,fe){return fe.get($)}L.to=W})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var g;(function(L){function R(K,W){let $;return K.scope!==void 0&&typeof K.scope!="number"?$=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===_.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=I.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:$}}L.from=R})(g=e.TaskHandleDTO||(e.TaskHandleDTO={}));var p;(function(L){function R(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}L.from=R})(p=e.TaskGroupDTO||(e.TaskGroupDTO={}));var P;(function(L){function R($,fe){if($==null)return[];const J=[];for(const Q of $){const ce=K(Q,fe);ce&&J.push(ce)}return J}L.fromMany=R;function K($,fe){if($==null)return;let J;$.execution instanceof _.ProcessExecution?J=n.from($.execution):$.execution instanceof _.ShellExecution?J=a.from($.execution):$.execution&&$.execution instanceof _.CustomExecution&&(J=o.from($.execution));const Q=t.from($.definition);let ce;return $.scope?typeof $.scope=="number"?ce=$.scope:ce=$.scope.uri:ce=_.TaskScope.Workspace,!Q||!ce?void 0:{_id:$._id,definition:Q,name:$.name,source:{extensionId:fe.identifier.value,label:$.source,scope:ce},execution:J,isBackground:$.isBackground,group:p.from($.group),presentationOptions:d.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}L.from=K;async function W($,fe,J){if($==null)return;let Q;n.is($.execution)?Q=n.to($.execution):a.is($.execution)?Q=a.to($.execution):o.is($.execution)&&(Q=o.to($._id,J));const ce=t.to($.definition);let te;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?te=$.source.scope:te=await fe.resolveWorkspaceFolder(r.URI.revive($.source.scope)):te=_.TaskScope.Workspace),!ce||!te)return;const pe=new _.Task(ce,te,$.name,$.source.label,Q,$.problemMatchers);return $.isBackground!==void 0&&(pe.isBackground=$.isBackground),$.group!==void 0&&(pe.group=_.TaskGroup.from($.group._id),pe.group&&$.group.isDefault&&(pe.group=new _.TaskGroup(pe.group.id,pe.group.label),$.group.isDefault===!0&&(pe.group.isDefault=$.group.isDefault))),$.presentationOptions&&(pe.presentationOptions=d.to($.presentationOptions)),$._id&&(pe._id=$._id),$.detail&&(pe.detail=$.detail),pe}L.to=W})(P=e.TaskDTO||(e.TaskDTO={}));var N;(function(L){function R(W){return W}L.from=R;function K(W){if(!!W)return Object.assign(Object.create(null),W)}L.to=K})(N=e.TaskFilterDTO||(e.TaskFilterDTO={}));class V{constructor(R,K,W){this._id=K,this._task=W,w.set(this,void 0),Je(this,w,R,"f")}get task(){return this._task}terminate(){Oe(this,w,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}w=new WeakMap;var U;(function(L){function R(K){return{id:K._id,task:void 0}}L.from=R})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let D=class{constructor(R,K,W,$,fe,J,Q,ce){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=R.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=fe,this._terminalService=J,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(R,K,W){if(!W)return new _.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:K,provider:W,extension:R}),this._proxy.$registerTaskProvider($,K),new _.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(R,K){this._proxy.$registerTaskSystem(R,K)}fetchTasks(R){return this._proxy.$fetchTasks(N.from(R)).then(async K=>{const W=[];for(const $ of K){const fe=await P.to($,this._workspaceProvider,this._providedCustomExecutions2);fe&&W.push(fe)}return W})}get taskExecutions(){const R=[];return this._taskExecutions.forEach(K=>R.push(K)),R}terminateTask(R){if(!(R instanceof V))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(R._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(R,K,W){const $=this._providedCustomExecutions2.get(R.id);$&&(this._activeCustomExecutions2.set(R.id,$),this._terminalService.attachPtyToTerminal(K,await $.callback(W))),this._lastStartedTask=R.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(R)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(R){const K=await this.getTaskExecution(R);this._taskExecutionPromises.delete(R.id),this._taskExecutions.delete(R.id),this.customExecutionComplete(R),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessStarted.fire({execution:K,processId:R.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(R){const K=await this.getTaskExecution(R.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:R.exitCode})}$provideTasks(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));const $=[],fe=(0,y.asPromise)(()=>W.provider.provideTasks(O.CancellationToken.None)).then(J=>this.provideTasksInternal(K,$,W,J));return new Promise(J=>{fe.then(Q=>{Promise.all($).then(()=>{J(Q)})})})}async $resolveTask(R,K){const W=this._handlers.get(R);if(!W)return Promise.reject(new Error("no handler found"));if(K.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await P.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const fe=await W.provider.resolveTask($,O.CancellationToken.None);if(!fe)return;this.checkDeprecation(fe,W);const J=P.from(fe,W.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(fe.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(J.execution)&&await this.addCustomExecution(J,fe,!0),await this.resolveTaskInternal(J)}nextHandle(){return this._handleCounter++}async addCustomExecution(R,K,W){const $=await this._proxy.$createTaskId(R);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,K.execution)),this._providedCustomExecutions2.set($,K.execution)}async getTaskExecution(R,K){if(typeof R=="string"){const fe=this._taskExecutionPromises.get(R);if(!fe)throw new Error("Unexpected: The specified task is missing an execution");return fe}const W=this._taskExecutionPromises.get(R.id);if(W)return W;const $=new Promise((fe,J)=>{function Q(ce,te,pe){pe?fe(new V(ce,te.id,pe)):J("Unexpected: Task does not exist.")}K?Q(this,R,K):P.to(R.task,this._workspaceProvider,this._providedCustomExecutions2).then(ce=>Q(this,R,ce))});return this._taskExecutionPromises.set(R.id,$),$.then(fe=>(this._taskExecutions.set(R.id,fe),fe),fe=>Promise.reject(fe))}checkDeprecation(R,K){R._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(R){this._activeCustomExecutions2.get(R.id)&&this._activeCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.has(R.id)&&this._lastStartedTask!==R.id&&(this._providedCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.delete(R.id));const W=this._notProvidedCustomExecutions.values();let $=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};D=ze([$e(0,m.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,u.ILogService),$e(7,v.IExtHostApiDeprecationService)],D),e.ExtHostTaskBase=D;let x=class extends D{constructor(R,K,W,$,fe,J,Q,ce){super(R,K,W,$,fe,J,Q,ce),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(R,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const W=P.from(K,R);if(W===void 0)throw new Error("Task is not valid");if(o.is(W.execution))await this.addCustomExecution(W,K,!1);else throw new l.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),K);return this._proxy.$executeTask(W).catch(fe=>{throw new Error(fe)}),$}provideTasksInternal(R,K,W,$){const fe=[];if($)for(const J of $){this.checkDeprecation(J,W),(!J.definition||!R[J.definition.type])&&this._logService.warn(`The task [${J.source}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=P.from(J,W.extension);Q&&o.is(Q.execution)?(fe.push(Q),K.push(this.addCustomExecution(Q,J,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:fe,extension:W.extension}}async resolveTaskInternal(R){if(o.is(R.execution))return R;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(R,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,K,W){}};x=ze([$e(0,m.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,k.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,u.ILogService),$e(7,v.IExtHostApiDeprecationService)],x),e.WorkerExtHostTask=x,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ce[227],Ie([1,0,19,20,43,34,22,202,41]),function(ne,e,r,y,S,M,_,A,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(m,T,f){this.config=m,this.provider=T,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const T=this.config.folderQueries||[];return new Promise((f,c)=>{const h=u=>{this.resultCount++,m(u)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(u=>{const v=u.toString(),I=r.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,I)||this.matchFile(h,{base:u,basename:I})}),Promise.all(T.map(u=>this.searchInFolder(u,h))).then(u=>{f({limitHit:this.isLimitHit,stats:u[0]||void 0})},u=>{c(new Error((0,S.toErrorMessage)(u)))})})}async searchInFolder(m,T){const f=new y.CancellationTokenSource,c=this.getSearchOptionsForFolder(m),h=this.initDirectoryTree(),u=new E.QueryGlobTester(this.config,m),v=!u.hasSiblingExcludeClauses();let I;try{this.activeCancellationTokens.add(f),I=A.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,f.token),w=I.elapsed(),t=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(d=>{const i=r.posix.relative(m.folder.path,d.path);if(v){const n=r.basename(d.path);this.matchFile(T,{base:m.folder,relativePath:i,basename:n});return}this.addDirectoryEntries(h,m.folder,i,T)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,u,T),{providerTime:w,postProcessTime:t.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const T=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:T,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},T,f,c){if(f===this.filePattern){const u=r.basename(this.filePattern);this.matchFile(c,{base:T,relativePath:this.filePattern,basename:u})}function h(u){const v=r.basename(u),I=r.dirname(u);let l=m[I];l||(l=m[I]=[],h(I)),l.push({base:T,relativePath:u,basename:v})}h(f)}matchDirectoryTree({rootEntries:m,pathToEntries:T},f,c){const h=this,u=this.filePattern;function v(I){const l=(0,E.hasSiblingFn)(()=>I.map(w=>w.basename));for(let w=0,t=I.length;w<t;w++){const d=I[w],{relativePath:i,basename:n}=d;if(f.matchesExcludesSync(i,n,u!==n?l:void 0))continue;const s=T[i];if(s)v(s);else{if(i===u)continue;h.matchFile(c,d)}if(h.isLimitHit)break}}v(m)}matchFile(m,T){(!this.includePattern||T.relativePath&&this.includePattern(T.relativePath,T.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(T))}}class O{constructor(){this.sessions=new Map}fileSearch(m,T,f,c){const h=this.getSessionTokenSource(m.cacheKey),u=new k(m,T,h&&h.token);let v=0;const I=l=>{v+=l.length,f(l.map(w=>this.rawMatchToSearchItem(w)))};return this.doSearch(u,O.BATCH_SIZE,I,c).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:l.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new y.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:_.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,T,f,c){c.onCancellationRequested(()=>{m.cancel()});const h=v=>{v&&(u.push(v),T>0&&u.length>=T&&(f(u),u=[]))};let u=[];return m.search(h).then(v=>(u.length&&f(u),v),v=>(u.length&&f(u),Promise.reject(v)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(Ce[228],Ie([1,0,16,72,34,77,24,12,19,22,9,10,2,245,143,57,15,45,90,226,41]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(p,P,N,V,U){this.configurationService=p,this.workspaceContextService=P,this.editorGroupsService=N,this.logService=V,this.pathService=U}text(p,P,N={}){p=this.getContentPattern(p,N);const V=this.configurationService.getValue(),U=P&&P.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(P?.map(u.toWorkspaceFolder),N),type:2,contentPattern:p,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:V.search.usePCRE2||U||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}getContentPattern(p,P){const N=this.configurationService.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const V={...p,wordSeparators:N.editor.wordSeparators};return this.isCaseSensitive(p,P)&&(V.isCaseSensitive=!0),this.isMultiline(p)&&(V.isMultiline=!0),V}file(p,P={}){return{...this.commonQuery(p,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(p,P){return p?(p=Array.isArray(p)?p.map(s):s(p),P?this.parseSearchPaths(p):{pattern:d(...Array.isArray(p)?p:[p])}):{}}commonQuery(p=[],P={}){const N=this.handleIncludeExclude(P.includePattern,P.expandPatterns),V=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),U=p.length>1,D=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,P,V)):p.map(R=>this.getFolderQueryForRoot(R,P,V,U))).filter(R=>!!R),x={_reason:P._reason,folderQueries:D,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:V.pattern,includePattern:N.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const R=r.coalesce(r.flatten(this.editorGroupsService.groups.map($=>$.editors.map(fe=>fe.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const K=R.filter($=>(0,l.pathIncludedInQuery)(x,$.fsPath)),W=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...x,...W}}const L=P.extraFileResources&&P.extraFileResources.filter(R=>(0,l.pathIncludedInQuery)(x,R.fsPath));return x.extraFileResources=L&&L.length?L:void 0,x}commonQueryFromFileList(p){const P=[],N=new _.ResourceMap,V={};let U=!1;return p.forEach(D=>{if(D.scheme===A.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(D)){const L=this.workspaceContextService.getWorkspaceFolder(D)?.uri??D.with({path:E.dirname(D.fsPath)});let R=N.get(L);R||(U=!0,R={folder:L,includePattern:{}},P.push(R),N.set(L,R));const K=E.relative(L.fsPath,D.fsPath);(0,b.assertIsDefined)(R.includePattern)[K.replace(/\\/g,"/")]=!0}else D.fsPath&&(U=!0,V[D.fsPath]=!0)}),{folderQueries:P,includePattern:V,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}isCaseSensitive(p,P){if(P.isSmartCase){if(p.isRegExp){if(O.containsUppercaseCharacter(p.pattern,!0))return!0}else if(O.containsUppercaseCharacter(p.pattern))return!0}return!!p.isCaseSensitive}isMultiline(p){return p.isMultiline||p.isRegExp&&(0,T.isMultilineRegexSource)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const P=W=>E.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),V=(Array.isArray(p)?p:i(p)).map(W=>{const $=this.pathService.resolvedUserHome;return $?(0,M.untildify)(W,$.scheme===A.Schemas.file?$.fsPath:$.path):W}),U=y.groupBy(V,W=>P(W)?"searchPaths":"exprSegments"),D=(U.exprSegments||[]).map(W=>O.rtrim(W,"/")).map(W=>O.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),n(W))),x={},L=this.expandSearchPathPatterns(U.searchPaths||[]);L&&L.length&&(x.searchPaths=L);const R=r.flatten(D),K=d(...R);return K&&(x.pattern=K),x}getExcludesForFolder(p,P){return P.disregardExcludeSettings?void 0:(0,l.getExcludes)(p,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(p){if(!p||!p.length)return[];const P=r.flatten(p.map(V=>{let{pathPortion:U,globPortion:D}=t(V);D&&(D=a(D));const x=this.expandOneSearchPath(U);return r.flatten(x.map(L=>this.resolveOneSearchPathPattern(L,D)))})),N=new Map;return P.forEach(V=>{const U=V.searchPath.toString(),D=N.get(U);D?V.pattern&&(D.pattern=D.pattern||{},D.pattern[V.pattern]=!0):N.set(U,{searchPath:V.searchPath,pattern:V.pattern?d(V.pattern):void 0})}),Array.from(N.values())}expandOneSearchPath(p){if(E.isAbsolute(p)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==A.Schemas.file?[{searchPath:P[0].uri.with({path:p})}]:[{searchPath:m.URI.file(E.normalize(p))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(p=s(p),p.startsWith("../")||p===".."){const V=E.posix.resolve(P.path,p);return[{searchPath:P.with({path:V})}]}const N=a(p);return[{searchPath:P,pattern:N}]}else{if(p==="./"||p===".\\")return[];{const P=p.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map(U=>{const D=P.match(new RegExp(`^${O.escapeRegExpCharacters(U.name)}(?:/(.*)|$)`));return D?{match:D,folder:U}:null}).filter(b.isDefined);if(V.length)return V.map(U=>{const D=U.match[1];return{searchPath:U.folder.uri,pattern:D&&a(D)}});{const U=p.match(/\.[\/\\](.+)[\/\\]?/),D=U?U[1]:p,x=f.localize(0,null,D);throw new Error(x)}}}}resolveOneSearchPathPattern(p,P){const N=p.pattern&&P?`${p.pattern}/${P}`:p.pattern||P,V=[{searchPath:p.searchPath,pattern:N}];return N&&!N.endsWith("**")&&V.push({searchPath:p.searchPath,pattern:N+"/**"}),V}getFolderQueryForSearchPath(p,P,N){const V=this.getFolderQueryForRoot((0,u.toWorkspaceFolder)(p.searchPath),P,N,!1);return V?{...V,includePattern:p.pattern}:null}getFolderQueryForRoot(p,P,N,V){let U;const D=m.URI.isUri(p)?p:p.uri;if(N.searchPaths){const W=N.searchPaths.filter($=>(0,k.isEqual)($.searchPath,D))[0];if(W&&!W.pattern)return null;W&&(U=W.pattern)}const x=this.configurationService.getValue({resource:D}),R={...this.getExcludesForFolder(x,P)||{},...U||{}},K=m.URI.isUri(p)?(0,k.basename)(p):p.name;return{folder:D,folderName:V?K:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof P.disregardParentIgnoreFiles=="boolean"?P.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!x.search.followSymlinks}}};w=ze([$e(0,c.IConfigurationService),$e(1,u.IWorkspaceContextService),$e(2,v.IEditorGroupsService),$e(3,h.ILogService),$e(4,I.IPathService)],w),e.QueryBuilder=w;function t(g){const p=g.match(/[\*\{\}\(\)\[\]\?]/);if(p){const P=p.index,N=g.substr(0,P).match(/[/|\\][^/\\]*$/);if(N){let V=g.substr(0,N.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:g.substr((N.index||0)+1)}}}return{pathPortion:g}}function d(...g){return g.length?g.reduce((p,P)=>(p[P]=!0,p),Object.create(null)):void 0}function i(g){return S.splitGlobAware(g,",").map(p=>p.trim()).filter(p=>!!p.length)}function n(g){return[`**/${g}/**`,`**/${g}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function s(g){return g.replace(/\\/g,"/")}function a(g){return s(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(g,p){g=r.distinct(g,V=>V.toString());const P=[],N=p.getWorkspace();return g&&g.forEach(V=>{let U;if(p.getWorkbenchState()===2)U=(0,k.relativePath)(N.folders[0].uri,V),U&&U!=="."&&(U="./"+U);else{const D=p.getWorkspaceFolder(V);if(D){const x=D.name;if(N.folders.filter(R=>R.name===x).length===1){const R=(0,k.relativePath)(D.uri,V);R===""?U=`./${D.name}`:U=`./${D.name}/${R}`}else U=V.fsPath}}U&&P.push(U)}),P}e.resolveResourcesForSearchIncludes=o}),define(Ce[229],Ie([1,0,22,2,20,11,3,228,41,45]),function(ne,e,r,y,S,M,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function b(c,h){const u=h.activationEvents;if(!u)return Promise.resolve(void 0);const v=[],I=[];for(const n of u)if(/^workspaceContains:/.test(n)){const s=n.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||c.forceUsingSearch?I.push(s):v.push(s)}if(v.length===0&&I.length===0)return Promise.resolve(void 0);let l;const w=new Promise((n,s)=>{l=n}),t=n=>l({activationEvent:n}),d=Promise.all(v.map(n=>m(c,n,t))).then(()=>{}),i=T(c,h.identifier,I,t);return Promise.all([d,i]).then(()=>{l(void 0)}),w}e.checkActivateWorkspaceContainsExtension=b;async function m(c,h,u){for(const v of c.folders)if(await c.exists(r.joinPath(y.URI.revive(v),h))){u(`workspaceContains:${h}`);return}}async function T(c,h,u,v){if(u.length===0)return Promise.resolve(void 0);const I=new S.CancellationTokenSource,l=c.checkExists(c.folders,u,I.token),w=setTimeout(async()=>{I.cancel(),c.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},O);let t=!1;try{t=await l}catch(d){M.isCancellationError(d)||M.onUnexpectedError(d)}I.dispose(),clearTimeout(w),t&&v(`workspaceContains:${u.join(",")}`)}function f(c,h,u,v){const I=c.get(_.IInstantiationService),l=c.get(E.ISearchService),t=I.createInstance(A.QueryBuilder).file(h.map(d=>(0,k.toWorkspaceFolder)(y.URI.revive(d))),{_reason:"checkExists",includePattern:u,exists:!0});return l.fileSearch(t,v).then(d=>!!d.limitHit,d=>M.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ne,e,r,y,S){if(y==="m")throw new TypeError("Private method is not writable");if(y==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!S:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return y==="a"?S.call(ne,r):S?S.value=r:e.set(ne,r),r},Oe=this&&this.__classPrivateFieldGet||function(ne,e,r,y){if(r==="a"&&!y)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!y:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?y:r==="a"?y.call(ne):y?y.value:e.get(ne)};define(Ce[33],Ie([1,0,130,19,71,22,14,7,24,2,15,4,32,173,69,31,25,172,11,27,23,157,6,85,3,28,70,13,58,62,53,5,229,68,159,12]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l,w,t,d,i,n,s,a,o,g,p,P,N,V,U,D){"use strict";var x,L,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let K=class Ai extends A.Disposable{constructor(te,pe,be,re,Ee,Pe,Fe,We,Xe,Te){super(),this._onDidChangeRemoteConnectionData=this._register(new P.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=pe,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=re,this._extHostConfiguration=Ee,this._logService=Pe,this._extHostTunnelService=Xe,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._globalRegistry=new u.ExtensionDescriptionRegistry(this._initData.allExtensions);const _e=(0,h.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new u.ExtensionDescriptionRegistry(fe(this._globalRegistry,_e)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=te.createChild(new o.ServiceCollection([f.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));let ye=[],ae=[];this._initData.remote.isRemote&&(ye=this._initData.allExtensions.filter(Y=>!Y.main&&!Y.browser).map(Y=>Y.identifier),ae=this._initData.allExtensions.filter(Y=>!_e.has(I.ExtensionIdentifier.toKey(Y.identifier.value))).filter(Y=>(Y.main||Y.browser)&&Y.api==="none").map(Y=>Y.identifier));const ue=(0,h.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new T.ExtensionsActivator(this._myRegistry,ye,ae,{onExtensionActivationError:(Y,ee,C)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Y,v.transformErrorForSerialization(ee),C)},actualActivateExtension:async(Y,ee)=>{if(ue.has(I.ExtensionIdentifier.toKey(Y)))return await this._mainThreadExtensionsProxy.$activateExtension(Y,ee),new T.HostExtension;const C=this._myRegistry.getExtensionDescription(Y);return this._activateExtension(C,ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){v.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this._deactivate(Ee))}catch{}await Promise.all(te)}terminate(te,pe=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(re=>{this._logService.error(re)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,_.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${pe}`):this._logService.info(`Extension host exiting with code ${pe}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(pe)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const pe=await this._mainThreadExtensionsProxy.$getExtension(te);let be;if(pe?.browserNlsBundleUris){be={};for(const re of Object.keys(pe.browserNlsBundleUris))be[re]=k.URI.revive(pe.browserNlsBundleUris[re])}return pe&&{...pe,identifier:new I.ExtensionIdentifier(pe.identifier.value),extensionLocation:k.URI.revive(pe.extensionLocation),browserNlsBundleUris:be}}_activateByEvent(te,pe){return this._activator.activateByEvent(te,pe)}_activateById(te,pe){return this._activator.activateById(te,pe)}activateByIdWithErrors(te,pe){return this._activateById(te,pe).then(()=>{const be=this._activator.getActivatedExtension(te);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==D.Schemas.file)return te;const pe=await this._hostUtils.realpath(te.fsPath);return k.URI.file(pe)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new Q(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const pe=E.TernarySearchTree.forUris(be=>M.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(te.map(async be=>{if(this._getEntryPoint(be)){const re=await this._realPathExtensionUri(be.extensionLocation);pe.set(re,be)}})),pe}_deactivate(te){let pe=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return pe;const be=this._activator.getActivatedExtension(te);if(!be)return pe;try{typeof be.module.deactivate=="function"&&(pe=Promise.resolve(be.module.deactivate()).then(void 0,re=>(this._logService.error(re),Promise.resolve(void 0))))}catch(re){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(re)}try{(0,A.dispose)(be.subscriptions)}catch(re){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(re)}return pe}async _activateExtension(te,pe){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,pe).then(be=>{const re=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,re.codeLoadingTime,re.activateCallTime,re.activateResolvedTime,pe),this._logExtensionActivationTimes(te,pe,"success",re),be},be=>{throw this._logExtensionActivationTimes(te,pe,"failure"),be})}_logExtensionActivationTimes(te,pe,be,re){const Ee=W(te,pe);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Ee,...re||{},outcome:be})}_doActivateExtension(te,pe){const be=W(te,pe);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const re=this._getEntryPoint(te);if(!re)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${pe.startup}, activationEvent: '${pe.activationEvent}'${te.identifier.value!==pe.extensionId.value?`, root cause: ${pe.extensionId.value}`:""}`),this._logService.flush();const Ee=new T.ExtensionActivationTimesBuilder(pe.startup);return Promise.all([this._loadCommonJSModule(te,(0,M.joinPath)(te.extensionLocation,re),Ee),this._loadExtensionContext(te)]).then(Pe=>(S.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ai._callActivate(this._logService,te.identifier,Pe[0],Pe[1],Ee))).then(Pe=>(S.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Pe))}_loadExtensionContext(te){const pe=new w.ExtensionGlobalMemento(te,this._storage),be=new w.ExtensionMemento(te.identifier.value,!1,this._storage),re=new U.ExtensionSecrets(te,this._secretState),Ee=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([pe.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let We,Xe;const Te=(0,h.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(I.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:pe,workspaceState:be,secrets:re,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(_e){return y.join(te.extensionLocation.fsPath,_e)},get storagePath(){return Fe._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(te).fsPath},get logPath(){return y.join(Fe._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return k.URI.joinPath(Fe._initData.logsLocation,te.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(te)},get globalStorageUri(){return Fe._storagePath.globalValue(te)},get extensionMode(){return Ee},get extension(){return We===void 0&&(We=new $(Fe,te.identifier,te,Pe,!1)),We},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(te,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Xe){if(!Te)return;const _e=P.Event.buffer(P.Event.fromDOMEventEmitter(Te,"message",ye=>ye.data));Te.start(),Xe={onDidReceiveMessage:_e,postMessage:Te.postMessage.bind(Te)}}return Xe}})})}static _callActivate(te,pe,be,re,Ee){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,pe,be,re,Ee).then(Pe=>new T.ActivatedExtension(!1,null,Ee.build(),be,Pe,re.subscriptions))}static _callActivateOptional(te,pe,be,re,Ee){if(typeof be.activate=="function")try{Ee.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${pe.value}`);const Pe=typeof global=="object"?global:self,Fe=be.activate.apply(Pe,[re]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(Fe).then(We=>(Ee.activateResolveStop(),We))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(be)}_activateOneStartupFinished(te,pe){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:pe}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const pe of te.activationEvents)pe==="onStartupFinished"&&this._activateOneStartupFinished(te,pe)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,Ee=>{this._logService.error(Ee)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Ee=>this._handleWorkspaceContainsEagerExtensions(Ee.added)));const pe=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(pe),re=Promise.all([te,be]).then(()=>{});return Promise.race([re,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),re}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(pe=>this._handleWorkspaceContainsEagerExtension(te,pe))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,pe){if(this.isActivated(pe.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,re={logService:this._logService,folders:te.map(Pe=>Pe.uri),forceUsingSearch:be,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Fe,We)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Fe,We)},Ee=await(0,N.checkActivateWorkspaceContainsExtension)(re,pe);if(!!Ee)return this._activateById(pe.identifier,{startup:!0,extensionId:pe.identifier,activationEvent:Ee.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:pe}=this._initData.environment;if(!te||!pe)throw new Error(r.localize(0,null));const be=await this._loadCommonJSModule(null,pe,new T.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(r.localize(1,null,pe.toString()));return new Promise((re,Ee)=>{const Pe=(Xe,Te)=>{Xe?Ee(Xe):re(typeof Te=="number"&&Te>0?1:0)},Fe=(0,M.originalFSPath)(pe),We=be.run(Fe,Pe);We&&We.then&&We.then(()=>{re(0)}).catch(Xe=>{Ee(Xe instanceof Error&&Xe.stack?Xe.stack:String(Xe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,pe){return this._resolvers[te]=pe,(0,A.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const pe=te.indexOf("+");if(pe===-1)throw new Error("Not an authority that can be resolved!");const be=te.substr(0,pe);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(te,pe){this._logService.info(`$resolveAuthority invoked for authority (${J(te)})`);const{authorityPrefix:be,resolver:re}=await this._activateAndGetResolver(te);if(!re)return{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(re)),S.mark(`code/extHost/willResolveAuthority/${be}`);const Ee=await re.resolve(te,{resolveAttempt:pe});S.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Pe={authority:te,host:Ee.host,port:Ee.port,connectionToken:Ee.connectionToken},Fe={extensionHostEnv:Ee.extensionHostEnv,isTrusted:Ee.isTrusted,authenticationSession:Ee.authenticationSessionForInitializingExtensions?{id:Ee.authenticationSessionForInitializingExtensions.id,providerId:Ee.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Pe,options:Fe,tunnelInformation:{environmentTunnels:Ee.environmentTunnels,features:Ee.tunnelFeatures}}}}catch(Ee){if(S.mark(`code/extHost/didResolveAuthorityError/${be}`),Ee instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Ee._code,message:Ee._message,detail:Ee._detail}};throw Ee}}async $getCanonicalURI(te,pe){this._logService.info(`$getCanonicalURI invoked for authority (${J(te)})`);const{resolver:be}=await this._activateAndGetResolver(te);if(!be)return null;const re=k.URI.revive(pe);if(typeof be.getCanonicalURI>"u")return re;const Ee=await(0,_.asPromise)(()=>be.getCanonicalURI(re));return Ee||re}static _applyExtensionsDelta(te,pe,be){const re=new u.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());re.deltaExtensions(be.toAdd,be.toRemove);const Ee=(0,h.extensionIdentifiersArrayToSet)(pe.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)Ee.delete(I.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)Ee.add(I.ExtensionIdentifier.toKey(Fe));const Pe=fe(re,Ee);return{globalRegistry:re,myExtensions:Pe}}$startExtensionHost(te){te.toAdd.forEach(re=>re.extensionLocation=k.URI.revive(re.extensionLocation));const{globalRegistry:pe,myExtensions:be}=Ai._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(pe.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(te,pe){return pe===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(te,!1))}async $activate(te,pe){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,pe),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Pe=>Pe.extensionLocation=k.URI.revive(Pe.extensionLocation));const{globalRegistry:pe,myExtensions:be}=Ai._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),re=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(re),this._globalRegistry.set(pe.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const pe=l.VSBuffer.alloc(te),be=Math.random()%256;for(let re=0;re<te;re++)pe.writeUInt8(be,re);return pe}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};K=ze([$e(0,i.IInstantiationService),$e(1,e.IHostUtils),$e(2,a.IExtHostRpcService),$e(3,c.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,O.ILogService),$e(6,n.IExtHostInitDataService),$e(7,s.IExtensionStoragePaths),$e(8,g.IExtHostTunnelService),$e(9,p.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function W(ce,te){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class ${constructor(te,pe,be,re,Ee){x.set(this,void 0),L.set(this,void 0),R.set(this,void 0),Je(this,x,te,"f"),Je(this,L,pe,"f"),Je(this,R,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=y.normalize((0,M.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=re,this.isFromDifferentExtensionHost=Ee}get isActive(){return Oe(this,x,"f").isActivated(Oe(this,R,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,x,"f").getExtensionExports(Oe(this,R,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,x,"f").activateByIdWithErrors(Oe(this,R,"f"),{startup:!1,extensionId:Oe(this,L,"f"),activationEvent:"api"}),this.exports}}e.Extension=$,x=new WeakMap,L=new WeakMap,R=new WeakMap;function fe(ce,te){return ce.getAllExtensionDescriptions().filter(pe=>te.has(I.ExtensionIdentifier.toKey(pe.identifier)))}function J(ce){const te=ce.indexOf("+");return te===-1?ce:ce.substring(0,te)}class Q{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=Q}),define(Ce[230],Ie([1,0,71,2,4,32,25,27,13,28,3,33,59,15,9]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(w,t,d,i,n,s,a){this._apiFactory=w,this._extensionRegistry=t,this._instaService=d,this._extHostConfiguration=i,this._extHostExtensionService=n,this._initData=s,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const w=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const t=await this._extHostExtensionService.getExtensionPathIndex();this.register(new u(this._apiFactory,t,this._extensionRegistry,w,this._logService)),this.register(this._instaService.createInstance(v,t)),this.register(this._instaService.createInstance(h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(I,t,this._initData.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const t of w.nodeModuleName)this._factories.set(t,w);else this._factories.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this._alternatives.push(t=>w.alternativeModuleName(t))}};c=ze([$e(2,O.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,b.IExtHostExtensionService),$e(5,k.IExtHostInitDataService),$e(6,T.ILogService)],c),e.RequireInterceptor=c;let h=class Xi{constructor(w){if(w.environment.appRoot&&Xi.aliased.size){const t=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(w.environment.appRoot.fsPath)),d="[a-z0-9_.-]",i=`@${d}+\\/${d}+|${d}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${t}/${n}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(w){if(!this.re)return;const t=this.re.exec(this.forceForwardSlashes(w));if(!t)return;const[,d,i,n]=t,s=Xi.aliased.get(i);if(s!==void 0)return console.warn(`${i} as been renamed to ${s}, please update your imports`),d+s+n}forceForwardSlashes(w){return w.replace(/\\/g,"/")}};h.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=ze([$e(0,k.IExtHostInitDataService)],h);class u{constructor(w,t,d,i,n){this._apiFactory=w,this._extensionPaths=t,this._extensionRegistry=d,this._configProvider=i,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(w,t){const d=this._extensionPaths.findSubstr(t);if(d){let i=this._extApiImpl.get(A.ExtensionIdentifier.toKey(d.identifier));return i||(i=this._apiFactory(d,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(d.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((n,s)=>i+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(w,t,d){this._extensionPaths=w,this.nodeModuleName="keytar",this._mainThreadTelemetry=t.getProxy(S.MainContext.MainThreadTelemetry);const{environment:i}=d,n=t.getProxy(S.MainContext.MainThreadKeytar);if(i.appRoot){let s=i.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,a)=>n.$getPassword(s,a),setPassword:(s,a,o)=>n.$setPassword(s,a,o),deletePassword:(s,a)=>n.$deletePassword(s,a),findPassword:s=>n.$findPassword(s),findCredentials(s){return n.$findCredentials(s)}}}load(w,t){const d=this._extensionPaths.findSubstr(t);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(w){const t=w.length;if(t<=7||!this.alternativeNames)return;const d=t-7;if((w.charAt(d)==="/"||w.charAt(d)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.alternativeNames.has(w)))return"keytar"}};v=ze([$e(1,E.IExtHostRpcService),$e(2,k.IExtHostInitDataService)],v);let I=class{constructor(w,t,d){this._extensionPaths=w,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=d.getProxy(S.MainContext.MainThreadTelemetry);const i=d.getProxy(S.MainContext.MainThreadWindow);this._impl=(n,s)=>{const a=y.URI.parse(n);return s?this.callOriginal(n,s):a.scheme==="http"||a.scheme==="https"?i.$openUri(a,n,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?i.$openUri(a,n,{}):this.callOriginal(n,s)}}load(w,t,d){const i=this._extensionPaths.findSubstr(t);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=d(w),this._impl}callOriginal(w,t){return this.sendNoForwardTelemetry(),this._original(w,t)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};I=ze([$e(2,E.IExtHostRpcService)],I)}),define(Ce[102],Ie([1,0,196,7,19,59,3,50,51,33,6,31,169,32]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,_.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(u,v,I,l,w,t,d){function i(){if(I){const n=I.activeEditor();if(n)return n.document.uri;const s=l.tabGroups.all.find(a=>a.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof O.TextDiffTabInput||s.input instanceof O.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof O.TextTabInput||s.input instanceof O.NotebookEditorTabInput||s.input instanceof O.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:n=>{const s=t.folders.filter(a=>a.name===n);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,s)=>w.getConfiguration(void 0,n).get(s),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=i();if(n)return S.normalize(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const n=i();if(n){const s=v.getWorkspaceFolder(n);if(s)return S.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(I){const n=I.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(I){const n=I.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>u.getExtension(n)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let c=class extends y.Disposable{constructor(u,v,I,l,w){super(),this.extensionService=u,this.workspaceService=v,this.editorService=I,this.configurationService=l,this.editorTabs=w,this._resolver=new r.Lazy(async()=>{const t=await this.configurationService.getConfigProvider(),i={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async n=>{i.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,t,i,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};c=ze([$e(0,k.IExtHostExtensionService),$e(1,b.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,T.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs)],c),e.ExtHostVariableResolverProviderService=c}),define(Ce[103],Ie([1,0,14,5,10,2,3,4,51,33,13,6,31,162,164,32,102]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let u=class{constructor(i,n,s,a,o,g){this._workspaceService=n,this._extensionService=s,this._configurationService=a,this._editorTabs=o,this._variableResolver=g,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=i.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new I(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(p=>{p.onDidChange(P=>{this.registerAllDebugTypes(p)}),this.registerAllDebugTypes(p)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(i,n){const s=i;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let a=`debug:${encodeURIComponent(s.path||"")}`,o="?";return n&&(a+=`${o}session=${encodeURIComponent(n.id)}`,o="&"),a+=`${o}ref=${s.sourceReference}`,M.URI.parse(a)}else{if(s.path)return M.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(i){const n=[];for(const s of i.getAllExtensionDescriptions())if(s.contributes){const a=s.contributes.debuggers;if(a&&a.length>0)for(const o of a)(0,f.isDebuggerMainContribution)(o)&&n.push(o.type)}this._debugServiceProxy.$registerDebugTypes(n)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const i=[];return this._breakpoints.forEach(n=>i.push(n)),i}addBreakpoints(i){this.startBreakpoints();const n=i.filter(o=>{const g=o.id;return this._breakpoints.has(g)?!1:(this._breakpoints.set(g,o),!0)});this.fireBreakpointChanges(n,[],[]);const s=[],a=new Map;for(const o of n)if(o instanceof b.SourceBreakpoint){let g=a.get(o.location.uri.toString());g||(g={type:"sourceMulti",uri:o.location.uri,lines:[]},a.set(o.location.uri.toString(),g),s.push(g)),g.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof b.FunctionBreakpoint&&s.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(i){this.startBreakpoints();const n=i.filter(g=>this._breakpoints.delete(g.id));this.fireBreakpointChanges([],n,[]);const s=n.filter(g=>g instanceof b.SourceBreakpoint).map(g=>g.id),a=n.filter(g=>g instanceof b.FunctionBreakpoint).map(g=>g.id),o=n.filter(g=>g instanceof b.DataBreakpoint).map(g=>g.id);return this._debugServiceProxy.$unregisterBreakpoints(s,a,o)}startDebugging(i,n,s){return this._debugServiceProxy.$startDebugging(i?i.uri:void 0,n,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,debugUI:s.debugUI,suppressSaveBeforeStart:s.suppressSaveBeforeStart})}stopDebugging(i){return this._debugServiceProxy.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,n,s){if(!n)return new b.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:i,handle:a,provider:n}),this._debugServiceProxy.$registerDebugConfigurationProvider(i,s,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,a),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==n),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(i,n,s){if(!s)return new b.Disposable(()=>{});if(!this.definesDebugType(i,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.getAdapterDescriptorFactoryByType(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:n,handle:a,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(n,a),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(i,n){if(!n)return new b.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:i,handle:s,factory:n}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==n)})}async $runInTerminal(i,n){return Promise.resolve(void 0)}async $substituteVariables(i,n){let s;const a=await this.getFolder(i);return a&&(s={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,n)}createDebugAdapter(i,n){if(i.type==="implementation")return new w(i.implementation)}createSignService(){}async $startDASession(i,n){const s=this,a=await this.getSession(n);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const g=this.convertToDto(o),p=this.createDebugAdapter(g,a);if(!p)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const P=p;return this._debugAdapters.set(i,P),this.getDebugAdapterTrackers(a).then(N=>(N&&this._debugAdaptersTrackers.set(i,N),P.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const U=V,D={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const x=await this._signService.sign(U.arguments.value);D.body={signature:x},P.sendResponse(D)}else throw new Error("no signer")}catch(x){D.success=!1,D.message=x.message,P.sendResponse(D)}}else N&&N.onDidSendMessage&&N.onDidSendMessage(V),V=(0,f.convertToVSCPaths)(V,!0),s._debugServiceProxy.$acceptDAMessage(i,V)}),P.onError(V=>{N&&N.onError&&N.onError(V),this._debugServiceProxy.$acceptDAError(i,V.name,V.message,V.stack)}),P.onExit(V=>{N&&N.onExit&&N.onExit((0,S.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(i,(0,S.withNullAsUndefined)(V),void 0)}),N&&N.onWillStartSession&&N.onWillStartSession(),P.startSession()))})}$sendDAMessage(i,n){n=(0,f.convertToDAPaths)(n,!1);const s=this._debugAdaptersTrackers.get(i);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(n),this._debugAdapters.get(i)?.sendMessage(n)}$stopDASession(i){const n=this._debugAdaptersTrackers.get(i);this._debugAdaptersTrackers.delete(i),n&&n.onWillStopSession&&n.onWillStopSession();const s=this._debugAdapters.get(i);return this._debugAdapters.delete(i),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const n=[],s=[],a=[];if(i.added)for(const o of i.added){const g=o.id;if(g&&!this._breakpoints.has(g)){let p;if(o.type==="function")p=new b.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")p=new b.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const P=M.URI.revive(o.uri);p=new b.SourceBreakpoint(new b.Location(P,new b.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}p._id=g,this._breakpoints.set(g,p),n.push(p)}}if(i.removed)for(const o of i.removed){const g=this._breakpoints.get(o);g&&(this._breakpoints.delete(o),s.push(g))}if(i.changed){for(const o of i.changed)if(o.id){const g=this._breakpoints.get(o.id);if(g){if(g instanceof b.FunctionBreakpoint&&o.type==="function"){const p=g;p.enabled=o.enabled,p.condition=o.condition,p.hitCondition=o.hitCondition,p.logMessage=o.logMessage,p.functionName=o.functionName}else if(g instanceof b.SourceBreakpoint&&o.type==="source"){const p=g;p.enabled=o.enabled,p.condition=o.condition,p.hitCondition=o.hitCondition,p.logMessage=o.logMessage,p.location=new b.Location(M.URI.revive(o.uri),new b.Position(o.line,o.character))}a.push(g)}}}this.fireBreakpointChanges(n,s,a)}$provideDebugConfigurations(i,n,s){return(0,r.asPromise)(async()=>{const a=this.getConfigProviderByHandle(i);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(n);return a.provideDebugConfigurations(o,s)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(i,n,s,a){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const g=await this.getFolder(n);return o.resolveDebugConfiguration(g,s,a)})}$resolveDebugConfigurationWithSubstitutedVariables(i,n,s,a){return(0,r.asPromise)(async()=>{const o=this.getConfigProviderByHandle(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const g=await this.getFolder(n);return o.resolveDebugConfigurationWithSubstitutedVariables(g,s,a)})}async $provideDebugAdapter(i,n){const s=this.getAdapterDescriptorFactoryByHandle(i);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(n);return this.getAdapterDescriptor(s,a).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(i){const n=await this.getSession(i);this._onDidStartDebugSession.fire(n)}async $acceptDebugSessionTerminated(i){const n=await this.getSession(i);n&&(this._onDidTerminateDebugSession.fire(n),this._debugSessions.delete(n.id))}async $acceptDebugSessionActiveChanged(i){this._activeDebugSession=i?await this.getSession(i):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(i,n){(await this.getSession(i))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(i,n){const a={session:await this.getSession(i),event:n.event,body:n.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(i){if(i instanceof b.DebugAdapterExecutable)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof b.DebugAdapterServer)return{type:"server",port:i.port,host:i.host};if(i instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:i.path};if(i instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(i){const n=this._adapterFactories.filter(s=>s.type===i);if(n.length>0)return n[0].factory}getAdapterDescriptorFactoryByHandle(i){const n=this._adapterFactories.filter(s=>s.handle===i);if(n.length>0)return n[0].factory}getConfigProviderByHandle(i){const n=this._configProviders.filter(s=>s.handle===i);if(n.length>0)return n[0].provider}definesDebugType(i,n){if(i.contributes){const s=i.contributes.debuggers;if(s&&s.length>0){for(const a of s)if(a.label&&a.type&&a.type===n)return!0}}return!1}getDebugAdapterTrackers(i){const s=i.configuration.type,a=this._trackerFactories.filter(o=>o.type===s||o.type==="*").map(o=>(0,r.asPromise)(()=>o.factory.createDebugAdapterTracker(i)).then(g=>g,g=>null));return Promise.race([Promise.all(a).then(o=>{const g=o.filter(p=>!!p);if(g.length>0)return new l(g)}),new Promise((o,g)=>{const p=setTimeout(()=>{clearTimeout(p),g(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(i,n){const s=n.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new b.DebugAdapterServer(s));if(i){const o=await this._extensionService.getExtensionRegistry();return(0,r.asPromise)(()=>i.createDebugAdapterDescriptor(n,this.daExecutableFromPackage(n,o))).then(g=>{if(g)return g})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(n,a))}daExecutableFromPackage(i,n){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(i,n,s){(i.length>0||n.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:i,removed:n,changed:s}))}async getSession(i){if(i)if(typeof i=="string"){const n=this._debugSessions.get(i);if(n)return n}else{let n=this._debugSessions.get(i.id);if(!n){const s=await this.getFolder(i.folderUri),a=i.parent?this._debugSessions.get(i.parent):void 0;n=new v(this._debugServiceProxy,i.id,i.type,i.name,s,i.configuration,a),this._debugSessions.set(n.id,n),this._debugServiceProxy.$sessionCached(n.id)}return n}throw new Error("cannot find session")}getFolder(i){if(i){const n=M.URI.revive(i);return this._workspaceService.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};u=ze([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,c.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,h.IExtHostVariableResolverProvider)],u),e.ExtHostDebugServiceBase=u;class v{constructor(i,n,s,a,o,g,p){this._debugServiceProxy=i,this._id=n,this._type=s,this._name=a,this._workspaceFolder=o,this._configuration=g,this._parentSession=p}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(i){this._name=i,this._debugServiceProxy.$setDebugSessionName(this._id,i)}get parentSession(){return this._parentSession}_acceptNameChanged(i){this._name=i}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(i,n){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,i,n)}getDebugProtocolBreakpoint(i){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,i.id)}}e.ExtHostDebugSession=v;class I{constructor(i){this.value=Object.freeze({append(n){i.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.ExtHostDebugConsole=I;class l{constructor(i){this.trackers=i}onWillStartSession(){this.trackers.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.trackers.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.trackers.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(i):void 0)}onWillStopSession(){this.trackers.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.trackers.forEach(n=>n.onError?n.onError(i):void 0)}onExit(i,n){this.trackers.forEach(s=>s.onExit?s.onExit(i,n):void 0)}}class w extends T.AbstractDebugAdapter{constructor(i){super(),this.implementation=i,i.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.implementation.handleMessage(i)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let t=class extends u{constructor(i,n,s,a,o,g){super(i,n,s,a,o,g)}};t=ze([$e(0,O.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,c.IExtHostConfiguration),$e(4,E.IExtHostEditorTabs),$e(5,h.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[231],Ie([1,0,11,71,2,4,222,15,56,58,28,147,13,46,33]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class c{constructor(u,v,I,l,w){this._hostUtils=I,this._rpcProtocol=new _.RPCProtocol(u,null,l),v=c._transform(v,this._rpcProtocol);const t=new k.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());t.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:w}),t.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),t.set(T.IURITransformerService,new T.URITransformerService(l)),t.set(f.IHostUtils,I);const d=new b.InstantiationService(t,!0);this._logService=d.invokeFunction(a=>a.get(A.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=d.invokeFunction(a=>a.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const i=new WeakMap;this._extensionService.getExtensionPathIndex().then(a=>{Error.prepareStackTrace=(o,g)=>{let p="",P,N;for(const V of g)p+=`
	at ${V.toString()}`,N=V.getFileName(),!P&&N&&(P=a.findSubstr(S.URI.file(N)));return i.set(o,P),`${o.name||"Error"}: ${o.message||""}${p}`}});const n=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(M.MainContext.MainThreadErrors);r.setUnexpectedErrorHandler(a=>{const o=r.transformErrorForSerialization(a),g=i.get(a);g?n.$onExtensionRuntimeError(g.identifier,o):s.$onUnexpectedError(o)})}async asBrowserUri(u){const v=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return S.URI.revive(await v.$asBrowserUri(u))}terminate(u){this._extensionService.terminate(u)}static _transform(u,v){u.allExtensions.forEach(l=>{l.extensionLocation=S.URI.revive(v.transformIncomingURIs(l.extensionLocation));const w={};l.browserNlsBundleUris&&(Object.keys(l.browserNlsBundleUris).forEach(t=>w[t]=S.URI.revive(v.transformIncomingURIs(l.browserNlsBundleUris[t]))),l.browserNlsBundleUris=w)}),u.environment.appRoot=S.URI.revive(v.transformIncomingURIs(u.environment.appRoot));const I=u.environment.extensionDevelopmentLocationURI;return I&&(u.environment.extensionDevelopmentLocationURI=I.map(l=>S.URI.revive(v.transformIncomingURIs(l)))),u.environment.extensionTestsLocationURI=S.URI.revive(v.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=S.URI.revive(v.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=S.URI.revive(v.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=S.URI.revive(v.transformIncomingURIs(u.logsLocation)),u.logFile=S.URI.revive(v.transformIncomingURIs(u.logFile)),u.workspace=v.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=c}),define(Ce[232],Ie([1,0,16,14,20,43,12,19,22,2,41]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(v,I,l,w){this.query=v,this.provider=I,this.fileUtils=l,this.processType=w,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,I){const l=this.query.folderQueries||[],w=new S.CancellationTokenSource;return I.onCancellationRequested(()=>w.cancel()),new Promise((t,d)=>{this.collector=new T(v);let i=!1;const n=(s,a)=>{if(!i&&!this.isLimitHit){const o=this.resultSize(s);c(s)&&typeof this.query.maxResults=="number"&&this.resultCount+o>this.query.maxResults&&(this.isLimitHit=!0,i=!0,w.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const g=this.resultSize(s);this.resultCount+=g,(g>0||!c(s))&&this.collector.add(s,a)}};Promise.all(l.map((s,a)=>this.searchInFolder(s,o=>n(o,a),w.token))).then(s=>{w.dispose(),this.collector.flush();const a=s.some(o=>!!o&&!!o.limitHit);t({limitHit:this.isLimitHit||a,messages:(0,r.flatten)(s.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.processType}})},s=>{w.dispose();const a=(0,M.toErrorMessage)(s);d(new Error(a))})})}resultSize(v){return c(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,I){const l=Array.isArray(v.ranges)?v.ranges:[v.ranges],w=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:l.slice(0,I),preview:{matches:w.slice(0,I),text:v.preview.text},uri:v.uri}}async searchInFolder(v,I,l){const w=new O.QueryGlobTester(this.query,v),t=[],d={report:s=>{if(!this.validateProviderResult(s))return;const a=v.folder.scheme===_.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(s.uri))):void 0,o=E.relativePath(v.folder,s.uri);if(o){const g=w.includedInQuery(o,A.basename(o),a);(0,y.isThenable)(g)?t.push(g.then(p=>{p&&I(s)})):g&&I(s)}}},i=this.getSearchOptionsForFolder(v),n=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,d,l);return t.length&&await Promise.all(t),n}validateProviderResult(v){if(c(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const I=(0,O.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),l=(0,O.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),w={folder:k.URI.from(v.folder),excludes:l,includes:I,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return w.usePCRE2=this.query.usePCRE2,w}}e.TextSearchManager=b;function m(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class T{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new h(512,I=>this.sendItems(I))}add(v,I){this._currentFileMatch&&(this._currentFolderIdx!==I||!E.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=I,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(f(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=T;function f(u){return c(u)?{preview:{matches:(0,r.mapArrayOrNot)(u.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:u.preview.text},ranges:(0,r.mapArrayOrNot)(u.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function c(u){return!!u.preview}e.extensionResultIsMatch=c;class h{constructor(v,I){this.maxBatchSize=v,this.cb=I,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,I){!v||this.addItemToBatch(v,I)}addItems(v,I){!v||this.addItemsToBatch(v,I)}addItemToBatch(v,I){this.batch.push(v),this.batchSize+=I,this.onUpdate()}addItemsToBatch(v,I){this.batch=this.batch.concat(v),this.batchSize+=I,this.onUpdate()}onUpdate(){this.totalNumberCompleted<h.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},h.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=h,h.TIMEOUT=4e3,h.START_BATCH_AFTER_COUNT=50}),define(Ce[104],Ie([1,0,7,4,3,227,13,46,15,2,232]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,S.createDecorator)("IExtHostSearch");let b=class{constructor(c,h,u){this.extHostRpc=c,this._uriTransformer=h,this._logService=u,this._proxy=this.extHostRpc.getProxy(y.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,h){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const u=this._handlePool++;return this._textSearchProvider.set(u,h),this._proxy.$registerTextSearchProvider(u,this._transformScheme(c)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}registerFileSearchProvider(c,h){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const u=this._handlePool++;return this._fileSearchProvider.set(u,h),this._proxy.$registerFileSearchProvider(u,this._transformScheme(c)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(u),this._proxy.$unregisterProvider(u)})}$provideFileSearchResults(c,h,u,v){const I=m(u),l=this._fileSearchProvider.get(c);if(l)return this._fileSearchManager.fileSearch(I,l,w=>{this._proxy.$handleFileMatch(c,h,w.map(t=>t.resource))},v);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,h,u,v){const I=this._textSearchProvider.get(c);if(!I||!I.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const l=m(u);return this.createTextSearchManager(l,I).search(t=>this._proxy.$handleTextMatch(c,h,t),v)}$enableExtensionHostSearch(){}createTextSearchManager(c,h){return new O.TextSearchManager(c,h,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};b=ze([$e(0,_.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,E.ILogService)],b),e.ExtHostSearch=b;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(T),extraFileResources:f.extraFileResources&&f.extraFileResources.map(c=>k.URI.revive(c))}}e.reviveQuery=m;function T(f){return{...f,folder:k.URI.revive(f.folder)}}}),define(Ce[233],Ie([1,0,56,99,31,96,32,36,50,53,101,103,104,69,62,67,98,52,35,68,87,51,204,15,174,102,97]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l,w,t,d,i,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,!0),(0,r.registerSingleton)(d.ILogService,i.ExtHostLogService,!0),(0,r.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService,!1),(0,r.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,r.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration,!1),(0,r.registerSingleton)(u.IExtHostConsumerFileSystem,u.ExtHostConsumerFileSystem,!1),(0,r.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,!1),(0,r.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,!1),(0,r.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,!1),(0,r.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo,!1),(0,r.registerSingleton)(y.IExtHostOutputService,y.ExtHostOutputService,!0),(0,r.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,r.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,!1),(0,r.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,!1),(0,r.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,!1),(0,r.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,!1),(0,r.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow,!1),(0,r.registerSingleton)(S.IExtHostWorkspace,S.ExtHostWorkspace,!1),(0,r.registerSingleton)(I.IExtHostSecretState,I.ExtHostSecretState,!1),(0,r.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry,!1),(0,r.registerSingleton)(s.IExtHostTelemetryLogService,s.ExtHostTelemetryLogService,!1),(0,r.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,!1),(0,r.registerSingleton)(n.IExtHostVariableResolverProvider,n.ExtHostVariableResolverProviderService,!1)}),define(Ce[234],Ie([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class r{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(S){if(S&&this._dragOperations.has(S)){const M=this._dragOperations.get(S);return this._dragOperations.delete(S),M}}addDragOperationTransfer(S,M){this._dragOperations.set(S,M)}getRenderedTreeElement(S){if(this._renderedElements.has(S))return this._renderedElements.get(S)}addRenderedTreeItemElement(S,M){this._renderedElements.set(S,M)}removeRenderedTreeItemElement(S){this._renderedElements.has(S)&&this._renderedElements.delete(S)}}e.TreeviewsService=r}),define(Ce[235],Ie([1,0,134,6,22,2,5,7,14,6,10,16,8,20,234,25]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(I,l){if((0,O.isString)(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let w;return Array.isArray(I.highlights)&&(w=I.highlights.filter(t=>t.length===2&&typeof t[0]=="number"&&typeof t[1]=="number"),w=w.length?w:void 0),{label:I.label,highlights:w}}}class u{constructor(l,w,t){this._proxy=l,this.commands=w,this.logService=t,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function d(i){return i&&i.$treeViewId&&(i.$treeItemHandle||i.$selectedTreeItems||i.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:i=>d(i)?this.convertArgument(i):Array.isArray(i)&&i.length>0?i.map(n=>d(n)?this.convertArgument(n):n):i})}registerTreeDataProvider(l,w,t){const d=this.createTreeView(l,{treeDataProvider:w},t);return{dispose:()=>d.dispose()}}createTreeView(l,w,t){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=w.dragAndDropController?.dropMimeTypes??[],i=w.dragAndDropController?.dragMimeTypes??[],n=!!w.dragAndDropController?.handleDrag,s=!!w.dragAndDropController?.handleDrop,a=this.createExtHostTreeView(l,w,t),o=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:d,dragMimeTypes:i,hasHandleDrag:n,hasHandleDrop:s});return{get onDidCollapseElement(){return a.onDidCollapseElement},get onDidExpandElement(){return a.onDidExpandElement},get selection(){return a.selectedElements},get onDidChangeSelection(){return a.onDidChangeSelection},get visible(){return a.visible},get onDidChangeVisibility(){return a.onDidChangeVisibility},get onDidChangeTreeCheckbox(){return(0,c.checkProposedApiEnabled)(t,"treeItemCheckbox"),a.onDidChangeTreeCheckbox},get message(){return a.message},set message(g){a.message=g},get title(){return a.title},set title(g){a.title=g},get description(){return a.description},set description(g){a.description=g},get badge(){return a.badge},set badge(g){a.badge=g},reveal:(g,p)=>a.reveal(g,p),dispose:async()=>{await o,this.treeViews.delete(l),a.dispose()}}}$getChildren(l,w){const t=this.treeViews.get(l);return t?t.getChildren(w):Promise.reject(new Error((0,r.localize)(0,null,l)))}async $handleDrop(l,w,t,d,i,n,s,a){const o=this.treeViews.get(l);if(!o)return Promise.reject(new Error((0,r.localize)(1,null,l)));const g=m.DataTransfer.toDataTransfer(t,async p=>(await this._proxy.$resolveDropFileData(l,w,p)).buffer);return s===l&&a&&await this.addAdditionalTransferItems(g,o,a,i,n),o.onDrop(g,d,i)}async addAdditionalTransferItems(l,w,t,d,i){const n=this.treeDragAndDropService.removeDragOperationTransfer(i);if(n)(await n)?.forEach((s,a)=>{s&&l.set(a,s)});else if(i&&w.handleDrag){const s=w.handleDrag(t,l,d);this.treeDragAndDropService.addDragOperationTransfer(i,s),await s}return l}async $handleDrag(l,w,t,d){const i=this.treeViews.get(l);if(!i)return Promise.reject(new Error((0,r.localize)(2,null,l)));const n=await this.addAdditionalTransferItems(new y.DataTransfer,i,w,d,t);if(!!n)return m.DataTransfer.toDataTransferDTO(n)}async $hasResolve(l){const w=this.treeViews.get(l);if(!w)throw new Error((0,r.localize)(3,null,l));return w.hasResolve}$resolve(l,w,t){const d=this.treeViews.get(l);if(!d)throw new Error((0,r.localize)(4,null,l));return d.resolveTreeItem(w,t)}$setExpanded(l,w,t){const d=this.treeViews.get(l);if(!d)throw new Error((0,r.localize)(5,null,l));d.setExpanded(w,t)}$setSelection(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(6,null,l));t.setSelection(w)}$setFocus(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(7,null,l));t.setFocus(w)}$setVisible(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(8,null,l));t.setVisible(w)}$changeCheckboxState(l,w){const t=this.treeViews.get(l);if(!t)throw new Error((0,r.localize)(9,null,l));t.setCheckboxState(w)}createExtHostTreeView(l,w,t){const d=new v(l,w,this._proxy,this.commands.converter,this.logService,t);return this.treeViews.set(l,d),d}convertArgument(l){const w=this.treeViews.get(l.$treeViewId);return w&&"$treeItemHandle"in l?w.getExtensionElement(l.$treeItemHandle):w&&"$focusedTreeItem"in l&&l.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=u;class v extends A.Disposable{constructor(l,w,t,d,i,n){if(super(),this.viewId=l,this.proxy=t,this.commands=d,this.logService=i,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new _.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new _.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new _.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new _.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeTreeCheckbox=this._register(new _.Emitter),this.onDidChangeTreeCheckbox=this._onDidChangeTreeCheckbox.event,this._onDidChangeData=this._register(new _.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new T.CancellationTokenSource,n.contributes&&n.contributes.views)for(const o in n.contributes.views)for(const g of n.contributes.views[o])g.id===l&&(this._title=g.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let s,a;this._register(_.Event.debounce(this._onDidChangeData.event,(o,g)=>(o||(o={message:!1,elements:[]}),g.element!==!1&&(s||(s=new Promise(p=>a=p),this.refreshPromise=this.refreshPromise.then(()=>s)),Array.isArray(g.element)?o.elements.push(...g.element):o.elements.push(g.element)),g.message&&(o.message=!0),o),200,!0)(({message:o,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=a;return s=null,this.refresh(g).then(()=>p())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,O.isUndefinedOrNull)(l))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}async getChildren(l){const w=l?this.getExtensionElement(l):void 0;if(l&&!w)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let t=this.getChildrenNodes(l);return t||(t=await this.fetchChildrenNodes(w)),t?t.map(d=>d.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,w){w=w||{select:!0,focus:!1};const t=(0,O.isUndefinedOrNull)(w.select)?!0:w.select,d=(0,O.isUndefinedOrNull)(w.focus)?!1:w.focus,i=(0,O.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(n=>this.resolveTreeNode(l,n[n.length-1]).then(s=>this.proxy.$reveal(this.viewId,{item:s.item,parentChain:n.map(a=>a.item)},{select:t,focus:d,expand:i})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:t,focus:d,expand:i})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=m.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,w){const t=this.getExtensionElement(l);t&&(w?this._onDidExpandElement.fire(Object.freeze({element:t})):this._onDidCollapseElement.fire(Object.freeze({element:t})))}setSelection(l){(0,b.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(l){this._focusedHandle=l}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(l){const w=(await Promise.all(l.map(async t=>{const d=this.getExtensionElement(t.treeItemHandle);return d?{extensionItem:d,treeItem:await this.dataProvider.getTreeItem(d),newState:t.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(t=>t!==void 0);w.forEach(t=>{t.treeItem.checkboxState=t.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this._onDidChangeTreeCheckbox.fire({items:w.map(t=>[t.extensionItem,t.newState])})}async handleDrag(l,w,t){const d=[];for(const i of l){const n=this.getExtensionElement(i);n&&d.push(n)}if(!(!this.dndController?.handleDrag||d.length===0))return await this.dndController.handleDrag(d,w,t),w}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,w,t){const d=w?this.getExtensionElement(w):void 0;if(!(!d&&w||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(d,l,t):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,w){if(!this.dataProvider.resolveTreeItem)return;const t=this.elements.get(l);if(t){const d=this.nodes.get(t);if(d){const i=await this.dataProvider.resolveTreeItem(d.extensionItem,t,w)??d.extensionItem;return this.validateTreeItem(i),d.item.tooltip=this.getTooltip(i.tooltip),d.item.command=this.getCommand(d.disposableStore,i.command),d.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(w=>w?this.resolveUnknownParentChain(w).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(d=>(t.push(d),t))):Promise.resolve([]))}resolveParent(l){const w=this.nodes.get(l);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,w){const t=this.nodes.get(l);return t?Promise.resolve(t):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(d=>this.createHandle(l,d,w,!0)).then(d=>this.getChildren(w?w.item.handle:void 0).then(()=>{const i=this.getExtensionElement(d);if(i){const n=this.nodes.get(i);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(l){if(l){let w;if(typeof l=="string"){const t=this.getExtensionElement(l);w=t?this.nodes.get(t):void 0}else w=l;return w&&w.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const w=new T.CancellationTokenSource(this._refreshCancellationSource.token);try{const t=l?this.nodes.get(l):void 0,d=await this.dataProvider.getChildren(l);if(w.token.isCancellationRequested)return;const i=await Promise.all((0,b.coalesce)(d||[]).map(async n=>{const s=await this.dataProvider.getTreeItem(n);return s&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(n,s,t):null}));return w.token.isCancellationRequested?void 0:(0,b.coalesce)(i)}finally{w.dispose()}}refresh(l){if(l.some(t=>!t))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new T.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(l);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const w=new Set,t=l.map(i=>this.nodes.get(i));for(const i of t)if(i&&!w.has(i.item.handle)){let n=i;for(;n&&n.parent&&t.findIndex(s=>n&&n.parent&&s&&s.item.handle===n.parent.item.handle)===-1;){const s=this.elements.get(n.parent.item.handle);n=s?this.nodes.get(s):void 0}n&&!n.parent&&w.add(i.item.handle)}const d=[];return w.forEach(i=>{const n=this.elements.get(i);if(n){const s=this.nodes.get(n);s&&(!s.parent||!w.has(s.parent.item.handle))&&d.push(i)}}),d}refreshHandles(l){const w={};return Promise.all(l.map(t=>this.refreshNode(t).then(d=>{d&&(w[t]=d.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(l){const w=this.getExtensionElement(l);if(w){const t=this.nodes.get(w);if(t)return this.clearChildren(w),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(d=>{if(d){const i=this.createTreeNode(w,d,t.parent);return this.updateNodeCache(w,i,t,t.parent),t.dispose(),i}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,w,t){const d=this.createTreeNode(l,w,t);if(w.id&&this.elements.has(d.item.handle))throw new Error((0,r.localize)(10,null,w.id));return this.addNodeToCache(l,d),this.addNodeToParentCache(d,t),d}getTooltip(l){return k.MarkdownString.isMarkdownString(l)?m.MarkdownString.from(l):l}getCommand(l,w){return w?{...this.commands.toInternal(w,l),originalId:w.command}:void 0}getCheckbox(l){if(!l.checkboxState)return;let w,t;return typeof l.checkboxState=="number"?w=l.checkboxState:(w=l.checkboxState.state,t=l.checkboxState.tooltip),{isChecked:w===k.TreeItemCheckboxState.Checked,tooltip:t}}validateTreeItem(l){if(!k.TreeItem.isTreeItem(l,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(l,w,t){this.validateTreeItem(w);const d=new A.DisposableStore,i=this.createHandle(l,w,t),n=this.getLightIconPath(w);return{item:{handle:i,parentHandle:t?t.item.handle:void 0,label:h(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(d,w.command),contextValue:w.contextValue,icon:n,iconDark:this.getDarkIconPath(w)||n,themeIcon:this.getThemeIcon(w),collapsibleState:(0,O.isUndefinedOrNull)(w.collapsibleState)?k.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.getCheckbox(w)},extensionItem:w,parent:t,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(l){return l.iconPath instanceof k.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:w,label:t,resourceUri:d},i,n){if(w)return`${v.ID_HANDLE_PREFIX}/${w}`;const s=h(t,this.extension),a=i?i.item.handle:v.LABEL_HANDLE_PREFIX;let o=s?s.label:d?(0,S.basename)(d):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const g=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,p=this.getChildrenNodes(i)||[];let P,N=0;do{if(P=`${a}/${N}:${o}`,n||!this.elements.has(P)||g===P)break;N++}while(N<=p.length);return P}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof k.ThemeIcon))return typeof l.iconPath=="string"||M.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof k.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return M.URI.isUri(l)?l:M.URI.file(l)}addNodeToCache(l,w){this.elements.set(w.item.handle,l),this.nodes.set(l,w)}updateNodeCache(l,w,t,d){this.elements.delete(w.item.handle),this.nodes.delete(l),w.item.handle!==t.item.handle&&this.elements.delete(t.item.handle),this.addNodeToCache(l,w);const i=this.getChildrenNodes(d)||[],n=i.filter(s=>s.item.handle===t.item.handle)[0];n&&i.splice(i.indexOf(n),1,w)}addNodeToParentCache(l,w){w?(w.children||(w.children=[]),w.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const w=this.nodes.get(l);if(w){if(w.children)for(const t of w.children){const d=this.elements.get(t.item.handle);d&&this.clear(d)}w.children=void 0}}else this.clearAll()}clear(l){const w=this.nodes.get(l);if(w){if(w.children)for(const t of w.children){const d=this.elements.get(t.item.handle);d&&this.clear(d)}this.nodes.delete(l),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(Ce[236],Ie([1,0,20,11,5,29,2,121,246,110,119,39,4,91,189,188,36,190,32,192,193,194,177,195,50,33,197,198,201,203,205,99,180,209,210,211,69,53,214,235,8,6,217,54,98,31,161,200,86,96,101,103,104,15,46,13,28,206,175,62,67,186,215,70,52,220,218,219,187,35,212,216,68,51,87,207,100,208,12,82,179,158,199,7,25,163,97]),function(ne,e,r,y,S,M,_,A,E,k,O,b,m,T,f,c,h,u,v,I,l,w,t,d,i,n,s,a,o,g,p,P,N,V,U,D,x,L,R,K,W,$,fe,J,Q,ce,te,pe,be,re,Ee,Pe,Fe,We,Xe,Te,_e,ye,ae,ue,Y,ee,C,B,H,j,oe,le,Z,ve,ge,Ne,xe,Ye,Ge,ke,nt,G,X,he,Ue,Ve,Ze,Ke,je,tt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function dt(at){const rt=at.get(_e.IExtHostInitDataService),_t=at.get(ve.IExtHostFileSystemInfo),Rt=at.get(H.IExtHostConsumerFileSystem),Ot=at.get(n.IExtHostExtensionService),mt=at.get(ce.IExtHostWorkspace),Dt=at.get(Ge.IExtHostTelemetry),Nt=at.get(v.IExtHostConfiguration),Mt=at.get(Xe.IURITransformerService),qe=at.get(Te.IExtHostRpcService),Ut=at.get(x.IExtHostStorage),Ft=at.get(B.IExtensionStoragePaths),Tt=at.get(We.ILoggerService),gt=at.get(We.ILogService),yt=at.get(ue.IExtHostTunnelService),Se=at.get(st.IExtHostTelemetryLogService),De=at.get(Y.IExtHostApiDeprecationService),me=at.get(Q.IExtHostWindow),q=at.get(xe.IExtHostSecretState),Ae=at.get(Ye.IExtHostEditorTabs);qe.set(m.ExtHostContext.ExtHostFileSystemInfo,_t),qe.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Tt),qe.set(m.ExtHostContext.ExtHostWorkspace,mt),qe.set(m.ExtHostContext.ExtHostConfiguration,Nt),qe.set(m.ExtHostContext.ExtHostExtensionService,Ot),qe.set(m.ExtHostContext.ExtHostStorage,Ut),qe.set(m.ExtHostContext.ExtHostTunnelService,yt),qe.set(m.ExtHostContext.ExtHostWindow,me),qe.set(m.ExtHostContext.ExtHostSecretState,q),qe.set(m.ExtHostContext.ExtHostTelemetry,Dt),qe.set(m.ExtHostContext.ExtHostEditorTabs,Ae);const Le=qe.set(m.ExtHostContext.ExtHostDecorations,at.get(re.IExtHostDecorations)),et=qe.set(m.ExtHostContext.ExtHostDocumentsAndEditors,at.get(i.IExtHostDocumentsAndEditors)),Be=qe.set(m.ExtHostContext.ExtHostCommands,at.get(h.IExtHostCommands)),it=qe.set(m.ExtHostContext.ExtHostTerminalService,at.get(L.IExtHostTerminalService)),ct=qe.set(m.ExtHostContext.ExtHostDebugService,at.get(Pe.IExtHostDebugService)),Ct=qe.set(m.ExtHostContext.ExtHostSearch,at.get(Fe.IExtHostSearch)),pt=qe.set(m.ExtHostContext.ExtHostTask,at.get(Ee.IExtHostTask)),It=qe.set(m.ExtHostContext.ExtHostOutputService,at.get(P.IExtHostOutputService)),bt=qe.set(m.ExtHostContext.ExtHostUrls,new fe.ExtHostUrls(qe)),vt=qe.set(m.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(qe,et)),wt=qe.set(m.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(qe,et,gt)),ti=qe.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(gt,vt,qe.getProxy(m.MainContext.MainThreadBulkEdits))),Et=qe.set(m.ExtHostContext.ExtHostNotebook,new ye.ExtHostNotebookController(qe,Be,et,vt)),$t=qe.set(m.ExtHostContext.ExtHostNotebookDocuments,new Ve.ExtHostNotebookDocuments(Et)),Wt=qe.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(gt,Et)),ii=qe.set(m.ExtHostContext.ExtHostNotebookKernels,new ke.ExtHostNotebookKernels(qe,rt,Et,Be,gt)),gi=qe.set(m.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(qe,Et)),kt=qe.set(m.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(qe,et)),ni=qe.set(m.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(qe.getProxy(m.MainContext.MainThreadTreeViews),Be,gt)),Ht=qe.set(m.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(qe.getProxy(m.MainContext.MainThreadEditorInsets),kt,rt.remote)),Yt=qe.set(m.ExtHostContext.ExtHostDiagnostics,new I.ExtHostDiagnostics(qe,gt,_t)),ri=qe.set(m.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(qe,vt,Be.converter,Mt)),ut=qe.set(m.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(qe,Mt,vt,Be,Yt,gt,De)),Jt=qe.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(qe,ut)),xt=qe.set(m.ExtHostContext.ExtHostFileSystemEventService,new a.ExtHostFileSystemEventService(qe,gt,et)),Kt=qe.set(m.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(qe,mt,Be)),si=qe.set(m.ExtHostContext.ExtHostSCM,new U.ExtHostSCM(qe,Be,gt)),pi=qe.set(m.ExtHostContext.ExtHostComments,(0,u.createExtHostComments)(qe,Be,vt)),oi=qe.set(m.ExtHostContext.ExtHostProgress,new N.ExtHostProgress(qe.getProxy(m.MainContext.MainThreadProgress))),vi=qe.set(m.ExtHostContext.ExtHosLabelService,new pe.ExtHostLabelService(qe)),ai=qe.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(qe)),Zt=qe.set(m.ExtHostContext.ExtHostAuthentication,new ee.ExtHostAuthentication(qe)),Ri=qe.set(m.ExtHostContext.ExtHostTimeline,new C.ExtHostTimeline(qe,Be)),Ei=qe.set(m.ExtHostContext.ExtHostWebviews,new J.ExtHostWebviews(qe,rt.remote,mt,gt,De)),ei=qe.set(m.ExtHostContext.ExtHostWebviewPanels,new le.ExtHostWebviewPanels(qe,Ei,mt)),bi=qe.set(m.ExtHostContext.ExtHostCustomEditors,new oe.ExtHostCustomEditors(qe,vt,Ft,Ei,ei)),wi=qe.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(qe,Ei)),Gt=qe.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(qe,Be,et)),Oi=qe.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(qe));qe.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(qe,Et,et,Be,gt));const Si=Object.values(m.ExtHostContext);qe.assertRegistered(Si);const _i=new Z.ExtHostBulkEdits(qe,et),Fi=new c.ExtHostClipboard(qe),yi=new p.ExtHostMessageService(qe,gt),Ii=new l.ExtHostDialogs(qe),Ti=new D.ExtHostStatusBar(qe,Be.converter);return f.ExtHostApiCommands.register(Be),function(Me,Vt,ci){const ft=function(){let se=!Me.isUnderDevelopment;function de(){se||(gt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const St=ot;typeof St.scheme>"u"&&de(),typeof St.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ot}}(),Ni={getSession(se,de,Re){return Zt.getSession(Me,se,de,Re)},async hasSession(se,de){return(0,je.checkProposedApiEnabled)(Me,"authSession"),!!await Zt.getSession(Me,se,de,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,de,Re,ot){return Zt.registerAuthenticationProvider(se,de,Re,ot)}},Mi={registerCommand(se,de,Re){return Be.registerCommand(!0,se,de,Re,void 0,Me)},registerTextEditorCommand(se,de,Re){return Be.registerCommand(!0,se,(...ot)=>{const St=kt.getActiveTextEditor();if(!St){gt.warn("Cannot execute "+se+" because there is no active text editor.");return}return St.edit(Pt=>{de.apply(Re,[St,Pt,...ot])}).then(Pt=>{Pt||gt.warn("Edits from command "+se+" were not applied.")},Pt=>{gt.warn("An error occurred while running command "+se,Pt)})},void 0,void 0,Me)},registerDiffInformationCommand:(se,de,Re)=>((0,je.checkProposedApiEnabled)(Me,"diffCommand"),Be.registerCommand(!0,se,async(...ot)=>{const St=et.activeEditor(!0);if(!St){gt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Pt=await kt.getDiffInformation(St.id);de.apply(Re,[Pt,...ot])},void 0,void 0,Me)),executeCommand(se,...de){return Be.executeCommand(se,...de)},getCommands(se=!1){return Be.getCommands(se)}},ki={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Fi.value},get shell(){return it.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const se=Date.now()-new Date(rt.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,de){return me.openUri(se,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===rt.environment.appUriScheme)return bt.createAppUri(se);try{return await me.asExternalUri(se,{allowTunneling:!!rt.remote.authority})}catch(de){if((0,he.matchesScheme)(se,X.Schemas.http)||(0,he.matchesScheme)(se,X.Schemas.https))return se;throw de}},get remoteName(){return(0,be.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Me,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind}};rt.environment.extensionTestsLocationURI||Object.freeze(ki);const li={createTestController(se,de,Re){return Gt.createTestController(se,de,Re)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.createTestObserver()},runTests(se){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.runTests(se)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Me,"testObserver"),Gt.results}},ui=rt.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Li={getExtension(se,de){(0,je.isProposedApiEnabled)(Me,"extensionsAny")||(de=!1);const Re=Vt.mine.getExtensionDescription(se);if(Re)return new n.Extension(Ot,Me.identifier,Re,ui,!1);if(de){const ot=Vt.all.getExtensionDescription(se);if(ot)return new n.Extension(Ot,Me.identifier,ot,ui,!0)}},get all(){const se=[];for(const de of Vt.mine.getAllExtensionDescriptions())se.push(new n.Extension(Ot,Me.identifier,de,ui,!1));return se},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(Me,"extensionsAny");const se=new je.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of Vt.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);de.push(new n.Extension(Ot,Me.identifier,Re,ui,ot))}return de},get onDidChange(){return(0,je.isProposedApiEnabled)(Me,"extensionsAny")?S.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Ui={createDiagnosticCollection(se){return Yt.createDiagnosticCollection(Me.identifier,se)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:se=>Yt.getDiagnostics(se),getLanguages(){return ri.getLanguages()},setTextDocumentLanguage(se,de){return ri.changeLanguage(se.uri,de)},match(se,de){const Re=vt.getDocumentData(de.uri)?.notebook;return(0,O.score)(W.LanguageSelector.from(se),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,de,Re){return ut.registerCodeActionProvider(Me,ft(se),de,Re)},registerDocumentPasteEditProvider(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,ft(se),de,Re)},registerCodeLensProvider(se,de){return ut.registerCodeLensProvider(Me,ft(se),de)},registerDefinitionProvider(se,de){return ut.registerDefinitionProvider(Me,ft(se),de)},registerDeclarationProvider(se,de){return ut.registerDeclarationProvider(Me,ft(se),de)},registerImplementationProvider(se,de){return ut.registerImplementationProvider(Me,ft(se),de)},registerTypeDefinitionProvider(se,de){return ut.registerTypeDefinitionProvider(Me,ft(se),de)},registerHoverProvider(se,de){return ut.registerHoverProvider(Me,ft(se),de,Me.identifier)},registerEvaluatableExpressionProvider(se,de){return ut.registerEvaluatableExpressionProvider(Me,ft(se),de,Me.identifier)},registerInlineValuesProvider(se,de){return ut.registerInlineValuesProvider(Me,ft(se),de,Me.identifier)},registerDocumentHighlightProvider(se,de){return ut.registerDocumentHighlightProvider(Me,ft(se),de)},registerLinkedEditingRangeProvider(se,de){return ut.registerLinkedEditingRangeProvider(Me,ft(se),de)},registerReferenceProvider(se,de){return ut.registerReferenceProvider(Me,ft(se),de)},registerRenameProvider(se,de){return ut.registerRenameProvider(Me,ft(se),de)},registerDocumentSymbolProvider(se,de,Re){return ut.registerDocumentSymbolProvider(Me,ft(se),de,Re)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Me,se)},registerDocumentFormattingEditProvider(se,de){return ut.registerDocumentFormattingEditProvider(Me,ft(se),de)},registerDocumentRangeFormattingEditProvider(se,de){return ut.registerDocumentRangeFormattingEditProvider(Me,ft(se),de)},registerOnTypeFormattingEditProvider(se,de,Re,...ot){return ut.registerOnTypeFormattingEditProvider(Me,ft(se),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,de,Re){return ut.registerDocumentSemanticTokensProvider(Me,ft(se),de,Re)},registerDocumentRangeSemanticTokensProvider(se,de,Re){return ut.registerDocumentRangeSemanticTokensProvider(Me,ft(se),de,Re)},registerSignatureHelpProvider(se,de,Re,...ot){return typeof Re=="object"?ut.registerSignatureHelpProvider(Me,ft(se),de,Re):ut.registerSignatureHelpProvider(Me,ft(se),de,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(se,de,...Re){return ut.registerCompletionItemProvider(Me,ft(se),de,Re)},registerInlineCompletionItemProvider(se,de){return de.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,ft(se),de)},registerInlineCompletionItemProviderNew(se,de){if((0,je.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,je.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Me,ft(se),de)},registerDocumentLinkProvider(se,de){return ut.registerDocumentLinkProvider(Me,ft(se),de)},registerColorProvider(se,de){return ut.registerColorProvider(Me,ft(se),de)},registerFoldingRangeProvider(se,de){return ut.registerFoldingRangeProvider(Me,ft(se),de)},registerSelectionRangeProvider(se,de){return ut.registerSelectionRangeProvider(Me,se,de)},registerCallHierarchyProvider(se,de){return ut.registerCallHierarchyProvider(Me,se,de)},registerTypeHierarchyProvider(se,de){return ut.registerTypeHierarchyProvider(Me,se,de)},setLanguageConfiguration:(se,de)=>ut.setLanguageConfiguration(Me,se,de),getTokenInformationAtPosition(se,de){return(0,je.checkProposedApiEnabled)(Me,"tokenInformation"),ri.tokenAtPosition(se,de)},registerInlayHintsProvider(se,de){return ut.registerInlayHintsProvider(Me,se,de)},createLanguageStatusItem(se,de){return ri.createLanguageStatusItem(Me,se,de)},registerDocumentDropEditProvider(se,de){return ut.registerDocumentOnDropEditProvider(Me,se,de)}},Bi={get activeTextEditor(){return kt.getActiveTextEditor()},get visibleTextEditors(){return kt.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(se,de,Re){const ot=await(_.URI.isUri(se)?Promise.resolve(di.openTextDocument(se)):Promise.resolve(se));return kt.showTextDocument(ot,de,Re)},createTextEditorDecorationType(se){return kt.createTextEditorDecorationType(Me,se)},onDidChangeActiveTextEditor(se,de,Re){return kt.onDidChangeActiveTextEditor(se,de,Re)},onDidChangeVisibleTextEditors(se,de,Re){return kt.onDidChangeVisibleTextEditors(se,de,Re)},onDidChangeTextEditorSelection(se,de,Re){return kt.onDidChangeTextEditorSelection(se,de,Re)},onDidChangeTextEditorOptions(se,de,Re){return kt.onDidChangeTextEditorOptions(se,de,Re)},onDidChangeTextEditorVisibleRanges(se,de,Re){return kt.onDidChangeTextEditorVisibleRanges(se,de,Re)},onDidChangeTextEditorViewColumn(se,de,Re){return kt.onDidChangeTextEditorViewColumn(se,de,Re)},onDidCloseTerminal(se,de,Re){return it.onDidCloseTerminal(se,de,Re)},onDidOpenTerminal(se,de,Re){return it.onDidOpenTerminal(se,de,Re)},onDidChangeActiveTerminal(se,de,Re){return it.onDidChangeActiveTerminal(se,de,Re)},onDidChangeTerminalDimensions(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"terminalDimensions"),it.onDidChangeTerminalDimensions(se,de,Re)},onDidChangeTerminalState(se,de,Re){return it.onDidChangeTerminalState(se,de,Re)},onDidWriteTerminalData(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),it.onDidWriteTerminalData(se,de,Re)},get state(){return me.state},onDidChangeWindowState(se,de,Re){return me.onDidChangeWindowState(se,de,Re)},showInformationMessage(se,...de){return yi.showMessage(Me,M.default.Info,se,de[0],de.slice(1))},showWarningMessage(se,...de){return yi.showMessage(Me,M.default.Warning,se,de[0],de.slice(1))},showErrorMessage(se,...de){return yi.showMessage(Me,M.default.Error,se,de[0],de.slice(1))},showQuickPick(se,de,Re){return Kt.showQuickPick(se,de,Re)},showWorkspaceFolderPick(se){return Kt.showWorkspaceFolderPick(se)},showInputBox(se,de){return Kt.showInput(se,de)},showOpenDialog(se){return Ii.showOpenDialog(se)},showSaveDialog(se){return Ii.showSaveDialog(se)},createStatusBarItem(se,de,Re){let ot,St,Pt;return typeof se=="string"?(ot=se,St=de,Pt=Re):(St=se,Pt=de),Ti.createStatusBarEntry(Me,ot,St,Pt)},setStatusBarMessage(se,de){return Ti.setStatusBarMessage(se,de)},withScmProgress(se){return De.report("window.withScmProgress",Me,"Use 'withProgress' instead."),oi.withProgress(Me,{location:$.ProgressLocation.SourceControl},(de,Re)=>se({report(ot){}}))},withProgress(se,de){return oi.withProgress(Me,se,de)},createOutputChannel(se,de){return It.createOutputChannel(se,de,Me)},createWebviewPanel(se,de,Re,ot){return ei.createWebviewPanel(Me,se,de,Re,ot)},createWebviewTextEditorInset(se,de,Re,ot){return(0,je.checkProposedApiEnabled)(Me,"editorInsets"),Ht.createWebviewEditorInset(se,de,Re,ot,Me)},createTerminal(se,de,Re){return typeof se=="object"?"pty"in se?it.createExtensionTerminal(se):it.createTerminalFromOptions(se):it.createTerminal(se,de,Re)},registerTerminalLinkProvider(se){return it.registerLinkProvider(se)},registerTerminalProfileProvider(se,de){return it.registerProfileProvider(Me,se,de)},registerTreeDataProvider(se,de){return ni.registerTreeDataProvider(se,de,Me)},createTreeView(se,de){return ni.createTreeView(se,de,Me)},registerWebviewPanelSerializer:(se,de)=>ei.registerWebviewPanelSerializer(Me,se,de),registerCustomEditorProvider:(se,de,Re={})=>bi.registerCustomEditorProvider(Me,se,de,Re),registerFileDecorationProvider(se){return Le.registerFileDecorationProvider(se,Me.identifier)},registerUriHandler(se){return bt.registerUriHandler(Me.identifier,se)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return ai.activeColorTheme},onDidChangeActiveColorTheme(se,de,Re){return ai.onDidChangeActiveColorTheme(se,de,Re)},registerWebviewViewProvider(se,de,Re){return wi.registerWebviewViewProvider(Me,se,de,Re?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,de,Re){return Et.onDidChangeActiveNotebookEditor(se,de,Re)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,de,Re){return Wt.onDidChangeNotebookEditorSelection(se,de,Re)},onDidChangeNotebookEditorVisibleRanges(se,de,Re){return Wt.onDidChangeNotebookEditorVisibleRanges(se,de,Re)},showNotebookDocument(se,de){return _.URI.isUri(se)&&De.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),Et.showNotebookDocument(se,de)},registerExternalUriOpener(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"externalUriOpener"),Oi.registerExternalUriOpener(Me.identifier,se,de,Re)},get tabGroups(){return Ae.tabGroups},logTelemetryToOutputChannel(se,de){(0,je.checkProposedApiEnabled)(Me,"telemetryLog"),Se.logToTelemetryOutputChannel(Me,se,de)}},di={get rootPath(){return De.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(se){throw y.readonly()},getWorkspaceFolder(se){return mt.getWorkspaceFolder(se)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(se){throw y.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(se){throw y.readonly()},updateWorkspaceFolders:(se,de,...Re)=>mt.updateWorkspaceFolders(Me,se,de||0,...Re),onDidChangeWorkspaceFolders:function(se,de,Re){return mt.onDidChangeWorkspace(se,de,Re)},asRelativePath:(se,de)=>mt.getRelativePath(se,de),findFiles:(se,de,Re,ot)=>mt.findFiles(se,de,Re,Me.identifier,ot),findTextInFiles:(se,de,Re,ot)=>{(0,je.checkProposedApiEnabled)(Me,"findTextInFiles");let St,Pt;return typeof de=="object"?(St=de,Pt=Re):(St={},Pt=de,ot=Re),mt.findTextInFiles(se,St||{},Pt,Me.identifier,ot)},saveAll:se=>mt.saveAll(se),applyEdit(se,de){return _i.applyWorkspaceEdit(se,Me,de)},createFileSystemWatcher:(se,de,Re,ot)=>xt.createFileSystemWatcher(mt,Me,se,de,Re,ot),get textDocuments(){return vt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw y.readonly()},openTextDocument(se){let de;const Re=se;if(typeof se=="string")de=Promise.resolve(_.URI.file(se));else if(_.URI.isUri(se))de=Promise.resolve(se);else if(!Re||typeof Re=="object")de=vt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>vt.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(se,de,Re)=>vt.onDidAddDocument(se,de,Re),onDidCloseTextDocument:(se,de,Re)=>vt.onDidRemoveDocument(se,de,Re),onDidChangeTextDocument:(se,de,Re)=>vt.onDidChangeDocument(se,de,Re),onDidSaveTextDocument:(se,de,Re)=>vt.onDidSaveDocument(se,de,Re),onWillSaveTextDocument:(se,de,Re)=>ti.getOnWillSaveTextDocumentEvent(Me)(se,de,Re),get notebookDocuments(){return Et.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,de){let Re;if(_.URI.isUri(se))Re=se,await Et.openNotebookDocument(se);else if(typeof se=="string")Re=_.URI.revive(await Et.createNotebookDocument({viewType:se,content:de}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,de,Re){return $t.onDidSaveNotebookDocument(se,de,Re)},onDidChangeNotebookDocument(se,de,Re){return $t.onDidChangeNotebookDocument(se,de,Re)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(se,de,Re,ot){return Et.registerNotebookSerializer(Me,se,de,Re,(0,je.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,de,Re,ot)=>((0,je.checkProposedApiEnabled)(Me,"notebookContentProvider"),De.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),Et.registerNotebookContentProvider(Me,se,de,Re,(0,je.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,de,Re)=>ci.onDidChangeConfiguration(se,de,Re),getConfiguration(se,de){return de=arguments.length===1?void 0:de,ci.getConfiguration(se,de,Me)},registerTextDocumentContentProvider(se,de){return wt.registerTextDocumentContentProvider(se,de)},registerTaskProvider:(se,de)=>(De.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Me,se,de)),registerFileSystemProvider(se,de,Re){return(0,Ke.combinedDisposable)(Jt.registerFileSystemProvider(Me,se,de,Re),Rt.addFileSystemProvider(se,de))},get fs(){return Rt.value},registerFileSearchProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"fileSearchProvider"),Ct.registerFileSearchProvider(se,de)),registerTextSearchProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"textSearchProvider"),Ct.registerTextSearchProvider(se,de)),registerRemoteAuthorityResolver:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),Ot.registerRemoteAuthorityResolver(se,de)),registerResourceLabelFormatter:se=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),vi.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,de,Re)=>xt.onDidCreateFile(se,de,Re),onDidDeleteFiles:(se,de,Re)=>xt.onDidDeleteFile(se,de,Re),onDidRenameFiles:(se,de,Re)=>xt.onDidRenameFile(se,de,Re),onWillCreateFiles:(se,de,Re)=>xt.getOnWillCreateFileEvent(Me)(se,de,Re),onWillDeleteFiles:(se,de,Re)=>xt.getOnWillDeleteFileEvent(Me)(se,de,Re),onWillRenameFiles:(se,de,Re)=>xt.getOnWillRenameFileEvent(Me)(se,de,Re),openTunnel:se=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),yt.openTunnel(Me,se).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,je.checkProposedApiEnabled)(Me,"resolvers"),yt.getTunnels()},onDidChangeTunnels:(se,de,Re)=>((0,je.checkProposedApiEnabled)(Me,"resolvers"),yt.onDidChangeTunnels(se,de,Re)),registerPortAttributesProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"portsAttributes"),yt.registerPortsAttributesProvider(se,de)),registerTimelineProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"timeline"),Ri.registerTimelineProvider(se,de,Me.identifier,Be.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:se=>((0,je.checkProposedApiEnabled)(Me,"workspaceTrust"),mt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,de,Re)=>mt.onDidGrantWorkspaceTrust(se,de,Re),registerEditSessionIdentityProvider:(se,de)=>((0,je.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(se,de))},xi={get inputBox(){return De.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),si.getLastInputBox(Me)},createSourceControl(se,de,Re){return si.createSourceControl(Me,se,de,Re)}},jt={createCommentController(se,de){return pi.createCommentController(Me,se,de)}},hi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(se,de,Re){return ct.onDidStartDebugSession(se,de,Re)},onDidTerminateDebugSession(se,de,Re){return ct.onDidTerminateDebugSession(se,de,Re)},onDidChangeActiveDebugSession(se,de,Re){return ct.onDidChangeActiveDebugSession(se,de,Re)},onDidReceiveDebugSessionCustomEvent(se,de,Re){return ct.onDidReceiveDebugSessionCustomEvent(se,de,Re)},onDidChangeBreakpoints(se,de,Re){return ct.onDidChangeBreakpoints(se,de,Re)},registerDebugConfigurationProvider(se,de,Re){return ct.registerDebugConfigurationProvider(se,de,Re||tt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,de){return ct.registerDebugAdapterDescriptorFactory(Me,se,de)},registerDebugAdapterTrackerFactory(se,de){return ct.registerDebugAdapterTrackerFactory(se,de)},startDebugging(se,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(se,de,{parentSession:Re}):ct.startDebugging(se,de,Re||{})},stopDebugging(se){return ct.stopDebugging(se)},addBreakpoints(se){return ct.addBreakpoints(se)},removeBreakpoints(se){return ct.removeBreakpoints(se)},asDebugSourceUri(se,de){return ct.asDebugSourceUri(se,de)}},zi={registerTaskProvider:(se,de)=>pt.registerTaskProvider(Me,se,de),fetchTasks:se=>pt.fetchTasks(se),executeTask:se=>pt.executeTask(Me,se),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(se,de,Re)=>pt.onDidStartTask(se,de,Re),onDidEndTask:(se,de,Re)=>pt.onDidEndTask(se,de,Re),onDidStartTaskProcess:(se,de,Re)=>pt.onDidStartTaskProcess(se,de,Re),onDidEndTaskProcess:(se,de,Re)=>pt.onDidEndTaskProcess(se,de,Re)},Lt={createNotebookController(se,de,Re,ot,St){return ii.createNotebookController(Me,se,de,Re,ot,(0,je.isProposedApiEnabled)(Me,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(se,de)=>Et.registerNotebookCellStatusBarItemProvider(Me,se,de),createRendererMessaging(se){return gi.createRendererMessaging(Me,se)},onDidChangeNotebookCellExecutionState(se,de,Re){return(0,je.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),ii.onDidChangeNotebookCellExecutionState(se,de,Re)}};return{version:rt.version,authentication:Ni,commands:Mi,comments:jt,debug:hi,env:ki,extensions:Li,languages:Ui,notebooks:Lt,scm:xi,tasks:zi,tests:li,window:Bi,workspace:di,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:y.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CommentThreadState:$.CommentThreadState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:tt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:$.InlineCompletionTriggerKindNew,EventEmitter:S.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionItemNew:$.InlineSuggestionNew,InlineCompletionList:$.InlineSuggestionList,InlineCompletionListNew:$.InlineSuggestionsNew,Hover:$.Hover,IndentAction:k.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,SnippetTextEdit:$.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItem2:$.TreeItem,TreeItemCheckboxState:$.TreeItemCheckboxState,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:T.UIKind,Uri:_.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,DocumentDropEdit:$.DocumentDropEdit,DocumentPasteEdit:$.DocumentPasteEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,NotebookEdit:$.NotebookEdit,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:$.DataTransfer,DataTransferItem:$.DataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind,InputBoxValidationSeverity:$.InputBoxValidationSeverity,TabInputText:$.TextTabInput,TabInputTextDiff:$.TextDiffTabInput,TabInputTextMerge:$.TextMergeTabInput,TabInputCustom:$.CustomEditorTabInput,TabInputNotebook:$.NotebookEditorTabInput,TabInputNotebookDiff:$.NotebookDiffEditorTabInput,TabInputWebview:$.WebviewEditorTabInput,TabInputTerminal:$.TerminalEditorTabInput,TabInputInteractiveWindow:$.InteractiveWindowInput,TerminalExitReason:$.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=dt}),define(Ce[237],Ie([1,0,236,33,2,230,6,14,221,21]),function(ne,e,r,y,S,M,_,A,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class O extends M.RequireInterceptor{_installInterceptor(){}getModule(f,c){for(const h of this._alternatives){const u=h(f);if(u){f=u;break}}if(this._factories.has(f))return this._factories.get(f).load(f,c,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class b extends y.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=_.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(O,f,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,c,h){c=c.with({path:m(c.path,".js")});const u=f?.identifier.value;u&&performance.mark(`code/extHost/willFetchExtensionCode/${u}`);const v=S.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(c)),I=await fetch(v.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u}`),I.status!==200)throw new Error(I.statusText);const l=await I.text(),w=`${c.toString(!0)}#vscode-extension`,t=`${l}
//# sourceURL=${w}`;let d;try{d=new Function("module","exports","require",t)}catch(o){throw console.error(u?`Loading code for extension ${u} failed: ${o.message}`:`Loading code failed: ${o.message}`),console.error(`${c.toString(!0)}${typeof o.line=="number"?` line ${o.line}`:""}${typeof o.column=="number"?` column ${o.column}`:""}`),console.error(o),o}const i=await this.fetchTranslatedStrings(f),n={},s={exports:n},a=o=>{if(o==="vscode-nls-web-data")return i;const g=this._fakeModules.getModule(o,c);if(g===void 0)throw new Error(`Cannot load module '${o}'`);return g};try{return h.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u}`),d(s,n,a),s.exports!==n?s.exports:n}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u}`),h.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const c=Date.now()+f;for(;Date.now()<c&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}async fetchTranslatedStrings(f){let c={};if(!f)return{};const h=k.Language.isDefaultVariant()?f.browserNlsBundleUris?.en:f.browserNlsBundleUris?.[k.Language.value()]??f.browserNlsBundleUris?.en;if(f&&h)try{const u=await fetch(h.toString(!0));if(!u.ok)throw new Error(await u.text());c=await u.json()}catch(u){try{console.error(`Failed to load translations for ${f.identifier.value} from ${h}: ${u.message}`);const v=f.browserNlsBundleUris?.en;if(v){const I=await fetch(v.toString(!0));if(!I.ok)throw new Error(await I.text());c=await I.json()}throw new Error("No English strings found")}catch(v){console.error(v)}}return c}}e.ExtHostExtensionService=b;function m(T,f){return T.endsWith(f)?T:T+f}}),define(Ce[238],Ie([1,0,56,33,70,237]),function(ne,e,r,y,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(y.IExtHostExtensionService,M.ExtHostExtensionService,!1),(0,r.registerSingleton)(S.IExtensionStoragePaths,S.ExtensionStoragePaths,!1)}),define(Ce[247],Ie([1,0,23,5,91,231,223,19,71,12,2,233,238]),function(ne,e,r,y,S,M,_,A,E,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function T(t){return/^(file|vscode-remote):/i.test(t)}const f=fetch.bind(self);function c(t){self.fetch=async function(d,i){return d instanceof Request||T(String(d))&&(d=(await t(O.URI.parse(String(d)))).toString(!0)),f(d,i)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,i,n,s,a){(async()=>(T(i.toString())&&(i=(await t(O.URI.parse(i.toString()))).toString(!0)),super.open(d,i,n??!0,s,a)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,i){if(/^file:/i.test(d.toString()))d=k.FileAccess.asBrowserUri(O.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(p){function P(U){return typeof U=="string"||U instanceof URL?String(U).replace(/^file:\/\//i,"vscode-file://vscode-app"):U}const N=fetch.bind(self);self.fetch=function(U,D){return U instanceof Request?N(U,D):N(P(U),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(U,D,x,L,R){return super.open(U,P(D),x??!0,L,R)}};const V=importScripts.bind(self);self.importScripts=(...U)=>{V(...U.map(P))},V(p)}.toString()}('${d}'))`;i=i||{},i.name=i.name||A.basename(d.toString());const a=new Blob([s],{type:"application/javascript"}),o=URL.createObjectURL(a);return new t(o,i)}}else self.Worker=class extends _.NestedWorker{constructor(t,d){super(m,t,{name:A.basename(t.toString()),...d})}};const h=new class{constructor(){this.pid=void 0}exit(t){b()}async exists(t){return!0}async realpath(t){return t}};class u{constructor(){const d=new MessageChannel,i=new y.Emitter;let n=!1;m(d.port2,[d.port2]),d.port1.onmessage=s=>{const{data:a}=s;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const o=r.VSBuffer.wrap(new Uint8Array(a,0,a.byteLength));if((0,S.isMessageOfType)(o,2)){n=!0,I("received terminate message from renderer");return}i.fire(o)},this.protocol={onMessage:i.event,send:s=>{if(!n){const a=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);d.port1.postMessage(a,[a])}}}}}function v(t){return new Promise(d=>{const i=t.onMessage(n=>{i.dispose();const s=JSON.parse(n.toString());t.send((0,S.createMessageOfType)(0)),d({protocol:t,initData:s})});t.send((0,S.createMessageOfType)(1))})}let I=t=>b();function l(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function w(){E.mark("code/extHost/willConnectToRenderer");const t=new u;return{onmessage(d){!l(d)||v(t.protocol).then(i=>{E.mark("code/extHost/didWaitForInitData");const n=new M.ExtensionHostMain(i.protocol,i.initData,h,null,d.data);c(s=>n.asBrowserUri(s)),I=s=>n.terminate(s)})}}}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b3546b4bb5aff5254ef857cfd68a3da8534c068f/core/vs/workbench/api/worker/extensionHostWorker.js.map
